/* A Bison parser, made by GNU Bison 3.3.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.3.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs

#define yylval          base_yylval
#define yychar          base_yychar
#define yylloc          base_yylloc

/* First part of user prologue.  */
#line 5 "preproc.y" /* yacc.c:337  */

#include "postgres_fe.h"

#include "extern.h"
#include "ecpg_config.h"
#include <unistd.h>

/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N)						\
			(Current) = (Rhs)[1];	\
		else						\
			(Current) = (Rhs)[0];	\
	} while (0)

/*
 * The %name-prefix option below will make bison call base_yylex, but we
 * really want it to call filtered_base_yylex (see parser.c).
 */
#define base_yylex filtered_base_yylex

/*
 * This is only here so the string gets into the POT.  Bison uses it
 * internally.
 */
#define bison_gettext_dummy gettext_noop("syntax error")

/*
 * Variables containing simple states.
 */
int struct_level = 0;
int braces_open; /* brace level counter */
char *current_function;
int ecpg_internal_var = 0;
char	*connection = NULL;
char	*input_filename = NULL;

static int	FoundInto = 0;
static int	initializer = 0;
static int	pacounter = 1;
static char	pacounter_buffer[sizeof(int) * CHAR_BIT * 10 / 3]; /* a rough guess at the size we need */
static struct this_type actual_type[STRUCT_DEPTH];
static char *actual_startline[STRUCT_DEPTH];
static int	varchar_counter = 1;

/* temporarily store struct members while creating the data structure */
struct ECPGstruct_member *struct_member_list[STRUCT_DEPTH] = { NULL };

/* also store struct type so we can do a sizeof() later */
static char *ECPGstruct_sizeof = NULL;

/* for forward declarations we have to store some data as well */
static char *forward_name = NULL;

struct ECPGtype ecpg_no_indicator = {ECPGt_NO_INDICATOR, NULL, NULL, NULL, {NULL}, 0};
struct variable no_indicator = {"no_indicator", &ecpg_no_indicator, 0, NULL};

static struct ECPGtype ecpg_query = {ECPGt_char_variable, NULL, NULL, NULL, {NULL}, 0};

static void vmmerror(int error_code, enum errortype type, const char *error, va_list ap) pg_attribute_printf(3, 0);

/*
 * Handle parsing errors and warnings
 */
static void
vmmerror(int error_code, enum errortype type, const char *error, va_list ap)
{
	/* localize the error message string */
	error = _(error);

	fprintf(stderr, "%s:%d: ", input_filename, base_yylineno);

	switch(type)
	{
		case ET_WARNING:
			fprintf(stderr, _("WARNING: "));
			break;
		case ET_ERROR:
			fprintf(stderr, _("ERROR: "));
			break;
	}

	vfprintf(stderr, error, ap);

	fprintf(stderr, "\n");

	switch(type)
	{
		case ET_WARNING:
			break;
		case ET_ERROR:
			ret_value = error_code;
			break;
	}
}

void
mmerror(int error_code, enum errortype type, const char *error, ...)
{
	va_list		ap;

	va_start(ap, error);
	vmmerror(error_code, type, error, ap);
	va_end(ap);
}

void
mmfatal(int error_code, const char *error, ...)
{
	va_list		ap;

	va_start(ap, error);
	vmmerror(error_code, ET_ERROR, error, ap);
	va_end(ap);

	if (base_yyin)
		fclose(base_yyin);
	if (base_yyout)
		fclose(base_yyout);

	if (strcmp(output_filename, "-") != 0 && unlink(output_filename) != 0)
		fprintf(stderr, _("could not remove output file \"%s\"\n"), output_filename);
	exit(error_code);
}

/*
 * string concatenation
 */

static char *
cat2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 2);

	strcpy(res_str, str1);
	if (strlen(str1) != 0 && strlen(str2) != 0)
		strcat(res_str, " ");
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return(res_str);
}

static char *
cat_str(int count, ...)
{
	va_list		args;
	int			i;
	char		*res_str;

	va_start(args, count);

	res_str = va_arg(args, char *);

	/* now add all other strings */
	for (i = 1; i < count; i++)
		res_str = cat2_str(res_str, va_arg(args, char *));

	va_end(args);

	return(res_str);
}

static char *
make2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return(res_str);
}

static char *
make3_str(char *str1, char *str2, char *str3)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) +strlen(str3) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	strcat(res_str, str3);
	free(str1);
	free(str2);
	free(str3);
	return(res_str);
}

/* and the rest */
static char *
make_name(void)
{
	return mm_strdup(base_yytext);
}

static char *
create_questionmarks(char *name, bool array)
{
	struct variable *p = find_variable(name);
	int count;
	char *result = EMPTY;

	/* In case we have a struct, we have to print as many "?" as there are attributes in the struct
	 * An array is only allowed together with an element argument
	 * This is essentially only used for inserts, but using a struct as input parameter is an error anywhere else
	 * so we don't have to worry here. */

	if (p->type->type == ECPGt_struct || (array && p->type->type == ECPGt_array && p->type->u.element->type == ECPGt_struct))
	{
		struct ECPGstruct_member *m;

		if (p->type->type == ECPGt_struct)
			m = p->type->u.members;
		else
			m = p->type->u.element->u.members;

		for (count = 0; m != NULL; m=m->next, count++);
	}
	else
		count = 1;

	for (; count > 0; count --)
	{
		sprintf(pacounter_buffer, "$%d", pacounter++);
		result = cat_str(3, result, mm_strdup(pacounter_buffer), mm_strdup(" , "));
	}

	/* removed the trailing " ," */

	result[strlen(result)-3] = '\0';
	return(result);
}

static char *
adjust_outofscope_cursor_vars(struct cursor *cur)
{
	/* Informix accepts DECLARE with variables that are out of scope when OPEN is called.
	 * For instance you can DECLARE a cursor in one function, and OPEN/FETCH/CLOSE
	 * it in another functions. This is very useful for e.g. event-driver programming,
	 * but may also lead to dangerous programming. The limitation when this is allowed
	 * and doesn't cause problems have to be documented, like the allocated variables
	 * must not be realloc()'ed.
	 *
	 * We have to change the variables to our own struct and just store the pointer
	 * instead of the variable. Do it only for local variables, not for globals.
	 */

	char *result = EMPTY;
	int insert;

	for (insert = 1; insert >= 0; insert--)
	{
		struct arguments *list;
		struct arguments *ptr;
		struct arguments *newlist = NULL;
		struct variable *newvar, *newind;

		list = (insert ? cur->argsinsert : cur->argsresult);

		for (ptr = list; ptr != NULL; ptr = ptr->next)
		{
			char var_text[20];
			char *original_var;
			bool skip_set_var = false;
			bool var_ptr = false;

			/* change variable name to "ECPGget_var(<counter>)" */
			original_var = ptr->variable->name;
			sprintf(var_text, "%d))", ecpg_internal_var);

			/* Don't emit ECPGset_var() calls for global variables */
			if (ptr->variable->brace_level == 0)
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type == ECPGt_char_variable)
					 && (strncmp(ptr->variable->name, "ECPGprepared_statement", strlen("ECPGprepared_statement")) == 0))
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type != ECPGt_varchar
					  && ptr->variable->type->type != ECPGt_char
					  && ptr->variable->type->type != ECPGt_unsigned_char
					  && ptr->variable->type->type != ECPGt_string)
					 && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, mm_strdup("("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->u.element->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type,
																			   mm_strdup("1"),
																			   ptr->variable->type->u.element->counter),
														  ptr->variable->type->size),
									  0);
			}
			else if ((ptr->variable->type->type == ECPGt_varchar
					  || ptr->variable->type->type == ECPGt_char
					  || ptr->variable->type->type == ECPGt_unsigned_char
					  || ptr->variable->type->type == ECPGt_string)
					 && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, mm_strdup("("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_simple_type(ptr->variable->type->type,
														   ptr->variable->type->size,
														   ptr->variable->type->counter),
									  0);
				if (ptr->variable->type->type == ECPGt_varchar)
					var_ptr = true;
			}
			else if (ptr->variable->type->type == ECPGt_struct
					 || ptr->variable->type->type == ECPGt_union)
			{
				newvar = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->variable->type->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
									  ECPGmake_struct_type(ptr->variable->type->u.members,
														   ptr->variable->type->type,
														   ptr->variable->type->type_name,
														   ptr->variable->type->struct_sizeof),
									  0);
				var_ptr = true;
			}
			else if (ptr->variable->type->type == ECPGt_array)
			{
				if (ptr->variable->type->u.element->type == ECPGt_struct
					|| ptr->variable->type->u.element->type == ECPGt_union)
				{
					newvar = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->variable->type->u.element->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
										  ECPGmake_struct_type(ptr->variable->type->u.element->u.members,
															   ptr->variable->type->u.element->type,
															   ptr->variable->type->u.element->type_name,
															   ptr->variable->type->u.element->struct_sizeof),
										  0);
				}
				else
				{
					newvar = new_variable(cat_str(4, mm_strdup("("),
												  mm_strdup(ecpg_type_name(ptr->variable->type->u.element->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type,
																				   ptr->variable->type->u.element->size,
																				   ptr->variable->type->u.element->counter),
															  ptr->variable->type->size),
										  0);
					var_ptr = true;
				}
			}
			else
			{
				newvar = new_variable(cat_str(4, mm_strdup("*("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_simple_type(ptr->variable->type->type,
														   ptr->variable->type->size,
														   ptr->variable->type->counter),
									  0);
				var_ptr = true;
			}

			/* create call to "ECPGset_var(<counter>, <connection>, <pointer>. <line number>)" */
			if (!skip_set_var)
			{
				sprintf(var_text, "%d, %s", ecpg_internal_var++, var_ptr ? "&(" : "(");
				result = cat_str(5, result, mm_strdup("ECPGset_var("),
								 mm_strdup(var_text), mm_strdup(original_var),
								 mm_strdup("), __LINE__);\n"));
			}

			/* now the indicator if there is one and it's not a global variable */
			if ((ptr->indicator->type->type == ECPGt_NO_INDICATOR) || (ptr->indicator->brace_level == 0))
			{
				newind = ptr->indicator;
			}
			else
			{
				/* change variable name to "ECPGget_var(<counter>)" */
				original_var = ptr->indicator->name;
				sprintf(var_text, "%d))", ecpg_internal_var);
				var_ptr = false;

				if (ptr->indicator->type->type == ECPGt_struct
					|| ptr->indicator->type->type == ECPGt_union)
				{
					newind = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->indicator->type->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
										  ECPGmake_struct_type(ptr->indicator->type->u.members,
															   ptr->indicator->type->type,
															   ptr->indicator->type->type_name,
															   ptr->indicator->type->struct_sizeof),
										  0);
					var_ptr = true;
				}
				else if (ptr->indicator->type->type == ECPGt_array)
				{
					if (ptr->indicator->type->u.element->type == ECPGt_struct
						|| ptr->indicator->type->u.element->type == ECPGt_union)
					{
						newind = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->indicator->type->u.element->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
											  ECPGmake_struct_type(ptr->indicator->type->u.element->u.members,
																   ptr->indicator->type->u.element->type,
																   ptr->indicator->type->u.element->type_name,
																   ptr->indicator->type->u.element->struct_sizeof),
											  0);
					}
					else
					{
						newind = new_variable(cat_str(4, mm_strdup("("),
													  mm_strdup(ecpg_type_name(ptr->indicator->type->u.element->type)),
													  mm_strdup(" *)(ECPGget_var("), mm_strdup(var_text)),
											  ECPGmake_array_type(ECPGmake_simple_type(ptr->indicator->type->u.element->type,
																					   ptr->indicator->type->u.element->size,
																					   ptr->indicator->type->u.element->counter),
																  ptr->indicator->type->size),
											  0);
						var_ptr = true;
					}
				}
				else if (atoi(ptr->indicator->type->size) > 1)
				{
					newind = new_variable(cat_str(4, mm_strdup("("),
												  mm_strdup(ecpg_type_name(ptr->indicator->type->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_simple_type(ptr->indicator->type->type,
															   ptr->indicator->type->size,
															   ptr->variable->type->counter),
										  0);
				}
				else
				{
					newind = new_variable(cat_str(4, mm_strdup("*("),
												  mm_strdup(ecpg_type_name(ptr->indicator->type->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_simple_type(ptr->indicator->type->type,
															   ptr->indicator->type->size,
															   ptr->variable->type->counter),
										  0);
					var_ptr = true;
				}

				/* create call to "ECPGset_var(<counter>, <pointer>. <line number>)" */
				sprintf(var_text, "%d, %s", ecpg_internal_var++, var_ptr ? "&(" : "(");
				result = cat_str(5, result, mm_strdup("ECPGset_var("),
								 mm_strdup(var_text), mm_strdup(original_var),
								 mm_strdup("), __LINE__);\n"));
			}

			add_variable_to_tail(&newlist, newvar, newind);
		}

		if (insert)
			cur->argsinsert_oos = newlist;
		else
			cur->argsresult_oos = newlist;
	}

	return result;
}

/* This tests whether the cursor was declared and opened in the same function. */
#define SAMEFUNC(cur)	\
	((cur->function == NULL) ||		\
	 (cur->function != NULL && strcmp(cur->function, current_function) == 0))

static struct cursor *
add_additional_variables(char *name, bool insert)
{
	struct cursor *ptr;
	struct arguments *p;
	int (* strcmp_fn)(const char *, const char *) = ((name[0] == ':' || name[0] == '"') ? strcmp : pg_strcasecmp);

	for (ptr = cur; ptr != NULL; ptr=ptr->next)
	{
		if (strcmp_fn(ptr->name, name) == 0)
			break;
	}

	if (ptr == NULL)
	{
		mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" does not exist", name);
		return NULL;
	}

	if (insert)
	{
		/* add all those input variables that were given earlier
		 * note that we have to append here but have to keep the existing order */
		for (p = (SAMEFUNC(ptr) ? ptr->argsinsert : ptr->argsinsert_oos); p; p = p->next)
			add_variable_to_tail(&argsinsert, p->variable, p->indicator);
	}

	/* add all those output variables that were given earlier */
	for (p = (SAMEFUNC(ptr) ? ptr->argsresult : ptr->argsresult_oos); p; p = p->next)
		add_variable_to_tail(&argsresult, p->variable, p->indicator);

	return ptr;
}

static void
add_typedef(char *name, char *dimension, char *length, enum ECPGttype type_enum,
			char *type_dimension, char *type_index, int initializer, int array)
{
	/* add entry to list */
	struct typedefs *ptr, *this;

	if ((type_enum == ECPGt_struct ||
		 type_enum == ECPGt_union) &&
		initializer == 1)
		mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in type definition");
	else if (INFORMIX_MODE && strcmp(name, "string") == 0)
		mmerror(PARSE_ERROR, ET_ERROR, "type name \"string\" is reserved in Informix mode");
	else
	{
		for (ptr = types; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp(name, ptr->name) == 0)
				/* re-definition is a bug */
				mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", name);
		}
		adjust_array(type_enum, &dimension, &length, type_dimension, type_index, array, true);

		this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

		/* initial definition */
		this->next = types;
		this->name = name;
		this->brace_level = braces_open;
		this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
		this->type->type_enum = type_enum;
		this->type->type_str = mm_strdup(name);
		this->type->type_dimension = dimension; /* dimension of array */
		this->type->type_index = length;	/* length of string */
		this->type->type_sizeof = ECPGstruct_sizeof;
		this->struct_member_list = (type_enum == ECPGt_struct || type_enum == ECPGt_union) ?
		ECPGstruct_member_dup(struct_member_list[struct_level]) : NULL;

		if (type_enum != ECPGt_varchar &&
			type_enum != ECPGt_char &&
			type_enum != ECPGt_unsigned_char &&
			type_enum != ECPGt_string &&
			atoi(this->type->type_index) >= 0)
			mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

		types = this;
	}
}

#line 651 "preproc.c" /* yacc.c:337  */
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "preproc.h".  */
#ifndef YY_BASE_YY_PREPROC_H_INCLUDED
# define YY_BASE_YY_PREPROC_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    SQL_ALLOCATE = 258,
    SQL_AUTOCOMMIT = 259,
    SQL_BOOL = 260,
    SQL_BREAK = 261,
    SQL_CALL = 262,
    SQL_CARDINALITY = 263,
    SQL_CONNECT = 264,
    SQL_COUNT = 265,
    SQL_DATETIME_INTERVAL_CODE = 266,
    SQL_DATETIME_INTERVAL_PRECISION = 267,
    SQL_DESCRIBE = 268,
    SQL_DESCRIPTOR = 269,
    SQL_DISCONNECT = 270,
    SQL_FOUND = 271,
    SQL_FREE = 272,
    SQL_GET = 273,
    SQL_GO = 274,
    SQL_GOTO = 275,
    SQL_IDENTIFIED = 276,
    SQL_INDICATOR = 277,
    SQL_KEY_MEMBER = 278,
    SQL_LENGTH = 279,
    SQL_LONG = 280,
    SQL_NULLABLE = 281,
    SQL_OCTET_LENGTH = 282,
    SQL_OPEN = 283,
    SQL_OUTPUT = 284,
    SQL_REFERENCE = 285,
    SQL_RETURNED_LENGTH = 286,
    SQL_RETURNED_OCTET_LENGTH = 287,
    SQL_SCALE = 288,
    SQL_SECTION = 289,
    SQL_SHORT = 290,
    SQL_SIGNED = 291,
    SQL_SQLERROR = 292,
    SQL_SQLPRINT = 293,
    SQL_SQLWARNING = 294,
    SQL_START = 295,
    SQL_STOP = 296,
    SQL_STRUCT = 297,
    SQL_UNSIGNED = 298,
    SQL_VAR = 299,
    SQL_WHENEVER = 300,
    S_ADD = 301,
    S_AND = 302,
    S_ANYTHING = 303,
    S_AUTO = 304,
    S_CONST = 305,
    S_DEC = 306,
    S_DIV = 307,
    S_DOTPOINT = 308,
    S_EQUAL = 309,
    S_EXTERN = 310,
    S_INC = 311,
    S_LSHIFT = 312,
    S_MEMPOINT = 313,
    S_MEMBER = 314,
    S_MOD = 315,
    S_MUL = 316,
    S_NEQUAL = 317,
    S_OR = 318,
    S_REGISTER = 319,
    S_RSHIFT = 320,
    S_STATIC = 321,
    S_SUB = 322,
    S_VOLATILE = 323,
    S_TYPEDEF = 324,
    CSTRING = 325,
    CVARIABLE = 326,
    CPP_LINE = 327,
    IP = 328,
    DOLCONST = 329,
    ECONST = 330,
    NCONST = 331,
    UCONST = 332,
    UIDENT = 333,
    IDENT = 334,
    FCONST = 335,
    SCONST = 336,
    BCONST = 337,
    XCONST = 338,
    Op = 339,
    ICONST = 340,
    PARAM = 341,
    TYPECAST = 342,
    DOT_DOT = 343,
    COLON_EQUALS = 344,
    EQUALS_GREATER = 345,
    LESS_EQUALS = 346,
    GREATER_EQUALS = 347,
    NOT_EQUALS = 348,
    ABORT_P = 349,
    ABSOLUTE_P = 350,
    ACCESS = 351,
    ACTION = 352,
    ADD_P = 353,
    ADMIN = 354,
    AFTER = 355,
    AGGREGATE = 356,
    ALL = 357,
    ALSO = 358,
    ALTER = 359,
    ALWAYS = 360,
    ANALYSE = 361,
    ANALYZE = 362,
    AND = 363,
    ANY = 364,
    ARRAY = 365,
    AS = 366,
    ASC = 367,
    ASSERTION = 368,
    ASSIGNMENT = 369,
    ASYMMETRIC = 370,
    AT = 371,
    ATTRIBUTE = 372,
    AUTHORIZATION = 373,
    BACKWARD = 374,
    BEFORE = 375,
    BEGIN_P = 376,
    BETWEEN = 377,
    BIGINT = 378,
    BINARY = 379,
    BIT = 380,
    BOOLEAN_P = 381,
    BOTH = 382,
    BY = 383,
    CACHE = 384,
    CALLED = 385,
    CASCADE = 386,
    CASCADED = 387,
    CASE = 388,
    CAST = 389,
    CATALOG_P = 390,
    CHAIN = 391,
    CHAR_P = 392,
    CHARACTER = 393,
    CHARACTERISTICS = 394,
    CHECK = 395,
    CHECKPOINT = 396,
    CLASS = 397,
    CLOSE = 398,
    CLUSTER = 399,
    COALESCE = 400,
    COLLATE = 401,
    COLLATION = 402,
    COLUMN = 403,
    COMMENT = 404,
    COMMENTS = 405,
    COMMIT = 406,
    COMMITTED = 407,
    CONCURRENTLY = 408,
    CONFIGURATION = 409,
    CONFLICT = 410,
    CONNECTION = 411,
    CONSTRAINT = 412,
    CONSTRAINTS = 413,
    CONTENT_P = 414,
    CONTINUE_P = 415,
    CONVERSION_P = 416,
    COPY = 417,
    COST = 418,
    CREATE = 419,
    CROSS = 420,
    CSV = 421,
    CUBE = 422,
    CURRENT_P = 423,
    CURRENT_CATALOG = 424,
    CURRENT_DATE = 425,
    CURRENT_ROLE = 426,
    CURRENT_SCHEMA = 427,
    CURRENT_TIME = 428,
    CURRENT_TIMESTAMP = 429,
    CURRENT_USER = 430,
    CURSOR = 431,
    CYCLE = 432,
    DATA_P = 433,
    DATABASE = 434,
    DAY_P = 435,
    DEALLOCATE = 436,
    DEC = 437,
    DECIMAL_P = 438,
    DECLARE = 439,
    DEFAULT = 440,
    DEFAULTS = 441,
    DEFERRABLE = 442,
    DEFERRED = 443,
    DEFINER = 444,
    DELETE_P = 445,
    DELIMITER = 446,
    DELIMITERS = 447,
    DEPENDS = 448,
    DESC = 449,
    DICTIONARY = 450,
    DISABLE_P = 451,
    DISCARD = 452,
    DISTINCT = 453,
    DO = 454,
    DOCUMENT_P = 455,
    DOMAIN_P = 456,
    DOUBLE_P = 457,
    DROP = 458,
    EACH = 459,
    ELSE = 460,
    ENABLE_P = 461,
    ENCODING = 462,
    ENCRYPTED = 463,
    END_P = 464,
    ENUM_P = 465,
    ESCAPE = 466,
    EVENT = 467,
    EXCEPT = 468,
    EXCLUDE = 469,
    EXCLUDING = 470,
    EXCLUSIVE = 471,
    EXECUTE = 472,
    EXISTS = 473,
    EXPLAIN = 474,
    EXTENSION = 475,
    EXTERNAL = 476,
    EXTRACT = 477,
    FALSE_P = 478,
    FAMILY = 479,
    FETCH = 480,
    FILTER = 481,
    FIRST_P = 482,
    FLOAT_P = 483,
    FOLLOWING = 484,
    FOR = 485,
    FORCE = 486,
    FOREIGN = 487,
    FORWARD = 488,
    FREEZE = 489,
    FROM = 490,
    FULL = 491,
    FUNCTION = 492,
    FUNCTIONS = 493,
    GLOBAL = 494,
    GRANT = 495,
    GRANTED = 496,
    GREATEST = 497,
    GROUP_P = 498,
    GROUPING = 499,
    HANDLER = 500,
    HAVING = 501,
    HEADER_P = 502,
    HOLD = 503,
    HOUR_P = 504,
    IDENTITY_P = 505,
    IF_P = 506,
    ILIKE = 507,
    IMMEDIATE = 508,
    IMMUTABLE = 509,
    IMPLICIT_P = 510,
    IMPORT_P = 511,
    IN_P = 512,
    INCLUDING = 513,
    INCREMENT = 514,
    INDEX = 515,
    INDEXES = 516,
    INHERIT = 517,
    INHERITS = 518,
    INITIALLY = 519,
    INLINE_P = 520,
    INNER_P = 521,
    INOUT = 522,
    INPUT_P = 523,
    INSENSITIVE = 524,
    INSERT = 525,
    INSTEAD = 526,
    INT_P = 527,
    INTEGER = 528,
    INTERSECT = 529,
    INTERVAL = 530,
    INTO = 531,
    INVOKER = 532,
    IS = 533,
    ISNULL = 534,
    ISOLATION = 535,
    JOIN = 536,
    KEY = 537,
    LABEL = 538,
    LANGUAGE = 539,
    LARGE_P = 540,
    LAST_P = 541,
    LATERAL_P = 542,
    LEADING = 543,
    LEAKPROOF = 544,
    LEAST = 545,
    LEFT = 546,
    LEVEL = 547,
    LIKE = 548,
    LIMIT = 549,
    LISTEN = 550,
    LOAD = 551,
    LOCAL = 552,
    LOCALTIME = 553,
    LOCALTIMESTAMP = 554,
    LOCATION = 555,
    LOCK_P = 556,
    LOCKED = 557,
    LOGGED = 558,
    MAPPING = 559,
    MATCH = 560,
    MATERIALIZED = 561,
    MAXVALUE = 562,
    METHOD = 563,
    MINUTE_P = 564,
    MINVALUE = 565,
    MODE = 566,
    MONTH_P = 567,
    MOVE = 568,
    NAME_P = 569,
    NAMES = 570,
    NATIONAL = 571,
    NATURAL = 572,
    NCHAR = 573,
    NEXT = 574,
    NO = 575,
    NONE = 576,
    NOT = 577,
    NOTHING = 578,
    NOTIFY = 579,
    NOTNULL = 580,
    NOWAIT = 581,
    NULL_P = 582,
    NULLIF = 583,
    NULLS_P = 584,
    NUMERIC = 585,
    OBJECT_P = 586,
    OF = 587,
    OFF = 588,
    OFFSET = 589,
    OIDS = 590,
    ON = 591,
    ONLY = 592,
    OPERATOR = 593,
    OPTION = 594,
    OPTIONS = 595,
    OR = 596,
    ORDER = 597,
    ORDINALITY = 598,
    OUT_P = 599,
    OUTER_P = 600,
    OVER = 601,
    OVERLAPS = 602,
    OVERLAY = 603,
    OWNED = 604,
    OWNER = 605,
    PARALLEL = 606,
    PARSER = 607,
    PARTIAL = 608,
    PARTITION = 609,
    PASSING = 610,
    PASSWORD = 611,
    PLACING = 612,
    PLANS = 613,
    POLICY = 614,
    POSITION = 615,
    PRECEDING = 616,
    PRECISION = 617,
    PRESERVE = 618,
    PREPARE = 619,
    PREPARED = 620,
    PRIMARY = 621,
    PRIOR = 622,
    PRIVILEGES = 623,
    PROCEDURAL = 624,
    PROCEDURE = 625,
    PROGRAM = 626,
    QUOTE = 627,
    RANGE = 628,
    READ = 629,
    REAL = 630,
    REASSIGN = 631,
    RECHECK = 632,
    RECURSIVE = 633,
    REF = 634,
    REFERENCES = 635,
    REFRESH = 636,
    REINDEX = 637,
    RELATIVE_P = 638,
    RELEASE = 639,
    RENAME = 640,
    REPEATABLE = 641,
    REPLACE = 642,
    REPLICA = 643,
    RESET = 644,
    RESTART = 645,
    RESTRICT = 646,
    RETURNING = 647,
    RETURNS = 648,
    REVOKE = 649,
    RIGHT = 650,
    ROLE = 651,
    ROLLBACK = 652,
    ROLLUP = 653,
    ROW = 654,
    ROWS = 655,
    RULE = 656,
    SAVEPOINT = 657,
    SCHEMA = 658,
    SCROLL = 659,
    SEARCH = 660,
    SECOND_P = 661,
    SECURITY = 662,
    SELECT = 663,
    SEQUENCE = 664,
    SEQUENCES = 665,
    SERIALIZABLE = 666,
    SERVER = 667,
    SESSION = 668,
    SESSION_USER = 669,
    SET = 670,
    SETS = 671,
    SETOF = 672,
    SHARE = 673,
    SHOW = 674,
    SIMILAR = 675,
    SIMPLE = 676,
    SKIP = 677,
    SMALLINT = 678,
    SNAPSHOT = 679,
    SOME = 680,
    SQL_P = 681,
    STABLE = 682,
    STANDALONE_P = 683,
    START = 684,
    STATEMENT = 685,
    STATISTICS = 686,
    STDIN = 687,
    STDOUT = 688,
    STORAGE = 689,
    STRICT_P = 690,
    STRIP_P = 691,
    SUBSTRING = 692,
    SYMMETRIC = 693,
    SYSID = 694,
    SYSTEM_P = 695,
    TABLE = 696,
    TABLES = 697,
    TABLESAMPLE = 698,
    TABLESPACE = 699,
    TEMP = 700,
    TEMPLATE = 701,
    TEMPORARY = 702,
    TEXT_P = 703,
    THEN = 704,
    TIME = 705,
    TIMESTAMP = 706,
    TO = 707,
    TRAILING = 708,
    TRANSACTION = 709,
    TRANSFORM = 710,
    TREAT = 711,
    TRIGGER = 712,
    TRIM = 713,
    TRUE_P = 714,
    TRUNCATE = 715,
    TRUSTED = 716,
    TYPE_P = 717,
    TYPES_P = 718,
    UNBOUNDED = 719,
    UNCOMMITTED = 720,
    UNENCRYPTED = 721,
    UNION = 722,
    UNIQUE = 723,
    UNKNOWN = 724,
    UNLISTEN = 725,
    UNLOGGED = 726,
    UNTIL = 727,
    UPDATE = 728,
    USER = 729,
    USING = 730,
    VACUUM = 731,
    VALID = 732,
    VALIDATE = 733,
    VALIDATOR = 734,
    VALUE_P = 735,
    VALUES = 736,
    VARCHAR = 737,
    VARIADIC = 738,
    VARYING = 739,
    VERBOSE = 740,
    VERSION_P = 741,
    VIEW = 742,
    VIEWS = 743,
    VOLATILE = 744,
    WHEN = 745,
    WHERE = 746,
    WHITESPACE_P = 747,
    WINDOW = 748,
    WITH = 749,
    WITHIN = 750,
    WITHOUT = 751,
    WORK = 752,
    WRAPPER = 753,
    WRITE = 754,
    XML_P = 755,
    XMLATTRIBUTES = 756,
    XMLCONCAT = 757,
    XMLELEMENT = 758,
    XMLEXISTS = 759,
    XMLFOREST = 760,
    XMLPARSE = 761,
    XMLPI = 762,
    XMLROOT = 763,
    XMLSERIALIZE = 764,
    YEAR_P = 765,
    YES_P = 766,
    ZONE = 767,
    NOT_LA = 768,
    NULLS_LA = 769,
    WITH_LA = 770,
    POSTFIXOP = 771,
    UMINUS = 772
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 581 "preproc.y" /* yacc.c:352  */

	double	dval;
	char	*str;
	int		ival;
	struct	when		action;
	struct	index		index;
	int		tagname;
	struct	this_type	type;
	enum	ECPGttype	type_enum;
	enum	ECPGdtype	dtype_enum;
	struct	fetch_desc	descriptor;
	struct  su_symbol	struct_union;
	struct	prep		prep;

#line 1227 "preproc.c" /* yacc.c:352  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE base_yylval;
extern YYLTYPE base_yylloc;
int base_yyparse (void);

#endif /* !YY_BASE_YY_PREPROC_H_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   128259

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  537
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  762
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2992
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5663

#define YYUNDEFTOK  2
#define YYMAXUTOK   772

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   524,     2,     2,
     529,   530,   522,   520,   532,   521,   531,   523,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   534,   533,
     516,   518,   517,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   527,     2,   528,   525,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   535,     2,   536,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   519,   526
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,  1561,  1561,  1564,  1566,  1568,  1570,  1572,  1574,  1576,
    1578,  1580,  1582,  1584,  1586,  1588,  1590,  1592,  1594,  1596,
    1598,  1600,  1602,  1604,  1606,  1608,  1610,  1612,  1614,  1616,
    1618,  1620,  1622,  1624,  1626,  1628,  1646,  1648,  1650,  1652,
    1654,  1656,  1658,  1660,  1662,  1664,  1666,  1668,  1670,  1672,
    1674,  1676,  1678,  1680,  1682,  1684,  1686,  1688,  1690,  1692,
    1694,  1696,  1698,  1700,  1702,  1704,  1706,  1708,  1710,  1712,
    1716,  1718,  1720,  1722,  1724,  1726,  1728,  1730,  1732,  1734,
    1736,  1738,  1740,  1742,  1744,  1746,  1748,  1750,  1752,  1754,
    1756,  1758,  1760,  1762,  1764,  1766,  1768,  1770,  1772,  1774,
    1776,  1778,  1780,  1782,  1784,  1786,  1788,  1790,  1797,  1799,
    1801,  1803,  1805,  1807,  1809,  1811,  1813,  1815,  1817,  1819,
    1825,  1827,  1829,  1831,  1833,  1835,  1837,  1839,  1841,  1847,
    1857,  1861,  1867,  1871,  1881,  1891,  1892,  1906,  1913,  1919,
    1930,  1936,  1945,  1952,  1958,  1967,  1974,  1982,  1987,  1995,
    1999,  2004,  2010,  2015,  2021,  2026,  2032,  2036,  2040,  2044,
    2048,  2052,  2056,  2060,  2064,  2072,  2076,  2080,  2084,  2088,
    2092,  2100,  2108,  2117,  2119,  2127,  2131,  2139,  2147,  2151,
    2159,  2163,  2171,  2175,  2183,  2191,  2199,  2203,  2211,  2215,
    2223,  2227,  2231,  2236,  2245,  2250,  2256,  2261,  2267,  2271,
    2275,  2279,  2283,  2287,  2295,  2299,  2303,  2311,  2315,  2319,
    2327,  2331,  2335,  2339,  2347,  2351,  2355,  2359,  2364,  2368,
    2372,  2376,  2380,  2384,  2388,  2396,  2400,  2408,  2412,  2420,
    2424,  2438,  2442,  2446,  2450,  2458,  2462,  2466,  2470,  2478,
    2482,  2486,  2490,  2494,  2498,  2502,  2510,  2514,  2519,  2525,
    2529,  2537,  2545,  2549,  2553,  2557,  2565,  2569,  2577,  2581,
    2589,  2593,  2601,  2605,  2609,  2613,  2617,  2626,  2634,  2638,
    2646,  2650,  2658,  2666,  2670,  2674,  2678,  2682,  2690,  2694,
    2698,  2702,  2706,  2710,  2714,  2718,  2722,  2726,  2730,  2734,
    2738,  2742,  2746,  2750,  2758,  2762,  2770,  2774,  2778,  2782,
    2786,  2790,  2794,  2798,  2802,  2806,  2810,  2814,  2818,  2822,
    2826,  2830,  2834,  2838,  2842,  2846,  2850,  2854,  2858,  2862,
    2866,  2870,  2874,  2878,  2882,  2886,  2890,  2894,  2898,  2902,
    2906,  2910,  2914,  2918,  2922,  2926,  2930,  2934,  2938,  2942,
    2946,  2950,  2954,  2958,  2962,  2966,  2970,  2974,  2982,  2986,
    2994,  2998,  3003,  3009,  3014,  3020,  3025,  3031,  3035,  3039,
    3043,  3051,  3059,  3064,  3070,  3074,  3082,  3086,  3090,  3094,
    3102,  3110,  3114,  3122,  3126,  3130,  3134,  3142,  3147,  3155,
    3163,  3171,  3175,  3183,  3188,  3194,  3198,  3202,  3210,  3214,
    3222,  3227,  3233,  3237,  3241,  3245,  3249,  3253,  3257,  3261,
    3265,  3269,  3273,  3277,  3281,  3285,  3293,  3298,  3304,  3309,
    3315,  3320,  3326,  3331,  3337,  3341,  3349,  3357,  3361,  3365,
    3369,  3374,  3380,  3384,  3392,  3400,  3404,  3408,  3412,  3420,
    3424,  3428,  3432,  3436,  3440,  3444,  3449,  3455,  3460,  3466,
    3471,  3477,  3481,  3489,  3493,  3501,  3505,  3509,  3517,  3521,
    3529,  3537,  3545,  3550,  3556,  3560,  3564,  3568,  3576,  3580,
    3584,  3588,  3592,  3596,  3600,  3608,  3612,  3616,  3620,  3628,
    3636,  3640,  3645,  3651,  3655,  3659,  3663,  3667,  3671,  3679,
    3683,  3691,  3695,  3699,  3703,  3707,  3711,  3715,  3723,  3728,
    3734,  3739,  3745,  3749,  3757,  3765,  3769,  3774,  3779,  3785,
    3789,  3797,  3801,  3809,  3814,  3820,  3824,  3828,  3832,  3837,
    3843,  3851,  3859,  3863,  3867,  3871,  3875,  3883,  3888,  3894,
    3898,  3902,  3907,  3913,  3917,  3921,  3926,  3932,  3937,  3943,
    3948,  3954,  3962,  3970,  3974,  3979,  3985,  3989,  3997,  4005,
    4010,  4016,  4024,  4028,  4036,  4040,  4048,  4053,  4059,  4063,
    4071,  4075,  4079,  4083,  4087,  4091,  4095,  4099,  4103,  4107,
    4111,  4115,  4123,  4128,  4134,  4138,  4142,  4146,  4154,  4158,
    4166,  4170,  4178,  4183,  4189,  4193,  4201,  4206,  4212,  4216,
    4224,  4229,  4235,  4239,  4247,  4252,  4258,  4266,  4271,  4277,
    4281,  4289,  4293,  4301,  4306,  4312,  4316,  4320,  4324,  4332,
    4340,  4345,  4351,  4359,  4363,  4367,  4371,  4375,  4379,  4383,
    4387,  4391,  4395,  4399,  4403,  4407,  4411,  4415,  4419,  4423,
    4427,  4431,  4435,  4439,  4443,  4447,  4451,  4455,  4459,  4467,
    4475,  4479,  4483,  4487,  4495,  4499,  4507,  4512,  4518,  4522,
    4530,  4534,  4542,  4547,  4553,  4557,  4565,  4573,  4577,  4585,
    4589,  4593,  4597,  4605,  4613,  4621,  4629,  4637,  4642,  4648,
    4652,  4660,  4665,  4671,  4675,  4683,  4687,  4691,  4699,  4703,
    4711,  4715,  4723,  4731,  4735,  4743,  4748,  4754,  4762,  4766,
    4774,  4778,  4786,  4794,  4802,  4810,  4814,  4822,  4827,  4833,
    4838,  4844,  4849,  4855,  4860,  4866,  4871,  4877,  4881,  4885,
    4889,  4893,  4901,  4909,  4913,  4921,  4925,  4929,  4937,  4941,
    4949,  4953,  4957,  4961,  4965,  4973,  4978,  4984,  4989,  4995,
    4999,  5007,  5012,  5018,  5022,  5027,  5033,  5037,  5041,  5045,
    5053,  5058,  5065,  5067,  5075,  5079,  5083,  5087,  5091,  5095,
    5103,  5107,  5115,  5119,  5127,  5131,  5139,  5147,  5151,  5159,
    5167,  5171,  5175,  5179,  5187,  5196,  5205,  5209,  5213,  5217,
    5221,  5225,  5229,  5233,  5237,  5241,  5245,  5249,  5253,  5257,
    5265,  5273,  5277,  5285,  5289,  5297,  5301,  5305,  5309,  5313,
    5321,  5329,  5333,  5341,  5349,  5354,  5360,  5364,  5372,  5376,
    5380,  5388,  5393,  5399,  5407,  5411,  5419,  5423,  5427,  5431,
    5435,  5443,  5448,  5454,  5459,  5465,  5469,  5474,  5480,  5486,
    5492,  5500,  5504,  5512,  5516,  5524,  5528,  5536,  5540,  5548,
    5552,  5560,  5568,  5576,  5580,  5584,  5588,  5592,  5596,  5600,
    5604,  5612,  5616,  5620,  5624,  5628,  5632,  5636,  5640,  5644,
    5648,  5652,  5656,  5660,  5664,  5668,  5672,  5680,  5684,  5692,
    5696,  5704,  5708,  5716,  5720,  5728,  5736,  5740,  5745,  5751,
    5755,  5759,  5763,  5767,  5771,  5775,  5779,  5783,  5787,  5791,
    5795,  5799,  5803,  5807,  5811,  5815,  5819,  5827,  5831,  5835,
    5839,  5843,  5847,  5851,  5855,  5859,  5863,  5867,  5871,  5875,
    5879,  5883,  5887,  5891,  5895,  5899,  5903,  5907,  5911,  5919,
    5923,  5931,  5935,  5939,  5943,  5947,  5951,  5955,  5963,  5968,
    5974,  5978,  5982,  5986,  5990,  5994,  5998,  6002,  6006,  6010,
    6014,  6022,  6026,  6034,  6038,  6042,  6046,  6052,  6058,  6064,
    6070,  6076,  6082,  6088,  6098,  6109,  6120,  6131,  6142,  6153,
    6164,  6180,  6196,  6212,  6223,  6239,  6250,  6266,  6281,  6285,
    6293,  6298,  6304,  6312,  6316,  6324,  6328,  6332,  6336,  6340,
    6348,  6352,  6360,  6364,  6368,  6372,  6380,  6384,  6388,  6392,
    6396,  6400,  6404,  6408,  6412,  6416,  6420,  6424,  6428,  6432,
    6436,  6440,  6448,  6452,  6460,  6464,  6472,  6477,  6483,  6487,
    6495,  6503,  6511,  6515,  6523,  6528,  6534,  6539,  6545,  6553,
    6558,  6564,  6568,  6572,  6580,  6584,  6588,  6596,  6600,  6604,
    6608,  6616,  6620,  6628,  6633,  6639,  6644,  6650,  6655,  6661,
    6666,  6672,  6676,  6684,  6688,  6692,  6700,  6705,  6711,  6716,
    6722,  6726,  6731,  6737,  6741,  6746,  6752,  6756,  6760,  6768,
    6773,  6779,  6783,  6791,  6795,  6803,  6807,  6815,  6819,  6827,
    6831,  6835,  6839,  6843,  6851,  6855,  6859,  6863,  6867,  6875,
    6883,  6891,  6895,  6899,  6907,  6911,  6915,  6923,  6932,  6936,
    6940,  6944,  6952,  6956,  6964,  6968,  6976,  6980,  6984,  6988,
    6992,  6996,  7000,  7004,  7008,  7012,  7016,  7020,  7024,  7028,
    7032,  7036,  7044,  7048,  7052,  7056,  7060,  7068,  7072,  7080,
    7084,  7092,  7097,  7103,  7111,  7115,  7123,  7131,  7135,  7143,
    7148,  7154,  7158,  7166,  7170,  7178,  7182,  7190,  7194,  7198,
    7202,  7210,  7214,  7222,  7230,  7234,  7242,  7246,  7254,  7258,
    7262,  7270,  7274,  7279,  7285,  7293,  7298,  7304,  7312,  7316,
    7320,  7324,  7332,  7340,  7344,  7348,  7352,  7360,  7364,  7372,
    7376,  7380,  7388,  7392,  7400,  7408,  7412,  7420,  7424,  7428,
    7432,  7436,  7440,  7444,  7448,  7452,  7456,  7460,  7464,  7468,
    7472,  7476,  7480,  7484,  7488,  7492,  7496,  7500,  7504,  7508,
    7512,  7516,  7520,  7524,  7528,  7532,  7536,  7540,  7544,  7548,
    7552,  7556,  7560,  7564,  7568,  7572,  7576,  7580,  7584,  7588,
    7592,  7596,  7600,  7604,  7608,  7616,  7621,  7627,  7632,  7638,
    7642,  7646,  7650,  7658,  7662,  7666,  7670,  7674,  7678,  7682,
    7686,  7690,  7694,  7698,  7702,  7706,  7710,  7714,  7718,  7722,
    7726,  7730,  7734,  7738,  7742,  7746,  7750,  7758,  7766,  7770,
    7778,  7782,  7790,  7794,  7798,  7802,  7806,  7810,  7814,  7818,
    7822,  7826,  7830,  7834,  7838,  7842,  7846,  7850,  7854,  7858,
    7862,  7870,  7878,  7882,  7886,  7894,  7898,  7906,  7910,  7914,
    7918,  7922,  7930,  7935,  7941,  7945,  7949,  7953,  7961,  7965,
    7970,  7976,  7980,  7988,  7996,  8001,  8007,  8015,  8019,  8027,
    8031,  8035,  8039,  8043,  8047,  8051,  8055,  8059,  8063,  8067,
    8071,  8075,  8079,  8087,  8091,  8096,  8102,  8106,  8110,  8114,
    8118,  8126,  8130,  8134,  8142,  8147,  8153,  8157,  8161,  8166,
    8175,  8179,  8183,  8188,  8194,  8202,  8210,  8215,  8221,  8225,
    8233,  8237,  8241,  8249,  8253,  8257,  8261,  8265,  8269,  8273,
    8281,  8286,  8292,  8296,  8300,  8308,  8316,  8320,  8328,  8332,
    8340,  8348,  8352,  8356,  8360,  8364,  8368,  8372,  8380,  8385,
    8391,  8399,  8403,  8407,  8411,  8415,  8419,  8427,  8431,  8439,
    8447,  8451,  8455,  8463,  8468,  8474,  8478,  8482,  8486,  8490,
    8498,  8502,  8510,  8514,  8518,  8522,  8526,  8534,  8538,  8546,
    8550,  8558,  8563,  8569,  8574,  8580,  8585,  8591,  8596,  8602,
    8606,  8610,  8614,  8622,  8626,  8630,  8634,  8638,  8642,  8646,
    8650,  8654,  8662,  8666,  8674,  8682,  8686,  8694,  8698,  8703,
    8709,  8715,  8725,  8730,  8736,  8740,  8744,  8748,  8756,  8758,
    8762,  8770,  8775,  8781,  8789,  8793,  8801,  8805,  8809,  8817,
    8821,  8829,  8837,  8841,  8846,  8852,  8856,  8861,  8867,  8872,
    8878,  8886,  8891,  8897,  8905,  8910,  8916,  8920,  8924,  8928,
    8932,  8936,  8940,  8944,  8952,  8957,  8963,  8967,  8972,  8978,
    8986,  8990,  8998,  9002,  9010,  9018,  9022,  9030,  9038,  9042,
    9050,  9103,  9107,  9120,  9122,  9126,  9130,  9134,  9143,  9149,
    9153,  9161,  9165,  9173,  9177,  9185,  9189,  9193,  9197,  9201,
    9205,  9209,  9213,  9221,  9225,  9233,  9237,  9241,  9245,  9249,
    9253,  9257,  9265,  9269,  9273,  9281,  9285,  9293,  9301,  9306,
    9312,  9317,  9319,  9325,  9329,  9333,  9337,  9341,  9345,  9349,
    9353,  9357,  9365,  9370,  9376,  9380,  9385,  9391,  9395,  9403,
    9408,  9414,  9419,  9425,  9433,  9437,  9445,  9449,  9457,  9461,
    9465,  9469,  9477,  9482,  9488,  9492,  9497,  9501,  9509,  9513,
    9521,  9525,  9533,  9541,  9545,  9549,  9557,  9561,  9569,  9573,
    9581,  9585,  9593,  9598,  9604,  9608,  9616,  9620,  9624,  9628,
    9632,  9640,  9648,  9656,  9664,  9672,  9677,  9683,  9687,  9695,
    9700,  9706,  9710,  9718,  9726,  9730,  9734,  9738,  9746,  9751,
    9757,  9761,  9769,  9774,  9780,  9784,  9792,  9796,  9800,  9804,
    9808,  9815,  9822,  9826,  9834,  9838,  9842,  9846,  9850,  9854,
    9862,  9866,  9870,  9874,  9882,  9887,  9893,  9897,  9901,  9905,
    9910,  9916,  9920,  9924,  9928,  9936,  9941,  9947,  9951,  9959,
    9963,  9967,  9971,  9979,  9983,  9991,  9995,  9999, 10007, 10015,
   10020, 10026, 10030, 10038, 10046, 10050, 10058, 10063, 10069, 10074,
   10080, 10085, 10091, 10095, 10101, 10107, 10112, 10118, 10122, 10130,
   10138, 10140, 10142, 10146, 10150, 10154, 10162, 10172, 10183, 10192,
   10196, 10200, 10204, 10208, 10212, 10216, 10224, 10228, 10232, 10236,
   10244, 10248, 10256, 10261, 10267, 10271, 10275, 10279, 10283, 10287,
   10291, 10295, 10299, 10303, 10307, 10315, 10320, 10326, 10330, 10338,
   10342, 10350, 10358, 10366, 10370, 10378, 10382, 10390, 10398, 10406,
   10410, 10414, 10418, 10422, 10426, 10434, 10439, 10445, 10450, 10456,
   10460, 10464, 10468, 10476, 10484, 10488, 10493, 10499, 10503, 10507,
   10511, 10515, 10519, 10523, 10527, 10531, 10535, 10539, 10543, 10547,
   10552, 10558, 10562, 10570, 10574, 10578, 10582, 10586, 10590, 10594,
   10598, 10602, 10606, 10610, 10614, 10618, 10622, 10626, 10630, 10634,
   10638, 10642, 10646, 10650, 10654, 10658, 10662, 10666, 10670, 10674,
   10678, 10682, 10686, 10690, 10694, 10698, 10702, 10706, 10710, 10714,
   10718, 10722, 10726, 10730, 10734, 10738, 10742, 10746, 10750, 10754,
   10758, 10762, 10766, 10770, 10774, 10778, 10782, 10786, 10790, 10794,
   10798, 10802, 10806, 10810, 10815, 10819, 10827, 10831, 10835, 10839,
   10843, 10847, 10851, 10855, 10859, 10863, 10867, 10871, 10875, 10879,
   10883, 10887, 10891, 10895, 10899, 10903, 10907, 10911, 10915, 10919,
   10923, 10931, 10935, 10939, 10943, 10947, 10951, 10955, 10959, 10963,
   10967, 10971, 10975, 10979, 10983, 10991, 10995, 10999, 11003, 11007,
   11011, 11015, 11023, 11027, 11035, 11039, 11047, 11051, 11055, 11059,
   11063, 11067, 11071, 11075, 11079, 11083, 11087, 11091, 11095, 11099,
   11103, 11107, 11111, 11115, 11119, 11123, 11127, 11131, 11135, 11139,
   11143, 11147, 11151, 11155, 11159, 11163, 11167, 11171, 11175, 11179,
   11183, 11187, 11191, 11195, 11199, 11203, 11207, 11211, 11219, 11223,
   11231, 11235, 11239, 11244, 11250, 11258, 11262, 11270, 11274, 11282,
   11286, 11294, 11298, 11303, 11309, 11313, 11317, 11321, 11329, 11334,
   11340, 11345, 11351, 11356, 11362, 11366, 11374, 11382, 11386, 11391,
   11397, 11405, 11409, 11416, 11421, 11427, 11432, 11437, 11443, 11447,
   11455, 11459, 11463, 11467, 11471, 11479, 11483, 11487, 11495, 11499,
   11507, 11515, 11519, 11523, 11531, 11535, 11543, 11547, 11551, 11555,
   11559, 11563, 11567, 11571, 11575, 11579, 11583, 11587, 11595, 11599,
   11607, 11611, 11619, 11623, 11627, 11631, 11635, 11639, 11647, 11651,
   11659, 11663, 11671, 11675, 11679, 11687, 11691, 11699, 11703, 11707,
   11715, 11719, 11727, 11732, 11738, 11742, 11746, 11750, 11754, 11758,
   11762, 11766, 11774, 11778, 11786, 11794, 11799, 11805, 11809, 11813,
   11817, 11821, 11826, 11832, 11840, 11848, 11852, 11856, 11864, 11868,
   11876, 11884, 11888, 11896, 11904, 11909, 11915, 11920, 11926, 11930,
   11938, 11942, 11946, 11950, 11958, 11963, 11969, 11973, 11982, 11984,
   11992, 11997, 12003, 12007, 12015, 12019, 12027, 12035, 12040, 12046,
   12050, 12058, 12062, 12066, 12070, 12078, 12082, 12090, 12094, 12102,
   12106, 12114, 12122, 12130, 12138, 12146, 12154, 12162, 12166, 12174,
   12178, 12182, 12186, 12190, 12194, 12198, 12202, 12206, 12210, 12214,
   12218, 12222, 12226, 12227, 12232, 12238, 12242, 12243, 12247, 12255,
   12263, 12267, 12271, 12279, 12283, 12291, 12295, 12299, 12303, 12311,
   12315, 12319, 12323, 12327, 12331, 12335, 12339, 12343, 12347, 12351,
   12355, 12359, 12363, 12367, 12371, 12375, 12379, 12383, 12387, 12391,
   12395, 12399, 12403, 12407, 12411, 12415, 12419, 12423, 12427, 12431,
   12435, 12439, 12443, 12447, 12451, 12455, 12459, 12463, 12467, 12471,
   12475, 12479, 12483, 12487, 12491, 12495, 12499, 12503, 12507, 12511,
   12515, 12519, 12523, 12527, 12531, 12535, 12539, 12543, 12547, 12551,
   12555, 12559, 12563, 12567, 12571, 12575, 12579, 12583, 12587, 12591,
   12595, 12599, 12603, 12607, 12611, 12615, 12619, 12623, 12627, 12631,
   12635, 12639, 12643, 12647, 12651, 12655, 12659, 12663, 12667, 12671,
   12675, 12679, 12683, 12687, 12691, 12695, 12699, 12703, 12707, 12711,
   12715, 12719, 12723, 12727, 12731, 12735, 12739, 12743, 12747, 12751,
   12755, 12759, 12763, 12767, 12771, 12775, 12779, 12783, 12787, 12791,
   12795, 12799, 12803, 12807, 12811, 12815, 12819, 12823, 12827, 12831,
   12835, 12839, 12843, 12847, 12851, 12855, 12859, 12863, 12867, 12871,
   12875, 12879, 12883, 12887, 12891, 12895, 12899, 12903, 12907, 12911,
   12915, 12919, 12923, 12927, 12931, 12935, 12939, 12943, 12947, 12951,
   12955, 12959, 12963, 12967, 12971, 12975, 12979, 12983, 12987, 12991,
   12995, 12999, 13003, 13007, 13011, 13015, 13019, 13023, 13027, 13031,
   13035, 13039, 13043, 13047, 13051, 13055, 13059, 13063, 13067, 13071,
   13075, 13079, 13083, 13087, 13091, 13095, 13099, 13103, 13107, 13111,
   13115, 13119, 13123, 13127, 13131, 13135, 13139, 13143, 13147, 13151,
   13155, 13159, 13163, 13167, 13171, 13175, 13179, 13183, 13187, 13191,
   13195, 13199, 13203, 13207, 13211, 13215, 13219, 13223, 13227, 13231,
   13235, 13239, 13243, 13247, 13251, 13255, 13259, 13263, 13267, 13271,
   13275, 13279, 13283, 13287, 13291, 13295, 13299, 13303, 13307, 13311,
   13315, 13319, 13323, 13327, 13331, 13335, 13339, 13343, 13347, 13351,
   13355, 13363, 13367, 13371, 13375, 13379, 13383, 13387, 13391, 13395,
   13399, 13403, 13407, 13411, 13415, 13419, 13423, 13427, 13431, 13435,
   13439, 13443, 13447, 13451, 13455, 13459, 13463, 13467, 13471, 13475,
   13479, 13483, 13487, 13491, 13495, 13499, 13503, 13507, 13511, 13515,
   13519, 13523, 13527, 13531, 13535, 13539, 13547, 13551, 13555, 13559,
   13563, 13567, 13571, 13575, 13579, 13583, 13587, 13591, 13595, 13599,
   13603, 13607, 13611, 13615, 13619, 13623, 13627, 13631, 13635, 13643,
   13647, 13651, 13655, 13659, 13663, 13667, 13671, 13675, 13679, 13683,
   13687, 13691, 13695, 13699, 13703, 13707, 13711, 13715, 13719, 13723,
   13727, 13731, 13735, 13739, 13743, 13747, 13751, 13755, 13759, 13763,
   13767, 13771, 13775, 13779, 13783, 13787, 13791, 13795, 13799, 13803,
   13807, 13811, 13815, 13819, 13823, 13827, 13831, 13835, 13839, 13843,
   13847, 13851, 13855, 13859, 13863, 13867, 13871, 13875, 13879, 13883,
   13887, 13891, 13895, 13899, 13903, 13907, 13911, 13915, 13919, 13923,
   13927, 13931, 13935, 13939, 13949, 13950, 13953, 13954, 13955, 13961,
   13962, 13963, 13964, 13965, 13978, 13978, 13985, 13985, 13994, 14009,
   14011, 14014, 14016, 14020, 14032, 14048, 14052, 14063, 14064, 14067,
   14079, 14088, 14089, 14092, 14093, 14094, 14097, 14098, 14101, 14102,
   14105, 14106, 14109, 14111, 14113, 14115, 14119, 14126, 14133, 14149,
   14183, 14193, 14196, 14200, 14213, 14214, 14216, 14218, 14222, 14236,
   14243, 14304, 14313, 14315, 14316, 14319, 14321, 14322, 14325, 14326,
   14327, 14328, 14329, 14336, 14335, 14345, 14347, 14349, 14350, 14353,
   14354, 14355, 14356, 14359, 14360, 14364, 14363, 14380, 14378, 14394,
   14393, 14407, 14413, 14414, 14417, 14419, 14420, 14423, 14424, 14425,
   14426, 14429, 14430, 14433, 14441, 14458, 14466, 14489, 14595, 14629,
   14631, 14633, 14637, 14641, 14640, 14691, 14693, 14692, 14707, 14713,
   14720, 14725, 14731, 14732, 14735, 14736, 14737, 14738, 14739, 14740,
   14741, 14749, 14757, 14760, 14761, 14762, 14763, 14764, 14765, 14773,
   14781, 14782, 14783, 14786, 14787, 14790, 14792, 14801, 14889, 14890,
   14897, 14898, 14899, 14905, 14914, 14917, 14918, 14919, 14920, 14923,
   14924, 14925, 14928, 14930, 14938, 14939, 14945, 14953, 14954, 14957,
   14958, 14961, 14966, 14973, 14978, 14985, 14992, 14992, 14994, 15001,
   15002, 15005, 15006, 15007, 15008, 15009, 15010, 15011, 15012, 15013,
   15019, 15026, 15038, 15044, 15051, 15059, 15060, 15072, 15083, 15094,
   15098, 15099, 15102, 15107, 15111, 15112, 15115, 15121, 15129, 15135,
   15142, 15146, 15147, 15150, 15153, 15157, 15158, 15161, 15167, 15176,
   15181, 15191, 15201, 15213, 15214, 15215, 15216, 15217, 15218, 15219,
   15220, 15221, 15222, 15223, 15224, 15225, 15226, 15227, 15234, 15235,
   15238, 15239, 15246, 15247, 15248, 15255, 15254, 15271, 15272, 15279,
   15278, 15348, 15354, 15360, 15368, 15374, 15380, 15386, 15392, 15398,
   15404, 15410, 15416, 15427, 15428, 15431, 15432, 15433, 15434, 15435,
   15436, 15437, 15438, 15439, 15440, 15441, 15442, 15443, 15444, 15445,
   15446, 15447, 15448, 15449, 15450, 15451, 15452, 15453, 15456, 15457,
   15458, 15459, 15460, 15461, 15465, 15466, 15467, 15468, 15469, 15470,
   15471, 15474, 15477, 15478, 15479, 15480, 15481, 15482, 15483, 15484,
   15497, 15498, 15499, 15500, 15501, 15502, 15503, 15508, 15509, 15510,
   15511, 15512, 15513, 15519, 15520, 15521, 15522, 15523, 15524, 15525,
   15526, 15527, 15528, 15529, 15532, 15533, 15534, 15535, 15536, 15539,
   15540, 15541, 15542, 15545, 15546, 15547, 15548, 15549, 15550, 15551,
   15568, 15569, 15570, 15573, 15574, 15575, 15576, 15577, 15578, 15582,
   15582, 15585, 15591, 15592, 15595, 15597, 15602, 15612, 15623, 15630,
   15631, 15632, 15635, 15668, 15670, 15672, 15675, 15685, 15695, 15705,
   15706, 15709, 15711, 15712, 15713, 15716, 15718, 15726, 15727, 15728,
   15732, 15733, 15737, 15738, 15741, 15742, 15745, 15746, 15747, 15748,
   15749, 15752, 15753, 15754, 15755, 15756, 15757, 15758, 15759, 15760,
   15761, 15762, 15763, 15764, 15765, 15766, 15767, 15768, 15769, 15770,
   15771, 15772, 15773, 15774, 15775, 15776, 15777, 15778, 15779, 15780,
   15781, 15782, 15783, 15784, 15785, 15786, 15787, 15788, 15789, 15790,
   15791, 15792, 15793, 15794, 15795, 15796, 15797, 15798, 15799, 15800,
   15801, 15802, 15803, 15804, 15805, 15806, 15807, 15810, 15811, 15812,
   15813, 15816, 15817, 15818, 15819, 15820, 15821, 15822, 15823, 15824,
   15825, 15832, 15833, 15834, 15835, 15838, 15839, 15842, 15843, 15846,
   15847, 15858, 15859
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SQL_ALLOCATE", "SQL_AUTOCOMMIT",
  "SQL_BOOL", "SQL_BREAK", "SQL_CALL", "SQL_CARDINALITY", "SQL_CONNECT",
  "SQL_COUNT", "SQL_DATETIME_INTERVAL_CODE",
  "SQL_DATETIME_INTERVAL_PRECISION", "SQL_DESCRIBE", "SQL_DESCRIPTOR",
  "SQL_DISCONNECT", "SQL_FOUND", "SQL_FREE", "SQL_GET", "SQL_GO",
  "SQL_GOTO", "SQL_IDENTIFIED", "SQL_INDICATOR", "SQL_KEY_MEMBER",
  "SQL_LENGTH", "SQL_LONG", "SQL_NULLABLE", "SQL_OCTET_LENGTH", "SQL_OPEN",
  "SQL_OUTPUT", "SQL_REFERENCE", "SQL_RETURNED_LENGTH",
  "SQL_RETURNED_OCTET_LENGTH", "SQL_SCALE", "SQL_SECTION", "SQL_SHORT",
  "SQL_SIGNED", "SQL_SQLERROR", "SQL_SQLPRINT", "SQL_SQLWARNING",
  "SQL_START", "SQL_STOP", "SQL_STRUCT", "SQL_UNSIGNED", "SQL_VAR",
  "SQL_WHENEVER", "S_ADD", "S_AND", "S_ANYTHING", "S_AUTO", "S_CONST",
  "S_DEC", "S_DIV", "S_DOTPOINT", "S_EQUAL", "S_EXTERN", "S_INC",
  "S_LSHIFT", "S_MEMPOINT", "S_MEMBER", "S_MOD", "S_MUL", "S_NEQUAL",
  "S_OR", "S_REGISTER", "S_RSHIFT", "S_STATIC", "S_SUB", "S_VOLATILE",
  "S_TYPEDEF", "CSTRING", "CVARIABLE", "CPP_LINE", "IP", "DOLCONST",
  "ECONST", "NCONST", "UCONST", "UIDENT", "IDENT", "FCONST", "SCONST",
  "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT",
  "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS", "GREATER_EQUALS",
  "NOT_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P",
  "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS",
  "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION",
  "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED",
  "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COMMENT", "COMMENTS",
  "COMMIT", "COMMITTED", "CONCURRENTLY", "CONFIGURATION", "CONFLICT",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CROSS", "CSV", "CUBE",
  "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE",
  "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER",
  "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC",
  "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED",
  "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DEPENDS", "DESC",
  "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO", "DOCUMENT_P",
  "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING",
  "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE",
  "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXTENSION",
  "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER", "FIRST_P",
  "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD", "FREEZE",
  "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED",
  "GREATEST", "GROUP_P", "GROUPING", "HANDLER", "HAVING", "HEADER_P",
  "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDING", "INCREMENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P",
  "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATERIALIZED", "MAXVALUE", "METHOD", "MINUTE_P", "MINVALUE",
  "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL", "NATURAL",
  "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING", "NOTIFY", "NOTNULL",
  "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF",
  "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS",
  "OR", "ORDER", "ORDINALITY", "OUT_P", "OUTER_P", "OVER", "OVERLAPS",
  "OVERLAY", "OWNED", "OWNER", "PARALLEL", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POLICY",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROGRAM",
  "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE",
  "REF", "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE",
  "RENAME", "REPEATABLE", "REPLACE", "REPLICA", "RESET", "RESTART",
  "RESTRICT", "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE",
  "ROLLBACK", "ROLLUP", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA",
  "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE",
  "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET",
  "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP",
  "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE",
  "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "TABLE", "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE",
  "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER",
  "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA", "'<'", "'>'",
  "'='", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "','", "';'", "':'", "'{'", "'}'",
  "$accept", "prog", "stmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "AlterUserStmt", "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "DropGroupStmt",
  "CreateSchemaStmt", "OptSchemaName", "OptSchemaEltList", "schema_stmt",
  "VariableSetStmt", "set_rest", "generic_set", "set_rest_more",
  "var_name", "var_list", "var_value", "iso_level",
  "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "reset_rest",
  "generic_reset", "SetResetClause", "FunctionSetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "DropPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "type_name_list",
  "TruncateStmt", "opt_restart_seqs", "CommentStmt", "comment_type",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label_type",
  "security_label", "FetchStmt", "fetch_args", "from_in", "opt_from_in",
  "GrantStmt", "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "CreateTransformStmt", "transform_element_list",
  "DropTransformStmt", "ReindexStmt", "reindex_target_type",
  "reindex_target_multitable", "reindex_option_list",
  "reindex_option_elem", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "AlterObjectSchemaStmt",
  "AlterOperatorStmt", "operator_def_list", "operator_def_elem",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "InsertStmt", "insert_target", "insert_rest",
  "insert_column_list", "insert_column_item", "opt_on_conflict",
  "opt_conf_expr", "returning_clause", "DeleteStmt", "using_clause",
  "LockStmt", "opt_lock", "lock_type", "opt_nowait", "opt_nowait_or_skip",
  "UpdateStmt", "set_clause_list", "set_clause", "single_set_clause",
  "multiple_set_clause", "set_target", "set_target_list",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "all_or_distinct", "distinct_clause", "opt_all_clause",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value", "select_fetch_first_value",
  "I_or_F_const", "row_or_rows", "first_or_next", "group_clause",
  "group_by_list", "group_by_item", "empty_grouping_set", "rollup_clause",
  "cube_clause", "grouping_sets_clause", "having_clause",
  "for_locking_clause", "opt_for_locking_clause", "for_locking_items",
  "for_locking_item", "for_locking_strength", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "opt_alias_clause", "func_alias_clause", "join_type",
  "join_outer", "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "Typename", "opt_array_bounds", "SimpleTypename", "ConstTypename",
  "GenericType", "opt_type_modifiers", "Numeric", "opt_float", "Bit",
  "ConstBit", "BitWithLength", "BitWithoutLength", "Character",
  "ConstCharacter", "CharacterWithLength", "CharacterWithoutLength",
  "character", "opt_varying", "opt_charset", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "explicit_row", "implicit_row", "sub_type",
  "all_Op", "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "func_arg_list", "func_arg_expr", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "opt_slice_bound", "indirection", "opt_indirection", "opt_asymmetric",
  "ctext_expr", "ctext_expr_list", "ctext_row", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "database_name", "access_method", "attr_name",
  "index_name", "file_name", "func_name", "AexprConst", "Iconst",
  "SignedIconst", "RoleId", "RoleSpec", "role_list", "NonReservedWord",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", "statements", "statement", "CreateAsStmt", "$@1",
  "$@2", "at", "ECPGConnect", "connection_target", "opt_database_name",
  "db_prefix", "server", "opt_server", "server_name", "opt_port",
  "opt_connection_name", "opt_user", "ora_user", "user_name",
  "char_variable", "opt_options", "connect_options", "opt_opt_value",
  "prepared_name", "ECPGCursorStmt", "ECPGExecuteImmediateStmt",
  "ECPGVarDeclaration", "single_vt_declaration", "precision", "opt_scale",
  "ecpg_interval", "ECPGDeclaration", "$@3", "sql_startdeclare",
  "sql_enddeclare", "var_type_declarations", "vt_declarations",
  "variable_declarations", "type_declaration", "$@4", "var_declaration",
  "$@5", "$@6", "opt_bit_field", "storage_declaration", "storage_clause",
  "storage_modifier", "var_type", "enum_type", "enum_definition",
  "struct_union_type_with_symbol", "$@7", "struct_union_type", "$@8",
  "s_struct_union_symbol", "s_struct_union", "simple_type",
  "unsigned_type", "signed_type", "opt_signed", "variable_list",
  "variable", "opt_initializer", "opt_pointer", "ECPGDeclare",
  "ECPGDisconnect", "dis_name", "connection_object", "execstring",
  "ECPGFree", "ECPGOpen", "opt_ecpg_using", "ecpg_using",
  "using_descriptor", "into_descriptor", "into_sqlda", "using_list",
  "UsingValue", "UsingConst", "ECPGDescribe", "opt_output",
  "ECPGAllocateDescr", "ECPGDeallocateDescr", "ECPGGetDescriptorHeader",
  "ECPGGetDescHeaderItems", "ECPGGetDescHeaderItem",
  "ECPGSetDescriptorHeader", "ECPGSetDescHeaderItems",
  "ECPGSetDescHeaderItem", "IntConstVar", "desc_header_item",
  "ECPGGetDescriptor", "ECPGGetDescItems", "ECPGGetDescItem",
  "ECPGSetDescriptor", "ECPGSetDescItems", "ECPGSetDescItem",
  "AllConstVar", "descriptor_item", "ECPGSetAutocommit", "on_off",
  "ECPGSetConnection", "ECPGTypedef", "$@9", "opt_reference", "ECPGVar",
  "$@10", "ECPGWhenever", "action", "ECPGKeywords", "ECPGKeywords_vanames",
  "ECPGKeywords_rest", "ECPGTypeName", "symbol", "ECPGColId", "ColId",
  "type_function_name", "ColLabel", "ECPGColLabel", "ECPGColLabelCommon",
  "ECPGCKeywords", "all_unreserved_keyword", "ECPGunreserved_interval",
  "into_list", "ecpgstart", "c_args", "coutputvariable", "civarind",
  "char_civar", "civar", "indicator", "cvariable", "ecpg_param",
  "ecpg_bconst", "ecpg_fconst", "ecpg_sconst", "ecpg_xconst", "ecpg_ident",
  "quoted_ident_stringvar", "c_stuff_item", "c_stuff", "c_list", "c_term",
  "c_thing", "c_anything", "DeallocateStmt", "Iresult", "execute_rest",
  "ecpg_into", "opt_ecpg_into", "ecpg_fetch_into", "opt_ecpg_fetch_into", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,    60,    62,    61,   771,
      43,    45,    42,    47,    37,    94,   772,    91,    93,    40,
      41,    46,    44,    59,    58,   123,   125
};
# endif

#define YYPACT_NINF -4920

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4920)))

#define YYTABLE_NINF -2832

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2832)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   -4920,   807, 10225, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, 31995, -4920,
   -4920, -4920, -4920, -4920,116517,   485, -4920, -4920, -4920,121144,
   -4920, -4920, -4920,   628, 80013, -4920, 83055,   887, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, 87111, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, 67323,  1002, -4920,   499,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920,    18, 11045, -4920,
   -4920, 83562, -4920,   223, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, 84069,   422, -4920, -4920,   693,  1414, -4920,   132, 15650,
   -4920, -4920, 76464, 81027, -4920, -4920, 87618,   737,  2311,  5730,
      18, 32622, 88125, -4920,  1484, -4920, 63730, -4920, -4920, -4920,
   80520, -4920, -4920, -4920,  1103, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, 93702,  2575,   747, 64246, -4920,
   -4920, -4920, -4920, 93702, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, 88632, -4920,  1101,  1287,    94, 94209, 94716,
   77985, -4920,  1551, -4920, 93702,  1298,  1345, 66307, -4920, 95223,
   -4920, -4920,  1152, -4920, 89139, -4920, -4920, -4920, -4920, -4920,
     747, -4920, 67323, 62714,    61,  1236, -4920, -4920, 95730, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, 93702,  2143,
    1281, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920,   422, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920,   879, -4920,   823,   946,  1573,
     680,  1351, -4920, -4920, -4920, 16848, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, 30270,  2291, -4920, -4920, -4920,  1384, -4920,
    1451, -4920, -4920, -4920,  1554, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920,   984, -4920, -4920, -4920, -4920,  1889,117021, 87111,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, 75957, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920,   218, -4920, -4920, -4920, -4920, -4920, 87111,
   87111, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, 87111,  1548, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,   713,
    1783, -4920, -4920, 67323,  2214,  2214,  2121, 30270, -4920, -4920,
   -4920, 68847, 93702, 93702, 93702,  1894, 93702,  1773, 93702,   202,
   68847,125547, 89646,  1961,  1798, 58057, 96237, -4920,123787, 93702,
   93702, 96744, 93702,  1572, 84576, 93702,  1974, 93702, 93702,124227,
   97251,  2135, -4920,  2405,  1628, -4920, -4920, -4920, 93702, 13299,
    2575, -4920, -4920,  2143, 93702,  2138, 68847, 93702,  1922, 93702,
    2040, 93702, -4920, 93702,  2046, 97758,   374,  2113,125547,  2185,
   58577,  2086, 93702,125547, 98265, 93702, 93702, -4920, -4920,  2123,
   93702, 93702, -4920,  2227,125987,  1617,  2233,  2357,  2290,   808,
   -4920, -4920,  2470,  2043, -4920, -4920,  2510, 87111, -4920, 85083,
   -4920, -4920, -4920,  2512, -4920, -4920, -4920, -4920, -4920, -4920,
  122907,  2311, -4920, -4920,  2294, 69355, 93702,  2354, -4920, -4920,
   98772, 72403,  2163, -4920,   385, 69863,126427,  2473,  2152, 59097,
    2529, 99279,126867, 99786, -4920, -4920,100293, -4920,100800,  2256,
    2354,101307, 72911,127307, -4920,  2382,101814, -4920, 10949, -4920,
    2134,  2408,  2145,  1036, 87111, 87111,  1639,118909, -4920, -4920,
     422, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,   272,
    2104, 64762,  1054, 65278, -4920, -4920,  1067,  1109,  1176,   272,
    2592,  2592,   686, 87111, -4920, -4920,  2104, -4920,   688,    78,
    2151,  2151,  2151,  2363,   438, -4920,  2151,  2303, -4920, -4920,
   -4920, -4920, 89139, 64762, 65278, -4920,  2183,  2575,   112,  2591,
    2259, -4920, -4920, -4920, -4920, -4920,  2252, 93702, 93702, 93702,
   -4920, -4920, -4920,  2639,  2242,  2484, -4920,  2255, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920,  2434,  2451,  2462,
     150,  2575,  2356, -4920,  2593, -4920,  2478, 39389, 39389,  1421,
   87111,  2575, 65794, 90153,113475,   219,122907,  2575,102321,  2317,
    1150,  2501, -4920, -4920, -4920,   866, -4920,  2733,  2345,  2581,
     436,  1628, 54972, -4920,  2340,  1823, 89139,118029, -4920, -4920,
   -4920, -4920,  1275,  2624, 39914, -4920, 93702,  2364, -4920,  2351,
    2364,  2355,  2379,  1573, -4920, 93702,  1529,  1529,  2760,  1529,
    2202,  2339, -4920,  2313, -4920,  2680,  2642, 89139,  1236,    18,
    2399, -4920, -4920, -4920,  2416, -4920,  2404,  2417, -4920,   830,
    2671, -4920, -4920, -4920, -4920,  2520,  2547,  2548,  2552,  2426,
    2553,   238, -4920, -4920, -4920, -4920,  2778, -4920, -4920, -4920,
   -4920, -4920, -4920,  2901,  2887,121587,121587,   854,   873,   199,
     285, -4920, -4920, -4920,  2747, -4920, -4920,  2763, 93702,  2585,
   93702, -4920, -4920, -4920,102828, -4920, -4920,  2214,  2416,  2498,
   -4920,   201, -4920,  1823, -4920,   312,   344,   355,  1858,  2533,
    1876,   962, -4920,   858, 93702,  2646,   191,   572,  2573, 90660,
    4913,  2522,  2697,  1325,  2837,  2880,  5164,   238, 91167, -4920,
   -4920, -4920, -4920, 93702, 93702, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920,  2556, -4920, -4920,  2571,  2885,  2773,
    2874,  2767,  1500,  2796,  1861,  2925,  9521,  1191,103335,113982,
    2900,  2942,  5299,  2207,   153,  2830,   232,  2874,  2935,  2784,
    1500,  2955,  7168, 93702,  2641, -4920,  2892,  3004,    63, -4920,
    1083, -4920,  2717,  2859,  1082,  2895, 68847,  2696, -4920, -4920,
   93702, -4920, -4920, 73419,  2764, -4920,   732, 68847, -4920,  2902,
    2779, 59617, 93702, -4920, 93702, -4920, -4920, -4920, -4920, -4920,
    2842,  3035, 93702, 73419, -4920,  2986, 93702, -4920,  2762, -4920,
   -4920, -4920, -4920,  2151, 93702,  2781,  3161, 73419,   161, 93702,
    1837,  3182, 93702,  2983,  1837,  2820,103842, -4920, -4920,  1837,
   -4920, -4920, 93702, 93702,  2792,  1496,  2995,  1837,  3017,  3226,
    3236,  2906,  3022,   794,  1378,   141,  3137,  1837,  2894,104349,
  104856, 93702,  2907, 93702,  3243, 68847, 93702,  3156, -4920,  3028,
   91674, -4920,  2866,  2470, -4920, -4920, -4920, -4920, -4920,   872,
   -4920, -4920, -4920, -4920, -4920,  3183,  2498,   348,  3185,  2876,
    3188, -4920, -4920,  2923, -4920,  2923,  2923,  2879,  2879,  3047,
    2881,  3194, -4920, -4920, -4920,  2588,  2923,  2879, -4920, 74435,
   -4920,  1954,  2016, -4920,   194, -4920,  3304, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920,   121, -4920,  1248, -4920,  2041,
   -4920, -4920, -4920, -4920,  2917, -4920,  3198,  2522,  3199, -4920,
    2886,105363, -4920,105870,106377,  3201,  2556,125547,  3202,  3085,
    3206,  2886,  3207,  3096,  3220,   348,  3221, -4920,  1259,  3210,
    3224,  3107,  3228,   194,  3229,  2125,  2886,123347,  3230,   220,
   -4920, 16438, 10949, -4920, 20462,  1873, -4920, -4920, -4920, -4920,
   -4920, -4920, 43589,   940,  3008, -4920, -4920, -4920,  2114, -4920,
  120248, -4920,  1639,  2104, -4920, 87111,  2104, 87111,   686,  2104,
   87111,  2104, 87111,   686,  2104, 87111, 87111, 87111,  2104, -4920,
   -4920,   246,   240, -4920, -4920, -4920, -4920, -4920, 87111,  2915,
   93702, 93702, -4920, -4920, -4920, 81534,125547, 82041, -4920, 93702,
   -4920,   264, 87111, -4920, 87111, -4920,  2575, -4920, -4920,  2408,
   73419,  3339,125547,  3243, -4920,  2153, -4920, -4920, -4920, -4920,
   -4920, -4920,  3159, 93702,  3222,  3223, 81534,125547, -4920,106884,
  122907,  3118,  2926, -4920, -4920, -4920, -4920,  2211,  2772,   174,
    2905, 43589,  2927,   301,   301,  2929,  3231, -4920, -4920, -4920,
     366,  2930,  2934, -4920,   417,   417,  2937,  2939, -4920,   443,
    2944,  2945,  2920,   466,  2951,  2962,  2963,  2588,   301, 43589,
   -4920,  2964,   417,  2966,  2968,  2970,  2948,  2972, -4920,  3003,
    2973,   265,   384,  2974,  2975, -4920,  2937, -4920,   401,  2976,
    2977,  2978,  2980,  2984,  2987,  2988,  2989, 43589, 43589, 43589,
   -4920, 37814,  1823,  2575, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920,   474,  4260, -4920,  2969, -4920, -4920,  3124, -4920,
   -4920, 43589, -4920, -4920,   292, -4920,   484, -4920, -4920,  1823,
   -4920, -4920,  1622, -4920, -4920, -4920, -4920,  3218,  2990,  1465,
    1465,   225, -4920, 83562, 83562, -4920, -4920,  1788,  2991, -4920,
    2265, -4920, -4920, -4920, -4920, -4920, -4920,122467,  3366, -4920,
    1120,  2575,  1083,  1948,  3344,119352,119800,  3239,  3239,  3232,
   -4920, -4920, 93702, -4920, -4920, 43589, 61698, -4920,  1823,   114,
    3242, -4920, -4920, -4920,  2203, -4920, -4920, -4920, -4920,   422,
   -4920, 15351, -4920,  2212,  2364, 93702, 93702,  3410, -4920, -4920,
    2351, -4920, -4920,  1573,  1573, 43589,  1573,   716,  1561, 40439,
   44114,  3295,  3192,  1503,  1457,  3297, -4920,  3197,  2202,  2339,
   89139, 93702,107391,  3119, -4920, -4920,  2416,  3013,  2156, -4920,
   75450,117525,117525,  3265, -4920, -4920,  1239,  1274,  3132,  3227,
    2592,  1584,  2144,  2144, -4920, -4920,  3009, -4920,  3356, 83562,
    3068,121587, -4920, -4920, 93702, -4920, -4920, 92181, -4920, -4920,
   -4920,  2332,  3011, -4920,  3026, 93702, -4920,  3531,  2144,  2144,
   -4920, -4920,  3014, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, 30270,  3019, 93702, -4920,  3023,  3025, -4920,118029, 62206,
    1878,  1823,  3099,  3104,  3154, 67323,  3027,  3108,  3110,  3162,
    3270, -4920, -4920,  3114,  3120,114489, -4920, -4920,  1366, -4920,
   -4920, -4920,  1366, -4920,  3056, -4920,  1519,   918,  1124,  3123,
     310,   671,  3419, -4920,  1897,  3174, -4920, -4920, -4920,  5608,
   93702,  3360,  7632,  3244,   238,  3248,  3172, -4920, -4920,  3296,
    3134, 93702,  3138,  3262,   238,  1115,114996, -4920, -4920, -4920,
   -4920, -4920, -4920,  5481, 36265, -4920,  3139,  3127,  3148, 93702,
   76971,  2318,  3257,  3261,  1915,  2353,   681,  3203, 93702,  1814,
    3271, 93702,  3075,  3155,  3157,  3361,  3077,  1862,  3456,  3083,
   -4920, -4920,  3266,  3362,  3400,  6389,  3145,  3149, 71387,  1658,
   60137, 93702, 93702,  3447,  1890,  3175, -4920, -4920, -4920,  1890,
   93702,  3176,  3178, 93702,   238, -4920,  3503,   238,   238,  2025,
    3505,  3184,   445,  1136,  1837,  3083,  2157, -4920,  3190,  3191,
    1845, -4920,  3294, -4920, -4920,  1439,  3200, 89139,   352,  1541,
    3083,  3193,  3196,  3077,  3077, 93702, 93702, 93702, 93702, 93702,
     171,  3529,  3532,  3204,   181,  3247,  3122, -4920,  1890,124667,
    3208, -4920,  1890, 93702,  3214,  1635,  3083,  1951, -4920,  2026,
   -4920, -4920, -4920,  1628, -4920, 93702, -4920, 93702, -4920,  2498,
   73419,  3315,  3374, -4920,  3170, -4920,  2522,   238, -4920, 93702,
   93702,  2556,  3323,   193,  1260, 73419,  3333,  3393, 93702,  3394,
    3235,  3179,  3212, 62206, -4920,  2792,  3146,  3570, 93702, 67323,
   -4920,  3582,  1366, -4920, 73419,  3347,  3466, -4920, 93702,  3367,
    3163, -4920,  3506,  3213, -4920, -4920,  1160, 93702, -4920,  3475,
  125547,  1135,  2575,  3209,125547,  3396, 93702, 93702, 93702, 93702,
   -4920, -4920,  3369,   923,   100, -4920,124667, -4920, 93702,  3372,
    2157,  3377,  3591,   428,  2151,107898,  3473, -4920,108405,  3177,
    3593, 73419,  3421, -4920, -4920,  3180,  2592, -4920,  2866, -4920,
    2247, -4920,  3303, -4920, 68847,   348, -4920, -4920, -4920, -4920,
   73419, 93702, -4920,  3181, -4920, -4920, 43589, -4920, -4920, -4920,
    2592, -4920, 73419,  2923,  2923, -4920, -4920,  3598,  3259,  3263,
    2592, -4920,  2592, -4920, 73419, -4920,  3187,  3189,  3300,  2592,
   -4920,  3260, -4920,  3269,  2592, -4920,  2241, -4920,108912, 68847,
     348,125547,125547,  3507,   220,  3508,  3249,  3510,  3254, 60137,
     348,   221, 93702, 93702,125547, 93702, 93702, 93702, -4920, 93702,
   -4920, -4920, -4920, -4920, 73419, 93702, 93702, 73419, -4920,125547,
  124667,  3512,  3513,   348, 93702, 93702, -4920, -4920, 17954,  1920,
   -4920, 10949, -4920, 15351,  2231,  3239, -4920,  1548,109419,  1629,
    1639,127747, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   87111, -4920, 87111,   686, -4920, -4920, 87111, -4920, 87111,   686,
   -4920, 87111, -4920, -4920, -4920, 87111, 93702,  3709,  3211, -4920,
    1622, -4920, 93702,  2257, -4920, -4920,  2261,  1028, 93702, 93702,
     635, 68847, 93702,  3401, 93702, 93702, 93702, 93702, 93702,  3286,
    2991,  1555, -4920,  1324,   895, 89139,  3413, -4920, -4920, -4920,
   -4920, -4920,  2267,  2143,  1232, 93702,  1280,  2252, -4920, -4920,
   82041, 80520,  3509,   242, 93702, -4920, -4920,  4122, 43589, 38864,
   -4920, -4920, 15351,  3255, 43589, 43589,  3219,  2592,  2592, -4920,
    3153, 43589, 43589, 43589,  2592,  2592,  4413, 43589, 60137, 43589,
   46739, 34687, 43589, 43589, 38339, -4920, 43589,  3433, 48314, 43589,
    1948,  3450, 43589,  1948,  4413,  3674,  3674,  1236,  1750,  6577,
    3237,  1823, -4920,  2592,  1252,   224, 73419, 43589, 43589, 43589,
   43589, 67323,  3317,   187, 93702, 43589,  3241,  1532, -4920, 43589,
   -4920,  3245, 43589,  3313,  1447, 43589, 43589, 43589, 43589, 43589,
   43589, 43589, 43589, 43589, -4920, 49336,   297, -4920,  3525,  3545,
      -1,   569, 82548, 39389,  3537, -4920, 33635, -4920,   190, 87111,
   -4920, -4920,  1823,  3537, -4920, -4920, -4920, -4920, -4920,  2332,
    3246, -4920,  3267, -4920, -4920, -4920, -4920, -4920, 93702,  3366,
   -4920, -4920,  3319, -4920, -4920, -4920, -4920,   520, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920,  3251, -4920, -4920, -4920,
   -4920,  3251, -4920, -4920,  3239,  3272, 11591,  3250, -4920, -4920,
   -4920, -4920,  3527,  3539,   348, 30270, 93702,  1275, 85590, -4920,
   39914, -4920,  2273, -4920,  3252, -4920,  3501, -4920,  3258, -4920,
   11980,  3501, -4920, -4920, 47264,  3373,  3511,  3458, -4920, -4920,
   -4920,  3268, 15351, 43589, 43589, -4920,  2350, 15351,  2377, -4920,
   -4920, -4920, -4920, -4920, -4920,  1556, -4920, 93702,  1272,  3295,
    1457,  3312,   539,  3686, 93702, -4920, 55483,  2250, -4920,  2416,
   -4920, -4920, 19905, -4920, 33129, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920,  3279, -4920, -4920, -4920, -4920, -4920,
     238,  3290,  3767, -4920,121587, -4920, -4920, -4920,  3709, -4920,
    2510, -4920,  2510,  3811, -4920, 87111, -4920, -4920, -4920, -4920,
    1149, -4920, 10949, -4920, 10949, -4920,  3481, -4920,  3698, -4920,
   74435, -4920,  3299, -4920, 73927, 70371, -4920, -4920,   870, -4920,
    1107,  3375,  3378,  3428,125547, 93702, 93702, -4920, 67323,125547,
   93702, 93702, -4920,125547, 93702, 93702, -4920, -4920, -4920, -4920,
   -4920,120696,    72, 80520,  3429, 78492, -4920, -4920,  3305, 93702,
    3363,  3553,  3554,  1676, -4920, -4920,109926, -4920,  3515,125547,
   93702, 93702, 43589,  3516, 93702, 93702, -4920,   230,  3388,  3392,
   -4920, 93702,  3395,  3538, 68847,  3316, 93702, 93702, 73419,  3398,
     800, 68847,  3364, 60657, 93702, 93702, 93702, 93702,  3445,  3623,
   73419, 93702,  3572,  1376, 89139,   279,  1992,  3083,  3533, -4920,
    3637,  1435, -4920,125547, -4920, 93702,  3522, -4920, -4920, -4920,
   78999,  3741,  3437, -4920, -4920,115503, -4920, -4920, -4920,  2274,
   -4920,125547,125547, 93702,  7847,110433,  1709,  3542, -4920, -4920,
   73419, -4920, 93702, 93702, 93702,  3645,  3577, 93702, 86097,110940,
  111447,  1405,  1449,  3578, 93702, 86604,  3581, -4920,  3477, 93702,
   -4920, -4920, 67831,125547, 93702,   941, 67323, -4920, -4920, 93702,
   -4920,  3544,   837, -4920, 93702,  7445,  3425,  3438, 93702,  3547,
     305,  2226,  3083, 93702, 93702,  3352,  2279,  3439,    35, -4920,
    3549,    79, 93702,113475, -4920,125547,  1669, -4920,  3504,125547,
   93702,  9537, -4920, -4920,   238, -4920, -4920, -4920, -4920, -4920,
   93702, 93702,   238, 93702,   238,  1577, -4920,125547, 93702, -4920,
   -4920, -4920, 93702,  8381, 93702, 93702, 93702, 93702,125547, 93702,
   -4920, -4920,  1360,  1381,   937,  1816,   851, 93702,  3641, 93702,
  111954,125547, 93702, 93702, 93702,  1836, -4920, -4920,  3482, -4920,
  125547,  1669, -4920,  8767, 93702, 93702,  3443,  3444,   156,  3523,
   -4920, -4920, -4920, -4920, -4920, -4920,  3620,  3788,112461,  2193,
   -4920,  3622,  3625,  3426,  3430,  3626, 93702,  2193, 93702, -4920,
   -4920, -4920, -4920,  3628, 93702,  2193,  3629,  2193,  3543,  3580,
     373,  3653,  2298, -4920,  3399, -4920, 43589, 73419, -4920,  2302,
   -4920,  3402,   923, -4920, -4920, 67323, 93702,   227,   759,  3701,
   77478,  2336,  3691, 93702,  3435, 93702,  3694,  2336, 93702, -4920,
    1780, 80520, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920,  3684, -4920,  2575,  2792,  2792,  2792,  2792, -4920, -4920,
   -4920, -4920,  3594,  2058, -4920,  3403,  2792, 93702,  3517,  2336,
    3406,  3712, -4920,  2157,  3713,  3710, 93702, 77478,  2358,  3446,
    3616,  3828,  2151,  2575,  3619,  3606, -4920, 36777,  6297,  3607,
    3660,122907, 91674, -4920,  3422,  3699,  3700,  3716, -4920,  2498,
   -4920,  3840, -4920, 43589,  2338,  3427,   194, -4920, -4920,  3432,
    3189,  3440,  3448,  3431,  3434, -4920,  2592, 52928, 93702,  3436,
    1307,  3643,  3449, -4920,  3745,   348,  2522, -4920,  2886, -4920,
   93702, -4920, 93702, 93702, 93702, 93702,  2556, -4920, -4920,  3631,
     348,  2886,  3632,   348,   348, -4920,  3681,  3634,   348,   194,
    2886,  3562,  3746,122907, -4920,   220, -4920, -4920, -4920, -4920,
   -4920, 43589, -4920, -4920, -4920,  3655,  2151,  2247, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, 87111,
    2510, -4920,  2344, -4920, 93702, -4920,  3718,  3721,  3723,  3453,
    3454,  3483, 93702,  3457, -4920,  3453,   238,  3453,  2991,  2991,
    3453,  3454,125107,  3891,  3750, -4920,  3540,  3464,  3759,   197,
   -4920,   198,  1432,  3685, -4920, -4920, -4920, -4920, 73419, -4920,
  125547,  3514, 93702, 93702, -4920,   213,  3659,  3465,125107,  3870,
     348, -4920, 68847, -4920, -4920, 73419,  3546,  3558, 68847,  3669,
    3518, -4920, -4920, -4920, -4920, -4920, 73419, -4920,  3717, 93702,
    2349, -4920,  1953, -4920,  1963, 43589,   291, -4920, 13158,  2360,
   43589,  3476,  3479, -4920, -4920, -4920, -4920, -4920, -4920,  3480,
    3772, -4920, -4920,  2361,  2371,  2389,  3486,  3487,  5835,  3490,
   13498,  3493,  3495, 46739, 46739, 37814,  1594, -4920, 46739,  3496,
    3664,  2403, 12700,  3498,  3502, 13708, 40964, 43589, 40964, 40964,
   14096,  3498,  3519,  2441, 67323,  3657, 14351,  2453, -4920, 43589,
   67323,  6364, 43589, -4920, 43589,  3526, -4920, -4920,  2751,  2751,
    2751,  4413, -4920,  3521, -4920, 46739, 46739, -4920,  1576, 37814,
   -4920, -4920,  3790, -4920, -4920,  2066, -4920,  3499, -4920, -4920,
    2443, 60137,  4123, 43589,   189, 43589,  3241, 43589,  3579,  2751,
    2751,  2751,   276,   276,   185,   185,   185,  2107,   569, -4920,
   -4920, -4920,  3550,  3551,  3555,  3688,  3556, 43589, -4920,  2545,
    2566, 93702, 11855, 11935, 13022, -4920, -4920, -4920, 50372,  3552,
   43589, 43589, 43589,  3528, -4920,  2776, 15351,  1026, -4920,  2836,
   -4920, -4920, -4920,  3552,  1338,  3811,  2332, -4920,  1628,  2592,
    1252,120248, -4920, -4920, -4920, 43589, -4920, -4920, -4920, -4920,
    2351, -4920, -4920, -4920, -4920, -4920, 93702,  2143, 43589, -4920,
   -4920,  3548,  3524,   615,  3702,  2144,  2144,  2350,  3703, -4920,
   -4920,  3563, -4920, 43589, -4920,  2395,  2418, -4920, -4920, -4920,
   -4920,  2991, -4920,  3735, -4920, -4920, -4920, 50372,  3568,  3564,
   54461,  3708, -4920, 93702, -4920, 93702,   231, -4920, -4920, -4920,
    3557, -4920, -4920, -4920,   805, -4920, -4920, -4920, -4920, -4920,
   -4920,  3534, -4920,  3560, -4920,  3559, -4920, -4920, -4920, -4920,
     207,  3567,  3561,  3574,  1647, -4920, 70371,  2041, -4920, 73927,
   -4920, 73927, -4920,  2041,  3932, -4920, 70371,  2032,125547, 93702,
   93702, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920,125547,125547,  3725, 93702,  3737,  3738,
   43589,   852, 93702,  3565,  3569,  1715,  3822, 93702, -4920,  3865,
     348, -4920, -4920,  3638, -4920, 15351, -4920, -4920, -4920, -4920,
   -4920,125547, 93702, -4920,122907, -4920, 93702,  2498, 73419, -4920,
   -4920, -4920, 93702,  3602, 93702, -4920, 93702, 93702, 93702,  2556,
   -4920, -4920, -4920, -4920,  1367, 73419, -4920, -4920, 93702, 93702,
     104,  3650,  3656, 93702, -4920,   621,  3294,  8987, 93702, 93702,
   93702,  3821, 93702, -4920, -4920, -4920, -4920,  3778, -4920, -4920,
   70371, -4920,  2886,  1530,  3661,  3083,  3785, -4920,  3894,  3774,
   -4920,  1508, -4920, 93702,  3711, -4920, -4920, -4920, -4920,  3898,
     348,  3899,   348, 93702, 93702, 93702, 93702,  3714, -4920, -4920,
   -4920, -4920,  3715,  3827, -4920, 67323, 67323, 67323,  2488, -4920,
   -4920,  2575, -4920, -4920, -4920, -4920, -4920, -4920,  3860, -4920,
    2502, -4920,   -29, -4920, -4920, -4920, -4920, -4920, -4920,125547,
   93702, 10312,  3903, 93702, 93702, 93702,  1928, -4920,  1322, 73419,
   -4920, 71895,125547, 93702, 67323, 93702,  3673,125547,  3651, -4920,
   -4920,  3833,  3773, -4920,  2348,  3775,125547,  3658, -4920, -4920,
    3680, -4920, -4920,  3683,  2393,  3083,  2157, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920,  1644,   397,  2513,  3083,  3687,
   -4920,  3689, -4920, -4920, -4920,  3824,  3838,  3841,  3692,  3695,
    3734,  3696,  3719,  3743, -4920,  3722,  3751,  3724,  3762,  3817,
    3728,   348, 73419,  3844,  2575,  3753,  3952,   348, -4920,  3729,
   -4920, -4920,  4058, -4920, 93702, -4920,  3731,  2667,  3083, -4920,
   -4920,125547, 93702, -4920, -4920, -4920,  2193, 73419, 93702,  3907,
   -4920, -4920, -4920,  2193,  2193, 93702, 93702,  2193,  3909, -4920,
    3910, 93702,  3912, -4920,  2193, -4920, -4920,   335, -4920, -4920,
   -4920,  3543,  3948, -4920,  2512, 57537,  6946,  3665, -4920, 67323,
   57537,  2085,  1695,   235,  1837, -4920,122907, 93702,122907, -4920,
     759,  3774, 93702, 93702,  3672,  3662, -4920, -4920, -4920, -4920,
  125547,   785,125547,  2592, -4920, -4920,  3742, -4920, 93702,  2151,
     179,  3754,  4085,  3236,  1135,  3826,  1717,  4030,  3446, -4920,
   -4920, -4920, -4920, 93702, 93702,   923,  2575, -4920,  3679,  3690,
   -4920, 93702, 93702, 93702, 93702, 93702,  2143,  3697,  3704, 73419,
     639,  3882,  3883,  3077,  4107,  4002,  2143,  3446,  3769,  4007,
   93702, -4920,  2503,   120, -4920,  2575,122907, 70879,  4000, -4920,
    6082, -4920, -4920,   664, 93702,  3988, -4920, 93702, -4920, -4920,
   53950,   348, 73419,  2518, -4920, -4920, -4920,  2592, -4920, -4920,
    1612,  1612,  3707, -4920, 53439, -4920,  3720, -4920,  2384, -4920,
    4098, -4920, 93702, -4920,   348,   220,  3763,   348,  3765,   348,
     348, 93702, -4920, 93702, -4920, -4920, 93702, 93702, -4920, -4920,
   93702,124667,   348, -4920, 15351,  4019,  4012, -4920, -4920, -4920,
   -4920,  3845,  3851,  3852, 93702,  3453, 68847, -4920,  3726,125547,
    1591, -4920, -4920,  3905, -4920, -4920, 89139,  3847, -4920, -4920,
   -4920, -4920,  4040,  4041, -4920, -4920, -4920,  1388, -4920, -4920,
   -4920,125547, 81534,   233,125547, -4920,  2498,  3982, -4920, -4920,
    2522,   238, -4920,  3984, 93702,  3986, -4920, -4920, -4920,  3740,
   14735, 43589, -4920,  4056, 73419, -4920,  7334, -4920, -4920, -4920,
   43589, -4920, -4920, -4920, -4920, -4920, 43589, -4920, 43589,  4033,
   -4920, 35213,  4184,  4184,  3744, 73419, 46739, 46739, 46739, 46739,
    1620,  2966, 46739, 46739, 46739, 46739, 46739, 46739, 46739, 46739,
   46739, 47789,   176, -4920,  3925, 43589, 43589,  4043,  4033, -4920,
   73419,  3747,  3498,  3748,  3756, 43589, -4920, -4920,  2530, 48825,
    3761, 67323, -4920, 43589,  8117,  2535,  3789, 14820,  1823,  7636,
    2575, 43589,  2424,  2728, 43589,  2551, 43589,  4039, -4920, -4920,
   -4920,  3755, -4920, -4920, 73419, 43589,  3764,  3676, 46739, 46739,
    4163, -4920,  4507, 43589, 37814, -4920,  3947,  3801, 55994, -4920,
   35739,  3766,   747,   747,   747,   747, -4920, 93702, 93702, 93702,
   50883,  4060, 49861, 92688,  3768,  2636, -4920, 92688, 93195, -4920,
    3781, -4920,  3770,  1823, 43589,  4050,  1046,  1046,  3947, -4920,
   43589, 43589, 41489,  3776, -4920,  4050, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920,  3771, -4920,  3779, -4920, -4920,  1083,  3780, -4920, -4920,
   15351,  3777,   207, -4920, -4920,  3782, -4920,  3786, -4920,  3524,
    1592, -4920, -4920, -4920,  3965, -4920, -4920, -4920, -4920,  3768,
   42014,  3916, -4920,  2558, -4920, -4920,  4149,  3916, -4920, -4920,
    2565, 55483,  3568, 39914,  1823,  2592,  3793, -4920,  2510,  1338,
   -4920, -4920, -4920, -4920, -4920,  2569,  2054, -4920, -4920, 70371,
   -4920,  3854, -4920, -4920, -4920,  2886,  2886,  1187,  3453,  4084,
    1187,  7782, -4920, -4920, 51394, 93702, 93702, -4920, 93702,  2578,
    2020, 93702, -4920, 93702, -4920, -4920, -4920, -4920, -4920,  4206,
   -4920, 93702, -4920, -4920,  3843,  3846, -4920, 93702, 93702, 93702,
   93702,  4035, -4920, -4920,  2533, -4920, -4920,125547, 93702, -4920,
   -4920, -4920,   359,  2875,  3083, -4920,  3872, -4920, -4920, -4920,
    4054, -4920,  4197,  3885, 93702,  4108, 93702,  3803, -4920,  2020,
    1146,  3077,   690, -4920, -4920,  3871, -4920, -4920, 93702, -4920,
   93702, -4920, -4920, -4920, -4920, -4920, -4920, -4920,  3928, -4920,
   -4920, -4920, -4920, 67831, -4920, -4920, 93702, -4920, 67323, 57537,
   67323, -4920,  1654,   362,  2899,  3083, 93702, -4920,  3888, -4920,
    3889,  3893,  3934,   779,   977,  3896,  3897,  3940,  3820,  3825,
    3830, -4920, -4920,  2584, -4920,  3839,  3971, 93702,  2886,  3829,
    3867,   272,  2575, -4920, -4920,  2575,  2886,  2575, 93702, 93702,
   93702,  4234,  3919, 93702, 93702, 93702, 93702, 93702, 93702,  4135,
    1205,  2159,125547, 93702, 93702,125547, 93702, 93702, 93702, 93702,
   93702, 93702,  4146, 93702, -4920,  4223,  4152,  1971,  4194,  3911,
   93702, -4920, 93702,  3294, 93702, 93702, -4920, -4920, -4920,  3849,
    4099,  2193, -4920, -4920,  4105,  4106, -4920,  2193,  2193,  4109,
    2193, -4920, -4920, -4920,  1837, -4920,   335, 93702, -4920,  3399,
    3786,  2144,  2144, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
    2629, -4920, -4920, 93702,  3856, 93702, 93702, 46739, -4920,  1828,
    1000, -4920,  4104, 93702,  3895, -4920, -4920, -4920,  4020, 93702,
   -4920, -4920, -4920, -4920, -4920,  3862, -4920,  4129, 77478,  2886,
  125547,125547,  2886, -4920, 73419,  3864,  3446, -4920, -4920, -4920,
   -4920, -4920, -4920,125547,  3651,125547,  1135,  1511,112968,  3900,
   -4920,  3863,  4164, -4920,  3866,  3868, -4920, -4920, 93702,  3774,
    2594,  2157,  4288,   542,  2145,  3514, 79506,  2358,  4129, -4920,
   -4920, -4920,  4252,  3960, -4920,  2143, 93702,  3514,  3960,  2575,
   93702,  3363, -4920, 70371, 43589, 43589, -4920,  3873, -4920,  3880,
    6617, -4920,  3949,  3878,  2792, -4920, -4920, -4920, -4920, -4920,
   -4920,  3970,  3904, 93702,  4328, -4920, -4920, -4920,  3887, -4920,
    3901, -4920, -4920, -4920,  2188, 30270, 53439, 53439, 53439, 53439,
   53439, -4920, -4920,   348, -4920, -4920, 93702, -4920, 93702, -4920,
   -4920,   348,   348,   348,   348, -4920,  4011, -4920, 93702,  2143,
   93702, 93702, 93702,  3453, -4920,   238, -4920,  4187,125107, -4920,
   -4920,  2598, 93702, -4920, -4920, -4920,  4246,   242,  4199, -4920,
   -4920,  4158,  2499,  4159,  4166,  2499,  4167,  2499, -4920, 43589,
   15351, -4920,  3917, -4920, 15351,  8097, 15351,  4043, -4920,  2609,
   43589, -4920,  2965,  2965,  2965,  2791,  4207, -4920,  1097,  3921,
    2965,  2965,  2965,   151,   151,   159,   159,   159,  4184,   176,
   15351, 15351, -4920, -4920,  3923, -4920, -4920, -4920,  3498, -4920,
   44639,  4067,  4323, -4920, -4920, -4920,  3962,  3963,  3927, -4920,
   43589, 45164,  3926, 74435,  4112, -4920,  1831, 43589, 43589,  5240,
   -4920,  5872, 43589, 73419,  2610,  5240,   315, 43589,  3233,  3530,
   43589, 43589,  4955,  8136,  3930, 43589,116010, -4920, -4920, -4920,
    2614, 43589, 93702, 93702, 93702, 93702, -4920, -4920, -4920, 92688,
   93195,  3933, 52416,  2636,  3935, 93702, -4920, -4920,  3937, 50372,
    4182,  4124, -4920, 50372,  4124,  2208,  4124,  4189,  4025, 56505,
   -4920, -4920,  3943,  4130, -4920, 33635,  2082, 15351,  4346,  4229,
   43589,  3946,  3950,  3951, 15351, 15351, 43589, -4920,  2575,  4229,
    1338,   529,  2575, -4920, -4920, -4920, 60137, -4920, -4920, -4920,
   -4920,  4145, 15351, 39389, -4920,  2143, 93702,  1823,   749, -4920,
    3961, 93702, -4920,  3916, -4920, -4920, 10949, -4920, -4920, -4920,
   -4920,  4024,  2617, -4920, -4920, -4920, -4920, -4920,  4037, 80520,
    4255, -4920, 43589,  2618, -4920,  3993,  4347,   138,  2638,  2647,
    2020, -4920,  3895, -4920,  1877,  4230,   314, -4920,   348, -4920,
   73419, -4920, 93702, 93702, -4920, -4920, -4920, -4920, 93702,  3027,
   -4920, -4920, 93702, 93702, 93702, 93702, -4920,125547, 93702, -4920,
   93702, -4920, 67323,  1695,  4168, -4920, -4920,  4169,   272, 93702,
   -4920, 73419,   348,   348, -4920, -4920, -4920, -4920, -4920,  3980,
    4371,  4059, 93702, 93702, 93702, -4920, 93702,125547, 93702, 93702,
    2592,  2592, 73419,  3975, -4920,  2592,  2592,  3976, -4920,125547,
   93702, 93702, -4920, -4920, -4920, -4920, 67323, 57016,  4057, -4920,
   43589,  4362, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
  125547, 93702,  4061, -4920,  4062, -4920, -4920, -4920, 93702, 93702,
   93702, 93702,  4292, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, 93702, -4920, 93702, -4920, -4920,  2575,  2575,
   73419,   348,   348, -4920, -4920, -4920,  4237,  2193, -4920,  2193,
    2193, -4920, -4920,  2193, -4920,  3987,   392, -4920,  2020,   244,
    4282,  4285, 43589, -4920,   809,  2791, -4920, -4920, -4920, -4920,
    3895,  2151,  4047, 68847,  1226, -4920,  4266,   227, 77478,  1362,
    3997,  4115, -4920,  2886,  2886,  4053, 93702,  4419,  2886,  3867,
   -4920,  4210,   875, 93702,  4329,  4046, -4920,  2575, -4920, -4920,
    3446, -4920,  4320, 93702, 77478,  3514, -4920,  2650, -4920, -4920,
   -4920,  4048,  3883,  2358,  1411, 93702, -4920,  4051,  4433, -4920,
   -4920,  4312,  4212,  4023, -4920, 15351, 15351,  2575, 74943,  6082,
   73419,  4319, -4920, 93702,   652,  4289, 93702, -4920,   348, -4920,
   -4920,  4026,  2206,  2206, -4920, -4920, -4920, -4920,   348,   348,
   -4920, -4920, -4920, -4920, 93702,  3453,  3453,  3453, -4920,  4216,
   -4920, -4920,  4281, -4920,   348,125107,  2499, -4920, -4920, -4920,
    2499,  2499, -4920,  2499, -4920, 15351, -4920, -4920, -4920, -4920,
    8655, 46739,  4325, -4920,  4032, 73419, -4920,  4038,  2651,  2655,
   48314,  4183, -4920, -4920, -4920,  8742,  4088, 15351,  4136,  4049,
    4052,  5240,  5240,  5872,  2668, -4920,  5240, 43589, 43589,  5240,
    5240, 43589, -4920, -4920,  8950,  4215, -4920, -4920,  9249, -4920,
   -4920, -4920, -4920, -4920, -4920, 68339, 92688,  4044, 93702,  2636,
   50372, -4920, -4920,  2232, -4920, 50372,  4295, -4920, 50372, 68847,
   -4920, 93702,  4063, 93702, -4920,  1026, 45689, 43589,  4093, -4920,
   -4920, -4920,  3947, -4920,  4093, -4920,  2144, -4920, -4920, -4920,
   -4920, -4920,  4065, 87111,   583, -4920, -4920,  4420, 51394,  4379,
    4064, -4920, -4920, -4920, -4920, -4920,125107,  4245,125107,  2020,
    9463,  3895, 51394, 61177, 93702, 93702, 93702,  4190,  3895,  4047,
   -4920, -4920, -4920, -4920, -4920, -4920,  4066, -4920, -4920, -4920,
   -4920,  4147, -4920, -4920,   523,  3413, -4920,  2669, -4920, -4920,
   -4920, -4920, -4920,  4223, -4920, -4920, 57537,125547, 93702, -4920,
    4148, -4920, -4920, -4920, -4920, -4920, 51905, 60137, -4920,   779,
    4073,  4074,   977, -4920, -4920, -4920, -4920, -4920, -4920, 93702,
    9812,  4075,  1091,  3413, 93702, 93702,  1684,  1645,  1896,  3453,
    4357, -4920, -4920, -4920, -4920,  4223, -4920, -4920,  2193, -4920,
   -4920, -4920, -4920, 67323, -4920,  2703, -4920,  1837,  4396, 68847,
    4495,  4495, 93702, -4920, 10100,  4284, -4920,  4047,  4303,  4352,
   -4920,  4086, 93702,  4243,  4087,  4089,  1133,  1133, 93702, 93702,
   93702,  2674,  2143, -4920,  1135,  4400, 77478,  3774, -4920,  1675,
    4091,  4397, -4920,  4510, 93702,  2143,  3697,  4092, -4920, -4920,
   79506,  4286,  3960,  3883,  4227, -4920,  4231, -4920,  1563, -4920,
    2143, 93702, 93702, 51394, -4920, 73927, -4920,  2682, -4920, -4920,
   -4920,  4170,  3552,  4208,  4224,  4103, 93702,   588, -4920,  4131,
   -4920, -4920, -4920, -4920, -4920, -4920, 93702, -4920,   233, -4920,
   -4920, -4920, -4920, -4920,  2867, 46739, 73419,  2687, 43589, -4920,
   43589, -4920,  4514, -4920, -4920, -4920,   731, -4920, -4920, -4920,
    5240,  5240,  5240, -4920,  4523,  3947, -4920, -4920,  2688,  4541,
   -4920, 93702,  2692, -4920, 43589,  4125, -4920, -4920, 50372,  2232,
    4126,  2705, 93702,  2710, 73419,  4127,  4132,  1159,  4133, 34161,
    4134, -4920, -4920, -4920, -4920, -4920, 15351, 15351, 93702, -4920,
    4128, -4920, -4920, -4920, -4920, -4920, -4920, 93702,  2724, -4920,
     825, 37289, -4920, -4920,  1591,  1187,   233,  4347,  4047, -4920,
    4138, -4920, -4920, -4920,  1550,  1550, 93702,  4047, -4920, -4920,
   93702,  4220, -4920, -4920, 67323,  4181, -4920,  1111,  3413, 93702,
   73419,  2522,   115, -4920, 73419, 73419, -4920, -4920, -4920, 43589,
    4225, -4920, -4920, -4920, -4920, -4920, 93702, 93702, 93702, 93702,
   93702,   348, -4920,  2727, -4920,118469, -4920, -4920,  3182,  2575,
    3182,  1927, -4920, -4920,  3182, -4920,  3182, -4920,  3987,  2575,
    4495,  1166, -4920, -4920, -4920,  1822,  4339, -4920,   919,  4335,
    4228,  4143, -4920, 68847,  4593,  4129, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920,  2731,  3774,  4451,  3446,  4051, 93702,
   -4920, -4920, -4920, -4920, 43589,  4307,  2143,  2145,  3514,  2358,
    4129, -4920, -4920, -4920,  3960, -4920, -4920,  4539,  4342,  4542,
    3514, -4920,  3363,  2749, -4920,  6617, 74943, 73419,  4490,  4200,
    4201, -4920, -4920,  4214, 93702, -4920, -4920,  2608,  4612,  3774,
   -4920,  2867,  2750, -4920,  2754,  2755,  4318,  4218, -4920, 43589,
    1898,  3781, 68339,  4171, -4920,  2758, -4920, 15351, 93702, -4920,
   -4920, 43589, -4920,  2759, -4920, -4920, 43589,  4173, 43589, -4920,
   45689,  4172, -4920,  4588, -4920, -4920,  3552, 51394, -4920,  4290,
   -4920,  4468, -4920, 93702,  4217, 60137,  3524,  3524,  2151, -4920,
    2020, -4920, 93702, -4920, 43589, -4920,  4263, -4920, -4920,  2768,
   -4920,  1626,  4332,  4480,  2797,  2800, 10304, 93702,  3454,  1896,
    3454, -4920,  3453, -4920, -4920, 67323, -4920,122027, -4920, -4920,
   -4920,  2575, -4920,  2575,  4384, 93702, 63222,  2575,  2575, -4920,
   -4920, -4920, -4920, -4920,  4508,  4452, -4920, -4920, -4920, -4920,
     316, -4920,  4377,  4380, 93702, -4920,  4186, -4920,  2804,  4305,
   -4920, -4920, 93702,  4608,  4609, -4920,   878, 10790, 68847,  4051,
    3514, -4920,  3883,  2358,  1695, -4920,  4382, -4920,  4385, -4920,
    4196,  3446,  6082, -4920, -4920,   300,  4486,  4489, -4920, -4920,
   -4920, -4920, -4920, 93702, -4920, -4920, -4920, -4920, -4920, -4920,
    3498, 42539, 42539,  4198, -4920, -4920, 93702, -4920,  2805,  2808,
   -4920,  2815, 45689,  2818, -4920, 93702,  4202, -4920, -4920, 55483,
  125107,  1550,  4203, -4920,  4204, -4920, -4920,  4303,  2020,  3413,
   15351, 93702, 68847,  4601, -4920, -4920, -4920,  4332, -4920, -4920,
   -4920,  3413, 93702, -4920, -4920,  2821, -4920, -4920, -4920, 93702,
    3863, -4920,  3863, -4920, -4920,  4331, -4920,   467,   467,  4543,
   -4920,  4262, -4920, -4920,  4209, -4920,  4655, 93702, -4920,   779,
    2143, 77478, -4920,  4211, -4920, -4920,  3960,  3883, -4920, -4920,
   51394,  3960, -4920, -4920, -4920,  2606, 68847, 68847, -4920, 46214,
    4338,  1038, 12826, -4920, -4920, -4920, -4920,  2825, -4920,  4355,
   -4920,  2828, -4920, -4920, -4920,  1290,   233,  3524, 43589,  2020,
   -4920,  4335, -4920,  3413,  2522, 93702, -4920, -4920, -4920, -4920,
  122027,  3863,  4046, -4920,  4645, -4920,  1076, -4920, -4920, -4920,
   -4920,  3774,  3975,  4051, 66815, -4920,  3960,  2829,  3552, -4920,
    2678, -4920, -4920, -4920, -4920, -4920, -4920, -4920,  4221,  4222,
    4635, -4920, -4920, -4920, -4920, -4920, -4920,  4219, -4920, -4920,
   -4920, -4920, -4920, 11244, -4920, -4920, -4920, -4920, -4920,  4527,
   -4920, -4920, -4920, -4920, -4920,  2833, -4920, -4920, -4920, -4920,
   -4920, -4920,  3446, -4920,  1742, -4920, -4920,  1901,  2379,  4294,
    4512, 43064, 43589, -4920,  2020,  4387, -4920, 66815,  3960, -4920,
    2678,  4324,  4326, -4920, 11465, 68847, -4920,  3552, -4920,  4261,
    4267, -4920,  4236, -4920,  4526,  4529, 66815, 68847, 68847,  2834,
   -4920, -4920, -4920
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    2514,     0,     2,     1,  2945,  2949,  2953,  2954,  2871,  2955,
    2956,  2921,  2922,  2923,  2924,  2925,  2926,  2927,  2928,  2929,
    2930,  2931,  2932,  2934,  2933,  2935,  2936,  2937,  2938,  2939,
    2940,  2941,  2942,  2944,  2943,  2893,  2521,  2890,  2887,  2888,
    2889,  2894,  2892,  2885,  2886,  2094,  2958,  2946,  2959,  2947,
    2948,  2950,  2951,  2920,  2952,  2960,  2961,  2962,  2957,  2965,
    2916,  2917,  2915,  2918,  2919,  2963,  2964,  2907,  2908,  2909,
    2910,  2966,  2522,  2523,  2912,  2515,  2519,  2583,  2654,  2913,
    2914,  2911,  2520,  2906,  2654,     0,  2775,  2776,  2777,     0,
    2778,  2779,  2780,  2706,  2668,  2781,     0,     0,  2782,  2783,
    2784,  2785,  2786,  2787,  2788,  2789,     0,  2790,  2791,  2792,
    2793,  2653,  2794,  2795,  2796,  2797,  2630,  2636,  2759,     0,
    2610,  2611,  2607,  2609,  2608,  2612,  2595,  1305,   585,  1390,
    1389,     0,  2416,  1305,  2371,  2372,  2417,  2373,  2374,  2375,
     272,     0,  1392,  2376,  2418,     0,  1305,  2419,   407,  1040,
    2420,  2421,  2538,     0,  2377,  2378,     0,     0,     0,   585,
    1305,     0,     0,  2379,  1519,  2380,     0,  2381,  2422,  2423,
       0,  2382,  2383,  2424,     0,  2425,  2384,  2385,  2386,  2426,
    2427,  2428,  2387,  2429,  2430,     0,     0,  1533,     0,  2388,
    2431,  2389,  2390,     0,  2432,  2391,  2392,  2393,  2433,  2434,
    2394,  2395,  2396,     0,  2397,     0,     0,     0,     0,     0,
       0,  2435,  1305,  2398,     0,     0,  1540,     0,  2399,     0,
    2436,  2400,     0,  2401,     0,  2437,  2402,  2403,  2404,  2405,
    1533,  2755,  2631,     0,  1394,     0,  2406,  2438,     0,  2407,
    2408,  2409,  2410,  2411,  2412,  2413,  2414,  2415,     0,     0,
       0,    65,    66,    27,    26,    32,    31,    90,    91,    51,
      15,    79,    58,   125,   124,   126,    38,    34,    73,    23,
      25,    35,    39,    60,    52,   103,    59,    21,    57,    84,
      61,    87,    46,     9,    10,    47,    77,    11,    48,    78,
      12,    49,    13,    99,    67,    92,    30,    56,    20,    83,
      40,    63,    89,    64,     3,    42,    75,    71,     8,    53,
      54,    55,    80,    81,    82,   108,    86,   120,    37,   117,
      96,    97,   114,    98,   115,     6,   100,    50,    14,   111,
     110,   112,    74,    43,    76,    62,    88,   109,    24,   113,
      16,    17,    19,    18,   116,    85,   106,   102,   121,   119,
     127,   104,    68,     4,     5,    93,    22,    45,     7,    29,
      28,    44,    36,   123,    33,  1392,    95,   107,    94,   101,
      72,   105,   122,    70,   118,  1504,  1491,  1542,  1503,  1518,
       0,  1507,  2850,  2851,    41,  1519,   129,   130,   135,  2518,
    2572,  2573,  2574,  2654,  2605,  2606,  2599,  2615,  2625,  2614,
    2618,  2626,  2613,  2632,     0,   132,   134,   136,   139,   133,
     128,   131,   138,   143,   137,   142,   140,   141,   144,   145,
     146,  2852,  1750,  2849,    69,  2590,  2589,     0,  2654,     0,
    2882,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,  2149,  2150,  2151,  2152,  2101,  2153,  2154,  2155,  2156,
    2157,  2158,  2159,  2160,  2161,  2162,  2163,  2164,  2165,  2166,
    2167,  2168,  2169,  2170,  2171,  2172,  2173,  2174,  2175,  2176,
    2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,
    2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2210,  2211,  2212,  2213,  2214,  2215,  2216,
    2217,  2218,  2219,  2220,  2221,  2222,  2223,  2224,  2225,  2226,
    2227,  2228,  2229,  2230,  2231,  2232,  2233,  2234,  2235,  2236,
    2237,  2238,  2239,  2240,  2241,  2242,  2243,  2244,  2245,  2246,
    2247,  2248,  2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,
    2257,  2258,  2259,  2260,  2261,  2262,  2263,  2264,  2265,  2266,
    2267,  2270,  2268,  2269,  2271,  2272,  2273,  2274,  2275,  2276,
    2277,  2278,  2279,  2280,  2281,  2282,  2283,  2284,  2285,  2286,
    2287,  2288,  2289,  2290,  2291,  2292,  2293,  2294,  2295,  2296,
    2297,  2298,  2299,  2300,  2301,  2302,  2303,  2304,  2305,  2306,
    2307,  2308,  2309,  2310,  2102,  2311,  2312,  2313,  2314,  2315,
    2316,  2317,  2318,  2319,  2320,  2321,  2322,  2323,  2324,  2325,
    2326,  2327,  2328,  2329,  2330,  2331,  2332,  2333,  2334,  2335,
    2336,  2538,  2337,  2338,  2339,  2340,  2341,  2342,  2343,  2344,
    2345,  2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,  2354,
    2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,
    2365,  2366,  2367,  2368,  2369,  2370,  2556,  2099,  2100,  2106,
    2107,  2108,  2531,  2552,  2558,  2878,  2557,  2105,  2705,     0,
       0,  2798,  2799,  2800,  2801,  2802,  2803,  2853,  2854,  2855,
    2856,  2857,  2859,  2858,  2667,  2825,  2862,  2666,  2863,  2670,
    2864,  2865,  2866,  2867,  2826,  2868,  2669,  2860,  2822,  2671,
    2664,  2665,  2823,  2773,  2774,  2072,  2824,  2821,  2861,  2559,
    2820,  2675,  2674,  1481,  2877,  2071,  1482,     0,  2677,  2804,
    2805,  2806,  2807,  2809,  2808,  2810,  2439,  2440,  2441,  2442,
    2443,  2444,  2445,  2446,  2447,  2448,  2449,  2450,  2835,  2451,
    2452,  2453,  2848,  2454,  2455,  2836,  2456,  2457,  2458,  2459,
    2460,  2461,  2462,  2463,  2464,  2465,  2466,  2467,  2468,  2469,
    2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2837,  2838,  2480,  2481,  2482,  2483,  2484,  2485,  2486,  2487,
    2488,  2489,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,  2499,  2500,  2501,  2502,  2503,  2839,  2504,  2505,  2840,
    2506,  2507,  2508,  2841,  2509,  2510,  2511,  2512,  2513,  2845,
    2846,  2847,  2834,  2628,  2811,  2833,  2844,  2842,  2843,  2638,
    2634,  2642,  2637,     0,     0,     0,     0,  2654,  1304,  1303,
    1289,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   584,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2528,     0,  1315,   378,   377,  1391,  1371,   585,
       0,  1292,   406,  1519,     0,     0,     0,     0,     0,     0,
       0,     0,   801,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   195,     0,     0,   430,   429,     0,
       0,     0,  1013,   435,     0,     0,     0,     0,     0,   573,
    2537,  2532,  2542,     0,  2535,  2536,  2820,     0,  2969,  2268,
    2568,  2569,  2967,  2322,  1483,   273,   276,   277,   274,   275,
       0,  1123,  1124,  1126,     0,     0,     0,  1136,   839,   840,
       0,     0,     0,   842,     0,     0,     0,   835,     0,     0,
       0,     0,     0,     0,   841,   832,     0,   831,     0,     0,
    1136,     0,     0,     0,   833,     0,     0,  1293,     0,  2620,
    2621,  2202,  1432,   436,     0,     0,  1519,     0,  1409,  1410,
    1392,  1399,  1411,  1404,  1406,  1405,  1407,  1403,  1408,  2110,
     951,  2124,   951,  2192,   948,   949,   951,   951,   951,  2285,
       0,     0,   923,     0,   934,  2095,   951,  2096,  2878,   956,
     491,   491,   491,     0,   955,   960,   491,     0,  1286,  1324,
    2076,  1532,     0,  2124,  2192,   924,  1285,  2337,  1423,     0,
       0,  1151,  1147,  1149,  1150,  1148,     0,     0,     0,  2301,
    1297,   257,  2818,  2310,  2402,  2337,  2819,   256,   251,   252,
    2813,  2814,  2816,   225,  2817,  2815,  2812,  2114,     0,     0,
     955,     0,  1294,  1295,   909,  1539,  1537,     0,  2058,     0,
       0,  2132,     0,  2145,  2227,   248,  2296,  2302,  2310,  2402,
    2337,  2368,   204,   214,   209,     0,   266,  2310,  2402,  2337,
       0,  1315,     0,  1508,  1639,  2067,     0,     0,  2629,  1288,
    1287,  1393,     0,  1396,     0,  1600,  2281,  1512,  1515,  1398,
    1513,  1504,     0,     0,  2517,  1387,  1536,  1536,     0,  1536,
       0,  1496,  1504,  1499,  1503,     0,     0,     0,     0,  1305,
       0,  2597,  2625,  2604,  2660,  2601,     0,     0,  2650,  2646,
    2643,  2651,  2652,  2645,  2633,  1739,  1740,  1741,  1738,  1751,
    1737,     0,  2578,  1742,  2617,  2584,     0,  2592,  2591,  2895,
    2896,  2707,  2530,  2549,     0,     0,     0,     0,     0,     0,
       0,  2676,  2678,  2680,  2640,  2639,  2635,     0,     0,     0,
       0,  2765,  2766,  2764,     0,  2761,  2763,     0,  2660,     0,
    2829,  2823,  2832,     0,  2077,  2824,  2821,  2820,     0,   849,
       0,  1327,  1000,     0,     0,     0,     0,  2071,     0,     0,
       0,     0,     0,  2099,     0,  2201,     0,     0,     0,  1964,
    1975,  1976,  1977,  2136,  2187,  1972,  1973,  1974,  1966,  1967,
    1968,  1969,  1970,  1971,     0,  1121,  1965,     0,  2201,     0,
     173,     0,   151,     0,     0,  2201,     0,     0,     0,     0,
       0,  2201,     0,     0,     0,     0,     0,   173,  2232,     0,
     151,  2201,     0,     0,     0,  1309,     0,     0,     0,  1311,
    1314,  1290,  1374,     0,  2067,     0,     0,     0,   886,   878,
       0,   887,   879,     0,     0,   889,     0,     0,   881,     0,
       0,     0,     0,   890,     0,   880,   882,   892,   883,   888,
       0,     0,     0,     0,   884,     0,     0,  1301,     0,  1425,
    1427,  1426,  1424,   491,     0,     0,     0,     0,     0,     0,
     151,  1359,     0,  2201,   151,     0,     0,   434,   433,   151,
     432,   431,  2136,  2187,     0,  1039,     0,   151,  2201,     0,
     197,   658,   588,     0,     0,   760,  2232,   151,     0,     0,
       0,     0,     0,     0,  1016,     0,     0,     0,   572,   585,
       0,  2541,  2547,     0,  2539,  2708,  2970,  2968,  2663,     0,
    1127,   249,   250,  1125,   837,  2201,     0,   352,     0,     0,
    2201,  1346,  1697,  1726,  1704,  1726,  1726,  1693,  1693,  2171,
    1706,  2201,  1694,  1695,  1733,     0,  1726,  1693,  1698,     0,
    1696,  1736,  1736,  1721,   352,   853,  1678,  1679,  1680,  1681,
    1707,  1708,  1682,  1713,  1714,  1728,  1683,  1750,  2830,  1693,
    2831,  2828,  2827,   838,     0,   836,  2201,     0,  2201,  2103,
     188,     0,   834,  2136,  2187,  2201,     0,     0,  2201,     0,
    2201,   180,  2201,     0,  2201,   352,  2201,   589,     0,     0,
    2201,     0,  2201,   352,  2201,  2232,   182,     0,  2201,   352,
     847,     0,     0,  2900,  2904,     0,  2902,  2897,  2619,  2673,
    2672,  2571,     0,  2981,     0,  1483,  1401,  1416,     0,  1412,
    1419,  1415,  1519,   951,   950,     0,   951,     0,  2991,   951,
       0,   951,     0,  2991,   951,     0,     0,     0,   951,  2097,
    2098,     0,     0,  2990,  2986,  2989,   925,   935,     0,   957,
       0,     0,   964,   963,   962,     0,     0,     0,   965,     0,
    1643,  1455,     0,   932,     0,   930,     0,  1283,  1300,     0,
       0,     0,     0,  1016,  1154,     0,  1152,  1143,  1144,  1296,
     255,   253,     0,     0,     0,     0,     0,     0,  1302,     0,
       0,     0,     0,  2884,  2083,  1978,  2883,     0,  2372,  2373,
    2374,  2037,     0,  2825,  2375,  2376,  2418,  1880,  1867,  1876,
    1881,  1868,  1870,  1877,  2377,  2378,  2379,  2380,  2090,  2381,
    2382,  2383,  2385,  2386,  2387,  1872,  1874,  2388,  2389,     0,
    2091,  2391,  2392,  2252,  2394,  2395,  2397,  2398,  1878,  2400,
    2401,  2402,  2403,  2404,  2405,  2089,     0,  1879,  2406,  2408,
    2409,  2410,  2411,  2412,  2413,  2414,  2415,     0,     0,     0,
    2064,     0,  1847,     0,  1686,  1687,  1709,  1710,  1688,  1715,
    1716,  1689,     0,  2063,  1753,  1929,  1846,  1863,     0,  1852,
    1853,     0,  1845,  1841,  1522,  2059,     0,  1842,  2079,  2038,
    2093,  2092,  2878,  2048,  2082,  2080,  2081,  1522,  2057,     0,
       0,     0,   217,     0,     0,  2754,   268,     0,   269,  2065,
    2310,   205,   247,   219,   246,   220,   218,     0,  2134,   206,
       0,     0,   207,     0,     0,     0,     0,     0,     0,     0,
     262,  1291,     0,  1641,  1640,  2045,     0,  2046,  2068,   858,
       0,  1384,  1385,  1383,     0,  1380,  1382,  1386,  1395,  1392,
    2053,  2052,  2054,     0,  1514,     0,     0,     0,  1494,  1493,
    1398,  1534,  1535,     0,     0,     0,     0,     0,     0,     0,
       0,  1590,  1550,  1551,  1553,  1587,  1591,  1599,     0,  1500,
       0,     0,  1645,     0,  1601,  2516,  2660,  2661,     0,  2655,
       0,  2654,  2654,  2648,  2647,  2644,     0,     0,     0,     0,
       0,     0,     0,     0,  2575,   567,  2577,   564,     0,     0,
    2551,     0,  2555,  2553,     0,  2700,  2703,     0,  2701,  2702,
    2704,     0,  2709,  2710,     0,     0,  2891,     0,     0,     0,
    2691,  2679,  2686,  2688,  2690,  2689,  2698,  2694,  2697,  2699,
    2641,  2654,  2772,     0,  2767,  2770,     0,  2762,     0,     0,
       0,  2078,     0,     0,     0,     0,   850,     0,     0,     0,
       0,  1335,  1336,  1337,     0,     0,  1338,  1339,  1327,   259,
    1345,  1343,  1326,  1328,  1341,  1333,     0,     0,     0,     0,
       0,     0,     0,  1351,     0,     0,   186,   187,   601,   585,
       0,  2201,     0,     0,     0,     0,     0,  1079,  1086,     0,
       0,     0,     0,     0,     0,     0,     0,  1080,  1078,  1081,
     261,  1090,  1107,  1110,     0,   990,     0,     0,     0,     0,
       0,  1206,     0,     0,     0,  1206,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   282,
     294,   347,     0,     0,  2201,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   149,   150,   155,     0,
       0,     0,     0,     0,     0,   551,   563,     0,     0,     0,
       0,     0,   560,     0,   151,   286,   544,   548,     0,     0,
       0,   667,   666,  1349,  1348,     0,     0,     0,  1206,     0,
     278,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   370,   371,     0,     0,
       0,   155,     0,     0,     0,     0,   288,     0,  2585,     0,
    1310,  1307,  1308,     0,  1313,     0,  1370,     0,   877,     0,
       0,     0,     0,   894,     0,   891,     0,     0,   885,  2136,
    2187,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   409,     0,     0,   757,     0,     0,     0,     0,     0,
     768,     0,  1327,  1358,     0,     0,     0,   594,     0,  2201,
       0,   153,   802,     0,   758,   435,     0,     0,   153,     0,
       0,   191,     0,   662,     0,     0,     0,     0,     0,     0,
     706,   705,     0,     0,     0,   759,     0,   153,     0,  2201,
     547,  2201,     0,   491,   491,     0,     0,  1015,  1018,     0,
       0,     0,     0,  2545,  2540,  2543,     0,  2533,  2547,  1486,
    1488,  1487,     0,  1485,     0,   352,   350,   351,   755,  1135,
       0,     0,  1725,  1712,  1720,  1719,     0,  1702,  1701,  1700,
       0,  1699,     0,  1726,  1726,  1724,  1703,  1678,     0,     0,
       0,  1732,     0,  1730,     0,   827,  1674,  1670,     0,     0,
    1718,  1739,  1738,  1737,     0,  1684,  1693,  1690,     0,     0,
     352,     0,     0,  2201,   352,  2201,     0,  2201,     0,     0,
     352,   352,     0,     0,     0,     0,     0,     0,   663,     0,
     846,   844,   843,   845,     0,     0,     0,     0,   825,     0,
       0,     0,  2201,   352,     0,     0,   824,  2898,     0,     0,
    2901,     0,  2622,  1988,     0,  2987,  1428,  2984,     0,     0,
    1519,     0,   236,   237,   235,  1417,   238,  1418,  1414,  1400,
       0,   943,     0,  2991,  2992,   928,     0,   938,     0,  2991,
     926,     0,   939,   936,   937,     0,     0,     0,  2985,  2869,
    2875,   942,     0,     0,   492,   494,     0,     0,  2156,  2170,
       0,  2193,  2220,  2221,  2302,  2306,     0,  2332,  2342,     0,
     966,   995,   961,   676,     0,     0,  1465,   933,   931,  1284,
    1421,  1995,     0,  1519,     0,     0,     0,     0,   254,   226,
       0,     0,     0,   997,  2301,  1299,   908,   585,     0,     0,
    1850,  1851,  2036,     0,     0,     0,     0,     0,     0,  1849,
    2003,     0,     0,     0,     0,     0,  1776,     0,     0,     0,
    2016,     0,  2022,     0,     0,  1813,     0,     0,     0,     0,
       0,     0,     0,     0,  1777,  1757,  1758,  2826,  1847,  1988,
       0,  1848,  2086,     0,  1750,  1978,     0,  1975,  1976,  1977,
       0,     0,     0,  2051,     0,  1986,     0,     0,  1791,  1984,
    1793,     0,     0,     0,     0,  1972,  1973,  1974,  1966,  1967,
    1968,  1969,  1970,  1971,  1982,  1773,     0,  2062,     0,  1931,
       0,  1772,     0,     0,  1603,  1521,     0,  2084,  2039,     0,
    2876,  2879,  1843,  1603,  2751,  2750,  2749,  2748,  2719,     0,
    2713,  2714,     0,  2752,  2753,   270,   271,   267,     0,     0,
     222,   221,     0,   244,   245,   216,   243,     0,   239,   240,
     224,  1920,  1919,   223,   215,   212,   210,   227,   229,   230,
     213,   211,   265,   263,     0,     0,  2044,     0,  2041,  2040,
    2074,  2047,     0,     0,   352,  2654,  1378,     0,  1375,  2056,
       0,  1516,     0,  2069,     0,  1388,  1511,  1510,  1543,  1544,
    1032,  1509,  1570,  1571,     0,     0,     0,     0,  1596,  1594,
    1561,  1554,  1560,     0,     0,  1558,     0,  1562,  1753,  1589,
    1498,  1548,  1549,  1552,  1497,     0,  1592,     0,  1468,  1590,
    1553,  1452,     0,  1434,     0,  1646,     0,     0,  2662,  2660,
    2600,  1678,  2654,  2593,  2654,  2649,  2581,  1744,  1745,  1746,
    1747,  1748,  1749,  2582,     0,  2579,  1743,  2580,   565,   566,
       0,     0,     0,  2548,     0,  2529,  2554,  2685,  2318,  2717,
       0,  2718,     0,     0,  2682,     0,  2692,  2695,  2693,  2696,
       0,  1678,  2872,  2768,  2872,  1678,  1054,  1056,     0,  1055,
       0,  1058,     0,  1067,     0,     0,  1053,  1072,     0,  1061,
    1059,     0,     0,     0,     0,     0,     0,   851,     0,     0,
       0,     0,  1334,     0,     0,  2332,   258,  1337,  1342,  1329,
    1340,     0,     0,     0,     0,     0,   999,   998,     0,     0,
    1020,     0,     0,     0,  1354,   480,     0,   349,     0,     0,
       0,     0,     0,     0,     0,     0,   753,   750,     0,     0,
     749,     0,   599,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   637,     0,  1206,     0,   670,     0,  1088,
       0,     0,  1087,     0,  1091,     0,     0,  1089,  1084,  1085,
    2302,  2310,  2337,   260,  1109,     0,  1108,  1106,  1042,     0,
    1043,     0,     0,     0,     0,     0,  2180,  2201,   296,   311,
       0,  1205,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   334,     0,     0,
     337,   336,     0,     0,     0,     0,     0,   341,   320,     0,
     321,     0,     0,   340,     0,     0,     0,     0,     0,     0,
    1206,     0,   290,     0,     0,     0,     0,     0,     0,  1122,
       0,   694,     0,     0,   176,     0,   172,   175,     0,     0,
       0,     0,   550,   562,     0,   554,   555,   552,   556,   557,
       0,     0,     0,     0,     0,     0,   549,     0,     0,   660,
     659,   665,     0,     0,     0,     0,     0,     0,     0,     0,
    1156,  1155,     0,     0,     0,     0,     0,     0,   792,     0,
       0,     0,     0,     0,     0,     0,   179,   679,     0,   678,
       0,   177,   178,     0,     0,     0,     0,     0,     0,     0,
     234,  1306,  1312,  1373,  2075,  1372,     0,     0,     0,     0,
     893,     0,     0,     0,     0,     0,     0,     0,     0,   895,
     896,   897,   898,     0,     0,     0,     0,     0,   384,     0,
       0,     0,     0,   781,  2827,   756,     0,     0,   769,     0,
     771,   774,     0,  1325,   453,     0,     0,   591,   637,     0,
     438,   184,     0,     0,     0,     0,   696,   148,   195,   197,
     436,     0,   196,   198,   200,   201,   202,   199,   203,   657,
     661,     0,   587,     0,     0,     0,     0,     0,   707,   711,
     710,   714,   712,     0,   708,     0,     0,  1666,     0,   171,
       0,     0,   542,   546,     0,  2524,     0,   438,   522,   363,
    2201,     0,   491,     0,  2201,     0,  1017,     0,     0,     0,
       0,     0,     0,  2546,     0,     0,     0,     0,  1484,     0,
    1113,     0,  1347,     0,     0,     0,   352,  1723,  1722,  1675,
    1671,     0,     0,     0,     0,   854,     0,     0,     0,     0,
       0,     0,     0,  1691,  2201,   352,     0,  1111,   189,  2104,
       0,   829,     0,     0,     0,     0,     0,  1115,   821,     0,
     352,   181,     0,   352,   352,   590,     0,     0,   352,   352,
     183,     0,     0,     0,   582,   352,   848,  2899,  2905,  2903,
    1431,     0,  2988,  2982,  2983,  2201,   491,  1488,  1402,  1413,
     940,   947,   929,   946,   945,   927,   944,   941,  2684,     0,
       0,  2874,     0,   958,     0,   490,     0,     0,     0,   972,
     973,     0,     0,   971,   988,   974,     0,   976,   968,   967,
     977,   978,     0,     0,   997,   674,     0,     0,     0,     0,
    1462,     0,  1460,     0,  1644,  1464,  1453,  1422,     0,  1420,
       0,   535,     0,     0,  1153,     0,     0,   955,     0,     0,
     352,  1298,     0,   910,   911,     0,     0,     0,     0,     0,
       0,   917,   914,   915,   916,   918,     0,   919,     0,     0,
       0,  1999,     0,  2000,     0,     0,  2035,  2031,     0,     0,
       0,     0,     0,  2007,  2008,  2009,  2006,  2010,  2005,     0,
       0,  2011,  2004,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2398,     0,     0,     0,     0,  1816,     0,     0,
    1959,     0,  1988,  2021,     0,     0,     0,     0,     0,     0,
    1988,  2027,     0,     0,     0,     0,  1918,     0,  1915,     0,
       0,     0,     0,  2048,     0,     0,  2087,  1754,  1768,  1769,
    1770,  1774,  2061,     0,  2050,     0,     0,  1755,  1782,     0,
    2028,  1809,     0,  1814,  1797,     0,  1790,     0,  1795,  1799,
    1778,     0,  1775,     0,  2051,  1987,     0,  1985,     0,  1765,
    1766,  1767,  1759,  1760,  1761,  1762,  1763,  1764,  1771,  1963,
    1961,  1962,     0,     0,     0,  1939,     0,     0,  1794,  2195,
    2227,     0,  1533,  1533,  1533,  1520,  1531,  2060,     0,  1661,
       0,     0,     0,     0,  1855,     0,  1992,  1542,  1990,  2077,
    2881,  2880,  2049,  1661,     0,     0,     0,  2066,     0,     0,
    1750,     0,   264,  1642,  2042,  2045,   856,   857,   855,  1678,
    1398,  1381,  1377,  1376,  2055,  1397,     0,  1519,     0,  1030,
    1031,     0,  1035,  2398,  2299,     0,     0,     0,     0,  1563,
    1597,     0,  1588,     0,  1564,  2079,  2080,  1565,  1568,  1569,
    1559,  1598,  1466,     0,  1593,  1502,  1501,     0,  1664,     0,
       0,  1444,  1436,     0,  1647,     0,  1603,  1470,  1472,  1473,
       0,  2048,  2598,  2656,  2603,  2624,  2594,  2627,  1752,  2576,
    2616,     0,  2550,  2720,  2721,     0,  2711,  2712,  2681,  2687,
    2758,     0,  2873,     0,     0,  1057,     0,  1693,  1068,     0,
    1052,     0,  1051,  1693,     0,  1069,     0,  1693,     0,     0,
       0,  1243,  1158,  1214,   852,  1244,  1159,  1215,  1245,  1160,
    1344,  1332,  1331,  1330,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   732,  2201,
     352,  1352,  1246,     0,  1161,   348,  1353,  1216,  1357,   752,
     751,     0,     0,  1217,     0,   600,     0,     0,     0,   606,
     607,   608,     0,     0,     0,   609,     0,  2136,  2187,     0,
     614,   621,   626,   616,     0,     0,   628,   622,     0,     0,
       0,     0,     0,     0,   634,   636,     0,     0,     0,     0,
       0,     0,     0,  1082,  1083,  1247,  1164,     0,  1218,  1041,
       0,  1165,   185,     0,     0,   283,  2201,   298,     0,   643,
     732,  1208,   318,     0,     0,   333,   328,   329,   327,  2201,
     352,  2201,   352,     0,     0,     0,     0,     0,   330,   325,
     326,   322,     0,     0,   335,  2113,  2172,  2311,     0,   647,
     649,     0,   654,   338,  1181,   359,   358,   357,     0,   342,
       0,   364,   367,   339,   316,   319,   317,   313,   295,     0,
       0,     0,     0,     0,     0,     0,     0,  2073,     0,     0,
    1117,     0,     0,     0,     0,     0,     0,     0,   688,   174,
    1196,     0,     0,   160,     0,     0,     0,     0,   154,   164,
       0,  1253,  1171,     0,     0,   287,   545,   553,   558,  1175,
     561,  1228,   559,  1259,  1172,     0,  1206,     0,   279,     0,
    1173,     0,  1222,  1255,  1198,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1360,     0,     0,     0,     0,     0,
       0,   352,     0,     0,     0,  1208,  2201,   352,  1254,     0,
    1203,  1236,     0,   372,     0,  1197,     0,     0,   289,  1177,
    1230,     0,     0,   232,   231,   233,     0,     0,  2170,     0,
     900,   861,   899,     0,     0,     0,     0,     0,     0,   869,
       0,     0,     0,   860,     0,   859,   383,     0,   408,   381,
     382,   384,     0,   780,     0,     0,     0,     0,   770,     0,
       0,     0,  1350,     0,   151,   598,     0,     0,     0,   593,
     636,   643,     0,     0,     0,   437,   441,   445,   446,   447,
       0,     0,     0,     0,   165,   152,     0,   810,     0,   491,
       0,   692,     0,   197,   190,     0,     0,     0,   363,   767,
     765,   764,   766,     0,     0,     0,   785,   763,     0,  1665,
    1667,     0,     0,     0,     0,     0,     0,   440,     0,   494,
       0,     0,   526,     0,     0,     0,     0,   363,     0,     0,
       0,  1046,     0,  1064,  1047,     0,     0,     0,     0,  1095,
    1102,  1096,  1074,     0,     0,   570,  2544,  2538,  1489,  1490,
       0,   352,     0,     0,  1692,  1705,   828,     0,  1735,  1734,
    1736,  1736,     0,  1676,     0,  2971,  2979,  2978,     0,  1727,
    1728,  1685,     0,   638,   352,   352,     0,   352,     0,   352,
     352,     0,   685,     0,  1281,   664,     0,     0,   740,   826,
       0,     0,   352,   823,  1989,     0,     0,  2683,  2870,   959,
     493,     0,     0,     0,     0,   970,     0,   568,   975,     0,
     987,   982,   984,     0,   991,   673,     0,     0,  1463,  1456,
    1458,  1457,     0,     0,  1454,  1996,   822,     0,   541,  1145,
    1146,     0,     0,   352,     0,   992,     0,     0,   912,   913,
       0,     0,   920,     0,     0,     0,  1538,  1997,  1998,     0,
       0,     0,  2032,     0,     0,  1893,     0,  1869,  1871,  1883,
       0,  1894,  1854,  1895,  1873,  1875,     0,  1979,     0,     0,
    1884,     0,  1818,  1819,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1834,  1833,  1885,  1958,     0,     0,  2019,  2020,  1886,
       0,     0,  2026,     0,     0,     0,  1891,  1896,     0,     0,
       0,     0,  1902,     0,  1923,     0,     0,     0,  1844,  1989,
       0,     0,     0,     0,     0,     0,     0,     0,  1815,  1798,
    1792,     0,  1796,  1800,     0,     0,     0,  1786,     0,     0,
    1784,  1810,  1780,     0,     0,  1811,     0,     0,     0,  1862,
       0,     0,  1533,  1533,  1533,  1533,  1530,     0,     0,     0,
       0,  2299,     0,  1625,  1602,  1604,  1612,  1625,  1630,  1864,
    1659,  1865,     0,  2067,     0,  1573,  1542,  1542,  1542,  1861,
       0,     0,     0,     0,  1541,  1573,  2733,  2735,  2736,  2737,
    2738,  2739,  2741,  2742,  2744,  2745,  2746,  2734,  2740,  2743,
    2747,  2724,  2725,     0,  2715,  2716,   208,     0,   241,   228,
    2044,     0,  2758,  1379,  2070,     0,  1545,     0,  1980,  1035,
       0,  1547,  1566,  1567,     0,  1557,  1595,  1555,  1467,  1451,
       0,  1449,  1438,     0,  1439,  2048,     0,  1449,  1435,  1478,
       0,     0,  1664,     0,  1477,     0,  2658,  2586,     0,     0,
    2757,  2760,  2771,  2769,  2596,     0,  1693,  1049,  1050,     0,
    1073,     0,  1242,  1157,  1213,  1002,  1003,     0,  1001,     0,
       0,     0,   479,  1019,     0,     0,     0,   732,     0,     0,
     483,     0,  1355,     0,  1260,  1195,   602,   603,   604,     0,
     615,     0,   624,   623,     0,     0,   611,     0,     0,     0,
       0,     0,   610,   630,   574,   631,   633,     0,     0,   632,
     635,   640,  1206,     0,   671,  1183,     0,  1234,  1076,  1209,
       0,  1044,     0,     0,     0,     0,     0,     0,   453,   312,
       0,     0,     0,   300,   310,     0,  1212,   344,     0,   315,
       0,   308,   331,   323,   332,   324,   343,   345,     0,   651,
     652,   650,   646,     0,   653,   655,     0,   361,     0,     0,
       0,  1249,     0,  1206,     0,   291,     0,  1179,     0,  1232,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1250,  1219,     0,  1238,     0,     0,     0,   693,     0,
     690,     0,     0,   157,   156,     0,   163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   373,   354,     0,   788,     0,     0,
       0,   375,     0,     0,     0,     0,  1248,  1166,   862,     0,
       0,     0,   863,   874,     0,     0,   864,     0,     0,     0,
       0,   876,   386,   387,   151,   385,     0,     0,   782,     0,
    2252,  1966,  1967,   778,   783,   775,   777,   776,   779,   732,
       0,   772,   773,     0,     0,     0,     0,     0,   465,     0,
       0,   459,     0,     0,  1102,   452,   455,   456,     0,     0,
     594,   597,   595,   596,   629,     0,   472,   518,     0,   167,
       0,     0,   168,   166,     0,     0,   363,   697,   701,   699,
     698,   700,   695,     0,   688,     0,   193,   436,     0,     0,
     586,   713,   716,   709,     0,   784,   786,   761,     0,   643,
       0,   547,     0,   491,  1432,   535,     0,   522,   518,   520,
     519,   521,     0,   528,   362,     0,     0,   535,   528,     0,
       0,  1020,  1045,     0,     0,     0,  1092,  1097,  1093,     0,
       0,  1060,     0,  1094,     0,  1075,  1038,  1276,  1277,  1274,
    1275,     0,     0,     0,  2561,  1480,  2570,  1114,     0,  1711,
       0,  1731,  1729,  1672,     0,  2654,     0,     0,     0,     0,
       0,  1677,  1717,   352,  1112,   830,     0,   817,     0,   819,
    1116,   352,   352,   352,   352,   680,     0,   583,     0,     0,
       0,     0,     0,   969,   989,     0,   985,     0,     0,   952,
     994,     0,     0,  1461,  1459,   533,     0,   997,     0,   953,
     996,     0,     0,     0,     0,     0,     0,     0,  2001,     0,
    2034,  2030,     0,  1866,  2002,     0,  2014,  2013,  1959,     0,
       0,  1817,  1829,  1830,  1831,  2015,     0,  1839,     0,     0,
    1826,  1827,  1828,  1820,  1821,  1822,  1823,  1824,  1825,  1832,
    2024,  2023,  2017,  2018,     0,  1888,  1889,  1890,  2025,  1897,
       0,  2127,  1924,  1901,  1917,  1916,     0,     0,     0,  1904,
       0,     0,  1913,     0,  1960,  2088,  1756,     0,     0,  1783,
    2029,  1801,     0,     0,     0,  1779,  1979,     0,     0,     0,
       0,     0,  1788,     0,     0,     0,  1942,  1937,  1938,  1956,
       0,     0,     0,     0,     0,     0,  1524,  1523,  1529,  1625,
    1630,     0,  1504,     0,  1612,     0,  1624,  1610,  1623,     0,
       0,  1636,  1634,     0,  1636,     0,  1636,     0,  1606,     0,
    1626,  1608,  1623,     0,  1651,     0,  2068,  1660,     0,  1586,
       0,     0,     0,     0,  1993,  1994,     0,  1991,  1856,  1586,
       0,     0,     0,  2043,  2756,  1517,     0,  1546,  1033,  1034,
    1556,     0,  1662,     0,  1450,     0,     0,  1441,  1447,  1433,
       0,     0,  1471,  1449,  1474,  2602,     0,  2657,  2722,  2723,
    1070,     0,     0,  1062,  1008,  1009,  1007,  1010,     0,     0,
       0,   732,     0,     0,   499,     0,  1027,  1027,     0,     0,
     485,   531,  1102,   735,     0,     0,     0,   733,   352,  1162,
       0,   625,     0,     0,   620,   618,   617,   619,     0,   575,
    1258,  1163,     0,     0,     0,     0,  1077,     0,     0,  1182,
       0,   297,     0,   450,     0,   305,  1207,     0,     0,     0,
     304,     0,   352,   352,   346,   648,   360,   365,   366,   369,
       0,     0,     0,     0,     0,  1211,     0,     0,     0,     0,
       0,     0,     0,   811,   794,     0,     0,   812,   813,     0,
       0,     0,  1119,  1120,  1118,  1237,     0,     0,     0,  1169,
       0,     0,   684,   161,   158,   159,   162,  1193,  1176,  1229,
       0,     0,     0,  1174,     0,  1223,  1189,  1185,     0,     0,
       0,     0,     0,  1257,  1202,  1227,  1256,  1200,  1225,  1199,
    1224,  1201,  1226,     0,  1194,     0,  1669,   791,     0,     0,
       0,   352,   352,   682,  1178,  1231,     0,     0,   865,     0,
       0,   867,   868,     0,   871,   391,   411,   702,   754,     0,
       0,   731,     0,   457,     0,   463,   467,   468,   466,   458,
    1102,   491,   530,     0,     0,   744,     0,   592,   438,   469,
       0,     0,   442,   170,   169,     0,     0,     0,   691,   690,
     197,  2201,     0,     0,   718,   722,   762,     0,  1668,   677,
     363,   543,  2526,     0,   438,   535,  2525,     0,   443,   448,
     449,     0,   526,   522,     0,     0,   532,  1323,     0,   536,
     538,     0,     0,     0,  1048,  1065,  1066,     0,     0,  1102,
       0,     0,  1101,     0,     0,   577,     0,  2534,   352,  1673,
    2972,     0,  2973,  2974,  2975,  2976,  2977,   639,   352,   352,
     686,  1282,  1142,   741,     0,   981,   980,   979,   569,     0,
     983,   675,     0,   534,   352,     0,     0,   922,   903,   921,
       0,     0,   902,     0,   901,  2033,  1882,  1892,  2012,  1958,
    1989,     0,     0,  1840,     0,     0,  1887,  2407,     0,     0,
       0,     0,  1921,  1922,  1903,     0,  2243,  1908,     0,     0,
       0,  1807,  1805,  1802,     0,  1803,  1787,     0,     0,  1785,
    1781,     0,  1812,  1928,     0,  1944,  1941,  1955,  1989,  1528,
    1527,  1526,  1525,  1611,  1609,     0,  1614,  1621,     0,  1605,
       0,  1635,  1631,     0,  1632,     0,     0,  1633,     0,     0,
    1607,     0,  1621,     0,  1658,  1542,     0,     0,  1933,  1859,
    1860,  1857,  1542,  2085,  1933,  2726,     0,  2729,  2727,  2728,
    2732,   242,     0,     0,  2987,  1437,  1440,     0,     0,     0,
       0,  1479,  1469,  2659,  1063,  1071,     0,     0,     0,   481,
       0,  1102,     0,     0,     0,  1029,  1029,     0,  1102,   530,
     737,   736,   739,   734,   738,  1356,     0,   612,   613,   627,
    1184,     0,  1235,  1191,     0,  1465,   299,     0,   644,   301,
     302,   303,   306,   354,   314,   307,     0,     0,     0,  1180,
       0,  1233,  1187,  1251,  1167,  1220,     0,     0,   800,     0,
       0,     0,     0,  1252,  1168,  1221,  1239,  1240,  1241,     0,
       0,     0,     0,  1465,     0,     0,     0,     0,     0,  1365,
       0,  1210,   353,   790,   789,   354,   374,  1204,     0,   866,
     872,   873,   870,     0,   380,   388,   412,   151,     0,     0,
    1133,  1133,     0,   732,     0,     0,   454,   530,   498,     0,
     460,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   683,   192,     0,   438,   643,   717,     0,
       0,     0,   787,     0,     0,     0,   440,     0,  1429,   439,
       0,     0,   528,   526,     0,   523,     0,   527,     0,  1316,
       0,     0,     0,     0,  1098,     0,  1104,     0,  1059,  1036,
    1099,     0,  1661,     0,     0,     0,     0,   581,  2560,  2564,
    1134,  2980,   818,   820,   681,   986,     0,   993,   352,   904,
     905,   906,   907,  1960,  1835,     0,     0,     0,     0,  1898,
       0,  1899,  1926,  1925,  1905,  1909,     0,  1906,  1907,  1804,
    1808,  1806,  1789,  1930,     0,  1542,  1957,  1654,     0,  1657,
    1613,     0,     0,  1615,     0,     0,  1617,  1619,     0,     0,
       0,     0,     0,     0,  2071,     0,  2152,  2383,  2298,     0,
    1572,  1574,  1577,  1579,  1578,  1580,  1576,  1585,     0,  1506,
       0,  1505,  2731,  2730,  1981,  1663,  1448,     0,     0,  1021,
       0,     0,  1476,  1475,   987,     0,   352,  1027,   530,   500,
    2252,   501,  1026,  1028,  1032,  1032,     0,   530,   732,   605,
       0,     0,   284,   642,     0,   356,   368,     0,  1465,     0,
       0,     0,   807,   795,     0,     0,   814,  1170,   687,     0,
       0,   280,  1190,  1186,  1367,  1368,     0,     0,     0,     0,
       0,   352,   875,     0,   414,   421,   392,   397,  1359,     0,
    1359,     0,   394,   398,  1359,   393,  1359,   390,   391,     0,
    1133,     0,  1130,  1129,   730,     0,   489,   461,     0,   509,
       0,     0,   745,     0,     0,   518,   478,   477,   474,   473,
     475,   476,   471,   470,     0,   643,   804,   363,  1323,     0,
     656,   719,   720,   715,     0,     0,     0,  1432,   535,   522,
     518,   444,   453,   427,   528,   524,   525,     0,     0,     0,
     535,  1369,  1020,     0,  1103,     0,     0,     0,     0,     0,
       0,  1137,   576,     0,     0,   580,   571,     0,  2562,   643,
     954,  1836,     0,  1837,     0,     0,     0,  1911,  1910,     0,
    1947,  1659,     0,     0,  1653,     0,  1622,  1638,     0,  1618,
    1616,     0,  1627,     0,  1629,  1856,     0,     0,     0,  1581,
       0,  1932,  1934,     0,  1858,  1446,  1661,     0,  1443,     0,
    1004,     0,  1005,  1029,   504,     0,  1035,  1035,   491,   732,
     482,  1192,     0,   645,     0,   309,     0,   292,  1188,     0,
     798,     0,   809,   807,     0,     0,     0,     0,  1361,     0,
    1362,  1363,  1366,   376,   389,     0,   419,     0,   417,   416,
     418,     0,   405,     0,     0,     0,     0,     0,     0,   379,
     410,  1128,  1132,  1131,     0,     0,   462,   495,   496,   497,
       0,   464,   505,   506,     0,   742,     0,   747,     0,     0,
     517,   668,     0,     0,     0,  1317,     0,     0,     0,  1323,
     535,  2527,   526,   522,   451,   425,     0,  1320,     0,   537,
       0,   363,  1102,  1105,  1100,  1280,     0,     0,   579,   578,
    2565,  2567,  2566,     0,   672,  1838,  1914,  1900,  1927,  1912,
    1943,     0,     0,     0,  1652,  1655,     0,  1620,     0,     0,
    1628,     0,     0,     0,  1575,     0,     0,  1445,  1022,     0,
       0,  1032,     0,   732,     0,  1024,  1023,   498,   484,  1465,
     355,     0,     0,     0,   805,   808,   796,   809,   816,   815,
     689,  1465,     0,   415,   424,     0,   422,   395,   400,     0,
     404,   402,   401,   396,   399,     0,   488,     0,     0,     0,
     507,     0,   508,   529,     0,   746,     0,     0,   803,     0,
       0,   438,   721,     0,  1318,  1430,   528,   526,  1321,  1322,
       0,   528,  1037,  1279,  1278,  1519,     0,     0,  2563,  2371,
       0,  2344,     0,  1945,  1948,  1946,  1940,     0,  1637,  1650,
    1583,     0,  1582,  1935,  1936,  1661,   352,  1035,     0,   486,
     502,   509,   285,  1465,     0,     0,   797,   281,  1364,   420,
       0,   403,   722,   514,     0,   513,     0,   511,   510,   743,
     748,   643,   793,  1323,   725,   428,   528,     0,  1661,  1262,
    1519,  1261,  1263,  1271,  1268,  1270,  1269,  1267,  1140,  1141,
       0,  1952,  1951,  1950,  1954,  1953,  1656,     0,  1648,  1584,
    1442,  1006,  1025,     0,   732,   293,   799,   806,   423,     0,
     512,   516,   515,   669,  1319,     0,   723,   726,   729,   727,
     728,   426,   363,  1011,     0,  1272,  1266,  1504,  1491,     0,
       0,     0,     0,   503,   487,     0,   703,     0,   528,  1264,
    1519,     0,     0,  1949,     0,     0,   724,  1661,  1265,     0,
       0,  1649,     0,  1012,     0,     0,   725,     0,     0,     0,
    1138,  1139,   704
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4920, -4920,  4364, -4920, -1256,   226,  2756,  -819, -4920, -4920,
   -4920,  1237, -4920, -4920, -4920, -4920, -4920, -4920, -4920,  3535,
   -4920, -4920,  1912, -2760, -4920, -4920,   -31,  3485, -1711,   -39,
    3042,  1558, -4920, -1519, -4920, -4920,  -895,    38, -4920,  3484,
   -1485, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -1201,
    2065,  1364,  2843, -2955, -4920, -4920, -1826, -3550, -4920,   683,
   -4920, -4920,  2004, -4920, -4920, -4920,  1206,   600,  -427, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920,  -573, -4920, -4920,  -763,
     228,  -102, -2807,  -242, -4920, -4920,   570,  -241, -1875, -4920,
   -3903, -4920,   107, -4920, -4920, -4920,  -215, -1846,  1472, -4920,
   -1031, -1501,  1810,  -662, -4920,  -106, -4920,  -744,  -585,  -581,
    -688, -4075, -4103, -4540, -4142, -3631,  1477, -3445, -4087,   237,
     538, -4920,   241,   243, -4920,   554, -1160, -1874, -4920, -1148,
   -4920, -4920, -4920, -3295, -4920, -4920, -4920, -4920,   -82, -4920,
   -4920, -4920, -4920,   596, -4920, -4920, -4920, -4920, -4920, -4920,
   -3047,  1979,  1981, -4920, -4920, -3504, -4920, -1250, -4920,   738,
   -3317,  1386, -4920, -4920, -4920,  2737, -4920, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -2004, -4920, -4920, -4920, -4920,
   -4920,   579,   105, -4920, -4920, -4920, -4920, -4920,   249, -4920,
    1993,  1192, -4920, -4920, -4920,  -736,  -828,  -808, -4920, -3339,
   -4920, -4920, -4920, -4920,  -182, -4920, -4920, -4920, -4920, -4920,
   -4920, -1332, -4920,  1242, -3457, -4920, -4920,  1250, -4920, -4920,
   -4920, -4920, -4920,  -677,  -122,  2766, -4920,  -513,  -636, -4920,
   -4920, -4920,  -120, -4920, -4920, -4920, -4920, -4920, -4920, -1456,
   17395, -1409,  -841, -4920, -4920, -4920, -4920, -2504, -4920, -4920,
   -4920, -3779, -4920,  4656,    45,  -524,   254, -4920,  -208,   -87,
    3289, -1523, -2978,   495,  -307, -4920, -2231, -4920, -4920, -4920,
   -2880, -4920, -4920, -4920, -4920, -3849,   293, -4920,  3276, -4920,
   -4105, -4813, -3874, -4321, -4671, -4714, -3822, -4920, -4920, -1463,
   -4920, -4920, -4920, -1855,  2295, -2340, -4920, -2456,   568,  1546,
   -1301, -3095, -4113, -1042, -3580, -4920, -4920, -4065,  -422, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -1460,  -894, -4920, -4920,
    3884, -4920, -4651, -4920,  3857, -4920, -4920, -4920, -4920,  2570,
    2574, -4920,  2572, -4920, -4920, -1853,  1326, -4920, -4920, -4920,
   -4920,   236, -4920, -4920, -4920, -4920,  -661,  -775, -4920, -4920,
   -4920,   295, -4920, -4920, -4920, -4920,  2334, -1252, -1051,  3749,
     296, -4919, -4920, -4920,  -905, -4920,  2996, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -2574, -4920, -4920, -4692, -4920,
   -4920, -4920, -4920, -4920,  2429,  2430,   -96,  -237, -4920, -4920,
   -1655, -4920,  -862, -4920,  2656, -4920, -4920, -4920, -4920, -2104,
     303, -4091,   -73, -4920, -4920, -4920,   363, -4920, -4920, -3754,
     -69, -4920, -4920, -4920, -4920, -4715, -4920,   -65,  -577,   913,
   -4920, -4920, -3123, -4920,   319,   -45,  3370,  1909,   -51,  1225,
    -239,  -217,  -213,   -71,   -60,  3133, -4920,  3195, -4920,  -206,
    2220, -4920, -4920, -1155,  -366, -4920,  1659,  -950,  2407,  3116,
    3121, -4920,  1651,  2431, -2283, -2282, -4920,   985,  -551,  -418,
   -4920, -4920, -4920, -4920,   404,  -931,  2419, -4920,  3136, -4920,
   -4920, -4920, -2201,  1650, -3740,  1017, -3711, -3675,   453,   439,
   -1096,  -204,  -185, -1098,  3140, -4920, -4920,  1027,  -386, -4920,
   -4920,  -382, -3138,   949, -4920, -4637, -2655,  4892, -1975, -1407,
   -4920, -4920, -1371, 22408, -4920, -4920, -4920, 24889, 25011, -4920,
   -4920, 25550, 26061, -4920, -1220,  1222, 26671, 11749, -1362, -1373,
   -1614, 23952, -2561,   343, -3082, -4920, -3901, -2965, -4920, -4920,
   -4920,  -165,  1081,   284, -4920, -4920, -4920, -4920,    41, -4920,
    -527, -4920,  -517, -4920, -4920, -4920,  -502, -4597,  2561, -4920,
   -4920, -4920,  -851, -4920, 27071,  1711, -4920, -1393, -3044, -3048,
   -3719, -2174, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -2017,
   -3600,  -392,  1787, -4920, -4920,  1880, -4920, -4920, -4920, -1686,
    1732, -1205, -2934,  1795, -2356, -4920, -1165, -4920, -1082,  2567,
   -1107, 11280, -1575, 20693,  -104, -2590, -1651, -1955, -4920,  4077,
   -4920,  3070,  -148,  -759,  4794,  -350,  -953,  7484,  5210,  6323,
   -3453, -4920, -4920,   350, -4920, -4920, -4920, -4920,  4291,  1276,
   -4920,  3566, -4920,  2049,  2838, -4920, -4920,  2435,  -974,    66,
   -4920,  -478, -4920,  -130, -4920, -4920, -4920,   203, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920, -4920, -4920,  3166, -4920, -4920,
   -1567, -4920, -4920, -4920, -4920, -4920,  4566,  -381, -4920,  3953,
    -379, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920, -4920,
    3186,  2463, -4920,  3733, -4920, -4920, -4920,   -14,  3397, -4920,
   -4920, -4920, -1315,  -615,  3757,  3787,  2427, -4920, -4920, -4920,
   -4920, -4920, -4920, -4920, -4920,  2438, -4920, -4920,  1768, -2318,
    2442, -4920, -4920,   999, -4920, -4920,   478, -4920,  1001, -4920,
    3281, -4920, -4920, -4920,  1037, -4920, -4920, -4920,  -582, 17524,
     163,    96,   547,  1394, -4920, 10267, 19023,   -75,  3215,   -49,
   14083, 22819,   -61, -4920,  4555,  2439,  1995, -1071, -4920,  5602,
    2736, 15873, -4920, -1069,   956,  2452, -4920,    -2,  -695, -1304,
    3488,  -766, -2144, -4920,  4985, -4920, -3485, -4920, -1108,   106,
    3956, -1330
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   250,   251,  1958,  2841,  2726,  3614,  3615,   252,
     253,  1954,   254,   255,   256,   257,   258,   259,   260,  1889,
     261,   262,  1379,  2081,  2852,   263,  2576,  1123,  1124,  1125,
    2426,  2427,  2791,  2428,  2415,  1713,  2226,  1910,  1088,  1089,
    1870,  1911,   265,   266,  1707,  2407,   267,   268,   269,  1939,
    1940,  1883,  2128,  4666,  5345,  3449,  2703,  3654,  3450,  3451,
     270,  2006,  2007,   271,   272,  3581,  3577,  4184,  4994,  4995,
    5217,   914,  2820,  4997,  4998,  5203,  5204,  5369,  5485,  5486,
    2853,  2076,  3648,  4267,  3605,  4737,  3606,  4738,  3607,  4739,
    3592,  4215,  4216,  4217,  3608,  4709,  5242,  3609,  2595,  5386,
    2888,  2256,  2254,  5229,  4543,  4544,  5463,  5391,  5392,  5393,
    5567,  4711,  3652,  4273,  4746,  5010,  3338,  2102,  3758,  1018,
    2891,   946,  1019,  2854,   277,  2882,  2883,  1977,  2734,  4193,
    3738,   278,  1399,  4033,  5067,  5285,  5286,   279,   901,   280,
    2085,   281,   282,  2837,  3599,   283,  2612,  3355,   284,   285,
    3384,  3385,  3386,   286,   287,  4058,  4937,  1941,  3438,  3439,
    3440,  3441,  4084,   288,  2083,  1982,  2861,   289,   290,   291,
     292,   293,  3017,  3018,   294,  2778,   295,   296,   297,   298,
     299,  4120,  4632,  4244,  3478,  3621,  4242,   300,  2855,  2093,
    2873,  2874,  4725,  5029,  5253,  5031,  5615,  5616,  5003,  4010,
    4557,   302,   303,  4704,  4705,  5398,   304,  2610,   305,   306,
     307,  2060,  2829,  2830,  4194,  2054,  2822,  2823,  4254,  4255,
     308,  3534,   309,  4613,  4614,   947,  5403,  5352,  5476,   310,
     311,  4617,  4618,   312,   313,   314,   315,   316,  1006,  1499,
    1500,  1856,  1444,   317,  2444,   318,  1346,  3561,   319,  1591,
    3059,  4798,   320,  1042,  1524,  1525,  2856,   322,  1053,  3037,
    1055,  2269,  3740,  3741,  4349,  3003,  1250,   323,   324,  3014,
    3040,   325,  1876,  2586,  2587,  4538,  2857,   948,  2108,  2895,
    3333,  5148,  5149,  4915,  5164,  3232,  3951,   327,   949,  1915,
    2659,  2898,  3662,  2553,  2554,  2555,  4290,  2556,  3664,  2557,
    1850,  2558,  3670,  3671,  3672,  4286,  4293,  4296,  5056,  5057,
     328,  1913,  2657,   329,   330,   331,  1949,  1274,   332,   971,
     972,   333,  5222,   334,  1419,   335,  5065,   336,   337,  1077,
    1078,  1575,  1576,   338,   339,  2673,  4065,   340,   341,   342,
    4113,  4114,   343,   344,  5581,  5624,  5625,  5626,  4301,  5525,
     345,  5583,  1567,   347,   348,   349,   904,  1309,  1310,  1311,
    2858,  5049,   351,   352,  1871,  1872,  1873,  1874,  2581,   353,
     354,   355,   356,   357,   358,  2064,   359,   360,  5196,   361,
     362,  2026,   363,  1744,  1745,   364,   365,   908,  1143,  1749,
    1757,   366,  1021,  1518,  1519,  1520,  2228,   367,  1571,  1348,
    1022,  1513,  1023,  2492,  3261,  3963,  3964,  3967,  4899,  4514,
    1024,  3258,   371,  2276,  3023,  3026,  3254,  1025,  3266,  3267,
    3268,  3269,  3270,  3970,  1026,  1044,  1409,  2907,  1027,  1662,
     376,   377,   378,  1153,  1147,  1148,   380,  2384,  3185,  1062,
    1763,  1107,  1108,  1160,  3914,  2458,  2459,  2483,  2484,  1772,
    1773,  2471,  2475,  2476,  3244,  3238,  2464,  4489,  5130,  5131,
    5132,  5133,  5134,  5135,  4878,  2479,  2480,  1775,  1776,  1777,
    2488,   381,  3189,  3894,  3895,  3896,  4466,  4467,  4481,  4477,
    4862,  5116,  3897,  1561,  1783,  4870,  5598,  3898,  5107,  5108,
    5304,  4484,  3905,  3961,  3638,  3639,  3640,  2559,  2157,  1446,
    1663,  1447,  2167,  1664,  2141,  1449,  1665,  1666,  1667,  1452,
    1668,  1669,  1670,  1455,  2133,  2160,  1671,  1672,  2151,  1192,
    1193,  2213,  3096,  1674,  1675,  1676,  3900,  1677,  4422,  4829,
    4818,  3117,  3118,  2423,  4418,  3840,  2379,  3175,  5139,  5321,
    5322,  3879,  4447,  4845,  5105,  5443,  5533,  5534,  1678,  1679,
    1680,  3172,  2374,  1276,  1681,  4196,  2376,  3111,  3197,  3198,
    2282,  2301,  3064,  3079,  3080,  3091,  3799,  3099,  3104,  3827,
    3828,  3112,  3141,  1682,  3066,  3067,  3783,  2303,  1683,  1737,
    2437,  1738,  2392,  3136,  1752,  1753,  1145,  1697,  1684,  1685,
    2270,  1134,  5112,   753,   736,  3466,  2439,  1313,  1059,  1686,
    1687,  1688,  1805,   696,  1469,  1470,   698,   737,   738,  1230,
     850,     2,    75,  1028,  3646,  5035,   385,   386,   951,   952,
     953,  1401,  1402,  2114,  2117,  1810,  2525,   702,   703,   754,
    4767,  5068,  5288,  1012,   387,   388,   389,   390,  1806,  2521,
    1194,    76,    84,    77,  1195,   427,   428,  2502,   391,   867,
     392,  1786,  1174,  3976,   393,   394,   395,   396,   397,  1009,
     398,  1176,   399,  1177,   400,   401,   402,   403,  1184,   404,
    1788,  1789,  4527,  1790,   405,   406,   740,   741,  1511,   407,
     408,  1211,  1212,  1543,  1544,  1816,  1831,  1832,  1833,   409,
     710,   410,   411,   412,  1822,  1823,   413,  2400,  2401,  2530,
    2402,   414,  3283,  3284,   415,  3931,  3932,  4888,  3933,   416,
    2396,   417,   418,  1137,  3981,   419,   863,   420,  1225,   742,
     743,   744,  1232,   853,  1093,   755,  1234,  3442,   855,   856,
     746,   747,   748,  2248,    78,  3291,  2249,  1690,   756,  1691,
    2390,  1692,  1693,  1694,  1695,  1696,  1839,   750,  1201,  1503,
    1504,  3292,  1506,    82,  1507,   424,  3698,  2216,  1545,  2973,
    2234,  2235
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      81,  2225,  1099,  1784,  2170,   369,  1708,   379,  1778,   370,
    1152,  1161,  1171,   372,  1172,  2174,  2180,  1411,  1046,  1552,
    1553,  1554,  1730,   962,  1136,  1558,  1698,   374,  1851,   422,
    3004,  2594,  2147,  3604,  1275,   422,  1374,  1981,  1739,  1133,
    1046,   854,  2074,  1804,  2011,  2668,  3195,   945,   950,  2253,
    2166,   752,  2441,  2095,  2055,   858,  2137,  2138,  2024,  2660,
    3763,   758,  1209,  2292,  1521,  3915,  2146,  2969,  1020,  1722,
    2793,  4059,  2680,  1068,  2669,  1410,   423,  1005,  4250,  1275,
    2153,  3204,   423,  1054,  2165,  1975,   854,   707,  4039,  3624,
    4295,  1990,  2878,   379,  3224,  1476,   906,  4224,  3300,  3302,
     858,  2016,  2746,  4546,  2062,  2455,  3899,  4278,  2067,  1942,
    2697,   964,  3531,  2071,   423,  2125,   264,   902,  4079,  2214,
    4081,  2078,  1252,  1100,  3468,  3063,  1976,  4507,  1155,  1281,
    4545,  2097,  4197,  4202,  3744,  2756,  4750,  4197,  1275,  1834,
    1299,  1836,  3969,  1213,  3908,  4434,  3906,  3907,  1095,  4702,
     956,  4540,  4463,  2896,  1516,  4583,  1095,   854,  1095,   423,
     739,  1493,  1163,  1411,  4742,  2441,  1164,  2760,  2761,  1369,
    1087,   858,  2920,  4735,  1377,  3899,  4753,  4759,  4736,  3029,
    1130,  2452,  2509,  2511,  2512,  1387,  1122,  4480,  1150,  3848,
    4749,  3247,  3203,  4743,  3250,  2653,  2961,   739,  2215,  4262,
    2210,  3985,  5042,  2240,  2567,  2134,  2135,  1096,  1912,  4314,
    1771,  1043,   851,  4519,  3299,  1096,  2145,  1096,   954,   961,
    5172,  1715,  4478,  3901,  2503,  2503,  4916,  4402,   961,  1774,
     423,  1812,  1813,  1043,  5121,  2398,  5123,  3980,  3805,  1204,
    5273,   421,  1505,  2137,  2138,  5165,  3805,   421, -1726, -1726,
   -1726, -1726,  2094,  3617,  1825, -1726,   912,   851,  5191,  2158,
    2246,  2146,  1405,  3805, -2078, -2078, -2078, -2078,  2340,   961,
     430, -2078,  2346,  1071,  2442, -2830, -2830, -2830, -2830,   421,
    2153,  4237, -2830,  1226,  4914,  5198,  5199,   426,  2767,  1886,
   -2830, -2830,  3901,    37,    38,    39,    40,  1141,  2772,  1825,
      44,  2352,  3134,  3569,  3134,  4284,   273,  1995,  3553,   430,
    2875,  3573,   369,  3575,   379,   274,   370,   430,    43,   275,
     372,   276,  2051,    45,   421,  2126, -1964,   301,   851,  5405,
    2000,  2354,   321, -1964,   374,  3349,  2001,  3974,  4040, -1736,
   -1736, -1736, -1736,   430,   422,  5351, -1736,  1569,  1996,  4035,
    5223,  2126,  2126,  3707,  1072,  3709,   430,    45,  3595,    37,
      38,    39,    40,  2346,  2126,    43,    44,  1593,  1826,  4238,
      45,   326,  2227,   346,   350, -1726, -1726, -1726, -1726,   422,
    1248,   368, -1726,  2134,  2135,  1587, -2831, -2831, -2831, -2831,
    3365,   423,  2352, -2831,  1887,   421,  2058,   373,  3176,  3169,
    2021, -2831, -2831,  5523,  1712,  2217,  3170,   903,  2145,    37,
      38,    39,    40,  3748,  3750,  1701,    44, -1983, -2828, -2828,
   -2828, -2828,  2354,   264, -1983, -2828,   423,  2671,   384, -2827,
   -2827, -2827, -2827, -2828, -2828,  2002, -2827,  2041,  3473, -1726,
   -2421, -2421, -2421, -2421, -2827, -2827,  1549, -2421,  3761,  4239,
    5336,  5337,  4218,  2671, -2241, -2421, -2421,  2341, -1736, -1736,
   -1736, -1736,  3596,  5347,  3476, -1736,  3188,  2600,  3324,  2724,
    2024,  2807,   868,  2876,  2727, -1721, -1721, -1721, -1721,  2126,
    1275,  4999, -1721,  3039,  2388,  5313,  1228,  4919,  1172,  4089,
    5514, -1693, -1693, -1693, -1693,  1200,  3781,  1073, -1693,   429,
    2671,  4923,  4090,  5264,  2443,  1997,  5497,  2671,  1530,  2754,
    2671,  5000,  1535,  1536,  1537,   869,  -151, -1706, -1706, -1706,
   -1706,  2274,  1548,  2776, -1706,  -151,  3274,  2782,  3177,  2808,
    -151,  3477,  3802,  3803,  1074,  1075,   864,  3822,   865, -1721,
   -1733, -1733, -1733, -1733,  1411,  2671,  3325, -1733,    37,    38,
      39,    40,  1365,  4040,  4133,    44,   421,   950,    37,    38,
      39,    40,  2022,  1464,  3474,    44,  3290,  1411,  2382,  5381,
    3294,  5524,  2416,  2801,  3852,  3853,  2385,  2429,  2429,  1207,
    1208,  2805,  2003,  4036,  -413,  2127,  4802,  4240,  4804,  2385,
    1142,   421,  1815,  1818,    37,    38,    39,    40,  5563,  1998,
     430,    44,  2203,    37,    38,    39,    40,  1550,  3579,    43,
      44,  2127,  2127,   273,    45,  3749,  3751,  2004,  3350,  2432,
    2433,  3554,   274,  1076,  2127,  3135,   275,  3868,   276,  2877,
    3597,  1198,  4598,  2773,   301,  5007,  4197,  1411,  4285,   321,
    5043,  1570,  1481,  1249,  1948,  1847,  2275,  2005,  5038, -1964,
    2159,  2768,  4241,  1496,  5614,  2441,  2346,   708,  2132,   956,
    2229,   913,  5461,   852,  1888,  1735,  1827,  5482,  4550,  1736,
    2059, -2241,  2247,  3817,  3818,  3819,  3820,   868,   326,  1821,
     346,   350,  1557,  2999,  3820,  2352,  4717,  3005,   368,  3007,
    2059,  2637,  3010,  1205,  5059,  2296,  3815,  3816,  3817,  3818,
    3819,  3820,  2441, -1726,   373,  2399,  3202,  5577,   852,  1292,
    2373,  1827,  1541,  3598,  4834,  2354,  2742,  1735,  2744, -2078,
     869,  1736,  3171,  2825,  3259,  4219,  2154,   954,  2796,  4859,
   -2830,  3388,  2751,  4863,  2927,   384,  2209, -2241,  1214,  2127,
   -1983,  1206,  4003,  2914,  2712,  1557,  2639,  5547,  2965,  4480,
   -2241,  2992,  2205,  2172,  5552,  4729,  2647,  3463,  1802,  1803,
    2886,  2148,  2601,  3971,  1411,  4348,  5557,  4182,  4183,  4902,
    1241,  2792,  1411,  1411,  2172,   961,   961,  4808,  1152,   852,
    2149,  3065,  3389,  1522,  4853,  2132,  2681,  5564,  1217,  5498,
    3407,  4924,  1040,  1041,  2150,  2933,  2275,  1779,  2370,  2371,
    2372,  2373,   858,  3000,  2755,  1828,  1829,     3,  3899,  5537,
    3899,  4572,  3011,  3001,  4602,  1366,  2732,  1360,   422,  2735,
    2736,   866,  2411,  1200,  2383,  3580,  1465,  1345,  2489,  1407,
   -1726,  4772,  4773,  4774,  4775,  4776,  5333,  2526,  5605,   965,
    1349, -2831,   379,  3987,  1350,  3988,  5158,  2490,  1351,  4134,
    3195,  3195,  3195,  5167,  4297,  1793,  2602,  3464,  5565,  1541,
    4688,   423,  1352,  4246,  4497,   423,  3379,  4996,  4586,  1237,
    1165,  2656,  5516, -2828,  4733,  2602,  1421,  1560,  1237,   707,
    2148,  1523,  5566,  1529, -2827,  1534,   707,  5063,  3935,  2802,
    1556,  1538,  4687,  4262,  4532, -2421,   709,   707,  1213,  2149,
    5263,   757,  2974,  2982,  2210,  3060,  3062,   907,  5283,  2985,
    2034,  1514,  3069,  2152,  1237,  1529,  1534,  3314,  3083,  3084,
    3085,  1517,  3899,  2917,  2918,  3901,   707,  3901,  3101,  3103,
   -1721,   707,  5590,  3113,  4298,  3276,  1163,  3276,  5171,  1956,
    1164,  3380,   707,  2462,  2653,   379,  2136,   216,  2086,  4204,
    1166,  1560, -1568,  3247,  5109,  3954,  1877,  2887,    79,   851,
    1957,  1408,  1541,  2578, -2559,  -151,  -151,  1583,   707,  1515,
    1557,  3126,  2140,  1237,  4269,  4174,  4175,  5576,  3363,  1462,
     224,  3455,  1782,  1237,   707,  1215,  1528,  -849,  1533,  2087,
     707,  3019,  2588,  2603,  4207, -1733,  2119,  4546,  1547,  2230,
    1462,   707,  2232,  2343,  3379,  2236,    81,  2238,  4765,  2746,
    2241,  4546,  4587,  2386,  2245,   707,  4610,  5079,  1563,  1565,
     235,  5080,  5081,  1200,  5082,   961,   421,   859,  4230,   909,
     421,  4517,    35,   238,  5643,  2463,  1156,   860,  4545,  3901,
      41,    42,  3663, -1492,  3529,  1395,  1746,  3002,  2120,  3209,
    4886,  5297,  4168,  1095,   248,  2172,  2719,  1095,  2588,  4172,
    4173,  1878,  3322,  4176,  1892,  3972,  2590,  5284,  3260,  2682,
    4181,  4734,  4299,  2889,  2604,  2589,  1527,  1510,  1532,  3380,
    2683,   961,  2684,  1711,  2591,  4897,  1754,  1719,  1740,  2368,
    2369,  2370,  2371,  2372,  2373,   966,  5087,  1157,  1705,  1275,
    3383,  1724,  1794,  1855,  5064,  1237,  1237,  2972,  1562,  1564,
   -1495,  3020,  1096,  2869,   707,  2383,  1096,  4611,  1860, -1492,
    5113,  4588,  5415,  3945,  4589,  5117,  3445,  2181,  5119,  4195,
    1814,  5005,  2590,  2341,  4195,   423,  4211,  4300,  2685,   861,
    1747,  2121,  1237,  2147,  3801,  5110,  2088,   967,  5328,  1817,
    2591,  3307,  4546,  1167,  -641,  5387,  5412,  2833,  3008,  3009,
    5399,  1542,  5422, -2559,  1185,  1158,  5410,  5420,  2696,  1861,
    4968,  5411,  3456,  2035,  4197,  4212,  1200,  3446,   739,  4295,
    5033,  4231,   968,  5419,   969,  5413, -1495,  4698,  1061,  4213,
      35,   430,  2122,  2870,    37,    38,    39,    40,    41,    42,
      43,    44,  4909,   707,   707,    45,  2271,  2886,  1879,  1396,
    4733,  4291,  3304,  4612,  4615, -1492,  1541, -1693,  2592,  2696,
     430, -2559,  2284,    37,    38,    39,    40,  1095,  1095,    43,
      44,  1593,  1826,  1186,    45,  5236,  3530,  2293,  3383,  1875,
    2089,  3364,  5298,  1880,  3942,  4382,  4383,  4384,  4385,  1087,
    1985,  4390,  4391,  4392,  4393,  4394,  4395,  4396,  4397,  4398,
    4399,  5611,  1862,  1397,  3447,  4938,  2996,  5592,  1521,  1398,
    1305, -1492,  5388,  1881,   862,   927,  2123,  4214,  4898,  1869,
    5382,  2596, -1495,  5237,  2592,  2946,  1096,  1096,  5168,  1034,
    1159,  5238, -1693,  1187,  3021,  4812,  1188,  4813,  5329,  2850,
     421,  2916,  1034,   375,  2648,  2413,  5331,  4438,  4439,  2597,
    5517,  1035,  1863,  3022,  1237,  4616,  2509,  2112,  1725,  5239,
    2593,  1462,  3525,  5515,  1035,  1237,  3212,  4699,  1275,  1542,
   -2189,  2597,  2927,   929,  5012,  1057,  1882,  1305, -1495,  3975,
    5389,  1462,  -540, -2222,  1034,    35,  3916,  1864,  1542,  3917,
    3918,   209,  3526,    41,    42,  1462,  2959,  5522,  2978,  5414,
    3919,  3920,  3921,  1306,  3922,  3923,  1035,  5292,  1158,  3924,
    3925,  3926,  3279, -1492,  5575,  2851,  5227,  1865,  5309,  5578,
    3251,   129,   130,  2871,  1726, -2242,  2593,  3899,  1158,   375,
    1189,  3899,  2649,  1237,  5240,  1434,  2872,  1583,  4901,  5593,
    3305,  5109,  3306,  5612,  5026,  1307,  1866,  5511,  1867, -1492,
     852,  1034, -1492,  2190,  2809,  1210,  3448,  2414, -2075,  2506,
    4103,  5383,  1152,  1886,  3089,  4534,  4546,  3735,  2161,  4814,
    1306,  3524,  2161,  1035,  5621,  4649,    35,  1462,  2997,  2698,
   -1495,  4875,  4497,  5013,    41,    42,  2598,  1105,  4882, -1693,
    1069,   379, -2271,  5458,  2191,  2810,  1868,  1308,  3515,  1071,
    2541,  5349,  1172,  3405,  3516,  5354,  5355,  1275,  4584,  1834,
    2998,  1836,  1307,  3704,  1151,   707, -1495,  4794,  2090, -1495,
    2231,   937,  2233,   938,  3705,  2237,  3710,  2239,  2507,  5176,
    2242,  2243,  2244,  4197,  1190,   707,  5647,  1186,  2091,    81,
      81,  1186,    81,  2251,  3901,  4344,  5190,   943,  3901,  1741,
    1237,  1742,  2448,  1191,  5465,  5466,  3927,  2277,   707,  2278,
    3683,  4027,  1860,  5250,  1308,  4104,  5346,  5334,  1887, -2189,
    3495,  1932,  3629,  3630,  3631,  3632,  5339,  3015,  2844,  2743,
    1072,  1978, -2222,  1106,  3637,  4051,  2456,  2457,  2508,  2461,
    1164,  1164,  3508,  1164,   707,  1010,  2507,  1187,  3912,  1178,
    2162,  1187,  4028,  3517,  2162,  3943,  4355,  5241,  1462,  3154,
     707,  3496,  3195,  1861,  1721,  5317,  1979,  5016,  4490,  1179,
    2699,  1104,  3548,  2510, -2242,   707,  3497, -2189,   707,  1180,
     129,   130,  4650,  1070,  3500,  1782,  3502,  4535,  3252,  1237,
   -2222,  5044,  1213,  4728,  1162,  4368,  1131,  2700,  3681,  1735,
     375,  2192,  2811,  1736,  5045,  2023,  2508,  4524,  3016,  4546,
    5017,  3379,  2746,  2172,  3393, -1693,  1138,  1237,  1411,  4536,
    2701,  1761,  2702,  4195, -1693,  1510,  2136, -1693,  1855, -1693,
    1802,  1803, -2242,  2172,  2389,  1189,  4695,  2845,  1013,  2092,
    4537, -2271,  3928,  4135,  1189,  1237,  1237,  1237,  1189,  1237,
    2345,  2440,  3229,  2346,  5225,  2696,  1862,  4678,  1014,  1828,
    1829,  2377,  4105,  4681,  4682,   858,  4684,  1980,  1595,  1237,
    1189,  3805,  1767,  1073,  3030,  3806,  3807,  3808,  2312,  2403,
    2404,  1181,  2352,   430,  3253,  5267,  3380,  5404, -2832,  3155,
    3929,  1015,  3804,  5268,  3156,  2193,  2812,  4106,  4356, -2271,
    3518,  4060,  3394,  1189,  3832,   707,  2577,  4336,  2419,  4029,
    1074,  1075,  2354,   707,   707,  5602,  3381,  1762,  1767,  3369,
    3142,  3521,  3143,  1237,   423,   927,  4778,  4107,  4779,    35,
    3157,  5401,   422,   422,  3230,  3519,  3855,    41,    42,  2582,
     927,  1769,  3998,  2119,  2737,  3144,  1182,  1953,  2163,  2583,
    1743,  3382,  2163,  1237,  2172,  1144,  3522,  1237,  1237,   739,
     739,  5282,  1275,  3899,  5046,  3520,  2584,  2164,  3899,   910,
    2440,  3904,  4377,  3899,  3881,  5434,  3899,  3854,   423,   423,
     423,  1770,   422,   929,   858,  2523,  3523,  1769,  2394,  2545,
    3930,  2395,  2753,  1013,  1095,  2977,  3423,  2632,   929,   707,
    1866,  4403,  1867,  4030,  1154,  1305,  3899,  5078,  4386,  4508,
    4387,  2938,  3971,  1014,  4270,  3481,  1183,  4274, -2832,  5340,
    3899,  3752,   851, -2832,  2951,  4204,  4009,  3938,  2465,   423,
    3288,  4205,  4295,  2465,  2698,  1095,   423,  1462,  1932,  2960,
    3425,  3809,  4206,   423,  3145,  3383,  1015,  5343,  3737,  3146,
    5269,  3657,  3424,  1096,  3147,   206,  1875,  3158,   868, -2832,
    1875,  5521,  3810,  1699,  -436,   739,  2466,  3482,  4509,  4052,
    4207,  2466,  4208,  1168,  2738, -2099,   851,  2739,  3986,  -173,
    3901,  1725,   216,  2515,  3307,  3901,  2516,  4061,  2121,   421,
    3901,  5015,  3401,  3901,  1096,  3753,  3426,  3488,  1306,  4026,
    2059,   869,  1462,  2585,  2361,  -173,  1101,  1175,  2346,    37,
      38,    39,    40,  4062,  5278,   224,    44,  5037,  5154,     8,
    5156,  3483,  3811,  3901,  3542,  2467,  2933,   920,  2698,  1700,
    2001,   937,  4388,   938,  2757,  4053,  1462,  3901,  1411,  2122,
    1307,   851,  4389,   421,   421,   421,   937,  1726,   938,  4209,
    5024,  1288,  3488, -1504,    79,   235,  3480,  2075,  5473,  1016,
    1583,  3899,  4927,  4928,  2468, -1504,  2405,  2354,   238,  2468,
   -1504,   216,  2075,  -436,  2831,  2699, -2623,  1289,  5175,  5429,
    2517,  3148,  1869,  4131,  1956,  1388, -2832,  1869,   858,   248,
    5468,  3149,  1308,  4600,   421,   868,  3675,   707,  2717,  4553,
    1411,   421,  2700,  1017,   224,  1957,  4696,  4210,   421,   927,
     206,  3545,  4211,  1210, -1504,  3484,  1389,  2912,  1462,  2469,
    5201,  5474,  5197,  2123,  2469,  2701,  3899,  2702,  2785,  2002,
   -1014,  2406,  3913,  1462, -1504,  2688,  1869,   216,   869,  3013,
    1869,  2824,  5384,  4551,   235,  1216,  4018,   423,  1390,  4132,
    1875,  4212,  1462,  2429,  3219,  4920,  1172,  5613,  3722,  4601,
    2696,  4668,  5638,  2718,  5251,  4213,  2689,   929,   707,  2699,
     224,  4697,   707,  3036, -1504,  4347,  4554,  2172,  3901, -2832,
    3024,  4669, -1504,  2606,   707,  1388,  2368,  2369,  2370,  2371,
    2372,  2373,   249,  2607,  1391,  5252,  2700,  2421,  2148,  1462,
    3812,  3813,  3814,  2478,  3815,  3816,  3817,  3818,  3819,  3820,
     235,  3625,  1237,  4348,  5549,  1517,  1389,  2149,  1462,  2701,
    4921,  2702,  4251,   238,  1237,  3485,  4041,  1227,   375,  5194,
    1462,  4260,  4555,  3486,  4556,  3195,  3487,  1807,  2422,   379,
    3195,  3336,  1462,  3901,   248,   851,  3195,  3936,  4248,  4343,
    5195,  4064,  3202,  4214,  2696,  2698,  1837,  1237,   249,   707,
     707,  4195,  2749,  4989,  2927,  4990,  4991,  3226,  5194,  4992,
    3984,  4581,   707,  4887,  3332,  2980,  4044,  2981,  5457,  4573,
    3336,  2983,  1462,  2984,  2346,  1462,  2986,   707,   707,  5195,
    2987,  3527,  2737,  3035,  1391,  3337,    81,  4553,  1852,    81,
    1349,  1961,   379,  1807,  1350,  3058,  3226, -1504,  1351,   707,
    3899,  1218,   421,  2352,    43,   937,  1857,   938,  2561,    45,
    1244,  3528,  1352,  1219,  1220,  4585,  4590,   940, -1020,  4358,
    4603,   375,  1151,  1853,  4006,  3899,  1962,  2608,   942,  5374,
    5084,  2075,  1221,  2354,  5375,  1222,  2688,  3866,  1411,  1237,
    4095,  1858,  1242,  2562,  3857,  5634,  3858,    37,    38,    39,
      40,  5441,  5639,  1854,    44,  5640,  3132,  1735,  4100,   209,
    1758,  1736,  2609,   852,  4554,  1258,  1964,  2689,  3202,  3859,
     858,  1859,  1257,  2563,  3727,  2698,  1237,  1237,  5442,  5376,
    1275,  2786,  1237,  1237,  2847,  2723,  2699,  4363,  3082,  1237,
    1237,  1237,  3402,  4101,  2676,  1237,  2677,  1237,  1237,  1237,
    1237,  1237,  1237,  2879,  1237,  4752,  1237,  1237,  4311,  4312,
    1237,  1956,  2738,  2700,  1965,  2739,  2787,  3901,  4220,  1034,
    4555,   121,  4556,  4102,  1462,  1237,  1237,  1237,  1237,   423,
    1735,  1746,  1957,  1237,  1736,  2200,  2701,  1237,  2702,   125,
    1237,  1035,  3901,  1237,  1237,  1237,  1237,  1237,  1237,  1237,
    1237,  1237,  2678,  1237,  1223,  3326,  2201,  3329,  1162,  1294,
    3948,  1237,  4903,  1717,  1237,    37,    38,    39,    40,  4651,
    5194,  2696,    44,  3860,  3634,  3390,   422,  4470,  3861,  3635,
    2788,  1411,   852,   430,  2409,  2211,    35,  5600,  4379,  2212,
    4652,  5195,  2789,  1224,    41,    42,  1966,    45,  5055,  1303,
    4740,  4203,    37,    38,    39,    40,  3635,  1767,  3663,    44,
    5246,  1758,  1768,  3323, -1492,  3610,  2699,  2790,  3899,  1304,
    5623,  3262,  4408,   423,  4471,  1747,  1354,   851,  1237,  3387,
    2148,  1357,  2211,   422,    80,   422,  2968,    79,    79,  4016,
      79,   870,  1237,  2700,  1967,  4361,  2671,  1968,  4471,  2149,
    3319,  1237,  1237,  1375,  4472,  2672,  1807,  2745,  1509,   430,
     911,  3777,  5546,  2150,  5202,  2971,  2701,  4450,  2702,  4865,
    4195,  3778,  3481,  2440,  1007,  3779,  1769,  1359,  4472,  4474,
     423,  2671,   423,  1362,  4548,  4549,  1970,   858,  1595,  5653,
    2679,  3805,  2148,  4473,   421,  3806,  3807,  3808,  1393,  1959,
    3560,  2696,   707,  4474,  5291,  3862,  1156,  2345,  1383,  2698,
    2346,  2149,  4427,  -539,  2008,  3863,  1770,  2012, -1542,  1392,
      81,   706,    81, -1542,  3482,  2152,  1102,  1972,  1462,  4475,
    1394,   216,  1462,  1462,  1400,  3901,  3991,  1991,  1367,  2352,
    1368,  2136,   707,  2568, -1541, -2832,   423,   707,  5114, -1541,
    2136,   707,  1855,    37,    38,    39,    40,  1403,  4531,   707,
      44,   430,    35,  2136,   224,  2568,  1974,  1157,  4236,  2354,
      41,    42,  1992,  3611,  1095,   970,  1993,   707,  3483,  5274,
    1237,  1200,  1414,  4476,   955,  1418,   852, -1542,   421,  1735,
     973, -2078,  1237,  1736,  3119,  2933,  1462,  3122,  3479,  1237,
    1463,  3452,  1994,  4364,   235,  4569,  1471,  4476,  1462,  3465,
    1370,   858,  1371, -1541,  5371,   858,  5373,   238,  1060,  1472,
    5377,   707,  5378,  1411,  2220,  1411,  2221, -1542,  4351,    37,
      38,    39,    40,  1096,  3865,  1158,    44,  1477,   248,   707,
     707,  1488,  1095,  3097,   851,   421,  1497,   421,  1462,  1008,
    2699,  3115,   249, -1541,  1512,  4123,  1807,    45,    35,   430,
    1551,  1807,  1807,  2286,  2024,  2287,    41,    42,  2499,  2500,
     423,   707,  3484,    45,   423, -2832,  2698,  2700,  4486,  1555,
   -2832,  4221,  3810,  4223,  5037,  4936,  1559,  5115,  4316,  4317,
    4318,  4319,  4320,  1411,  3831,  1566,  3833,  3834,  4770,  1572,
    2701,  1096,  2702,   707,  3489,  2143,  2144,   707,  4318,  4319,
    4320,   421,  3612,  2446,  3948,  2447, -2832,  1574,  2299,  3948,
     249,  2905,  2449,  2906,  2450,   707,  1573,   375,  3626,  3248,
    3249,  4491,  4492,  4493,  1581,  2696,   707,  1580,  2518,  2519,
    3593,  2970,  3811,  2971,  1582,  4785,  4786,  4787,  5220,   707,
    2136,  4288,  2568,  1584,   858,  3613, -1563, -1563,   707,  3489,
    1159,  2361,  2499,  3272,  2537,  2539,  1583,  2993,   851,  2994,
    1585,  2995,   851,  2994, -1566, -1566,  4130,  3027,  1586,  3028,
    2441,  4470,  3485,  3225,  3399,  3226,  3400,  3239,  1589,  3470,
    3486,  3471,  1595,  3487,  1592,  3805,  2698, -1567, -1567,  3806,
    3807,  3808,  2300,  1590,  1237,  1462,  4797,  5206,  3583,  1720,
    3584,  3202,  3588,   423,  3589,  2345,  4428,  2699,  2346,  3489,
    1723,  2309, -2832, -2832, -2832,  3489, -1697, -1697, -1697, -1697,
    1807,  1727,  3650, -1697,  3651,   421,  1152,  1728,  1748,   421,
    1807,  1729,  1734, -2832,  2700,  3910,  3911,  2352,  3684,  5207,
    2971,  2325,  4471,  2353,  3729,  1595,  2994,  3489,  3805,  3776,
    1756,  2971,  3806,  3807,  3808,  1758,  2338,  2701,  1765,  2702,
    3785,  3791,  2971,  2971,  5208,  1462,  1755,  2354,   852,   707,
    1152,  3792,  4472,  2971,  4316,  4317,  4318,  4319,  4320,  1759,
    5209,  1237,  4321,  4673,  5210,  1780,  4136,  4473,  1781,  3793,
    1807,  2971,  2696,  1807,  1807, -1059, -1059,  4474,  4685,  5579,
     193,   851,  1785,  3824,  5211,  2971,  5055,  5212,  1787,  1791,
    3812,  3813,  3814,  1795,  3815,  3816,  3817,  3818,  3819,  3820,
    5213,  1595,  1792,  4475,  3805,  1800, -2832,  2699,  3806,  3807,
    3808,   707,  4762,  2368,  2369,  2370,  2371,  2372,  2373,  1237,
    2698,  3837,  1796,  2971,  3995,  3996,  3887,  3888,  3889, -1704,
   -1704, -1704, -1704,  3842,  2700,  3843, -1704,  1808,  1162,  1162,
    3882,  1162,  3883,  1807, -1695, -1695, -1695, -1695,   421,  1797,
    1798, -1695,   193,  2355,  1799,  1801,  3810,  2701,  2356,  2702,
     707,  3884,  1809,  3885,   216,  1811,  4830,  4819,  4082,  1840,
    4083,  1152, -1698, -1698, -1698, -1698,  1462,  1849,   707, -1698,
    5214,  4476,  4087,  4282,  4088,  4283,   707,  1843,  5215,  3838,
    1237,  1841,  2696,  1462,  2359,  3845,  1237,   224,  4309,  1595,
    2971,  1914,  3805,   858,  1462,  1200, -2832, -2832, -2832,   858,
    4409,  1885,  4410,  1237,  1855,  4419,  3811,  4420,  1237,  3810,
    4165,  1890,    74,  4976,  4977,  5216,  4979, -1696, -1696, -1696,
   -1696,  4430,  1916,  2971, -1696,  1948,   216,   235,  4515,  2361,
    4516,  1237,  1237,  1237,  1918,  4520,  1237,  4521,  1919,  4530,
     238,  3306,  1950,  1951,  1237,  1237,  1237,  1237,  4552,  1952,
    2994,  2699,   423,   955,  4625,   852,  4626,  1237,   423,   224,
    1237,   248,  1237,  4689,  4730,  4690,  2994,  4118,  4791,  3811,
    2275,  1953,  1960,  1237,  1237,  5580,  4126,  1237,  2700,  4809,
    4835,  2971,  3028,  1963,  4847, -2832,  2971,  4905,  4911,  3306,
    4912,  1237,  1955,  1237,  1349,  1237,   379,  1986,  1350,   235,
    1987,  2701,  1351,  2702,    79,  2009,  1999,    79,  4917,  2010,
    2994,  2363,   238,  2013,  2018,  1237,  1352,  4918,  2698,  2994,
    5039,  5089,  5040,  5090,  2019,  5091,  1237,  2971,  1237,  1237,
    1237,  2020,  2025,   248,  4740,  2027,  2696,  4788,  5099,  5173,
    3028,  5174,  2698,  2028,  5247,  3811,  2994,   249, -1273,   707,
     851, -1273,  5275,  1237,  5276,  5021,   851,  5293,  5301,  3028,
    5302,  2033,  5306,    35,  3226,  2030,  1237,    37,    38,    39,
      40,    41,    42,  2037,    44,  5312,  1045,  4258,  3948,   852,
    5314,  1237,  4258,   852,  3812,  3813,  3814,  2044,  3815,  3816,
    3817,  3818,  3819,  3820,  5326,  1237,  5327,  5364,  1045,  5365,
    4229,  5400,  4232,  2408,  2364,  2045,  2038, -2832, -2832, -2832,
    2048,  2368,  2369,  2370,  2371,  2372,  2373,   421,  4574,  5421,
    5435,  5327,  3028,   421,  5436,  5437,  3843,  2971,  5447,  5450,
    3226,  4258,  2050,  2063,  1462,  5588,  5589,  1462,  5472,  1462,
    3028,  2056,  4604,  3811,  1462,  2066,   707,  3812,  3813,  3814,
    2053,  3815,  3816,  3817,  3818,  3819,  3820,  1595,  2068,  2699,
    3805,  2059,   707,   707,  3806,  3807,  3808,  5478,  1237,  3028,
    5479,  2077,  3028,  3073,  5505,  5538,  5506,  3226,  5539,  2079,
    2971,  4837,  1851,  2699,  2080,  5540,  2700,  2971,  5542,   707,
    2971,  5559,   707,  5560,  -194,  5596,  1462,  4258,  5599,  5622,
    5320,  5327,  1347,  5636,  5662,  5637,  5637,  2096,  2082,  2701,
    2700,  2702,  2084,  1462,   858,   858,   858,  1764,  4864,  1766,
    4867,  2098,   852,  3812,  3813,  3814,  2111,  3815,  3816,  3817,
    3818,  3819,  3820,  2701,  2105,  2702,  2107,   887,  1462,  4115,
    2116,  2124,  3074,  2129,  2696,  2130,  2131,  2132,  2136,  2139,
    2140,  4357,  2142,   858,  2156,  2168,  2169,  2171,  2172,  2179,
    2182,  2183,  1412,   973,  2184,  2185,  5660,  5661,  2696,  3246,
    3246,  4894,  2186,   423,   423,   423,  3097,  3097,  2187,  2189,
    2194,  3097,  2195,  2196,  2252,   375,  2197,  2199,  2204,  2218,
    2283,  2288,  2290,  2291,  2297,  2298,  2304,   707,  2305,  2307,
      80,  2306,  3075,  2308,  2378,  3076,   249,  1462,  2310,  1462,
     707,  2380,   423,  2311,  2312,   707,  1807,  2412,  3097,  3097,
    2313, -2832, -2832, -2832,   707,  3815,  3816,  3817,  3818,  3819,
    3820,  2314,  2315,  2317,  2382,  2318,  1837,  2319,    79,  2320,
      79,  2321,  2322,  2323,  2324,  2326,  2327,  2328,   375,  2329,
    4444,  3810,  2424,  2330,  2831,  1541,  2331,  2332,  2333,  1568,
    2445,  2454,  2383,  2408,  2434,  1768,  1770,  2485,   858,  2487,
    1462,   851,   851,   851,  2496,  2498,  5305,  2505,  1189,  2513,
    2522,  2520,  2524,  2532,  2533,  2535,  2540,  5305,  2542,   707,
    4306,  2564, -2775,  1588,  2544,  1462,  2565,  2566,  2568,  3077,
    2569,  1560,  2570,  1702,  2572,  2571,  2573,  1714,  1412,  1716,
     851,  3811,  2574,   950,  2580,  2599,  2605,  2611,  2634,  2641,
    2638,  3140,  4189,  1462,  2640,  2642,  2643,   423,  1462,  2646,
    2645,  2661,  2663,  2674,   707,  4265,   707,  2675,   421,   421,
     421,  2662,  2686,  2690,  2692,  4277,  2696,  2693,   707,  2694,
     707,  2695,  4892,  2704,  1595,  2705,  2706,  3805,  2708,  2707,
    2713,  3806,  3807,  3808,  2714,  5362,  2722,  2725,  2729,  4305,
    2730,  2733,  1259,  2740,  1932,  1152,  2741,   421,  4838,  1260,
    1261,  1262,  2747,  2748,  2752,  2758,  2769,  1462,  2759,  2770,
    2774,  2798,  2799,  1152,  2775,  1275,  2771,   706,   706,  2806,
    2780,   852,  1838,  3078,   707,  1462,  2784,   852,  2800,  2814,
    5008,  2815,  2817,  2819,  2821,  2826,  4452,  4453,  4454,  4455,
    1462,  2827,  2832,  2835,  2836,   851,  5368,  2818,  2843,  2839,
    1807,   922,  2840,  2848,  2881,  1980,  2863,  5295,  1807,  2884,
    1807,  2868,  2885,  2893,  2899,  2901,  2897,  2908,  2919,  2921,
    2913,  2902,  2930,  2922,  2926,  2928,  2927,   375,  5350,   707,
    5125,  2931,  5353,  2989,  2943,  2940,  2942,  5140,  2944,  2945,
    2962,  2963,  3006,  5448,  1237,  5153,  2340,   707,  3012,  3025,
    5358,  5218,  5360,  2990,  3038,  3065,   961,  3114,  3070,  3812,
    3813,  3814,   421,  3815,  3816,  3817,  3818,  3819,  3820,   707,
    2345,  2346,   707,  2346,  3120,  3153,  4414,  3133,  3173,  3124,
    3139,  3174,  3188,  3208,  3151,  1157,  3948,  3216,  3205,  1237,
     858,  3227,  1462,  3211,  3215,  3206,  2972,  3257,  1237,  3217,
    3228,  3240,  2352,  3241,  1237,  3242,  1237,  3263, -2832,  1237,
    3243,  3281,  3213,  1462,  1237,  1237,  1237,  1237,  3810,  3278,
    1237,  1237,  1237,  1237,  1237,  1237,  1237,  1237,  1237,  1237,
    3280,  2398,  2354,  1237,  1237,  3295,  3296,  3308,  1462,  3298,
    3309,  3310,  3327,  1237,  3330,  3334,  3335,  1237,  3332,   423,
    3351,  1237,  3341,  3346,  3352,  3358,  3356,  3354,  5484,  1237,
    3374,  3366,  1237,  3375,  1237,  3362,  3378,  3392,  3397,  1717,
    3391,  1721,  1462,  1237,  3408,  3413,  1237,  1237,  3811,  3414,
    3427,  1237,  1237,  3432,  5490,  5492,  3433,  3459,  1237,  3454,
    4713,  4714,  3460,  3462,  3469,  3475,  3947,  4437,  1237,  3490,
    1237,  3472,  3533,  4718,  3544,  3551,  3552,  3555,  3556,  3557,
    3563,  3565,  1237,  3564,  3567,  3566,  5440,  3574,  1237,  1237,
    1237,  5244,  3571,  3582,  3576,  3578,  3627,  3585,  5449,  3602,
    3590,  3616,  3618,  5451,  3620,  5453,  3633,  3645, -2832,  3641,
    3643,  3644,  3636, -2832,  4771,  3642,  1172,   851,  3655,  3656,
    3653,  3659,  3660,  3673,  3674,  3677,  3680,  3678,  3679,  1412,
    5300,  3682,  3688,    80,    80,  2516,    80,  3685,  1237,  3687,
    3689,  3690,  1807,  3702,  3691,  3716,  3700,  3711,  3713, -2832,
    3717,  1237,  1412,  4633,  3720,  3731,  3721,  3725,  3732,  3701,
    3733,  3734,   852,   852,   852,  3226,  2205,  1462,  5561,  3736,
    3743,  3039,  3745,  3746,  3747,  3762,  3754,  1557,  3764,  3769,
    3771,  3774,  1237,  3768,   421,  3772,  3787,  3790,  3757,  3788,
    3789, -1956,  3839,  3452,  2361,  4599,  3794,  3795,  2279,  5161,
    3797,   852,   858,  3800,  3801,  3856,  3823,   858,  3864,   858,
    2971,  3873,  3829,  3851,  3878,   707,  3956,  3958,  3950, -1569,
    3955,  5484,  1412,  3904,  3966,  3962,  3812,  3813,  3814,  3836,
    3815,  3816,  3817,  3818,  3819,  3820,  3850,  5370,  3909,  3960,
    3989,  3997,  1275,  5182,  1265,  1266,  1267,  3977,  1268,  1269,
    1270,  1271,  1272,  1273,  4000,  3973,  3999,  3979,    74,  3874,
    3876,   423,  4008,  4011,  3877,  3880,   423,  1462,   423,  4048,
    4013,  5606,  3978,  2211,  4004,  3948, -2832,  3982,  4005,  1045,
    4021,  1045,  4037,  1045,  3983,  4050,  1275,  4055,  4038,  1045,
    1539,  1540,  4056,  4054,  4057,  2342,  4068,  4070,  4067,  4078,
    4086,  4076,  4077,  4096,  2344,  4117,  4119,  4121,  4139,  4122,
    4127,  4125,  4128,  1045,  1045,  4129,   852,  4144,  2387,  4137,
     707,  4138,  4140,   707,  4142,  4141,  4147,  4143,  4145,  3097,
    3097,  3097,  3097,  4152,  4149,  3097,  3097,  3097,  3097,  3097,
    3097,  3097,  3097,  3097,  3097,  4151,  4156,  1807,  4158,  1412,
    4160,  4146,  2418,  2420,  4148,  2767,  4150,  1412,  1412,   851,
    4153,  4162,  4412,  4164,   851,  4171,   851,  4177,  4178, -2832,
    4180,  3953,  3953,  4187,  4228,  4200,  2368,  2369,  2370,  2371,
    2372,  2373,  4227,  4245,  4234,  1237,  4243,  2345,  4249,  4257,
    2346,  3097,  3097,  4247,  2347,  2348,  2349,  4271,  4275,  4272,
    4276,  4279,  4258,  3042,  4747,  4280,  4266,  4934,   707,   707,
    4292,  2350,  1462,  4303,  4268,  4313,  2158,  4338,  4326,  2352,
    4328,   707,  4339,   707,  4350,  2353,   421,  2345,  4340,  4315,
    2346,   421,  1411,   421,  4341,  4342,  4353,  4354,  4345,  4352,
    4362,  1045,  4365,   706,  4367,  4371,   422,  2299,  3826,  2354,
    3043,  3805, -1955,  3825,  4432,  4421,  4380,  4405,  4406,  2352,
    1830,  1462,  1237,  1237,  4433, -2832,  4407,  2155,  4305,  1158,
    4972,  4413,  4445,  4488,  4436,  4461,  4483,  4501,  4451,  4485,
    4469,  3044,  4510,  4500,  4518,  4503,  4498,  5467,  4513,  2354,
    4502,  4526,  4505,   423,  4539,  4506,  4533,  4560,  4562,  4568,
    2338,  4563,  4576,  3045,  4575,  4577,  4580,  1045,  2188,  4578,
      35,  4907,  4582,  4591,  3046,  4594,  2198,  4609,    41,    42,
    4606,  4607,  2206,  4621,  2345,  4608,   707,  2346,  4619,  4620,
    4622,  2347,  2348,  2349,  3047,  4623,  4628,  4627,  4630,  3048,
    4624,  4631,  4640,  4641,  2338,  4648,  4663,  1237,  2350,  4665,
    4667,  2351,  4586,  4670,  4440,  2355,  2352,  4677,  1237,  4676,
    2356,  3140,  2353,  4679,  4680,  4692,  4700,  4683,   852,  4294,
    4703,  4708,  4710,  4716,  4724,  2994,  4726,  3875,  4723,  4732,
    4727,  2357,  2358,  4744,  4745,  4757,  2354,  3049,  1237,  4758,
    4761,  4760,  4766,  3893,  1411, -2832,  2359,  4768,  1237,  1237,
   -2832,  1462,  4763,  4784,  4793,  1237,  1237,  4789,  3050,  4769,
    1237,  1462,  2750,  4764,  4795,  1237,  4796,  4800,  1237,  1237,
    4941,  5464,  4811,  1237,  4801,  4803,  4820,  4806,  2360,  1237,
    4815,  4821,   375,  4816,  4822,  4823, -2832,  4824,  4828, -1957,
    4843,  2361,  4855,  4860,  4895,  4856,  4858,  1237,  4869,  4861,
    4868,  1237,  4873,  4874,  4876,  4877,  4879,  4893,   421,  4900,
    4880,  4881,  3893,  1237,  1275,  1151,  4904,  4913,  1237,  4906,
    4908,   887,  4922,  4914,  1237,  4939,  4940,  2345,  4946,  4947,
    2346,  2361,  4971,  4948,  2347,  2348,  2349,  4959,  4962,  4969,
    4980,  1237,  2355,  4974,  4975,  4988,  4993,  2356,  3051,  5001,
    5002,   858,  5009,  5014,    81,  3052,  5018,  5019,  5020,  2352,
    5022,  3053,  5025,  5028,  2859,  2353,  5030,  5034,  2357,  2358,
    1237,  1807,  5041,  2363,  5050,  5048,  1807,  5051,  5052,  5061,
    3097,  4115,  5053,  2359,  5066,  5075,  5071,  5076,  1462,  2354,
    5085,  5086,  5093,  3054,  5096,   858,  3055,  5088,  5095,  5104,
    5166,    74,    74,  5111,    74,   707,  5118,  5147,  5150,  5097,
     423,  5155,  5098, -2832,  3056,  2360,  5138,  5200,  5219,  1462,
    1045,  2345,  5122,  5151,  2346,  5144,  5169,  5177,  2361,  5170,
    5179,  2362,  5184,  5185,  5189,   707,  5221,  1411,  5228,  3057,
    1462,  4699,  5230,  5233,  5255,  5231,  5234,   707,  5249,  5235,
    5254,  5256,  5260,  2352,   423,  1462,  5262,  5265,  1237, -2832,
     852,  5266,  5277,  5281,  5279,   852,  2364,   852,   707,  2365,
    2366,  2367,  5296,  2368,  2369,  2370,  2371,  2372,  2373,  5287,
    5280,  5299,  5303,  2354,  5308,  5311,  5344,  5315,  5324,  5385,
      80,  5316,  5318,    80,  5342,  2355,  5320,  5335,  1462,  5357,
    2356,  5390,  5394,  5395,  5397,  5402, -2832,  5408,   851,  5416,
    2363,  5417,  5418,  2368,  2369,  2370,  2371,  2372,  2373,  5425,
    1237,  2357,  2358,  5428,  5426,  5427,  5433,  5438,  5439,  5456,
    5446,  1237,  5452,  5460,  5455,  5459,  2359,  5471,  5462,  5475,
    5351,  5489,  5495,  5499,  5496,  5504,  5501,  5507,  4441,  5509,
    5510,  5518,   851,  5526,  5519,  5520,  5527,  1807,  5536,  5555,
    5562,  4446,  5548,  5497,  5550,  5498,  5570,  5591,  2360,  5569,
    5574,  5597,  5610,  5631,  5635,   421,  5641,  5642,  5632,  1170,
    5649,  2361,  5650,  5629,  5630,  5654,  1462,  5645,  1462, -2832,
    3622,  5655,  3081,  5657, -2832,  5656,  5658,  2781,  2431,  3939,
    3458,  4597,  1983,  2364,  1984,  4063,  2365,  2366,  2367,  3543,
    2368,  2369,  2370,  2371,  2372,  2373,  4686,  4186,  1917,   421,
    1045,  5379,  5483,   707,  5259,  1045,  1045,  5608,  4712,  5261,
   -2832,  5006,  5243,  4002,  3730,  5551,  5159,  5604,  5502,  1237,
    5568,  5500,  4007,  1462,  4748,  4731,  4707,  3600,  1237,  3601,
    2860,  4595,  4080,  4719,  5023,  3591,  5609,  4253,  5659,  5646,
    5232,  4201,  5572,  2363,  4188,  1237,  1237,  5183,  2842,  1237,
    5477,  5556,  5186,  4790,  1065,  2361,  2272,  5330,  5145,  2285,
    3301,  4754,  3990,  1237,  5423,  1413,  3032,  1489,  1237,  3034,
    3033,  4159,  4966,  1237,  5582,  5648,  1237,  1237,  2579,  3210,
    2514,   375,  1539,  1540,  1237,  1237,  3221,  2979,  3222,  4896,
    1731,   375,  5545,   697,  4522,  2219,  3726,  3946,  2451,  2482,
    1152,  2529,  2393,  2481,  3957,  3237,  1237,  3256,  2536,  2538,
    4499,  5541,  5454,  4884,   707,   375,   707,  3959,  3255,  4464,
    1237,  2486,  1152,  4854,  4866,  5310,  5445,  4460,  5205,  5444,
    2491,  4523,  4322,  5294,  4415,  5141,  2364, -2832,  5543,  2365,
    2366,  2367,   858,  2368,  2369,  2370,  2371,  2372,  2373,  5544,
    5535,  3178,  3949,  3871,  1462,   707,  3782,  3941,  1229,  3869,
    3187,  3676,  1203,  4304,  1237,  5528,  2904,  1251,  2504,  3282,
    1173,  1848,  3273,  1508,  1045,  1819,  2280,  3289,  2910,  2118,
    3286,  5248,  2497,  3934,  1045,  3287,   706,  4528,  4885,  4504,
    4529,  2397,  1196,  3293,  5258,  3728,  2991,    83,     0,  2208,
       0,   423,  1838,  1355,    80,  1820,    80,  1237,  1546,  5270,
    5146,     0,     0,     0,     0,  2501,     0,     0,     0,     0,
       0,     0,     0,  2937,     0,     0,     0,  2941,     0,     0,
   -2832,     0,     0,  2947,  2948,     0,     0,  2368,  2369,  2370,
    2371,  2372,  2373,  1412,  1045,     0,     0,  1045,  1045,  2345,
       0,     0,  2346,  1893,     0,  1807,  2964,     0,     0,     0,
       0,  1237,  1416,  1462,     0,     0,     0,     0,     0,     0,
       0,     0,  1467,     0,     0,     0,     0,     0,     0,     0,
       0,  2352,     0,     0,     0,     0,  1894, -2832,     0,     0,
       0,     0,     0,  1237,  1462,     0,  1237,     0,  1237,   851,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2338,
       0,  2354,  1716,     0,     0,     0,  1895,  1045,     0,     0,
       0,     0,  1237,   858,     0,  4459,  1237,  4462,     0,     0,
       0,     0,  1462,     0,     0,     0,     0,  1237,     0,   852,
       0,     0,     0,     0,  1896,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2518,  2519,  1237,
       0,     0,     0,     0,  3097,     0,   421,     0,     0,     0,
       0,     0,     0,  5092,     0,     0,  4841,  1897,     0,     0,
       0,     0,   423,   852,     0,     0,     0,     0,  1462,     0,
       0,     0,  1462,  1462,     0,     0,  2903,  1237,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1898,   707,     0,  5409,     0, -2832,     0,     0,
    2915,     0, -2832,     0,     0,     0,     0,     0,     0,     0,
    2923,     0,  2924,     0,     0,     0,     0,     0,     0,  2929,
       0,  1237,     0,     0,  2932,  1899,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2832,     0,
       0,  3562,  1237,     0,     0,     0,     0,     0,     0,  3562,
       0,     0,  1920,  1900,  1901,     0,     0,  3562,  1921,  3562,
     851,     0,     0,     0,  1462,  1462,     0,     0,    74,     0,
       0,    74,     0,     0,     0,  5432,     0,  3218,   382,     0,
    5205,     0,     0,  2361,   382,     0,     0,  1237,  1902,   700,
    1237,  1807,   209,     0,   858,     0,  1903,     0,  1922,  1237,
       0,     0,     0,  1904,  1237,  3628,  1237,     0,  1237,     0,
    1905,     0,     0,     0,  2345,  1237,   382,  2346,  1906,     0,
       0,     0,     0,     0,     0,     0,     0,   421,     0,     0,
    1907,  5628,  1237,     0,     0,  3658,     0,     0,  1908,     0,
       0,     0,     0,  1412,     0,     0,  2352,  1923,     0,     0,
    1924,     0, -2832,   423,     0,   707,     0,  1925,     0,     0,
    1926,   382,     0,     0,     0, -2832,     0,  3071,  3072,  3697,
       0,     0,     0,     0,  3086,  3087,  2354,     0,     0,     0,
       0,     0,     0,  2029,     0,  1927,     0,  1920,     0,     0,
       0,     0,  1909,  1921,  2036,     0,  1237,     0,     0,     0,
       0,     0,     0,  3125,     0,  1412,     0,     0,     0,  1091,
       0,     0,     0,     0,     0,     0,  1928,  1091,  3097,  1091,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1237,
    1237,     0,   382,  1922,     0,     0,     0,     0,     0,     0,
    1237,     0,  5584,     0,   379,     0,  5585,  4889,   707,  5573,
    5586,   851,     0,     0,     0,     0,     0,     0, -2832,  2529,
    1237,     0,  2109,     0,  5587,  2368,  2369,  2370,  2371,  2372,
    2373,     0,    79,     0,  1929,     0,  1930,     0,     0,     0,
       0,     0, -2832,     0,     0,  1924,  1931, -2832,     0,  5618,
     375,     0,  1925,     0,  1932,  1926,     0,  5584,     0,   379,
       0,  5585,     0,   858,  1933,  5586,     0,     0,  1237,     0,
       0,     0,     0,     0,  1237,  1237,     0,  1237,   421,  5587,
    1927,     0,     0, -2832,     0,     0,     0,     0,     0,     0,
     852,     0,     0,  3245,  3245,     0,  1237,     0,     0,  1934,
       0,     0,  1935,  1936,     0,     0,     0,     0,   707,     0,
       0,  1928,  5618,     0,   375,     0,     0,  5584,     0,   379,
       0,  5585,   423,     0,     0,  5586,   858,     0,  2361,  1937,
       0,  5618,     0,  1807,     0,     0,     0,     0,     0,  5587,
    1045,     0,     0,     0,     0,   858,     0,     0,     0,     0,
       0,     0,     0,   382,     0,     0,     0,     0,     0,     0,
    1830,  1893,    74,     0,    74,     0,     0,     0,     0,  1929,
       0,  1930,     0,     0,     0,     0,     0,     0,     0,  1237,
    1237,  1931,     0,     0,     0,   423,     0,     0,   382,  1932,
       0,     0,  1938,  1237,  1894,     0,     0,     0,     0,  1933,
       0,  1045,     0,     0,   423,  1237,  1237,     0,     0,     0,
   -2832,     0,     0,  1412,     0,     0,     0,     0,     0,     0,
     851,     0,     0,     0,     0,  1253,     0,     0,     0,     0,
       0,     0,  1282,     0,  1988,     0,     0,  1935,  1936,     0,
       0,   704,     0,  1300,  3893,     0,     0,     0,  3893,     0,
       0,     0,  1896,     0,  2613,     0,     0,     0,     0,  2614,
       0,     0,     0,     0,  1989,     0,     0,     0,     0,     0,
       0,   852,   697,     0,     0,     0,     0,   697,     0,     0,
       0,     0,     0,   851,     0,  1897,     0,   421,   697,     0,
     375,     0,  2615,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   851, -2832,     0,  2616,     0,     0,     0,  3686,
    2368,  2369,  2370,  2371,  2372,  2373,     0,     0,  1047,  2617,
    1898,     0,     0,     0,     0,     0,     0,  1938,  3703,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1047,     0,     0,  3712,     0,     0,  3714,  3715,     0,     0,
     421,  3718,  3719,  1899,  1045,     0,  1412,     0,  3723,  2618,
       0,     0,  1045,     0,  1045,     0,     0,     0,     0,   421,
    2619,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,   975,  1901,     0,     0,     0,     0,     0,     0,     0,
    2620,     0,  5143,   976,     0,  2621,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   977,     0,     0,     0,     0,     0,
     209,     0,  2654,  1445,  1903,     0,     0,   978,     0,     0,
       0,  1904,     0,  3765,     0,     0,     0,     0,  1905,     0,
       0,   979,     0,  4085,  1445,     0,  2655,     0,     0,     0,
       0,     0,  1807,     0,     0,     0,     0,     0,  1907,   980,
       0,     0,   852,     0,  2622,     0,  1908,     0,     0,  2345,
       0,     0,  2346,     0,     0,     0,  2347,  2348,  2349,     0,
       0,   981,     0,     0,     0,     0,  4124,     0,     0,     0,
       0,     0,   982,  2350,     0,     0,  2623,     0,     0,     0,
     983,  2352,     0,     0,     0,     0,  2345,  2353,     0,  2346,
       0,     0,   984,  2347,  2348,  2349,     0,   985,     0,     0,
    1909,     0,     0,   986,     0,     0,     0,   887,     0,     0,
       0,  2354,     0,     0,     0,     0,  4157,     0,  2352,     0,
     987,     0,     0,     0,  2353,     0,  3692,  3695,     0,   697,
     697,     0,     0,     0,     0,     0,     0,     0,  3562,     0,
       0,  2624,     0,     0,     0,  3562,  3562,  2625,  2354,  3562,
    2626,     0,     0,     0,     0,     0,  3562,     0,     0,  4185,
       0,     0,     0,     0,     0,     0,   988,  4198,     0,     0,
       0,     0,  4198,     0,     0,     0,     0,     0,  1412,  2627,
    1412,     0,     0,     0,     0,     0,  2628,     0,     0,     0,
       0,     0,     0,  2629,     0,     0,     0,     0,   989,     0,
    2630,     0,     0,   382,     0,     0,  1045,   382,     0,   990,
       0,     0,     0,     0,     0,  3893,     0,  2355,  4256,   991,
    3893,   700,  2356,  3893,     0,  2631,     0,     0,   700,   887,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   700,
       0,     0,     0,  2357,  2358,     0,     0,  4287,  1412,     0,
       0,   852,     0,     0,  2355,  5152,   992,     0,  2359,  2356,
       0,   993,     0,   994,     0,     0,     0,     0,   700,   995,
       0,     0,   996,   700,     0,     0,  3697,     0,     0,     0,
   -2832, -2832,     0,     0,   700,     0,     0,     0,     0,     0,
    2360,  1807,     0,     0,     0,  2359,     0,     0,     0,     0,
       0,   997,     0,  2361,   998,     0,  2362,     0,   999,     0,
     700,     0,     0,  4012,   852,  1000,     0,  1001,     0,     0,
       0,     0,  1002,  3665,     0,     0,   700, -2832,     0,     0,
       0,  2909,   700,   852,  1003,     0,     0,     0,     0,     0,
    2361,     0,  1893,   700,     0,  2032,     0,  1004,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   700,     0,     0,
       0,     0,     0,     0,     0,  2047,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1894,  2936,   375,     0,  2057,
       0,     0,     0,     0,     0,  2363,     0,     0,     0,     0,
     375,     0,     0,  4069,     0,  4071,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   375,  2529,     0,     0,  3937,
       0,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2363,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4425,  1896,     0,  3952,  3952,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1091,     0,   700,     0,  1091,     0,
       0,     0,     0,     0,     0,     0,  1897,     0,  1251,     0,
       0,     0,     0,  3893,     0,     0,     0,   382,  2364,     0,
       0,  2365,  2366,  2367,  2338,  2368,  2369,  2370,  2371,  2372,
    2373,     0,     0,     0,     0,     0,  3666,  3796,     0,     0,
       0,  1898,     0,     0,  4154,     0,  2338,     0,     0,     0,
    4161,     0,     0,     0,     0,  2364,     0,     0,  2365,  2366,
    2367,     0,  2368,  2369,  2370,  2371,  2372,  2373,     0,     0,
       0,   383,     0,     0,  1899,     0,     0,   383,  3665,     0,
       0,     0,   701,     0,     0,   700,   700,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1893,     0,     0,
       0,     0,     0,  1901,     0,     0,     0,     0,     0,   383,
       0,     0,     0,     0,     0,     0,     0,     0,  2345,     0,
       0,  2346,     0,     0,     0,  2347,  2348,  2349,     0,     0,
    1894,     0,  2281,     0,     0,     0,     0,     0,     0,     0,
       0,   209,  2350,     0,     0,  1903,     0,     0,     0,     0,
    2352,   375,  1904,     0,   383,     0,  2353,  1920,     0,  1905,
       0,     0,     0,  1921,     0,     0,     0,  2655,  1091,  1091,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1907,
    2354,     0,     0,     0,     0,     0,     0,  1908,  1896,     0,
       0,     0,     0,     0,  4307,     0,     0,     0,     0,     0,
    5619,     0,     0,  1922,     0,     0,     0,  3668,     0,     0,
       0,  4198,     0,     0,     0,     0,     0,  4324,  4325,     0,
    4327,  1897,  4329,  4330,     0,   383,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4337,     0,     0,     0,     0,
       0,  1909,     0,     0,  4634,  3669,  4294,  4635,     0,  4636,
       0,  3666,  2709,     0,     0,  1924,  1898,     0,     0,     0,
       0,     0,  1925,  5619,     0,  1926,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   697,  4359,     0,     0,     0,
       0,     0,  5619,     0,     0,     0,  2355,     0,     0,  1899,
    1927,  2356,     0,  3562,     0,     0,     0,     0,     0,  3562,
    3562,  1047,  3562,  1047,     0,  1047,     0,     0,  4185,     0,
       0,  1047,  2357,  2358,     0,     0,     0,     0,  1901,     0,
       0,  1928,     0,     0,     0,  1045,     0,  2359,     0,     0,
    1045,  2345,     0,     0,  2346,  1047,  1047,     0,  2347,  2348,
    2349,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4233,     0,  2350,   209,   700,     0,  2360,
    3667,  3357,     0,  2352,     0,     0,     0,  1904,  1251,  2353,
       0,     0,  2361,     0,  1905,  2362,     0,   700,     0,  1929,
       0,  1930,  2655,     0,     0,     0,   383,     0,     0,     0,
       0,  1931,     0,  2354,  1907,     0,     0,     0,  3665,  1932,
     700,  4751,  1908,     0,     0,   375,     0,     0,     0,  1933,
       0,     0,     0,     0,     0,     0,     0,  1893,     0,     0,
     375,   383,  3668,     0,     0,     0,     0,  4310,     0,     0,
       0,     0,     0,     0,  3695,     0,   700,     0,  3697,  3697,
    3697,  3697,  3697,     0,  2710,     0,     0,  1935,  1936,     0,
    1894,     0,   700,     0,  2363,     0,  1909,     0,     0,     0,
    3669,     0,     0,  1047,     0,     0,     0,   700,     0,     0,
     700,     0,     0,  2779,  2711,  5627,     0,   704,   704,     0,
       0,     0,  1835,     0,  4799,     0,     0,  4799,     0,  4799,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2355,
       0,     0,     0,     0,  2356,     0,     0,     0,  1896,     0,
    2716,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2357,  2358,     0,     0,  1047,
       0,     0,     0,     0,     0,   375,     0,  1938,     0,     0,
    2359,  1897,     0,     0,  2849,     0,     0,  2364,  2862,     0,
    2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,  2372,  2373,
    2779,     0,     0,     0,     0,     0,  3846,     0,     0,     0,
       0,  3666,  2360,     0,     0,     0,  1898,     0,     0,     0,
       0,     0,     0,     0,     0,  2361,     0,     0,  2362,     0,
       0,     0,  2797,     0,     0,     0,     0,   700,     0,     0,
       0,     0,     0,     0,     0,   700,   700,  2813,     0,  1899,
       0,     0,     0,     0,     0,     0,   382,     0,     0,     0,
    4883,     0,     0,  4890,  4891,     0,  2834,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2939,     0,  1901,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    80,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2779,     0,     0,  2363,     0,     0,
     382,   382,   382,  2900,     0,     0,   209,     0,     0,     0,
    1903,     0,     0,     0,     0,     0,     0,  1904,     0,     0,
       0,   700,  2911,     0,  1905,     0,     0,     0,     0,     0,
    2345,     0,  2655,  2346,  1445,     0,     0,  2347,  2348,  2349,
       0,     0,     0,     0,  1907,  4525,  2925,     0,     0,     0,
       0,   382,  1908,     0,  2350,     0,     0,     0,   382,     0,
       0,     0,  2352,     0,     0,   382,     0,     0,  2353,     0,
       0,     0,  3668,     0,     0,  1091,     0,     0,     0,  4198,
       0,     0,     0,     0,     0,     0,  2956,     0,     0,  1445,
    2364,     0,  2354,  2365,  2366,  2367,     0,  2368,  2369,  2370,
    2371,  2372,  2373,     0,     0,     0,  1909,  3123,     0,     0,
    3669,     0,     0,     0,     0,     0,  1091,     0,     0,  3766,
    4983,  4984,  1047,     0,     0,  3770,     0,     0,     0,  3562,
       0,  3562,  3562,     0,     0,  3562,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1045,
       0,     0,     0,     0,     0,     0,  4777,     0,     0,     0,
       0,     0,     0,     0,  4780,  4781,  4782,  4783,     0,  5032,
       0,     0,     0,     0,     0,     0,   383,     0,     0,     0,
     383,  1045,     0,     0,     0,     0,     0,     0,  2355,     0,
       0,     0,     0,  2356,   701,     0,     0,     0,     0,  5054,
       0,   701,     0,     0,     0,     0,     0,     0,     0,   700,
       0,     0,   701,     0,  2357,  2358,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3127,  2359,
       0,     0,     0,     0,     0,     0,     0,     0,  4799,     0,
       0,   701,  4799,  4799,     0,  4799,   701,     0,     0,     0,
       0,  1539,  1540,     0,     0,  3902,  1920,   701,     0,   382,
       0,  2360,  1921,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2361,     0,     0,  2362,     0,     0,
     700,     0,     0,   701,   700,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   700,     0,     0,   701,
       0,     0,  1922,     0,     0,   701,     0,     0,   697,     0,
       0,     0,  1047,     0,     0,     0,   701,  1047,  1047,     0,
       0,     0,     0,     0,  3902,     0,     0,     0,     0,     0,
     701,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3311,     0,
       0,     0,     0,  3315,  1924,     0,  2363,  3318,     0,     0,
       0,  1925,     0,     0,  1926,     0,     0,     0,     0,     0,
       0,   700,   700,     0,     0,     0,  3695,  3695,  3695,  3695,
    3695,     0,     0,  3342,   700,     0,     0,     0,  4198,  1927,
       0,  4925,     0,     0,     0,     0,     0,     0,     0,   700,
     700,     0,     0,   704,     0,  1045,     0,     0,  2345,     0,
       0,  2346,     0,     0,     0,  2347,  2348,  2349,     0,     0,
    1928,   700,     0,     0,     0,  4944,  4945,  3395,     0,   701,
    3562,     0,  2350,     0,     0,     0,     0,     0,     0,     0,
    2352,     0,     0,     0,     0,   697,  2353,     0,     0,  2364,
     383,     0,  2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,
    2372,  2373,     0,     0,     0,     0,  4199,     0,     0,     0,
    2354,     0,     0,     0,     0,     0,     0,  3443,  1929,     0,
    1930,     0,     0,     0,     0,     0,  1047,     0,     0,     0,
    1931,     0,     0,     0,     0,     0,  1047,     0,  1932,     0,
    3361,     0,     0,     0,  4986,  4987,     0,     0,  1933,   697,
       0,     0,  3376,  3491,     0,     0,     0,     0,   701,   701,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3503,     0,  1920,     0,     0,     0,     0,     0,  1921,
       0,     0,  3513,  2014,     0,     0,  1935,  1936,     0,     0,
       0,   382,  3409,     0,     0,  3538,  1047,     0,     0,  1047,
    1047,  2529,     0,   699,   697,     0,     0,     0,     0,     0,
       0,     0,     0,  2015,     0,     0,  2355,     0,     0,  1922,
       0,  2356,     0,     0,     0,     0,    74,     0,     0,     0,
     849,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5070,  2357,  2358,     0,     0,     0,     0,     0,     0,
       0,  5072,  5073,     0,     0,     0,     0,  2359,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5077,     0,  1047,
       0,  1924,     0,     0,     0,   849,  1938,     0,  1925,     0,
       0,  1926,     0,     0,     0,   382,     0,  1412,  1045,  2360,
       0,  5372,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5380,  2361,     0,     0,  2362,  1927,     0,     0,     0,
    4956,  4957,     0,     0,     0,  4960,  4961,     0,     0,     0,
       0,     0,     0,  1090,     0,     0,     0,  1045,     0,     0,
       0,  1090,     0,  1090,     0,     0,     0,  1928,     0,     0,
       0,     0,   382,     0,   382,     0,   849,     0,     0,  3587,
    2345,     0,     0,  2346,     0,     0,     0,  2347,  2348,  2349,
    1920,     0,     0,     0,   700,     0,  1921,     0,     0,     0,
       0,     0,     0,     0,  2350,     0,     0,     0,     0,     0,
       0,     0,  2352,     0,  2363,     0,     0,     0,  2353,     0,
       0,     0,     0,     0,     0,  1929,     0,  1930,     0,     0,
       0,     0,     0,     0,   700,     0,  1922,  1931,   382,   700,
       0,     0,  2354,   700,     0,  1932,     0,     0,     0,     0,
       0,   700,     0,     0,     0,  1933,     0,     0,     0,     0,
     701,     0,     0,     0,     0,     0,  3742,     0,     0,   700,
       0,     0,     0,  1251,     0,     0,     0,     0,     0,  1412,
     701,     0,     0,  5487,  3756,  5488,     0,     0,  1924,  5493,
    5494,     0,  3742,  1935,  1936,  1925,     0,     0,  1926,     0,
       0,     0,     0,   701,     0,     0,     0,  2364,     0,     0,
    2365,  2366,  2367,   700,  2368,  2369,  2370,  2371,  2372,  2373,
    1937,     0,     0,  1927,  4373,  1091,  2345,     0,     0,  2346,
       0,   700,   700,  2347,  2348,  2349,     0,     0,     0,   701,
       0,     0,     0,     0,     0,     0,     0,     0,  2355,     0,
    2350,     0,     0,  2356,  1928,   701,     0,     0,  2352,     0,
       0,     0,   382,   700,  2353,     0,   382,     0,     0,     0,
     701,     0,     0,   701,  2357,  2358,     0,     0,     0,     0,
    3755,  5290,     0,  1938,     0,     0,     0,     0,  2354,  2359,
       0,     0,     0,  1091,     0,   700,     0,  3767,     0,   700,
       0,     0,     0,     0,     0,  1920,     0,     0,  3773,     0,
       0,  1921,  1929,     0,  1930,     0,  5142,   700,     0,     0,
       0,  2360,     0,     0,  1931,     0,     0,  3902,   700,  3902,
       0,     0,  1932,     0,  2361,     0,     0,  2362,     0,     0,
       0,   700,  1933,     0,     0,     0,     0,     0,     0,     0,
     700,  1922,     0,     0,     0,     0,     0,     0,     0,  5332,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1412,     0,     0,     0,  1045,  2635,     0,     0,
    1935,  1936,     0,     0,     0,     0,  5620,     0,     0,     0,
       0,     0,     0,     0,  2355,     0,     0,     0,     0,  2356,
     701,     0,     0,  1924,  5363,   382,     0,  2636,   701,   701,
    1925,     0,     0,  1926,     0,     0,  2363,     0,     0,   383,
    2357,  2358,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2359,     0,     0,  1927,     0,
       0,  3902,     0,     0,     0,     0,     0,     0,     0,  5620,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3992,     0,     0,     0,     0,  2360,  5620,  1928,
    1938,   700,     0,   383,   383,   383,     0,     0,     0,     0,
    2361,     0,  1047,  2362,     0,     0,   704,     0,     0,     0,
       0,     0,     0,     0,   701,     0,     0,     0,     0,     0,
       0,     0,  1835,     0,     0,  4014,     0,     0,     0,  2364,
       0,     0,  2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,
    2372,  2373,     0,     0,   383,     0,  4424,  1929,     0,  1930,
       0,   383,     0,   700,     0,     0,     0,     0,   383,  1931,
       0,  2345,     0,  1047,  2346,     0,     0,  1932,  2347,  2348,
    2349,     0,     0,     0,     0,     0,     0,  1933,     0,     0,
       0,  2345,  2363,     0,  2346,  2350,     0,     0,  2347,  2348,
    2349,     0,     0,  2352,     0,     0,     0,     0,     0,  2353,
    2345,     0,   700,  2346,     0,  2350,     0,  2347,  2348,  2349,
       0,     0,  3404,  2352,     0,  1935,  1936,     0,     0,  2353,
     700,     0,     0,  2354,  2350,     0,     0,     0,   700,     0,
    4019,     0,  2352,  4091,     0,     0,     0,     0,  2353,     0,
       0,     0,  1937,  2354,     0,     0,  4111,  4031,     0,     0,
       0,     0,     0,     0,     0,  1045,     0,     0,     0,     0,
       0,     0,  2354,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2364,     0,     0,  2365,  2366,
    2367,     0,  2368,  2369,  2370,  2371,  2372,  2373,     0,     0,
       0,     0,  4541,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   382,  1938,     0,     0,     0,     0,
     382,     0,   701,     0,     0,     0,  1047,     0,     0,     0,
       0,     0,     0,     0,  1047,  4166,  1047,   849,     0,  2355,
       0,     0,     0,     0,  2356,     0,     0,  5430,     0,     0,
       0,  4108,     0,  4110,     0,   699,     0,     0,     0,  2355,
       0,     0,   699,     0,  2356,  2357,  2358,     0,     0,     0,
       0,     0,   383,   699,     0,     0,     0,     0,  2355,  5601,
    2359,     0,     0,  2356,     0,  2357,  2358,     0,     0,     0,
       0,     0,     0,   701,     0,     0,     0,   701,     0,     0,
    2359,     0,   699,     0,  2357,  2358,     0,   699,     0,   701,
       0,   700,  2360,     0,  4155,     0,     0,     0,   699,  2359,
       0,     0,     0,     0,     0,  2361,     0,     0,  2362,     0,
       0,     0,  2360,     0,     0,     0,     0,     0,     0,  4169,
       0,     0,     0,     0,   699,  2361,     0,     0,  2362,     0,
       0,  2360,     0,     0,     0,     0,     0,     0,     0,     0,
     699,     0,     0,     0,  2361,     0,   699,  2362,     0,  1920,
    4416,     0,     0,     0,     0,  1921,     0,   699,     0,     0,
       0,     0,     0,     0,   701,   701,     0,     0,     0,     0,
       0,   699,     0,     0,     0,     0,     0,   701,     0,     0,
       0,     0,     0,     0,     0,  2779,     0,  2363,   700,     0,
       0,     0,   701,   701,     0,  1922,     0,     0,     0,     0,
       0,     0,     0,  4346,   700,   700,     0,  2363,     0,     0,
       0,  3409,     0,     0,   701,     0,  3902,     0,     0,     0,
    3902,     0,     0,  4417,     0,     0,  2363,     0,  4360,     0,
       0,   700,     0,     0,   700,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4308,     0,     0,  1924,     0,     0,
       0,     0,     0,     0,  1925,     0,     0,  1926,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1090,     0,
     699,     0,  1090,     0,     0,     0,     0,     0,  1047,     0,
    2364,     0,  1927,  2365,  2366,  2367,     0,  2368,  2369,  2370,
    2371,  2372,  2373,     0,     0,     0,     0,  4807,     0,     0,
    2364,     0,     0,  2365,  2366,  2367,     0,  2368,  2369,  2370,
    2371,  2372,  2373,  1928,  5617,   382,   382,   382,     0,  2364,
       0,     0,  2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,
    2372,  2373,     0,     0,     0,     0,  4842,     0,     0,   700,
       0,     0,     0,     0,   383,     0,  4372,     0,     0,     0,
       0,     0,   700,     0,   382,     0,     0,   700,     0,   699,
     699,     0,     0,     0,     0,     0,   700,  4381,     0,     0,
       0,  1929,     0,  1930,     0,     0,     0,  5617,     0,     0,
       0,     0,     0,  1931,     0,     0,     0,     0,     0,     0,
       0,  1932,  4404,     0,     0,     0,  5617,     0,     0,     0,
       0,  1933,     0,     0,     0,     0,     0,     0,     0,  2345,
       0,     0,  2346,     0,     0,     0,  2347,  2348,  2349,     0,
       0,     0,     0,     0,     0,     0,  2281,     0,     0,     0,
       0,   700,     0,  2350,     0,     0,  3506,     0,   383,  1935,
    1936,  2352,  1090,  1090,     0,     0,     0,  2353,     0,     0,
    5011,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3507,     0,     0,   382,
       0,  2354,     0,     0,     0,     0,   700,     0,   700,     0,
       0,     0,     0,  1047,     0,     0,     0,     0,     0,     0,
     700,     0,   700,     0,     0,   383,  2345,   383,     0,  2346,
       0,  4570,     0,  2347,  2348,  2349,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   701,     0,     0,
    2350,     0,     0,     0,     0,     0,     0,     0,  2352,  1938,
       0,     0,     0,     0,  2353,  1920,     0,     0,     0,     0,
       0,  1921,     0,     0,     0,     0,   700,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   701,  2354,     0,
       0,   383,   701,     0,     0,     0,   701,     0,     0,     0,
       0,     0,     0,     0,   701,     0,     0,  2355,     0,     0,
       0,  1922,  2356,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   701,     0,     0,     0,     0,     0,     0,     0,
       0,   700,  3902,  2357,  2358,     0,  4653,  3902,     0,  4656,
       0,     0,  3902,     0,     0,  3902,  5120,     0,  2359,   700,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   699,     0,  1924,     0,     0,   701,     0,     0,     0,
    1925,   700,     0,  1926,   700,  3902,     0,     0,     0,     0,
    2360,   699,     0,     0,   701,   701,     0,     0,     0,  3902,
       0,     0,     0,  2361,  2355,     0,  2362,     0,  1927,  2356,
       0,     0,     0,     0,   699,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   383,   701,     0,     0,   383,
    2357,  2358,     0,     0,     0,     0,     0,     0,     0,  1928,
       0,     0,     0,  5181,  2345,  2359,     0,  2346,     0,  4720,
     699,  2347,  2348,  2349,     0,     0,     0,     0,   701,     0,
       0,   382,   701,     0,     0,     0,   699,     0,  2350,     0,
       0,     0,     0,     0,     0,     0,  2352,  2360,     0,     0,
     701,   699,  2353,     0,   699,  2363,  1251,     0,     0,     0,
    2361,   701,     0,  2362,     0,  1920,     0,  1929,     0,  1930,
       0,  1921,     0,     0,   701,     0,  2354,     0,     0,  1931,
       0,     0,     0,   701,     0,     0,     0,  1932,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1933,     0,     0,
       0,     0,     0,     0,     0,     0,  4715,     0,     0,     0,
    3902,  1922,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3742,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3546,     0,     0,  1935,  1936,     0,   383,     0,
       0,     0,  2363,     0,     0,     0,     0,     0,  2364,     0,
       0,  2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,  2372,
    2373,     0,  3547,  1924,     0,  5083,     0,  1047,     0,     0,
    1925,     0,  1047,  1926,     0,  3902,     0,     0,     0,     0,
       0,   699,  2355,     0,     0,     0,     0,  2356,     0,   699,
     699,     0,     0,     0,     0,     0,     0,     0,  1927,     0,
     849,     0,     0,     0,   701,     0,     0,     0,  2357,  2358,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2359,     0,  1938,     0,   700,     0,  1928,
       0,     0,     0,     0,     0,  2364,     0,     0,  2365,  2366,
    2367,     0,  2368,  2369,  2370,  2371,  2372,  2373,     0,     0,
       0,     0,  5094,     0,   849,  2360,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   701,     0,  2361,     0,
       0,  2362,     0,   382,     0,   699,     0,     0,   382,     0,
     382,     0,     0,     0,     0,     0,     0,  1929,     0,  1930,
    5396,     0,     0,     0,     0,     0,     0,     0,     0,  1931,
       0,     0,     0,     0,     0,  2281,     0,  1932,     0,     0,
       0,     0,     0,  2345,     0,   701,  2346,  1933,     0,   849,
    2347,  2348,  2349,     0,     0,     0,     0,     0,     0,  1090,
       0,     0,   700,   701,     0,   700,     0,  2350,     0,     0,
       0,   701,     0,     0,     0,  2352,     0,     0,     0,     0,
    2363,  2353,  4042,  1047,     0,  1935,  1936,     0,     0,  3902,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1090,     0,     0,     0,     0,  2354,     0,     0,     0,     0,
       0,  4953,  4043,     0,  3902,     0,     0,     0,     0,     0,
       0,     0,     0,  4963,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   383,     0,     0,
     700,   700,     0,   383,     0,     0,     0,     0,     0,     0,
       0,     0,  4926,   700,     0,   700,     0,     0,     0,     0,
       0,     0,     0,  2364,     0,  1938,  2365,  2366,  2367,     0,
    2368,  2369,  2370,  2371,  2372,  2373,     0,     0,     0,     0,
    5103,     0,     0,  4943,     0,  5513,     0,     0,     0,     0,
       0,     0,     0,   699,     0,     0,     0,     0,     0,     0,
       0,  2355,     0,     0,  4958,     0,  2356,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   382,     0,  2357,  2358,     0,
       0,     0,     0,     0,   701,     0,     0,     0,     0,     0,
       0,     0,  2359,   849,     0,     0,     0,  2345,     0,  5554,
    2346,     0,     0,     0,  2347,  2348,  2349,     0,   700,     0,
       0,     0,  4985,     0,   699,     0,     0,     0,   699,     0,
       0,  2350,     0,     0,  2360,     0,     0,     0,     0,  2352,
     699,     0,     0,     0,     0,  2353,     0,  2361,     0,  3742,
    2362,     0,     0,     0,     0,     0,     0,  3902,     0,     0,
       0,     0,     0,  1251,  1251,     0,     0,     0,     0,  2354,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1920,
       0,     0,     0,     0,     0,  1921,     0,     0,     0,     0,
       0,   701,     0,     0,     0,  1920,     0,     0,     0,     0,
       0,  1921,     0,     0,     0,     0,     0,   701,   701,     0,
    1964,     0,  5060,     0,     0,   699,   699,     0,     0,     0,
       0,     0,     0,     0,     0,  1922,  1964,     0,   699,  2363,
       0,     0,     0,     0,   701,     0,     0,   701,     0,     0,
       0,  1922,     0,   699,   699,     0,     0,     0,     0,     0,
       0,  1047,     0,     0,     0,     0,     0,     0,  1965,     0,
    3742,     0,  3742,     0,     0,   699,     0,  2281,     0,     0,
       0,     0,     0,     0,  1965,  2355,     0,  1924,     0,     0,
    2356,     0,  5652,  1047,  1925,     0,     0,  1926,     0,     0,
       0,     0,     0,  1924,  1251,  1251,     0,     0,     0,     0,
    1925,  2357,  2358,  1926,     0,     0,     0,     0,     0,     0,
       0,     0,  1927,     0,     0,     0,  2359,     0,   383,   383,
     383,     0,  2364,     0,     0,  2365,  2366,  2367,  1927,  2368,
    2369,  2370,  2371,  2372,  2373,     0,     0,     0,     0,  5106,
    1966,     0,   701,  1928,     0,     0,     0,   700,  2360,     0,
       0,     0,   382,     0,     0,   701,  1966,   383,     0,  1928,
     701,  2361,     0,     0,  2362,     0,     0,     0,     0,   701,
       0,     0,     0,     0,     0,     0,     0,   700,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1967,   700,
       0,  1968,     0,     0,     0,   849,   382,     0,     0,     0,
       0,  1969,     0,  1930,  1967,     0,     0,  1968,     0,     0,
     700,     0,     0,  1931,     0,     0,     0,  1969,     0,  1930,
       0,  1932,     0,     0,     0,     0,     0,     0,     0,  1931,
    1970,  1933,     0,     0,   701,     0,     0,  1932,     0,     0,
       0,     0,     0,  2363,     0,     0,  1970,  1933,     0,     0,
       0,     0,     0,     0,     0,     0,  2345,     0,     0,  2346,
       0,     0,     0,  2347,  2348,  2349,  1971,     0,     0,  1935,
    1936,  1972,   383,     0,     0,     0,     0,     0,     0,   701,
    2350,   701,  3493,     0,     0,  1935,  1936,  1972,  2352,     0,
       0,     0,     0,   701,  2353,   701,  1973,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1047,     0,     0,
    1974,     0,  3494,     0,     0,     0,     0,     0,  2354,     0,
       0,     0,     0,     0,     0,     0,  1974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2364,     0,  2281,  2365,
    2366,  2367,     0,  2368,  2369,  2370,  2371,  2372,  2373,   701,
       0,     0,     0,  5157,     0,     0,     0,     0,     0,  1938,
       0,     0,     0,     0,     0,   700,     0,     0,   699,     0,
       0,     0,     0,     0,     0,  1938,  4155,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   701,     0,     0,     0,   699,     0,
       0,     0,   849,   699,     0,     0,     0,   699,     0,     0,
       0,     0,   701,     0,  2355,   699,     0,     0,     0,  2356,
       0,     0,  2281,     0,     0,     0,  2281,  2281,     0,     0,
       0,     0,     0,   699,   701,     0,     0,   701,     0,     0,
    2357,  2358,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2359,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   700,     0,   700,     0,
       0,     0,     0,     0,     0,     0,     0,   699,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2360,     0,  1090,
       0,     0,     0,     0,     0,   699,   699,     0,     0,     0,
    2361,     0,     0,  2362,     0,     0,     0,   700,     0,     0,
       0,     0,     0,     0,   383,     0,     0,     0,     0,  5424,
       0,     0,     0,     0,     0,     0,   849,   699,     0,     0,
     849,     0,     0,     0,  2345,     0,     0,  2346,     0,     0,
    1047,  2347,  2348,  2349,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   382,     0,     0,     0,  1090,  2350,   699,
       0,     0,     0,   699,     0,     0,  2352,     0,     0,     0,
       0,     0,  2353,     0,     0,     0,     0,     0,     0,  1047,
       4,   699,  2363,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   699,     0,     0,     0,  2354,     0,     0,     0,
       5,     0,     0,     0,  3742,   699,     0,     0,     0,     0,
       6,     7,     0,     0,   699,     8,     0,     9,    10,     0,
       0,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,     0,    36,     0,    37,
      38,    39,    40,    41,    42,    43,    44,     0,     0,     0,
      45,     0,     0,     0,     0,     0,     0,     0,     0,   849,
       0,     0,     0,     0,     0,  2364,     0,     0,  2365,  2366,
    2367,     0,  2368,  2369,  2370,  2371,  2372,  2373,     0,     0,
       0,     0,  5188,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2355,     0,     0,     0,     0,  2356,     0,     0,
     701,   745,    46,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2357,  2358,
       0,     0,     0,     0,   382,   699,     0,     0,  2345,     0,
       0,  2346,     0,  2359,     0,  2347,  2348,  2349,   745,     0,
       0,     0,     0,     0,     0,     0,   383,     0,     0,     0,
    1920,   383,  2350,   383,     0,   700,  1921,     0,     0,   745,
    2352,     0,     0,     0,     0,  2360,  2353,     0,     0,     0,
       0,     0,     0,     0,     0,    47,     0,  1056,  2361,     0,
       0,  2362,     0,     0,     0,     0,     0,   699,     0,     0,
    2354,     0,  1058,    48,     0,     0,  1922,     0,     0,     0,
    1066,     0,     0,     0,     0,   701,     0,     0,   701,     0,
       0,     0,     0,     0,    49,  1080,     0,  1056,     0,     0,
       0,  1103,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1135,     0,     0,     0,     0,   699,    50,     0,     0,
    1140,     0,     0,     0,     0,     0,     0,     0,  1924,     0,
       0,     0,     0,     0,   699,  1925,     0,     0,  1926,     0,
    2363,     0,   699,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    51,     0,     0,    52,     0,     0,
       0,     0,     0,  1927,     0,     0,     0,     0,  1047,     0,
       0,     0,    53,   701,   701,     0,  2355,     0,     0,     0,
       0,  2356,     0,     0,     0,     0,   701,     0,   701,     0,
       0,     0,     0,     0,  1928,   382,     0,   700,     0,     0,
       0,     0,  2357,  2358,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2359,   849,     0,
       0,     0,     0,     0,   849,     0,     0,     0,     0,     0,
       0,     0,     0,  2364,     0,     0,  2365,  2366,  2367,     0,
    2368,  2369,  2370,  2371,  2372,  2373,     0,     0,     0,  2360,
    5226,    54,  1929,     0,  1930,     0,     0,     0,   383,     0,
       0,     0,  2361,     0,  1931,  2362,     0,     0,     0,     0,
       0,     0,  1932,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1933,     0,     0,     0,     0,     0,     0,     0,
     700,   701,     0,     0,     0,     0,     0,    55,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    56,     0,     0,   699,     0,  4093,     0,     0,
    1935,  1936,     0,     0,     0,     0,     0,    57,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2363,     0,     0,  4094,     0,     0,
       0,     0,     0,     0,     0,    58,     0,     0,     0,     0,
       0,     0,     0,    59,     0,    60,    61,    62,    63,    64,
       0,     0,    65,    66,    67,    68,     0,    69,    70,    71,
      72,    73,     0,     0,     0,     0,     0,     0,     0,     0,
     700,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   382,     0,     0,     0,     0,     0,
    1938,     0,   699,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1047,   699,   699,
       0,     0,     0,     0,     0,     0,     0,  2364,     0,     0,
    2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,  2372,  2373,
       0,     0,     0,     0,  5480,   699,     0,     0,   699,     0,
       0,     0,     0,     0,     0,     0,     0,   382,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   382,     0,     0,     0,
       0,     0,     0,     0,  2345,     0,     0,  2346,     0,     0,
       0,  2347,  2348,  2349,     0,     0,     0,     0,     0,  5431,
       0,     0,     0,     0,     0,     0,     0,     0,  2350,     0,
     701,     0,     0,     0,     0,   383,  2352,     0,     0,     0,
       0,     0,  2353,     0,     0,     0,     0,     0,     0,   849,
     849,   849,     0,     0,     0,     0,     0,     0,   745,     0,
     701,     0,     0,     0,     0,     0,  2354,     0,     0,     0,
       0,     0,   701,   699,     0,     0,     0,     0,     0,   383,
       0,     0,     0,     0,     4,     0,   699,     0,   849,     0,
       0,   699,     0,   701,     0,     0,     0,     0,     0,     0,
     699,     0,     0,     0,     5,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     6,     7,     0,     0,     0,     0,
       0,     9,    10,     0,     0,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
       0,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,     0,     0,     0,    45,   699,     0,     0,     0,     0,
       0,     0,  2355,     0,     0,     0,     0,  2356,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2357,  2358,
       0,     0,     0,   849,     0,     0,     0,     0,     0,     0,
     699,     0,   699,  2359,     0,     0,    46,     0,     0,     0,
       0,     0,     0,     0,   699,     0,   699,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2360,     0,     0,   701,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2361,     0,
       0,  2362,     0,     0,     0,     0,     0,     0,  1233,  1239,
    1239,   745,     0,  1239,     0,  1247,   871,  1233,     0,  1135,
     699,     0,  1277,     0,     0,     0,     0,     0,  1135,    47,
       0,  1135,     0,     0,     0,  1239,     0,  1135,     0,     0,
       0,     0,     0,     0,     0,  1314,     0,    48,     0,     0,
       0,  1135,     0,  1233,     0,     0,  1239,     0,   745,     0,
    1239,     0,   872,     0,     0,     0,     0,  1277,    49,     0,
       0,  1380,     0,     0,     0,   699,   873,     0,  1239,     0,
    2363,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,     0,   699,   874,     0,     0,     0,     0,   701,
     875,   701,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1233,     0,     0,   699,   876,   745,   699,     0,
       0,     0,  1233,     0,     0,     0,  1277,   877,    51,     0,
       0,    52,     0,     0,     0,   878,     0,     0,     0,     0,
     701,     0,     0,  1239,     0,     0,    53,   879,     0,     0,
       0,     0,   880,     0,     0,     0,     0,     0,   881,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2364,     0,   882,  2365,  2366,  2367,     0,
    2368,  2369,  2370,  2371,  2372,  2373,   383,     0,     0,     0,
    5512,     0,     0,     0,     0,   849,     0,     0,  2345,  1135,
     883,  2346,     0,     0,     0,  2347,  2348,  2349,     0,     0,
       0,     0,     0,     0,  1135,     0,  1579,     0,     0,     0,
       0,   884,  2350,     0,     0,    54,     0,     0,     0,     0,
    2352,     0,     0,     0,     0,     0,  2353,     0,     0,     0,
       0,     0,     0,     0,  1689,  1689,     0,     0,     0,   745,
    1135,     0,     0,   885,     0,     0,     0,     0,     0,     0,
    2354,     0,     0,     0,     0,     0,     0,     0,     0,  1135,
       0,    55,     0,  1135,   886,     0,     0,     0,     0,     0,
       0,  1689,     0,     0,   887,     0,    56,     0,     0,     0,
       0,     0,  1135,     0,     0,     0,     0,     0,     0,     0,
       0,    57,     0,     0,  1135,     0,     0,     0,     0,     0,
       0,   888,     0,     0,     0,     0,   889,     0,   890,     0,
       0,     0,     0,     0,   891,     0,     0,   892,     0,    58,
       0,     0,     0,     0,     0,     0,     0,    59,     0,    60,
      61,    62,    63,    64,     0,     0,    65,    66,  1501,     0,
       0,     0,     0,    71,  1502,   893,   894,     0,     0,   895,
       0,     0,     0,   896,     0,     0,  2355,   383,     0,     0,
       0,  2356,   897,     0,     0,     0,     0,   898,     0,     0,
       0,     0,     0,     0,     0,     0,  1135,     0,     0,   899,
       0,   699,  2357,  2358,     0,  1135,     0,     0,   701,     0,
    1239,  1239,   900,     0,     0,     0,     0,  2359,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2345,
       0,     0,  2346,     0,     0,     0,  2347,  2348,  2349,     0,
       0,     0,     0,     0,     0,     0,     0,   849,     0,  2360,
       0,     0,   849,  2350,   849,     0,     0,     0,     0,     0,
       0,  2352,  2361,  1233,     0,  2362,     0,  2353,     0,     0,
       0,     0,     0,     0,  1233,     0,     0,     0,  1277,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2354,     0,  1239,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   699,     0,     0,   699,
       0,     0,     0,  1135,     0,     0,     0,     0,     0,  1239,
    1239,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1135,  1135,  1135,     0,
    1239,     0,  1233,     0,  2363,     0,     0,  2115,     0,     0,
       0,     0,     0,     0,     0,  2345,     0,     0,  2346,     0,
       0,     0,  2347,  2348,  2349,     0,     0,     0,   383,     0,
     701,     0,     0,     0,     0,     0,     0,     0,     0,  2350,
       0,     0,     0,     0,     0,     0,     0,  2352,     0,     0,
       0,     0,     0,  2353,   699,   699,     0,  2355,     0,     0,
       0,     0,  2356,     0,     0,     0,     0,   699,     0,   699,
       0,     0,     0,     0,     0,     0,     0,  2354,  1239,     0,
    1239,  1239,     0,  2357,  2358,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2364,  2359,     0,
    2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,  2372,  2373,
       0,     0,     0,     0,  5633,     0,     0,     0,     0,  1689,
       0,     0,     0,   701,     0,     0,     0,     0,     0,     0,
    2360,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2361,     0,     0,  2362,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2255,  2255,     0,
       0,     0,  1135,     0,  1056,     0,     0,     0,     0,     0,
       0,     0,   699,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2355,     0,     0,     0,     0,  2356,     0,
    2289,     0,     0,  1135,     0,     0,  2295,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1689,  2357,
    2358,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   701,  2359,  2363,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1689,   383,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2360,     0,     0,     0,
       0,     0,     0,     0,  1689,  1689,  1689,     0,  1689,  2361,
       0,     0,  2362,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1689,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     383,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     745,   745,     0,     0,     0,     0,     0,     0,  2364,   383,
       0,  2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,  2372,
    2373,     0,     0,     0,     0,  5651,     0,     0,     0,  1135,
       0,     0,  1689,     0,     0,     0,     0,     0,     0,     0,
       0,  2363,     0,     0,     0,     0,     0,     0,     0, -2333,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1689,     0,     0,     0,  1689,  1689,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1135,  1135,  2495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   699,     0,     0,  2345,     0,   849,  2346, -2333,     0,
       0,  2347,  2348,  2349,     0,     0,   745,     0,     0,     0,
   -2333,     0,     0,     0,     0, -2333,     0,     0,  2350,     0,
   -2333,   699,  3229,     0,     0, -2333,  2352,     0, -2333, -2335,
       0, -2333,  2353,   699,  2364,     0,     0,  2365,  2366,  2367,
     849,  2368,  2369,  2370,  2371,  2372,  2373,     0,     0,  3214,
       0,     0,     0,     0,   699,     0,  2354,     0,     0, -2333,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2335, -2333,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2335,     0,  1256,     0,     0, -2335,     0,     0,  2644,     0,
   -2335,  1286,     0,     0,  3230, -2335,     0,     0, -2335,     0,
    1302, -2335,     0,     0,     0,     0,  1135,  2670,  1312, -2333,
       0, -2333,     0,     0,  1353,  1135,     0, -2333,  1239,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -2335,
       0,     0,     0,     0,     0,     0,     0,  1277,     0,  1135,
       0,     0,     0,     0,     0,     0,     0,  1135,     0, -2335,
    1135,     0,  2355,     0,     0,     0,     0,  2356,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2333,     0,     0,
       0,     0,     0,     0,  1135,     0,     0,     0,  2357,  2358,
       0,     0,  1239,  1239,  1239,  1239,  1135,     0,     0, -2335,
       0, -2335,     0,  2359,     0,     0,     0, -2335,     0,   699,
    1135,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2794,     0,  1135,     0,  1061,     0,     0,     0,
       0,     0,     0,     0,     0,  2360,  1239,  1239,     0,     0,
       0,     0,     0,     0,     0,  1239,     0,     0,  2361,     0,
       0,  2362, -2333,     0,     0,  1239,     0, -2335,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1135,     0, -2333,     0, -2333, -2333,
       0,     0,     0,  1239,  1239,  1239,  1239,  1577,     0,     0,
       0,     0,     0,     0,     0,  1135,     0,     0,     0,     0,
       0,     0,  1135,     0,     0,  2794,  1061,     0,     0,     0,
       0,     0, -2333,     0,     0, -2333, -2333,     0, -2333,     0,
     699,  1233,   699,  1709,     0,     0,     0,     0,   745,     0,
    2363,     0, -2335,  1689,     0,     0,     0,     0,     0,     0,
       0,     0,  1733,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -2335,     0, -2335, -2335,
       0,   699,     0,     0,     0,  1760,  1233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1277,     0,     0,     0,
    1239,     0,     0,  1239,     0,  3231,     0,     0,     0,     0,
       0,     0, -2335,  1239,     0, -2335, -2335,     0, -2335,     0,
       0,  1239,  1239,     0,     0,     0,     0,   849,     0,     0,
       0,     0,     0,     0,     0,  1135,     0,     0,     0,     0,
       0,     0,     0,  2364,     0,     0,  2365,  2366,  2367,     0,
    2368,  2369,  2370,  2371,  2372,  2373,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2255,
       0,     0,     0,     0,     0,     0,  1239,     0,  1233,     0,
       0,     0,  1135,  1135,     0,  1239,     0,     0,  1945,     0,
       0,     0,  1135,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1135,     0,     0,     0,     0,  1056,  1056,     0,
       0,  3041,     0,     0,     0,  1689,  1689,     0,     0,     0,
       0,  1689,  1689,     0,     0,     0,     0,     0,  1689,  1689,
    1689,     0,     0,     0,  1689,  1277,  1689,  1689,  1689,  1689,
    1689,  1689,     0,  1689,     0,  1689,  1689,     0,     0,  1689,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1689,  1689,  1689,  1689,     0,     0,
       0,  1239,  1689,     0,     0,     0,  1689,     0,     0,  1689,
       0,     0,  1689,  1689,  1689,  1689,  1689,  1689,  1689,  1689,
    1689,     0,  1689,     0,     0,     0,  2070,     0,     0,  1135,
    1689,     0,     0,  1689,     0,     0,     0,     0,   849,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2100,
    2103,  2104,     0,     0,     0,  1135,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   699,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1135,     0,  1135,     0,  1689,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1457,  1689,     0,     0,     0,     0,     0,     0,     0,     0,
    1689,  1689,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1457,     0,     0,  1135,     0,     0,     0,     0,     0,
       0,  3264,     0,  3271,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2345,     0,     0,  2346,     0,     0,
       0,  2347,  2348,  2349,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2350,     0,
       0,     0,     0,     0,     0,     0,  2352,     0,     0,     0,
       0,     0,  2353,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1709,     0,     0,     0,     0,
       0,   745,     0,     0,     0,     0,  2354,     0,     0,   849,
    1056,   699,  1056,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1709,     0,     0,  1689,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1233,     0,  1239,  1239,     0,     0,     0,  1233,     0,
    1277,     0,  1239,     0,  1239,     0,     0,     0,  1239,     0,
       0,  1135,     0,     0,     0,     0,     0,     0,     0,     0,
    2345,     0,     0,  2346,     0,     0,     0,  2347,  2348,  2349,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3825,     0,  2670,     0,  2350,  3826,     0,     0,     0,     0,
    3411,     0,  2352,     0,   699,     0,     0,  3422,  2353,     0,
       0,     0,  2355,     0,     0,     0,  1135,  2356,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2354,     0,     0,  1135,     0,     0,  2357,  2358,
    3467,  3467,     0,     0,     0,     0,     0,     0,     0,   745,
       0,     0,     0,  2359,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1239,     0,     0,
       0,     0,  2435,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2360,     0,     0,     0,     0,
       0,     0,     0,     0,  3532,     0,  3535,  3537,  2361,     0,
       0,  2362,     0,     0,   699,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5594,     0,     0,   849,     0,
       0,  2493,     0,     0,     0,  1239,     0,     0,     0,     0,
       0,     0,  1457,  1239,     0,  1239,     0,     0,  2355,     0,
       0,  1239,     0,  2356,     0,     0,     0,     0,     0,     0,
       0,     0,  1457,  1689,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2357,  2358,  1457,  2670,     0,     0,
    3467,     0,  1135,     0,     0,  3623,     0,     0,  1056,  2359,
    2363,   849,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     849,     0,     0,     0,  3532,     0,     0,     0,     0,     0,
       0,  2360,     0,  1239,  3649,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2361,     0,     0,  2362,     0,  2115,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1689,     0,     0,     0,     0,     0, -2349,  5595,  1457,     0,
       0,     0,     0,     0,  3696,  3699,     0,     0,     0,  2664,
       0,     0,     0,     0,     0,     0,     0,  1239,  2687,  1239,
    3467,  1239,  3467,  2364,     0,     0,  2365,  2366,  2367,     0,
    2368,  2369,  2370,  2371,  2372,  2373,     0,     0,     0,     0,
       0,     0,  2721,     0,     0, -2349,     0,     0,  1689,     0,
    2728,     0,  2345,  2731,     0,  2346,  2363, -2349,     0,  2347,
    2348,  2349, -2349,     0,     0,     0,     0, -2349,     0,     0,
       0,  2255, -2349,     0,     0, -2349,  2350,     0, -2349,  3784,
       0,     0,     0,     0,  2352,     0,     0,     0,     0,  2766,
    2353,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2783,     0,     0, -2349,     0,     0,  1135,
       0,     0,     0,     0,  2354,     0,     0,  2795,     0,  1233,
       0,     0,     0,     0,     0,  1233, -2349,     0,     0,  1457,
       0,     0,     0,     0,     0,     0,  1239,     0,     0,     0,
       0,     0,  1689,     0,     0,     0,     0,  1689,     0,  2364,
       0,     0,  2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,
    2372,  2373,     0,     0,     0,     0, -2349,  2846, -2349,     0,
    1689,  1689,  1689,     0, -2349,  1689,     0,     0,     0,     0,
       0,     0,     0,  1689,  1689,  1689,  1689,     0,  2880,     0,
       0,     0,     0,     0,     0,  2892,  1689,     0,     0,  1689,
       0,  1689,     0,     0,     0,  1315,     0,     0,     0,     0,
    1316,     0,  1689,  1689,     0,     0,  1689,     0,     0,     0,
    2355,     0,     0,     0, -2349,  2356,     0,     0,  1277,     0,
    1689,     0,  1689,     0,  1689,     0,     0,     0,     0,     0,
       0,     0,     0,  1317,     0,     0,  2357,  2358,     0,     0,
       0,     0,     0,     0,  1689,     0,  1318,  1319,  1135,     0,
       0,  2359,     0,     0,     0,  3903,  1320,  1689,  1689,  1689,
    1321,     0,     0,  1061,     0,     0,     0,     0,     0,  2417,
       0,     0,     0,     0,     0,     0,     0,     0,  1322,     0,
       0,     0,  1689,  2360,     0,     0,     0,     0,     0, -2349,
       0,     0,     0,     0,     0,  1689,  2361,     0,  2976,  2362,
    1323,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1689,  1324,     0, -2349,     0, -2349, -2349,     0,     0,  1325,
       0,     0,     0,     0,  3903,     0,     0,  3965,     0,     0,
    3968,  1326,  3271,     0,     0,     0,  1327,     0,     0,     0,
       0,     0,     0,     0,     0,  1709,  1709,     0,     0, -2349,
       0,     0, -2349, -2349,     0, -2349,     0,     0,     0,  1328,
       0,     0,     0,     0,     0,  3031,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2363,     0,
       0,     0,  2345,     0,  1329,  2346,     0,     0,     0,  2347,
    2348,  2349,     0,     0,     0,     0,     0,  1689,  1457,  3467,
       0,     0,     0,     0,  2255,  1330,  2350,     0,     0,     0,
       0,     0,     0,     0,  2352,     0,     0,     0,     0,     0,
    2353,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1239,     0,  1239,  1239,  1239,     0,  1331,     0,     0,
       0,     0,     0,     0,  2354,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1332,     0,
       0,     0,  3186,  1457,     0,     0,     0,     0,   887,     0,
       0,  2364,     0,     0,  2365,  2366,  2367,     0,  2368,  2369,
    2370,  2371,  2372,  2373,     0,     0,     0,     0,  3207,     0,
       0,     0,     0,     0,     0,  1333,     0,  1457,     0,     0,
    1334,     0,  1335,     0,     0,     0,     0,     0,  1336,     0,
       0,  1337,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3220,     0,  3223,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1338,     0,  1135,  1339,     0,     0,     0,  1340,     0,     0,
    2355,     0,     0,     0,  1341,  2356,  1342,     0,     0,     0,
       0,  1343,     0,     0,     0,     0,     0,  1709,     0,     0,
       0,     0,     0,     0,     0,     0,  2357,  2358,     0,  1457,
       0,     0,     0,     0,     0,     0,  1344,     0,     0,     0,
       0,  2359,  2345,     0,  1457,  2346,     0,     0,     0,  2347,
    2348,  2349,  1457,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1457,     0,     0,  2350,     0,     0,  3830,
       0,     0,     0,  2360,  2352,  1239,     0,     0,     0,     0,
    2353,     0,  3467,  3467,     0,     0,  2361,     0,     0,  2362,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2354,  3798,     0,     0,     0,     0,
    1457,     0,     0,     0,     0,     0,     0,     0,     0,  1135,
    1135,     0,     0,     0,     0,     0,     0,     0,     0,  1457,
       0,     0,     0,     0,     0,  1135,     0,     0,     0,     0,
       0,  1457,     0,     0,     0,     0,     0,     0,     0,     0,
    2255,  1135,     0,  1457,     0,     0,     0,     0,     0,  2255,
    1135,  1135,     0,     0,     0,     0,     0,     0,  2363,     0,
       0,     0,     0,     0,     0,     0,     0,  1135,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1457,   745,     0,  1457,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2355,  3696,     0,     0,     0,  2356,     0,     0,     0,  3434,
       0,     0,     0,     0,     0,     0,     0,     0,  1239,     0,
    1239,     0,     0,     0,  1239,     0,  2357,  2358,  3461,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2359,     0,  1233,     0,     0,     0,     0,     0,     0,
       0,  2364,     0,  1135,  2365,  2366,  2367,     0,  2368,  2369,
    2370,  2371,  2372,  2373,     0,     0,     0,     0,     0,  1135,
       0,     0,     0,  2360,     0,     0,     0,     0,     0,     0,
       0,  1239,     0,     0,     0,     0,  2361,     0,  1689,  2362,
       0,     0,     0,     0,     0,     0,     0,  1689,     0,     0,
       0,     0,     0,  1689,     0,  1689,     0,     0,  1689,     0,
       0,     0,     0,  1689,  1689,  1689,  1689,     0,     0,  1689,
    1689,  1689,  1689,  1689,  1689,  1689,  1689,  1689,  1689,     0,
       0,     0,  1689,  1689,     0,  1457,     0,     0,     0,     0,
       0,     0,  1689,     0,     0,     0,  1689,     0,     0,     0,
    1689,     0,     0,     0,     0,     0,     0,     0,  1689,     0,
       0,  1689,     0,  1689,     0,  3619,     0,     0,  2363,     0,
       0,     0,  1689,     0,     0,  1689,  1689,     0,     0,     0,
    1689,  1689,     0,     0,     0,  4448,     0,  1689,     0,     0,
       0,     0,     0,     0,  1135,  1135,  1135,  1233,     0,  3903,
    4468,     0,     0,     0,  4468,  4482,     0,     0,     0,     0,
       0,  1689,     0,     0,     0,     0,     0,  1689,  1689,  1689,
    2345,     0,     0,  2346,     0,     0,     0,  2347,  2348,  2349,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   857,
       0,     0,     0,     0,  2350,     0,     0,     0,     0,     0,
       0,     0,  2352,     0,     0,     0,     0,     0,  2353,     0,
       0,  2364,     0,     0,  2365,  2366,  2367,  1689,  2368,  2369,
    2370,  2371,  2372,  2373,     0,     0,     0,     0,  3271,     0,
    1689,     0,  2354,     0,   857,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4547,  2255,  2255,     0,  2794,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1094,     0,  1239,  1239,  1239,  1239,     0,  1457,
    1094,     0,  1094,  1457,  1457,     0,     0,     0,     0,     0,
       0,     0,  3759,     0,     0,   857,     0,     0,     0,     0,
       0,     0,     0,  2670,     0,     0,     0,     0,     0,     0,
       0,  3835,     0,     0,     0,     0,     0,  4593,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2355,     0,
       0,     0,     0,  2356,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1457,     0,     0,
       0,     0,     0,     0,  2357,  2358,     0,     0,     0,  1457,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2359,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1457,
       0,  2360,     0,     0,     0,     0,     0,  4671,     0,     0,
       0,     0,     0,     0,  2361,  2345,     0,  2362,  2346,     0,
       0,     0,  2347,  2348,  2349,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2350,
       0,  3886,  3841,     0,     0,     0,     0,  2352,     0,     0,
    1135,     0,  1239,  2353,  1689,     0,     0,     0,     0,     0,
    1135,     0,     0,     0,     0,     0,  4706,     0,     0,     0,
       0,     0,     0,     0,     0,  2670,     0,  2354,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1135,  2363,     0,     0,     0,
       0,     0,     0,     0,     0,  3532,     0,     0,     0,     0,
       0,     0,     0,  4741,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1135,     0,     0,     0,  2794,     0,     0,
       0,  1689,  1689,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1457,     0,     0,     0,
       0,     0,     0,  3696,  3696,  3696,  3696,  3696,     0,     0,
       0,     0,     0,  3467,     0,  3467,     0,     0,     0,     0,
       0,     0,     0,  2355,     0,  1135,     0,     0,  2356,  2364,
       0,     0,  2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,
    2372,  2373,     0,     0,     0,     0,     0,     0,     0,  2357,
    2358,     0,     0,     0,     0,     0,  1689,     0,     0,     0,
       0,     0,     0,     0,  2359,     0,  1457,  1689,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2360,  1689,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1689,  1689,  2361,
       0,     0,  2362,     0,  1689,  1689,     0,     0,     0,  1689,
       0,     0,     0,     0,  1689,     0,     0,  1689,  1689,     0,
       0,     0,  1689,  4846,     0,     0,     0,     0,  1689,  1135,
    1135,  1135,  1135,     0,     0,     0,  4468,  4482,     0,  4468,
       0,     0,  4857,     0,     0,     0,  3903,     0,     0,     0,
    3903,     0,     0,     0,     0,     0,  4872,     0,     0,     0,
       0,     0,  1689,     0,     0,  4116,     0,  1689,     0,     0,
       0,     0,     0,  1689,     0,     0,     0,     0,     0,     0,
       0,  2363,     0,  1277,     0,     0,     0,  1457,     0,     0,
    1689,     0,     0,  3965,     0,     0,     0,     0,  3271,     0,
       0,     0,     0,     0,  1457,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1457,  1056,     0,     0,  1689,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2345,
       0,     0,  2346,     0,     0,     0,  2347,  2348,  2349,  3467,
    3467,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2350,     0,     0,     0,  2670,     0,     0,
       0,  2352,     0,     0,     0,     0,  4942,  2353,     0,     0,
       0,     0,     0,     0,  2364,     0,     0,  2365,  2366,  2367,
       0,  2368,  2369,  2370,  2371,  2372,  2373,     0,     0,     0,
       0,  2354,  4225,  4226,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1689,  4235,     0,
       0,     0,     0,     0,  2345,     0,     0,  2346,     0,     0,
       0,  2347,  2348,  2349,  4252,     0,     0,  1239,     0,     0,
       0,     0,     0,  4261,  4263,     0,     0,     0,  2350,     0,
       0,  4423,  1239,     0,     0,     0,  2352,     0,     0,     0,
    4281,     0,  2353,     0,     0,     0,   857,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,  1689,
       0,     0,     0,  1235,     0,     0,  2354,     0,     0,     0,
    1233,     0,     0,     0,     0,  2670,     0,     0,     0,     0,
       0,     0,     0,  2255,     0,     0,     0,  2355,     0,     0,
       0,     0,  2356,     0,     0,     0,     0,     0,     0,  1235,
    1239,  3649,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2357,  2358,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2359,     0,
    1135,     0,     0,  5069,     0,     0,     0,     0,     0,     0,
       0,     0,  1709,     0,     0,  1457,     0,     0,  1457,     0,
    1457,     0,     0,     0,     0,  1457,     0,     0,  1235,     0,
    2360,     0,     0,     0,  1460,     0,     0,     0,  1235,     0,
       0,     0,  2355,  2361,     0,     0,  2362,  2356,  1689,     0,
       0,     0,     0,     0,     0,  1460,     0,  1689,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2357,  2358,
       0,     0,     0,     0,  1689,  1689,     0,  1457,  1689,     0,
       0,     0,     0,  2359,     0,     0,     0,     0,     0,     0,
       0,     0,  1233,  4468,  1457,     0,     0,  3903,     0,     0,
       0,     0,  3903,     0,     0,  3903,  1233,     0,  3532,     0,
    5124,     0,     0,  1689,  1689,  2360,     0,     0,     0,  1457,
       0,     0,     0,     0,     0,  2363,     0,     0,  2361,     0,
       0,  2362,     0,     0,     0,  4547,     0,  4456,  4457,  4458,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4547,
    1277,  1239,  1239,  1239,  4369,     0,     0,     0,     0,     0,
    1235,  1235,     0,     0,     0,     0,     0,  1094,     0,     0,
       0,  1094,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1457,     0,
    1457,     0,     0,  1233,  1277,     0,     0,  1235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2363,     0,     0,     0,     0,     0,     0,     0,  2364,     0,
       0,  2365,  2366,  2367,     0,  2368,  2369,  2370,  2371,  2372,
    2373,     0,     0,     0,     0,     0,  1233,     0,     0,  1135,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4706,
       0,  1457,     0,     0,     0,  1135,     0,  3467,     0,     0,
       0,     0,     0,  2670,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1457,  4741,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1239,  1135,
    4547,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2364,  1457,     0,  2365,  2366,  2367,  1457,
    2368,  2369,  2370,  2371,  2372,  2373,     0,     0,     0,     0,
       0,     0,  1689,     0,     0,  1689,     0,  1689,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1094,  1094,     0,     0,     0,     0,     0,     0,     0,
       0,  1689,     0,     0,     0,  3903,     0,     0,     0,  5124,
       0,     0,     0,     0,     0,     0,  1689,     0,  1457,  1235,
       0,     0,     0,     0,     0,  5323,  1460,     0,     0,     0,
    1235,     0,     0,     0,     0,     0,  1457,     0,  1689,     0,
       0,     0,     0,     0,     0,     0,  1460,     0,     0,     0,
       0,  1457,     0,  1135,     0,  2345,     0,     0,  2346,     0,
    1460,     0,  2347,  2348,  2349,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1689,     0,     0,  2350,
       0,     0,     0,  1239,  1239,  1239,  1239,  2352,     0,     0,
       0,     0,     0,  2353,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,  4691,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4701,     0,     0,     0,  2354,     0,     0,
    1233,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1135,     0,     0,     0,
       0,  1689,  1460,     0,     0,     0,     0,     0,  4722,     0,
       0,     0,     0,  1457,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1457,     0,  2892,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1689,     0,     0,  1233,
       0,     0,     0,     0,     0,     0,     0,     0,  1689,  1457,
       0,     0,     0,  1689,     0,  1689,     0,  1689,     0,     0,
       0,     0,     0,     0,  4547,  1235,     0,     0,     0,     0,
    1239,     0,  1277,  2355,     0,     0,     0,     0,  2356,     0,
       0,  1689,     0,  1457,     0,     0,     0,     0,  2976,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2357,
    2358,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2255,  2255,  2359,     0,     0,     0,     0,     0,
       0,     0,     0,  1460,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1239,
       0,     0,     0,     0,     0,  1233,  2360,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,  2361,
       0,     0,  2362,     0,     0,     0,     0,     0,     0,     0,
    5069,     0,     0,     0,     0,     0,     0,     0,  1689,  1689,
       0,     0,  1235,  3532,     0,     0,     0,     0,     0,  1689,
       0,     0,  5323,     0,     0,     0,  3271,     0,     0,     0,
       0,     0,  4849,  4850,  4851,  4852,     0,     0,  1457,  1233,
    1235,  1235,  1235,     0,  1235,     0,   915,     0,     0,  1239,
       0,   916,     0,     0,     0,     0,  2255,     0,     0,     0,
       0,     0,     0,   917,  1235,     0,     0,     0,     0,     0,
       0,  2363,     0,     0,     0,     0,     0,     0,  2670,     0,
       0,     0,     0,     0,   918,     0,     0,  4547,     0,     0,
       0,     0,     0,  1233,  1233,     0,  1689,   919,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   920,     0,     0,
       0,  -802,     0,     0,     0,  1689,     0,     0,  1235,   857,
       0,     0,  1239,     0,     0,     0,     0,     0,     0,   921,
       0,     0,     0,     0,     0,   922,     0,     0,  1457,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1235,     0,
       0,   923,  1235,  1235,     0,     0,     0,     0,     0,     0,
       0,     0,   924,     0,  2364,     0,     0,  2365,  2366,  2367,
     925,  2368,  2369,  2370,  2371,  2372,  2373,     0,     0,     0,
       0,     0,   926,     0,     0,     0,     0,     0,     0,   927,
       0,     0,     0,   928,     0,     0,     0,     0,  1689,  1689,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -1014,     0,  1233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1233,  1233,     0,     0,     0,     0,
       0,     0,  1460,     0,     0,     0,     0,     0,   857,     0,
       0,     0,     0,     0,     0,     0,     0,   929,  1094,     0,
       0,     0,     0,     0,     0,     0,  -540,     0,     0,     0,
       0,     0,   705,     0,     0,     0,     0,   749,     0,   749,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   749,
       0,     0,     0,  1457,     0,     0,     0,     0,   930,  1094,
       0,   931,     0,     0,     0,     0,     0,  1460,     0,     0,
       0,     0,     0,     0,   749,     0,     0,     0,     0,   932,
       0,     0,     0,     0,   749,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   749,   749,     0,  -436,   749,
       0,  1460,  1457,     0,     0,   749,     0,     0,     0,  1048,
       0,     0,     0,  5062,     0,     0,   933,     0,     0,     0,
       0,     0,     0,   934,     0,     0,     0,     0,     0,  -436,
       0,  1048,   935,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   749,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -436,     0,     0,   936,   937,     0,   938,   939,     0,
       0,     0,     0,     0,     0,     0,     0,   940,     0,     0,
       0,     0,   941,  1460,     0,     0,     0,     0,   942,     0,
       0,   943,     0,     0,   944,     0,     0,     0,  1460,     0,
       0,     0,     0,     0,     0,     0,  1460,  -436,     0,     0,
       0,     0,   857,     0,     0,     0,     0,  1460,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1457,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1457,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1460,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,     0,
       0,     0,     0,  1460,     0,     0,     0,     0,     0,  1235,
       0,     0,     0,     0,     0,  1460,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1460,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1460,     0,     0,
    1460,     0,  5224,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1709,     0,
       0,     0,   749,     0,     0,     0,     0,     0,     0,  1457,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5272,     0,     0,     0,     0,     0,     0,     0,
    1457,     0,     0,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1457,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1457,     0,     0,     0,
       0,  1235,  1235,     0,     0,     0,     0,  1235,  1235,     0,
       0,     0,     0,     0,  1235,  1235,  1235,     0,     0,     0,
    1235,     0,  1235,  1235,  1235,  1235,  1235,  1235,     0,  1235,
       0,  1235,  1235,     0,     0,  1235,     0,     0,     0,  1457,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1460,
    1235,  1235,  1235,  1235,   857,     0,     0,     0,  1235,     0,
       0,     0,  1235,     4,     0,  1235,  5338,     0,  1235,  1235,
    1235,  1235,  1235,  1235,  1235,  1235,  1235,     0,  1235,     0,
       0,     0,     0,     5,     0,     0,  1235,     0,     0,  1235,
       0,     0,     0,     6,     7,     0,     0,     0,     0,     0,
       9,    10,     0,     0,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,  1457,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
       0,     0,     0,    45,     0,     0,     0,     0,     0,  5406,
       0,     0,     0,  1235,   749,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,     0,
       0,     0,     0,     0,     0,     0,  1235,  1235,     0,     0,
       0,     0,     0,     0,  1457,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,     0,     0,     0,     0,
       0,     0,   749,   749,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     749,     0,     0,  1460,     0,     0,     0,  1460,  1460,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    47,     0,
       0,   857,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    48,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1235,     0,    49,     0,     0,
       0,     0,     0,     0,     0,  1457,     0,  1235,     0,     0,
       0,  1460,     0,     0,  1235,     0,     0,     0,     0,     0,
      50,     0,     0,  1460,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1094,     0,
       0,     0,     0,     0,     0,     0,     0,    51,     0,     0,
      52,     0,     0,  1460,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    53,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   857,     0,     0,     0,   857,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1457,     0,  1094,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1404,
     749,     0,   749,     0,     0,  1457,     0,     0,     0,     0,
       0,     0,     0,     0,    54,     0,     0,     0,     0,     0,
       0,    85,     0,     0,     0,     0,     0,    89,     0,     0,
       0,    93,     0,    94,     0,    96,    97,     0,     0,     0,
       0,     0,     0,  1457,     0,     0,   106,     0,     0,     0,
       0,     0,     0,     0,   749,     0,     0,   749,   749,     0,
      55,     0,   118,   119,     0,     0,     0,     0,     0,     0,
       0,     0,   705,     0,  1048,    56,  1048,     0,     0,  1235,
    1460,     0,   705,     0,     0,     0,   749,     0,   857,     0,
      57,     0,     0,     0,     0,     0,     0,     0,     0,  1457,
       0,     0,     0,  1457,  1457,     0,  1048,  1048,     0,     0,
       0,     0,   127,     0,     0,     0,     0,     0,    58,     0,
       0,     0,   128,     0,   129,   130,    59,     0,    60,    61,
      62,    63,    64,     0,     0,    65,    66,  1501,  2207,  1169,
       0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
    1460,     0,     0,   749,     0,   749,     0,     0,     0,   140,
       0,   141,   142,     0,     0,     0,  1235,   145,     0,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     148,     0,   149,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1457,   152,     0,   153,
       0,     0,   156,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   157,     0,   158,     0,     0,
       0,   159,     0,     0,  1235,     0,     0,   160,     0,     0,
       0,     0,     0,     0,   705,   162,     0,   164,     0,     0,
       0,     0,     0,   166,     0,     0,     0,     0,   705,   705,
       0,     0,  1824,     0,     0,     0,     0,     0,   170,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,     0,     0,     0,     0,     0,
       0,  1460,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1235,     0,     0,  1460,     0,
     705,  1235,     0,     0,     0,     0,     0,     0,     0,  1460,
       0,     0,     0,   185,   186,     0,     0,     0,  1235,   187,
       0,     0,     0,  1235,     0,     0,     0,     0,     0,     0,
       0,   188,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   193,     0,     0,     0,  1235,  1235,  1235,     0,
       0,  1235,     0,     0,     0,     0,     0,     0,     0,  1235,
    1235,  1235,  1235,     0,     0,     0,     0,   857,     0,     0,
       0,     0,  1235,   857,     0,  1235,     0,  1235,     0,     0,
       0,     0,   203,     0,     0,     0,     0,     0,  1235,  1235,
       0,     0,  1235,     0,   205,     0,     0,     0,     0,   206,
     207,     0,   208,     0,     0,     0,  1235,   209,  1235,     0,
    1235,     0,   210,     0,     0,   212,     0,     0,     0,     0,
     214,     0,     0,     0,     0,   215,   216,     0,     0,     0,
    1235,     0,     0,   217,     0,     0,     0,   219,     0,     0,
       0,  1235,     0,  1235,  1235,  1235,     0,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
       0,     0,     0,     0,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,     0,
     231,  1235,     0,     0,     0,     0,     0,     0,   233,     0,
       0,     0,     0,     0,   234,     0,  1235,     0,     0,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1235,     0,   238,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   248,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   249,     0,  1460,
       0,  -147,  1460,     0,  1460,     0,     0,     0,     0,  1460,
       0,     0,     0,   705,     0,     0,     0,     0,   749,     0,
     749,     0,     0,   749,     0,   749,     0,     0,   749,   749,
     749,     0,     0,  1235,  2250,     0,     0,     0,     0,     0,
       0,   749,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   749,     0,   749,     0,     0,
       0,  1460,   749,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1460,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1460,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   857,   857,
     857,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1460,     0,  1460,     0,     0,   857,     0,     0,
       0,     0,     0,     0,     0,  2391,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   749,   749,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   705,     0,     0,     0,     0,   705,   705,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1460,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1460,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1460,     0,
       0,     0,   857,  1460,     0,     0,     0,     0,     0,     0,
       0,     0,   749,     0,   705,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1460,  1092,     0,     0,     0,     0,     0,     0,
       0,  1092,     0,  1092,     0,     0,     0,     0,     0,     0,
    1460,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1460,     0,   705,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   705,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   705,     0,     0,
     705,   705,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,  1460,     0,     0,
       0,     0,     0,  1235,     0,     0,     0,     0,     0,  1235,
       0,  1235,     0,     0,  1235,     0,     0,     0,  1460,  1235,
    1235,  1235,  1235,     0,     0,  1235,  1235,  1235,  1235,  1235,
    1235,  1235,  1235,  1235,  1235,     0,     0,     0,  1235,  1235,
     705,     0,     0,  1460,     0,     0,     0,     0,  1235,     0,
       0,     0,  1235,     0,   857,     0,  1235,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,  1235,     0,  1235,
       0,     0,     0,     0,     0,     0,     0,  1460,  1235,     0,
       0,  1235,  1235,     0,     0,     0,  1235,  1235,     0,     4,
       0,     0,     0,  1235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1235,     0,  1235,     0,     0,     0,     5,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,     6,
       7,     0,     0,  1235,  1235,  1235,     9,    10,     0,     0,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,     0,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,     0,     0,     0,    45,
       0,     0,     0,  1235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1460,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,     0,
       0,    46,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   749,     0,   749,     0,     0,     0,   749,
       0,   749,     0,     0,   749,     0,     0,     0,   749,     0,
       0,     0,     0,  2391,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    47,     0,   857,     0,     0,     0,
       0,   857,  1460,   857,     0,     0,     0,     0,     0,     0,
       0,     0,    48,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    49,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    50,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2250,     0,     0,     0,     0,
       0,     0,  3201,    51,     0,     0,    52,  1238,  1240,     0,
       0,  1243,  2531,  1245,     0,     0,     0,     0,     0,     0,
       0,    53,     0,     0,     0,     0,     0,     0,     0,     0,
    1235,     0,     0,  1296,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1358,     0,     0,  1460,  1361,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1385,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      54,     0,     0,     0,     0,     0,  1460,  1235,  1235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   705,     0,  1231,     0,   705,     0,     0,
       0,     0,     0,  3285,  1231,  1824,    55,     0,   749,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    56,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    57,     0,     0,     0,
    1231,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,   705,     0,     0,     0,     0,     0,
       0,     0,     0,  1235,    58,     0,     0,     0,     0,     0,
       0,     0,    59,     0,    60,    61,    62,    63,    64,     0,
       0,    65,    66,  1501,  2967,     0,     0,     0,    71,     0,
       0,     0,     0,  1235,     0,     0,     0,     0,     0,  1231,
       0,     0,     0,  1235,  1235,  1458,  1460,     0,     0,  1231,
    1235,  1235,     0,     0,     0,  1235,  1460,     0,     0,     0,
    1235,     0,     0,  1235,  1235,     0,  1458,     0,  1235,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,     0,     0,  1235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,  1235,     0,     0,     0,     0,     0,  1235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   705,     0,     0,
       0,     0,     0,     0,     0,   705,     0,   705,     0,     0,
       0,     0,     0,     0,     0,  1235,     0,     0,     0,     0,
       0,  1231,  1231,     0,     0,     0,     0,     0,  1092,     0,
       0,     0,  1092,  1460,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1946,  1947,
       0,     0,     0,     0,     0,   857,     0,     0,  1231,     0,
       0,     0,     0,     0,  1460,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1460,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   857,
    1460,     0,     0,  1235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2049,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1460,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2072,  2073,     0,
       0,     0,     0,     0,     0,  1235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1235,     0,  2106,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1092,  1092,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1231,  1460,     0,  1460,     0,     0,     0,  1458,     0,     0,
       0,  1231,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   749,  2250,     0,     0,     0,  1458,  2176,  2178,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   705,
       0,  1458,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,  1460,     0,
       0,     0,     0,  1235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1231,
    1235,  1235,     0,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,  1235,     0,     0,     0,     0,  1235,     0,
       0,  1235,  1235,     0,     0,     0,     0,     0,     0,  1235,
    1235,     0,     0,  1458,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1460,
       0,     0,     0,     0,     0,     0,  1231,     0,     0,  1235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   857,     0,     0,  2531,
       0,     0,  1235,     0,   705,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1458,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1231,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1235,     0,  1460,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1235,  1460,
       0,  1235,     0,  1235,     0,     0,     0,     0,     0,     0,
       0,  1231,  1231,  1231,     0,  1231,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,     0,
       0,  1235,     0,     0,     0,  1231,     0,  1460,     0,     0,
       0,     0,  1235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   857,     0,  1231,
       0,     0,     0,  1460,     0,     0,     0,  1460,  1460,     0,
       0,     0,  1235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1231,
       0,     0,     0,  1231,  1231,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2691,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1460,
    1460,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1458,     0,     0,     0,     0,     0,     0,
       0,     0,  1235,     0,     0,  1235,     0,     0,     0,  1092,
    2762,  2763,  2764,  2765,  1235,     0,     0,     0,     0,  1235,
       0,  1235,     0,  1235,     0,     0,     0,     0,     0,     0,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1235,     0,     0,
    1092,     0,     0,     0,  2803,  2804,     0,     0,  1458,     0,
       0,     0,     0,  2816,     0,     0,     0,     0,   857,     0,
       0,     0,     0,  2828,     0,     0,     0,     0,   705,     0,
       0,     0,     0,   705,     0,     0,     0,     0,     0,     0,
       0,     0,  1458,     0,     0,     0,     0,     0,     0,     0,
       0,  2864,  2865,  2866,  2867,     0,     0,     0,     0,     0,
       0,  1235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,  1235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   749,  1458,  1235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1458,
       0,     0,     0,     0,     0,     0,     0,  1458,  2950,     0,
       0,  2953,     0,     0,     0,     0,     0,     0,  1458,     0,
       0,  2958,     0,     0,     0,     0,     0,     0,     0,     0,
    2966,     0,     0,  1235,     0,     0,     0,     0,     0,  1235,
    1235,     0,  1235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1235,     0,     0,     0,  1458,     0,     0,     0,     0,
       0,     0,     0,     0,   705,     0,     0,     0,  1231,     0,
       0,     0,     0,     0,  1458,     0,     0,   857,     0,     0,
    1231,     0,     0,     0,     0,     0,  1458,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1458,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,  1235,     0,     0,  1458,     0,
     857,  1458,     0,     0,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   857,
    1235,  1235,     0,     0,     0,     0,     0,     0,     0,  3137,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1231,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1231,  1231,     0,     0,     0,     0,  1231,  1231,
       0,     0,     0,     0,     0,  1231,  1231,  1231,     0,     0,
       0,  1231,     0,  1231,  1231,  1231,  1231,  1231,  1231,     0,
    1231,  3285,  1231,  1231,     0,     0,  1231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1458,  1231,  1231,  1231,  1231,     0,     0,     0,     0,  1231,
       0,     0,     0,  1231,     0,     0,  1231,     0,     0,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,     0,  1231,
       0,     0,     0,     0,     0,     0,     0,  1231,     0,     0,
    1231,    86,    87,    88,     0,    90,    91,    92,     0,     0,
       0,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,     0,     0,     0,   107,   108,   109,   110,
       0,   111,   112,   113,   114,     0,   115,   116,   117,     0,
       0,     0,     0,     0,   120,   121,     0,     0,     0,     0,
     122,     0,   705,     0,     0,     0,     0,     0,     0,   123,
       0,   124,     0,   125,  1231,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,  1231,     0,
       0,     0,     0,     0,   705,     0,     0,  1231,  1231,     0,
       0,     0,     0,     0,  1459,     0,     0,     0,     0,     0,
       0,  3359,  3360,     0,     0,     0,     0,     0,     0,     0,
    3371,     0,  3373,   132,     0,  1459,  3377,   134,   135,   136,
     137,   138,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   139,     0,     0,     0,     0,     0,     0,
     143,     0,   144,     0,     0,     0,     0,     0,   147,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     150,     0,     0,     0,  1458,     0,     0,   151,  1458,  1458,
       0,     0,     0,     0,     0,     0,     0,   154,   155,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,     0,     0,
       0,     0,     0,   163,     0,     0,  1231,   165,     0,     0,
       0,     0,     0,   167,     0,  3498,     0,     0,  1231,   168,
       0,   169,  1458,     0,     0,  1231,     0,   171,     0,   172,
       0,     0,     0,     0,  1458,     0,     0,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   175,   176,     0,     0,     0,     0,     0,   177,  1092,
     178,     0,     0,   179,   180,     0,   181,     0,     0,     0,
       0,     0,     0,  3559,  1458,   182,   183,     0,   184,     0,
       0,  3568,     0,  3570,     0,     0,     0,     0,     0,  3572,
       0,     0,     0,     0,     0,     0,     0,     0,   705,     0,
       0,   189,   190,   191,     0,     0,   192,     0,     0,     0,
     194,     0,     0,   195,     0,   196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1092,     0,   197,
     198,     0,   199,   200,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   201,     0,   202,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     204,  3647,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,     0,     0,     0,   213,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   218,     0,     0,   220,     0,     0,   221,     0,
       0,     0,     0,     0,     0,     0,     0,  3706,     0,  3708,
       0,     0,   223,     0,     0,     0,  1459,     0,   225,     0,
    1231,  1458,     0,     0,     0,   226,   227,     0,     0,     0,
       0,   228,     0,   229,     0,     0,  1459,     0,     0,     0,
       0,     0,   232,     0,  2531,     0,     0,     0,     0,     0,
    1459,     0,     0,     0,     0,     0,     0,   236,     0,     0,
     237,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   239,   240,   241,   242,
     243,   244,   245,   246,   247,     0,     0,     0,     0,     0,
       0,  1458,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1231,     0,     0,
       0,  3275,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3775,     0,     0,     0,     0,     0,
       0,   705,  1459,     0,     0,     0,     0,     4,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     5,     0,     0,
       0,     0,     0,     0,     0,  1231,     0,     6,     7,     0,
     705,     0,     0,     0,     9,    10,     0,     0,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,     0,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,     0,     0,     0,    45,     0,     0,
       0,     0,  1458,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1231,     0,     0,  1458,
       0,     0,  1231,     0,     0,     0,     0,     0,     0,     0,
    1458,     0,     0,     0,     0,     0,     0,     0,     0,  1231,
       0,     0,     0,  1459,  1231,     0,     0,     0,     0,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1231,  1231,  1231,
       0,     0,  1231,     0,     0,     0,     0,     0,     0,     0,
    1231,  1231,  1231,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1231,     0,     0,  1231,     0,  1231,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1231,
    1231,     0,     0,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,    47,     0,     0,     0,     0,  1231,     0,  1231,
       0,  1231,     0,     0,     0,     0,     0,     0,     0,     0,
      48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1231,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    49,  1231,     0,  1231,  1231,  1231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    50,     0,     0,     0,     0,  1231,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1231,     0,     0,     0,     0,     0,     0,  4022,
       0,  4023,  4024,  4025,     0,     0,   749,  1231,     0,     0,
       0,    51,     0,     0,    52,     0,     0,     0,     0,     0,
       0,  1231,     0,     0,     0,     0,     0,     0,     0,    53,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   705,
    1458,     0,     0,  1458,     0,  1458,     0,     0,     0,     0,
    1458,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   960,     0,     0,     0,
       0,     0,     0,     0,  1231,   960,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    54,     0,
       0,     0,  2560,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1458,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   960,     0,     0,  1458,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    55,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1458,     0,     0,     0,     0,    56,
       0,  1149,     0,     0,     0,     0,     0,  2560,     0,     0,
       0,  1149,     0,     0,    57,     0,     0,     0,     0,     0,
       0,     0,     0,  4170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1459,    58,     0,     0,     0,     0,     0,     0,     0,
      59,     0,    60,    61,    62,    63,    64,     0,     0,    65,
      66,  1501,     0,  1458,     0,  1458,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1459,     0,     0,  1458,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1459,     0,
       0,     0,     0,     0,     0,     0,  2560,     0,   705,     0,
       0,  1458,     0,     0,     0,     0,     0,  1459,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4331,     0,  4332,  1458,
       0,     0,  4334,     0,  1458,     0,     0,     0,     0,     0,
       0,     0,  1199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1459,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1459,     0,     0,     0,     0,     0,     0,
     705,     0,     0,     0,     0,  1459,     0,     0,     0,  4366,
       0,     0,     0,  1458,     0,     0,     0,  1459,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1458,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1458,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1459,     0,     0,
    1459,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1231,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1231,     0,     0,  1458,     0,
       0,     0,     0,     0,  1231,     0,     0,     0,     0,     0,
    1231,     0,  1231,     0,     0,  1231,     0,     0,     0,  1458,
    1231,  1231,  1231,  1231,     0,     0,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,     0,     0,     0,  1231,
    1231,     0,     0,     0,  1458,     0,     0,     0,     0,  1231,
       0,     0,     0,  1231,     0,     0,     0,  1231,     0,  1459,
       0,     0,     0,     0,     0,  1231,     0,     0,  1231,     0,
    1231,     0,     0,     0,     0,     0,     0,     0,  1458,  1231,
       0,     0,  1231,  1231,     0,     0,     0,  1231,  1231,     0,
       0,     0,   960,   960,  1231,     0,     0,     0,     0,  3199,
       0,     0,     0,     0,  1231,     0,  1231,     0,     0,     0,
       0,     0,  4564,  4565,  4566,  4567,     0,     0,  1231,     0,
       0,     0,     0,     0,  1231,  1231,  1231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1231,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1231,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1458,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1231,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1246,     0,  3297,     0,     0,     0,  2560,  3303,  1279,
       0,     0,  1283,  1284,     0,  1287,     0,     0,  1293,     0,
    1295,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4693,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1356,     0,     0,  1458,     0,     0,     0,     0,  1364,     0,
       0,     0,     0,     0,     0,  1376,     0,     0,  1381,  1382,
       0,     0,     0,  1384,     0,     0,     0,     0,     0,     0,
       0,  1459,     0,     0,     0,     0,     0,     0,     0,     0,
    1199,     0,   960,  1459,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1417,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1479,     0,  1483,     0,     0,  1485,
       0,  1487,     0,  1459,  1491,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   960,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1231,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1458,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1578,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1199,     0,     0,     0,  1458,  1231,  1231,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1149,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1459,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1231,     0,     0,     0,     0,     0,
       0,  1842,     0,  1844,     0,     0,     0,  1846,     0,     0,
    2560,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1231,     0,     0,  1884,     0,     0,
       0,     0,     0,     0,  1231,  1231,     0,  1458,     0,     0,
       0,  1231,  1231,     0,     0,     0,  1231,  1458,     0,     0,
       0,  1231,     0,     0,  1231,  1231,     0,     0,     0,  1231,
       0,     0,     0,     0,     0,  1231,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1231,     0,     0,  2017,  1231,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1231,
       0,     0,     0,  2031,  1231,     0,     0,     0,     0,     0,
    1231,     0,     0,     0,     0,  2042,     0,  2043,     0,     0,
       0,     0,     0,     0,     0,  2046,     0,  1231,     0,     0,
       0,     0,     0,     0,     0,  4978,     0,  2052,     0,     0,
       0,  1459,  2061,     0,     0,  2065,     0,     0,     0,     0,
    4982,     0,     0,     0,     0,     0,  1231,     0,  1459,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1459,
       0,     0,     0,     0,  1458,     0,     0,     0,     0,  2110,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1458,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5036,     0,
       0,     0,     0,     0,     0,     0,  1458,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1458,     0,     0,  1231,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1458,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3199,  3199,  3199,  1231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1231,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2273,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1458,     0,  1458,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5162,
    5163,  5163,     0,     0,     0,     0,     0,     0,     0,  2560,
       0,     0,  3303,     0,  3303,     0,     0,     0,     0,  2560,
       0,     0,     0,     0,     0,  1231,     0,     0,     0,  1458,
       0,     0,     0,     0,  1231,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1231,  1231,     0,     0,  1231,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1231,
       0,  1459,     0,     0,  1231,     0,     0,     0,     0,  1231,
       0,     0,  1231,  1231,     0,     0,     0,     0,  1459,     0,
    1231,  1231,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1231,  2560,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5271,     0,  1149,  2453,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1458,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1231,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1459,     0,  1459,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2527,     0,     0,
    2527,     0,     0,     0,     0,     0,     0,     0,  2534,     0,
       0,     0,     0,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2543,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1459,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1231,     0,  1458,
    1459,     0,     0,  2633,     0,     0,     0,     0,     0,     0,
       0,     0,  5359,     0,  5361,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3303,  1231,
    1458,     0,  1231,  3303,  1231,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1231,     0,
       0,     0,  1231,     0,  2720,     0,     0,     0,  1458,     0,
       0,     0,     0,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1459,     0,     0,  1231,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3303,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1458,  1459,     0,     0,  1458,  1458,
       0,     0,     0,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5163,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1231,     0,     0,
       0,  2838,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1231,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5508,     0,     0,
    1458,  1458,     0,     0,     0,     0,     0,  1459,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1231,     0,     0,  1231,     0,  1459,     0,
       0,     0,     0,     0,     0,  1231,     0,     0,     0,     0,
    1231,     0,  1231,     0,  1231,     0,     0,     0,     0,     0,
       0,  1231,     0,  1459,     0,     0,     0,     0,     0,     0,
       0,  2935,     0,     0,     0,     0,     0,     0,  1231,     0,
       0,     0,     0,     0,     0,  2949,     0,  5558,  2952,     0,
    2954,     0,  2955,     0,     0,     0,     0,  1459,  2957,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1231,     0,     0,  3199,     0,     0,     0,  2988,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5607,  2453,     0,     0,     0,  2453,     0,  2453,     0,     0,
    2453,     0,     0,     0,     0,  1231,  1231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2560,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1231,     0,     0,     0,     0,     0,
    1231,  1231,     0,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1231,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3200,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3303,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1231,  1231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1231,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1231,  1231,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1459,  3312,  3313,
       0,     0,     0,  3316,  3317,     0,     0,     0,  3320,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3331,     0,     0,     0,     0,     0,     0,  3340,
       0,     0,     0,  3343,  3344,     0,     0,  3347,  3348,     0,
       0,     0,     0,     0,  3353,     0,  2560,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3370,     0,  3372,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3396,     0,
       0,     0,     0,  3398,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3403,     0,     0,     0,
       0,     0,     0,     0,     0,  3410,     0,  3412,     0,     0,
    3415,  3418,  3420,     0,     0,     0,     0,  3428,  3431,     0,
       0,     0,     0,     0,     0,     0,     0,  3444,     0,  1448,
       0,     0,  3453,     0,     0,     0,     0,  3457,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1448,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3492,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3499,     0,  3501,     0,     0,     0,
       0,  3504,     0,     0,     0,  3505,  1459,  3509,  3510,  3511,
    3512,     0,  3514,     0,     0,     0,  1459,     0,     0,     0,
       0,     0,     0,     0,     0,  3539,  3540,  3541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3549,  3550,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3199,     0,
       0,     0,     0,  3199,     0,     0,     0,     0,     0,  3199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3594,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1459,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1459,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1459,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3303,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1199,     0,     0,     0,     0,     0,     0,     0,
    1236,     0,     0,  1459,     0,  2453,     0,     0,     0,  1236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3760,     0,     0,     0,
       0,  1448,     0,     0,     0,  1236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1448,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1448,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5058,     0,  1459,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1236,     0,     0,     0,     0,     0,
    1461,     0,     0,     0,  1236,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1461,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1459,     0,
       0,     0,     0,     0,     0,     0,     0,  1448,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3944,
       0,     0,     0,     0,     0,     0,  1236,  1236,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,     0,     0,  3303,
       0,     0,     0,     0,     0,     0,     0,     0,  1448,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3993,  3994,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2453,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4015,     0,     0,     0,  4017,
       0,     0,     0,     0,     0,  4020,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4032,  4034,     0,     0,     0,  4034,     0,  3303,     0,
       0,  4045,  4046,  4047,     0,  4049,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4066,     0,     0,  1459,
       0,     0,     0,     0,     0,     0,  4072,  4073,  4074,  4075,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1236,     0,     0,     0,     0,
       0,     0,  1461,     0,     0,     0,  1236,  1459,     0,     0,
       0,     0,     0,  4092,     0,     0,  4097,  4098,  4099,     0,
       0,     0,  1461,     0,     0,     0,  4112,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1461,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1459,     0,     0,     0,  1459,  1459,     0,
       0,     0,     0,     0,  1236,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4163,     0,     0,
       0,     0,     0,     0,     0,  4167,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1448,  1461,     0,
       0,     0,     0,     0,  4179,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4222,     0,     0,     0,     0,     0,     0,     0,     0,  5058,
    1459,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1448,     0,     0,     0,     0,     0,     0,     0,
       0,  1236,     0,     0,  4259,     0,     0,     0,  4264,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1448,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4302,     0,     0,
       0,     0,     0,   960,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1461,
       0,     0,     0,     0,     0,  4323,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4333,
       0,     0,     0,  4335,     0,     0,     0,     0,     0,     0,
    1236,     0,     0,     0,     0,     0,     0,  2453,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1448,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,  1448,     0,     0,     0,     0,     0,     0,
       0,  1448,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1448,     0,     0,     0,  1236,  1236,  1236,     0,
    1236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1448,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1448,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1448,     0,     0,     0,  1236,     0,     0,     0,     0,     0,
       0,     0,  1448,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1236,     0,     0,     0,  1236,  1236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1448,     0,     0,  1448,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1461,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4558,     0,  4559,     0,     0,     0,
       0,     0,     0,     0,  4561,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4571,     0,  1461,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4579,     0,     0,
       0,     0,     0,     0,  1448,     0,     0,     0,     0,     0,
       0,  4592,     0,     0,     0,     0,     0,  1461,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4596,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4605,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4629,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4637,  4638,  4639,     0,     0,  4642,  4643,  4644,  4645,
    4646,  4647,     0,     0,     0,     0,  4654,  4655,     0,  4657,
    4658,  4659,  4660,  4661,  4662,     0,  4664,     0,     0,  1461,
       0,     0,     0,     0,     0,  4672,     0,  4674,  4675,     0,
       0,     0,     0,     0,  1461,     0,     0,     0,     0,     0,
       0,     0,  1461,     0,     0,     0,     0,     0,     0,     0,
    4034,     0,     0,  1461,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4694,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1461,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,     0,     0,  1461,
       0,     0,     0,     0,     0,  1236,     0,     0,  1448,     0,
       0,  1461,  1448,  1448,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1461,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,     0,     0,     0,  4034,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1461,     0,     0,  1461,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1448,     0,     0,     0,
       0,     0,     0,  2453,  2453,  2453,     0,     0,  1448,     0,
       0,     0,     0,     0,     0,  4792,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1673,
    1673,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1448,     0,
    1236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1751,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1236,  1236,     0,
       0,     0,     0,  1236,  1236,     0,     0,     0,     0,     0,
    1236,  1236,  1236,     0,     0,     0,  1236,     0,  1236,  1236,
    1236,  1236,  1236,  1236,     0,  1236,     0,  1236,  1236,     0,
       0,  1236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1461,  1236,  1236,  1236,  1236,
       0,     0,     0,     0,  1236,     0,     0,     0,  1236,     0,
       0,  1236,     0,     0,  1236,  1236,  1236,  1236,  1236,  1236,
    1236,  1236,  1236,     0,  1236,     0,     0,     0,     0,     0,
       0,     0,  1236,     0,     0,  1236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1448,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4929,     0,     0,     0,  4930,  4931,  4932,  4933,  1236,
       0,  4935,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,     0,     0,     0,
       0,     0,  1236,  1236,     0,  4949,  4950,  4951,     0,  4952,
       0,  4954,  4955,     0,     0,  1448,     0,     0,     0,     0,
       0,     0,     0,  4964,  4965,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4973,     0,     0,     0,     0,     0,
       0,  2453,  2453,     0,  2453,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4981,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1461,
       0,     0,     0,  1461,  1461,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5027,     0,     0,     0,
       0,  1236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,  1448,  1461,  5047,     0,
    1236,     0,     0,     0,     0,     0,     0,     0,     0,  1461,
       0,     0,     0,  1448,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1448,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5074,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1461,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2453,     0,  2302,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2453,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2316,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2334,
    2335,  2336,     0,  2339,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2381,     0,     0,     0,     0,     0,     0,
       0,  5178,     0,     0,     0,  1236,  1461,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5187,     0,     0,     0,     0,  5192,  5193,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2436,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1448,     0,     0,  1448,     0,  1448,
       0,     0,  5245,     0,  1448,     0,  1461,  2460,     0,     0,
       0,  2472,  2477,     0,     0,     0,     0,  5257,     0,     0,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4034,
       0,     0,     0,     0,     0,     0,  1448,     0,     0,  5289,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1448,     0,     0,     0,     0,     0,     0,
    1236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2453,     0,     0,     0,  1448,     0,
       0,     0,     0,     0,     0,  2453,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5325,     0,     0,     0,     0,     0,     0,  1461,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1236,     0,  5341,  1461,     0,     0,  1236,     0,     0,
    1450,     0,  5348,     0,     0,  1461,     0,  1448,     0,  1448,
       0,     0,     0,     0,  1236,     0,     0,     0,     0,  1236,
       0,  1450,     0,  2453,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1236,  1236,  1236,     0,     0,  1236,     0,     0,
       0,     0,     0,     0,     0,  1236,  1236,  1236,  1236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
    1448,  1236,     0,  1236,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1236,  1236,     0,     0,  1236,     0,
       0,     0,     0,     0,     0,  1448,     0,     0,     0,     0,
       0,     0,  1236,     0,  1236,     0,  1236,  4034,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1451,  1448,     0,     0,  1236,     0,  1448,     0,
       0,  2453,     0,     0,     0,     0,     0,  1236,     0,  1236,
    1236,  1236,     0,  1451,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1236,  5469,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1236,     0,     0,
    5481,     0,     0,     0,     0,     0,     0,  1448,     0,     0,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1448,  1236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5503,     0,     0,
    1448,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1461,     0,     0,  1461,     0,
    1461,     0,     0,     0,     0,  1461,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5553,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1461,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1448,     0,  1461,     0,     0,     0,     0,     0,
    5571,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1450,  1448,     0,     0,     0,     0,     0,  1461,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1450,     0,     0,     0,     0,     0,  1448,     0,
       0,     0,     0,     0,     0,     0,  1450,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3068,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3088,
       0,  3090,  1448,     0,  3102,  3105,  3110,     0,     0,     0,
       0,  3116,     0,     0,  3121,     0,     0,     0,  1461,     0,
    1461,     0,     0,     0,     0,     0,     0,     0,     0,  3128,
    3129,  3130,  3131,     0,     0,     0,     0,  3138,     0,     0,
       0,  3150,     0,     0,  3152,     0,     0,  3159,  3160,  3161,
    3162,  3163,  3164,  3165,  3166,  3167,     0,  3168,  1450,     0,
       0,     0,     0,     0,  1451,  1673,     0,     0,  3196,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1461,     0,     0,  1451,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1451,     0,
       0,     0,     0,     0,     0,     0,  1461,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1448,     0,     0,
       0,     0,  1751,     0,  1461,     0,     0,     0,     0,  1461,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2335,  2336,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1451,     0,     0,     0,     0,     0,     0,     0,     0,  1450,
       0,     0,     0,     0,     0,     0,     0,     0,  1461,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1461,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1448,     0,     0,
       0,  1461,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1453,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1453,     0,  3345,  1236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1451,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1236,     0,     0,  1461,     0,     0,     0,     0,     0,  1236,
       0,     0,     0,     0,     0,  1236,     0,  1236,     0,     0,
    1236,     0,     0,     0,  1461,  1236,  1236,  1236,  1236,     0,
       0,  1236,  1236,  1236,  1236,  1236,  1236,  1236,  1236,  1236,
    1236,     0,  1448,     0,  1236,  1236,     0,     0,     0,  1461,
       0,     0,     0,     0,  1236,     0,     0,     0,  1236,     0,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
    1236,     0,     0,  1236,     0,  1236,     0,     0,     0,     0,
       0,     0,     0,  1461,  1236,     0,     0,  1236,  1236,     0,
       0,  1448,  1236,  1236,     0,     0,     0,     0,     0,  1236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1236,
       0,  1236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,     0,     0,  1236,
    1236,  1236,     0,     0,     0,     0,     0,     0,  1450,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3586,  1236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1450,     0,     0,     0,     0,  1461,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,     0,     0,     0,
       0,  1448,     0,     0,     0,     0,     0,  1450,     0,     0,
       0,  1448,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1451,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1453,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1453,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1453,  1461,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1450,
       0,     0,     0,  3724,     0,  1451,     0,     0,     0,     0,
       0,     0,     0,     0,  1450,     0,     0,     0,     0,     0,
       0,     0,  1450,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1450,     0,     0,     0,     0,     0,  1451,
       0,     0,     0,     0,     0,     0,     0,     0,  1448,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1453,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1448,
    1450,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3780,     0,  1450,
    1448,     0,  3786,     0,     0,     0,  1236,     0,     0,     0,
       0,  1450,     0,     0,     0,  1448,     0,     0,     0,     0,
       0,  1451,  1454,  1450,     0,     0,     0,  2339,     0,     0,
       0,     0,     0,  1461,     0,     0,  1451,     0,  3110,     0,
    3110,  3110,     0,  1454,  1451,     0,     0,     0,     0,     0,
       0,  3844,     0,     0,  3847,  1451,  3849,     0,  1448,     0,
       0,     0,     0,  1450,     0,     0,  1450,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1461,  1236,  1236,  3867,     0,  3870,     0,  3872,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1453,     0,  1451,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1451,  3196,  3196,  3196,     0,     0,     0,     0,     0,
       0,     0,     0,  1451,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1451,     0,  3940,  1448,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2460,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,     0,     0,  2477,     0,     0,     0,  1236,
       0,     0,     0,     0,     0,  1451,     0,     0,  1451,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1448,     0,     0,     0,     0,     0,  1236,
       0,     0,     0,     0,     0,  1450,     0,     0,     0,  1236,
    1236,     0,  1461,     0,     0,     0,  1236,  1236,     0,     0,
       0,  1236,  1461,     0,     0,     0,  1236,     0,     0,  1236,
    1236,     0,     0,     0,  1236,     0,     0,     0,     0,     0,
    1236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4001,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1236,     0,     0,     0,     0,  1236,
       0,     0,     0,     0,     0,  1236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1448,     0,     0,  1451,     0,     0,
       0,  1236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1461,
       0,     0,     0,     0,  1454,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1453,
       0,     0,     0,     0,  1454,     0,     0,     0,     0,     0,
    1461,     0,     0,     0,     0,     0,     0,     0,  1454,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1461,     0,     0,     0,     0,     0,     0,     0,  1450,
       0,     0,     0,  1450,  1450,     0,  1461,     0,     0,  1236,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1448,  1453,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1461,
       0,     0,     0,     0,  1448,     0,     0,     0,  1453,     0,
    1454,     0,     0,     0,     0,     0,     0,  1450,     0,     0,
       0,  1236,     0,     0,     0,     0,     0,     0,     0,  1450,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1448,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1450,
       0,  1451,     0,     0,     0,  1451,  1451,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1461,     0,  1461,
    1453,     0,     0,     0,     0,     0,     0,     0,  1448,     0,
       0,     0,  1448,  1448,     0,  1453,     0,     0,     0,     0,
       0,     0,     0,  1453,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1453,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1451,
    1236,  1454,     0,     0,  1461,     0,     0,     0,     0,  1236,
       0,  1451,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1456,     0,     0,     0,  1236,  1236,     0,     0,
    1236,  1453,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1456,  1236,     0,     0,     0,     0,  1236,
    1453,  1451,     0,     0,  1236,  1448,     0,  1236,  1236,     0,
       0,     0,  1453,     0,     0,  1236,  1236,     0,     0,     0,
       0,     0,     0,     0,  1453,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1450,  1236,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1236,     0,  4370,     0,     0,     0,     0,     0,     0,
       0,     0,  4374,     0,  1453,     0,     0,  1453,  4375,     0,
    4376,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1461,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1236,     0,  4400,  4401,     0,
       0,     0,     0,     0,     0,     0,  1450,     0,     0,     0,
       0,     0,     0,     0,     0,  3116,     0,     0,     0,     0,
       0,     0,     0,  4426,     0,     0,  4429,     0,  4431,     0,
       0,     0,     0,     0,     0,     0,     0,  4435,  1236,     0,
       0,     0,     0,     0,     0,  4442,  4443,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1451,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4487,     0,     0,     0,
       0,     0,  4494,  4495,  3196,     0,     0,     0,     0,     0,
       0,     0,  1236,     0,  1461,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1453,     0,     0,     0,
       0,     0,     0,     0,  1236,  1461,     0,  1236,  1451,  1236,
    1454,     0,  4512,     0,     0,     0,     0,  1450,     0,     0,
       0,     0,     0,     0,     0,  1751,     0,     0,     0,     0,
       0,     0,     0,  1236,  1450,     0,     0,  1236,     0,     0,
       0,     0,     0,  1461,     0,  1450,     0,     0,  1236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1236,     0,     0,     0,     0,  1454,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1456,     0,     0,     0,     0,  1461,
       0,     0,     0,  1461,  1461,     0,     0,     0,  1236,  1454,
       0,     0,     0,     0,  1456,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1456,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1451,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1236,     0,     0,     0,  1451,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1451,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1454,     0,     0,     0,  1461,  1461,     0,     0,     0,
    1453,     0,     0,     0,  1453,  1453,  1454,     0,     0,     0,
    1456,     0,     0,     0,  1454,     0,     0,     0,  1236,     0,
       0,  1236,     0,     0,     0,  1454,     0,     0,     0,     0,
    1236,     0,     0,     0,     0,  1236,     0,  1236,     0,  1236,
       0,     0,     0,     0,     0,     0,  1236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,     0,  1453,     0,
       0,     0,  1454,     0,     0,     0,     0,     0,     0,     0,
    1453,     0,     0,     0,     0,  1450,     0,     0,  1450,     0,
    1450,  1454,     0,     0,     0,  1450,     0,     0,     0,     0,
       0,     0,     0,  1454,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1454,     0,     0,     0,     0,
    1453,     0,     0,     0,     0,     0,     0,  1236,     0,     0,
       0,     0,     0,     0,     0,     0,  4755,  4756,     0,     0,
       0,  1456,     0,     0,     0,     0,     0,  1450,     0,     0,
       0,     0,     0,     0,     0,  1454,     0,     0,  1454,     0,
    1236,  1236,     0,     0,  1450,     0,     0,     0,     0,     0,
       0,  1236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1450,
       0,  1236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1451,     0,     0,
    1451,     0,  1451,     0,     0,     0,     0,  1451,     0,     0,
       0,  4805,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4810,     0,     0,     0,     0,     0,     0,  1236,
       0,     0,     0,     0,     0,  1236,  1236,     0,  1236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1450,     0,
    1450,     0,     0,     0,     0,     0,     0,  1236,     0,  1451,
       0,     0,  4825,  4827,     0,     0,     0,  1453,     0,  4831,
    4832,     0,     0,     0,  4833,     0,  1451,     0,     0,  4836,
       0,     0,  4839,  4840,     0,     0,     0,  4844,     0,     0,
       0,     0,     0,  4848,     0,     0,     0,  1454,     0,     0,
       0,  1451,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1450,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3196,     0,     0,
       0,     0,  3196,     0,     0,     0,  1450,  1453,  3196,     0,
    1236,  1236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1236,  1673,     0,     0,     0,     0,
       0,     0,     0,     0,  1450,     0,  1236,  1236,     0,  1450,
    1451,     0,  1451,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4910,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1456,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1450,     0,
       0,     0,     0,  1451,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1450,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1451,     0,
       0,  1450,     0,     0,     0,     0,     0,     0,  1453,     0,
       0,     0,  4970,     0,     0,  1456,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1453,  1451,     0,     0,     0,
       0,  1451,     0,     0,     0,     0,  1453,     0,     0,     0,
       0,  1454,     0,     0,     0,  1454,  1454,     0,     0,  1456,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5004,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1451,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1450,     0,     0,     0,     0,  1451,  1454,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1454,     0,  1451,  1450,     0,     0,     0,     0,     0,
       0,  1456,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1456,     0,     0,  1450,
       0,     0,     0,     0,  1456,     0,     0,     0,     0,     0,
       0,  1454,     0,     0,     0,  1456,     0,     0,     0,     0,
       0,     0,     0,     0,  2375,     0,     0,     0,     0,     0,
       0,     0,     0,  1450,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1456,     0,     0,     0,     0,     0,     0,  5100,
    5101,     0,     0,  5102,     0,  1451,     0,     0,     0,     0,
       0,  1456,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1456,     0,     0,  1451,     0,     0,     0,
       0,     0,  2375,     0,     0,  1456,     0,     0,  5136,  5137,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1451,     0,     0,     0,     0,  1453,     0,     0,  1453,
       0,  1453,     0,     0,     0,     0,  1453,     0,     0,     0,
       0,     0,     0,     0,     0,  1456,     0,     0,  1456,     0,
       0,     0,     0,     0,     0,  1451,     0,     0,  1450,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1454,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1453,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1453,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1453,     0,     0,     0,     0,     0,     0,     0,  1454,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1450,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1451,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1456,     0,  1453,
       0,  1453,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5307,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2339,  1453,     0,     0,     0,     0,     0,     0,  1454,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1451,     0,     0,  1751,     0,     0,  1454,  1453,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1454,     0,     0,
       0,     0,     0,  1450,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1453,     0,     0,     0,     0,
    1453,  5356,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1450,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1453,
       0,     0,     0,     0,     0,     0,  5407,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1453,     0,     0,
       0,  1456,     0,     0,     0,  1456,  1456,     0,     0,     0,
       0,     0,  1453,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1451,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5136,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2375,     0,     0,     0,     0,  1456,
       0,     0,     0,     0,  1451,     0,  5470,     0,     0,     0,
       0,  1456,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1450,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1450,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1453,     0,     0,     0,     0,     0,
       0,  1456,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1453,     0,  1454,     0,     0,
    1454,     0,  1454,     0,     0,     0,     0,  1454,     0,     0,
       0,     0,     0,  2375,     0,     0,     0,     0,     0,     0,
    1453,     0,     0,     0,     0,     0,     0,  2375,     0,     0,
       0,  3098,     0,  5532,  5532,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5136,  2375,  2375,  2375,     0,     0,
    2375,     0,     0,     0,  1453,     0,     0,     0,     0,  1454,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1451,     0,  1454,     0,     0,     0,
       0,     0,     0,     0,  1451,     0,     0,     0,     0,  1450,
       0,     0,  2375,     0,     0,     0,     0,     0,     0,     0,
       0,  1454,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1450,  5532,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1456,     0,
    5603,  1450,     0,     0,     0,     0,     0,  2375,     0,     0,
       0,     0,     0,     0,     0,     0,  1450,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1454,  2375,  1454,     0,     0,     0,     0,     0,     0,  1453,
       0,     0,     0,  2375,     0,     0,     0,     0,  2375,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1450,
       0,     0,     0,     0,     0,     0,     0,     0,  1456,     0,
       0,  1451,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5532,  5644,     0,     0,     0,     0,     0,
       0,     0,     0,  1454,     0,     0,     0,     0,     0,     0,
       0,     0,  1451,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1454,     0,
       0,     0,     0,  1451,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1451,  1453,
       0,     0,     0,     0,     0,     0,  1454,     0,     0,  1450,
       0,  1454,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1451,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1456,
       0,     0,     0,     0,  1450,     0,     0,     0,     0,     0,
    1454,     0,     0,     0,     0,     0,  1456,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1456,  1454,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1454,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1451,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1453,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1451,     0,     0,     0,
       0,     0,     0,  1453,     0,  1450,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1454,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1454,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1454,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1454,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1450,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1451,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1456,     0,     0,
    1456,     0,  1456,  1453,     0,  1450,     0,  1456,     0,     0,
       0,     0,     0,  1453,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1450,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1456,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1456,     0,     0,     0,
    1454,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1451,     0,     0,  1450,
       0,  1456,     0,  1450,  1450,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1451,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1453,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1451,     0,     0,     0,  2375,
    1456,  1453,  1456,     0,     0,     0,     0,     0,     0,     0,
    1454,     0,     0,     0,     0,     0,     0,     0,     0,  2375,
       0,  2375,  1453,     0,  3098,  3098,  1450,  3821,     0,  3098,
       0,     0,     0,  2375,     0,     0,  2375,  1453,     0,     0,
       0,  2375,     0,     0,     0,     0,     0,  2375,     0,     0,
       0,  1451,  2375,     0,     0,  1451,  1451,     0,     0,  2375,
    2375,  2375,  2375,  1456,     0,     0,  3098,  3098,     0,  2375,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1453,  2375,     0,  2375,     0,     0,     0,     0,  1456,     0,
    2375,  2375,  2375,  2375,  2375,  2375,  2375,  2375,  2375,  2375,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1456,     0,     0,     0,
       0,  1456,     0,     0,     0,     0,     0,  2375,     0,     0,
       0,     0,     0,     0,     0,     0,    86,    87,    88,     0,
      90,    91,    92,     0,     0,     0,    95,     0,  1451,    98,
      99,   100,   101,   102,   103,  1454,   104,   105,     0,     0,
       0,   107,   108,   109,   110,     0,   111,   112,   113,   114,
    1453,   115,   116,   117,     0,     0,     0,     0,     0,     0,
    1456,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1456,     0,
      35,     0,     0,     0,  1454,     0,     0,     0,    41,    42,
       0,     0,     0,  1456,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1453,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   132,     0,
       0,     0,   134,   135,   136,   137,   138,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   139,     0,
       0,     0,     0,     0,     0,   143,  2375,   144,     0,     0,
       0,     0,     0,   147,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   150,     0,     0,     0,     0,
       0,     0,   151,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   154,   155,     0,  1456,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1456,     0,     0,     0,
     161,     0,     0,     0,  1454,     0,     0,     0,   163,     0,
       0,     0,   165,     0,  1454,     0,  1453,     0,   167,     0,
       0,  1456,     0,     0,   168,     0,   169,     0,     0,     0,
       0,     0,   171,     0,   172,     0,     0,     0,     0,     0,
       0,     0,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1456,   175,   176,     0,     0,
       0,     0,     0,   177,     0,   178,     0,     0,   179,   180,
       0,   181,     0,     0,     0,     0,     0,     0,     0,     0,
     182,   183,     0,   184,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   189,   190,   191,     0,
       0,   192,     0,     0,     0,   194,     0,     0,   195,     0,
     196,     0,     0,     0,     0,  1453,     0,     0,     0,     0,
       0,     0,     0,     0,   197,   198,     0,   199,   200,     0,
       0,  1454,     0,     0,     0,     0,     0,     0,     0,     0,
     201,     0,   202,     0,     0,     0,  1453,     0,     0,     0,
       0,     0,     0,     0,     0,   204,     0,     0,     0,     0,
       0,     0,  1454,     0,     0,     0,     0,  2375,     0,     0,
    1456,     0,     0,     0,     0,   211,     0,     0,     0,   213,
       0,     0,     0,  1454,  1453,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   218,  1454,     0,
     220,     0,     0,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   223,     0,     0,
       0,     0,     0,   225,     0,     0,     0,     0,     0,     0,
     226,   227,     0,     0,     0,     0,   228,     0,   229,     0,
    1453,  1454,     0,     0,  1453,  1453,     0,   232,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,     0,     0,   237,     0,     0,     0,     0,
    1456,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2375,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1454,     0,     0,     0,     0,     0,  1453,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2375,     0,     0,     0,     0,     0,  2375,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3821,  3821,     0,  1454,  3098,  3098,  3098,
    3098,     0,     0,  3098,  3098,  3098,  3098,  3098,  3098,  3098,
    3098,  3098,  3098,  3821,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1456,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2375,     0,     0,  2375,     0,
    2375,     0,     0,  3821,  3821,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2375,  3098,
    3098,  2375,     0,  2375,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1456,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1454,     0,     0,
       0,  2375,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2375,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1456,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1456,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1454,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1454,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1454,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1456,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1454,     0,     0,     0,  1454,  1454,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1456,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3098,     0,
       0,     0,     0,  1456,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1456,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1454,     0,
       0,  1456,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1456,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2375,     0,     0,     0,  2375,  2375,  2375,     0,     0,
       0,     0,     0,  3821,  3821,  3821,  3821,     0,     0,     0,
       0,  3821,  3821,  3821,  3821,  3821,  3821,  3821,  3821,  3821,
    3821,  2375,  2375,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1456,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2375,     0,     0,
    2375,     0,  2375,     0,     0,     0,  2375,     0,     0,  3821,
    3821,     0,     0,  2375,  2375,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2375,     0,
       0,     0,     0,     0,     0,  2375,  2375,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2375,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1456,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1456,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1456,     0,     0,
       0,     0,     0,     0,     0,     0,  3821,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1456,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2375,  2375,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1456,     0,     0,     0,  1456,  1456,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2375,     0,     0,     0,
       0,  2375,  3098,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2375,     0,  2375,     0,
       0,     0,  2375,  2375,  2375,     0,     0,  2375,     0,     0,
    2375,  2375,     0,     0,     0,  2375,     0,     0,     0,  2375,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1456,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2375,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    85,     0,
       0,    86,    87,    88,    89,    90,    91,    92,    93,     0,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   106,     0,     0,   107,   108,   109,   110,
       0,   111,   112,   113,   114,     0,   115,   116,   117,   118,
     119,  2375,     0,     0,   120,   121,     0,     0,     0,     0,
     122,     0,     0,     0,     0,     0,     0,     0,     0,   123,
       0,   124,     0,   125,   126,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,  2375,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   127,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   128,
       0,   129,   130,     0,     0,     0,     0,     0,     0,     0,
       0,   131,     0,   132,     0,     0,   133,   134,   135,   136,
     137,   138,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   139,     0,     0,   140,     0,   141,   142,
     143,     0,   144,     0,   145,     0,   146,     0,   147,     0,
       0,     0,     0,     0,     0,  3821,  3098,   148,     0,   149,
     150,     0,     0,     0,     0,     0,     0,   151,     0,     0,
       0,  2375,  2375,  2375,   152,     0,   153,   154,   155,   156,
       0,     0,     0,     0,     0, -1519,     0,     0,     0,     0,
       0,     0,   157,     0,   158,     0,     0,     0,   159,     0,
       0,     0,     0,     0,   160,   161,     0,  2375,  2375,     0,
       0,     0,   162,   163,   164,     0,     0,   165,     0,     0,
     166,     0,     0,   167,     0,     0,     0,     0,     0,   168,
       0,   169,     0,     0,     0,   170,     0,   171,     0,   172,
       0,     0,     0,     0,     0,     0,     0,   173,     0,     0,
       0,   174,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   175,   176,     0,     0, -1519,     0,     0,   177,     0,
     178,     0,     0,   179,   180,     0,   181,     0,     0,     0,
       0,     0,     0,     0,     0,   182,   183,     0,   184,     0,
     185,   186,     0,     0,     0,     0,   187,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   188,     0,
       0,   189,   190,   191,     0,     0,   192,     0,     0,   193,
     194,     0,     0,   195,     0,   196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   197,
     198,     0,   199,   200,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   201,     0,   202,     0,   203,
       0,     0,  3821,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,     0,     0,     0,   206,   207,  2375,   208,
       0,     0,     0,     0,   209,     0,     0,     0,     0,   210,
     211,     0,   212,     0,   213,     0,     0,   214,     0,     0,
       0,     0,   215,   216,     0,     0,     0,     0,     0,     0,
     217,     0,   218,     0,   219,   220,     0,     0,   221,     0,
       0,     0,     0,     0,   222,     0,     0,  2375,     0,     0,
       0,     0,   223,     0,     0,     0,   224,     0,   225,     0,
       0,     0,     0,     0,     0,   226,   227,     0,     0,     0,
       0,   228,     0,   229,     0,   230,     0,   231,     0,     0,
       0,     0,   232,     0,     0,   233,     0,     0, -1519,     0,
       0,   234,     0,     0,     0,     0,   235,   236,  2375,     0,
     237,     0,     0,     0,     0,     0,     0,     0,     0,   238,
       0,     0,     0,     0,     0,     0,   239,   240,   241,   242,
     243,   244,   245,   246,   247,     0,     0,     0,     0,     0,
     248,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   249,     0,     0,     0,  -147,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2375,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2375,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   759,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   760,   104,   105,
     714,   761,     0,   107,   108,   109,   110,   762,   763,   112,
     113,   114,     0,   115,   764,   765,   715,   716,     0,     0,
       0,   717,   718,     0,  2375,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2375,   431,   432,   433,   434,
     435,   436,   437,   438,   766,   439,   440,   441,   767,   768,
     769,   770,   771,   772,   773,   442,   443,   774,   444,   445,
     132,   446,   447,   448,   134,   135,   136,   137,   138,   775,
     449,   450,   451,   452,   453,   776,   777,   454,   455,   778,
     139,   456,   779,   457,   458,   459,   460,   143,   780,   144,
     781,   461,   462,   463,   464,   147,   465,   466,   782,   783,
     467,   468,   469,   470,   471,   472,   784,   150,   473,   474,
     785,   786,   787,   788,   151,   789,   790,   791,   476,   477,
     478,   479,   728,   480,   154,   155,   481,   792,   482,   793,
     483,   484,   485,   486,   487,   488,   794,   489,   490,   491,
     795,   796,   492,   493,   494,   495,   496,   797,   497,   498,
     499,   798,   500,   501,   502,   799,   503,   504,   505,   506,
     163,   507,   508,   509,   165,   800,   510,   801,   511,   512,
     167,   513,   802,   514,   803,   515,   168,   804,   169,   516,
     517,   518,   805,   519,   171,   806,   172,   520,   807,   521,
     522,   730,   523,   524,   173,   525,   526,   527,   528,   808,
     529,   530,   531,   532,   533,   534,   809,   535,   175,   176,
     810,   536,   537,   538,   811,   177,   812,   178,   813,   539,
     179,   180,   540,   181,   541,   542,   543,   544,   545,   814,
     815,   546,   182,   183,   547,   184,   816,   548,   549,   550,
     817,   818,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,   190,
     191,   565,   566,   192,   819,   567,   568,   194,   569,   820,
     195,   570,   196,   571,   572,   573,   821,   574,   822,   823,
     575,   576,   577,   824,   825,   578,   197,   198,   579,   199,
     200,   580,   581,   582,   583,   584,   585,   586,   587,   826,
     588,   589,   201,   590,   202,   591,   592,   593,   827,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,   828,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   829,   617,   618,   211,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
     830,   629,   630,   631,   632,   633,   831,   635,   636,   218,
     637,   638,   220,   639,   640,   221,   641,   832,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
     833,   653,   654,   834,   655,   225,   656,   657,   658,   659,
     660,   835,   226,   227,   836,   837,   662,   663,   228,   664,
     229,   838,   665,   666,   667,   668,   669,   670,   671,   839,
     840,   672,   673,   674,   675,   676,   841,   842,   677,   678,
     679,   680,   681,   843,   236,   844,   682,   237,   683,   684,
     685,   686,   845,   846,   687,   847,   848,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,    86,    87,    88,     0,    90,
      91,    92,     0,     0,     0,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,  1008,     0,     0,
     107,   108,   109,   110,     0,   111,   112,   113,   114,     0,
     115,   116,   117,     0,     0,     0,     0,     0,   120,   121,
       0,     0,     0,     0,   122,     0,     0,     0,     0,     0,
       0,     0,     0,   123,     0,   124,     0,   125,     0,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   132,     0,     0,
       0,   134,   135,   136,   137,   138,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   139,     0,     0,
       0,     0,     0,     0,   143,     0,   144,     0,     0,     0,
       0,     0,   147,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   150,     0,     0,     0,     0,     0,
       0,   151,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   154,   155,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   161,
       0,     0,     0,     0,     0,     0,     0,   163,     0,     0,
       0,   165,     0,     0,     0,     0,     0,   167,     0,     0,
       0,     0,     0,   168,     0,   169,     0,     0,     0,     0,
       0,   171,     0,   172,     0,     0,     0,     0,     0,     0,
       0,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   175,   176,     0,     0,     0,
       0,     0,   177,     0,   178,     0,     0,   179,   180,     0,
     181,     0,     0,     0,     0,     0,     0,     0,     0,   182,
     183,     0,   184,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   189,   190,   191,     0,     0,
     192,     0,     0,     0,   194,     0,     0,   195,     0,   196,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   197,   198,     0,   199,   200,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   201,
       0,   202,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   204,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,     0,     0,     0,   213,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   218,     0,     0,   220,
       0,     0,   221,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,     0,   225,     0,     0,     0,     0,     0,     0,   226,
     227,     0,     0,     0,     0,   228,     0,   229,     0,     0,
       0,     0,     0,     0,     0,     0,   232,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,     0,     0,   237,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     239,   240,   241,   242,   243,   244,   245,   246,   247,     0,
     759,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     760,   104,   105,   714,   761,  3277,   107,   108,   109,   110,
     762,   763,   112,   113,   114,     0,   115,   764,   765,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,   430,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,  1593,  1594,  1595,
      45,  1596,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,  3190,   439,   440,
     441,     0,     0,     0,     0,  1597,     0,     0,   442,   443,
       0,   444,   445,   132,   446,   447,   448,   134,  1598,   136,
    1599,  1600,     0,   449,   450,   451,   452,   453,  1601,  1602,
     454,   455,  1603,  1604,   456,     0,   457,   458,   459,   460,
    1605,     0,  1606,     0,   461,   462,   463,   464,   147,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
     150,   473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,
    1613,   476,   477,   478,   479,   728,   480,  1614,  1615,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,  3191,     0,   492,   493,  1429,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,  1616,   507,   508,   509,  1617,  1618,   510,
       0,   511,   512,  1619,   513,     0,   514,     0,   515,   168,
       0,   169,   516,   517,   518,     0,   519,  1620,     0,  1621,
     520,     0,   521,   522,   730,   523,   524,   173,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,   175,   176,     0,   536,   537,   538,  1432,  1622,     0,
    1623,     0,   539,   179,   180,   540,   181,   541,   542,   543,
     544,   545,     0,     0,   546,  1624,   183,   547,   184,     0,
     548,   549,   550,  1625,  1626,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,  1627,   190,  1628,   565,   566,   192,  1629,   567,   568,
     194,   569,  1630,  1631,   570,  1632,   571,   572,   573,     0,
     574,     0,     0,  1633,   576,   577,     0,     0,   578,   197,
     198,   579,   199,  1634,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,  1635,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
    1636,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
     211,   619,   620,   621,  1637,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,  1638,
     635,   636,   218,   637,   638,   220,   639,   640,  1639,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,  1640,     0,   653,   654,     0,   655,   225,   656,
     657,   658,   659,   660,     0,  1641,  1642,     0,     0,   662,
     663,  1643,   664,  1644,  1645,   665,   666,   667,   668,   669,
     670,   671,     0,  1646,   672,   673,   674,   675,   676,  1647,
       0,   677,   678,   679,   680,   681,   734,  1648,  3192,   682,
     237,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,   735,   694,   695,  1657,     0,
       0,     0,     0,     0,     0,  1658,  1659,  3193,     0,     0,
       0,     0,     0,     0,  1661,  3194,   759,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   760,   104,   105,   714,
     761,     0,   107,   108,   109,   110,   762,   763,   112,   113,
     114,     0,   115,   764,   765,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,   430,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,  1593,  1594,  1595,    45,  1596,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,  1597,     0,     0,   442,   443,     0,   444,   445,   132,
     446,   447,   448,   134,  1598,   136,  1599,  1600,     0,   449,
     450,   451,   452,   453,  1601,  1602,   454,   455,  1603,  1604,
     456,     0,   457,   458,   459,   460,  1605,     0,  1606,     0,
     461,   462,   463,   464,   147,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,     0,   150,   473,   474,     0,
    1607,  1608,  1609,  1610,  1611,  1612,  1613,   476,   477,   478,
     479,   728,   480,  1614,  1615,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,  1429,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,  1616,
     507,   508,   509,  1617,  1618,   510,     0,   511,   512,  1619,
     513,     0,   514,     0,   515,   168,     0,   169,   516,   517,
     518,     0,   519,  1620,     0,  1621,   520,     0,   521,   522,
     730,   523,   524,   173,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,   175,   176,     0,
     536,   537,   538,  1432,  1622,     0,  1623,     0,   539,   179,
     180,   540,   181,   541,   542,   543,   544,   545,     0,     0,
     546,  1624,   183,   547,   184,     0,   548,   549,   550,  1625,
    1626,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,  1627,   190,  1628,
     565,   566,   192,  1629,   567,   568,   194,   569,  1630,  1631,
     570,  1632,   571,   572,   573,     0,   574,     0,     0,  1633,
     576,   577,     0,     0,   578,   197,   198,   579,   199,  1634,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,  1635,   590,   202,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,  1636,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,   211,   619,   620,   621,
    1637,   622,   623,   624,   625,   626,   627,   733,   628,   216,
     629,   630,   631,   632,   633,  1638,   635,   636,   218,   637,
     638,   220,   639,   640,  1639,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,  1640,     0,
     653,   654,   224,   655,   225,   656,   657,   658,   659,   660,
       0,  1641,  1642,     0,     0,   662,   663,  1643,   664,  1644,
    1645,   665,   666,   667,   668,   669,   670,   671,     0,  1646,
     672,   673,   674,   675,   676,  1647,     0,   677,   678,   679,
     680,   681,  2337,  1648,     0,   682,   237,   683,   684,   685,
     686,     0,     0,   687,     0,   238,   688,   689,   690,   691,
     692,   693,   239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,   735,   694,   695,  1657,     0,   248,     0,     0,     0,
       0,  1658,  1659,     0,     0,     0,     0,     0,     0,     0,
    1661,  5319,   759,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   760,   104,   105,   714,   761,     0,   107,   108,
     109,   110,   762,   763,   112,   113,   114,     0,   115,   764,
     765,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,   430,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1593,
    1594,  1595,    45,  1596,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,  1597,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
    1598,   136,  1599,  1600,     0,   449,   450,   451,   452,   453,
    1601,  1602,   454,   455,  1603,  1604,   456,     0,   457,   458,
     459,   460,  1605,     0,  1606,     0,   461,   462,   463,   464,
     147,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,  1607,  1608,  1609,  1610,
    1611,  1612,  1613,   476,   477,   478,   479,   728,   480,  1614,
    1615,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,  1429,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,  1616,   507,   508,   509,  1617,
    1618,   510,     0,   511,   512,  1619,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,  1620,
       0,  1621,   520,     0,   521,   522,   730,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,  1432,
    1622,     0,  1623,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,  1624,   183,   547,
     184,     0,   548,   549,   550,  1625,  1626,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,  1627,   190,  1628,   565,   566,   192,  1629,
     567,   568,   194,   569,  1630,  1631,   570,  1632,   571,   572,
     573,     0,   574,     0,     0,  1633,   576,   577,     0,     0,
     578,   197,   198,   579,   199,  1634,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,  1635,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,  1636,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,  1637,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,  1638,   635,   636,   218,   637,   638,   220,   639,   640,
    1639,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,  1640,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,  1641,  1642,     0,
       0,   662,   663,  1643,   664,  1644,  1645,   665,   666,   667,
     668,   669,   670,   671,     0,  1646,   672,   673,   674,   675,
     676,  1647,     0,   677,   678,   679,   680,   681,   734,  1648,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,   694,   695,
    1657,     0,     0,     0,     0,     0,     0,  1658,  1659,     0,
       0,     0,     0,     0,     0,     0,  1661,  3100,   759,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   760,   104,
     105,   714,   761,     0,   107,   108,   109,   110,   762,   763,
     112,   113,   114,     0,   115,   764,   765,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,   430,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,  1593,  1594,  1595,    45,  1596,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,     0,
       0,     0,     0,  1597,     0,     0,   442,   443,     0,   444,
     445,   132,   446,   447,   448,   134,  1598,   136,  1599,  1600,
       0,   449,   450,   451,   452,   453,  1601,  1602,   454,   455,
    1603,  1604,   456,     0,   457,   458,   459,   460,  1605,     0,
    1606,     0,   461,   462,   463,   464,   147,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,   150,   473,
     474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,   476,
     477,   478,   479,   728,   480,  1614,  1615,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,  1429,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,  1616,   507,   508,   509,  1617,  1618,   510,     0,   511,
     512,  1619,   513,     0,   514,     0,   515,   168,     0,   169,
     516,   517,   518,     0,   519,  1620,     0,  1621,   520,     0,
     521,   522,   730,   523,   524,   173,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,   175,
     176,     0,   536,   537,   538,  1432,  1622,     0,  1623,     0,
     539,   179,   180,   540,   181,   541,   542,   543,   544,   545,
       0,     0,   546,  1624,   183,   547,   184,     0,   548,   549,
     550,  1625,  1626,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,  1627,
     190,  1628,   565,   566,   192,  1629,   567,   568,   194,   569,
    1630,  1631,   570,  1632,   571,   572,   573,     0,   574,     0,
       0,  1633,   576,   577,     0,     0,   578,   197,   198,   579,
     199,  1634,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,  1635,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,  1636,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,   211,   619,
     620,   621,  1637,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,  1638,   635,   636,
     218,   637,   638,   220,   639,   640,  1639,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
    1640,     0,   653,   654,     0,   655,   225,   656,   657,   658,
     659,   660,     0,  1641,  1642,     0,     0,   662,   663,  1643,
     664,  1644,  1645,   665,   666,   667,   668,   669,   670,   671,
       0,  1646,   672,   673,   674,   675,   676,  1647,     0,   677,
     678,   679,   680,   681,   734,  1648,     0,   682,   237,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,   735,   694,   695,  1657,     0,     0,     0,
       0,     0,     0,  1658,  1659,     0,     0,     0,     0,     0,
       0,     0,  1661,  4378,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,  1629,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  1637,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,  1646,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,  1657,     0,     0,     0,     0,     0,     0,  1658,
    1659,     0,     0,     0,     0,     0,     0,     0,  1661,  4449,
     759,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     760,   104,   105,   714,   761,     0,   107,   108,   109,   110,
     762,   763,   112,   113,   114,     0,   115,   764,   765,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,   132,   446,   447,   448,     0,  1422,   136,
    1423,  1424,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,  1425,  1426,   456,     0,   457,   458,   459,   460,
       0,     0,   144,     0,   461,   462,   463,   464,   147,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
     150,   473,   474,     0,     0,     0,     0,   151,     0,     0,
       0,   476,   477,   478,   479,   728,   480,  1427,  1428,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,  1429,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,     0,   507,   508,   509,     0,     0,   510,
       0,   511,   512,  1430,   513,     0,   514,     0,   515,   168,
       0,   169,   516,   517,   518,     0,   519,     0,     0,     0,
     520,     0,   521,   522,   730,   523,   524,   173,   525,   526,
     527,   528,  2546,   529,   530,   531,   532,   533,   534,     0,
     535,   175,  2547,     0,   536,   537,   538,  1432,  1433,     0,
    1434,     0,   539,   179,   180,   540,   181,   541,   542,   543,
     544,   545,     0,     0,   546,     0,   183,   547,   184,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,  1435,   190,  1436,   565,   566,     0,     0,   567,   568,
     194,   569,     0,     0,   570,  1437,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,  2549,
     198,   579,   199,     0,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,     0,   590,     0,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
    1438,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
     211,   619,   620,   621,     0,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,  2550,   637,   638,   220,   639,   640,  1440,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,     0,     0,   653,   654,     0,   655,   225,   656,
     657,   658,   659,   660,     0,  1441,  1442,     0,     0,   662,
     663,     0,   664,     0,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,     0,  1443,  2551,   682,
     237,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   735,   694,   695,     0,     0,
       0,     0,   759,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,  2658,    98,    99,   100,   101,
     102,   103,   760,   104,   105,   714,   761,     0,   107,   108,
     109,   110,   762,   763,   112,   113,   114,     0,   115,   764,
     765,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,     0,
    1422,   136,  1423,  1424,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,  1425,  1426,   456,     0,   457,   458,
     459,   460,     0,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,     0,   476,   477,   478,   479,   728,   480,  1427,
    1428,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,  1429,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,     0,   507,   508,   509,     0,
       0,   510,     0,   511,   512,  1430,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,     0,
       0,     0,   520,     0,   521,   522,   730,   523,   524,   173,
     525,   526,   527,   528,  2546,   529,   530,   531,   532,   533,
     534,     0,   535,   175,  2547,     0,   536,   537,   538,  1432,
    1433,     0,  1434,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,     0,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,  1435,   190,  1436,   565,   566,     0,     0,
     567,   568,   194,   569,     0,     0,   570,  1437,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,  2549,   198,   579,   199,     0,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,     0,   590,     0,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,  1438,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,  2550,   637,   638,   220,   639,   640,
    1440,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,     0,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,  1441,  1442,     0,
       0,   662,   663,     0,   664,     0,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,  1443,
    2551,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   735,   694,   695,
       0,     0,     0,     0,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,  3661,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,  1750,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,  1629,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  1637,   622,
     623,   624,   625,   626,   627,   733,   628,   216,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
     224,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,  1646,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
    2337,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,   238,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,  1657,     0,   248,     0,     0,     0,     0,  1658,
    1659,     0,     0,     0,     0,     0,     0,     0,  1661,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,  1595,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,   566,   192,  1629,   567,   568,   194,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,  1633,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  1637,   622,   623,   624,   625,   626,   627,
     733,   628,   216,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,   224,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,   669,   670,
     671,     0,  1646,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,  2337,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,   238,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,  1657,     0,   248,
       0,     0,     0,     0,  1658,  1659,     0,     0,     0,     0,
       0,     0,     0,  1661,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,  3106,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,  3107,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,  3108,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,  1629,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  1637,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,  3109,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,  1646,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,  1657,     0,     0,     0,     0,     0,     0,  1658,
    1659,     0,     0,     0,     0,     0,     0,     0,  1661,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,  1595,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,   566,   192,  1629,   567,   568,   194,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,  1633,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  1637,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,   669,   670,
     671,     0,  1646,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,  1657,     0,     0,
       0,     0,     0,     0,  1658,  1659,     0,     0,     0,     0,
       0,  2299,  3061,  1661,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,  1629,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  1637,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,  1646,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,  1657,     0,     0,     0,     0,     0,     0,  1658,
    1659,  1660,     0,     0,     0,     0,     0,     0,  1661,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,  1595,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,  1750,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,   566,   192,  1629,   567,   568,   194,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,  1633,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  1637,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,   669,   670,
     671,     0,  1646,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,  1657,     0,     0,
       0,     0,     0,     0,  1658,  1659,     0,     0,     0,     0,
       0,     0,     0,  1661,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,  2470,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,  1629,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  1637,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,  1646,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,  1657,     0,     0,     0,     0,     0,     0,  1658,
    1659,     0,     0,     0,     0,     0,     0,     0,  1661,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,  1595,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,  3107,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,   566,   192,  1629,   567,   568,   194,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,  1633,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  1637,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,   669,   670,
     671,     0,  1646,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,  1657,     0,     0,
       0,     0,     0,     0,  1658,  1659,     0,     0,     0,     0,
       0,     0,     0,  1661,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,  1629,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  1637,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,  1646,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,  4496,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,  1657,     0,     0,     0,     0,     0,     0,  1658,
    1659,     0,     0,     0,     0,     0,     0,     0,  1661,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,  1595,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,  4511,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,   566,   192,  1629,   567,   568,   194,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,  1633,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  1637,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,   669,   670,
     671,     0,  1646,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,  1657,     0,     0,
       0,     0,     0,     0,  1658,  1659,     0,     0,     0,     0,
       0,     0,     0,  1661,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,  5529,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,  5530,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,  1629,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  1637,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,  5531,   670,   671,     0,  1646,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,  1657,     0,     0,     0,     0,     0,     0,  1658,
    1659,     0,     0,     0,     0,     0,     0,     0,  1661,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,  1595,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,  5530,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,   566,   192,  1629,   567,   568,   194,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,  1633,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  1637,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,  5531,   670,
     671,     0,  1646,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,  1657,     0,     0,
       0,     0,     0,     0,  1658,  1659,     0,     0,     0,     0,
       0,     0,     0,  1661,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,  1629,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  1637,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,  1646,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,  1657,     0,     0,     0,     0,     0,     0,  1658,
    1659,     0,     0,     0,     0,     0,     0,     0,  1661,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,  1595,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,   566,   192,  1629,   567,   568,   194,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,  1633,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  1637,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,   669,   670,
     671,     0,  1646,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,  1657,     0,     0,
       0,     0,     0,     0,  2473,  2474,     0,     0,     0,     0,
       0,     0,     0,  1661,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,  1629,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  1637,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,  1646,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
    4817,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,  1657,     0,     0,     0,     0,     0,     0,  1658,
    1659,     0,     0,     0,     0,     0,     0,     0,  1661,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,  1595,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,  4826,   192,  1629,   567,   568,   194,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,  1633,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  1637,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,   669,   670,
     671,     0,  1646,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,  1657,     0,     0,
       0,     0,     0,     0,  1658,  1659,     0,     0,     0,     0,
       0,     0,     0,  1661,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,  5126,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  5127,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,  1629,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,  5128,  1637,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,  1646,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,  1657,     0,     0,     0,     0,     0,     0,  1658,
    1659,     0,     0,     0,     0,     0,     0,     0,  5129,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,  1595,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448, -2832,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,  5530,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524, -2832,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,     0,     0,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547, -2832,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,   566,   192,  1629,   567,   568,     0,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,  1633,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  1637,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638, -2832,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,  5531,   670,
     671,     0,  1646,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695, -2832,     0,     0,
       0,     0,     0,     0,  1658,  1659,     0,     0,     0,     0,
       0,     0,     0,  1661,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,     0,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  3092,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,     0,     0,     0,     0,     0,     0,     0,  3093,
    3094,     0,     0,     0,     0,     0,     0,     0,  3095,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,     0,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,   566,   192,     0,   567,   568,   194,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  3233,  3234,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,     0,     0,     0,
       0,     0,     0,     0,  3235,  3236,     0,     0,     0,     0,
       0,     0,     0,  3095,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1593,  1594,  1595,    45,  1596,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,  1597,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,  1598,   136,  1599,  1600,     0,   449,   450,   451,
     452,   453,  1601,  1602,   454,   455,  1603,  1604,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,  1614,  1615,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,  1616,   507,   508,
     509,  1617,  1618,   510,     0,   511,   512,  1619,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,  1621,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,  1432,  1622,     0,  1623,     0,   539,     0,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1627,   190,  1628,   565,   566,
     192,     0,   567,   568,   194,   569,  1630,  1631,   570,  1632,
     571,   572,   573,     0,   574,     0,     0,  1633,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1636,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,  3092,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,  1639,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1641,
    1642,     0,     0,   662,   663,  1643,   664,  1644,  1645,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,  1648,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,     0,     0,     0,     0,     0,     0,     0,  3093,
    3094,     0,     0,     0,     0,     0,     0,     0,  3095,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1593,  1594,     0,    45,
    1596,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,  1597,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,  1598,   136,  1599,
    1600,     0,   449,   450,   451,   452,   453,  1601,  1602,   454,
     455,  1603,  1604,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,  1614,  1615,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,  1429,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,  1616,   507,   508,   509,  1617,  1618,   510,     0,
     511,   512,  1619,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,  1621,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,  1432,  1622,     0,  1623,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
    1627,   190,  1628,   565,   566,   192,     0,   567,   568,   194,
     569,  1630,  1631,   570,  1632,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,  1636,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,  3092,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,  1639,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,  1641,  1642,     0,     0,   662,   663,
    1643,   664,  1644,  1645,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,  1648,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,     0,     0,     0,
     759,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,  3095,    98,    99,   100,   101,   102,   103,
     760,   104,   105,   714,   761,     0,   107,   108,   109,   110,
     762,   763,   112,   113,   114,     0,   115,   764,   765,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,   430,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,  1593,  1594,     0,
      45,  1596,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,  1597,     0,     0,   442,   443,
       0,   444,   445,   132,   446,   447,   448,   134,  1598,   136,
    1599,  1600,     0,  4411,   450,   451,   452,   453,  1601,  1602,
     454,   455,  1603,  1604,   456,     0,   457,   458,   459,   460,
    1605,     0,  1606,     0,   461,   462,   463,   464,   147,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
     150,   473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,
    1613,   476,   477,   478,   479,   728,   480,  1614,  1615,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,  1429,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,  1616,   507,   508,   509,  1617,  1618,   510,
       0,   511,   512,  1619,   513,     0,   514,     0,   515,   168,
       0,   169,   516,   517,   518,     0,   519,  1620,     0,  1621,
     520,     0,   521,   522,   730,   523,   524,   173,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,   175,   176,     0,   536,   537,   538,  1432,  1622,     0,
    1623,     0,   539,   179,   180,   540,   181,   541,   542,   543,
     544,   545,     0,     0,   546,  1624,   183,   547,   184,     0,
     548,   549,   550,  1625,  1626,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,  1627,   190,  1628,   565,   566,   192,     0,   567,   568,
     194,   569,  1630,  1631,   570,  1632,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
     198,   579,   199,  1634,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,  1635,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
    1636,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
     211,   619,   620,   621,  3092,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,  1638,
     635,   636,   218,   637,   638,   220,   639,   640,  1639,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,  1640,     0,   653,   654,     0,   655,   225,   656,
     657,   658,   659,   660,     0,  1641,  1642,     0,     0,   662,
     663,  1643,   664,  1644,  1645,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,  1647,
       0,   677,   678,   679,   680,   681,   734,  1648,     0,   682,
     237,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,   735,   694,   695,     0,     0,
       0,   759,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,  3095,    98,    99,   100,   101,   102,
     103,   760,   104,   105,   714,   761,     0,   107,   108,   109,
     110,   762,   763,   112,   113,   114,     0,   115,   764,   765,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,   430,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,  1593,  1594,
    1595,    45,  1596,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,     0,     0,     0,     0,  1597,     0,     0,   442,
     443,     0,   444,   445,   132,   446,   447,   448,     0,  1598,
     136,  1599,  1600,     0,   449,   450,   451,   452,   453,  1601,
    1602,   454,   455,  1603,  1604,   456,     0,   457,   458,   459,
     460,  1605,     0,  1606,     0,   461,   462,   463,   464,   147,
     465,   466,   726,     0,   467,   468,   469,   470,   471,   472,
       0,   150,   473,   474,     0,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,   476,   477,   478,   479,   728,   480,  1614,  1615,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,  1429,   495,
     496,     0,   497,   498,   499,     0,   500,     0,   502,     0,
     503,   504,   505,   506,  1616,   507,   508,   509,  1617,  1618,
     510,     0,   511,   512,  1619,   513,     0,   514,     0,   515,
     168,     0,   169,   516,   517,   518,     0,   519,  1620,     0,
    1621,   520,     0,   521,   522,   730,   523,   524,     0,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535,   175,   176,     0,   536,   537,   538,  1432,  1622,
       0,  1623,     0,   539,     0,     0,   540,   181,   541,   542,
     543,   544,   545,     0,     0,   546,  1624,   183,   547,     0,
       0,   548,   549,   550,  1625,  1626,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,  1627,   190,  1628,   565,   566,   192,  1629,   567,
     568,     0,   569,  1630,  1631,   570,  1632,   571,   572,   573,
       0,   574,     0,     0,  1633,   576,   577,     0,     0,   578,
     197,   198,   579,   199,  1634,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,  1635,   590,   202,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,  1636,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,   211,   619,   620,   621,  1637,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,   633,
    1638,   635,   636,   218,   637,   638,     0,   639,   640,  1639,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,  1640,     0,   653,   654,     0,   655,   225,
     656,   657,   658,   659,   660,     0,  1641,  1642,     0,     0,
     662,   663,  1643,   664,  1644,  1645,   665,   666,   667,   668,
     669,   670,   671,     0,  1646,   672,   673,   674,   675,   676,
    1647,     0,   677,   678,   679,   680,   681,   734,  1648,     0,
     682,   237,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,  1649,  1650,
    1651,  1652,  1653,  1654,  1655,  1656,   735,   694,   695,     0,
       0,     0,     0,     0,     0,     0,  1658,  1659,     0,     0,
       0,     0,     0,     0,     0,  1661,   759,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   760,   104,   105,   714,
     761,     0,   107,   108,   109,   110,   762,   763,   112,   113,
     114,     0,   115,   764,   765,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,   132,
     446,   447,   448,   134,   135,   136,   137,   138,     0,   449,
     450,   451,   452,   453,     0,  1602,   454,   455,   725,   139,
     456,     0,   457,   458,   459,   460,  1605,     0,  1606,     0,
     461,   462,   463,   464,   147,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,     0,   150,   473,   474,     0,
    1607,  1608,  1609,  1610,  1611,  1612,  1613,   476,   477,   478,
     479,   728,   480,   154,   155,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,   163,
     507,   508,   509,  1617,     0,   510,     0,   511,   512,   167,
     513,     0,   514,     0,   515,   168,     0,   169,   516,   517,
     518,     0,   519,  1620,     0,   172,   520,     0,   521,   522,
     730,   523,   524,   173,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,   175,   176,     0,
     536,   537,   538,     0,   177,     0,   178,     0,   539,   179,
     180,   540,   181,   541,   542,   543,   544,   545,  3890,     0,
     546,  1624,   183,   547,   184,     0,   548,   549,   550,  1625,
    1626,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,   189,   190,   191,
     565,   566,   192,     0,   567,   568,   194,   569,     0,  1631,
     570,   196,   571,   572,   573,     0,   574,     0,  1132,   575,
     576,   577,     0,     0,   578,   197,   198,   579,   199,  1634,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,  1635,   590,   202,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,   211,   619,   620,   621,
     213,  3891,   623,   624,   625,   626,   627,   733,   628,   216,
     629,   630,   631,   632,   633,  1638,   635,   636,   218,   637,
     638,   220,   639,   640,   221,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,  1640,     0,
     653,   654,   224,   655,   225,   656,   657,   658,   659,   660,
       0,   226,   227,     0,     0,   662,   663,  1643,   664,  1644,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,  1647,     0,   677,   678,   679,
     680,   681,  2337,   236,     0,   682,   237,   683,   684,   685,
     686,     0,     0,   687,     0,   238,   688,   689,   690,   691,
     692,   693,   239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,   735,   694,   695,     0,     0,   248,   759,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
    3892,    98,    99,   100,   101,   102,   103,   760,   104,   105,
     714,   761,     0,   107,   108,   109,   110,   762,   763,   112,
     113,   114,     0,   115,   764,   765,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
     132,   446,   447,   448,   134,   135,   136,   137,   138,     0,
     449,   450,   451,   452,   453,     0,  1602,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,  1605,     0,  1606,
       0,   461,   462,   463,   464,   147,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,     0,   150,   473,   474,
       0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,  1617,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,   168,     0,   169,   516,
     517,   518,     0,   519,  1620,     0,   172,   520,     0,   521,
     522,   730,   523,   524,   173,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,   175,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
     179,   180,   540,   181,   541,   542,   543,   544,   545,  3890,
       0,   546,  1624,   183,   547,   184,     0,   548,   549,   550,
    1625,  1626,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,   190,
     191,   565,   566,   192,     0,   567,   568,   194,   569,     0,
    1631,   570,   196,   571,   572,   573,     0,   574,     0,  1132,
     575,   576,   577,     0,     0,   578,   197,   198,   579,   199,
    1634,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,  1635,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,   211,   619,   620,
     621,   213,  3891,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,  1638,   635,   636,   218,
     637,   638,   220,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,  1640,
       0,   653,   654,     0,   655,   225,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,  1643,   664,
    1644,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,  1647,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,   237,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,  1649,  1650,  1651,  1652,  1653,  1654,
    1655,  1656,   735,   694,   695,     0,     0,     0,   759,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,  3892,    98,    99,   100,   101,   102,   103,   760,   104,
     105,   714,   761,     0,   107,   108,   109,   110,   762,   763,
     112,   113,   114,     0,   115,   764,   765,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,   132,   446,   447,   448,   134,   135,   136,   137,   138,
       0,   449,   450,   451,   452,   453,     0,  1602,   454,   455,
     725,   139,   456,     0,   457,   458,   459,   460,  1605,     0,
    1606,     0,   461,   462,   463,   464,   147,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,   150,   473,
     474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,   476,
     477,   478,   479,   728,   480,   154,   155,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,  1617,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,   168,     0,   169,
     516,   517,   518,     0,   519,  1620,     0,   172,   520,     0,
     521,   522,   730,   523,   524,   173,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,   175,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,   179,   180,   540,   181,   541,   542,   543,   544,   545,
       0,     0,   546,  1624,   183,   547,   184,     0,   548,   549,
     550,  1625,  1626,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
     190,   191,   565,   566,   192,     0,   567,   568,   194,   569,
       0,  1631,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,   198,   579,
     199,  1634,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,  1635,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,   211,   619,
     620,   621,   213,  3891,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,  1638,   635,   636,
     218,   637,   638,   220,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
    1640,     0,   653,   654,     0,   655,   225,   656,   657,   658,
     659,   660,     0,   226,   227,     0,     0,   662,   663,  1643,
     664,  1644,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,  1647,     0,   677,
     678,   679,   680,   681,   734,   236,     0,   682,   237,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,   735,   694,   695,     0,     0,     0,   759,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,   249,    98,    99,   100,   101,   102,   103,   760,
     104,   105,   714,   761,     0,   107,   108,   109,   110,   762,
     763,   112,   113,   114,     0,   115,   764,   765,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,   135,   136,   137,
     138,     0,   449,   450,   451,   452,   453,     0,  1602,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,  1605,
       0,  1606,     0,   461,   462,   463,   464,   147,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,     0,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
     476,   477,   478,   479,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,  1617,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,  1620,     0,   172,   520,
       0,   521,   522,   730,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,  1624,   183,   547,   184,     0,   548,
     549,   550,  1625,  1626,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,   190,   191,   565,   566,   192,     0,   567,   568,   194,
     569,     0,  1631,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,   198,
     579,   199,  1634,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,  1635,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,  1638,   635,
     636,   218,   637,   638,   220,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,  1640,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
    1643,   664,  1644,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,  1647,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,   735,   694,   695,     0,     0,     0,
     759,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,  4542,    98,    99,   100,   101,   102,   103,
     760,   104,   105,   714,   761,     0,   107,   108,   109,   110,
     762,   763,   112,   113,   114,     0,   115,   764,   765,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,   132,   446,   447,   448,   134,   135,   136,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,   725,   139,   456,     0,   457,   458,   459,   460,
     143,     0,   144,     0,   461,   462,   463,   464,   147,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
     150,   473,   474,     0,     0,     0,     0,   151,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,   168,
       0,   169,   516,   517,   518,     0,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,   524,   173,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,   175,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,   179,   180,   540,   181,   541,   542,   543,
     544,   545,     0,     0,   546,   182,   183,   547,   184,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,   190,   191,   565,   566,   192,     0,   567,   568,
     194,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
     198,   579,   199,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
     211,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,   218,   637,   638,   220,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,   225,   656,
     657,   658,   659,   660,     0,   226,   227,     0,     0,   662,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,   734,   236,     0,   682,
     237,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,     0,     0,
       0,     0,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,  5180,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   714,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,     0,     0,     0,     0,     0,  4465,     0,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   134,   135,
       0,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   725,   139,   456,     0,   457,   458,   459,
     460,   143,     0,     0,     0,   461,   462,   463,   464,     0,
     465,   466,   726,     0,   467,   468,   469,   470,   471,   472,
       0, -1625,   473,   474,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   728,   480,   154,   155,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   163,   507,   508,   509,   165,     0,
     510,     0,   511,   512,   167,   513,     0,   514,     0,   515,
       0,     0, -1625,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,   730,   523,   524,     0,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535, -1625,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,     0,     0,   540, -1625,   541,   542,
     543,   544,   545,     0,     0,   546,   182, -1625,   547,     0,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,   189, -1625,   191,   565,   566,   192,     0,   567,
     568,     0,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,     0,     0,   575,   576,   577,     0,     0,   578,
     197,     0,   579,     0,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618, -1625,   619,   620,   621,   213,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,   633,
       0,   635,   636,   218,   637,   638,     0,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,     0,
     656,   657,   658,   659,   660,     0,   226,   227,     0,     0,
     662,   663,   228,   664,   229,     0,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,   734,   236,     0,
     682,     0,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   735,   694,   695,     0,
       0,     0,     0,     0,    86,    87,    88,   711,    90,    91,
      92,   712,     0,   713,    95,     0,  1758,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   714,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,     0,
       0,     0,    37,    38,    39,    40,    41,    42,     0,    44,
       0,     0,     0,    45,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,     0,     0,     0,     0,     0,     0,
       0,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     134,   135,     0,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   725,   139,   456,     0,   457,
     458,   459,   460,   143,     0,     0,     0,   461,   462,   463,
     464,     0,   465,   466,   726,     0,   467,   468,   469,   470,
     471,   472,     0,     0,   473,   474,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   728,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   163,   507,   508,   509,
     165,     0,   510,     0,   511,   512,   167,   513,     0,   514,
       0,   515,     0,     0,     0,   516,   517,   518,     0,   519,
     171,     0,   172,   520,     0,   521,   522,   730,   523,   524,
       0,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,     0,   535,     0,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,     0,     0,   540,     0,
     541,   542,   543,   544,   545,     0,     0,   546,   182,     0,
     547,     0,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,     0,   191,   565,   566,   192,
       0,   567,   568,     0,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,     0,     0,   575,   576,   577,     0,
       0,   578,   197,     0,   579,     0,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,     0,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,     0,   639,
     640,   221,   641,     0,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,     0,
     655,     0,   656,   657,   658,   659,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,     0,   665,   666,
     667,   668,   669,   670,   671,     0,     0,   672,   673,   674,
     675,   676,     0,     0,   677,   678,   679,   680,   681,   734,
     236,     0,   682,     0,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,     0,     0,     0,     0,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,  3693,  3694,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   714,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,    37,    38,    39,    40,    41,    42,     0,
      44,     0,     0,     0,    45,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   134,   135,     0,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,   725,   139,   456,     0,
     457,   458,   459,   460,   143,     0,     0,     0,   461,   462,
     463,   464,     0,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,     0,   473,   474,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   728,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,     0,     0,     0,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,   730,   523,
     524,     0,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,     0,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,     0,     0,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   182,
       0,   547,     0,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,   189,     0,   191,   565,   566,
     192,     0,   567,   568,     0,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,   197,     0,   579,     0,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,     0,   619,   620,   621,   213,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,   218,   637,   638,     0,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
       0,   655,     0,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,   228,   664,   229,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
     734,   236,     0,   682,     0,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   735,
     694,   695,     0,     0,     0,     0,    86,    87,    88,   711,
      90,    91,    92,   712,     0,   713,    95,     0,  3694,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,   717,
     718,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,   721,     0,   722,   723,
      35,   430,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   134,   135,     0,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   725,   139,   456,
       0,   457,   458,   459,   460,   143,     0,     0,     0,   461,
     462,   463,   464,     0,   465,   466,   726,     0,   467,   468,
     469,   470,   471,   472,     0,     0,   473,   474,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     728,   480,   154,   155,   481,     0,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,     0,   510,     0,   511,   512,   167,   513,
       0,   514,     0,   515,     0,     0,     0,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,   730,
     523,   524,     0,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,     0,   535,     0,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,     0,     0,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     182,     0,   547,     0,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   731,
     560,   561,   732,   562,   563,   564,   189,     0,   191,   565,
     566,   192,     0,   567,   568,     0,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,     0,     0,   575,   576,
     577,     0,     0,   578,   197,     0,   579,     0,   200,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,   594,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,   604,   605,
       0,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,     0,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,   733,   628,   216,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
       0,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,   224,   655,     0,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,     0,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,  2337,   236,     0,   682,     0,   683,   684,   685,   686,
       0,     0,   687,     0,   238,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     735,   694,   695,     0,     0,   248,     0,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,   249,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   714,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   134,   135,     0,   137,   138,     0,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   725,   139,
     456,     0,   457,   458,   459,   460,   143,     0,     0,     0,
     461,   462,   463,   464,     0,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,     0,     0,   473,   474,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   477,   478,
     479,   728,   480,   154,   155,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,   163,
     507,   508,   509,   165,     0,   510,     0,   511,   512,   167,
     513,     0,   514,     0,   515,     0,     0,     0,   516,   517,
     518,     0,   519,   171,     0,   172,   520,     0,   521,   522,
     730,   523,   524,     0,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,     0,   176,     0,
     536,   537,   538,     0,   177,     0,   178,     0,   539,     0,
       0,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   182,     0,   547,     0,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,   189,     0,   191,
     565,   566,   192,     0,   567,   568,     0,   569,     0,   195,
     570,   196,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,   197,     0,   579,     0,   200,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   201,   590,   202,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,     0,   619,   620,   621,
     213,   622,   623,   624,   625,   626,   627,   733,   628,   216,
     629,   630,   631,   632,   633,     0,   635,   636,   218,   637,
     638,     0,   639,   640,   221,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   223,     0,
     653,   654,   224,   655,     0,   656,   657,   658,   659,   660,
       0,   226,   227,     0,     0,   662,   663,   228,   664,   229,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,  2337,   236,     0,   682,     0,   683,   684,   685,
     686,     0,     0,   687,     0,   238,   688,   689,   690,   691,
     692,   693,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   735,   694,   695,     0,     0,   248,     0,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
     249,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,     0,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,     0,     0,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,   524,     0,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,     0,     0,     0,     0,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,  1732,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   714,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   134,   135,     0,   137,   138,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     725,   139,   456,     0,   457,   458,   459,   460,   143,     0,
       0,     0,   461,   462,   463,   464,     0,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,     0,   473,
     474,     0,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   728,   480,   154,   155,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,   165,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,     0,     0,     0,
     516,   517,   518,     0,   519,   171,     0,   172,   520,     0,
     521,   522,   730,   523,   524,     0,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,     0,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,     0,     0,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   182,     0,   547,     0,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
       0,   191,   565,   566,   192,     0,   567,   568,     0,   569,
       0,   195,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,     0,   579,
       0,   200,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   201,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,     0,   619,
     620,   621,   213,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,     0,   635,   636,
     218,   637,   638,     0,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,     0,   653,   654,     0,   655,     0,   656,   657,   658,
     659,   660,     0,   226,   227,     0,     0,   662,   663,   228,
     664,   229,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,   734,   236,     0,   682,     0,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,     0,     0,     0,     0,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,  3265,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,     0,     0,
       0,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,   524,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,     0,   656,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,     0,     0,     0,
       0,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,  4446,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   714,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   134,   135,     0,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,   725,   139,   456,     0,   457,   458,   459,   460,
     143,     0,     0,     0,   461,   462,   463,   464,     0,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
       0,   473,   474,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,     0,
       0,     0,   516,   517,   518,     0,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,   524,     0,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,     0,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,     0,     0,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   182,     0,   547,     0,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,     0,   191,   565,   566,   192,     0,   567,   568,
       0,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
       0,   579,     0,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
       0,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,   218,   637,   638,     0,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,     0,   656,
     657,   658,   659,   660,     0,   226,   227,     0,     0,   662,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,   734,   236,     0,   682,
       0,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,     0,     0,
       0,   759,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,  4871,    98,    99,   100,   101,   102,
     103,   760,   104,   105,   714,   761,     0,   107,   108,   109,
     110,   762,   763,   112,   113,   114,     0,   115,   764,   765,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,   430,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,     0,     0,
    1259,    45,     0,     0,     0,     0,     0,  1260,  1261,  1262,
     431,   432,   433,   434,   435,   436,   437,   438,   766,   439,
     440,   441,   767,   768,   769,   770,   771,   772,   773,   442,
     443,   774,   444,   445,   132,   446,   447,   448,     0,  1422,
     136,  1423,  1424,   775,   449,   450,   451,   452,   453,   776,
     777,   454,   455,  1425,  1426,   456,   779,   457,   458,   459,
     460,     0,   780,   144,   781,   461,   462,   463,   464,   147,
     465,   466,   726,   783,   467,   468,   469,   470,   471,   472,
     784,   150,   473,   474,     0,   786,   787,   788,   151,   789,
     790,   791,   476,   477,   478,   479,   728,   480,  1427,  1428,
     481,   792,   482,   793,   483,   484,   485,   486,   487,   488,
     794,   489,   490,   491,   795,   796,   492,   493,  1429,   495,
     496,   797,   497,   498,   499,   798,   500,   501,   502,   799,
     503,   504,   505,   506,     0,   507,   508,   509,     0,   800,
     510,   801,   511,   512,  1430,   513,   802,   514,   803,   515,
     168,   804,   169,   516,   517,   518,   805,   519,     0,   806,
       0,   520,   807,   521,   522,   730,   523,   524,   173,   525,
     526,   527,   528,   808,   529,   530,   531,   532,   533,   534,
     809,   535,   175,     0,     0,   536,   537,   538,  1432,  1433,
     812,  1434,   813,   539,   179,   180,   540,   181,   541,   542,
     543,   544,   545,   814,   815,   546,     0,   183,   547,   184,
     816,   548,   549,   550,   817,   818,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,  1435,   190,  1436,   565,   566,  4967,   819,   567,
     568,   194,   569,   820,     0,   570,  1437,   571,   572,   573,
     821,   574,   822,   823,  4190,   576,   577,   824,   825,   578,
       0,   198,   579,   199,     0,   580,   581,   582,   583,   584,
     585,   586,   587,   826,   588,   589,     0,   590,     0,   591,
     592,   593,   827,   594,   595,   596,   597,   598,   599,   600,
     601,  1438,   602,   603,   604,   605,   828,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   829,   617,
     618,   211,   619,   620,   621,     0,   622,   623,   624,   625,
     626,   627,   733,   628,   830,   629,   630,   631,   632,   633,
     831,   635,   636,  2550,   637,   638,   220,   639,   640,  1440,
     641,   832,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,     0,   833,   653,   654,   834,   655,   225,
     656,   657,   658,   659,   660,   835,  1441,  1442,     0,   837,
     662,   663,     0,   664,     0,   838,   665,   666,   667,   668,
     669,   670,   671,     0,   840,   672,   673,   674,   675,   676,
     841,   842,   677,   678,   679,   680,   681,     0,  1443,   844,
     682,   237,   683,   684,   685,   686,   845,   846,   687,   847,
     848,   688,   689,   690,   691,   692,   693,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   735,   694,   695,     0,
       0,     0,  1265,  1266,  1267,     0,  4191,  4192,  1270,  1271,
    1272,  1273,   759,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   760,   104,   105,   714,   761,     0,   107,   108,
     109,   110,   762,   763,   112,   113,   114,     0,   115,   764,
     765,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,   430,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,     0,
       0,  1259,    45,     0,     0,     0,     0,     0,  1260,  1261,
    1262,   431,   432,   433,   434,   435,   436,   437,   438,   766,
     439,   440,   441,   767,   768,   769,   770,   771,   772,   773,
     442,   443,   774,   444,   445,   132,   446,   447,   448,     0,
    1422,   136,  1423,  1424,   775,   449,   450,   451,   452,   453,
     776,   777,   454,   455,  1425,  1426,   456,   779,   457,   458,
     459,   460,     0,   780,   144,   781,   461,   462,   463,   464,
     147,   465,   466,   726,   783,   467,   468,   469,   470,   471,
     472,   784,   150,   473,   474,     0,   786,   787,   788,   151,
     789,   790,   791,   476,   477,   478,   479,   728,   480,  1427,
    1428,   481,   792,   482,   793,   483,   484,   485,   486,   487,
     488,   794,   489,   490,   491,   795,   796,   492,   493,  1429,
     495,   496,   797,   497,   498,   499,   798,   500,   501,   502,
     799,   503,   504,   505,   506,     0,   507,   508,   509,     0,
     800,   510,   801,   511,   512,  1430,   513,   802,   514,   803,
     515,   168,   804,   169,   516,   517,   518,   805,   519,     0,
     806,     0,   520,   807,   521,   522,   730,   523,   524,   173,
     525,   526,   527,   528,   808,   529,   530,   531,   532,   533,
     534,   809,   535,   175,     0,     0,   536,   537,   538,  1432,
    1433,   812,  1434,   813,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,   814,   815,   546,     0,   183,   547,
     184,   816,   548,   549,   550,   817,   818,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,  1435,   190,  1436,   565,   566,     0,   819,
     567,   568,   194,   569,   820,     0,   570,  1437,   571,   572,
     573,   821,   574,   822,   823,  4190,   576,   577,   824,   825,
     578,     0,   198,   579,   199,     0,   580,   581,   582,   583,
     584,   585,   586,   587,   826,   588,   589,     0,   590,     0,
     591,   592,   593,   827,   594,   595,   596,   597,   598,   599,
     600,   601,  1438,   602,   603,   604,   605,   828,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   829,
     617,   618,   211,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,   733,   628,   830,   629,   630,   631,   632,
     633,   831,   635,   636,  2550,   637,   638,   220,   639,   640,
    1440,   641,   832,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,     0,   833,   653,   654,   834,   655,
     225,   656,   657,   658,   659,   660,   835,  1441,  1442,     0,
     837,   662,   663,     0,   664,     0,   838,   665,   666,   667,
     668,   669,   670,   671,     0,   840,   672,   673,   674,   675,
     676,   841,   842,   677,   678,   679,   680,   681,     0,  1443,
     844,   682,   237,   683,   684,   685,   686,   845,   846,   687,
     847,   848,   688,   689,   690,   691,   692,   693,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   735,   694,   695,
       0,     0,     0,  1265,  1266,  1267,     0,  4191,  4192,  1270,
    1271,  1272,  1273,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,  1259,     0,     0,     0,     0,     0,     0,  1260,  1261,
    1262,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,  1263,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,  1264,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
       0,     0,     0,  1265,  1266,  1267,     0,  1268,  1269,  1270,
    1271,  1272,  1273,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,  1259,     0,     0,     0,     0,     0,     0,  1260,  1261,
    1262,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,  1372,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,  1373,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
       0,     0,     0,  1265,  1266,  1267,     0,  1268,  1269,  1270,
    1271,  1272,  1273,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,  1259,     0,     0,     0,     0,     0,     0,  1260,  1261,
    1262,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,  1473,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,  1474,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,  1475,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
       0,     0,     0,  1265,  1266,  1267,     0,  1268,  1269,  1270,
    1271,  1272,  1273,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,  1259,     0,     0,     0,     0,     0,     0,  1260,  1261,
    1262,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,  2039,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,  2040,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
       0,     0,     0,  1265,  1266,  1267,     0,  1268,  1269,  1270,
    1271,  1272,  1273,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,  1259,     0,     0,     0,     0,     0,     0,  1260,  1261,
    1262,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
       0,     0,     0,  1265,  1266,  1267,     0,  1268,  1269,  1270,
    1271,  1272,  1273,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,  1259,     0,     0,     0,     0,     0,     0,  1260,  1261,
    1262,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,  3367,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,  3368,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
       0,     0,     0,  1265,  1266,  1267,     0,  1268,  1269,  1270,
    1271,  1272,  1273,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,  1259,     0,     0,     0,     0,     0,     0,  1260,  1261,
    1262,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,  5160,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
       0,     0,     0,  1265,  1266,  1267,     0,  1268,  1269,  1270,
    1271,  1272,  1273,   759,    86,    87,    88,   711,    90,    91,
      92,   712,     0,   713,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   760,   104,   105,   714,   761,     0,   107,
     108,   109,   110,   762,   763,   112,   113,   114,     0,   115,
     764,   765,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
     766,   439,   440,   441,   767,   768,   769,   770,   771,   772,
     773,   442,   443,   774,   444,   445,   132,   446,   447,   448,
     134,   135,   136,   137,   138,   775,   449,   450,   451,   452,
     453,   776,   777,   454,   455,   778,   139,   456,   779,   457,
     458,   459,   460,   143,   780,   144,   781,   461,   462,   463,
     464,   147,   465,   466,   782,   783,   467,   468,   469,   470,
     471,   472,   784,   150,   473,   474,   785,   786,   787,   788,
     151,   789,   790,   791,   476,   477,   478,   479,   728,   480,
     154,   155,   481,   792,   482,   793,   483,   484,   485,   486,
     487,   488,   794,   489,   490,   491,   795,   796,   492,   493,
     494,   495,   496,   797,   497,   498,   499,   798,   500,   501,
     502,   799,   503,   504,   505,   506,   163,   507,   508,   509,
     165,   800,   510,   801,   511,   512,   167,   513,   802,   514,
     803,   515,   168,   804,   169,   516,   517,   518,   805,   519,
     171,   806,   172,   520,   807,   521,   522,   730,   523,   524,
     173,   525,   526,   527,   528,   808,   529,   530,   531,   532,
     533,   534,   809,   535,   175,   176,   810,   536,   537,   538,
     811,   177,   812,   178,   813,   539,   179,   180,   540,   181,
     541,   542,   543,   544,   545,   814,   815,   546,   182,   183,
     547,   184,   816,   548,   549,   550,   817,   818,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,   190,   191,   565,   566,   192,
     819,   567,   568,   194,   569,   820,   195,   570,   196,   571,
     572,   573,   821,   574,   822,   823,   575,   576,   577,   824,
     825,   578,   197,   198,   579,   199,   200,   580,   581,   582,
     583,   584,   585,   586,   587,   826,   588,   589,   201,   590,
     202,   591,   592,   593,   827,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,   828,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     829,   617,   618,   211,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,   830,   629,   630,   631,
     632,   633,   831,   635,   636,   218,   637,   638,   220,   639,
     640,   221,   641,   832,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,   833,   653,   654,   834,
     655,   225,   656,   657,   658,   659,   660,   835,   226,   227,
     836,   837,   662,   663,   228,   664,   229,   838,   665,   666,
     667,   668,   669,   670,   671,   839,   840,   672,   673,   674,
     675,   676,   841,   842,   677,   678,   679,   680,   681,   843,
     236,   844,   682,   237,   683,   684,   685,   686,   845,   846,
     687,   847,   848,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,   759,    86,    87,    88,   711,    90,    91,    92,   712,
    2438,   713,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   760,   104,   105,   714,   761,     0,   107,   108,   109,
     110,   762,   763,   112,   113,   114,     0,   115,   764,   765,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,   132,   446,   447,   448,     0,  1422,
     136,  1423,  1424,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,  1425,  1426,   456,     0,   457,   458,   459,
     460,     0,     0,   144,     0,   461,   462,   463,   464,   147,
     465,   466,   726,     0,   467,   468,   469,   470,   471,   472,
       0,   150,   473,   474,     0,     0,     0,     0,   151,     0,
       0,     0,   476,   477,   478,   479,   728,   480,  1427,  1428,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,  1429,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,     0,   507,   508,   509,     0,     0,
     510,     0,   511,   512,  1430,   513,     0,   514,     0,   515,
     168,     0,   169,   516,   517,   518,     0,   519,     0,     0,
       0,   520,     0,   521,   522,   730,   523,   524,   173,   525,
     526,   527,   528,  2546,   529,   530,   531,   532,   533,   534,
       0,   535,   175,  2547,     0,   536,   537,   538,  1432,  1433,
       0,  1434,     0,   539,   179,   180,   540,   181,   541,   542,
     543,   544,   545,     0,     0,   546,     0,   183,   547,   184,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,  1435,   190,  1436,   565,   566,     0,     0,   567,
     568,   194,   569,     0,     0,   570,  1437,   571,   572,   573,
       0,   574,     0,     0,   575,   576,   577,     0,  2548,   578,
    2549,   198,   579,   199,     0,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,     0,   590,     0,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,  1438,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,   211,   619,   620,   621,     0,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,   633,
       0,   635,   636,  2550,   637,   638,   220,   639,   640,  1440,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,     0,     0,   653,   654,     0,   655,   225,
     656,   657,   658,   659,   660,     0,  1441,  1442,     0,     0,
     662,   663,     0,   664,     0,     0,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,     0,  1443,  2551,
     682,   237,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   735,   694,   695,     0,
      86,    87,    88,   711,    90,    91,    92,   712,  2552,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,     0,     0,
       0,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,   524,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,     0,   656,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,     0,    86,    87,
      88,   711,    90,    91,    92,   712,  1139,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,     0,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,     0,     0,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,   524,     0,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,     0,    86,    87,    88,   711,
      90,    91,    92,   712,  5491,   713,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,   717,
     718,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,   721,     0,   722,   723,
      35,   430,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,    45,     0,     0,     0,     0,
       0,     0,     0,     0,   431,  1029,   433,   434,   435,   436,
     437,   438,  1030,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,     0,  1031,
     447,   448,   134,   135,     0,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   725,   139,   456,
       0,   457,   458,   459,   460,   143,     0,     0,     0,   461,
     462,   463,   464,     0,   465,   466,   726,     0,   467,   468,
     469,   470,   471,   472,     0,     0,   473,   474,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     728,   480,   154,   155,   481,     0,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,     0,   510,     0,   511,  1032,   167,   513,
       0,   514,     0,  1033,     0,  1034,     0,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,   730,
     523,   524,     0,   525,   526,   527,   528,  1035,   529,   530,
     531,   532,   533,   534,     0,   535,     0,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,     0,     0,
     540,     0,   541,   542,   543,   544,  1036,     0,     0,   546,
     182,     0,   547,     0,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   731,
     560,   561,   732,   562,   563,   564,   189,     0,   191,  1037,
     566,   192,     0,   567,   568,     0,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,     0,     0,   575,   576,
     577,     0,     0,   578,   197,     0,   579,     0,   200,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,  1038,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,   604,   605,
       0,   606,   607,  1039,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,     0,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,   733,   628,     0,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
       0,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,     0,   655,     0,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,     0,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,   734,   236,     0,   682,     0,   683,   684,   685,   686,
       0,     0,   687,     0,     0,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     735,   694,   695,     0,     0,     0,     0,     0,     0,     0,
    1040,  1041,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   714,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,   430,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
     431,  1029,   433,   434,   435,   436,   437,   438,  1030,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,     0,  1063,   447,   448,   134,   135,
       0,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   725,   139,   456,     0,   457,   458,   459,
     460,   143,     0,     0,     0,   461,   462,   463,   464,     0,
     465,   466,   726,     0,   467,   468,   469,   470,   471,   472,
       0,     0,   473,   474,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   728,   480,   154,   155,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   163,   507,   508,   509,   165,     0,
     510,     0,   511,  1032,   167,   513,     0,   514,     0,  1064,
       0,  1034,     0,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,   730,   523,   524,     0,   525,
     526,   527,   528,  1035,   529,   530,   531,   532,   533,   534,
       0,   535,     0,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,     0,     0,   540,     0,   541,   542,
     543,   544,  1036,     0,     0,   546,   182,     0,   547,     0,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,   189,     0,   191,  1037,   566,   192,     0,   567,
     568,     0,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,     0,     0,   575,   576,   577,     0,     0,   578,
     197,     0,   579,     0,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,     0,  1038,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,  1039,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,     0,   619,   620,   621,   213,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,   633,
       0,   635,   636,   218,   637,   638,     0,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,     0,
     656,   657,   658,   659,   660,     0,   226,   227,     0,     0,
     662,   663,   228,   664,   229,     0,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,   734,   236,     0,
     682,     0,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   735,   694,   695,     0,
       0,     0,     0,     0,     0,     0,  1040,  1041,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,   430,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,    45,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,  1526,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,     0,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,  1034,     0,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,   524,     0,   525,   526,   527,   528,  1035,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,     0,     0,     0,     0,     0,
       0,     0,  1040,  1041,    86,    87,    88,   711,    90,    91,
      92,   712,     0,   713,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   714,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,   430,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,    45,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
    1531,   439,   440,   441,     0,     0,     0,     0,     0,     0,
       0,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     134,   135,     0,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   725,   139,   456,     0,   457,
     458,   459,   460,   143,     0,     0,     0,   461,   462,   463,
     464,     0,   465,   466,   726,     0,   467,   468,   469,   470,
     471,   472,     0,     0,   473,   474,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   728,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   163,   507,   508,   509,
     165,     0,   510,     0,   511,   512,   167,   513,     0,   514,
       0,   515,     0,  1034,     0,   516,   517,   518,     0,   519,
     171,     0,   172,   520,     0,   521,   522,   730,   523,   524,
       0,   525,   526,   527,   528,  1035,   529,   530,   531,   532,
     533,   534,     0,   535,     0,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,     0,     0,   540,     0,
     541,   542,   543,   544,   545,     0,     0,   546,   182,     0,
     547,     0,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,     0,   191,   565,   566,   192,
       0,   567,   568,     0,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,     0,     0,   575,   576,   577,     0,
       0,   578,   197,     0,   579,     0,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,     0,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,     0,   639,
     640,   221,   641,     0,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,     0,
     655,     0,   656,   657,   658,   659,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,     0,   665,   666,
     667,   668,   669,   670,   671,     0,     0,   672,   673,   674,
     675,   676,     0,     0,   677,   678,   679,   680,   681,   734,
     236,     0,   682,     0,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,     0,     0,     0,     0,     0,     0,     0,  1040,  1041,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   728,   480,   154,   155,   481,   729,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,     0,     0,
       0,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,   524,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,     0,   656,   657,
     658,   659,   660,     0,   226,   227,  1703,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,     0,     0,     0,
       0,  1109,  1704,    86,    87,    88,   711,    90,    91,    92,
     712,  1110,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,  1111,   455,  1082,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,  1112,     0,  1113,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,  1114,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,  1115,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,  1116,   620,   621,   213,   622,   623,   624,
    1117,   626,   627,   733,   628,     0,   629,   630,   631,   632,
    1118,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,  1119,   227,     0,
       0,  1120,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,  1086,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,  1121,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
     759,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     760,   104,   105,   714,   761,     0,   107,   108,   109,   110,
     762,   763,   112,   113,   114,     0,   115,   764,   765,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,     0,     0,     0,
      45,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   766,   439,   440,
     441,   767,   768,   769,   770,   771,   772,   773,   442,   443,
     774,   444,   445,   132,   446,   447,   448,   134,   135,   136,
     137,   138,   775,   449,   450,   451,   452,   453,   776,   777,
     454,   455,   778,   139,   456,   779,   457,   458,   459,   460,
     143,   780,   144,   781,   461,   462,   463,   464,   147,   465,
     466,   782,   783,   467,   468,   469,   470,   471,   472,   784,
     150,   473,   474,   785,   786,   787,   788,   151,   789,   790,
     791,   476,   477,   478,   479,   728,   480,   154,   155,   481,
     792,   482,   793,   483,   484,   485,   486,   487,   488,   794,
     489,   490,   491,   795,   796,   492,   493,   494,   495,   496,
     797,   497,   498,   499,   798,   500,   501,   502,   799,   503,
     504,   505,   506,   163,   507,   508,   509,   165,   800,   510,
     801,   511,   512,   167,   513,   802,   514,   803,   515,   168,
     804,   169,   516,   517,   518,   805,   519,   171,   806,   172,
     520,   807,   521,   522,   730,   523,   524,   173,   525,   526,
     527,   528,   808,   529,   530,   531,   532,   533,   534,   809,
     535,   175,   176,   810,   536,   537,   538,   811,   177,   812,
     178,   813,   539,   179,   180,   540,   181,   541,   542,   543,
     544,   545,   814,   815,   546,   182,   183,   547,   184,   816,
     548,   549,   550,   817,   818,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,   190,   191,   565,   566,   192,   819,   567,   568,
     194,   569,   820,   195,   570,   196,   571,   572,   573,   821,
     574,   822,   823,   575,   576,   577,   824,   825,   578,   197,
     198,   579,   199,   200,   580,   581,   582,   583,   584,   585,
     586,   587,   826,   588,   589,   201,   590,   202,   591,   592,
     593,   827,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,   828,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   829,   617,   618,
     211,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,   830,   629,   630,   631,   632,   633,   831,
     635,   636,   218,   637,   638,   220,   639,   640,   221,   641,
     832,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,   833,   653,   654,   834,   655,   225,   656,
     657,   658,   659,   660,   835,   226,   227,   836,   837,   662,
     663,   228,   664,   229,   838,   665,   666,   667,   668,   669,
     670,   671,   839,   840,   672,   673,   674,   675,   676,   841,
     842,   677,   678,   679,   680,   681,   843,   236,   844,   682,
     237,   683,   684,   685,   686,   845,   846,   687,   847,   848,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,   759,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   760,   104,
     105,   714,   761,     0,   107,   108,   109,   110,   762,   763,
     112,   113,   114,     0,   115,   764,   765,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   766,   439,   440,   441,   767,
     768,   769,   770,   771,   772,   773,   442,   443,   774,   444,
     445,   132,   446,   447,   448,   134,   135,   136,   137,   138,
     775,   449,   450,   451,   452,   453,   776,   777,   454,   455,
     778,   139,   456,   779,   457,   458,   459,   460,   143,   780,
     144,   781,   461,   462,   463,   464,   147,   465,   466,   782,
     783,   467,   468,   469,   470,   471,   472,   784,   150,   473,
     474,   785,   786,   787,   788,   151,   789,   790,   791,   476,
     477,   478,   479,   728,   480,   154,   155,   481,   792,   482,
     793,   483,   484,   485,   486,   487,   488,   794,   489,   490,
     491,   795,   796,   492,   493,   494,   495,   496,   797,   497,
     498,   499,   798,   500,   501,   502,   799,   503,   504,   505,
     506,   163,   507,   508,   509,   165,   800,   510,   801,   511,
     512,   167,   513,   802,   514,   803,   515,   168,   804,   169,
     516,   517,   518,   805,   519,   171,   806,   172,   520,   807,
     521,   522,   730,   523,   524,   173,   525,   526,   527,   528,
     808,   529,   530,   531,   532,   533,   534,   809,   535,   175,
     176,   810,   536,   537,   538,   811,   177,   812,   178,   813,
     539,   179,   180,   540,   181,   541,   542,   543,   544,   545,
     814,   815,   546,   182,   183,   547,   184,   816,   548,   549,
     550,   817,   818,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
     190,   191,   565,   566,   192,   819,   567,   568,   194,   569,
     820,   195,   570,   196,   571,   572,   573,   821,   574,   822,
     823,   575,   576,   577,   824,   825,   578,   197,   198,   579,
     199,   200,   580,   581,   582,   583,   584,   585,   586,   587,
     826,   588,   589,   201,   590,   202,   591,   592,   593,   827,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,   828,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   829,   617,   618,   211,   619,
     620,   621,   213,   622,   623,   624,   625,   626,   627,   733,
     628,   830,   629,   630,   631,   632,   633,   831,   635,   636,
     218,   637,   638,   220,   639,   640,   221,   641,   832,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,   833,   653,   654,   834,   655,   225,   656,   657,   658,
     659,   660,   835,   226,   227,   836,   837,   662,   663,   228,
     664,   229,   838,   665,   666,   667,   668,   669,   670,   671,
     839,   840,   672,   673,   674,   675,   676,   841,   842,   677,
     678,   679,   680,   681,   843,   236,   844,   682,   237,   683,
     684,   685,   686,   845,   846,   687,   847,   848,   688,   689,
     690,   691,   692,   693,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,   759,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   760,   104,   105,   714,
     761,     0,   107,   108,   109,   110,   762,   763,   112,   113,
     114,     0,   115,   764,   765,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,  3435,
     436,   437,   438,   766,   439,   440,   441,   767,   768,   769,
     770,   771,   772,   773,   442,   443,   774,   444,   445,   132,
     446,   447,   448,   134,   135,   136,   137,   138,   775,   449,
     450,   451,   452,   453,   776,   777,   454,   455,   778,   139,
     456,   779,   457,   458,   459,   460,   143,   780,   144,   781,
     461,   462,   463,   464,   147,   465,   466,   782,   783,   467,
     468,   469,   470,   471,   472,   784,   150,   473,   474,   785,
     786,   787,   788,   151,   789,   790,   791,   476,   477,   478,
     479,   728,   480,   154,   155,   481,   792,   482,   793,   483,
     484,   485,   486,   487,   488,   794,   489,   490,   491,   795,
     796,   492,   493,   494,  3436,   496,   797,   497,   498,   499,
     798,   500,   501,   502,   799,   503,   504,   505,   506,   163,
     507,   508,   509,   165,   800,   510,   801,   511,   512,   167,
     513,   802,   514,   803,   515,   168,   804,   169,   516,   517,
     518,   805,   519,   171,   806,   172,   520,   807,   521,   522,
     730,   523,   524,   173,   525,   526,   527,   528,   808,   529,
     530,   531,   532,   533,   534,   809,   535,   175,   176,   810,
     536,   537,   538,   811,   177,   812,   178,   813,   539,   179,
     180,   540,   181,   541,   542,   543,   544,   545,   814,   815,
     546,   182,   183,   547,   184,   816,   548,   549,   550,   817,
     818,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,   189,   190,   191,
     565,   566,   192,   819,   567,   568,   194,   569,   820,   195,
     570,   196,   571,   572,   573,   821,   574,   822,   823,   575,
     576,   577,   824,   825,   578,   197,   198,   579,   199,   200,
     580,   581,   582,   583,   584,   585,   586,   587,   826,   588,
     589,   201,   590,   202,   591,   592,   593,   827,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,   828,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   829,   617,   618,   211,   619,   620,   621,
     213,   622,   623,   624,   625,   626,   627,   733,   628,   830,
     629,   630,   631,   632,   633,   831,  3437,   636,   218,   637,
     638,   220,   639,   640,   221,   641,   832,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   223,   833,
     653,   654,   834,   655,   225,   656,   657,   658,   659,   660,
     835,   226,   227,   836,   837,   662,   663,   228,   664,   229,
     838,   665,   666,   667,   668,   669,   670,   671,   839,   840,
     672,   673,   674,   675,   676,   841,   842,   677,   678,   679,
     680,   681,   843,   236,   844,   682,   237,   683,   684,   685,
     686,   845,   846,   687,   847,   848,   688,   689,   690,   691,
     692,   693,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   735,   694,   695,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,   135,   136,   137,   138,     0,   449,   450,   451,
     452,   453,     0,  1602,   454,   455,   725,   139,   456,     0,
     457,   458,   459,   460,  1605,     0,  1606,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,   476,   477,   478,   479,   728,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,  1617,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,  1620,     0,   172,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,  1624,
     183,   547,   184,     0,   548,   549,   550,  1625,  1626,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,   189,   190,   191,   565,   566,
     192,     0,   567,   568,   194,   569,     0,  1631,   570,   196,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,   197,   198,   579,   199,  1634,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,  1635,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,   213,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,  1638,   635,   636,   218,   637,   638,   220,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,  1640,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,  1643,   664,  1644,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,  1647,     0,   677,   678,   679,   680,   681,
     734,   236,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,   735,
     694,   695,   759,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   760,   104,   105,   714,   761,     0,   107,   108,
     109,   110,   762,   763,   112,   113,   114,     0,   115,   764,
     765,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
     759,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     760,   104,   105,   714,   761,     0,   107,   108,   109,   110,
     762,   763,   112,   113,   114,     0,   115,   764,   765,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,   132,   446,   447,   448,   134,   135,   136,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,   725,   139,   456,     0,   457,   458,   459,   460,
     143,     0,   144,     0,   461,   462,   463,   464,   147,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
     150,   473,   474,     0,     0,     0,     0,   151,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,   168,
       0,   169,   516,   517,   518,     0,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,  1415,   173,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,   175,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,   179,   180,   540,   181,   541,   542,   543,
     544,   545,     0,     0,   546,   182,   183,   547,   184,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,   190,   191,   565,   566,   192,     0,   567,   568,
     194,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
     198,   579,   199,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
     211,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,   218,   637,   638,   220,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,   225,   656,
     657,   658,   659,   660,     0,   226,   227,     0,     0,   662,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,   734,   236,     0,   682,
     237,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,   759,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   760,   104,
     105,   714,   761,     0,   107,   108,   109,   110,   762,   763,
     112,   113,   114,     0,   115,   764,   765,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,   132,   446,   447,   448,   134,   135,   136,   137,   138,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     725,   139,   456,     0,   457,   458,   459,   460,   143,     0,
     144,     0,   461,   462,   463,   464,   147,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,   150,   473,
     474,     0,     0,     0,     0,   151,     0,     0,     0,   476,
     477,   478,   479,   728,   480,   154,   155,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,   165,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,   168,     0,   169,
     516,   517,   518,     0,   519,   171,     0,   172,   520,     0,
     521,   522,   730,   523,  1466,   173,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,   175,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,   179,   180,   540,   181,   541,   542,   543,   544,   545,
       0,     0,   546,   182,   183,   547,   184,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
     190,   191,   565,   566,   192,     0,   567,   568,   194,   569,
       0,   195,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,   198,   579,
     199,   200,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   201,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,   211,   619,
     620,   621,   213,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,     0,   635,   636,
     218,   637,   638,   220,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,     0,   653,   654,     0,   655,   225,   656,   657,   658,
     659,   660,     0,   226,   227,     0,     0,   662,   663,   228,
     664,   229,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,   734,   236,     0,   682,   237,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,   759,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   760,   104,   105,   714,
     761,     0,   107,   108,   109,   110,   762,   763,   112,   113,
     114,     0,   115,   764,   765,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,   132,
     446,   447,   448,     0,  1422,   136,  1423,  1424,     0,   449,
     450,   451,   452,   453,     0,     0,   454,   455,  1425,  1426,
     456,     0,   457,   458,   459,   460,     0,     0,   144,     0,
     461,   462,   463,   464,   147,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,     0,   150,   473,   474,     0,
       0,     0,     0,   151,     0,     0,     0,   476,   477,   478,
     479,   728,   480,  1427,  1428,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,  1429,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,     0,
     507,   508,   509,     0,     0,   510,     0,   511,   512,  1430,
     513,     0,   514,     0,   515,   168,     0,   169,   516,   517,
     518,     0,   519,     0,     0,     0,   520,     0,   521,   522,
     730,   523,   524,   173,   525,   526,   527,   528,  2546,   529,
     530,   531,   532,   533,   534,     0,   535,   175,  2547,     0,
     536,   537,   538,  1432,  1433,     0,  1434,     0,   539,   179,
     180,   540,   181,   541,   542,   543,   544,   545,     0,     0,
     546,     0,   183,   547,   184,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,  1435,   190,  1436,
     565,   566,     0,     0,   567,   568,   194,   569,     0,     0,
     570,  1437,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,  2549,   198,   579,   199,     0,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,     0,   590,     0,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,  1438,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,   211,   619,   620,   621,
       0,   622,   623,   624,   625,   626,   627,   733,   628,     0,
     629,   630,   631,   632,   633,     0,   635,   636,  2550,   637,
     638,   220,   639,   640,  1440,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,     0,     0,
     653,   654,     0,   655,   225,   656,   657,   658,   659,   660,
       0,  1441,  1442,     0,     0,   662,   663,     0,   664,     0,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,     0,  1443,  2551,   682,   237,   683,   684,   685,
     686,     0,     0,   687,     0,     0,   688,   689,   690,   691,
     692,   693,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   735,   694,   695,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,     0,  1422,   136,  1423,  1424,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,  1425,  1426,   456,     0,
     457,   458,   459,   460,     0,     0,   144,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,     0,     0,
       0,   151,     0,     0,     0,   476,   477,   478,   479,   728,
     480,  1427,  1428,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,     0,   507,   508,
     509,     0,     0,   510,     0,   511,   512,  1430,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,     0,     0,     0,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,     0,     0,   536,   537,
     538,  1432,  1433,     0,  1434,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,     0,
     183,   547,   184,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1435,   190,  1436,   565,   566,
       0,     0,   567,   568,   194,   569,  2646,     0,   570,  1437,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,     0,   198,   579,   199,     0,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,     0,
     590,     0,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1438,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,     0,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,  2550,   637,   638,   220,
     639,   640,  1440,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,     0,     0,   653,   654,
    4289,   655,   225,   656,   657,   658,   659,   660,     0,  1441,
    1442,     0,     0,   662,   663,     0,   664,     0,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
       0,  1443,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   735,
     694,   695,   759,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   760,   104,   105,   714,   761,     0,   107,   108,
     109,   110,   762,   763,   112,   113,   114,     0,   115,   764,
     765,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,     0,
    1422,   136,  1423,  1424,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,  1425,  1426,   456,     0,   457,   458,
     459,   460,     0,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,     0,   476,   477,   478,   479,   728,   480,  1427,
    1428,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,  1429,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,     0,   507,   508,   509,     0,
       0,   510,     0,   511,   512,  1430,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,     0,
       0,     0,   520,     0,   521,   522,   730,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,     0,     0,   536,   537,   538,  1432,
    1433,     0,  1434,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,     0,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,  1435,   190,  1436,   565,   566,  2715,     0,
     567,   568,   194,   569,     0,     0,   570,  1437,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,     0,   198,   579,   199,     0,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,     0,   590,     0,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,  1438,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,  1439,   637,   638,   220,   639,   640,
    1440,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,     0,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,  1441,  1442,     0,
       0,   662,   663,     0,   664,     0,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,  1443,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   735,   694,   695,
     759,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     760,   104,   105,   714,   761,     0,   107,   108,   109,   110,
     762,   763,   112,   113,   114,     0,   115,   764,   765,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,   132,   446,   447,   448,     0,  1422,   136,
    1423,  1424,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,  1425,  1426,   456,     0,   457,   458,   459,   460,
       0,     0,   144,     0,   461,   462,   463,   464,   147,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
     150,   473,   474,     0,     0,     0,     0,   151,     0,     0,
       0,   476,   477,   478,   479,   728,   480,  1427,  1428,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,  1429,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,     0,   507,   508,   509,     0,     0,   510,
       0,   511,   512,  1430,   513,     0,   514,     0,   515,   168,
       0,   169,   516,   517,   518,     0,   519,     0,     0,     0,
     520,     0,   521,   522,   730,   523,   524,   173,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,   175,     0,     0,   536,   537,   538,  1432,  1433,     0,
    1434,     0,   539,   179,   180,   540,   181,   541,   542,   543,
     544,   545,     0,     0,   546,     0,   183,   547,   184,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,  1435,   190,  1436,   565,   566,  4109,     0,   567,   568,
     194,   569,     0,     0,   570,  1437,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,     0,
     198,   579,   199,     0,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,     0,   590,     0,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
    1438,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
     211,   619,   620,   621,     0,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,  1439,   637,   638,   220,   639,   640,  1440,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,     0,     0,   653,   654,     0,   655,   225,   656,
     657,   658,   659,   660,     0,  1441,  1442,     0,     0,   662,
     663,     0,   664,     0,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,     0,  1443,     0,   682,
     237,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   735,   694,   695,   759,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   760,   104,
     105,   714,   761,     0,   107,   108,   109,   110,   762,   763,
     112,   113,   114,     0,   115,   764,   765,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,   132,   446,   447,   448,     0,  1422,   136,  1423,  1424,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
    1425,  1426,   456,     0,   457,   458,   459,   460,     0,     0,
     144,     0,   461,   462,   463,   464,   147,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,   150,   473,
     474,     0,     0,     0,     0,   151,     0,     0,     0,   476,
     477,   478,   479,   728,   480,  1427,  1428,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,  1429,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,     0,   507,   508,   509,     0,     0,   510,     0,   511,
     512,  1430,   513,     0,   514,     0,   515,   168,     0,   169,
     516,   517,   518,     0,   519,     0,     0,     0,   520,     0,
     521,   522,   730,   523,  1431,   173,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,   175,
       0,     0,   536,   537,   538,  1432,  1433,     0,  1434,     0,
     539,   179,   180,   540,   181,   541,   542,   543,   544,   545,
       0,     0,   546,     0,   183,   547,   184,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,  1435,
     190,  1436,   565,   566,     0,     0,   567,   568,   194,   569,
       0,     0,   570,  1437,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,     0,   198,   579,
     199,     0,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,     0,   590,     0,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,  1438,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,   211,   619,
     620,   621,     0,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,     0,   635,   636,
    1439,   637,   638,   220,   639,   640,  1440,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
       0,     0,   653,   654,     0,   655,   225,   656,   657,   658,
     659,   660,     0,  1441,  1442,     0,     0,   662,   663,     0,
     664,     0,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,     0,  1443,     0,   682,   237,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   735,   694,   695,   759,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   760,   104,   105,   714,
     761,     0,   107,   108,   109,   110,   762,   763,   112,   113,
     114,     0,   115,   764,   765,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,   132,
     446,   447,   448,     0,  1422,   136,  1423,  1424,     0,   449,
     450,   451,   452,   453,     0,     0,   454,   455,  1425,  1426,
     456,     0,   457,   458,   459,   460,     0,     0,   144,     0,
     461,   462,   463,   464,   147,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,     0,   150,   473,   474,     0,
       0,     0,     0,   151,     0,     0,     0,   476,   477,   478,
     479,   728,   480,  1427,  1428,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,  1429,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,     0,
     507,   508,   509,     0,     0,   510,     0,   511,   512,  1430,
     513,     0,   514,     0,   515,   168,     0,   169,   516,   517,
     518,     0,   519,     0,     0,     0,   520,     0,   521,   522,
     730,   523,  1492,   173,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,   175,     0,     0,
     536,   537,   538,  1432,  1433,     0,  1434,     0,   539,   179,
     180,   540,   181,   541,   542,   543,   544,   545,     0,     0,
     546,     0,   183,   547,   184,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,  1435,   190,  1436,
     565,   566,     0,     0,   567,   568,   194,   569,     0,     0,
     570,  1437,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,     0,   198,   579,   199,     0,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,     0,   590,     0,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,  1438,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,   211,   619,   620,   621,
       0,   622,   623,   624,   625,   626,   627,   733,   628,     0,
     629,   630,   631,   632,   633,     0,   635,   636,  1439,   637,
     638,   220,   639,   640,  1440,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,     0,     0,
     653,   654,     0,   655,   225,   656,   657,   658,   659,   660,
       0,  1441,  1442,     0,     0,   662,   663,     0,   664,     0,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,     0,  1443,     0,   682,   237,   683,   684,   685,
     686,     0,     0,   687,     0,     0,   688,   689,   690,   691,
     692,   693,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   735,   694,   695,   759,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   760,   104,   105,   714,   761,     0,
     107,   108,   109,   110,   762,   763,   112,   113,   114,     0,
     115,   764,   765,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,     0,  1422,   136,  1423,  1424,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,  1425,  1426,   456,     0,
     457,   458,   459,   460,     0,     0,   144,     0,   461,   462,
     463,   464,   147,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,     0,     0,
       0,   151,     0,     0,     0,   476,   477,   478,   479,   728,
     480,  1427,  1428,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,  1429,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,     0,   507,   508,
     509,     0,     0,   510,     0,   511,   512,  1430,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,     0,     0,     0,   520,     0,   521,   522,   730,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,     0,     0,   536,   537,
     538,  1432,  1433,     0,  1434,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,     0,
     183,   547,   184,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,  1435,   190,  1436,   565,   566,
       0,     0,   567,   568,   194,   569,     0,     0,   570,  1437,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,     0,   198,   579,   199,     0,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,     0,
     590,     0,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,  1438,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,     0,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,  1439,   637,   638,   220,
     639,   640,  1440,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,     0,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,  1441,
    1442,     0,     0,   662,   663,     0,   664,     0,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
       0,  1443,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   735,
     694,   695,   759,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   760,   104,   105,   714,   761,     0,   107,   108,
     109,   110,   762,   763,   112,   113,   114,     0,   115,   764,
     765,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,     0,
    1422,   136,  1423,  1424,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,  1425,  1426,   456,     0,   457,   458,
     459,   460,     0,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,     0,   476,   477,   478,   479,   728,   480,  1427,
    1428,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,  1429,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,     0,   507,   508,   509,     0,
       0,   510,     0,   511,   512,  1430,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,     0,
       0,     0,   520,     0,   521,   522,   730,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,     0,     0,   536,   537,   538,  1432,
    1433,     0,  1434,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,     0,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,  1435,   190,  1436,   565,   566,     0,     0,
     567,   568,   194,   569,     0,     0,   570,  1437,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,     0,   198,   579,   199,     0,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,     0,   590,     0,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,  1438,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,  2550,   637,   638,   220,   639,   640,
    1440,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,     0,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,  1441,  1442,     0,
       0,   662,   663,     0,   664,     0,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,  1443,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   735,   694,   695,
     759,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     760,   104,   105,   714,   761,     0,   107,   108,   109,   110,
     762,   763,   112,   113,   114,     0,   115,   764,   765,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,   132,   446,   447,   448,     0,  1422,   136,
    1423,  1424,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,  1425,  1426,   456,     0,   457,   458,   459,   460,
       0,     0,   144,     0,   461,   462,   463,   464,   147,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
     150,   473,   474,     0,     0,     0,     0,   151,     0,     0,
       0,   476,   477,   478,   479,   728,   480,  1427,  1428,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,  1429,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,     0,   507,   508,   509,     0,     0,   510,
       0,   511,   512,  1430,   513,     0,   514,     0,   515,   168,
       0,   169,   516,   517,   518,     0,   519,     0,     0,     0,
     520,     0,   521,   522,   730,   523,   524,   173,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,   175,     0,     0,   536,   537,   538,  1432,  1433,     0,
    1434,     0,   539,   179,   180,   540,   181,   541,   542,   543,
     544,   545,     0,     0,   546,     0,   183,   547,   184,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,  1435,   190,  1436,   565,   566,     0,     0,   567,   568,
     194,   569,     0,     0,   570,  1437,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,     0,
     198,   579,   199,     0,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,     0,   590,     0,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
    1438,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
     211,   619,   620,   621,     0,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,     0,   637,   638,   220,   639,   640,  1440,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,     0,     0,   653,   654,     0,   655,   225,   656,
     657,   658,   659,   660,     0,  1441,  1442,     0,     0,   662,
     663,     0,   664,     0,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,     0,  1443,     0,   682,
     237,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   735,   694,   695,   759,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   760,   104,
     105,   714,   761,     0,   107,   108,   109,   110,   762,   763,
     112,   113,   114,     0,   115,   764,   765,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,   132,   446,   447,   448,     0,     0,   136,     0,     0,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
       0,     0,   456,     0,   457,   458,   459,   460,     0,     0,
     144,     0,   461,   462,   463,   464,   147,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,   150,   473,
     474,     0,     0,     0,     0,   151,     0,     0,     0,   476,
     477,   478,   479,   728,   480,     0,     0,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,     0,   507,   508,   509,     0,     0,   510,     0,   511,
     512,     0,   513,     0,   514,     0,   515,   168,     0,   169,
     516,   517,   518,     0,   519,     0,     0,     0,   520,     0,
     521,   522,   730,   523,   524,   173,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,   175,
       0,     0,   536,   537,   538,     0,     0,     0,     0,     0,
     539,   179,   180,   540,   181,   541,   542,   543,   544,   545,
       0,     0,   546,     0,   183,   547,   184,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,     0,
     190,     0,   565,   566,     0,     0,   567,   568,   194,   569,
       0,     0,   570,     0,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,     0,   198,   579,
     199,     0,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,     0,   590,     0,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,   211,   619,
     620,   621,     0,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,     0,   635,   636,
       0,   637,   638,   220,   639,   640,     0,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
       0,     0,   653,   654,     0,   655,   225,   656,   657,   658,
     659,   660,     0,     0,     0,     0,     0,   662,   663,     0,
     664,     0,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,     0,     0,     0,   682,   237,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   735,   694,   695,    86,    87,    88,   711,
      90,    91,    92,   712,     0,   713,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,   766,   439,   440,   441,   767,   768,   769,   770,
     771,   772,   773,   442,   443,   774,   444,   445,   132,   446,
     447,   448,   134,   135,   136,   137,   138,   775,   449,   450,
     451,   452,   453,   776,   777,   454,   455,     0,   139,   456,
     779,   457,   458,   459,   460,   143,   780,   144,   781,   461,
     462,   463,   464,   147,   465,   466,   782,   783,   467,   468,
     469,   470,   471,   472,   784,   150,   473,   474,     0,   786,
     787,   788,   151,   789,   790,   791,   476,   477,   478,   479,
       0,   480,   154,   155,   481,   792,   482,   793,   483,   484,
     485,   486,   487,   488,   794,   489,   490,   491,   795,   796,
     492,   493,   494,   495,   496,   797,   497,   498,   499,   798,
     500,   501,   502,   799,   503,   504,   505,   506,   163,   507,
     508,   509,   165,   800,   510,   801,   511,   512,   167,   513,
     802,   514,   803,   515,   168,   804,   169,   516,   517,   518,
     805,   519,   171,   806,   172,   520,   807,   521,   522,     0,
     523,   524,   173,   525,   526,   527,   528,   808,   529,   530,
     531,   532,   533,   534,   809,   535,   175,   176,     0,   536,
     537,   538,     0,   177,   812,   178,   813,   539,   179,   180,
     540,   181,   541,   542,   543,   544,   545,   814,   815,   546,
     182,   183,   547,   184,   816,   548,   549,   550,   817,   818,
     551,   552,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,     0,   562,   563,   564,   189,   190,   191,   565,
     566,   192,   819,   567,   568,   194,   569,   820,   195,   570,
     196,   571,   572,   573,   821,   574,   822,   823,   575,   576,
     577,   824,   825,   578,   197,   198,   579,   199,   200,   580,
     581,   582,   583,   584,   585,   586,   587,   826,   588,   589,
     201,   590,   202,   591,   592,   593,   827,   594,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,   604,   605,
     828,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   829,   617,   618,   211,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,     0,   628,   830,   629,
     630,   631,   632,   633,   831,   635,   636,   218,   637,   638,
     220,   639,   640,   221,   641,   832,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,   833,   653,
     654,   834,   655,   225,   656,   657,   658,   659,   660,   835,
     226,   227,     0,   837,   662,   663,   228,   664,   229,   838,
     665,   666,   667,   668,   669,   670,   671,     0,   840,   672,
     673,   674,   675,   676,   841,   842,   677,   678,   679,   680,
     681,     0,   236,   844,   682,   237,   683,   684,   685,   686,
     845,   846,   687,   847,   848,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   694,   695,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,   430,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,  1202,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,   430,     0,     0,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,     0,     0,
       0,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,   524,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,     0,   656,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   714,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   134,   135,     0,   137,   138,     0,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   725,   139,
     456,  2588,   457,   458,   459,   460,   143,     0,     0,  2665,
     461,   462,   463,   464,     0,   465,   466,   726,  2589,   467,
     468,   469,   470,   471,   472,     0,     0,   473,   474,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   477,   478,
     479,   728,   480,   154,   155,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,  2666,   504,   505,   506,   163,
     507,   508,   509,   165,     0,   510,     0,   511,   512,   167,
     513,     0,   514,  2591,   515,     0,     0,     0,   516,   517,
     518,     0,   519,   171,     0,   172,   520,     0,   521,   522,
     730,   523,  2667,     0,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,     0,   176,     0,
     536,   537,   538,     0,   177,     0,   178,     0,   539,     0,
       0,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   182,     0,   547,     0,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,   189,     0,   191,
     565,   566,   192,     0,   567,   568,     0,   569,     0,   195,
     570,   196,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,   197,     0,   579,     0,   200,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   201,   590,   202,   591,   592,   593,  2592,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,     0,   619,   620,   621,
     213,   622,   623,   624,   625,   626,   627,   733,   628,     0,
     629,   630,   631,   632,   633,     0,   635,   636,   218,   637,
     638,     0,   639,   640,   221,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   223,     0,
     653,   654,     0,   655,     0,   656,   657,   658,   659,   660,
       0,   226,   227,     0,     0,   662,   663,   228,   664,   229,
       0,   665,   666,   667,   668,   669,   670,   671,     0,  2593,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,   734,   236,     0,   682,     0,   683,   684,   685,
     686,     0,     0,   687,     0,     0,   688,   689,   690,   691,
     692,   693,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   735,   694,   695,    86,    87,    88,   711,    90,    91,
      92,   712,     0,   713,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   714,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,     0,     0,     0,     0,     0,     0,
       0,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     134,   135,     0,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   725,   139,   456,  2588,   457,
     458,   459,   460,   143,     0,     0,     0,   461,   462,   463,
     464,     0,   465,   466,   726,  2589,   467,   468,   469,   470,
     471,   472,     0,     0,   473,   474,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   728,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,  2666,   504,   505,   506,   163,   507,   508,   509,
     165,     0,   510,     0,   511,   512,   167,   513,     0,   514,
    2591,   515,     0,     0,     0,   516,   517,   518,     0,   519,
     171,     0,   172,   520,     0,   521,   522,   730,   523,   524,
       0,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,     0,   535,     0,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,     0,     0,   540,     0,
     541,   542,   543,   544,   545,     0,     0,   546,   182,     0,
     547,  3603,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,     0,   191,   565,   566,   192,
       0,   567,   568,     0,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,     0,     0,   575,   576,   577,     0,
       0,   578,   197,     0,   579,     0,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,  2592,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,     0,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,     0,   639,
     640,   221,   641,     0,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,     0,
     655,     0,   656,   657,   658,   659,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,     0,   665,   666,
     667,   668,   669,   670,   671,     0,  2593,   672,   673,   674,
     675,   676,     0,     0,   677,   678,   679,   680,   681,   734,
     236,     0,   682,     0,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   714,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,  1097,   437,   438,  1049,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   134,   135,     0,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,   725,   139,   456,     0,   457,   458,   459,   460,
     143,     0,     0,     0,   461,   462,   463,   464,     0,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,  1050,
       0,   473,   474,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,     0,
       0,     0,   516,   517,   518,  1098,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,   524,     0,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,     0,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,     0,     0,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   182,     0,   547,     0,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,     0,   191,   565,   566,   192,     0,   567,   568,
       0,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
       0,   579,     0,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,  1051,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
       0,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,  1052,   629,   630,   631,   632,   633,     0,
     635,   636,   218,   637,   638,     0,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,     0,   656,
     657,   658,   659,   660,     0,   226,   227,     0,     0,   662,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,   734,   236,     0,   682,
       0,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,  1049,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,  1050,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,     0,     0,   516,
     517,   518,  3328,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,   524,     0,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,  1051,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
    1052,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   714,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,    37,    38,    39,    40,    41,    42,     0,
      44,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   134,   135,     0,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,   725,   139,   456,     0,
     457,   458,   459,   460,   143,     0,     0,     0,   461,   462,
     463,   464,     0,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,     0,   473,   474,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   728,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,     0,     0,     0,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,   730,   523,
     524,     0,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,     0,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,     0,     0,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   182,
       0,   547,     0,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,   189,     0,   191,   565,   566,
     192,     0,   567,   568,     0,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,   197,     0,   579,     0,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,     0,   619,   620,   621,   213,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,   218,   637,   638,     0,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
       0,   655,     0,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,   228,   664,   229,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
     734,   236,     0,   682,     0,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   735,
     694,   695,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   714,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   134,   135,
       0,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   725,   139,   456,  2588,   457,   458,   459,
     460,   143,     0,     0,     0,   461,   462,   463,   464,     0,
     465,   466,   726,  2589,   467,   468,   469,   470,   471,   472,
       0,     0,   473,   474,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   728,   480,   154,   155,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
    2666,   504,   505,   506,   163,   507,   508,   509,   165,     0,
     510,     0,   511,   512,   167,   513,     0,   514,  2591,   515,
       0,     0,     0,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,   730,   523,   524,     0,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535,     0,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,     0,     0,   540,     0,   541,   542,
     543,   544,   545,     0,     0,   546,   182,     0,   547,     0,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,   189,     0,   191,   565,   566,   192,     0,   567,
     568,     0,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,     0,     0,   575,   576,   577,     0,     0,   578,
     197,     0,   579,     0,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,  2592,   594,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,     0,   619,   620,   621,   213,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,   633,
       0,   635,   636,   218,   637,   638,     0,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,     0,
     656,   657,   658,   659,   660,     0,   226,   227,     0,     0,
     662,   663,   228,   664,   229,     0,   665,   666,   667,   668,
     669,   670,   671,     0,  2593,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,   734,   236,     0,
     682,     0,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   735,   694,   695,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   714,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,   430,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   724,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   134,   135,     0,   137,   138,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     725,   139,   456,     0,   457,   458,   459,   460,   143,     0,
       0,     0,   461,   462,   463,   464,     0,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,     0,   473,
     474,   727,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   728,   480,   154,   155,   481,   729,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,   165,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,     0,     0,     0,
     516,   517,   518,     0,   519,   171,     0,   172,   520,     0,
     521,   522,   730,   523,   524,     0,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,     0,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,     0,     0,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   182,     0,   547,     0,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
       0,   191,   565,   566,   192,     0,   567,   568,     0,   569,
       0,   195,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,     0,   579,
       0,   200,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   201,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,     0,   619,
     620,   621,   213,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,     0,   635,   636,
     218,   637,   638,     0,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,     0,   653,   654,     0,   655,     0,   656,   657,   658,
     659,   660,     0,   226,   227,     0,     0,   662,   663,   228,
     664,   229,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,   734,   236,     0,   682,     0,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,    86,    87,    88,   711,
      90,    91,    92,   712,     0,   713,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,   717,
     718,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,   721,     0,   722,   723,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,  1049,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   134,   135,     0,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   725,   139,   456,
       0,   457,   458,   459,   460,   143,     0,     0,     0,   461,
     462,   463,   464,     0,   465,   466,   726,     0,   467,   468,
     469,   470,   471,   472,  1050,     0,   473,   474,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     728,   480,   154,   155,   481,     0,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,     0,   510,     0,   511,   512,   167,   513,
       0,   514,     0,   515,     0,     0,     0,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,   730,
     523,   524,     0,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,     0,   535,     0,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,     0,     0,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     182,     0,   547,     0,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   731,
     560,   561,   732,   562,   563,   564,   189,     0,   191,   565,
     566,   192,     0,   567,   568,     0,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,     0,     0,   575,   576,
     577,     0,     0,   578,   197,     0,   579,     0,   200,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,   594,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,   604,   605,
    1051,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,     0,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,   733,   628,  1052,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
       0,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,     0,   655,     0,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,     0,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,   734,   236,     0,   682,     0,   683,   684,   685,   686,
       0,     0,   687,     0,     0,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     735,   694,   695,    86,    87,    88,   711,    90,    91,    92,
     712,   957,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,   430,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   958,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   959,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,  2257,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,  2258,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,  2259,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,  2260,   515,     0,     0,
       0,  2261,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,   524,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,  2262,  2263,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,   624,  2264,   626,   627,
     733,   628,     0,  2265,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,  2266,   655,     0,  2267,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
     228,   664,   229,     0,   665,   666,  2268,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   714,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   134,   135,     0,   137,   138,     0,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   725,   139,
     456,     0,   457,   458,   459,   460,   143,     0,     0,     0,
     461,   462,   463,   464,     0,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,  1050,     0,   473,   474,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   477,   478,
     479,   728,   480,   154,   155,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,   163,
     507,   508,   509,   165,     0,   510,     0,   511,   512,   167,
     513,     0,   514,     0,   515,     0,     0,     0,   516,   517,
     518,     0,   519,   171,     0,   172,   520,     0,   521,   522,
     730,   523,   524,     0,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,     0,   176,     0,
     536,   537,   538,     0,   177,     0,   178,     0,   539,     0,
       0,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   182,     0,   547,     0,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,   189,     0,   191,
     565,   566,   192,     0,   567,   568,     0,   569,     0,   195,
     570,   196,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,   197,     0,   579,     0,   200,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   201,   590,   202,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,  1051,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,     0,   619,   620,   621,
     213,   622,   623,   624,   625,   626,   627,   733,   628,  1052,
     629,   630,   631,   632,   633,     0,   635,   636,   218,   637,
     638,     0,   639,   640,   221,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   223,     0,
     653,   654,     0,   655,     0,   656,   657,   658,   659,   660,
       0,   226,   227,     0,     0,   662,   663,   228,   664,   229,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,   734,   236,     0,   682,     0,   683,   684,   685,
     686,     0,     0,   687,     0,     0,   688,   689,   690,   691,
     692,   693,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   735,   694,   695,    86,    87,    88,   711,    90,    91,
      92,   712,  2246,   713,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   714,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,   430,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,     0,     0,     0,     0,     0,     0,
       0,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     134,   135,     0,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   725,   139,   456,     0,   457,
     458,   459,   460,   143,     0,     0,     0,   461,   462,   463,
     464,     0,   465,   466,   726,     0,   467,   468,   469,   470,
     471,   472,     0,     0,   473,   474,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   728,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   163,   507,   508,   509,
     165,     0,   510,     0,   511,   512,   167,   513,     0,   514,
       0,   515,     0,     0,     0,   516,   517,  3179,     0,   519,
     171,     0,   172,   520,     0,   521,   522,   730,   523,   524,
       0,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,     0,   535,     0,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,     0,     0,   540,     0,
     541,   542,   543,   544,   545,     0,     0,   546,   182,     0,
     547,     0,     0,   548,   549,  3180,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,     0,   191,   565,   566,   192,
       0,   567,   568,     0,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,     0,     0,   575,   576,   577,     0,
       0,   578,   197,     0,   579,     0,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,     0,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,     0,   639,
     640,   221,   641,     0,  2528,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,  3181,
     655,     0,   656,  3182,   658,  3183,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,     0,   665,   666,
     667,   668,   669,   670,   671,     0,     0,   672,   673,  3184,
     675,   676,     0,     0,   677,   678,   679,   680,   681,   734,
     236,     0,   682,     0,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   714,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,   430,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   751,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   134,   135,     0,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,   725,   139,   456,     0,   457,   458,   459,   460,
     143,     0,     0,     0,   461,   462,   463,   464,     0,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
       0,   473,   474,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,     0,
       0,     0,   516,   517,   518,     0,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,   524,     0,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,     0,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,     0,     0,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   182,     0,   547,     0,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,     0,   191,   565,   566,   192,     0,   567,   568,
       0,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
       0,   579,     0,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
       0,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,   218,   637,   638,     0,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,     0,   656,
     657,   658,   659,   660,     0,   226,   227,     0,     0,   662,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,   734,   236,     0,   682,
       0,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,   430,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,     0,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,   729,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,     0,     0,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,   524,     0,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   714,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
     430,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   905,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   134,   135,     0,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,   725,   139,   456,     0,
     457,   458,   459,   460,   143,     0,     0,     0,   461,   462,
     463,   464,     0,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,     0,   473,   474,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   728,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,     0,     0,     0,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,   730,   523,
     524,     0,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,     0,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,     0,     0,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   182,
       0,   547,     0,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,   189,     0,   191,   565,   566,
     192,     0,   567,   568,     0,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,   197,     0,   579,     0,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,     0,   619,   620,   621,   213,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,   218,   637,   638,     0,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
       0,   655,     0,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,   228,   664,   229,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
     734,   236,     0,   682,     0,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   735,
     694,   695,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   714,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,  1290,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   134,   135,
       0,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   725,   139,   456,     0,   457,   458,   459,
     460,   143,     0,     0,     0,   461,   462,   463,   464,     0,
     465,   466,   726,     0,   467,   468,   469,   470,   471,   472,
       0,     0,   473,   474,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   728,   480,   154,   155,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   163,   507,   508,   509,   165,     0,
     510,     0,   511,   512,   167,   513,     0,   514,     0,   515,
       0,     0,     0,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,   730,   523,  1291,     0,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535,     0,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,     0,     0,   540,     0,   541,   542,
     543,   544,   545,     0,     0,   546,   182,     0,   547,     0,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,   189,     0,   191,   565,   566,   192,     0,   567,
     568,     0,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,     0,  1132,   575,   576,   577,     0,     0,   578,
     197,     0,   579,     0,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,     0,   619,   620,   621,   213,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,   633,
       0,   635,   636,   218,   637,   638,     0,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,     0,
     656,   657,   658,   659,   660,     0,   226,   227,     0,     0,
     662,   663,   228,   664,   229,     0,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,   734,   236,     0,
     682,     0,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   735,   694,   695,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   714,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,   430,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,  1406,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   134,   135,     0,   137,   138,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     725,   139,   456,     0,   457,   458,   459,   460,   143,     0,
       0,     0,   461,   462,   463,   464,     0,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,     0,   473,
     474,     0,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   728,   480,   154,   155,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,   165,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,     0,     0,     0,
     516,   517,   518,     0,   519,   171,     0,   172,   520,     0,
     521,   522,   730,   523,   524,     0,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,     0,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,     0,     0,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   182,     0,   547,     0,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
       0,   191,   565,   566,   192,     0,   567,   568,     0,   569,
       0,   195,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,     0,   579,
       0,   200,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   201,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,     0,   619,
     620,   621,   213,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,     0,   635,   636,
     218,   637,   638,     0,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,     0,   653,   654,     0,   655,     0,   656,   657,   658,
     659,   660,     0,   226,   227,     0,     0,   662,   663,   228,
     664,   229,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,   734,   236,     0,   682,     0,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,    86,    87,    88,   711,
      90,    91,    92,   712,     0,   713,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,   717,
     718,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,   721,     0,   722,   723,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   129,   130,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   134,   135,     0,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   725,   139,   456,
       0,   457,   458,   459,   460,   143,     0,     0,     0,   461,
     462,   463,   464,     0,   465,   466,   726,     0,   467,   468,
     469,   470,   471,   472,     0,     0,   473,   474,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     728,   480,   154,   155,   481,     0,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,     0,   510,     0,   511,   512,   167,   513,
       0,   514,     0,   515,     0,     0,     0,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,   730,
     523,   524,     0,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,     0,   535,     0,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,     0,     0,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     182,     0,   547,     0,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   731,
     560,   561,   732,   562,   563,   564,   189,     0,   191,   565,
     566,   192,     0,   567,   568,     0,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,     0,     0,   575,   576,
     577,     0,     0,   578,   197,     0,   579,     0,   200,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,   594,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,   604,   605,
       0,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,     0,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,   733,   628,     0,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
       0,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,     0,   655,     0,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,     0,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,   734,   236,     0,   682,     0,   683,   684,   685,   686,
       0,     0,   687,     0,     0,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     735,   694,   695,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,  3416,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,   524,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,  3417,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,  3429,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,     0,     0,
       0,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,   524,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,     0,   656,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,  3430,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   714,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,   430,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   134,   135,     0,   137,   138,     0,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   725,   139,
     456,     0,   457,   458,   459,   460,   143,     0,     0,     0,
     461,   462,   463,   464,     0,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,     0,     0,   473,   474,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   477,   478,
     479,   728,   480,   154,   155,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,   163,
     507,   508,   509,   165,     0,   510,     0,   511,   512,   167,
     513,     0,   514,     0,   515,     0,     0,     0,   516,   517,
     518,     0,   519,   171,     0,   172,   520,     0,   521,   522,
     730,   523,   524,     0,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,     0,   176,     0,
     536,   537,   538,     0,   177,     0,   178,     0,   539,     0,
       0,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   182,     0,   547,     0,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,   189,     0,   191,
     565,   566,   192,     0,   567,   568,     0,   569,     0,   195,
     570,   196,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,   197,     0,   579,     0,   200,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   201,   590,   202,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,     0,   619,   620,   621,
     213,   622,   623,   624,   625,   626,   627,   733,   628,     0,
     629,   630,   631,   632,   633,     0,   635,   636,   218,   637,
     638,     0,   639,   640,   221,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   223,     0,
     653,   654,     0,   655,     0,   656,   657,   658,   659,   660,
       0,   226,   227,     0,     0,   662,   663,   228,   664,   229,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,   734,   236,     0,   682,     0,   683,   684,   685,
     686,     0,     0,   687,     0,     0,   688,   689,   690,   691,
     692,   693,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   735,   694,   695,    86,    87,    88,   711,    90,    91,
      92,   712,     0,   713,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   714,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,   430,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,     0,     0,     0,     0,     0,     0,
       0,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     134,   135,     0,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   725,   139,   456,     0,   457,
     458,   459,   460,   143,     0,     0,     0,   461,   462,   463,
     464,     0,   465,   466,   726,     0,   467,   468,   469,   470,
     471,   472,     0,     0,   473,   474,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   728,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   163,   507,   508,   509,
     165,     0,   510,     0,   511,   512,   167,   513,     0,   514,
       0,   515,     0,     0,     0,   516,   517,   518,     0,   519,
     171,     0,   172,   520,     0,   521,   522,   730,   523,   524,
       0,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,     0,   535,     0,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,     0,     0,   540,     0,
     541,   542,   543,   544,   545,     0,     0,   546,   182,     0,
     547,     0,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,     0,   191,   565,   566,   192,
       0,   567,   568,     0,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,     0,     0,   575,   576,   577,     0,
       0,   578,   197,     0,   579,     0,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,     0,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,     0,   639,
     640,   221,   641,     0,   642,   643,   644,   645,   963,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,     0,
     655,     0,   656,   657,   658,   659,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,     0,   665,   666,
     667,   668,   669,   670,   671,     0,     0,   672,   673,   674,
     675,   676,     0,     0,   677,   678,   679,   680,   681,   734,
     236,     0,   682,     0,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   714,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,   430,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   134,   135,     0,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,   725,   139,   456,     0,   457,   458,   459,   460,
     143,     0,     0,     0,   461,   462,   463,   464,     0,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
       0,   473,   474,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,     0,
       0,     0,   516,   517,   518,     0,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,   524,     0,  1011,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,     0,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,     0,     0,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   182,     0,   547,     0,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,     0,   191,   565,   566,   192,     0,   567,   568,
       0,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
       0,   579,     0,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
       0,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,   218,   637,   638,     0,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,     0,   656,
     657,   658,   659,   660,     0,   226,   227,     0,     0,   662,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,   734,   236,     0,   682,
       0,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,   430,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,     0,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,     0,     0,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,   524,     0,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,  1067,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   714,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   134,   135,     0,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,   725,   139,   456,     0,
     457,   458,   459,   460,   143,     0,     0,     0,   461,   462,
     463,   464,     0,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,     0,   473,   474,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   728,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,     0,     0,     0,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,   730,   523,
     524,     0,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,     0,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,     0,     0,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   182,
       0,   547,     0,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,   189,     0,   191,   565,   566,
     192,     0,   567,   568,     0,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,     0,  1132,   575,   576,   577,
       0,     0,   578,   197,     0,   579,     0,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,     0,   619,   620,   621,   213,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,   218,   637,   638,     0,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
       0,   655,     0,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,   228,   664,   229,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
     734,   236,     0,   682,     0,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   735,
     694,   695,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   714,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,  1254,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   134,   135,
       0,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   725,   139,   456,     0,   457,   458,   459,
     460,   143,     0,     0,     0,   461,   462,   463,   464,     0,
     465,   466,   726,     0,   467,   468,   469,   470,   471,   472,
       0,     0,   473,   474,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   728,   480,   154,   155,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   163,   507,   508,   509,   165,     0,
     510,     0,   511,   512,   167,   513,     0,   514,     0,   515,
       0,     0,     0,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,   730,   523,  1255,     0,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535,     0,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,     0,     0,   540,     0,   541,   542,
     543,   544,   545,     0,     0,   546,   182,     0,   547,     0,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,   189,     0,   191,   565,   566,   192,     0,   567,
     568,     0,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,     0,     0,   575,   576,   577,     0,     0,   578,
     197,     0,   579,     0,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,     0,   619,   620,   621,   213,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,   633,
       0,   635,   636,   218,   637,   638,     0,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,     0,
     656,   657,   658,   659,   660,     0,   226,   227,     0,     0,
     662,   663,   228,   664,   229,     0,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,   734,   236,     0,
     682,     0,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   735,   694,   695,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   714,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,  1706,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   134,   135,     0,   137,   138,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     725,   139,   456,     0,   457,   458,   459,   460,   143,     0,
       0,     0,   461,   462,   463,   464,     0,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,     0,   473,
     474,     0,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   728,   480,   154,   155,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,   165,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,     0,     0,     0,
     516,   517,   518,     0,   519,   171,     0,   172,   520,     0,
     521,   522,   730,   523,   524,     0,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,     0,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,     0,     0,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   182,     0,   547,     0,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
       0,   191,   565,   566,   192,     0,   567,   568,     0,   569,
       0,   195,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,     0,   579,
       0,   200,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   201,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,     0,   619,
     620,   621,   213,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,     0,   635,   636,
     218,   637,   638,     0,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,     0,   653,   654,     0,   655,     0,   656,   657,   658,
     659,   660,     0,   226,   227,     0,     0,   662,   663,   228,
     664,   229,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,   734,   236,     0,   682,     0,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,    86,    87,    88,   711,
      90,    91,    92,   712,     0,   713,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,   717,
     718,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,   721,     0,   722,   723,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   134,   135,     0,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   725,   139,   456,
       0,   457,   458,   459,   460,   143,     0,     0,     0,   461,
     462,   463,   464,     0,   465,   466,   726,     0,   467,   468,
     469,   470,   471,   472,     0,     0,   473,   474,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     728,   480,   154,   155,   481,     0,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,     0,   510,     0,   511,   512,   167,   513,
       0,   514,     0,   515,     0,     0,     0,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,   730,
     523,  1891,     0,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,     0,   535,     0,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,     0,     0,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     182,     0,   547,     0,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   731,
     560,   561,   732,   562,   563,   564,   189,     0,   191,   565,
     566,   192,     0,   567,   568,     0,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,     0,  1132,   575,   576,
     577,     0,     0,   578,   197,     0,   579,     0,   200,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,   594,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,   604,   605,
       0,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,     0,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,   733,   628,     0,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
       0,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,     0,   655,     0,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,     0,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,   734,   236,     0,   682,     0,   683,   684,   685,   686,
       0,     0,   687,     0,     0,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     735,   694,   695,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,  1943,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,  1944,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,     0,     0,  2113,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,     0,     0,
       0,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,   524,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,     0,   656,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,    86,    87,    88,
     711,    90,    91,    92,   712,  2246,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   714,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   134,   135,     0,   137,   138,     0,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   725,   139,
     456,     0,   457,   458,   459,   460,   143,     0,     0,     0,
     461,   462,   463,   464,     0,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,     0,     0,   473,   474,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   477,   478,
     479,   728,   480,   154,   155,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,   163,
     507,   508,   509,   165,     0,   510,     0,   511,   512,   167,
     513,     0,   514,     0,   515,     0,     0,     0,   516,   517,
     518,     0,   519,   171,     0,   172,   520,     0,   521,   522,
     730,   523,   524,     0,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,     0,   176,     0,
     536,   537,   538,     0,   177,     0,   178,     0,   539,     0,
       0,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   182,     0,   547,     0,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,   189,     0,   191,
     565,   566,   192,     0,   567,   568,     0,   569,     0,   195,
     570,   196,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,   197,     0,   579,     0,   200,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   201,   590,   202,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,     0,   619,   620,   621,
     213,   622,   623,   624,   625,   626,   627,   733,   628,     0,
     629,   630,   631,   632,   633,     0,   635,   636,   218,   637,
     638,     0,   639,   640,   221,   641,     0,  2528,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   223,     0,
     653,   654,     0,   655,     0,   656,   657,   658,   659,   660,
       0,   226,   227,     0,     0,   662,   663,   228,   664,   229,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,   734,   236,     0,   682,     0,   683,   684,   685,
     686,     0,     0,   687,     0,     0,   688,   689,   690,   691,
     692,   693,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   735,   694,   695,    86,    87,    88,   711,    90,    91,
      92,   712,     0,   713,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   714,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,     0,     0,     0,     0,     0,  4465,
       0,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     134,   135,     0,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   725,   139,   456,     0,   457,
     458,   459,   460,   143,     0,     0,     0,   461,   462,   463,
     464,     0,   465,   466,   726,     0,   467,   468,   469,   470,
     471,   472,     0,     0,   473,   474,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   728,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   163,   507,   508,   509,
     165,     0,   510,     0,   511,   512,   167,   513,     0,   514,
       0,   515,     0,     0,     0,   516,   517,   518,     0,   519,
     171,     0,   172,   520,     0,   521,   522,   730,   523,   524,
       0,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,     0,   535,     0,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,     0,     0,   540,     0,
     541,   542,   543,   544,   545,     0,     0,   546,   182,     0,
     547,     0,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,     0,   191,   565,   566,   192,
       0,   567,   568,     0,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,     0,     0,   575,   576,   577,     0,
       0,   578,   197,     0,   579,     0,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,     0,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,     0,   639,
     640,   221,   641,     0,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,     0,
     655,     0,   656,   657,   658,   659,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,     0,   665,   666,
     667,   668,   669,   670,   671,     0,     0,   672,   673,   674,
     675,   676,     0,     0,   677,   678,   679,   680,   681,   734,
     236,     0,   682,     0,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   714,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,  4479,     0,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   134,   135,     0,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,   725,   139,   456,     0,   457,   458,   459,   460,
     143,     0,     0,     0,   461,   462,   463,   464,     0,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
       0,   473,   474,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,     0,
       0,     0,   516,   517,   518,     0,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,   524,     0,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,     0,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,     0,     0,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   182,     0,   547,     0,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,     0,   191,   565,   566,   192,     0,   567,   568,
       0,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
       0,   579,     0,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
       0,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,   218,   637,   638,     0,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,     0,   656,
     657,   658,   659,   660,     0,   226,   227,     0,     0,   662,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,   734,   236,     0,   682,
       0,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,     0,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,     0,     0,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,   524,     0,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   714,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   134,   135,     0,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,   725,   139,   456,     0,
     457,   458,   459,   460,   143,     0,     0,     0,   461,   462,
     463,   464,     0,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,     0,   473,   474,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   728,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,     0,     0,     0,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,   730,   523,
     524,     0,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,     0,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,     0,     0,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   182,
       0,   547,     0,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,   189,     0,   191,   565,   566,
     192,     0,   567,   568,     0,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,   197,     0,   579,     0,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,     0,   619,   620,   621,   213,   622,
     623,  1079,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,   218,   637,   638,     0,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
       0,   655,     0,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,   228,   664,   229,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
     734,   236,     0,   682,     0,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   735,
     694,   695,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   714,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,  1081,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   134,   135,
       0,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,  1082,   139,   456,     0,   457,   458,   459,
     460,   143,     0,     0,     0,   461,   462,   463,   464,     0,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
       0,     0,   473,   474,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   728,   480,   154,   155,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   163,   507,   508,   509,   165,     0,
     510,     0,   511,   512,   167,   513,     0,   514,     0,   515,
       0,     0,     0,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,   730,   523,   524,     0,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535,     0,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,     0,     0,   540,     0,   541,   542,
     543,   544,   545,     0,     0,   546,   182,     0,   547,     0,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,   189,     0,   191,   565,   566,   192,     0,   567,
     568,     0,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,     0,     0,   575,   576,   577,     0,     0,   578,
     197,     0,   579,     0,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,     0,   619,   620,   621,   213,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,  1083,
       0,   635,   636,   218,   637,   638,     0,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,     0,
     656,   657,   658,   659,   660,     0,  1084,   227,     0,     0,
    1085,   663,   228,   664,   229,     0,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,  1086,   236,     0,
     682,     0,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   735,   694,   695,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   714,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,  1126,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   134,   135,     0,   137,   138,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
    1082,   139,   456,     0,   457,   458,   459,   460,   143,     0,
       0,     0,   461,   462,   463,   464,     0,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,     0,     0,   473,
     474,     0,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   728,   480,   154,   155,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,   165,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,     0,     0,     0,
     516,   517,   518,     0,   519,   171,     0,   172,   520,     0,
     521,   522,   730,   523,   524,     0,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,     0,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,     0,     0,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   182,     0,   547,     0,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
       0,   191,   565,   566,   192,     0,   567,   568,     0,   569,
       0,   195,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,     0,   579,
       0,   200,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   201,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,     0,   619,
     620,   621,   213,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,  1127,     0,   635,   636,
     218,   637,   638,     0,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,     0,   653,   654,     0,   655,     0,   656,   657,   658,
     659,   660,     0,  1128,   227,     0,     0,  1129,   663,   228,
     664,   229,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,  1086,   236,     0,   682,     0,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,    86,    87,    88,   711,
      90,    91,    92,   712,     0,   713,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,   717,
     718,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,   721,     0,   722,   723,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   134,   135,     0,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   725,   139,   456,
       0,   457,   458,   459,   460,   143,     0,     0,     0,   461,
     462,   463,   464,     0,   465,   466,   726,     0,   467,   468,
     469,   470,   471,   472,     0,     0,   473,   474,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     728,   480,   154,   155,   481,     0,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,     0,   510,     0,   511,   512,   167,   513,
       0,   514,     0,   515,     0,     0,     0,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,   730,
     523,   524,     0,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,     0,   535,     0,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,     0,     0,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     182,     0,   547,     0,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   731,
     560,   561,   732,   562,   563,   564,   189,     0,   191,   565,
     566,   192,     0,   567,   568,     0,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,     0,     0,   575,   576,
     577,     0,     0,   578,   197,     0,   579,     0,   200,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,   594,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,  1146,   605,
       0,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,     0,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,   733,   628,     0,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
       0,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,     0,   655,     0,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,     0,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,   734,   236,     0,   682,     0,   683,   684,   685,   686,
       0,     0,   687,     0,     0,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     735,   694,   695,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,  1278,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,     0,     0,
       0,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,  1285,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,     0,   656,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   714,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   134,   135,     0,   137,   138,     0,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   725,   139,
     456,     0,   457,   458,   459,   460,   143,     0,     0,     0,
     461,   462,   463,   464,     0,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,     0,     0,   473,   474,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   477,   478,
     479,   728,   480,   154,   155,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,   163,
     507,   508,   509,   165,     0,   510,     0,   511,   512,   167,
     513,     0,   514,     0,   515,     0,     0,     0,   516,   517,
     518,     0,   519,   171,     0,   172,   520,     0,   521,   522,
     730,   523,  1301,     0,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,     0,   176,     0,
     536,   537,   538,     0,   177,     0,   178,     0,   539,     0,
       0,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   182,     0,   547,     0,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,   189,     0,   191,
     565,   566,   192,     0,   567,   568,     0,   569,     0,   195,
     570,   196,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,   197,     0,   579,     0,   200,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   201,   590,   202,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,     0,   619,   620,   621,
     213,   622,   623,   624,   625,   626,   627,   733,   628,     0,
     629,   630,   631,   632,   633,     0,   635,   636,   218,   637,
     638,     0,   639,   640,   221,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   223,     0,
     653,   654,     0,   655,     0,   656,   657,   658,   659,   660,
       0,   226,   227,     0,     0,   662,   663,   228,   664,   229,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,   734,   236,     0,   682,     0,   683,   684,   685,
     686,     0,     0,   687,     0,     0,   688,   689,   690,   691,
     692,   693,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   735,   694,   695,    86,    87,    88,   711,    90,    91,
      92,   712,     0,   713,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   714,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,     0,     0,     0,     0,     0,     0,
       0,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     134,   135,     0,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   725,   139,   456,     0,   457,
     458,   459,   460,   143,     0,     0,     0,   461,   462,   463,
     464,     0,   465,   466,   726,     0,   467,   468,   469,   470,
     471,   472,     0,     0,   473,   474,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   728,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   163,   507,   508,   509,
     165,     0,   510,     0,   511,   512,   167,   513,     0,   514,
       0,   515,     0,     0,     0,   516,   517,   518,     0,   519,
     171,     0,   172,   520,     0,   521,   522,   730,   523,  1363,
       0,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,     0,   535,     0,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,     0,     0,   540,     0,
     541,   542,   543,   544,   545,     0,     0,   546,   182,     0,
     547,     0,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,     0,   191,   565,   566,   192,
       0,   567,   568,     0,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,     0,     0,   575,   576,   577,     0,
       0,   578,   197,     0,   579,     0,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,     0,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,     0,   639,
     640,   221,   641,     0,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,     0,
     655,     0,   656,   657,   658,   659,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,     0,   665,   666,
     667,   668,   669,   670,   671,     0,     0,   672,   673,   674,
     675,   676,     0,     0,   677,   678,   679,   680,   681,   734,
     236,     0,   682,     0,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   714,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   134,   135,     0,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,   725,   139,   456,     0,   457,   458,   459,   460,
     143,     0,     0,     0,   461,   462,   463,   464,     0,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
       0,   473,   474,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,     0,
       0,     0,   516,   517,   518,     0,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,  1378,     0,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,     0,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,     0,     0,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   182,     0,   547,     0,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,     0,   191,   565,   566,   192,     0,   567,   568,
       0,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
       0,   579,     0,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
       0,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,   218,   637,   638,     0,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,     0,   656,
     657,   658,   659,   660,     0,   226,   227,     0,     0,   662,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,   734,   236,     0,   682,
       0,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,     0,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,     0,     0,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,  1420,     0,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   714,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   134,   135,     0,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,   725,   139,   456,     0,
     457,   458,   459,   460,   143,     0,     0,     0,   461,   462,
     463,   464,     0,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,     0,   473,   474,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   728,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,     0,     0,     0,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,   730,   523,
    1478,     0,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,     0,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,     0,     0,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   182,
       0,   547,     0,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,   189,     0,   191,   565,   566,
     192,     0,   567,   568,     0,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,   197,     0,   579,     0,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,     0,   619,   620,   621,   213,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,   218,   637,   638,     0,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
       0,   655,     0,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,   228,   664,   229,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
     734,   236,     0,   682,     0,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   735,
     694,   695,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   714,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   134,   135,
       0,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   725,   139,   456,     0,   457,   458,   459,
     460,   143,     0,     0,     0,   461,   462,   463,   464,     0,
     465,   466,   726,     0,   467,   468,   469,   470,   471,   472,
       0,     0,   473,   474,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   728,   480,   154,   155,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   163,   507,   508,   509,   165,     0,
     510,     0,   511,   512,   167,   513,     0,   514,     0,   515,
       0,     0,     0,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,   730,   523,  1482,     0,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535,     0,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,     0,     0,   540,     0,   541,   542,
     543,   544,   545,     0,     0,   546,   182,     0,   547,     0,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,   189,     0,   191,   565,   566,   192,     0,   567,
     568,     0,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,     0,     0,   575,   576,   577,     0,     0,   578,
     197,     0,   579,     0,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,     0,   619,   620,   621,   213,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,   633,
       0,   635,   636,   218,   637,   638,     0,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,     0,
     656,   657,   658,   659,   660,     0,   226,   227,     0,     0,
     662,   663,   228,   664,   229,     0,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,   734,   236,     0,
     682,     0,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   735,   694,   695,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   714,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   134,   135,     0,   137,   138,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     725,   139,   456,     0,   457,   458,   459,   460,   143,     0,
       0,     0,   461,   462,   463,   464,     0,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,     0,   473,
     474,     0,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   728,   480,   154,   155,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,   165,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,     0,     0,     0,
     516,   517,   518,     0,   519,   171,     0,   172,   520,     0,
     521,   522,   730,   523,  1484,     0,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,     0,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,     0,     0,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   182,     0,   547,     0,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
       0,   191,   565,   566,   192,     0,   567,   568,     0,   569,
       0,   195,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,     0,   579,
       0,   200,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   201,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,     0,   619,
     620,   621,   213,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,     0,   635,   636,
     218,   637,   638,     0,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,     0,   653,   654,     0,   655,     0,   656,   657,   658,
     659,   660,     0,   226,   227,     0,     0,   662,   663,   228,
     664,   229,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,   734,   236,     0,   682,     0,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,    86,    87,    88,   711,
      90,    91,    92,   712,     0,   713,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,   717,
     718,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,   721,     0,   722,   723,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   134,   135,     0,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   725,   139,   456,
       0,   457,   458,   459,   460,   143,     0,     0,     0,   461,
     462,   463,   464,     0,   465,   466,   726,     0,   467,   468,
     469,   470,   471,   472,     0,     0,   473,   474,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     728,   480,   154,   155,   481,     0,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,     0,   510,     0,   511,   512,   167,   513,
       0,   514,     0,   515,     0,     0,     0,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,   730,
     523,  1486,     0,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,     0,   535,     0,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,     0,     0,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     182,     0,   547,     0,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   731,
     560,   561,   732,   562,   563,   564,   189,     0,   191,   565,
     566,   192,     0,   567,   568,     0,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,     0,     0,   575,   576,
     577,     0,     0,   578,   197,     0,   579,     0,   200,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,   594,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,   604,   605,
       0,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,     0,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,   733,   628,     0,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
       0,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,     0,   655,     0,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,     0,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,   734,   236,     0,   682,     0,   683,   684,   685,   686,
       0,     0,   687,     0,     0,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     735,   694,   695,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,  1490,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,     0,     0,
       0,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,  1498,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,     0,   656,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   714,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,  1717,
     446,   447,   448,   134,   135,     0,   137,   138,     0,   449,
     450,   451,   452,   453,     0,     0,  1111,   455,  1082,   139,
    1718,     0,   457,   458,   459,   460,   143,     0,     0,     0,
     461,   462,   463,   464,     0,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,     0,     0,   473,   474,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   477,   478,
     479,   728,   480,   154,   155,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,   163,
     507,   508,   509,   165,     0,   510,     0,   511,   512,   167,
     513,     0,   514,     0,   515,     0,     0,     0,   516,   517,
     518,     0,   519,   171,     0,   172,   520,     0,   521,   522,
     730,   523,   524,     0,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,     0,   176,     0,
     536,   537,   538,     0,   177,     0,   178,     0,   539,     0,
       0,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   182,     0,   547,     0,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,  1115,   189,     0,   191,
     565,   566,   192,     0,   567,   568,     0,   569,     0,   195,
     570,   196,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,   197,     0,   579,     0,   200,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   201,   590,   202,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,     0,  1116,   620,   621,
     213,   622,   623,   624,  1117,   626,   627,   733,   628,     0,
     629,   630,   631,   632,  1710,     0,   635,   636,   218,   637,
     638,     0,   639,   640,   221,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   223,     0,
     653,   654,     0,   655,     0,   656,   657,   658,   659,   660,
       0,  1119,   227,     0,     0,  1120,   663,   228,   664,   229,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,  1086,   236,     0,   682,     0,   683,   684,   685,
     686,     0,     0,   687,     0,     0,   688,   689,   690,   691,
     692,  1121,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   735,   694,   695,  1845,    87,    88,   711,    90,    91,
      92,   712,     0,   713,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   714,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,     0,     0,     0,     0,     0,     0,
       0,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     134,   135,     0,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   725,   139,   456,     0,   457,
     458,   459,   460,   143,     0,     0,     0,   461,   462,   463,
     464,     0,   465,   466,   726,     0,   467,   468,   469,   470,
     471,   472,     0,     0,   473,   474,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   728,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   163,   507,   508,   509,
     165,     0,   510,     0,   511,   512,   167,   513,     0,   514,
       0,   515,     0,     0,     0,   516,   517,   518,     0,   519,
     171,     0,   172,   520,     0,   521,   522,   730,   523,   524,
       0,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,     0,   535,     0,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,     0,     0,   540,     0,
     541,   542,   543,   544,   545,     0,     0,   546,   182,     0,
     547,     0,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,     0,   191,   565,   566,   192,
       0,   567,   568,     0,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,     0,     0,   575,   576,   577,     0,
       0,   578,   197,     0,   579,     0,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,     0,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,     0,   639,
     640,   221,   641,     0,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,     0,
     655,     0,   656,   657,   658,   659,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,     0,   665,   666,
     667,   668,   669,   670,   671,     0,     0,   672,   673,   674,
     675,   676,     0,     0,   677,   678,   679,   680,   681,   734,
     236,     0,   682,     0,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   714,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,  1081,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   134,   135,     0,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,  1082,   139,   456,     0,   457,   458,   459,   460,
     143,     0,     0,     0,   461,   462,   463,   464,     0,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,     0,
       0,   473,   474,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,     0,
       0,     0,   516,   517,   518,     0,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,   524,     0,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,     0,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,     0,     0,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   182,     0,   547,     0,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,     0,   191,   565,   566,   192,     0,   567,   568,
       0,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
       0,   579,     0,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
       0,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,   218,   637,   638,     0,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,     0,   656,
     657,   658,   659,   660,     0,   226,   227,     0,     0,   662,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,  1086,   236,     0,   682,
       0,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,     0,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,     0,     0,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,  2069,     0,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   714,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   134,   135,     0,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,   725,   139,   456,     0,
     457,   458,   459,   460,   143,     0,     0,     0,   461,   462,
     463,   464,     0,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,     0,   473,   474,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   728,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,     0,     0,     0,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,   730,   523,
    2099,     0,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,     0,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,     0,     0,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   182,
       0,   547,     0,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,   189,     0,   191,   565,   566,
     192,     0,   567,   568,     0,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,   197,     0,   579,     0,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,     0,   619,   620,   621,   213,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,   218,   637,   638,     0,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
       0,   655,     0,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,   228,   664,   229,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
     734,   236,     0,   682,     0,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   735,
     694,   695,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   714,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   134,   135,
       0,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   725,   139,   456,     0,   457,   458,   459,
     460,   143,     0,     0,     0,   461,   462,   463,   464,     0,
     465,   466,   726,     0,   467,   468,   469,   470,   471,   472,
       0,     0,   473,   474,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   728,   480,   154,   155,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   163,   507,   508,   509,   165,     0,
     510,     0,   511,   512,   167,   513,     0,   514,     0,   515,
       0,     0,     0,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,   730,   523,  2101,     0,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535,     0,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,     0,     0,   540,     0,   541,   542,
     543,   544,   545,     0,     0,   546,   182,     0,   547,     0,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,   189,     0,   191,   565,   566,   192,     0,   567,
     568,     0,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,     0,     0,   575,   576,   577,     0,     0,   578,
     197,     0,   579,     0,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,     0,   619,   620,   621,   213,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,   633,
       0,   635,   636,   218,   637,   638,     0,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,     0,
     656,   657,   658,   659,   660,     0,   226,   227,     0,     0,
     662,   663,   228,   664,   229,     0,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,   734,   236,     0,
     682,     0,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   735,   694,   695,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   714,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   134,   135,     0,   137,   138,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     725,   139,   456,     0,   457,   458,   459,   460,   143,     0,
       0,     0,   461,   462,   463,   464,     0,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,     0,   473,
     474,     0,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   728,   480,   154,   155,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,   165,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,     0,     0,     0,
     516,   517,   518,     0,   519,   171,     0,   172,   520,     0,
     521,   522,   730,   523,  2173,     0,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,     0,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,     0,     0,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   182,     0,   547,     0,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
       0,   191,   565,   566,   192,     0,   567,   568,     0,   569,
       0,   195,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,     0,   579,
       0,   200,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   201,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,     0,   619,
     620,   621,   213,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,     0,   635,   636,
     218,   637,   638,     0,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,     0,   653,   654,     0,   655,     0,   656,   657,   658,
     659,   660,     0,   226,   227,     0,     0,   662,   663,   228,
     664,   229,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,   734,   236,     0,   682,     0,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,    86,    87,    88,   711,
      90,    91,    92,   712,     0,   713,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,   717,
     718,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,   721,     0,   722,   723,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   134,   135,     0,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   725,   139,   456,
       0,   457,   458,   459,   460,   143,     0,     0,     0,   461,
     462,   463,   464,     0,   465,   466,   726,     0,   467,   468,
     469,   470,   471,   472,     0,     0,   473,   474,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     728,   480,   154,   155,   481,     0,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,     0,   510,     0,   511,   512,   167,   513,
       0,   514,     0,   515,     0,     0,     0,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,   730,
     523,  2175,     0,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,     0,   535,     0,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,     0,     0,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     182,     0,   547,     0,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   731,
     560,   561,   732,   562,   563,   564,   189,     0,   191,   565,
     566,   192,     0,   567,   568,     0,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,     0,     0,   575,   576,
     577,     0,     0,   578,   197,     0,   579,     0,   200,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,   594,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,   604,   605,
       0,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,     0,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,   733,   628,     0,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
       0,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,     0,   655,     0,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,     0,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,   734,   236,     0,   682,     0,   683,   684,   685,   686,
       0,     0,   687,     0,     0,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     735,   694,   695,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,  2177,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,     0,     0,
       0,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,   524,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,  2294,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,     0,   656,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   714,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,  2494,     0,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   134,   135,     0,   137,   138,     0,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   725,   139,
     456,     0,   457,   458,   459,   460,   143,     0,     0,     0,
     461,   462,   463,   464,     0,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,     0,     0,   473,   474,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   477,   478,
     479,   728,   480,   154,   155,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,   163,
     507,   508,   509,   165,     0,   510,     0,   511,   512,   167,
     513,     0,   514,     0,   515,     0,     0,     0,   516,   517,
     518,     0,   519,   171,     0,   172,   520,     0,   521,   522,
     730,   523,   524,     0,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,     0,   176,     0,
     536,   537,   538,     0,   177,     0,   178,     0,   539,     0,
       0,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   182,     0,   547,     0,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,   189,     0,   191,
     565,   566,   192,     0,   567,   568,     0,   569,     0,   195,
     570,   196,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,   197,     0,   579,     0,   200,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   201,   590,   202,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,     0,   619,   620,   621,
     213,   622,   623,   624,   625,   626,   627,   733,   628,     0,
     629,   630,   631,   632,   633,     0,     0,   636,   218,   637,
     638,     0,   639,   640,   221,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   223,     0,
     653,   654,     0,   655,     0,   656,   657,   658,   659,   660,
       0,   226,   227,     0,     0,   662,   663,   228,   664,   229,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,   734,   236,     0,   682,     0,   683,   684,   685,
     686,     0,     0,   687,     0,     0,   688,   689,   690,   691,
     692,   693,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   735,   694,   695,    86,    87,    88,   711,    90,    91,
      92,   712,     0,   713,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   714,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,     0,     0,     0,     0,     0,     0,
       0,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     134,   135,     0,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   725,   139,   456,     0,   457,
     458,   459,   460,   143,     0,     0,     0,   461,   462,   463,
     464,     0,   465,   466,   726,     0,   467,   468,   469,   470,
     471,   472,     0,     0,   473,   474,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   728,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   163,   507,   508,   509,
     165,     0,   510,     0,   511,   512,   167,   513,     0,   514,
       0,   515,     0,     0,     0,   516,   517,   518,     0,   519,
     171,     0,   172,   520,     0,   521,   522,   730,   523,  2890,
       0,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,     0,   535,     0,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,     0,     0,   540,     0,
     541,   542,   543,   544,   545,     0,     0,   546,   182,     0,
     547,     0,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,     0,   191,   565,   566,   192,
       0,   567,   568,     0,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,     0,     0,   575,   576,   577,     0,
       0,   578,   197,     0,   579,     0,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,     0,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,     0,   639,
     640,   221,   641,     0,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,     0,
     655,     0,   656,   657,   658,   659,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,     0,   665,   666,
     667,   668,   669,   670,   671,     0,     0,   672,   673,   674,
     675,   676,     0,     0,   677,   678,   679,   680,   681,   734,
     236,     0,   682,     0,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   714,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   134,   135,     0,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
     454,   455,   725,   139,   456,     0,   457,   458,   459,   460,
     143,     0,     0,     0,   461,   462,   463,   464,     0,   465,
     466,   726,     0,   467,   468,   469,   470,   471,   472,     0,
       0,   473,   474,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,     0,
       0,     0,   516,   517,   518,     0,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,  2894,     0,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,     0,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,     0,     0,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   182,     0,   547,     0,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
     564,   189,     0,   191,   565,   566,   192,     0,   567,   568,
       0,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
       0,   579,     0,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
       0,   619,   620,   621,   213,   622,   623,   624,   625,   626,
     627,   733,   628,     0,   629,   630,   631,   632,   633,     0,
     635,   636,   218,   637,   638,     0,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,     0,   656,
     657,   658,   659,   660,     0,   226,   227,     0,     0,   662,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,   734,   236,     0,   682,
       0,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,   693,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   725,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,   726,     0,
     467,   468,   469,   470,   471,   472,     0,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,     0,     0,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,  2934,     0,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,   734,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   714,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   134,   135,     0,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,   725,   139,   456,     0,
     457,   458,   459,   460,   143,     0,     0,     0,   461,   462,
     463,   464,     0,   465,   466,   726,     0,   467,   468,   469,
     470,   471,   472,     0,     0,   473,   474,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   728,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,     0,     0,     0,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,   730,   523,
    2975,     0,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,     0,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,     0,     0,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   182,
       0,   547,     0,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,   564,   189,     0,   191,   565,   566,
     192,     0,   567,   568,     0,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,   197,     0,   579,     0,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,     0,   619,   620,   621,   213,   622,
     623,   624,   625,   626,   627,   733,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,   218,   637,   638,     0,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
       0,   655,     0,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,   228,   664,   229,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
     734,   236,     0,   682,     0,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   735,
     694,   695,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   714,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   134,   135,
       0,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   725,   139,   456,     0,   457,   458,   459,
     460,   143,     0,     0,     0,   461,   462,   463,   464,     0,
     465,   466,   726,     0,   467,   468,   469,   470,   471,   472,
       0,     0,   473,   474,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   728,   480,   154,   155,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   163,   507,   508,   509,   165,     0,
     510,     0,   511,   512,   167,   513,     0,   514,     0,   515,
       0,     0,     0,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,   730,   523,  3339,     0,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535,     0,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,     0,     0,   540,     0,   541,   542,
     543,   544,   545,     0,     0,   546,   182,     0,   547,     0,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,   564,   189,     0,   191,   565,   566,   192,     0,   567,
     568,     0,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,     0,     0,   575,   576,   577,     0,     0,   578,
     197,     0,   579,     0,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,     0,   619,   620,   621,   213,   622,   623,   624,   625,
     626,   627,   733,   628,     0,   629,   630,   631,   632,   633,
       0,   635,   636,   218,   637,   638,     0,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,     0,
     656,   657,   658,   659,   660,     0,   226,   227,     0,     0,
     662,   663,   228,   664,   229,     0,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,   734,   236,     0,
     682,     0,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   735,   694,   695,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   714,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   134,   135,     0,   137,   138,
       0,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     725,   139,   456,     0,   457,   458,   459,   460,   143,     0,
       0,     0,   461,   462,   463,   464,     0,   465,   466,   726,
       0,   467,   468,   469,   470,   471,   472,     0,     0,   473,
     474,     0,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   728,   480,   154,   155,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,   165,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,     0,     0,     0,
     516,   517,   518,     0,   519,   171,     0,   172,   520,     0,
     521,   522,   730,   523,  3406,     0,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,     0,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,     0,     0,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   182,     0,   547,     0,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,   564,   189,
       0,   191,   565,   566,   192,     0,   567,   568,     0,   569,
       0,   195,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,     0,   579,
       0,   200,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   201,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,     0,   619,
     620,   621,   213,   622,   623,   624,   625,   626,   627,   733,
     628,     0,   629,   630,   631,   632,   633,     0,   635,   636,
     218,   637,   638,     0,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,     0,   653,   654,     0,   655,     0,   656,   657,   658,
     659,   660,     0,   226,   227,     0,     0,   662,   663,   228,
     664,   229,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,   734,   236,     0,   682,     0,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,   693,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,    86,    87,    88,   711,
      90,    91,    92,   712,     0,   713,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,   717,
     718,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,   721,     0,   722,   723,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   134,   135,     0,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   725,   139,   456,
       0,   457,   458,   459,   460,   143,     0,     0,     0,   461,
     462,   463,   464,     0,   465,   466,   726,     0,   467,   468,
     469,   470,   471,   472,     0,     0,   473,   474,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     728,   480,   154,   155,   481,     0,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,     0,   510,     0,   511,   512,   167,   513,
       0,   514,     0,   515,     0,     0,     0,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,   730,
     523,  3419,     0,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,     0,   535,     0,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,     0,     0,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     182,     0,   547,     0,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   731,
     560,   561,   732,   562,   563,   564,   189,     0,   191,   565,
     566,   192,     0,   567,   568,     0,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,     0,     0,   575,   576,
     577,     0,     0,   578,   197,     0,   579,     0,   200,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,   594,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,   604,   605,
       0,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,     0,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,   733,   628,     0,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
       0,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,     0,   655,     0,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,     0,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,   734,   236,     0,   682,     0,   683,   684,   685,   686,
       0,     0,   687,     0,     0,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     735,   694,   695,    86,    87,    88,   711,    90,    91,    92,
     712,     0,   713,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   714,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,     0,   115,     0,
       0,   715,   716,     0,     0,     0,   717,   718,     0,     0,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
       0,   720,     0,   721,     0,   722,   723,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   134,
     135,     0,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   725,   139,   456,     0,   457,   458,
     459,   460,   143,     0,     0,     0,   461,   462,   463,   464,
       0,   465,   466,   726,     0,   467,   468,   469,   470,   471,
     472,     0,     0,   473,   474,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   728,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,     0,     0,     0,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,   730,   523,  3421,     0,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,     0,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,     0,     0,   540,     0,   541,
     542,   543,   544,   545,     0,     0,   546,   182,     0,   547,
       0,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   731,   560,   561,   732,
     562,   563,   564,   189,     0,   191,   565,   566,   192,     0,
     567,   568,     0,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,     0,   579,     0,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,     0,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,   733,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,     0,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
       0,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,   734,   236,
       0,   682,     0,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   735,   694,   695,
      86,    87,    88,   711,    90,    91,    92,   712,     0,   713,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   714,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,     0,   115,     0,     0,   715,   716,
       0,     0,     0,   717,   718,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,   720,     0,
     721,     0,   722,   723,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   134,   135,     0,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   725,   139,   456,     0,   457,   458,   459,   460,   143,
       0,     0,     0,   461,   462,   463,   464,     0,   465,   466,
     726,     0,   467,   468,   469,   470,   471,   472,     0,     0,
     473,   474,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   728,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,     0,     0,
       0,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,   730,   523,  3536,     0,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
       0,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,     0,     0,   540,     0,   541,   542,   543,   544,
     545,     0,     0,   546,   182,     0,   547,     0,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   731,   560,   561,   732,   562,   563,   564,
     189,     0,   191,   565,   566,   192,     0,   567,   568,     0,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,     0,
     579,     0,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,     0,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
     733,   628,     0,   629,   630,   631,   632,   633,     0,   635,
     636,   218,   637,   638,     0,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,     0,   656,   657,
     658,   659,   660,     0,   226,   227,     0,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,   734,   236,     0,   682,     0,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   735,   694,   695,    86,    87,    88,
     711,    90,    91,    92,   712,     0,   713,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   714,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,     0,   115,     0,     0,   715,   716,     0,     0,     0,
     717,   718,     0,     0,     0,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,   721,     0,   722,
     723,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,     0,     0,     0,
       0,     0,     0,     0,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   134,   135,     0,   137,   138,     0,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   725,   139,
     456,     0,   457,   458,   459,   460,   143,     0,     0,     0,
     461,   462,   463,   464,     0,   465,   466,   726,     0,   467,
     468,   469,   470,   471,   472,     0,     0,   473,   474,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   477,   478,
     479,   728,   480,   154,   155,   481,     0,   482,     0,   483,
     484,   485,   486,   487,   488,     0,   489,   490,   491,     0,
       0,   492,  3558,   494,   495,   496,     0,   497,   498,   499,
       0,   500,   501,   502,     0,   503,   504,   505,   506,   163,
     507,   508,   509,   165,     0,   510,     0,   511,   512,   167,
     513,     0,   514,     0,   515,     0,     0,     0,   516,   517,
     518,     0,   519,   171,     0,   172,   520,     0,   521,   522,
     730,   523,   524,     0,   525,   526,   527,   528,     0,   529,
     530,   531,   532,   533,   534,     0,   535,     0,   176,     0,
     536,   537,   538,     0,   177,     0,   178,     0,   539,     0,
       0,   540,     0,   541,   542,   543,   544,   545,     0,     0,
     546,   182,     0,   547,     0,     0,   548,   549,   550,     0,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     731,   560,   561,   732,   562,   563,   564,   189,     0,   191,
     565,   566,   192,     0,   567,   568,     0,   569,     0,   195,
     570,   196,   571,   572,   573,     0,   574,     0,     0,   575,
     576,   577,     0,     0,   578,   197,     0,   579,     0,   200,
     580,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   201,   590,   202,   591,   592,   593,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   204,   602,   603,   604,
     605,     0,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,     0,   617,   618,     0,   619,   620,   621,
     213,   622,   623,   624,   625,   626,   627,   733,   628,     0,
     629,   630,   631,   632,   633,     0,   635,   636,   218,   637,
     638,     0,   639,   640,   221,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   223,     0,
     653,   654,     0,   655,     0,   656,   657,   658,   659,   660,
       0,   226,   227,     0,     0,   662,   663,   228,   664,   229,
       0,   665,   666,   667,   668,   669,   670,   671,     0,     0,
     672,   673,   674,   675,   676,     0,     0,   677,   678,   679,
     680,   681,   734,   236,     0,   682,     0,   683,   684,   685,
     686,     0,     0,   687,     0,     0,   688,   689,   690,   691,
     692,   693,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   735,   694,   695,    86,    87,    88,   711,    90,    91,
      92,   712,     0,   713,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   714,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,     0,   115,
       0,     0,   715,   716,     0,     0,     0,   717,   718,     0,
       0,     0,     0,   719,     0,     0,     0,     0,     0,     0,
       0,     0,   720,     0,   721,     0,   722,   723,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,     0,     0,     0,     0,     0,     0,
       0,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     134,   135,     0,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   725,   139,   456,     0,   457,
     458,   459,   460,   143,     0,     0,     0,   461,   462,   463,
     464,     0,   465,   466,   726,     0,   467,   468,   469,   470,
     471,   472,     0,     0,   473,   474,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   728,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   163,   507,   508,   509,
     165,     0,   510,     0,   511,   512,   167,   513,     0,   514,
       0,   515,     0,     0,     0,   516,   517,   518,     0,   519,
     171,     0,   172,   520,     0,   521,   522,   730,   523,  4721,
       0,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,     0,   535,     0,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,     0,     0,   540,     0,
     541,   542,   543,   544,   545,     0,     0,   546,   182,     0,
     547,     0,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   731,   560,   561,
     732,   562,   563,   564,   189,     0,   191,   565,   566,   192,
       0,   567,   568,     0,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,     0,     0,   575,   576,   577,     0,
       0,   578,   197,     0,   579,     0,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,     0,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,   733,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,     0,   639,
     640,   221,   641,     0,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,     0,
     655,     0,   656,   657,   658,   659,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,     0,   665,   666,
     667,   668,   669,   670,   671,     0,     0,   672,   673,   674,
     675,   676,     0,     0,   677,   678,   679,   680,   681,   734,
     236,     0,   682,     0,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   735,   694,
     695,    86,    87,    88,   711,    90,    91,    92,   712,     0,
     713,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   714,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,     0,   115,     0,     0,   715,
     716,     0,     0,     0,   717,   718,     0,     0,     0,     0,
     719,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,   721,     0,   722,   723,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,     0,     0,     0,     0,     0,     0,     0,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   134,   135,     0,
     137,   138,     0,   449,   450,   451,   452,   453,     0,     0,
    1111,   455,  1082,   139,   456,     0,   457,   458,   459,   460,
     143,     0,     0,     0,   461,   462,   463,   464,     0,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,     0,
       0,   473,   474,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   728,   480,   154,   155,   481,
       0,   482,     0,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,   497,   498,   499,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   163,   507,   508,   509,   165,     0,   510,
       0,   511,   512,   167,   513,     0,   514,     0,   515,     0,
       0,     0,   516,   517,   518,     0,   519,   171,     0,   172,
     520,     0,   521,   522,   730,   523,   524,     0,   525,   526,
     527,   528,     0,   529,   530,   531,   532,   533,   534,     0,
     535,     0,   176,     0,   536,   537,   538,     0,   177,     0,
     178,     0,   539,     0,     0,   540,     0,   541,   542,   543,
     544,   545,     0,     0,   546,   182,     0,   547,     0,     0,
     548,   549,   550,     0,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   731,   560,   561,   732,   562,   563,
    1115,   189,     0,   191,   565,   566,   192,     0,   567,   568,
       0,   569,     0,   195,   570,   196,   571,   572,   573,     0,
     574,     0,     0,   575,   576,   577,     0,     0,   578,   197,
       0,   579,     0,   200,   580,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   201,   590,   202,   591,   592,
     593,     0,   594,   595,   596,   597,   598,   599,   600,   601,
     204,   602,   603,   604,   605,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   617,   618,
       0,  1116,   620,   621,   213,   622,   623,   624,  1117,   626,
     627,   733,   628,     0,   629,   630,   631,   632,  1710,     0,
     635,   636,   218,   637,   638,     0,   639,   640,   221,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   223,     0,   653,   654,     0,   655,     0,   656,
     657,   658,   659,   660,     0,  1119,   227,     0,     0,  1120,
     663,   228,   664,   229,     0,   665,   666,   667,   668,   669,
     670,   671,     0,     0,   672,   673,   674,   675,   676,     0,
       0,   677,   678,   679,   680,   681,  1086,   236,     0,   682,
       0,   683,   684,   685,   686,     0,     0,   687,     0,     0,
     688,   689,   690,   691,   692,  1121,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   735,   694,   695,    86,    87,
      88,   711,    90,    91,    92,   712,     0,   713,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     714,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,     0,   115,     0,     0,   715,   716,     0,     0,
       0,   717,   718,     0,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,     0,   720,     0,   721,     0,
     722,   723,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   134,   135,     0,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,  1082,
     139,   456,     0,   457,   458,   459,   460,   143,     0,     0,
       0,   461,   462,   463,   464,     0,   465,   466,     0,     0,
     467,   468,   469,   470,   471,   472,     0,     0,   473,   474,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   728,   480,   154,   155,   481,     0,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,     0,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,     0,     0,     0,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,   730,   523,   524,     0,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,     0,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
       0,     0,   540,     0,   541,   542,   543,   544,   545,     0,
       0,   546,   182,     0,   547,     0,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   731,   560,   561,   732,   562,   563,   564,   189,     0,
     191,   565,   566,   192,     0,   567,   568,     0,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,     0,     0,
     575,   576,   577,     0,     0,   578,   197,     0,   579,     0,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,     0,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,   733,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,     0,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,     0,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,     0,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,  1086,   236,     0,   682,     0,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   735,   694,   695,    86,    87,    88,   711,    90,
      91,    92,   712,     0,   713,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   714,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,   715,   716,     0,     0,     0,   717,   718,
       0,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,   721,     0,   722,   723,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   134,   135,     0,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,  1111,   455,  1082,   139,   456,     0,
     457,   458,   459,   460,   143,     0,     0,     0,   461,   462,
     463,   464,     0,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,     0,     0,   473,   474,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   728,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,     0,     0,     0,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,   730,   523,
     524,     0,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,     0,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,     0,     0,   540,
       0,   541,   542,   543,   544,   545,     0,     0,   546,   182,
       0,   547,     0,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   731,   560,
     561,   732,   562,   563,  1115,   189,     0,   191,   565,   566,
     192,     0,   567,   568,     0,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,   197,     0,   579,     0,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,     0,  1116,   620,   621,   213,   622,
     623,   624,  1117,   626,   627,   733,   628,     0,   629,   630,
     631,   632,  1710,     0,   635,   636,   218,   637,   638,     0,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
       0,   655,     0,  2575,   657,   658,   659,   660,     0,  1119,
     227,     0,     0,  1120,   663,   228,   664,   229,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
    1086,   236,     0,   682,     0,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,  1121,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   735,
     694,   695,    86,    87,    88,   711,    90,    91,    92,   712,
       0,   713,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   714,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,     0,   115,     0,     0,
     715,   716,     0,     0,     0,   717,   718,     0,     0,     0,
       0,   719,     0,     0,     0,     0,     0,     0,     0,     0,
     720,     0,   721,     0,   722,   723,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   134,   135,
       0,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,  1111,   455,  1082,   139,   456,     0,   457,   458,   459,
     460,   143,     0,     0,     0,   461,   462,   463,   464,     0,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
       0,     0,   473,   474,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   728,   480,   154,   155,
     481,     0,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   163,   507,   508,   509,   165,     0,
     510,     0,   511,   512,   167,   513,     0,   514,     0,   515,
       0,     0,     0,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,   730,   523,   524,     0,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535,     0,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,     0,     0,   540,     0,   541,   542,
     543,   544,   545,     0,     0,   546,   182,     0,   547,     0,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   731,   560,   561,   732,   562,
     563,  1115,   189,     0,   191,   565,   566,   192,     0,   567,
     568,     0,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,     0,     0,   575,   576,   577,     0,     0,   578,
     197,     0,   579,     0,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,     0,  1116,   620,   621,   213,   622,   623,   624,  2650,
     626,   627,   733,   628,     0,   629,   630,   631,   632,  2651,
       0,   635,   636,   218,   637,   638,     0,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,     0,
     656,   657,   658,   659,   660,     0,  1119,   227,     0,     0,
    2652,   663,   228,   664,   229,     0,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,  1086,   236,     0,
     682,     0,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,  1121,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   735,   694,   695,    86,
      87,    88,   711,    90,    91,    92,   712,     0,   713,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   714,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,     0,   115,     0,     0,   715,   716,     0,
       0,     0,   717,   718,     0,     0,     0,     0,   719,     0,
       0,     0,     0,     0,     0,     0,     0,   720,     0,   721,
       0,   722,   723,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,     0,
       0,     0,     0,     0,     0,     0,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   134,   135,     0,   137,   138,
       0,   449,   450,   451,   452,   453,     0,     0,  1111,   455,
    1082,   139,   456,     0,   457,   458,   459,   460,   143,     0,
       0,     0,   461,   462,   463,   464,     0,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,     0,     0,   473,
     474,     0,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   728,   480,   154,   155,   481,     0,   482,
       0,   483,   484,   485,   486,   487,   488,     0,   489,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,   497,
     498,   499,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   163,   507,   508,   509,   165,     0,   510,     0,   511,
     512,   167,   513,     0,   514,     0,   515,     0,     0,     0,
     516,   517,   518,     0,   519,   171,     0,   172,   520,     0,
     521,   522,   730,   523,   524,     0,   525,   526,   527,   528,
       0,   529,   530,   531,   532,   533,   534,     0,   535,     0,
     176,     0,   536,   537,   538,     0,   177,     0,   178,     0,
     539,     0,     0,   540,     0,   541,   542,   543,   544,   545,
       0,     0,   546,   182,     0,   547,     0,     0,   548,   549,
     550,     0,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   731,   560,   561,   732,   562,   563,  1115,   189,
       0,   191,   565,   566,   192,     0,   567,   568,     0,   569,
       0,   195,   570,   196,   571,   572,   573,     0,   574,     0,
       0,   575,   576,   577,     0,     0,   578,   197,     0,   579,
       0,   200,   580,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   201,   590,   202,   591,   592,   593,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   204,   602,
     603,   604,   605,     0,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,     0,   617,   618,     0,  1116,
     620,   621,   213,   622,   623,   624,  1117,   626,   627,   733,
     628,     0,   629,   630,   631,   632,  2651,     0,   635,   636,
     218,   637,   638,     0,   639,   640,   221,   641,     0,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     223,     0,   653,   654,     0,   655,     0,   656,   657,   658,
     659,   660,     0,  1119,   227,     0,     0,  2652,   663,   228,
     664,   229,     0,   665,   666,   667,   668,   669,   670,   671,
       0,     0,   672,   673,   674,   675,   676,     0,     0,   677,
     678,   679,   680,   681,  1086,   236,     0,   682,     0,   683,
     684,   685,   686,     0,     0,   687,     0,     0,   688,   689,
     690,   691,   692,  1121,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   735,   694,   695,    86,    87,    88,   711,
      90,    91,    92,   712,     0,   713,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   714,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
       0,   115,     0,     0,   715,   716,     0,     0,     0,   717,
     718,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,   721,     0,   722,   723,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   134,   135,     0,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   725,   139,   456,
       0,   457,   458,   459,   460,   143,     0,     0,     0,   461,
     462,   463,   464,     0,   465,   466,   726,     0,   467,   468,
     469,   470,   471,   472,     0,     0,   473,   474,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     728,   480,   154,   155,   481,     0,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,     0,   510,     0,   511,   512,   167,   513,
       0,   514,     0,   515,     0,     0,     0,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,   730,
     523,   524,     0,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,     0,   535,     0,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,     0,     0,
     540,     0,   541,   542,   543,   544,   545,     0,     0,   546,
     182,     0,   547,     0,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   731,
     560,   561,   732,   562,   563,   564,   189,     0,   191,   565,
     566,   192,     0,   567,   568,     0,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,     0,     0,   575,   576,
     577,     0,     0,   578,   197,     0,   579,     0,   200,   580,
     581,   582,   583,   584,     0,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,   594,   595,   596,
     597,   598,   599,     0,   601,   204,   602,   603,   604,   605,
       0,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,     0,   619,   620,   621,   213,
       0,   623,   624,   625,   626,   627,   733,   628,     0,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
       0,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,     0,   655,     0,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,     0,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,   734,   236,     0,   682,     0,   683,   684,   685,   686,
       0,     0,   687,     0,     0,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     735,   694,   695,    86,    87,    88,     0,    90,    91,    92,
       0,     0,     0,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,     0,     0,     0,   107,   108,
     109,   110,     0,   111,   112,   113,   114, -2587,   115,   116,
     117,     0,     0,     0,     0,     0,   120,   121,     0,     0,
       0,     0,   122,     0,     0,     0,     0,     0,     0,     0,
       0,   123,     0,   124,     0,   125,   126,    35,     0,   425,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   132,     0,     0,     0,   134,
     135,   136,   137,   138,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   139,     0,     0,     0,     0,
       0,     0,   143,     0,   144,     0,     0,     0,     0,     0,
     147,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   150,     0,     0,     0,     0,     0,     0,   151,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   154,
     155,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
       0,     0,     0,     0,     0,   163,     0,     0,     0,   165,
       0,     0,     0,     0,     0,   167,     0,     0,     0,     0,
       0,   168,     0,   169,     0,     0,     0,     0,     0,   171,
       0,   172,     0,     0,     0,     0,     0,     0,     0,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   175,   176,     0,     0,     0,     0,     0,
     177,     0,   178,     0,     0,   179,   180,     0,   181,     0,
       0,     0,     0,     0,     0,     0,     0,   182,   183,     0,
     184,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   189,   190,   191,     0,     0,   192,     0,
       0,     0,   194,     0,     0,   195,     0,   196,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   197,   198,     0,   199,   200,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   201,     0,   202,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   204,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,     0,     0,     0,   213,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   218,     0,     0,   220,     0,     0,
     221,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,     0,     0,     0,     0,     0,
     225,     0,     0,     0,     0,     0,     0,   226,   227,     0,
       0,     0,     0,   228,     0,   229,     0,     0,     0,     0,
       0,     0,     0,     0,   232,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
       0,     0,   237,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    86,    87,    88,
       0,    90,    91,    92,     0,     0,     0,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,     0,
       0,     0,   107,   108,   109,   110,     0,   111,   112,   113,
     114, -2588,   115,   116,   117,     0,     0,     0,     0,     0,
     120,   121,     0,     0,     0,     0,   122,     0,     0,     0,
       0,     0,     0,     0,     0,   123,     0,   124,     0,   125,
     126,    35,     0,  1197,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   132,
       0,     0,     0,   134,   135,   136,   137,   138,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   139,
       0,     0,     0,     0,     0,     0,   143,     0,   144,     0,
       0,     0,     0,     0,   147,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   150,     0,     0,     0,
       0,     0,     0,   151,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   154,   155,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,     0,     0,     0,     0,     0,   163,
       0,     0,     0,   165,     0,     0,     0,     0,     0,   167,
       0,     0,     0,     0,     0,   168,     0,   169,     0,     0,
       0,     0,     0,   171,     0,   172,     0,     0,     0,     0,
       0,     0,     0,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   175,   176,     0,
       0,     0,     0,     0,   177,     0,   178,     0,     0,   179,
     180,     0,   181,     0,     0,     0,     0,     0,     0,     0,
       0,   182,   183,     0,   184,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   189,   190,   191,
       0,     0,   192,     0,     0,     0,   194,     0,     0,   195,
       0,   196,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   197,   198,     0,   199,   200,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   201,     0,   202,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   204,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,     0,     0,     0,
     213,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   218,     0,
       0,   220,     0,     0,   221,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,     0,
       0,     0,     0,     0,   225,     0,     0,     0,     0,     0,
       0,   226,   227,     0,     0,     0,     0,   228,     0,   229,
       0,     0,     0,     0,     0,     0,     0,     0,   232,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,     0,     0,   237,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    86,    87,    88,     0,    90,    91,    92,     0,     0,
       0,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,     0,     0,     0,   107,   108,   109,   110,
       0,   111,   112,   113,   114,     0,   115,   116,   117,     0,
       0,     0,     0,     0,   120,   121,     0,     0,     0,     0,
     122,     0,     0,     0,     0,     0,     0,     0,     0,   123,
       0,   124,     0,   125,     0,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   132,     0,     0,     0,   134,   135,   136,
     137,   138,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   139,     0,     0,     0,     0,     0,     0,
     143,     0,   144,     0,     0,     0,     0,     0,   147,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     150,     0,     0,     0,     0,     0,     0,   151,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   154,   155,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,     0,     0,
       0,     0,     0,   163,     0,     0,     0,   165,     0,     0,
       0,     0,     0,   167,     0,     0,     0,     0,     0,   168,
       0,   169,     0,     0,     0,     0,     0,   171,     0,   172,
       0,     0,     0,     0,     0,     0,     0,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   175,   176,     0,     0,     0,     0,     0,   177,     0,
     178,     0,     0,   179,   180,     0,   181,     0,     0,     0,
       0,     0,     0,     0,     0,   182,   183,     0,   184,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   189,   190,   191,     0,     0,   192,     0,     0,     0,
     194,     0,     0,   195,     0,   196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   197,
     198,     0,   199,   200,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   201,     0,   202,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     204,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,     0,     0,     0,   213,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   218,     0,     0,   220,     0,     0,   221,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,     0,   225,     0,
       0,     0,     0,     0,     0,   226,   227,     0,     0,     0,
       0,   228,     0,   229,     0,     0,     0,     0,     0,     0,
       0,     0,   232,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,     0,     0,
     237,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   239,   240,   241,   242,
     243,   244,   245,   246,   247,    86,    87,    88,     0,    90,
      91,    92,     0,     0,     0,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,     0,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,     0,
     115,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   132,     0,     0,
       0,   134,   135,   136,   137,   138,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   139,     0,     0,
       0,     0,     0,     0,   143,     0,   144,     0,     0,     0,
       0,     0,   147,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   150,     0,     0,     0,     0,     0,
       0,   151,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   154,   155,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   163,     0,     0,
       0,   165,     0,     0,     0,     0,     0,   167,     0,     0,
       0,     0,     0,   168,     0,   169,     0,     0,     0,     0,
       0,   171,     0,   172,     0,     0,     0,     0,     0,     0,
       0,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   175,   176,     0,     0,     0,
       0,     0,   177,     0,   178,     0,     0,   179,   180,     0,
     181,     0,     0,     0,     0,     0,     0,     0,     0,   182,
     183,     0,   184,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   189,   190,   191,     0,     0,
     192,     0,     0,     0,   194,     0,     0,   195,     0,   196,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   197,   198,     0,   199,   200,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   201,
       0,   202,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   204,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,     0,     0,     0,   213,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   218,     0,     0,   220,
       0,     0,   221,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,     0,   225,     0,     0,     0,     0,     0,     0,   226,
     227,     0,     0,     0,     0,   228,     0,   229,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,     0,     0,   237,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     239,   240,   241,   242,   243,   244,   245,   246,   247,    35,
     430,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,     0,     0,     0,    45,     0,     0,     0,     0,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,     0,     0,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,   135,   136,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,     0,   139,   456,     0,
     457,   458,   459,   460,   143,     0,   144,     0,   461,   462,
     463,   464,   147,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,     0,     0,
       0,   151,     0,     0,     0,   476,   477,   478,   479,     0,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,  2222,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,     0,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,   182,
     183,   547,   184,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,     0,   560,
     561,     0,   562,   563,   564,   189,   190,   191,   565,   566,
     192,     0,   567,   568,   194,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,  2223,     0,   575,   576,   577,
       0,     0,   578,   197,   198,   579,   199,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,   213,   622,
     623,   624,   625,   626,   627,     0,   628,     0,   629,   630,
     631,   632,   633,     0,   635,   636,   218,   637,   638,   220,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
       0,   655,   225,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,   228,   664,   229,  2224,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
       0,   236,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,     0,   688,   689,   690,   691,   692,   693,
     239,   240,   241,   242,   243,   244,   245,   246,   247,    35,
     694,   695,     0,     0,     0,     0,     0,    41,    42,  1802,
    1803,  5366,     0,     0,     0,     0,     0,     0,  5367,     0,
       0,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   129,   130,     0,     0,     0,
       0,     0,   442,   443,     0,   444,   445,   132,   446,   447,
     448,   134,   135,   136,   137,   138,     0,   449,   450,   451,
     452,   453,     0,     0,   454,   455,     0,   139,   456,     0,
     457,   458,   459,   460,   143,     0,   144,     0,   461,   462,
     463,   464,   147,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,     0,   150,   473,   474,     0,     0,     0,
       0,   151,     0,     0,     0,   476,   477,   478,   479,     0,
     480,   154,   155,   481,     0,   482,     0,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,   497,   498,   499,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   163,   507,   508,
     509,   165,     0,   510,     0,   511,   512,   167,   513,     0,
     514,     0,   515,   168,     0,   169,   516,   517,   518,     0,
     519,   171,     0,   172,   520,     0,   521,   522,     0,   523,
     524,   173,   525,   526,   527,   528,     0,   529,   530,   531,
     532,   533,   534,     0,   535,   175,   176,     0,   536,   537,
     538,     0,   177,     0,   178,     0,   539,   179,   180,   540,
     181,   541,   542,   543,   544,   545,     0,     0,   546,   182,
     183,   547,   184,     0,   548,   549,   550,     0,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,     0,   560,
     561,     0,   562,   563,   564,   189,   190,   191,   565,   566,
     192,     0,   567,   568,   194,   569,     0,   195,   570,   196,
     571,   572,   573,     0,   574,     0,     0,   575,   576,   577,
       0,     0,   578,   197,   198,   579,   199,   200,   580,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   201,
     590,   202,   591,   592,   593,     0,   594,   595,   596,   597,
     598,   599,   600,   601,   204,   602,   603,   604,   605,     0,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,     0,   617,   618,   211,   619,   620,   621,   213,   622,
     623,   624,   625,   626,   627,     0,   628,   216,   629,   630,
     631,   632,   633,     0,   635,   636,   218,   637,   638,   220,
     639,   640,   221,   641,     0,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   223,     0,   653,   654,
     224,   655,   225,   656,   657,   658,   659,   660,     0,   226,
     227,     0,     0,   662,   663,   228,   664,   229,     0,   665,
     666,   667,   668,   669,   670,   671,     0,     0,   672,   673,
     674,   675,   676,     0,     0,   677,   678,   679,   680,   681,
     235,   236,     0,   682,   237,   683,   684,   685,   686,     0,
       0,   687,     0,   238,   688,   689,   690,   691,   692,   693,
     239,   240,   241,   242,   243,   244,   245,   246,   247,     0,
     694,   695,    35,   430,   248,     0,    37,    38,    39,    40,
      41,    42,    43,    44,     0,     0,     0,    45,   249,     0,
       0,     0,     0,     0,     0,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,     0,     0,
       0,     0,     0,     0,     0,   442,   443,     0,   444,   445,
     132,   446,   447,   448,   134,   135,   136,   137,   138,     0,
     449,   450,   451,   452,   453,     0,     0,   454,   455,     0,
     139,   456,     0,   457,   458,   459,   460,   143,     0,   144,
       0,   461,   462,   463,   464,   147,   465,   466,     0,     0,
     467,   468,   469,   470,   471,   472,     0,   150,   473,   474,
       0,     0,     0,     0,   151,     0,     0,     0,   476,   477,
     478,   479,     0,   480,   154,   155,   481,  2425,   482,     0,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,   497,   498,
     499,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     163,   507,   508,   509,   165,  2222,   510,     0,   511,   512,
     167,   513,     0,   514,     0,   515,   168,     0,   169,   516,
     517,   518,     0,   519,   171,     0,   172,   520,     0,   521,
     522,     0,   523,   524,   173,   525,   526,   527,   528,     0,
     529,   530,   531,   532,   533,   534,     0,   535,   175,   176,
       0,   536,   537,   538,     0,   177,     0,   178,     0,   539,
     179,   180,   540,   181,   541,   542,   543,   544,   545,     0,
       0,   546,   182,   183,   547,   184,     0,   548,   549,   550,
       0,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,     0,   560,   561,     0,   562,   563,   564,   189,   190,
     191,   565,   566,   192,     0,   567,   568,   194,   569,     0,
     195,   570,   196,   571,   572,   573,     0,   574,  2223,     0,
     575,   576,   577,     0,     0,   578,   197,   198,   579,   199,
     200,   580,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   201,   590,   202,   591,   592,   593,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   204,   602,   603,
     604,   605,     0,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,     0,   617,   618,   211,   619,   620,
     621,   213,   622,   623,   624,   625,   626,   627,     0,   628,
       0,   629,   630,   631,   632,   633,     0,   635,   636,   218,
     637,   638,   220,   639,   640,   221,   641,     0,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   223,
       0,   653,   654,     0,   655,   225,   656,   657,   658,   659,
     660,     0,   226,   227,     0,     0,   662,   663,   228,   664,
     229,  2224,   665,   666,   667,   668,   669,   670,   671,     0,
       0,   672,   673,   674,   675,   676,     0,     0,   677,   678,
     679,   680,   681,     0,   236,     0,   682,   237,   683,   684,
     685,   686,     0,     0,   687,     0,     0,   688,   689,   690,
     691,   692,   693,   239,   240,   241,   242,   243,   244,   245,
     246,   247,     0,   694,   695,     0,     0,     0,     0,     0,
      35,   430,  1802,  1803,    37,    38,    39,    40,    41,    42,
      43,    44,     0,     0,     0,    45,     0,     0,     0,     0,
       0,     0,     0,     0,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,     0,     0,     0,     0,
       0,     0,     0,   442,   443,     0,   444,   445,   132,   446,
     447,   448,   134,   135,   136,   137,   138,     0,   449,   450,
     451,   452,   453,     0,     0,   454,   455,     0,   139,   456,
       0,   457,   458,   459,   460,   143,     0,   144,     0,   461,
     462,   463,   464,   147,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,     0,   150,   473,   474,     0,     0,
       0,     0,   151,     0,     0,     0,   476,   477,   478,   479,
       0,   480,   154,   155,   481,  2430,   482,     0,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,   497,   498,   499,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   163,   507,
     508,   509,   165,  2222,   510,     0,   511,   512,   167,   513,
       0,   514,     0,   515,   168,     0,   169,   516,   517,   518,
       0,   519,   171,     0,   172,   520,     0,   521,   522,     0,
     523,   524,   173,   525,   526,   527,   528,     0,   529,   530,
     531,   532,   533,   534,     0,   535,   175,   176,     0,   536,
     537,   538,     0,   177,     0,   178,     0,   539,   179,   180,
     540,   181,   541,   542,   543,   544,   545,     0,     0,   546,
     182,   183,   547,   184,     0,   548,   549,   550,     0,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,     0,   562,   563,   564,   189,   190,   191,   565,
     566,   192,     0,   567,   568,   194,   569,     0,   195,   570,
     196,   571,   572,   573,     0,   574,  2223,     0,   575,   576,
     577,     0,     0,   578,   197,   198,   579,   199,   200,   580,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     201,   590,   202,   591,   592,   593,     0,   594,   595,   596,
     597,   598,   599,   600,   601,   204,   602,   603,   604,   605,
       0,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,     0,   617,   618,   211,   619,   620,   621,   213,
     622,   623,   624,   625,   626,   627,     0,   628,     0,   629,
     630,   631,   632,   633,     0,   635,   636,   218,   637,   638,
     220,   639,   640,   221,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   223,     0,   653,
     654,     0,   655,   225,   656,   657,   658,   659,   660,     0,
     226,   227,     0,     0,   662,   663,   228,   664,   229,  2224,
     665,   666,   667,   668,   669,   670,   671,     0,     0,   672,
     673,   674,   675,   676,     0,     0,   677,   678,   679,   680,
     681,     0,   236,     0,   682,   237,   683,   684,   685,   686,
       0,     0,   687,     0,     0,   688,   689,   690,   691,   692,
     693,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       0,   694,   695,     0,     0,     0,     0,     0,    35,   430,
    1802,  1803,    37,    38,    39,    40,    41,    42,    43,    44,
       0,     0,     0,    45,     0,     0,     0,     0,     0,     0,
       0,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,     0,     0,     0,     0,     0,     0,
       0,   442,   443,     0,   444,   445,   132,   446,   447,   448,
     134,   135,   136,   137,   138,     0,   449,   450,   451,   452,
     453,     0,     0,   454,   455,     0,   139,   456,     0,   457,
     458,   459,   460,   143,     0,   144,     0,   461,   462,   463,
     464,   147,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   472,     0,   150,   473,   474,     0,     0,     0,     0,
     151,     0,     0,     0,   476,   477,   478,   479,     0,   480,
     154,   155,   481,     0,   482,     0,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,   497,   498,   499,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   163,   507,   508,   509,
     165,  2222,   510,     0,   511,   512,   167,   513,     0,   514,
       0,   515,   168,     0,   169,   516,   517,   518,     0,   519,
     171,     0,   172,   520,     0,   521,   522,     0,   523,   524,
     173,   525,   526,   527,   528,     0,   529,   530,   531,   532,
     533,   534,     0,   535,   175,   176,     0,   536,   537,   538,
       0,   177,     0,   178,     0,   539,   179,   180,   540,   181,
     541,   542,   543,   544,   545,     0,     0,   546,   182,   183,
     547,   184,     0,   548,   549,   550,     0,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,     0,   560,   561,
       0,   562,   563,   564,   189,   190,   191,   565,   566,   192,
       0,   567,   568,   194,   569,     0,   195,   570,   196,   571,
     572,   573,     0,   574,  2223,     0,   575,   576,   577,     0,
       0,   578,   197,   198,   579,   199,   200,   580,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   201,   590,
     202,   591,   592,   593,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   204,   602,   603,   604,   605,     0,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,   617,   618,   211,   619,   620,   621,   213,   622,   623,
     624,   625,   626,   627,     0,   628,     0,   629,   630,   631,
     632,   633,     0,   635,   636,   218,   637,   638,   220,   639,
     640,   221,   641,     0,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   223,     0,   653,   654,     0,
     655,   225,   656,   657,   658,   659,   660,     0,   226,   227,
       0,     0,   662,   663,   228,   664,   229,  2224,   665,   666,
     667,   668,   669,   670,   671,     0,     0,   672,   673,   674,
     675,   676,     0,     0,   677,   678,   679,   680,   681,     0,
     236,     0,   682,   237,   683,   684,   685,   686,     0,     0,
     687,     0,     0,   688,   689,   690,   691,   692,   693,   239,
     240,   241,   242,   243,   244,   245,   246,   247,     0,   694,
     695,     0,     0,     0,     0,     0,    35,   430,  1802,  1803,
      37,    38,    39,    40,    41,    42,     0,    44,     0,     0,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,     0,     0,     0,     0,     0,     0,     0,   442,
     443,     0,   444,   445,   132,   446,   447,   448,   134,   135,
     136,   137,   138,     0,   449,   450,   451,   452,   453,     0,
       0,   454,   455,     0,   139,   456,     0,   457,   458,   459,
     460,   143,     0,   144,     0,   461,   462,   463,   464,   147,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
       0,   150,   473,   474,     0,     0,     0,     0,   151,     0,
       0,     0,   476,   477,   478,   479,     0,   480,   154,   155,
     481,  3321,   482,     0,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,   497,   498,   499,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   163,   507,   508,   509,   165,  2222,
     510,     0,   511,   512,   167,   513,     0,   514,     0,   515,
     168,     0,   169,   516,   517,   518,     0,   519,   171,     0,
     172,   520,     0,   521,   522,     0,   523,   524,   173,   525,
     526,   527,   528,     0,   529,   530,   531,   532,   533,   534,
       0,   535,   175,   176,     0,   536,   537,   538,     0,   177,
       0,   178,     0,   539,   179,   180,   540,   181,   541,   542,
     543,   544,   545,     0,     0,   546,   182,   183,   547,   184,
       0,   548,   549,   550,     0,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,     0,   562,
     563,   564,   189,   190,   191,   565,   566,   192,     0,   567,
     568,   194,   569,     0,   195,   570,   196,   571,   572,   573,
       0,   574,  2223,     0,   575,   576,   577,     0,     0,   578,
     197,   198,   579,   199,   200,   580,   581,   582,   583,   584,
     585,   586,   587,     0,   588,   589,   201,   590,   202,   591,
     592,   593,     0,   594,   595,   596,   597,   598,   599,   600,
     601,   204,   602,   603,   604,   605,     0,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,     0,   617,
     618,   211,   619,   620,   621,   213,   622,   623,   624,   625,
     626,   627,     0,   628,     0,   629,   630,   631,   632,   633,
       0,   635,   636,   218,   637,   638,   220,   639,   640,   221,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   223,     0,   653,   654,     0,   655,   225,
     656,   657,   658,   659,   660,     0,   226,   227,     0,     0,
     662,   663,   228,   664,   229,  2224,   665,   666,   667,   668,
     669,   670,   671,     0,     0,   672,   673,   674,   675,   676,
       0,     0,   677,   678,   679,   680,   681,     0,   236,     0,
     682,   237,   683,   684,   685,   686,     0,     0,   687,     0,
       0,   688,   689,   690,   691,   692,   693,   239,   240,   241,
     242,   243,   244,   245,   246,   247,     0,   694,   695,     0,
       0,     0,     0,     0,    35,   430,  1040,  1041,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
       0,     0,     0,     0,     0,     0,     0,   442,   443,     0,
     444,   445,   132,   446,   447,   448,   134,   135,   136,   137,
     138,     0,   449,   450,   451,   452,   453,     0,     0,   454,
     455,     0,   139,   456,     0,   457,   458,   459,   460,   143,
       0,   144,     0,   461,   462,   463,   464,   147,   465,   466,
       0,     0,   467,   468,   469,   470,   471,   472,     0,   150,
     473,   474,     0,     0,     0,     0,   151,     0,     0,   475,
     476,   477,   478,   479,     0,   480,   154,   155,   481,     0,
     482,     0,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
     497,   498,   499,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   163,   507,   508,   509,   165,     0,   510,     0,
     511,   512,   167,   513,     0,   514,     0,   515,   168,     0,
     169,   516,   517,   518,     0,   519,   171,     0,   172,   520,
       0,   521,   522,     0,   523,   524,   173,   525,   526,   527,
     528,     0,   529,   530,   531,   532,   533,   534,     0,   535,
     175,   176,     0,   536,   537,   538,     0,   177,     0,   178,
       0,   539,   179,   180,   540,   181,   541,   542,   543,   544,
     545,     0,     0,   546,   182,   183,   547,   184,     0,   548,
     549,   550,     0,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,     0,   560,   561,     0,   562,   563,   564,
     189,   190,   191,   565,   566,   192,     0,   567,   568,   194,
     569,     0,   195,   570,   196,   571,   572,   573,     0,   574,
       0,     0,   575,   576,   577,     0,     0,   578,   197,   198,
     579,   199,   200,   580,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   201,   590,   202,   591,   592,   593,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   204,
     602,   603,   604,   605,     0,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,     0,   617,   618,   211,
     619,   620,   621,   213,   622,   623,   624,   625,   626,   627,
       0,   628,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   218,   637,   638,   220,   639,   640,   221,   641,     0,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   223,     0,   653,   654,     0,   655,   225,   656,   657,
     658,   659,   660,     0,   226,   227,   661,     0,   662,   663,
     228,   664,   229,     0,   665,   666,   667,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
     677,   678,   679,   680,   681,     0,   236,     0,   682,   237,
     683,   684,   685,   686,     0,     0,   687,     0,     0,   688,
     689,   690,   691,   692,   693,   239,   240,   241,   242,   243,
     244,   245,   246,   247,     0,   694,   695,    35,   430,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,   475,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,     0,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
    2222,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,  2223,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,  2224,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,     0,   476,   477,   478,   479,     0,   480,   154,
     155,   481,  2410,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,     0,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,     0,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,  2202,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,  1280,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,   475,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,  1297,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,   475,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,  1298,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,   475,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,  2777,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,   475,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
    3739,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,   475,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,   475,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,  1386,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,   475,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,  1468,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,   475,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,  1480,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,     0,     0,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,   475,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,  1494,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,  1495,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,    35,   694,   695,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   129,   130,     0,     0,     0,     0,     0,
     442,   443,     0,   444,   445,   132,   446,   447,   448,   134,
     135,   136,   137,   138,     0,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   139,   456,     0,   457,   458,
     459,   460,   143,     0,   144,     0,   461,   462,   463,   464,
     147,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,     0,   150,   473,   474,     0,     0,     0,     0,   151,
       0,     0,     0,   476,   477,   478,   479,     0,   480,   154,
     155,   481,     0,   482,     0,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,   497,   498,   499,     0,   500,   501,   502,
       0,   503,   504,   505,   506,   163,   507,   508,   509,   165,
       0,   510,     0,   511,   512,   167,   513,     0,   514,     0,
     515,   168,     0,   169,   516,   517,   518,     0,   519,   171,
       0,   172,   520,     0,   521,   522,     0,   523,   524,   173,
     525,   526,   527,   528,     0,   529,   530,   531,   532,   533,
     534,     0,   535,   175,   176,     0,   536,   537,   538,     0,
     177,     0,   178,     0,   539,   179,   180,   540,   181,   541,
     542,   543,   544,   545,     0,     0,   546,   182,   183,   547,
     184,     0,   548,   549,   550,     0,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,     0,
     562,   563,   564,   189,   190,   191,   565,   566,   192,     0,
     567,   568,   194,   569,     0,   195,   570,   196,   571,   572,
     573,     0,   574,     0,     0,   575,   576,   577,     0,     0,
     578,   197,   198,   579,   199,   200,   580,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   201,   590,   202,
     591,   592,   593,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   204,   602,   603,   604,   605,     0,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,     0,
     617,   618,   211,   619,   620,   621,   213,   622,   623,   624,
     625,   626,   627,     0,   628,     0,   629,   630,   631,   632,
     633,     0,   635,   636,   218,   637,   638,   220,   639,   640,
     221,   641,     0,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   223,     0,   653,   654,     0,   655,
     225,   656,   657,   658,   659,   660,     0,   226,   227,     0,
       0,   662,   663,   228,   664,   229,     0,   665,   666,   667,
     668,   669,   670,   671,     0,     0,   672,   673,   674,   675,
     676,     0,     0,   677,   678,   679,   680,   681,     0,   236,
       0,   682,   237,   683,   684,   685,   686,     0,     0,   687,
       0,     0,   688,   689,   690,   691,   692,   693,   239,   240,
     241,   242,   243,   244,   245,   246,   247,     0,   694,   695
};

static const yytype_int16 yycheck[] =
{
       2,  1520,   210,  1168,  1467,    78,  1113,    78,  1163,    78,
     249,   377,   393,    78,   393,  1471,  1476,   970,   166,  1050,
    1051,  1052,  1130,   153,   230,  1056,  1108,    78,  1233,    78,
    2261,  1877,  1439,  2840,   885,    84,   930,  1287,  1136,   224,
     188,   116,  1374,  1191,  1300,  1920,  2386,   149,   152,  1550,
    1459,    96,  1738,  1385,  1355,   116,  1427,  1428,  1310,  1914,
    3038,   106,   757,  1586,  1017,  3203,  1437,  2211,   164,  1120,
    2025,  3410,  1925,   203,  1920,   970,    78,   159,  3628,   930,
    1442,  2399,    84,   170,  1457,  1286,   161,    89,  3383,  2849,
    3670,  1292,  2096,   164,  2450,   989,   141,  3601,  2554,  2555,
     161,  1302,  1976,  4004,  1360,  1760,  3188,  3657,  1364,  1257,
    1936,   156,  2767,  1369,   116,  1416,    78,   131,  3435,  1512,
    3437,  1377,   881,   210,  2714,  2299,  1286,  3949,   365,   888,
    4004,  1387,  3585,  3590,  3014,  1988,  4278,  3590,   989,  1210,
     899,  1210,  3265,   758,  3192,  3864,  3190,  3191,   209,  4214,
     152,  4000,  3892,  2108,  1016,  4058,   217,   232,   219,   161,
      94,  1002,   379,  1116,  4267,  1851,   379,  1993,  1994,   928,
     209,   232,  2147,  4264,   933,  3257,  4281,  4290,  4265,  2283,
     219,  1756,  1796,  1797,  1798,   944,   217,  3898,   248,  3123,
    4277,  2474,  2393,  4268,  2476,  1906,  2200,   131,  1513,  3644,
    1504,  3296,  4742,  1533,  1855,  1425,  1426,   209,  1250,  3694,
    1160,   166,   116,  3967,  2554,   217,  1436,   219,   152,   153,
    4935,  1116,  3897,  3188,  1791,  1792,  4547,  3827,   162,  1160,
     232,  1205,  1206,   188,  4871,    10,  4873,    30,    87,    21,
    5053,    78,  1008,  1614,  1615,  4916,    87,    84,    74,    75,
      76,    77,   111,  2843,    14,    81,   124,   161,  4973,   138,
      14,  1632,   957,    87,    74,    75,    76,    77,  1661,   203,
      71,    81,    87,   179,   160,    74,    75,    76,    77,   116,
    1642,   102,    81,   865,   146,  4977,  4978,    84,   117,    98,
      89,    90,  3257,    74,    75,    76,    77,   236,   117,    14,
      81,   116,   115,  2807,   115,   185,    78,   154,   152,    71,
     210,  2815,   385,  2817,   385,    78,   385,    71,    80,    78,
     385,    78,  1353,    85,   161,   131,   102,    78,   232,  5248,
      98,   146,    78,   109,   385,   105,   104,  3271,  3385,    74,
      75,    76,    77,    71,   393,   230,    81,   235,   195,   245,
    5001,   131,   131,  2943,   260,  2945,    71,    85,   131,    74,
      75,    76,    77,    87,   131,    80,    81,    82,    83,   190,
      85,    78,  1520,    78,    78,    74,    75,    76,    77,   428,
     178,    78,    81,  1603,  1604,   235,    74,    75,    76,    77,
    2621,   393,   116,    81,   203,   232,   235,    78,   399,   102,
     337,    89,    90,   103,   185,  1513,   109,   184,  1628,    74,
      75,    76,    77,   216,   216,  1110,    81,   102,    74,    75,
      76,    77,   146,   385,   109,    81,   428,   148,    78,    74,
      75,    76,    77,    89,    90,   203,    81,  1331,   403,   138,
      74,    75,    76,    77,    89,    90,   368,    81,   235,   270,
    5164,  5165,   217,   148,   235,    89,    90,  1662,    74,    75,
      76,    77,   235,  5178,   385,    81,   235,   157,   396,  1954,
    1722,   278,   454,   373,  1959,    74,    75,    76,    77,   131,
    1331,   237,    81,   241,  1689,  5122,   867,  4552,   867,   518,
    5409,    74,    75,    76,    77,   429,   205,   403,    81,    14,
     148,   187,   531,  5043,   390,   352,   190,   148,  1032,   157,
     148,   267,  1036,  1037,  1038,   497,    71,    74,    75,    76,
      77,   257,  1046,  2008,    81,    80,  2501,  2012,   529,   336,
      85,   452,  3093,  3094,   440,   441,    37,  3098,    39,   138,
      74,    75,    76,    77,  1497,   148,   474,    81,    74,    75,
      76,    77,   178,  3600,   157,    81,   393,   661,    74,    75,
      76,    77,   499,   178,   529,    81,  2541,  1520,   276,  5220,
    2545,   271,  1720,  2036,  3135,  3136,  1684,  1725,  1726,   709,
     710,  2041,   350,   479,   192,   391,  4365,   408,  4367,  1697,
     529,   428,  1207,  1208,    74,    75,    76,    77,   131,   446,
      71,    81,  1497,    74,    75,    76,    77,   529,   235,    80,
      81,   391,   391,   385,    85,   418,   418,   385,   388,  1727,
    1728,   465,   385,   529,   391,   438,   385,   438,   385,   529,
     403,   428,  4089,   452,   385,  4700,  4089,  1590,   518,   385,
    4743,   529,   992,   441,   529,  1227,   532,   415,  4735,   425,
     529,   480,   473,  1003,  5573,  2341,    87,    29,   484,   661,
    1522,   529,  5333,   116,   473,   527,   426,  5359,  4007,   531,
     529,   452,   426,   522,   523,   524,   525,   454,   385,   480,
     385,   385,   532,  2258,   525,   116,  4236,  2262,   385,  2264,
     529,  1892,  2267,   475,  4759,  1590,   520,   521,   522,   523,
     524,   525,  2388,   529,   385,   480,  2392,  5520,   161,   894,
     525,   426,   276,   486,  4433,   146,  1972,   527,  1974,   529,
     497,   531,   425,  2055,   185,   490,   532,   661,  2029,  4469,
     529,   452,  1982,  4473,   527,   385,  1502,   518,    25,   391,
     425,   523,  3332,  2136,  1945,   532,  1894,  5461,  2204,  4460,
     531,  2252,   532,   532,  5469,  4259,  1904,   452,   520,   521,
     332,   496,   452,   532,  1717,   532,  5481,   432,   433,  4523,
     874,  2023,  1725,  1726,   532,   709,   710,  4377,  1017,   232,
     515,   490,  2635,  1020,  4459,   484,   105,   320,   863,   473,
    2665,   477,   520,   521,   529,  2166,   532,  1163,   522,   523,
     524,   525,   863,  2259,   452,   520,   521,     0,  3890,  5446,
    3892,   452,  2268,   178,   452,   441,  1964,   921,   867,  1967,
    1968,   322,  1717,   757,   532,   452,   441,   909,  1778,   959,
     529,  4316,  4317,  4318,  4319,  4320,  5157,  1811,  5553,   102,
     913,   529,   913,  3299,   913,  3301,  4911,  1778,   913,   452,
    3190,  3191,  3192,  4918,   190,    25,   185,  2710,   391,   276,
    4199,   863,   913,  3623,  3912,   867,   245,   475,   178,   871,
     190,  1913,  5412,   529,   332,   185,   980,  1062,   880,   881,
     496,  1029,   415,  1031,   529,  1033,   888,   235,  3206,  2037,
     452,  1039,  4187,  4338,  3989,   529,   268,   899,  1513,   515,
    5042,    14,  2217,  2233,  2208,  2298,  2299,   485,   320,  2239,
     178,  1013,  2305,   529,   916,  1063,  1064,  2568,  2311,  2312,
    2313,  1017,  4004,  2143,  2144,  3890,   928,  3892,  2321,  2322,
     529,   933,  5529,  2326,   270,  2502,  1153,  2504,   415,   494,
    1153,   320,   944,   227,  2655,  1016,   529,   408,   154,   140,
     270,  1136,   337,  3236,  4855,  3237,    98,   529,     2,   863,
     515,   963,   276,  1868,   276,   520,   521,   531,   970,  1014,
     532,  2344,   529,   975,   335,  3565,  3566,  5517,   178,   981,
     441,   144,  1167,   985,   986,   272,  1031,   415,  1033,   195,
     992,    96,   140,   322,   185,   529,   124,  4898,  1043,  1523,
    1002,  1003,  1526,   529,   245,  1529,  1008,  1531,  4303,  2883,
    1534,  4912,   322,   529,  1538,  1017,   237,  4796,  1063,  1064,
     481,  4800,  4801,   957,  4803,   959,   863,    25,   243,   336,
     867,  3965,    70,   494,  5631,   319,   213,    35,  4912,  4004,
      78,    79,  2897,   164,   193,   237,  1142,   412,   176,   529,
     521,   320,  3556,  1114,   515,   532,  1950,  1118,   140,  3563,
    3564,   203,  2581,  3567,  1249,  3266,   214,   479,   529,   388,
    3574,   529,   408,  2104,   403,   157,  1031,  1011,  1033,   320,
     399,  1015,   401,  1114,   232,   336,  1146,  1118,  1137,   520,
     521,   522,   523,   524,   525,   358,  4815,   274,  1112,  1950,
     479,   235,   272,   531,   452,  1107,  1108,  2215,  1063,  1064,
     164,   216,  1114,   190,  1116,   532,  1118,   338,   156,   240,
    4860,   431,  5264,  3227,   434,  4865,   185,  1477,  4868,  3585,
     276,   322,   214,  2338,  3590,  1137,   327,   473,   457,   137,
    1142,   269,  1144,  2550,   529,  4856,   352,   410,   323,   276,
     232,  2560,  5053,   473,   533,   236,  5259,  2062,  2265,  2266,
    5235,   475,  5275,   475,   180,   342,  5257,  5272,   529,   207,
    4627,  5258,   335,   441,  4627,   366,  1110,   236,  1112,  4759,
    4730,   396,   445,  5270,   447,  5260,   240,   187,   441,   380,
      70,    71,   320,   270,    74,    75,    76,    77,    78,    79,
      80,    81,  4541,  1205,  1206,    85,  1556,   332,   350,   401,
     332,  3667,   342,   434,   237,   336,   276,   110,   366,   529,
      71,   533,  1572,    74,    75,    76,    77,  1288,  1289,    80,
      81,    82,    83,   249,    85,   102,   385,  1587,   479,  1241,
     446,   441,   511,   385,  3219,  3806,  3807,  3808,  3809,  1288,
    1289,  3812,  3813,  3814,  3815,  3816,  3817,  3818,  3819,  3820,
    3821,   185,   300,   455,   323,  4582,   238,   229,  2221,   461,
     187,   392,   353,   415,   272,   239,   404,   468,   529,  1241,
     114,   157,   336,   150,   366,  2179,  1288,  1289,  4919,   235,
     467,   158,   185,   309,   399,   198,   312,   200,   473,   164,
    1137,  2142,   235,    78,   189,   185,  5155,  3868,  3869,   185,
    5413,   257,   350,   418,  1316,   338,  2930,  1399,   452,   186,
     468,  1323,   385,  5410,   257,  1327,  2434,   327,  2179,   475,
     276,   185,   527,   297,   108,   232,   478,   187,   392,   534,
     421,  1343,   306,   276,   235,    70,     8,   385,   475,    11,
      12,   389,   415,    78,    79,  1357,  2197,  5422,  2220,  5262,
      22,    23,    24,   280,    26,    27,   257,  5086,   342,    31,
      32,    33,  2520,   494,  5516,   240,  5007,   415,  5118,  5521,
    2487,   106,   107,   460,   518,   276,   468,  4469,   342,   164,
     406,  4473,   277,  1395,   261,   275,   473,   531,  4521,   361,
     530,  5302,   532,   327,   529,   322,   444,   529,   446,   530,
     863,   235,   533,   154,   154,   475,   475,   297,   336,   180,
      98,   255,  1661,    98,  2318,   238,  5327,  3002,   180,   332,
     280,  2763,   180,   257,  5576,   230,    70,  1439,   410,   303,
     494,  4485,  4490,   217,    78,    79,   322,   102,  4496,   342,
     349,  1522,   276,  5327,   195,   195,   494,   374,    98,   179,
    1841,  5180,  1841,  2664,   104,  5184,  5185,  2318,   322,  2540,
     442,  2540,   322,  2936,   249,  1477,   530,  4357,   100,   533,
    1525,   445,  1527,   447,  2940,  1530,  2946,  1532,   249,  4946,
    1535,  1536,  1537,  4946,   510,  1497,  5638,   249,   120,  1501,
    1502,   249,  1504,  1548,  4469,  3736,   415,   471,  4473,   234,
    1512,   236,  1749,   529,  5336,  5337,   178,  1562,  1520,  1564,
    2913,   154,   156,  5027,   374,   203,   415,  5158,   203,   475,
    2731,   340,  2864,  2865,  2866,  2867,  5167,   213,   378,   403,
     260,   350,   475,   198,  2876,  3400,  1763,  1764,   309,  1766,
    1763,  1764,  2753,  1766,  1556,   161,   249,   309,   532,     5,
     312,   309,   195,   203,   312,  3220,   178,   434,  1570,   122,
    1572,  2731,  3912,   207,   424,   416,   385,   215,   532,    25,
     444,   283,  2783,   309,   475,  1587,  2734,   533,  1590,    35,
     106,   107,   387,   306,  2742,  1780,  2744,   410,   326,  1601,
     533,   190,  2217,  4258,   379,  3779,   454,   471,  2909,   527,
     385,   352,   352,   531,   203,   532,   309,  3973,   294,  5520,
     258,   245,  3496,   532,   189,   518,   232,  1629,  2581,   442,
     494,   102,   496,  4089,   527,  1569,   529,   530,   531,   532,
     520,   521,   533,   532,    22,   406,  4207,   487,   164,   271,
     463,   475,   314,  3506,   406,  1657,  1658,  1659,   406,  1661,
      84,  1736,   112,    87,  5003,   529,   300,  4171,   184,   520,
     521,  1673,   350,  4177,  4178,  1736,  4180,   486,    84,  1681,
     406,    87,   225,   403,   452,    91,    92,    93,   529,  1703,
    1704,   137,   116,    71,   422,   132,   320,  5247,   122,   252,
     362,   217,  3095,   140,   257,   446,   446,   385,   320,   533,
     350,   203,   277,   406,  3107,  1717,   350,  3721,  1720,   352,
     440,   441,   146,  1725,  1726,  5547,   350,   198,   225,  2623,
     198,   350,   200,  1735,  1736,   239,  4326,   415,  4328,    70,
     293,  5245,  1791,  1792,   194,   385,  3139,    78,    79,   230,
     239,   294,  3327,   124,   177,   223,   202,   257,   510,   240,
     485,   385,   510,  1765,   532,   529,   385,  1769,  1770,  1703,
    1704,  5066,  2623,  4855,   363,   415,   257,   529,  4860,   365,
    1855,   491,  3799,  4865,  3177,  5289,  4868,   211,  1790,  1791,
    1792,   334,  1841,   297,  1855,  1809,   415,   294,   333,  1848,
     462,   336,  1987,   164,  1865,   176,   401,  1889,   297,  1811,
     444,  3828,   446,   446,   533,   187,  4898,  4795,   198,   227,
     200,  2171,   532,   184,  3650,   156,   272,  3653,   252,  5168,
    4912,   399,  1736,   257,  2184,   140,  3337,  3210,   282,  1841,
    2535,   146,  5422,   282,   303,  1906,  1848,  1849,   340,  2199,
     401,   257,   157,  1855,   322,   479,   217,  5174,  3006,   327,
     297,  2892,   457,  1865,   332,   381,  1868,   420,   454,   293,
    1872,  5421,   278,   452,   378,  1809,   320,   208,   286,   349,
     185,   320,   187,   532,   307,   385,  1790,   310,  3297,   389,
    4855,   452,   408,   309,  3303,  4860,   312,   389,   269,  1736,
    4865,  4708,  2661,  4868,  1906,   473,   457,  2726,   280,  3369,
     529,   497,  1914,   394,   338,   415,   365,   533,    87,    74,
      75,    76,    77,   415,  5062,   441,    81,  4734,  4906,    40,
    4908,   262,   338,  4898,    98,   374,  3307,   157,   303,   518,
     104,   445,   322,   447,   403,   415,  1948,  4912,  2901,   320,
     322,  1855,   332,  1790,  1791,  1792,   445,   518,   447,   264,
    4720,   389,  2781,   213,  1008,   481,  2725,   471,   342,   485,
     531,  5053,  4562,  4563,   418,   225,   188,   146,   494,   418,
     230,   408,   471,   487,  2059,   444,   535,   415,  4943,  5284,
     406,   459,  1954,   349,   494,   378,   420,  1959,  2059,   515,
    5339,   469,   374,   349,  1841,   454,  2901,  2009,   350,   187,
    2963,  1848,   471,   529,   441,   515,   188,   322,  1855,   239,
     381,  2780,   327,   475,   274,   356,   409,  2131,  2030,   473,
    4985,   405,   387,   404,   473,   494,  5118,   496,   403,   203,
     260,   253,  3197,  2045,   294,   231,  2008,   408,   497,   494,
    2012,  2053,   230,  4008,   481,   272,  3357,  2059,   441,   415,
    2062,   366,  2064,  3211,  2445,   188,  2445,  5571,  2963,   415,
     529,   100,  5622,   415,   399,   380,   262,   297,  2080,   444,
     441,   253,  2084,  2291,   334,   494,   264,   532,  5053,   513,
    2275,   120,   342,   196,  2096,   378,   520,   521,   522,   523,
     524,   525,   529,   206,   487,   430,   471,   159,   496,  2111,
     516,   517,   518,  1770,   520,   521,   522,   523,   524,   525,
     481,   341,  2124,   532,  5463,  2221,   409,   515,  2130,   494,
     253,   496,  3633,   494,  2136,   466,  3386,    16,   913,   494,
    2142,  3642,   320,   474,   322,  4485,   477,  1191,   200,  2220,
    4490,   475,  2154,  5118,   515,  2059,  4496,  3208,   441,  3734,
     515,  3411,  3848,   468,   529,   303,  1210,  2169,   529,  2171,
    2172,  4627,   327,  4677,   527,  4679,  4680,   532,   494,  4683,
     533,  4056,  2184,  4501,   475,  2230,  3387,  2232,  5326,  4042,
     475,  2236,  2194,  2238,    87,  2197,  2241,  2199,  2200,   515,
    2245,   385,   177,  2290,   487,   529,  2208,   187,   350,  2211,
    2283,   350,  2283,  1257,  2283,  2297,   532,   467,  2283,  2221,
    5302,     7,  2059,   116,    80,   445,   350,   447,   350,    85,
     457,   415,  2283,    19,    20,  4061,  4062,   457,   529,  3762,
    4093,  1016,  1017,   385,   529,  5327,   385,   350,   468,   322,
    4811,   471,    38,   146,   327,    41,   231,  3151,  3211,  2261,
    3461,   385,   368,   385,   198,  5604,   200,    74,    75,    76,
      77,   373,   530,   415,    81,   533,  2351,   527,   350,   389,
     530,   531,   385,  1736,   264,   487,   129,   262,  3974,   223,
    2351,   415,   331,   415,  2989,   303,  2298,  2299,   400,   372,
    3151,   350,  2304,  2305,  2078,   415,   444,  3770,  2310,  2311,
    2312,  2313,  2662,   385,   399,  2317,   401,  2319,  2320,  2321,
    2322,  2323,  2324,  2097,  2326,  4280,  2328,  2329,  3690,  3691,
    2332,   494,   307,   471,   177,   310,   385,  5302,  3594,   235,
     320,    50,   322,   415,  2346,  2347,  2348,  2349,  2350,  2351,
     527,  2447,   515,  2355,   531,   230,   494,  2359,   496,    68,
    2362,   257,  5327,  2365,  2366,  2367,  2368,  2369,  2370,  2371,
    2372,  2373,   457,  2375,   160,  2583,   251,  2585,  1153,   405,
    3231,  2383,  4526,   118,  2386,    74,    75,    76,    77,   230,
     494,   529,    81,   327,   336,   403,  2445,   165,   332,   341,
     374,  3354,  1855,    71,   139,   532,    70,  5545,  3801,   536,
     251,   515,   386,   199,    78,    79,   259,    85,  4758,   284,
    4266,   336,    74,    75,    76,    77,   341,   225,  4283,    81,
    5020,   530,   230,  2581,   533,    99,   444,   411,  5520,    34,
    5578,  2492,  3835,  2445,   236,  2447,   308,  2351,  2450,  2634,
     496,   529,   532,  2502,     2,  2504,   536,  1501,  1502,  3354,
    1504,   127,  2464,   471,   307,  3766,   148,   310,   236,   515,
    2574,  2473,  2474,   387,   266,   157,  1520,   320,    70,    71,
     146,   528,  5460,   529,  4988,   532,   494,  3880,   496,   281,
    4946,   528,   156,  2568,   160,   532,   294,   457,   266,   291,
    2502,   148,  2504,   457,  4005,  4006,   349,  2568,    84,  5647,
     157,    87,   496,   281,  2351,    91,    92,    93,   161,  1282,
     327,   529,  2524,   291,  5085,   459,   213,    84,   405,   303,
      87,   515,   108,   306,  1297,   469,   334,  1300,   225,   306,
    2542,    89,  2544,   230,   208,   529,   212,   390,  2550,   317,
     260,   408,  2554,  2555,    84,  5520,   524,   350,   445,   116,
     447,   529,  2564,   531,   225,   122,  2568,  2569,   336,   230,
     529,  2573,   531,    74,    75,    76,    77,   534,   524,  2581,
      81,    71,    70,   529,   441,   531,   429,   274,  3619,   146,
      78,    79,   385,   257,  2655,   284,   389,  2599,   262,  5055,
    2602,  2535,   308,   395,   152,   251,  2059,   294,  2445,   527,
     158,   529,  2614,   531,  2330,  3986,  2618,  2333,  2722,  2621,
     457,  2696,   415,  3771,   481,  4034,   153,   395,  2630,   403,
     445,  2692,   447,   294,  5208,  2696,  5210,   494,   186,   487,
    5214,  2643,  5216,  3596,   530,  3598,   532,   334,  3746,    74,
      75,    76,    77,  2655,   211,   342,    81,   128,   515,  2661,
    2662,   405,  2723,  2320,  2568,  2502,   284,  2504,  2670,   535,
     444,  2328,   529,   334,   529,   327,  1720,    85,    70,    71,
     529,  1725,  1726,   530,  3936,   532,    78,    79,   532,   533,
    2692,  2693,   356,    85,  2696,   252,   303,   471,  3903,   336,
     257,  3596,   278,  3598,  5511,  4580,   403,   475,   520,   521,
     522,   523,   524,  3666,  3106,   532,  3108,  3109,   530,   128,
     494,  2723,   496,  2725,  2726,   137,   138,  2729,   522,   523,
     524,  2568,   396,   530,  3585,   532,   293,   485,   527,  3590,
     529,   494,   530,   496,   532,  2747,   487,  1522,  2850,   399,
     400,  3906,  3907,  3908,   512,   529,  2758,   118,  1802,  1803,
    2835,   530,   338,   532,   280,  4340,  4341,  4342,  4999,  2771,
     529,  3666,   531,   339,  2835,   439,   399,   400,  2780,  2781,
     467,   338,   532,   533,  1828,  1829,   531,   530,  2692,   532,
     339,   530,  2696,   532,   399,   400,   403,   530,   336,   532,
    4486,   165,   466,   530,   530,   532,   532,  2464,   452,   530,
     474,   532,    84,   477,   336,    87,   303,   399,   400,    91,
      92,    93,  1597,   230,  2826,  2827,   327,   124,   530,   512,
     532,  4517,   530,  2835,   532,    84,   108,   444,    87,  2841,
     339,  1616,    91,    92,    93,  2847,    74,    75,    76,    77,
    1894,   118,   494,    81,   496,  2692,  3095,   512,   234,  2696,
    1904,   280,   522,   420,   471,    89,    90,   116,   530,   166,
     532,  1646,   236,   122,   530,    84,   532,  2879,    87,   530,
     529,   532,    91,    92,    93,   530,  1661,   494,   128,   496,
     530,   530,   532,   532,   191,  2897,   532,   146,  2351,  2901,
    3139,   530,   266,   532,   520,   521,   522,   523,   524,   530,
     207,  2913,   528,  4163,   211,   235,   403,   281,   276,   530,
    1964,   532,   529,  1967,  1968,    89,    90,   291,  4184,   323,
     324,  2835,   533,   530,   231,   532,  5276,   234,   522,   535,
     516,   517,   518,   272,   520,   521,   522,   523,   524,   525,
     247,    84,   535,   317,    87,   529,   513,   444,    91,    92,
      93,  2963,  4294,   520,   521,   522,   523,   524,   525,  2971,
     303,   530,   452,   532,  3324,  3325,  3182,  3183,  3184,    74,
      75,    76,    77,   530,   471,   532,    81,   209,  1763,  1764,
     445,  1766,   447,  2037,    74,    75,    76,    77,  2835,   452,
     452,    81,   324,   252,   452,   452,   278,   494,   257,   496,
    3012,   445,   111,   447,   408,   128,  4423,  4410,   530,   272,
     532,  3260,    74,    75,    76,    77,  3028,   529,  3030,    81,
     327,   395,   530,   530,   532,   532,  3038,   452,   335,  3114,
    3042,   278,   529,  3045,   293,  3120,  3048,   441,   530,    84,
     532,   529,    87,  3114,  3056,  2989,    91,    92,    93,  3120,
     530,   415,   532,  3065,   531,   530,   338,   532,  3070,   278,
     403,   498,     2,  4648,  4649,   372,  4651,    74,    75,    76,
      77,   530,   385,   532,    81,   529,   408,   481,   530,   338,
     532,  3093,  3094,  3095,   257,   530,  3098,   532,   218,   530,
     494,   532,   531,   218,  3106,  3107,  3108,  3109,   530,   336,
     532,   444,  3114,   661,   530,  2568,   532,  3119,  3120,   441,
    3122,   515,  3124,   494,   530,   496,   532,  3477,   530,   338,
     532,   257,   336,  3135,  3136,   529,  3486,  3139,   471,   530,
     530,   532,   532,   218,   530,   278,   532,   530,   530,   532,
     532,  3153,   385,  3155,  3227,  3157,  3227,   257,  3227,   481,
     218,   494,  3227,   496,  2208,   230,   336,  2211,   530,   385,
     532,   420,   494,   218,   533,  3177,  3227,   530,   303,   532,
     530,   530,   532,   532,   292,   530,  3188,   532,  3190,  3191,
    3192,   187,   475,   515,  5040,   336,   529,  4345,   530,   530,
     532,   532,   303,   308,   530,   338,   532,   529,   530,  3211,
    3114,   533,   530,  3215,   532,  4716,  3120,   530,   530,   532,
     532,   457,   530,    70,   532,   529,  3228,    74,    75,    76,
      77,    78,    79,   331,    81,   530,   166,   532,  4089,  2692,
     530,  3243,   532,  2696,   516,   517,   518,   405,   520,   521,
     522,   523,   524,   525,   530,  3257,   532,   530,   188,   532,
    3610,   530,  3612,   532,   513,   230,   487,   516,   517,   518,
     284,   520,   521,   522,   523,   524,   525,  3114,   403,   530,
     530,   532,   532,  3120,   530,   530,   532,   532,   530,   530,
     532,   532,   530,   111,  3296,  5526,  5527,  3299,   530,  3301,
     532,   140,   403,   338,  3306,   322,  3308,   516,   517,   518,
     529,   520,   521,   522,   523,   524,   525,    84,   498,   444,
      87,   529,  3324,  3325,    91,    92,    93,   530,  3330,   532,
     530,   336,   532,   180,   530,   530,   532,   532,   530,   322,
     532,   108,  4547,   444,   118,   530,   471,   532,   530,  3351,
     532,   530,  3354,   532,   118,   530,  3358,   532,   530,   530,
     532,   532,   910,   530,   530,   532,   532,   230,   462,   494,
     471,   496,   350,  3375,  3435,  3436,  3437,  1157,  4474,  1159,
    4476,   487,  2835,   516,   517,   518,   230,   520,   521,   522,
     523,   524,   525,   494,   487,   496,   153,   369,  3400,  3474,
     534,   218,   249,   218,   529,   529,   218,   484,   529,   362,
     529,  3761,   218,  3474,   110,   498,   218,   218,   532,   218,
     218,   336,   970,   971,   218,   218,  5657,  5658,   529,  2473,
    2474,  4513,   336,  3435,  3436,  3437,  3093,  3094,   218,   218,
     230,  3098,   218,   336,   529,  2220,   218,   218,   218,   441,
     111,   292,   230,   230,   336,   529,   529,  3459,   529,   529,
    1008,   230,   309,   529,   495,   312,   529,  3469,   529,  3471,
    3472,   347,  3474,   529,   529,  3477,  2520,   111,  3135,  3136,
     529,   516,   517,   518,  3486,   520,   521,   522,   523,   524,
     525,   529,   529,   529,   276,   529,  2540,   529,  2542,   529,
    2544,   529,   529,   529,   529,   529,   529,   529,  2283,   529,
    3876,   278,   168,   529,  3589,   276,   529,   529,   529,  1067,
     278,   111,   532,   532,   292,   230,   334,   230,  3589,   332,
    3532,  3435,  3436,  3437,   415,   522,  5111,   272,   406,   312,
     184,   532,   474,   532,   518,    14,   532,  5122,   529,  3551,
    3680,   452,   529,  1101,   529,  3557,   452,   403,   531,   406,
     452,  3746,   452,  1111,   294,   403,   452,  1115,  1116,  1117,
    3474,   338,   452,  3677,   518,   452,   157,   403,   218,   407,
     336,  2356,  3584,  3585,   336,   289,   452,  3589,  3590,   327,
     452,   452,   444,   336,  3596,  3646,  3598,   336,  3435,  3436,
    3437,   474,   399,   332,   529,  3656,   529,   452,  3610,   452,
    3612,   250,  4506,   157,    84,   532,   350,    87,   218,   257,
     475,    91,    92,    93,   475,  5200,   179,   452,   452,  3680,
     452,   128,    84,   128,   340,  3874,   452,  3474,   108,    91,
      92,    93,   452,   452,   444,   452,   117,  3649,   452,   117,
     403,   336,   278,  3892,   532,  4506,   452,  1205,  1206,   336,
     452,  3114,  1210,   510,  3666,  3667,   452,  3120,   498,   336,
    4701,   278,   278,   494,   462,   529,  3882,  3883,  3884,  3885,
    3682,   111,   100,   336,   218,  3589,  5205,   452,   475,   322,
    2734,   185,   529,   218,   322,   486,   300,  5090,  2742,   322,
    2744,   332,   111,   230,   111,   284,   529,   404,   110,   450,
     529,   531,   452,   450,   527,   415,   527,  2492,  5181,  3721,
    4875,   452,  5182,    14,   475,   218,   218,  4882,   218,   475,
     218,   218,   331,  5308,  3736,  4900,  5129,  3739,   452,   326,
    5196,  4997,  5198,   532,   235,   490,  3680,   314,   529,   516,
     517,   518,  3589,   520,   521,   522,   523,   524,   525,  3761,
      84,    87,  3764,    87,   314,   452,  3841,   450,   243,   532,
     529,   226,   235,   454,   529,   274,  4627,   250,   532,  3781,
    3841,   529,  3784,   532,   534,   518,  4894,   475,  3790,   250,
     532,   418,   116,   282,  3796,   337,  3798,   111,   122,  3801,
     532,    34,   530,  3805,  3806,  3807,  3808,  3809,   278,   530,
    3812,  3813,  3814,  3815,  3816,  3817,  3818,  3819,  3820,  3821,
     530,    10,   146,  3825,  3826,   344,   128,   452,  3830,   530,
     452,   403,   403,  3835,   529,   282,   282,  3839,   475,  3841,
     452,  3843,   327,   327,   452,   529,   308,   452,  5367,  3851,
     405,   487,  3854,   230,  3856,   457,   284,   220,   336,   118,
     327,   424,  3864,  3865,   322,   220,  3868,  3869,   338,   292,
     292,  3873,  3874,   292,  5375,  5376,   399,   452,  3880,   335,
    4230,  4231,   444,   336,   532,   336,   338,   211,  3890,   385,
    3892,   452,   251,  4243,   412,   452,   452,   374,   278,   111,
     278,   475,  3904,   278,   278,   475,  5299,   278,  3910,  3911,
    3912,  5018,   284,   260,   371,   335,   232,   518,  5311,   218,
     518,   230,   487,  5316,   230,  5318,   332,   217,   252,   412,
     218,   218,   529,   257,  4315,   529,  4315,  3841,   322,   111,
     494,   322,   336,   336,   284,   523,   230,   248,   248,  1497,
    5105,   111,   512,  1501,  1502,   312,  1504,   530,  3960,   527,
     512,   530,  3006,   218,   530,   284,   530,   336,   336,   293,
     336,  3973,  1520,  4121,   412,   257,   230,   322,   257,   530,
     257,   498,  3435,  3436,  3437,   532,   532,  3989,  5489,   532,
      99,   241,   452,   529,   235,   336,   311,   532,   128,   441,
     331,   284,  4004,   457,  3841,   487,   530,   235,   494,   530,
     530,   347,   355,  4088,   338,  4090,   530,   530,  1566,  4913,
     530,  3474,  4083,   530,   529,   235,   530,  4088,   529,  4090,
     532,   452,   530,   512,   346,  4037,   473,   302,   514,   337,
     337,  5560,  1590,   491,   336,   481,   516,   517,   518,   530,
     520,   521,   522,   523,   524,   525,   530,  5205,   530,   491,
     128,   336,  4913,  4957,   516,   517,   518,   533,   520,   521,
     522,   523,   524,   525,   336,   518,   339,   518,  1008,   529,
     529,  4083,   260,   218,   529,   529,  4088,  4089,  4090,   268,
     452,  5554,   532,   532,   529,  4946,   420,   530,   529,  1029,
     498,  1031,   452,  1033,   530,   327,  4957,   322,   452,  1039,
    1040,  1041,   218,   452,   340,  1663,   218,   218,   407,   292,
     260,   407,   407,   220,  1672,   452,   475,   294,   304,   356,
     472,   356,   452,  1063,  1064,   452,  3589,   403,  1686,   452,
    4142,   452,   304,  4145,   452,   304,   403,   452,   452,  3806,
    3807,  3808,  3809,   336,   403,  3812,  3813,  3814,  3815,  3816,
    3817,  3818,  3819,  3820,  3821,   403,   322,  3211,   415,  1717,
     218,   452,  1720,  1721,   452,   117,   452,  1725,  1726,  4083,
     452,   452,  3839,   452,  4088,   278,  4090,   278,   278,   513,
     278,  3235,  3236,   245,   532,   530,   520,   521,   522,   523,
     524,   525,   530,   118,   462,  4207,   452,    84,   178,   530,
      87,  3868,  3869,   387,    91,    92,    93,   335,   111,   336,
     218,   452,   532,   101,  4275,   218,   529,  4577,  4230,  4231,
     230,   108,  4234,   245,   530,   528,   138,   218,   475,   116,
     475,  4243,   230,  4245,   339,   122,  4083,    84,   403,   529,
      87,  4088,  5205,  4090,   403,   403,   216,   216,   532,   412,
     278,  1191,   278,  1811,   278,   209,  4315,   527,   235,   146,
     148,    87,   347,   230,   235,   486,   532,   530,   530,   116,
    1210,  4283,  4284,  4285,   529,   122,   530,  1444,  4339,   342,
    4640,   530,   491,   243,   530,   235,   515,   518,   532,   529,
     532,   179,   337,   532,   155,   528,   530,  5338,   392,   146,
     530,   518,   530,  4315,   230,   529,   462,   111,   475,   284,
    3095,   475,   268,   201,   452,   128,   218,  1257,  1485,   444,
      70,  4539,   529,   462,   212,   407,  1493,   403,    78,    79,
     452,   452,  1499,   403,    84,   452,  4348,    87,   452,   452,
     530,    91,    92,    93,   232,   530,   385,   518,   529,   237,
     530,   494,   128,   444,  3139,   230,   220,  4369,   108,   146,
     218,   111,   178,   462,   211,   252,   116,   278,  4380,   530,
     257,  3156,   122,   278,   278,   529,   282,   278,  3841,   494,
     370,   529,   263,   529,   230,   532,   530,  3172,   498,   111,
     532,   278,   279,   151,   444,   532,   146,   285,  4410,   529,
     532,   462,    84,  3188,  5367,   252,   293,   530,  4420,  4421,
     257,  4423,   452,   412,   178,  4427,  4428,   240,   306,   528,
    4432,  4433,  1980,   529,   235,  4437,   278,   278,  4440,  4441,
    4588,  5335,   235,  4445,   278,   278,   379,   530,   325,  4451,
     529,   128,  3227,   530,   492,   492,   293,   530,   532,   347,
     530,   338,   529,   281,  4515,   530,   529,  4469,   443,   345,
     281,  4473,   529,   343,   128,   246,   530,   332,  4315,   518,
     530,   530,  3257,  4485,  5335,  3260,   462,   494,  4490,   452,
     235,   369,   262,   146,  4496,   327,   327,    84,   518,   128,
      87,   338,   140,   444,    91,    92,    93,   532,   532,   452,
     218,  4513,   252,   452,   452,   278,   529,   257,   396,   237,
     235,  4582,   475,   257,  4526,   403,   529,   412,   475,   116,
     111,   409,   322,   204,  2082,   122,   490,   217,   278,   279,
    4542,  3585,   494,   420,   111,   494,  3590,   235,   336,   230,
    4207,  4626,   529,   293,   265,   339,   530,   276,  4560,   146,
     235,   529,   379,   441,   428,  4626,   444,   529,   480,   354,
     380,  1501,  1502,   529,  1504,  4577,   281,   157,   199,   530,
    4582,   336,   530,   420,   462,   325,   493,   230,   192,  4591,
    1520,    84,   529,   529,    87,   530,   530,  4947,   338,   452,
     452,   341,   529,   529,   529,  4607,   111,  5560,   305,   487,
    4612,   327,   260,   370,   217,   529,   529,  4619,   218,   530,
     529,   111,   530,   116,  4626,  4627,   340,   400,  4630,   122,
    4083,   400,   462,   530,   426,  4088,   513,  4090,  4640,   516,
     517,   518,   128,   520,   521,   522,   523,   524,   525,   518,
     426,   128,   111,   146,   529,   529,   475,   530,   530,   320,
    2208,   529,   529,  2211,   444,   252,   532,   529,  4670,   444,
     257,   336,   444,   530,    81,   224,   513,   370,  4582,   140,
     420,   339,   140,   520,   521,   522,   523,   524,   525,   199,
    4692,   278,   279,   479,   494,   494,    84,   379,   480,   111,
     529,  4703,   529,   235,   532,   415,   293,   444,   491,   377,
     230,   327,   204,   336,   262,   529,   336,   412,   211,   111,
     111,   339,  4626,   237,   339,   529,   237,  3771,   530,   128,
     399,   529,   529,   190,   530,   473,    81,   399,   325,   530,
     529,   386,    97,   108,   217,  4582,   452,   235,   529,   385,
     426,   338,   426,   532,   532,   494,  4758,   370,  4760,   252,
    2848,   494,  2310,   237,   257,   529,   237,  2011,  1726,  3211,
    2705,  4088,  1288,   513,  1289,  3411,   516,   517,   518,  2775,
     520,   521,   522,   523,   524,   525,  4186,  3581,  1253,  4626,
    1720,  5218,  5365,  4795,  5036,  1725,  1726,  5560,  4228,  5040,
     293,  4694,  5017,  3331,  2994,  5467,  4912,  5551,  5393,  4811,
    5498,  5392,  3335,  4815,  4276,  4261,  4220,  2838,  4820,  2838,
    2083,  4083,  3436,  4244,  4719,  2832,  5562,  3635,  5656,  5637,
    5012,  3589,  5509,   420,  3584,  4837,  4838,  4959,  2072,  4841,
    5353,  5477,  4962,  4348,   188,   338,  1557,  5154,  4893,  1573,
    2555,  4283,  3306,  4855,  5276,   971,  2286,  1000,  4860,  2287,
    2286,  3535,  4626,  4865,  5525,  5640,  4868,  4869,  1872,  2417,
    1800,  3646,  1802,  1803,  4876,  4877,  2447,  2221,  2448,  4516,
    1131,  3656,  5459,    89,  3971,  1515,  2977,  3228,  1755,  1773,
    5129,  1821,  1697,  1772,  3243,  2464,  4898,  2490,  1828,  1829,
    3915,  5452,  5320,  4499,  4906,  3680,  4908,  3257,  2489,  3892,
    4912,  1775,  5151,  4460,  4475,  5119,  5302,  3890,  4993,  5301,
    1780,  3972,  3700,  5088,  3843,  4884,   513,   420,  5455,   516,
     517,   518,  4993,   520,   521,   522,   523,   524,   525,  5456,
    5442,  2380,  3231,  3156,  4946,  4947,  3066,  3215,   871,  3154,
    2383,  2902,   661,  3677,  4956,  5433,  2118,   880,  1792,  2524,
     394,  1228,  2499,  1010,  1894,  1208,  1569,  2540,  2125,  1403,
    2532,  5022,  1786,  3205,  1904,  2533,  2524,  3978,  4500,  3942,
    3979,  1700,   427,  2544,  5035,  2990,  2250,     2,    -1,  1501,
      -1,  4993,  2540,   916,  2542,  1208,  2544,  4999,  1042,  5050,
    4894,    -1,    -1,    -1,    -1,  1790,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2170,    -1,    -1,    -1,  2174,    -1,    -1,
     513,    -1,    -1,  2180,  2181,    -1,    -1,   520,   521,   522,
     523,   524,   525,  2581,  1964,    -1,    -1,  1967,  1968,    84,
      -1,    -1,    87,   130,    -1,  4089,  2203,    -1,    -1,    -1,
      -1,  5053,   975,  5055,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   985,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,    -1,    -1,    -1,   163,   122,    -1,    -1,
      -1,    -1,    -1,  5085,  5086,    -1,  5088,    -1,  5090,  4993,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3874,
      -1,   146,  2650,    -1,    -1,    -1,   193,  2037,    -1,    -1,
      -1,    -1,  5114,  5174,    -1,  3890,  5118,  3892,    -1,    -1,
      -1,    -1,  5124,    -1,    -1,    -1,    -1,  5129,    -1,  4582,
      -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4191,  4192,  5151,
      -1,    -1,    -1,    -1,  4811,    -1,  4993,    -1,    -1,    -1,
      -1,    -1,    -1,  4820,    -1,    -1,   211,   254,    -1,    -1,
      -1,    -1,  5174,  4626,    -1,    -1,    -1,    -1,  5180,    -1,
      -1,    -1,  5184,  5185,    -1,    -1,  2116,  5189,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   289,  5205,    -1,  5256,    -1,   252,    -1,    -1,
    2140,    -1,   257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2150,    -1,  2152,    -1,    -1,    -1,    -1,    -1,    -1,  2159,
      -1,  5233,    -1,    -1,  2164,   322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   293,    -1,
      -1,  2799,  5254,    -1,    -1,    -1,    -1,    -1,    -1,  2807,
      -1,    -1,    98,   350,   351,    -1,    -1,  2815,   104,  2817,
    5174,    -1,    -1,    -1,  5276,  5277,    -1,    -1,  2208,    -1,
      -1,  2211,    -1,    -1,    -1,  5287,    -1,  2444,    78,    -1,
    5365,    -1,    -1,   338,    84,    -1,    -1,  5299,   385,    89,
    5302,  4345,   389,    -1,  5365,    -1,   393,    -1,   144,  5311,
      -1,    -1,    -1,   400,  5316,  2863,  5318,    -1,  5320,    -1,
     407,    -1,    -1,    -1,    84,  5327,   116,    87,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5174,    -1,    -1,
     427,  5580,  5344,    -1,    -1,  2893,    -1,    -1,   435,    -1,
      -1,    -1,    -1,  2901,    -1,    -1,   116,   193,    -1,    -1,
     196,    -1,   122,  5365,    -1,  5367,    -1,   203,    -1,    -1,
     206,   161,    -1,    -1,    -1,   420,    -1,  2307,  2308,  2927,
      -1,    -1,    -1,    -1,  2314,  2315,   146,    -1,    -1,    -1,
      -1,    -1,    -1,  1316,    -1,   231,    -1,    98,    -1,    -1,
      -1,    -1,   489,   104,  1327,    -1,  5408,    -1,    -1,    -1,
      -1,    -1,    -1,  2343,    -1,  2963,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   217,  5085,   219,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5441,
    5442,    -1,   232,   144,    -1,    -1,    -1,    -1,    -1,    -1,
    5452,    -1,  5525,    -1,  5525,    -1,  5525,  4501,  5460,  5510,
    5525,  5365,    -1,    -1,    -1,    -1,    -1,    -1,   513,  2399,
    5472,    -1,  1395,    -1,  5525,   520,   521,   522,   523,   524,
     525,    -1,  4526,    -1,   320,    -1,   322,    -1,    -1,    -1,
      -1,    -1,   252,    -1,    -1,   196,   332,   257,    -1,  5574,
    4275,    -1,   203,    -1,   340,   206,    -1,  5580,    -1,  5580,
      -1,  5580,    -1,  5574,   350,  5580,    -1,    -1,  5520,    -1,
      -1,    -1,    -1,    -1,  5526,  5527,    -1,  5529,  5365,  5580,
     231,    -1,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,
    4993,    -1,    -1,  2473,  2474,    -1,  5548,    -1,    -1,   385,
      -1,    -1,   388,   389,    -1,    -1,    -1,    -1,  5560,    -1,
      -1,   262,  5637,    -1,  4339,    -1,    -1,  5640,    -1,  5640,
      -1,  5640,  5574,    -1,    -1,  5640,  5637,    -1,   338,   415,
      -1,  5656,    -1,  4627,    -1,    -1,    -1,    -1,    -1,  5640,
    2520,    -1,    -1,    -1,    -1,  5656,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   393,    -1,    -1,    -1,    -1,    -1,    -1,
    2540,   130,  2542,    -1,  2544,    -1,    -1,    -1,    -1,   320,
      -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5631,
    5632,   332,    -1,    -1,    -1,  5637,    -1,    -1,   428,   340,
      -1,    -1,   478,  5645,   163,    -1,    -1,    -1,    -1,   350,
      -1,  2581,    -1,    -1,  5656,  5657,  5658,    -1,    -1,    -1,
     420,    -1,    -1,  3211,    -1,    -1,    -1,    -1,    -1,    -1,
    5574,    -1,    -1,    -1,    -1,   881,    -1,    -1,    -1,    -1,
      -1,    -1,   888,    -1,   385,    -1,    -1,   388,   389,    -1,
      -1,    89,    -1,   899,  4469,    -1,    -1,    -1,  4473,    -1,
      -1,    -1,   221,    -1,    96,    -1,    -1,    -1,    -1,   101,
      -1,    -1,    -1,    -1,   415,    -1,    -1,    -1,    -1,    -1,
      -1,  5174,   928,    -1,    -1,    -1,    -1,   933,    -1,    -1,
      -1,    -1,    -1,  5637,    -1,   254,    -1,  5574,   944,    -1,
    4515,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5656,   513,    -1,   147,    -1,    -1,    -1,  2916,
     520,   521,   522,   523,   524,   525,    -1,    -1,   166,   161,
     289,    -1,    -1,    -1,    -1,    -1,    -1,   478,  2935,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     188,    -1,    -1,  2950,    -1,    -1,  2953,  2954,    -1,    -1,
    5637,  2958,  2959,   322,  2734,    -1,  3354,    -1,  2965,   201,
      -1,    -1,  2742,    -1,  2744,    -1,    -1,    -1,    -1,  5656,
     212,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
      -1,   101,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     232,    -1,  4886,   113,    -1,   237,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
     389,    -1,   391,   981,   393,    -1,    -1,   147,    -1,    -1,
      -1,   400,    -1,  3040,    -1,    -1,    -1,    -1,   407,    -1,
      -1,   161,    -1,  3441,  1002,    -1,   415,    -1,    -1,    -1,
      -1,    -1,  4946,    -1,    -1,    -1,    -1,    -1,   427,   179,
      -1,    -1,  5365,    -1,   306,    -1,   435,    -1,    -1,    84,
      -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,    -1,
      -1,   201,    -1,    -1,    -1,    -1,  3484,    -1,    -1,    -1,
      -1,    -1,   212,   108,    -1,    -1,   338,    -1,    -1,    -1,
     220,   116,    -1,    -1,    -1,    -1,    84,   122,    -1,    87,
      -1,    -1,   232,    91,    92,    93,    -1,   237,    -1,    -1,
     489,    -1,    -1,   243,    -1,    -1,    -1,   369,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,  3534,    -1,   116,    -1,
     260,    -1,    -1,    -1,   122,    -1,  2926,  2927,    -1,  1205,
    1206,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3556,    -1,
      -1,   403,    -1,    -1,    -1,  3563,  3564,   409,   146,  3567,
     412,    -1,    -1,    -1,    -1,    -1,  3574,    -1,    -1,  3577,
      -1,    -1,    -1,    -1,    -1,    -1,   306,  3585,    -1,    -1,
      -1,    -1,  3590,    -1,    -1,    -1,    -1,    -1,  3596,   441,
    3598,    -1,    -1,    -1,    -1,    -1,   448,    -1,    -1,    -1,
      -1,    -1,    -1,   455,    -1,    -1,    -1,    -1,   338,    -1,
     462,    -1,    -1,   863,    -1,    -1,  3006,   867,    -1,   349,
      -1,    -1,    -1,    -1,    -1,  4860,    -1,   252,  3636,   359,
    4865,   881,   257,  4868,    -1,   487,    -1,    -1,   888,   369,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   899,
      -1,    -1,    -1,   278,   279,    -1,    -1,  3665,  3666,    -1,
      -1,  5574,    -1,    -1,   252,  4900,   396,    -1,   293,   257,
      -1,   401,    -1,   403,    -1,    -1,    -1,    -1,   928,   409,
      -1,    -1,   412,   933,    -1,    -1,  3694,    -1,    -1,    -1,
     278,   279,    -1,    -1,   944,    -1,    -1,    -1,    -1,    -1,
     325,  5205,    -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,
      -1,   441,    -1,   338,   444,    -1,   341,    -1,   448,    -1,
     970,    -1,    -1,  3340,  5637,   455,    -1,   457,    -1,    -1,
      -1,    -1,   462,   111,    -1,    -1,   986,   325,    -1,    -1,
      -1,  2124,   992,  5656,   474,    -1,    -1,    -1,    -1,    -1,
     338,    -1,   130,  1003,    -1,  1323,    -1,   487,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1017,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1343,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   163,  2169,  5022,    -1,  1357,
      -1,    -1,    -1,    -1,    -1,   420,    -1,    -1,    -1,    -1,
    5035,    -1,    -1,  3420,    -1,  3422,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5050,  3206,    -1,    -1,  3209,
      -1,  3211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3850,   221,    -1,  3235,  3236,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1114,    -1,  1116,    -1,  1118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   254,    -1,  2261,    -1,
      -1,    -1,    -1,  5118,    -1,    -1,    -1,  1137,   513,    -1,
      -1,   516,   517,   518,  5129,   520,   521,   522,   523,   524,
     525,    -1,    -1,    -1,    -1,    -1,   284,   532,    -1,    -1,
      -1,   289,    -1,    -1,  3531,    -1,  5151,    -1,    -1,    -1,
    3537,    -1,    -1,    -1,    -1,   513,    -1,    -1,   516,   517,
     518,    -1,   520,   521,   522,   523,   524,   525,    -1,    -1,
      -1,    78,    -1,    -1,   322,    -1,    -1,    84,   111,    -1,
      -1,    -1,    89,    -1,    -1,  1205,  1206,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,
      -1,    -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,   116,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,
      -1,    87,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
     163,    -1,  1570,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   389,   108,    -1,    -1,   393,    -1,    -1,    -1,    -1,
     116,  5256,   400,    -1,   161,    -1,   122,    98,    -1,   407,
      -1,    -1,    -1,   104,    -1,    -1,    -1,   415,  1288,  1289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
     146,    -1,    -1,    -1,    -1,    -1,    -1,   435,   221,    -1,
      -1,    -1,    -1,    -1,  3681,    -1,    -1,    -1,    -1,    -1,
    5574,    -1,    -1,   144,    -1,    -1,    -1,   455,    -1,    -1,
      -1,  4089,    -1,    -1,    -1,    -1,    -1,  3704,  3705,    -1,
    3707,   254,  3709,  3710,    -1,   232,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3722,    -1,    -1,    -1,    -1,
      -1,   489,    -1,    -1,  4122,   493,   494,  4125,    -1,  4127,
      -1,   284,   193,    -1,    -1,   196,   289,    -1,    -1,    -1,
      -1,    -1,   203,  5637,    -1,   206,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1811,  3763,    -1,    -1,    -1,
      -1,    -1,  5656,    -1,    -1,    -1,   252,    -1,    -1,   322,
     231,   257,    -1,  4171,    -1,    -1,    -1,    -1,    -1,  4177,
    4178,  1029,  4180,  1031,    -1,  1033,    -1,    -1,  4186,    -1,
      -1,  1039,   278,   279,    -1,    -1,    -1,    -1,   351,    -1,
      -1,   262,    -1,    -1,    -1,  3585,    -1,   293,    -1,    -1,
    3590,    84,    -1,    -1,    87,  1063,  1064,    -1,    91,    92,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3613,    -1,   108,   389,  1477,    -1,   325,
     393,  2614,    -1,   116,    -1,    -1,    -1,   400,  2621,   122,
      -1,    -1,   338,    -1,   407,   341,    -1,  1497,    -1,   320,
      -1,   322,   415,    -1,    -1,    -1,   393,    -1,    -1,    -1,
      -1,   332,    -1,   146,   427,    -1,    -1,    -1,   111,   340,
    1520,  4279,   435,    -1,    -1,  5510,    -1,    -1,    -1,   350,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    5525,   428,   455,    -1,    -1,    -1,    -1,  3687,    -1,    -1,
      -1,    -1,    -1,    -1,  3694,    -1,  1556,    -1,  4316,  4317,
    4318,  4319,  4320,    -1,   385,    -1,    -1,   388,   389,    -1,
     163,    -1,  1572,    -1,   420,    -1,   489,    -1,    -1,    -1,
     493,    -1,    -1,  1191,    -1,    -1,    -1,  1587,    -1,    -1,
    1590,    -1,    -1,  2009,   415,  5580,    -1,  1205,  1206,    -1,
      -1,    -1,  1210,    -1,  4362,    -1,    -1,  4365,    -1,  4367,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
      -1,    -1,    -1,    -1,   257,    -1,    -1,    -1,   221,    -1,
    1948,  3771,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   278,   279,    -1,    -1,  1257,
      -1,    -1,    -1,    -1,    -1,  5640,    -1,   478,    -1,    -1,
     293,   254,    -1,    -1,  2080,    -1,    -1,   513,  2084,    -1,
     516,   517,   518,    -1,   520,   521,   522,   523,   524,   525,
    2096,    -1,    -1,    -1,    -1,    -1,   532,    -1,    -1,    -1,
      -1,   284,   325,    -1,    -1,    -1,   289,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   338,    -1,    -1,   341,    -1,
      -1,    -1,  2030,    -1,    -1,    -1,    -1,  1717,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1725,  1726,  2045,    -1,   322,
      -1,    -1,    -1,    -1,    -1,    -1,  1736,    -1,    -1,    -1,
    4498,    -1,    -1,  4501,  4502,    -1,  2064,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2172,    -1,   351,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4526,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2200,    -1,    -1,   420,    -1,    -1,
    1790,  1791,  1792,  2111,    -1,    -1,   389,    -1,    -1,    -1,
     393,    -1,    -1,    -1,    -1,    -1,    -1,   400,    -1,    -1,
      -1,  1811,  2130,    -1,   407,    -1,    -1,    -1,    -1,    -1,
      84,    -1,   415,    87,  2142,    -1,    -1,    91,    92,    93,
      -1,    -1,    -1,    -1,   427,  3975,  2154,    -1,    -1,    -1,
      -1,  1841,   435,    -1,   108,    -1,    -1,    -1,  1848,    -1,
      -1,    -1,   116,    -1,    -1,  1855,    -1,    -1,   122,    -1,
      -1,    -1,   455,    -1,    -1,  1865,    -1,    -1,    -1,  4627,
      -1,    -1,    -1,    -1,    -1,    -1,  2194,    -1,    -1,  2197,
     513,    -1,   146,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,    -1,    -1,    -1,   489,   530,    -1,    -1,
     493,    -1,    -1,    -1,    -1,    -1,  1906,    -1,    -1,  3042,
    4668,  4669,  1520,    -1,    -1,  3048,    -1,    -1,    -1,  4677,
      -1,  4679,  4680,    -1,    -1,  4683,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4089,
      -1,    -1,    -1,    -1,    -1,    -1,  4323,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4331,  4332,  4333,  4334,    -1,  4727,
      -1,    -1,    -1,    -1,    -1,    -1,   863,    -1,    -1,    -1,
     867,  4121,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,
      -1,    -1,    -1,   257,   881,    -1,    -1,    -1,    -1,  4757,
      -1,   888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2009,
      -1,    -1,   899,    -1,   278,   279,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2346,   293,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4796,    -1,
      -1,   928,  4800,  4801,    -1,  4803,   933,    -1,    -1,    -1,
      -1,  4191,  4192,    -1,    -1,  3188,    98,   944,    -1,  2059,
      -1,   325,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   338,    -1,    -1,   341,    -1,    -1,
    2080,    -1,    -1,   970,  2084,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2096,    -1,    -1,   986,
      -1,    -1,   144,    -1,    -1,   992,    -1,    -1,  2524,    -1,
      -1,    -1,  1720,    -1,    -1,    -1,  1003,  1725,  1726,    -1,
      -1,    -1,    -1,    -1,  3257,    -1,    -1,    -1,    -1,    -1,
    1017,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2564,    -1,
      -1,    -1,    -1,  2569,   196,    -1,   420,  2573,    -1,    -1,
      -1,   203,    -1,    -1,   206,    -1,    -1,    -1,    -1,    -1,
      -1,  2171,  2172,    -1,    -1,    -1,  4316,  4317,  4318,  4319,
    4320,    -1,    -1,  2599,  2184,    -1,    -1,    -1,  4946,   231,
      -1,  4558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2199,
    2200,    -1,    -1,  1811,    -1,  4345,    -1,    -1,    84,    -1,
      -1,    87,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
     262,  2221,    -1,    -1,    -1,  4592,  4593,  2643,    -1,  1116,
    4988,    -1,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     116,    -1,    -1,    -1,    -1,  2661,   122,    -1,    -1,   513,
    1137,    -1,   516,   517,   518,    -1,   520,   521,   522,   523,
     524,   525,    -1,    -1,    -1,    -1,   530,    -1,    -1,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,  2693,   320,    -1,
     322,    -1,    -1,    -1,    -1,    -1,  1894,    -1,    -1,    -1,
     332,    -1,    -1,    -1,    -1,    -1,  1904,    -1,   340,    -1,
    2618,    -1,    -1,    -1,  4671,  4672,    -1,    -1,   350,  2725,
      -1,    -1,  2630,  2729,    -1,    -1,    -1,    -1,  1205,  1206,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2747,    -1,    98,    -1,    -1,    -1,    -1,    -1,   104,
      -1,    -1,  2758,   385,    -1,    -1,   388,   389,    -1,    -1,
      -1,  2351,  2670,    -1,    -1,  2771,  1964,    -1,    -1,  1967,
    1968,  4501,    -1,    89,  2780,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   415,    -1,    -1,   252,    -1,    -1,   144,
      -1,   257,    -1,    -1,    -1,    -1,  4526,    -1,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4768,   278,   279,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4778,  4779,    -1,    -1,    -1,    -1,   293,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4794,    -1,  2037,
      -1,   196,    -1,    -1,    -1,   161,   478,    -1,   203,    -1,
      -1,   206,    -1,    -1,    -1,  2445,    -1,  5205,  4588,   325,
      -1,  5209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5219,   338,    -1,    -1,   341,   231,    -1,    -1,    -1,
    4610,  4611,    -1,    -1,    -1,  4615,  4616,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,  4627,    -1,    -1,
      -1,   217,    -1,   219,    -1,    -1,    -1,   262,    -1,    -1,
      -1,    -1,  2502,    -1,  2504,    -1,   232,    -1,    -1,  2827,
      84,    -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,
      98,    -1,    -1,    -1,  2524,    -1,   104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,   420,    -1,    -1,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,   320,    -1,   322,    -1,    -1,
      -1,    -1,    -1,    -1,  2564,    -1,   144,   332,  2568,  2569,
      -1,    -1,   146,  2573,    -1,   340,    -1,    -1,    -1,    -1,
      -1,  2581,    -1,    -1,    -1,   350,    -1,    -1,    -1,    -1,
    1477,    -1,    -1,    -1,    -1,    -1,  3012,    -1,    -1,  2599,
      -1,    -1,    -1,  3736,    -1,    -1,    -1,    -1,    -1,  5367,
    1497,    -1,    -1,  5371,  3030,  5373,    -1,    -1,   196,  5377,
    5378,    -1,  3038,   388,   389,   203,    -1,    -1,   206,    -1,
      -1,    -1,    -1,  1520,    -1,    -1,    -1,   513,    -1,    -1,
     516,   517,   518,  2643,   520,   521,   522,   523,   524,   525,
     415,    -1,    -1,   231,   530,  2655,    84,    -1,    -1,    87,
      -1,  2661,  2662,    91,    92,    93,    -1,    -1,    -1,  1556,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,
     108,    -1,    -1,   257,   262,  1572,    -1,    -1,   116,    -1,
      -1,    -1,  2692,  2693,   122,    -1,  2696,    -1,    -1,    -1,
    1587,    -1,    -1,  1590,   278,   279,    -1,    -1,    -1,    -1,
    3028,  5078,    -1,   478,    -1,    -1,    -1,    -1,   146,   293,
      -1,    -1,    -1,  2723,    -1,  2725,    -1,  3045,    -1,  2729,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,  3056,    -1,
      -1,   104,   320,    -1,   322,    -1,  4886,  2747,    -1,    -1,
      -1,   325,    -1,    -1,   332,    -1,    -1,  3890,  2758,  3892,
      -1,    -1,   340,    -1,   338,    -1,    -1,   341,    -1,    -1,
      -1,  2771,   350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2780,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5156,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5560,    -1,    -1,    -1,  4946,   385,    -1,    -1,
     388,   389,    -1,    -1,    -1,    -1,  5574,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,   257,
    1717,    -1,    -1,   196,  5201,  2835,    -1,   415,  1725,  1726,
     203,    -1,    -1,   206,    -1,    -1,   420,    -1,    -1,  1736,
     278,   279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   293,    -1,    -1,   231,    -1,
      -1,  4004,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5637,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3308,    -1,    -1,    -1,    -1,   325,  5656,   262,
     478,  2901,    -1,  1790,  1791,  1792,    -1,    -1,    -1,    -1,
     338,    -1,  2520,   341,    -1,    -1,  2524,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1811,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2540,    -1,    -1,  3351,    -1,    -1,    -1,   513,
      -1,    -1,   516,   517,   518,    -1,   520,   521,   522,   523,
     524,   525,    -1,    -1,  1841,    -1,   530,   320,    -1,   322,
      -1,  1848,    -1,  2963,    -1,    -1,    -1,    -1,  1855,   332,
      -1,    84,    -1,  2581,    87,    -1,    -1,   340,    91,    92,
      93,    -1,    -1,    -1,    -1,    -1,    -1,   350,    -1,    -1,
      -1,    84,   420,    -1,    87,   108,    -1,    -1,    91,    92,
      93,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,
      84,    -1,  3012,    87,    -1,   108,    -1,    91,    92,    93,
      -1,    -1,   385,   116,    -1,   388,   389,    -1,    -1,   122,
    3030,    -1,    -1,   146,   108,    -1,    -1,    -1,  3038,    -1,
    3358,    -1,   116,  3459,    -1,    -1,    -1,    -1,   122,    -1,
      -1,    -1,   415,   146,    -1,    -1,  3472,  3375,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5205,    -1,    -1,    -1,    -1,
      -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   513,    -1,    -1,   516,   517,
     518,    -1,   520,   521,   522,   523,   524,   525,    -1,    -1,
      -1,    -1,   530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3114,   478,    -1,    -1,    -1,    -1,
    3120,    -1,  2009,    -1,    -1,    -1,  2734,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2742,  3551,  2744,   863,    -1,   252,
      -1,    -1,    -1,    -1,   257,    -1,    -1,  5287,    -1,    -1,
      -1,  3469,    -1,  3471,    -1,   881,    -1,    -1,    -1,   252,
      -1,    -1,   888,    -1,   257,   278,   279,    -1,    -1,    -1,
      -1,    -1,  2059,   899,    -1,    -1,    -1,    -1,   252,  5546,
     293,    -1,    -1,   257,    -1,   278,   279,    -1,    -1,    -1,
      -1,    -1,    -1,  2080,    -1,    -1,    -1,  2084,    -1,    -1,
     293,    -1,   928,    -1,   278,   279,    -1,   933,    -1,  2096,
      -1,  3211,   325,    -1,  3532,    -1,    -1,    -1,   944,   293,
      -1,    -1,    -1,    -1,    -1,   338,    -1,    -1,   341,    -1,
      -1,    -1,   325,    -1,    -1,    -1,    -1,    -1,    -1,  3557,
      -1,    -1,    -1,    -1,   970,   338,    -1,    -1,   341,    -1,
      -1,   325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     986,    -1,    -1,    -1,   338,    -1,   992,   341,    -1,    98,
     363,    -1,    -1,    -1,    -1,   104,    -1,  1003,    -1,    -1,
      -1,    -1,    -1,    -1,  2171,  2172,    -1,    -1,    -1,    -1,
      -1,  1017,    -1,    -1,    -1,    -1,    -1,  2184,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3721,    -1,   420,  3308,    -1,
      -1,    -1,  2199,  2200,    -1,   144,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3739,  3324,  3325,    -1,   420,    -1,    -1,
      -1,  3649,    -1,    -1,  2221,    -1,  4469,    -1,    -1,    -1,
    4473,    -1,    -1,   436,    -1,    -1,   420,    -1,  3764,    -1,
      -1,  3351,    -1,    -1,  3354,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3682,    -1,    -1,   196,    -1,    -1,
      -1,    -1,    -1,    -1,   203,    -1,    -1,   206,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1114,    -1,
    1116,    -1,  1118,    -1,    -1,    -1,    -1,    -1,  3006,    -1,
     513,    -1,   231,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,    -1,    -1,    -1,    -1,   530,    -1,    -1,
     513,    -1,    -1,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,   262,  5574,  3435,  3436,  3437,    -1,   513,
      -1,    -1,   516,   517,   518,    -1,   520,   521,   522,   523,
     524,   525,    -1,    -1,    -1,    -1,   530,    -1,    -1,  3459,
      -1,    -1,    -1,    -1,  2351,    -1,  3784,    -1,    -1,    -1,
      -1,    -1,  3472,    -1,  3474,    -1,    -1,  3477,    -1,  1205,
    1206,    -1,    -1,    -1,    -1,    -1,  3486,  3805,    -1,    -1,
      -1,   320,    -1,   322,    -1,    -1,    -1,  5637,    -1,    -1,
      -1,    -1,    -1,   332,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   340,  3830,    -1,    -1,    -1,  5656,    -1,    -1,    -1,
      -1,   350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3864,    -1,    -1,    -1,
      -1,  3551,    -1,   108,    -1,    -1,   385,    -1,  2445,   388,
     389,   116,  1288,  1289,    -1,    -1,    -1,   122,    -1,    -1,
    4703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   415,    -1,    -1,  3589,
      -1,   146,    -1,    -1,    -1,    -1,  3596,    -1,  3598,    -1,
      -1,    -1,    -1,  3211,    -1,    -1,    -1,    -1,    -1,    -1,
    3610,    -1,  3612,    -1,    -1,  2502,    84,  2504,    -1,    87,
      -1,  4037,    -1,    91,    92,    93,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2524,    -1,    -1,
     108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,   478,
      -1,    -1,    -1,    -1,   122,    98,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,    -1,    -1,  3666,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2564,   146,    -1,
      -1,  2568,  2569,    -1,    -1,    -1,  2573,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2581,    -1,    -1,   252,    -1,    -1,
      -1,   144,   257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2599,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3721,  4855,   278,   279,    -1,  4142,  4860,    -1,  4145,
      -1,    -1,  4865,    -1,    -1,  4868,  4869,    -1,   293,  3739,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1477,    -1,   196,    -1,    -1,  2643,    -1,    -1,    -1,
     203,  3761,    -1,   206,  3764,  4898,    -1,    -1,    -1,    -1,
     325,  1497,    -1,    -1,  2661,  2662,    -1,    -1,    -1,  4912,
      -1,    -1,    -1,   338,   252,    -1,   341,    -1,   231,   257,
      -1,    -1,    -1,    -1,  1520,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2692,  2693,    -1,    -1,  2696,
     278,   279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,
      -1,    -1,    -1,  4956,    84,   293,    -1,    87,    -1,  4245,
    1556,    91,    92,    93,    -1,    -1,    -1,    -1,  2725,    -1,
      -1,  3841,  2729,    -1,    -1,    -1,  1572,    -1,   108,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   116,   325,    -1,    -1,
    2747,  1587,   122,    -1,  1590,   420,  4999,    -1,    -1,    -1,
     338,  2758,    -1,   341,    -1,    98,    -1,   320,    -1,   322,
      -1,   104,    -1,    -1,  2771,    -1,   146,    -1,    -1,   332,
      -1,    -1,    -1,  2780,    -1,    -1,    -1,   340,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4234,    -1,    -1,    -1,
    5053,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   385,    -1,    -1,   388,   389,    -1,  2835,    -1,
      -1,    -1,   420,    -1,    -1,    -1,    -1,    -1,   513,    -1,
      -1,   516,   517,   518,    -1,   520,   521,   522,   523,   524,
     525,    -1,   415,   196,    -1,   530,    -1,  3585,    -1,    -1,
     203,    -1,  3590,   206,    -1,  5118,    -1,    -1,    -1,    -1,
      -1,  1717,   252,    -1,    -1,    -1,    -1,   257,    -1,  1725,
    1726,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,
    1736,    -1,    -1,    -1,  2901,    -1,    -1,    -1,   278,   279,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   478,    -1,  4037,    -1,   262,
      -1,    -1,    -1,    -1,    -1,   513,    -1,    -1,   516,   517,
     518,    -1,   520,   521,   522,   523,   524,   525,    -1,    -1,
      -1,    -1,   530,    -1,  1790,   325,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2963,    -1,   338,    -1,
      -1,   341,    -1,  4083,    -1,  1811,    -1,    -1,  4088,    -1,
    4090,    -1,    -1,    -1,    -1,    -1,    -1,   320,    -1,   322,
    5233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   332,
      -1,    -1,    -1,    -1,    -1,  4433,    -1,   340,    -1,    -1,
      -1,    -1,    -1,    84,    -1,  3012,    87,   350,    -1,  1855,
      91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,  1865,
      -1,    -1,  4142,  3030,    -1,  4145,    -1,   108,    -1,    -1,
      -1,  3038,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
     420,   122,   385,  3771,    -1,   388,   389,    -1,    -1,  5302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1906,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,  4607,   415,    -1,  5327,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4619,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3114,    -1,    -1,
    4230,  4231,    -1,  3120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4560,  4243,    -1,  4245,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    -1,   478,   516,   517,   518,    -1,
     520,   521,   522,   523,   524,   525,    -1,    -1,    -1,    -1,
     530,    -1,    -1,  4591,    -1,  5408,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2009,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   252,    -1,    -1,  4612,    -1,   257,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4315,    -1,   278,   279,    -1,
      -1,    -1,    -1,    -1,  3211,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   293,  2059,    -1,    -1,    -1,    84,    -1,  5472,
      87,    -1,    -1,    -1,    91,    92,    93,    -1,  4348,    -1,
      -1,    -1,  4670,    -1,  2080,    -1,    -1,    -1,  2084,    -1,
      -1,   108,    -1,    -1,   325,    -1,    -1,    -1,    -1,   116,
    2096,    -1,    -1,    -1,    -1,   122,    -1,   338,    -1,  4795,
     341,    -1,    -1,    -1,    -1,    -1,    -1,  5520,    -1,    -1,
      -1,    -1,    -1,  5526,  5527,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,
      -1,  3308,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,    -1,    -1,    -1,  3324,  3325,    -1,
     129,    -1,  4760,    -1,    -1,  2171,  2172,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   144,   129,    -1,  2184,   420,
      -1,    -1,    -1,    -1,  3351,    -1,    -1,  3354,    -1,    -1,
      -1,   144,    -1,  2199,  2200,    -1,    -1,    -1,    -1,    -1,
      -1,  4089,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,
    4906,    -1,  4908,    -1,    -1,  2221,    -1,  4815,    -1,    -1,
      -1,    -1,    -1,    -1,   177,   252,    -1,   196,    -1,    -1,
     257,    -1,  5645,  4121,   203,    -1,    -1,   206,    -1,    -1,
      -1,    -1,    -1,   196,  5657,  5658,    -1,    -1,    -1,    -1,
     203,   278,   279,   206,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   231,    -1,    -1,    -1,   293,    -1,  3435,  3436,
    3437,    -1,   513,    -1,    -1,   516,   517,   518,   231,   520,
     521,   522,   523,   524,   525,    -1,    -1,    -1,    -1,   530,
     259,    -1,  3459,   262,    -1,    -1,    -1,  4577,   325,    -1,
      -1,    -1,  4582,    -1,    -1,  3472,   259,  3474,    -1,   262,
    3477,   338,    -1,    -1,   341,    -1,    -1,    -1,    -1,  3486,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4607,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,  4619,
      -1,   310,    -1,    -1,    -1,  2351,  4626,    -1,    -1,    -1,
      -1,   320,    -1,   322,   307,    -1,    -1,   310,    -1,    -1,
    4640,    -1,    -1,   332,    -1,    -1,    -1,   320,    -1,   322,
      -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   332,
     349,   350,    -1,    -1,  3551,    -1,    -1,   340,    -1,    -1,
      -1,    -1,    -1,   420,    -1,    -1,   349,   350,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,    -1,    87,
      -1,    -1,    -1,    91,    92,    93,   385,    -1,    -1,   388,
     389,   390,  3589,    -1,    -1,    -1,    -1,    -1,    -1,  3596,
     108,  3598,   385,    -1,    -1,   388,   389,   390,   116,    -1,
      -1,    -1,    -1,  3610,   122,  3612,   415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4345,    -1,    -1,
     429,    -1,   415,    -1,    -1,    -1,    -1,    -1,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   429,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,  5086,   516,
     517,   518,    -1,   520,   521,   522,   523,   524,   525,  3666,
      -1,    -1,    -1,   530,    -1,    -1,    -1,    -1,    -1,   478,
      -1,    -1,    -1,    -1,    -1,  4795,    -1,    -1,  2524,    -1,
      -1,    -1,    -1,    -1,    -1,   478,  5124,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3721,    -1,    -1,    -1,  2564,    -1,
      -1,    -1,  2568,  2569,    -1,    -1,    -1,  2573,    -1,    -1,
      -1,    -1,  3739,    -1,   252,  2581,    -1,    -1,    -1,   257,
      -1,    -1,  5180,    -1,    -1,    -1,  5184,  5185,    -1,    -1,
      -1,    -1,    -1,  2599,  3761,    -1,    -1,  3764,    -1,    -1,
     278,   279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4906,    -1,  4908,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2643,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   325,    -1,  2655,
      -1,    -1,    -1,    -1,    -1,  2661,  2662,    -1,    -1,    -1,
     338,    -1,    -1,   341,    -1,    -1,    -1,  4947,    -1,    -1,
      -1,    -1,    -1,    -1,  3841,    -1,    -1,    -1,    -1,  5277,
      -1,    -1,    -1,    -1,    -1,    -1,  2692,  2693,    -1,    -1,
    2696,    -1,    -1,    -1,    84,    -1,    -1,    87,    -1,    -1,
    4588,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4993,    -1,    -1,    -1,  2723,   108,  2725,
      -1,    -1,    -1,  2729,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,  4627,
       5,  2747,   420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2758,    -1,    -1,    -1,   146,    -1,    -1,    -1,
      25,    -1,    -1,    -1,  5460,  2771,    -1,    -1,    -1,    -1,
      35,    36,    -1,    -1,  2780,    40,    -1,    42,    43,    -1,
      -1,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    -1,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2835,
      -1,    -1,    -1,    -1,    -1,   513,    -1,    -1,   516,   517,
     518,    -1,   520,   521,   522,   523,   524,   525,    -1,    -1,
      -1,    -1,   530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   252,    -1,    -1,    -1,    -1,   257,    -1,    -1,
    4037,    94,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,   279,
      -1,    -1,    -1,    -1,  5174,  2901,    -1,    -1,    84,    -1,
      -1,    87,    -1,   293,    -1,    91,    92,    93,   131,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4083,    -1,    -1,    -1,
      98,  4088,   108,  4090,    -1,  5205,   104,    -1,    -1,   152,
     116,    -1,    -1,    -1,    -1,   325,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   210,    -1,   170,   338,    -1,
      -1,   341,    -1,    -1,    -1,    -1,    -1,  2963,    -1,    -1,
     146,    -1,   185,   228,    -1,    -1,   144,    -1,    -1,    -1,
     193,    -1,    -1,    -1,    -1,  4142,    -1,    -1,  4145,    -1,
      -1,    -1,    -1,    -1,   249,   208,    -1,   210,    -1,    -1,
      -1,   214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,    -1,    -1,    -1,  3012,   272,    -1,    -1,
     233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    -1,    -1,  3030,   203,    -1,    -1,   206,    -1,
     420,    -1,  3038,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   309,    -1,    -1,   312,    -1,    -1,
      -1,    -1,    -1,   231,    -1,    -1,    -1,    -1,  4946,    -1,
      -1,    -1,   327,  4230,  4231,    -1,   252,    -1,    -1,    -1,
      -1,   257,    -1,    -1,    -1,    -1,  4243,    -1,  4245,    -1,
      -1,    -1,    -1,    -1,   262,  5365,    -1,  5367,    -1,    -1,
      -1,    -1,   278,   279,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   293,  3114,    -1,
      -1,    -1,    -1,    -1,  3120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    -1,    -1,   516,   517,   518,    -1,
     520,   521,   522,   523,   524,   525,    -1,    -1,    -1,   325,
     530,   406,   320,    -1,   322,    -1,    -1,    -1,  4315,    -1,
      -1,    -1,   338,    -1,   332,   341,    -1,    -1,    -1,    -1,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5460,  4348,    -1,    -1,    -1,    -1,    -1,   452,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   467,    -1,    -1,  3211,    -1,   385,    -1,    -1,
     388,   389,    -1,    -1,    -1,    -1,    -1,   482,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   420,    -1,    -1,   415,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   510,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,    -1,   520,   521,   522,   523,   524,
      -1,    -1,   527,   528,   529,   530,    -1,   532,   533,   534,
     535,   536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5560,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5574,    -1,    -1,    -1,    -1,    -1,
     478,    -1,  3308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5205,  3324,  3325,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,    -1,
     516,   517,   518,    -1,   520,   521,   522,   523,   524,   525,
      -1,    -1,    -1,    -1,   530,  3351,    -1,    -1,  3354,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5637,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5656,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    -1,    -1,    87,    -1,    -1,
      -1,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,  5287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   108,    -1,
    4577,    -1,    -1,    -1,    -1,  4582,   116,    -1,    -1,    -1,
      -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,  3435,
    3436,  3437,    -1,    -1,    -1,    -1,    -1,    -1,   661,    -1,
    4607,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,
      -1,    -1,  4619,  3459,    -1,    -1,    -1,    -1,    -1,  4626,
      -1,    -1,    -1,    -1,     5,    -1,  3472,    -1,  3474,    -1,
      -1,  3477,    -1,  4640,    -1,    -1,    -1,    -1,    -1,    -1,
    3486,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    36,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    -1,    -1,    -1,    85,  3551,    -1,    -1,    -1,    -1,
      -1,    -1,   252,    -1,    -1,    -1,    -1,   257,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,   279,
      -1,    -1,    -1,  3589,    -1,    -1,    -1,    -1,    -1,    -1,
    3596,    -1,  3598,   293,    -1,    -1,   137,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3610,    -1,  3612,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   325,    -1,    -1,  4795,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   338,    -1,
      -1,   341,    -1,    -1,    -1,    -1,    -1,    -1,   871,   872,
     873,   874,    -1,   876,    -1,   878,   101,   880,    -1,   882,
    3666,    -1,   885,    -1,    -1,    -1,    -1,    -1,   891,   210,
      -1,   894,    -1,    -1,    -1,   898,    -1,   900,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   908,    -1,   228,    -1,    -1,
      -1,   914,    -1,   916,    -1,    -1,   919,    -1,   921,    -1,
     923,    -1,   147,    -1,    -1,    -1,    -1,   930,   249,    -1,
      -1,   934,    -1,    -1,    -1,  3721,   161,    -1,   941,    -1,
     420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   272,    -1,  3739,   179,    -1,    -1,    -1,    -1,  4906,
     185,  4908,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   975,    -1,    -1,  3761,   201,   980,  3764,    -1,
      -1,    -1,   985,    -1,    -1,    -1,   989,   212,   309,    -1,
      -1,   312,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
    4947,    -1,    -1,  1006,    -1,    -1,   327,   232,    -1,    -1,
      -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,   243,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    -1,   260,   516,   517,   518,    -1,
     520,   521,   522,   523,   524,   525,  4993,    -1,    -1,    -1,
     530,    -1,    -1,    -1,    -1,  3841,    -1,    -1,    84,  1062,
     285,    87,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
      -1,    -1,    -1,    -1,  1077,    -1,  1079,    -1,    -1,    -1,
      -1,   306,   108,    -1,    -1,   406,    -1,    -1,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1107,  1108,    -1,    -1,    -1,  1112,
    1113,    -1,    -1,   338,    -1,    -1,    -1,    -1,    -1,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1132,
      -1,   452,    -1,  1136,   359,    -1,    -1,    -1,    -1,    -1,
      -1,  1144,    -1,    -1,   369,    -1,   467,    -1,    -1,    -1,
      -1,    -1,  1155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   482,    -1,    -1,  1167,    -1,    -1,    -1,    -1,    -1,
      -1,   396,    -1,    -1,    -1,    -1,   401,    -1,   403,    -1,
      -1,    -1,    -1,    -1,   409,    -1,    -1,   412,    -1,   510,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,    -1,   520,
     521,   522,   523,   524,    -1,    -1,   527,   528,   529,    -1,
      -1,    -1,    -1,   534,   535,   440,   441,    -1,    -1,   444,
      -1,    -1,    -1,   448,    -1,    -1,   252,  5174,    -1,    -1,
      -1,   257,   457,    -1,    -1,    -1,    -1,   462,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1249,    -1,    -1,   474,
      -1,  4037,   278,   279,    -1,  1258,    -1,    -1,  5205,    -1,
    1263,  1264,   487,    -1,    -1,    -1,    -1,   293,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4083,    -1,   325,
      -1,    -1,  4088,   108,  4090,    -1,    -1,    -1,    -1,    -1,
      -1,   116,   338,  1316,    -1,   341,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,  1327,    -1,    -1,    -1,  1331,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,  1346,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4142,    -1,    -1,  4145,
      -1,    -1,    -1,  1366,    -1,    -1,    -1,    -1,    -1,  1372,
    1373,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1389,  1390,  1391,    -1,
    1393,    -1,  1395,    -1,   420,    -1,    -1,  1400,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    -1,    -1,    87,    -1,
      -1,    -1,    91,    92,    93,    -1,    -1,    -1,  5365,    -1,
    5367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   108,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,  4230,  4231,    -1,   252,    -1,    -1,
      -1,    -1,   257,    -1,    -1,    -1,    -1,  4243,    -1,  4245,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,  1471,    -1,
    1473,  1474,    -1,   278,   279,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,   293,    -1,
     516,   517,   518,    -1,   520,   521,   522,   523,   524,   525,
      -1,    -1,    -1,    -1,   530,    -1,    -1,    -1,    -1,  1512,
      -1,    -1,    -1,  5460,    -1,    -1,    -1,    -1,    -1,    -1,
     325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   338,    -1,    -1,   341,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1550,  1551,    -1,
      -1,    -1,  1555,    -1,  1557,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,   257,    -1,
    1583,    -1,    -1,  1586,    -1,    -1,  1589,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1601,   278,
     279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5560,   293,   420,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1629,  5574,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   325,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1657,  1658,  1659,    -1,  1661,   338,
      -1,    -1,   341,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1681,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1703,  1704,    -1,    -1,    -1,    -1,    -1,    -1,   513,  5656,
      -1,   516,   517,   518,    -1,   520,   521,   522,   523,   524,
     525,    -1,    -1,    -1,    -1,   530,    -1,    -1,    -1,  1732,
      -1,    -1,  1735,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   164,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1765,    -1,    -1,    -1,  1769,  1770,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1780,  1781,  1782,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4577,    -1,    -1,    84,    -1,  4582,    87,   213,    -1,
      -1,    91,    92,    93,    -1,    -1,  1809,    -1,    -1,    -1,
     225,    -1,    -1,    -1,    -1,   230,    -1,    -1,   108,    -1,
     235,  4607,   112,    -1,    -1,   240,   116,    -1,   243,   164,
      -1,   246,   122,  4619,   513,    -1,    -1,   516,   517,   518,
    4626,   520,   521,   522,   523,   524,   525,    -1,    -1,   528,
      -1,    -1,    -1,    -1,  4640,    -1,   146,    -1,    -1,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,   294,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     225,    -1,   882,    -1,    -1,   230,    -1,    -1,  1901,    -1,
     235,   891,    -1,    -1,   194,   240,    -1,    -1,   243,    -1,
     900,   246,    -1,    -1,    -1,    -1,  1919,  1920,   908,   334,
      -1,   336,    -1,    -1,   914,  1928,    -1,   342,  1931,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1950,    -1,  1952,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1960,    -1,   294,
    1963,    -1,   252,    -1,    -1,    -1,    -1,   257,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   392,    -1,    -1,
      -1,    -1,    -1,    -1,  1987,    -1,    -1,    -1,   278,   279,
      -1,    -1,  1995,  1996,  1997,  1998,  1999,    -1,    -1,   334,
      -1,   336,    -1,   293,    -1,    -1,    -1,   342,    -1,  4795,
    2013,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2025,    -1,  2027,    -1,   441,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   325,  2039,  2040,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2048,    -1,    -1,   338,    -1,
      -1,   341,   467,    -1,    -1,  2058,    -1,   392,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2077,    -1,   491,    -1,   493,   494,
      -1,    -1,    -1,  2086,  2087,  2088,  2089,  1077,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2098,    -1,    -1,    -1,    -1,
      -1,    -1,  2105,    -1,    -1,  2108,   441,    -1,    -1,    -1,
      -1,    -1,   527,    -1,    -1,   530,   531,    -1,   533,    -1,
    4906,  2124,  4908,  1113,    -1,    -1,    -1,    -1,  2131,    -1,
     420,    -1,   467,  2136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   491,    -1,   493,   494,
      -1,  4947,    -1,    -1,    -1,  1155,  2169,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2179,    -1,    -1,    -1,
    2183,    -1,    -1,  2186,    -1,   475,    -1,    -1,    -1,    -1,
      -1,    -1,   527,  2196,    -1,   530,   531,    -1,   533,    -1,
      -1,  2204,  2205,    -1,    -1,    -1,    -1,  4993,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2218,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    -1,    -1,   516,   517,   518,    -1,
     520,   521,   522,   523,   524,   525,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2252,
      -1,    -1,    -1,    -1,    -1,    -1,  2259,    -1,  2261,    -1,
      -1,    -1,  2265,  2266,    -1,  2268,    -1,    -1,  1258,    -1,
      -1,    -1,  2275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2285,    -1,    -1,    -1,    -1,  2290,  2291,    -1,
      -1,  2294,    -1,    -1,    -1,  2298,  2299,    -1,    -1,    -1,
      -1,  2304,  2305,    -1,    -1,    -1,    -1,    -1,  2311,  2312,
    2313,    -1,    -1,    -1,  2317,  2318,  2319,  2320,  2321,  2322,
    2323,  2324,    -1,  2326,    -1,  2328,  2329,    -1,    -1,  2332,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2347,  2348,  2349,  2350,    -1,    -1,
      -1,  2354,  2355,    -1,    -1,    -1,  2359,    -1,    -1,  2362,
      -1,    -1,  2365,  2366,  2367,  2368,  2369,  2370,  2371,  2372,
    2373,    -1,  2375,    -1,    -1,    -1,  1366,    -1,    -1,  2382,
    2383,    -1,    -1,  2386,    -1,    -1,    -1,    -1,  5174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1389,
    1390,  1391,    -1,    -1,    -1,  2408,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5205,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2446,    -1,  2448,    -1,  2450,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     981,  2464,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2473,  2474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1002,    -1,    -1,  2487,    -1,    -1,    -1,    -1,    -1,
      -1,  2494,    -1,  2496,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    -1,    -1,    87,    -1,    -1,
      -1,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   108,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1555,    -1,    -1,    -1,    -1,
      -1,  2574,    -1,    -1,    -1,    -1,   146,    -1,    -1,  5365,
    2583,  5367,  2585,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1586,    -1,    -1,  2602,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2614,    -1,  2616,  2617,    -1,    -1,    -1,  2621,    -1,
    2623,    -1,  2625,    -1,  2627,    -1,    -1,    -1,  2631,    -1,
      -1,  2634,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     230,    -1,  2665,    -1,   108,   235,    -1,    -1,    -1,    -1,
    2673,    -1,   116,    -1,  5460,    -1,    -1,  2680,   122,    -1,
      -1,    -1,   252,    -1,    -1,    -1,  2689,   257,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   146,    -1,    -1,  2708,    -1,    -1,   278,   279,
    2713,  2714,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2722,
      -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2740,    -1,    -1,
      -1,    -1,  1732,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   325,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2767,    -1,  2769,  2770,   338,    -1,
      -1,   341,    -1,    -1,  5560,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,  5574,    -1,
      -1,  1781,    -1,    -1,    -1,  2798,    -1,    -1,    -1,    -1,
      -1,    -1,  1323,  2806,    -1,  2808,    -1,    -1,   252,    -1,
      -1,  2814,    -1,   257,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1343,  2826,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   278,   279,  1357,  2840,    -1,    -1,
    2843,    -1,  2845,    -1,    -1,  2848,    -1,    -1,  2851,   293,
     420,  5637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5656,    -1,    -1,    -1,  2877,    -1,    -1,    -1,    -1,    -1,
      -1,   325,    -1,  2886,  2887,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   338,    -1,    -1,   341,    -1,  2902,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2913,    -1,    -1,    -1,    -1,    -1,   164,   361,  1439,    -1,
      -1,    -1,    -1,    -1,  2927,  2928,    -1,    -1,    -1,  1919,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2940,  1928,  2942,
    2943,  2944,  2945,   513,    -1,    -1,   516,   517,   518,    -1,
     520,   521,   522,   523,   524,   525,    -1,    -1,    -1,    -1,
      -1,    -1,  1952,    -1,    -1,   213,    -1,    -1,  2971,    -1,
    1960,    -1,    84,  1963,    -1,    87,   420,   225,    -1,    91,
      92,    93,   230,    -1,    -1,    -1,    -1,   235,    -1,    -1,
      -1,  2994,   240,    -1,    -1,   243,   108,    -1,   246,   111,
      -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,  1999,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2013,    -1,    -1,   274,    -1,    -1,  3032,
      -1,    -1,    -1,    -1,   146,    -1,    -1,  2027,    -1,  3042,
      -1,    -1,    -1,    -1,    -1,  3048,   294,    -1,    -1,  1570,
      -1,    -1,    -1,    -1,    -1,    -1,  3059,    -1,    -1,    -1,
      -1,    -1,  3065,    -1,    -1,    -1,    -1,  3070,    -1,   513,
      -1,    -1,   516,   517,   518,    -1,   520,   521,   522,   523,
     524,   525,    -1,    -1,    -1,    -1,   334,  2077,   336,    -1,
    3093,  3094,  3095,    -1,   342,  3098,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3106,  3107,  3108,  3109,    -1,  2098,    -1,
      -1,    -1,    -1,    -1,    -1,  2105,  3119,    -1,    -1,  3122,
      -1,  3124,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
     101,    -1,  3135,  3136,    -1,    -1,  3139,    -1,    -1,    -1,
     252,    -1,    -1,    -1,   392,   257,    -1,    -1,  3151,    -1,
    3153,    -1,  3155,    -1,  3157,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   134,    -1,    -1,   278,   279,    -1,    -1,
      -1,    -1,    -1,    -1,  3177,    -1,   147,   148,  3181,    -1,
      -1,   293,    -1,    -1,    -1,  3188,   157,  3190,  3191,  3192,
     161,    -1,    -1,   441,    -1,    -1,    -1,    -1,    -1,  1720,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,    -1,  3215,   325,    -1,    -1,    -1,    -1,    -1,   467,
      -1,    -1,    -1,    -1,    -1,  3228,   338,    -1,  2218,   341,
     201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3243,   212,    -1,   491,    -1,   493,   494,    -1,    -1,   220,
      -1,    -1,    -1,    -1,  3257,    -1,    -1,  3260,    -1,    -1,
    3263,   232,  3265,    -1,    -1,    -1,   237,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2265,  2266,    -1,    -1,   527,
      -1,    -1,   530,   531,    -1,   533,    -1,    -1,    -1,   260,
      -1,    -1,    -1,    -1,    -1,  2285,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,    -1,
      -1,    -1,    84,    -1,   285,    87,    -1,    -1,    -1,    91,
      92,    93,    -1,    -1,    -1,    -1,    -1,  3330,  1849,  3332,
      -1,    -1,    -1,    -1,  3337,   306,   108,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3364,    -1,  3366,  3367,  3368,    -1,   338,    -1,    -1,
      -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,    -1,
      -1,    -1,  2382,  1914,    -1,    -1,    -1,    -1,   369,    -1,
      -1,   513,    -1,    -1,   516,   517,   518,    -1,   520,   521,
     522,   523,   524,   525,    -1,    -1,    -1,    -1,  2408,    -1,
      -1,    -1,    -1,    -1,    -1,   396,    -1,  1948,    -1,    -1,
     401,    -1,   403,    -1,    -1,    -1,    -1,    -1,   409,    -1,
      -1,   412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2446,    -1,  2448,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     441,    -1,  3475,   444,    -1,    -1,    -1,   448,    -1,    -1,
     252,    -1,    -1,    -1,   455,   257,   457,    -1,    -1,    -1,
      -1,   462,    -1,    -1,    -1,    -1,    -1,  2487,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   278,   279,    -1,  2030,
      -1,    -1,    -1,    -1,    -1,    -1,   487,    -1,    -1,    -1,
      -1,   293,    84,    -1,  2045,    87,    -1,    -1,    -1,    91,
      92,    93,  2053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2064,    -1,    -1,   108,    -1,    -1,   111,
      -1,    -1,    -1,   325,   116,  3558,    -1,    -1,    -1,    -1,
     122,    -1,  3565,  3566,    -1,    -1,   338,    -1,    -1,   341,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   146,   357,    -1,    -1,    -1,    -1,
    2111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3602,
    3603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2130,
      -1,    -1,    -1,    -1,    -1,  3618,    -1,    -1,    -1,    -1,
      -1,  2142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3633,  3634,    -1,  2154,    -1,    -1,    -1,    -1,    -1,  3642,
    3643,  3644,    -1,    -1,    -1,    -1,    -1,    -1,   420,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3660,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2194,  3677,    -1,  2197,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     252,  3694,    -1,    -1,    -1,   257,    -1,    -1,    -1,  2689,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3711,    -1,
    3713,    -1,    -1,    -1,  3717,    -1,   278,   279,  2708,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   293,    -1,  3736,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   513,    -1,  3746,   516,   517,   518,    -1,   520,   521,
     522,   523,   524,   525,    -1,    -1,    -1,    -1,    -1,  3762,
      -1,    -1,    -1,   325,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3774,    -1,    -1,    -1,    -1,   338,    -1,  3781,   341,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3790,    -1,    -1,
      -1,    -1,    -1,  3796,    -1,  3798,    -1,    -1,  3801,    -1,
      -1,    -1,    -1,  3806,  3807,  3808,  3809,    -1,    -1,  3812,
    3813,  3814,  3815,  3816,  3817,  3818,  3819,  3820,  3821,    -1,
      -1,    -1,  3825,  3826,    -1,  2346,    -1,    -1,    -1,    -1,
      -1,    -1,  3835,    -1,    -1,    -1,  3839,    -1,    -1,    -1,
    3843,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3851,    -1,
      -1,  3854,    -1,  3856,    -1,  2845,    -1,    -1,   420,    -1,
      -1,    -1,  3865,    -1,    -1,  3868,  3869,    -1,    -1,    -1,
    3873,  3874,    -1,    -1,    -1,  3878,    -1,  3880,    -1,    -1,
      -1,    -1,    -1,    -1,  3887,  3888,  3889,  3890,    -1,  3892,
    3893,    -1,    -1,    -1,  3897,  3898,    -1,    -1,    -1,    -1,
      -1,  3904,    -1,    -1,    -1,    -1,    -1,  3910,  3911,  3912,
      84,    -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,    -1,
      -1,   513,    -1,    -1,   516,   517,   518,  3960,   520,   521,
     522,   523,   524,   525,    -1,    -1,    -1,    -1,  3971,    -1,
    3973,    -1,   146,    -1,   161,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4004,  4005,  4006,    -1,  4008,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,  4027,  4028,  4029,  4030,    -1,  2550,
     217,    -1,   219,  2554,  2555,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3032,    -1,    -1,   232,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4056,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,    -1,    -1,    -1,    -1,    -1,  4070,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,
      -1,    -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2618,    -1,    -1,
      -1,    -1,    -1,    -1,   278,   279,    -1,    -1,    -1,  2630,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   293,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2670,
      -1,   325,    -1,    -1,    -1,    -1,    -1,  4160,    -1,    -1,
      -1,    -1,    -1,    -1,   338,    84,    -1,   341,    87,    -1,
      -1,    -1,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   108,
      -1,  3181,   111,    -1,    -1,    -1,    -1,   116,    -1,    -1,
    4203,    -1,  4205,   122,  4207,    -1,    -1,    -1,    -1,    -1,
    4213,    -1,    -1,    -1,    -1,    -1,  4219,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4228,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4248,   420,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4258,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4266,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4276,    -1,    -1,    -1,  4280,    -1,    -1,
      -1,  4284,  4285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2827,    -1,    -1,    -1,
      -1,    -1,    -1,  4316,  4317,  4318,  4319,  4320,    -1,    -1,
      -1,    -1,    -1,  4326,    -1,  4328,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   252,    -1,  4338,    -1,    -1,   257,   513,
      -1,    -1,   516,   517,   518,    -1,   520,   521,   522,   523,
     524,   525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,
     279,    -1,    -1,    -1,    -1,    -1,  4369,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   293,    -1,  2897,  4380,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   325,  4410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4420,  4421,   338,
      -1,    -1,   341,    -1,  4427,  4428,    -1,    -1,    -1,  4432,
      -1,    -1,    -1,    -1,  4437,    -1,    -1,  4440,  4441,    -1,
      -1,    -1,  4445,  4446,    -1,    -1,    -1,    -1,  4451,  4452,
    4453,  4454,  4455,    -1,    -1,    -1,  4459,  4460,    -1,  4462,
      -1,    -1,  4465,    -1,    -1,    -1,  4469,    -1,    -1,    -1,
    4473,    -1,    -1,    -1,    -1,    -1,  4479,    -1,    -1,    -1,
      -1,    -1,  4485,    -1,    -1,  3475,    -1,  4490,    -1,    -1,
      -1,    -1,    -1,  4496,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   420,    -1,  4506,    -1,    -1,    -1,  3028,    -1,    -1,
    4513,    -1,    -1,  4516,    -1,    -1,    -1,    -1,  4521,    -1,
      -1,    -1,    -1,    -1,  3045,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3056,  4539,    -1,    -1,  4542,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      -1,    -1,    87,    -1,    -1,    -1,    91,    92,    93,  4562,
    4563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,    -1,    -1,    -1,  4580,    -1,    -1,
      -1,   116,    -1,    -1,    -1,    -1,  4589,   122,    -1,    -1,
      -1,    -1,    -1,    -1,   513,    -1,    -1,   516,   517,   518,
      -1,   520,   521,   522,   523,   524,   525,    -1,    -1,    -1,
      -1,   146,  3602,  3603,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4630,  3618,    -1,
      -1,    -1,    -1,    -1,    84,    -1,    -1,    87,    -1,    -1,
      -1,    91,    92,    93,  3634,    -1,    -1,  4650,    -1,    -1,
      -1,    -1,    -1,  3643,  3644,    -1,    -1,    -1,   108,    -1,
      -1,   111,  4665,    -1,    -1,    -1,   116,    -1,    -1,    -1,
    3660,    -1,   122,    -1,    -1,    -1,   863,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   871,    -1,    -1,    -1,    -1,  4692,
      -1,    -1,    -1,   880,    -1,    -1,   146,    -1,    -1,    -1,
    4703,    -1,    -1,    -1,    -1,  4708,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4716,    -1,    -1,    -1,   252,    -1,    -1,
      -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,    -1,   916,
    4733,  4734,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   278,   279,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   293,    -1,
    4763,    -1,    -1,  4766,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3762,    -1,    -1,  3296,    -1,    -1,  3299,    -1,
    3301,    -1,    -1,    -1,    -1,  3306,    -1,    -1,   975,    -1,
     325,    -1,    -1,    -1,   981,    -1,    -1,    -1,   985,    -1,
      -1,    -1,   252,   338,    -1,    -1,   341,   257,  4811,    -1,
      -1,    -1,    -1,    -1,    -1,  1002,    -1,  4820,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,   279,
      -1,    -1,    -1,    -1,  4837,  4838,    -1,  3358,  4841,    -1,
      -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4855,  4856,  3375,    -1,    -1,  4860,    -1,    -1,
      -1,    -1,  4865,    -1,    -1,  4868,  4869,    -1,  4871,    -1,
    4873,    -1,    -1,  4876,  4877,   325,    -1,    -1,    -1,  3400,
      -1,    -1,    -1,    -1,    -1,   420,    -1,    -1,   338,    -1,
      -1,   341,    -1,    -1,    -1,  4898,    -1,  3887,  3888,  3889,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4912,
    4913,  4914,  4915,  4916,   449,    -1,    -1,    -1,    -1,    -1,
    1107,  1108,    -1,    -1,    -1,    -1,    -1,  1114,    -1,    -1,
      -1,  1118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3469,    -1,
    3471,    -1,    -1,  4956,  4957,    -1,    -1,  1144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,
      -1,   516,   517,   518,    -1,   520,   521,   522,   523,   524,
     525,    -1,    -1,    -1,    -1,    -1,  4999,    -1,    -1,  5002,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5012,
      -1,  3532,    -1,    -1,    -1,  5018,    -1,  5020,    -1,    -1,
      -1,    -1,    -1,  5026,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3557,  5040,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5051,  5052,
    5053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,  3585,    -1,   516,   517,   518,  3590,
     520,   521,   522,   523,   524,   525,    -1,    -1,    -1,    -1,
      -1,    -1,  5085,    -1,    -1,  5088,    -1,  5090,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1288,  1289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5114,    -1,    -1,    -1,  5118,    -1,    -1,    -1,  5122,
      -1,    -1,    -1,    -1,    -1,    -1,  5129,    -1,  3649,  1316,
      -1,    -1,    -1,    -1,    -1,  5138,  1323,    -1,    -1,    -1,
    1327,    -1,    -1,    -1,    -1,    -1,  3667,    -1,  5151,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1343,    -1,    -1,    -1,
      -1,  3682,    -1,  5166,    -1,    84,    -1,    -1,    87,    -1,
    1357,    -1,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5189,    -1,    -1,   108,
      -1,    -1,    -1,  5196,  5197,  5198,  5199,   116,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,  1395,    -1,
      -1,    -1,    -1,  4203,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4213,    -1,    -1,    -1,   146,    -1,    -1,
    5233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5249,    -1,    -1,    -1,
      -1,  5254,  1439,    -1,    -1,    -1,    -1,    -1,  4248,    -1,
      -1,    -1,    -1,  3784,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3805,    -1,  4276,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5299,    -1,    -1,  5302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5311,  3830,
      -1,    -1,    -1,  5316,    -1,  5318,    -1,  5320,    -1,    -1,
      -1,    -1,    -1,    -1,  5327,  1512,    -1,    -1,    -1,    -1,
    5333,    -1,  5335,   252,    -1,    -1,    -1,    -1,   257,    -1,
      -1,  5344,    -1,  3864,    -1,    -1,    -1,    -1,  4338,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,
     279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5375,  5376,   293,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1570,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5402,
      -1,    -1,    -1,    -1,    -1,  5408,   325,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1601,    -1,    -1,    -1,    -1,   338,
      -1,    -1,   341,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5441,  5442,
      -1,    -1,  1629,  5446,    -1,    -1,    -1,    -1,    -1,  5452,
      -1,    -1,  5455,    -1,    -1,    -1,  5459,    -1,    -1,    -1,
      -1,    -1,  4452,  4453,  4454,  4455,    -1,    -1,  3989,  5472,
    1657,  1658,  1659,    -1,  1661,    -1,    96,    -1,    -1,  5482,
      -1,   101,    -1,    -1,    -1,    -1,  5489,    -1,    -1,    -1,
      -1,    -1,    -1,   113,  1681,    -1,    -1,    -1,    -1,    -1,
      -1,   420,    -1,    -1,    -1,    -1,    -1,    -1,  5511,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,  5520,    -1,    -1,
      -1,    -1,    -1,  5526,  5527,    -1,  5529,   147,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,
      -1,   161,    -1,    -1,    -1,  5548,    -1,    -1,  1735,  1736,
      -1,    -1,  5555,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,    -1,    -1,    -1,   185,    -1,    -1,  4089,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1765,    -1,
      -1,   201,  1769,  1770,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   212,    -1,   513,    -1,    -1,   516,   517,   518,
     220,   520,   521,   522,   523,   524,   525,    -1,    -1,    -1,
      -1,    -1,   232,    -1,    -1,    -1,    -1,    -1,    -1,   239,
      -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,  5631,  5632,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     260,    -1,  5645,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5657,  5658,    -1,    -1,    -1,    -1,
      -1,    -1,  1849,    -1,    -1,    -1,    -1,    -1,  1855,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,  1865,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   306,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    -1,    -1,    94,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   106,
      -1,    -1,    -1,  4234,    -1,    -1,    -1,    -1,   338,  1906,
      -1,   341,    -1,    -1,    -1,    -1,    -1,  1914,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,   359,
      -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   152,   153,    -1,   378,   156,
      -1,  1948,  4283,    -1,    -1,   162,    -1,    -1,    -1,   166,
      -1,    -1,    -1,  4763,    -1,    -1,   396,    -1,    -1,    -1,
      -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,   409,
      -1,   188,   412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   441,    -1,    -1,   444,   445,    -1,   447,   448,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   457,    -1,    -1,
      -1,    -1,   462,  2030,    -1,    -1,    -1,    -1,   468,    -1,
      -1,   471,    -1,    -1,   474,    -1,    -1,    -1,  2045,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2053,   487,    -1,    -1,
      -1,    -1,  2059,    -1,    -1,    -1,    -1,  2064,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2124,    -1,    -1,
      -1,    -1,    -1,  2130,    -1,    -1,    -1,    -1,    -1,  2136,
      -1,    -1,    -1,    -1,    -1,  2142,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2169,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2194,    -1,    -1,
    2197,    -1,  5002,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5018,    -1,
      -1,    -1,   429,    -1,    -1,    -1,    -1,    -1,    -1,  4560,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5052,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4591,    -1,    -1,    -1,  2261,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4612,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4627,    -1,    -1,    -1,
      -1,  2298,  2299,    -1,    -1,    -1,    -1,  2304,  2305,    -1,
      -1,    -1,    -1,    -1,  2311,  2312,  2313,    -1,    -1,    -1,
    2317,    -1,  2319,  2320,  2321,  2322,  2323,  2324,    -1,  2326,
      -1,  2328,  2329,    -1,    -1,  2332,    -1,    -1,    -1,  4670,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2346,
    2347,  2348,  2349,  2350,  2351,    -1,    -1,    -1,  2355,    -1,
      -1,    -1,  2359,     5,    -1,  2362,  5166,    -1,  2365,  2366,
    2367,  2368,  2369,  2370,  2371,  2372,  2373,    -1,  2375,    -1,
      -1,    -1,    -1,    25,    -1,    -1,  2383,    -1,    -1,  2386,
      -1,    -1,    -1,    35,    36,    -1,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,  4760,
      -1,    -1,    74,    75,    76,    77,    78,    79,    80,    81,
      -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,  5249,
      -1,    -1,    -1,  2450,   661,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2464,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2473,  2474,    -1,    -1,
      -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   137,    -1,    -1,    -1,    -1,
      -1,    -1,   709,   710,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     757,    -1,    -1,  2550,    -1,    -1,    -1,  2554,  2555,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,
      -1,  2568,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2602,    -1,   249,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4946,    -1,  2614,    -1,    -1,
      -1,  2618,    -1,    -1,  2621,    -1,    -1,    -1,    -1,    -1,
     272,    -1,    -1,  2630,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2655,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   309,    -1,    -1,
     312,    -1,    -1,  2670,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2692,    -1,    -1,    -1,  2696,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5055,    -1,  2723,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   956,
     957,    -1,   959,    -1,    -1,  5086,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   406,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,     9,    -1,    -1,
      -1,    13,    -1,    15,    -1,    17,    18,    -1,    -1,    -1,
      -1,    -1,    -1,  5124,    -1,    -1,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1011,    -1,    -1,  1014,  1015,    -1,
     452,    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1029,    -1,  1031,   467,  1033,    -1,    -1,  2826,
    2827,    -1,  1039,    -1,    -1,    -1,  1043,    -1,  2835,    -1,
     482,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5180,
      -1,    -1,    -1,  5184,  5185,    -1,  1063,  1064,    -1,    -1,
      -1,    -1,    94,    -1,    -1,    -1,    -1,    -1,   510,    -1,
      -1,    -1,   104,    -1,   106,   107,   518,    -1,   520,   521,
     522,   523,   524,    -1,    -1,   527,   528,   529,   530,   121,
      -1,    -1,   534,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2897,    -1,    -1,  1110,    -1,  1112,    -1,    -1,    -1,   141,
      -1,   143,   144,    -1,    -1,    -1,  2913,   149,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     162,    -1,   164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5277,   179,    -1,   181,
      -1,    -1,   184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   197,    -1,   199,    -1,    -1,
      -1,   203,    -1,    -1,  2971,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,  1191,   217,    -1,   219,    -1,    -1,
      -1,    -1,    -1,   225,    -1,    -1,    -1,    -1,  1205,  1206,
      -1,    -1,  1209,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,
      -1,  3028,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3042,    -1,    -1,  3045,    -1,
    1257,  3048,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3056,
      -1,    -1,    -1,   295,   296,    -1,    -1,    -1,  3065,   301,
      -1,    -1,    -1,  3070,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   324,    -1,    -1,    -1,  3093,  3094,  3095,    -1,
      -1,  3098,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3106,
    3107,  3108,  3109,    -1,    -1,    -1,    -1,  3114,    -1,    -1,
      -1,    -1,  3119,  3120,    -1,  3122,    -1,  3124,    -1,    -1,
      -1,    -1,   364,    -1,    -1,    -1,    -1,    -1,  3135,  3136,
      -1,    -1,  3139,    -1,   376,    -1,    -1,    -1,    -1,   381,
     382,    -1,   384,    -1,    -1,    -1,  3153,   389,  3155,    -1,
    3157,    -1,   394,    -1,    -1,   397,    -1,    -1,    -1,    -1,
     402,    -1,    -1,    -1,    -1,   407,   408,    -1,    -1,    -1,
    3177,    -1,    -1,   415,    -1,    -1,    -1,   419,    -1,    -1,
      -1,  3188,    -1,  3190,  3191,  3192,    -1,   429,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   441,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3215,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   460,    -1,
     462,  3228,    -1,    -1,    -1,    -1,    -1,    -1,   470,    -1,
      -1,    -1,    -1,    -1,   476,    -1,  3243,    -1,    -1,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3257,    -1,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   515,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,    -1,  3296,
      -1,   533,  3299,    -1,  3301,    -1,    -1,    -1,    -1,  3306,
      -1,    -1,    -1,  1520,    -1,    -1,    -1,    -1,  1525,    -1,
    1527,    -1,    -1,  1530,    -1,  1532,    -1,    -1,  1535,  1536,
    1537,    -1,    -1,  3330,  1541,    -1,    -1,    -1,    -1,    -1,
      -1,  1548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1562,    -1,  1564,    -1,    -1,
      -1,  3358,  1569,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3375,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3400,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3435,  3436,
    3437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3469,    -1,  3471,    -1,    -1,  3474,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1692,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1703,  1704,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1720,    -1,    -1,    -1,    -1,  1725,  1726,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3532,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3557,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3585,    -1,
      -1,    -1,  3589,  3590,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1809,    -1,  1811,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1821,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3649,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   217,    -1,   219,    -1,    -1,    -1,    -1,    -1,    -1,
    3667,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3682,    -1,  1894,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1904,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3736,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1964,    -1,    -1,
    1967,  1968,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3781,    -1,    -1,  3784,    -1,    -1,
      -1,    -1,    -1,  3790,    -1,    -1,    -1,    -1,    -1,  3796,
      -1,  3798,    -1,    -1,  3801,    -1,    -1,    -1,  3805,  3806,
    3807,  3808,  3809,    -1,    -1,  3812,  3813,  3814,  3815,  3816,
    3817,  3818,  3819,  3820,  3821,    -1,    -1,    -1,  3825,  3826,
    2037,    -1,    -1,  3830,    -1,    -1,    -1,    -1,  3835,    -1,
      -1,    -1,  3839,    -1,  3841,    -1,  3843,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3851,    -1,    -1,  3854,    -1,  3856,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3864,  3865,    -1,
      -1,  3868,  3869,    -1,    -1,    -1,  3873,  3874,    -1,     5,
      -1,    -1,    -1,  3880,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3890,    -1,  3892,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3904,    -1,    35,
      36,    -1,    -1,  3910,  3911,  3912,    42,    43,    -1,    -1,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    -1,    -1,    -1,    85,
      -1,    -1,    -1,  3960,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3973,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4004,    -1,    -1,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2230,    -1,  2232,    -1,    -1,    -1,  2236,
      -1,  2238,    -1,    -1,  2241,    -1,    -1,    -1,  2245,    -1,
      -1,    -1,    -1,  2250,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   210,    -1,  4083,    -1,    -1,    -1,
      -1,  4088,  4089,  4090,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2382,    -1,    -1,    -1,    -1,
      -1,    -1,  2389,   309,    -1,    -1,   312,   872,   873,    -1,
      -1,   876,  2399,   878,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4207,    -1,    -1,   898,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   919,    -1,    -1,  4234,   923,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   941,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     406,    -1,    -1,    -1,    -1,    -1,  4283,  4284,  4285,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2520,    -1,   871,    -1,  2524,    -1,    -1,
      -1,    -1,    -1,  2530,   880,  2532,   452,    -1,  2535,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   467,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   482,    -1,    -1,    -1,
     916,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4369,    -1,  2581,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4380,   510,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   518,    -1,   520,   521,   522,   523,   524,    -1,
      -1,   527,   528,   529,   530,    -1,    -1,    -1,   534,    -1,
      -1,    -1,    -1,  4410,    -1,    -1,    -1,    -1,    -1,   975,
      -1,    -1,    -1,  4420,  4421,   981,  4423,    -1,    -1,   985,
    4427,  4428,    -1,    -1,    -1,  4432,  4433,    -1,    -1,    -1,
    4437,    -1,    -1,  4440,  4441,    -1,  1002,    -1,  4445,    -1,
      -1,    -1,    -1,    -1,  4451,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4469,    -1,    -1,    -1,  4473,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4485,    -1,
      -1,    -1,    -1,  4490,    -1,    -1,    -1,    -1,    -1,  4496,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4513,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2734,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2742,    -1,  2744,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4542,    -1,    -1,    -1,    -1,
      -1,  1107,  1108,    -1,    -1,    -1,    -1,    -1,  1114,    -1,
      -1,    -1,  1118,  4560,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1263,  1264,
      -1,    -1,    -1,    -1,    -1,  4582,    -1,    -1,  1144,    -1,
      -1,    -1,    -1,    -1,  4591,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4612,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4626,
    4627,    -1,    -1,  4630,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4670,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1372,  1373,    -1,
      -1,    -1,    -1,    -1,    -1,  4692,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4703,    -1,  1393,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1288,  1289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1316,  4758,    -1,  4760,    -1,    -1,    -1,  1323,    -1,    -1,
      -1,  1327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2989,  2990,    -1,    -1,    -1,  1343,  1473,  1474,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3006,
      -1,  1357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4811,    -1,    -1,    -1,  4815,    -1,
      -1,    -1,    -1,  4820,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1395,
    4837,  4838,    -1,    -1,  4841,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4855,    -1,
      -1,    -1,    -1,  4860,    -1,    -1,    -1,    -1,  4865,    -1,
      -1,  4868,  4869,    -1,    -1,    -1,    -1,    -1,    -1,  4876,
    4877,    -1,    -1,  1439,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4898,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4912,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4946,
      -1,    -1,    -1,    -1,    -1,    -1,  1512,    -1,    -1,  4956,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4993,    -1,    -1,  3206,
      -1,    -1,  4999,    -1,  3211,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1570,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1601,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5053,    -1,  5055,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1629,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5085,  5086,
      -1,  5088,    -1,  5090,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1657,  1658,  1659,    -1,  1661,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5114,    -1,    -1,
      -1,  5118,    -1,    -1,    -1,  1681,    -1,  5124,    -1,    -1,
      -1,    -1,  5129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5151,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5174,    -1,  1735,
      -1,    -1,    -1,  5180,    -1,    -1,    -1,  5184,  5185,    -1,
      -1,    -1,  5189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1765,
      -1,    -1,    -1,  1769,  1770,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1931,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5254,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5276,
    5277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1849,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5299,    -1,    -1,  5302,    -1,    -1,    -1,  1865,
    1995,  1996,  1997,  1998,  5311,    -1,    -1,    -1,    -1,  5316,
      -1,  5318,    -1,  5320,    -1,    -1,    -1,    -1,    -1,    -1,
    5327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5344,    -1,    -1,
    1906,    -1,    -1,    -1,  2039,  2040,    -1,    -1,  1914,    -1,
      -1,    -1,    -1,  2048,    -1,    -1,    -1,    -1,  5365,    -1,
      -1,    -1,    -1,  2058,    -1,    -1,    -1,    -1,  3585,    -1,
      -1,    -1,    -1,  3590,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2086,  2087,  2088,  2089,    -1,    -1,    -1,    -1,    -1,
      -1,  5408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5441,  5442,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5452,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3680,  2030,  5472,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2045,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2053,  2183,    -1,
      -1,  2186,    -1,    -1,    -1,    -1,    -1,    -1,  2064,    -1,
      -1,  2196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2205,    -1,    -1,  5520,    -1,    -1,    -1,    -1,    -1,  5526,
    5527,    -1,  5529,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5548,    -1,    -1,    -1,  2111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3771,    -1,    -1,    -1,  2124,    -1,
      -1,    -1,    -1,    -1,  2130,    -1,    -1,  5574,    -1,    -1,
    2136,    -1,    -1,    -1,    -1,    -1,  2142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2169,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5631,  5632,    -1,    -1,  2194,    -1,
    5637,  2197,    -1,    -1,    -1,    -1,    -1,    -1,  5645,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5656,
    5657,  5658,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2354,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2261,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2298,  2299,    -1,    -1,    -1,    -1,  2304,  2305,
      -1,    -1,    -1,    -1,    -1,  2311,  2312,  2313,    -1,    -1,
      -1,  2317,    -1,  2319,  2320,  2321,  2322,  2323,  2324,    -1,
    2326,  3978,  2328,  2329,    -1,    -1,  2332,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2346,  2347,  2348,  2349,  2350,    -1,    -1,    -1,    -1,  2355,
      -1,    -1,    -1,  2359,    -1,    -1,  2362,    -1,    -1,  2365,
    2366,  2367,  2368,  2369,  2370,  2371,  2372,  2373,    -1,  2375,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2383,    -1,    -1,
    2386,     6,     7,     8,    -1,    10,    11,    12,    -1,    -1,
      -1,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    -1,    -1,    -1,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    -1,    41,    42,    43,    -1,
      -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,  4089,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,  2450,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,  2464,    -1,
      -1,    -1,    -1,    -1,  4121,    -1,    -1,  2473,  2474,    -1,
      -1,    -1,    -1,    -1,   981,    -1,    -1,    -1,    -1,    -1,
      -1,  2616,  2617,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2625,    -1,  2627,   118,    -1,  1002,  2631,   122,   123,   124,
     125,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,    -1,    -1,
     145,    -1,   147,    -1,    -1,    -1,    -1,    -1,   153,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     165,    -1,    -1,    -1,  2550,    -1,    -1,   172,  2554,  2555,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   182,   183,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   218,    -1,    -1,  2602,   222,    -1,    -1,
      -1,    -1,    -1,   228,    -1,  2740,    -1,    -1,  2614,   234,
      -1,   236,  2618,    -1,    -1,  2621,    -1,   242,    -1,   244,
      -1,    -1,    -1,    -1,  2630,    -1,    -1,   252,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   266,   267,    -1,    -1,    -1,    -1,    -1,   273,  2655,
     275,    -1,    -1,   278,   279,    -1,   281,    -1,    -1,    -1,
      -1,    -1,    -1,  2798,  2670,   290,   291,    -1,   293,    -1,
      -1,  2806,    -1,  2808,    -1,    -1,    -1,    -1,    -1,  2814,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4345,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,    -1,   328,    -1,   330,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2723,    -1,   344,
     345,    -1,   347,   348,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   360,    -1,   362,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     375,  2886,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     395,    -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,    -1,    -1,   420,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2942,    -1,  2944,
      -1,    -1,   437,    -1,    -1,    -1,  1323,    -1,   443,    -1,
    2826,  2827,    -1,    -1,    -1,   450,   451,    -1,    -1,    -1,
      -1,   456,    -1,   458,    -1,    -1,  1343,    -1,    -1,    -1,
      -1,    -1,   467,    -1,  4501,    -1,    -1,    -1,    -1,    -1,
    1357,    -1,    -1,    -1,    -1,    -1,    -1,   482,    -1,    -1,
     485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   501,   502,   503,   504,
     505,   506,   507,   508,   509,    -1,    -1,    -1,    -1,    -1,
      -1,  2897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2913,    -1,    -1,
      -1,   536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3059,    -1,    -1,    -1,    -1,    -1,
      -1,  4588,  1439,    -1,    -1,    -1,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2971,    -1,    35,    36,    -1,
    4627,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    -1,    -1,    -1,    85,    -1,    -1,
      -1,    -1,  3028,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3042,    -1,    -1,  3045,
      -1,    -1,  3048,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3056,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3065,
      -1,    -1,    -1,  1570,  3070,    -1,    -1,    -1,    -1,   137,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3093,  3094,  3095,
      -1,    -1,  3098,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3106,  3107,  3108,  3109,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3119,    -1,    -1,  3122,    -1,  3124,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3135,
    3136,    -1,    -1,  3139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   210,    -1,    -1,    -1,    -1,  3153,    -1,  3155,
      -1,  3157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   249,  3188,    -1,  3190,  3191,  3192,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,  3215,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3228,    -1,    -1,    -1,    -1,    -1,    -1,  3364,
      -1,  3366,  3367,  3368,    -1,    -1,  4893,  3243,    -1,    -1,
      -1,   309,    -1,    -1,   312,    -1,    -1,    -1,    -1,    -1,
      -1,  3257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4946,
    3296,    -1,    -1,  3299,    -1,  3301,    -1,    -1,    -1,    -1,
    3306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3330,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,    -1,
      -1,    -1,  1849,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3358,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,    -1,  3375,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   452,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3400,    -1,    -1,    -1,    -1,   467,
      -1,   238,    -1,    -1,    -1,    -1,    -1,  1914,    -1,    -1,
      -1,   248,    -1,    -1,   482,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3558,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1948,   510,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,    -1,   520,   521,   522,   523,   524,    -1,    -1,   527,
     528,   529,    -1,  3469,    -1,  3471,   534,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2030,    -1,    -1,  3532,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2045,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2053,    -1,  5205,    -1,
      -1,  3557,    -1,    -1,    -1,    -1,    -1,  2064,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3711,    -1,  3713,  3585,
      -1,    -1,  3717,    -1,  3590,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2130,    -1,    -1,    -1,    -1,    -1,    -1,
    5287,    -1,    -1,    -1,    -1,  2142,    -1,    -1,    -1,  3774,
      -1,    -1,    -1,  3649,    -1,    -1,    -1,  2154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3667,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3682,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2194,    -1,    -1,
    2197,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3781,    -1,    -1,  3784,    -1,
      -1,    -1,    -1,    -1,  3790,    -1,    -1,    -1,    -1,    -1,
    3796,    -1,  3798,    -1,    -1,  3801,    -1,    -1,    -1,  3805,
    3806,  3807,  3808,  3809,    -1,    -1,  3812,  3813,  3814,  3815,
    3816,  3817,  3818,  3819,  3820,  3821,    -1,    -1,    -1,  3825,
    3826,    -1,    -1,    -1,  3830,    -1,    -1,    -1,    -1,  3835,
      -1,    -1,    -1,  3839,    -1,    -1,    -1,  3843,    -1,  2346,
      -1,    -1,    -1,    -1,    -1,  3851,    -1,    -1,  3854,    -1,
    3856,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3864,  3865,
      -1,    -1,  3868,  3869,    -1,    -1,    -1,  3873,  3874,    -1,
      -1,    -1,   709,   710,  3880,    -1,    -1,    -1,    -1,  2386,
      -1,    -1,    -1,    -1,  3890,    -1,  3892,    -1,    -1,    -1,
      -1,    -1,  4027,  4028,  4029,  4030,    -1,    -1,  3904,    -1,
      -1,    -1,    -1,    -1,  3910,  3911,  3912,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3960,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3973,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3989,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4004,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   878,    -1,  2550,    -1,    -1,    -1,  2554,  2555,   886,
      -1,    -1,   889,   890,    -1,   892,    -1,    -1,   895,    -1,
     897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     917,    -1,    -1,  4089,    -1,    -1,    -1,    -1,   925,    -1,
      -1,    -1,    -1,    -1,    -1,   932,    -1,    -1,   935,   936,
      -1,    -1,    -1,   940,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2618,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     957,    -1,   959,  2630,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   976,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   991,    -1,   993,    -1,    -1,   996,
      -1,   998,    -1,  2670,  1001,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1015,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1110,    -1,    -1,    -1,  4283,  4284,  4285,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2827,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4369,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4380,    -1,    -1,    -1,    -1,    -1,
      -1,  1218,    -1,  1220,    -1,    -1,    -1,  1224,    -1,    -1,
    2897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4410,    -1,    -1,  1244,    -1,    -1,
      -1,    -1,    -1,    -1,  4420,  4421,    -1,  4423,    -1,    -1,
      -1,  4427,  4428,    -1,    -1,    -1,  4432,  4433,    -1,    -1,
      -1,  4437,    -1,    -1,  4440,  4441,    -1,    -1,    -1,  4445,
      -1,    -1,    -1,    -1,    -1,  4451,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4469,    -1,    -1,  1303,  4473,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4485,
      -1,    -1,    -1,  1320,  4490,    -1,    -1,    -1,    -1,    -1,
    4496,    -1,    -1,    -1,    -1,  1332,    -1,  1334,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1342,    -1,  4513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4650,    -1,  1354,    -1,    -1,
      -1,  3028,  1359,    -1,    -1,  1362,    -1,    -1,    -1,    -1,
    4665,    -1,    -1,    -1,    -1,    -1,  4542,    -1,  3045,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3056,
      -1,    -1,    -1,    -1,  4560,    -1,    -1,    -1,    -1,  1396,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4591,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4733,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4612,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4627,    -1,    -1,  4630,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4670,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3190,  3191,  3192,  4692,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4703,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1559,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4758,    -1,  4760,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4914,
    4915,  4916,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3296,
      -1,    -1,  3299,    -1,  3301,    -1,    -1,    -1,    -1,  3306,
      -1,    -1,    -1,    -1,    -1,  4811,    -1,    -1,    -1,  4815,
      -1,    -1,    -1,    -1,  4820,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4837,  4838,    -1,    -1,  4841,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4855,
      -1,  3358,    -1,    -1,  4860,    -1,    -1,    -1,    -1,  4865,
      -1,    -1,  4868,  4869,    -1,    -1,    -1,    -1,  3375,    -1,
    4876,  4877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4898,  3400,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4912,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5051,    -1,  1755,  1756,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4946,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4956,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3469,    -1,  3471,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1814,    -1,    -1,
    1817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1825,    -1,
      -1,    -1,    -1,  4999,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1843,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3532,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5053,    -1,  5055,
    3557,    -1,    -1,  1890,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5197,    -1,  5199,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3585,  5085,
    5086,    -1,  5088,  3590,  5090,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5114,    -1,
      -1,    -1,  5118,    -1,  1951,    -1,    -1,    -1,  5124,    -1,
      -1,    -1,    -1,  5129,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3649,    -1,    -1,  5151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3667,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5180,  3682,    -1,    -1,  5184,  5185,
      -1,    -1,    -1,  5189,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5333,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5233,    -1,    -1,
      -1,  2068,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5254,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5402,    -1,    -1,
    5276,  5277,    -1,    -1,    -1,    -1,    -1,  3784,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5299,    -1,    -1,  5302,    -1,  3805,    -1,
      -1,    -1,    -1,    -1,    -1,  5311,    -1,    -1,    -1,    -1,
    5316,    -1,  5318,    -1,  5320,    -1,    -1,    -1,    -1,    -1,
      -1,  5327,    -1,  3830,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2168,    -1,    -1,    -1,    -1,    -1,    -1,  5344,    -1,
      -1,    -1,    -1,    -1,    -1,  2182,    -1,  5482,  2185,    -1,
    2187,    -1,  2189,    -1,    -1,    -1,    -1,  3864,  2195,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5408,    -1,    -1,  3912,    -1,    -1,    -1,  2246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5555,  2258,    -1,    -1,    -1,  2262,    -1,  2264,    -1,    -1,
    2267,    -1,    -1,    -1,    -1,  5441,  5442,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5452,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5472,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5520,    -1,    -1,    -1,    -1,    -1,
    5526,  5527,    -1,  5529,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2389,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4089,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5631,  5632,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5645,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5657,  5658,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2535,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4234,  2565,  2566,
      -1,    -1,    -1,  2570,  2571,    -1,    -1,    -1,  2575,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2589,    -1,    -1,    -1,    -1,    -1,    -1,  2596,
      -1,    -1,    -1,  2600,  2601,    -1,    -1,  2604,  2605,    -1,
      -1,    -1,    -1,    -1,  2611,    -1,  4283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2624,    -1,  2626,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2645,    -1,
      -1,    -1,    -1,  2650,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2663,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2672,    -1,  2674,    -1,    -1,
    2677,  2678,  2679,    -1,    -1,    -1,    -1,  2684,  2685,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2694,    -1,   981,
      -1,    -1,  2699,    -1,    -1,    -1,    -1,  2704,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1002,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2730,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2741,    -1,  2743,    -1,    -1,    -1,
      -1,  2748,    -1,    -1,    -1,  2752,  4423,  2754,  2755,  2756,
    2757,    -1,  2759,    -1,    -1,    -1,  4433,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2772,  2773,  2774,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2784,  2785,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4485,    -1,
      -1,    -1,    -1,  4490,    -1,    -1,    -1,    -1,    -1,  4496,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2836,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4560,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4591,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4612,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4627,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     871,    -1,    -1,  4670,    -1,  3002,    -1,    -1,    -1,   880,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3033,    -1,    -1,    -1,
      -1,  1323,    -1,    -1,    -1,   916,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1343,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1357,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4758,    -1,  4760,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   975,    -1,    -1,    -1,    -1,    -1,
     981,    -1,    -1,    -1,   985,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1002,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4815,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1439,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3226,
      -1,    -1,    -1,    -1,    -1,    -1,  1107,  1108,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1144,    -1,    -1,    -1,    -1,    -1,  4946,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1570,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3309,  3310,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3352,    -1,    -1,    -1,  3356,
      -1,    -1,    -1,    -1,    -1,  3362,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3378,  3379,    -1,    -1,    -1,  3383,    -1,  5055,    -1,
      -1,  3388,  3389,  3390,    -1,  3392,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3413,    -1,    -1,  5086,
      -1,    -1,    -1,    -1,    -1,    -1,  3423,  3424,  3425,  3426,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1316,    -1,    -1,    -1,    -1,
      -1,    -1,  1323,    -1,    -1,    -1,  1327,  5124,    -1,    -1,
      -1,    -1,    -1,  3460,    -1,    -1,  3463,  3464,  3465,    -1,
      -1,    -1,  1343,    -1,    -1,    -1,  3473,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1357,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5180,    -1,    -1,    -1,  5184,  5185,    -1,
      -1,    -1,    -1,    -1,  1395,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3544,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3552,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1849,  1439,    -1,
      -1,    -1,    -1,    -1,  3571,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5276,
    5277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1914,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1512,    -1,    -1,  3641,    -1,    -1,    -1,  3645,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1948,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3674,    -1,    -1,
      -1,    -1,    -1,  3680,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1570,
      -1,    -1,    -1,    -1,    -1,  3702,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3716,
      -1,    -1,    -1,  3720,    -1,    -1,    -1,    -1,    -1,    -1,
    1601,    -1,    -1,    -1,    -1,    -1,    -1,  3734,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2030,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1629,    -1,
      -1,    -1,    -1,  2045,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2064,    -1,    -1,    -1,  1657,  1658,  1659,    -1,
    1661,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1681,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2130,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2142,    -1,    -1,    -1,  1735,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1765,    -1,    -1,    -1,  1769,  1770,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2194,    -1,    -1,  2197,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1849,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4011,    -1,  4013,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4021,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4038,    -1,  1914,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4054,    -1,    -1,
      -1,    -1,    -1,    -1,  2346,    -1,    -1,    -1,    -1,    -1,
      -1,  4068,    -1,    -1,    -1,    -1,    -1,  1948,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4086,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4096,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4128,  4129,  4130,    -1,    -1,  4133,  4134,  4135,  4136,
    4137,  4138,    -1,    -1,    -1,    -1,  4143,  4144,    -1,  4146,
    4147,  4148,  4149,  4150,  4151,    -1,  4153,    -1,    -1,  2030,
      -1,    -1,    -1,    -1,    -1,  4162,    -1,  4164,  4165,    -1,
      -1,    -1,    -1,    -1,  2045,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4187,    -1,    -1,  2064,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4206,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2124,    -1,    -1,    -1,    -1,    -1,  2130,
      -1,    -1,    -1,    -1,    -1,  2136,    -1,    -1,  2550,    -1,
      -1,  2142,  2554,  2555,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2169,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4303,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2194,    -1,    -1,  2197,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2618,    -1,    -1,    -1,
      -1,    -1,    -1,  4340,  4341,  4342,    -1,    -1,  2630,    -1,
      -1,    -1,    -1,    -1,    -1,  4352,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1107,
    1108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2670,    -1,
    2261,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1144,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2298,  2299,    -1,
      -1,    -1,    -1,  2304,  2305,    -1,    -1,    -1,    -1,    -1,
    2311,  2312,  2313,    -1,    -1,    -1,  2317,    -1,  2319,  2320,
    2321,  2322,  2323,  2324,    -1,  2326,    -1,  2328,  2329,    -1,
      -1,  2332,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2346,  2347,  2348,  2349,  2350,
      -1,    -1,    -1,    -1,  2355,    -1,    -1,    -1,  2359,    -1,
      -1,  2362,    -1,    -1,  2365,  2366,  2367,  2368,  2369,  2370,
    2371,  2372,  2373,    -1,  2375,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2383,    -1,    -1,  2386,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2827,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4568,    -1,    -1,    -1,  4572,  4573,  4574,  4575,  2450,
      -1,  4578,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2464,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2473,  2474,    -1,  4602,  4603,  4604,    -1,  4606,
      -1,  4608,  4609,    -1,    -1,  2897,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4620,  4621,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4641,    -1,    -1,    -1,    -1,    -1,
      -1,  4648,  4649,    -1,  4651,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4663,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2550,
      -1,    -1,    -1,  2554,  2555,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4723,    -1,    -1,    -1,
      -1,  2602,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2614,    -1,    -1,  3028,  2618,  4745,    -1,
    2621,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2630,
      -1,    -1,    -1,  3045,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3056,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4784,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2670,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4858,    -1,  1601,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4873,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1629,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1657,
    1658,  1659,    -1,  1661,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1681,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4948,    -1,    -1,    -1,  2826,  2827,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4969,    -1,    -1,    -1,    -1,  4974,  4975,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1735,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3296,    -1,    -1,  3299,    -1,  3301,
      -1,    -1,  5019,    -1,  3306,    -1,  2897,  1765,    -1,    -1,
      -1,  1769,  1770,    -1,    -1,    -1,    -1,  5034,    -1,    -1,
      -1,    -1,  2913,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5066,
      -1,    -1,    -1,    -1,    -1,    -1,  3358,    -1,    -1,  5076,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3375,    -1,    -1,    -1,    -1,    -1,    -1,
    2971,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5111,    -1,    -1,    -1,  3400,    -1,
      -1,    -1,    -1,    -1,    -1,  5122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5147,    -1,    -1,    -1,    -1,    -1,    -1,  3028,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3042,    -1,  5170,  3045,    -1,    -1,  3048,    -1,    -1,
     981,    -1,  5179,    -1,    -1,  3056,    -1,  3469,    -1,  3471,
      -1,    -1,    -1,    -1,  3065,    -1,    -1,    -1,    -1,  3070,
      -1,  1002,    -1,  5200,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3093,  3094,  3095,    -1,    -1,  3098,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3106,  3107,  3108,  3109,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3119,    -1,
    3532,  3122,    -1,  3124,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3135,  3136,    -1,    -1,  3139,    -1,
      -1,    -1,    -1,    -1,    -1,  3557,    -1,    -1,    -1,    -1,
      -1,    -1,  3153,    -1,  3155,    -1,  3157,  5284,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   981,  3585,    -1,    -1,  3177,    -1,  3590,    -1,
      -1,  5308,    -1,    -1,    -1,    -1,    -1,  3188,    -1,  3190,
    3191,  3192,    -1,  1002,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3215,  5342,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3228,    -1,    -1,
    5357,    -1,    -1,    -1,    -1,    -1,    -1,  3649,    -1,    -1,
      -1,    -1,  3243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3667,  3257,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5394,    -1,    -1,
    3682,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3296,    -1,    -1,  3299,    -1,
    3301,    -1,    -1,    -1,    -1,  3306,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3330,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5471,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3358,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3784,    -1,  3375,    -1,    -1,    -1,    -1,    -1,
    5507,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1323,  3805,    -1,    -1,    -1,    -1,    -1,  3400,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1343,    -1,    -1,    -1,    -1,    -1,  3830,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1357,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2304,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2317,
      -1,  2319,  3864,    -1,  2322,  2323,  2324,    -1,    -1,    -1,
      -1,  2329,    -1,    -1,  2332,    -1,    -1,    -1,  3469,    -1,
    3471,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2347,
    2348,  2349,  2350,    -1,    -1,    -1,    -1,  2355,    -1,    -1,
      -1,  2359,    -1,    -1,  2362,    -1,    -1,  2365,  2366,  2367,
    2368,  2369,  2370,  2371,  2372,  2373,    -1,  2375,  1439,    -1,
      -1,    -1,    -1,    -1,  1323,  2383,    -1,    -1,  2386,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3532,    -1,    -1,  1343,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1357,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3557,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3989,    -1,    -1,
      -1,    -1,  2450,    -1,  3585,    -1,    -1,    -1,    -1,  3590,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2473,  2474,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1570,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3649,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3667,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4089,    -1,    -1,
      -1,  3682,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   981,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1002,    -1,  2602,  3736,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1570,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3781,    -1,    -1,  3784,    -1,    -1,    -1,    -1,    -1,  3790,
      -1,    -1,    -1,    -1,    -1,  3796,    -1,  3798,    -1,    -1,
    3801,    -1,    -1,    -1,  3805,  3806,  3807,  3808,  3809,    -1,
      -1,  3812,  3813,  3814,  3815,  3816,  3817,  3818,  3819,  3820,
    3821,    -1,  4234,    -1,  3825,  3826,    -1,    -1,    -1,  3830,
      -1,    -1,    -1,    -1,  3835,    -1,    -1,    -1,  3839,    -1,
      -1,    -1,  3843,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3851,    -1,    -1,  3854,    -1,  3856,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3864,  3865,    -1,    -1,  3868,  3869,    -1,
      -1,  4283,  3873,  3874,    -1,    -1,    -1,    -1,    -1,  3880,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3890,
      -1,  3892,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3904,    -1,    -1,    -1,    -1,    -1,  3910,
    3911,  3912,    -1,    -1,    -1,    -1,    -1,    -1,  1849,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2826,  3960,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3973,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1914,    -1,    -1,    -1,    -1,  3989,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4004,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4423,    -1,    -1,    -1,    -1,    -1,  1948,    -1,    -1,
      -1,  4433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1849,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1323,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1343,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1357,  4089,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2030,
      -1,    -1,    -1,  2971,    -1,  1914,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2045,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2064,    -1,    -1,    -1,    -1,    -1,  1948,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4560,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1439,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4591,
    2111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3065,    -1,  2130,
    4612,    -1,  3070,    -1,    -1,    -1,  4207,    -1,    -1,    -1,
      -1,  2142,    -1,    -1,    -1,  4627,    -1,    -1,    -1,    -1,
      -1,  2030,   981,  2154,    -1,    -1,    -1,  3095,    -1,    -1,
      -1,    -1,    -1,  4234,    -1,    -1,  2045,    -1,  3106,    -1,
    3108,  3109,    -1,  1002,  2053,    -1,    -1,    -1,    -1,    -1,
      -1,  3119,    -1,    -1,  3122,  2064,  3124,    -1,  4670,    -1,
      -1,    -1,    -1,  2194,    -1,    -1,  2197,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4283,  4284,  4285,  3153,    -1,  3155,    -1,  3157,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1570,    -1,  2111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2130,  3190,  3191,  3192,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2154,    -1,  3215,  4760,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4369,    -1,
      -1,    -1,    -1,    -1,    -1,  3243,    -1,    -1,    -1,  4380,
      -1,    -1,    -1,    -1,    -1,  2194,    -1,    -1,  2197,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4815,    -1,    -1,    -1,    -1,    -1,  4410,
      -1,    -1,    -1,    -1,    -1,  2346,    -1,    -1,    -1,  4420,
    4421,    -1,  4423,    -1,    -1,    -1,  4427,  4428,    -1,    -1,
      -1,  4432,  4433,    -1,    -1,    -1,  4437,    -1,    -1,  4440,
    4441,    -1,    -1,    -1,  4445,    -1,    -1,    -1,    -1,    -1,
    4451,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3330,    -1,    -1,    -1,    -1,    -1,  4469,    -1,
      -1,    -1,  4473,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4485,    -1,    -1,    -1,    -1,  4490,
      -1,    -1,    -1,    -1,    -1,  4496,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4946,    -1,    -1,  2346,    -1,    -1,
      -1,  4542,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4560,
      -1,    -1,    -1,    -1,  1323,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1849,
      -1,    -1,    -1,    -1,  1343,    -1,    -1,    -1,    -1,    -1,
    4591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1357,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4612,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2550,
      -1,    -1,    -1,  2554,  2555,    -1,  4627,    -1,    -1,  4630,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5055,  1914,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4670,
      -1,    -1,    -1,    -1,  5086,    -1,    -1,    -1,  1948,    -1,
    1439,    -1,    -1,    -1,    -1,    -1,    -1,  2618,    -1,    -1,
      -1,  4692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2630,
      -1,    -1,  4703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2670,
      -1,  2550,    -1,    -1,    -1,  2554,  2555,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4758,    -1,  4760,
    2030,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5180,    -1,
      -1,    -1,  5184,  5185,    -1,  2045,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2053,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2064,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2618,
    4811,  1570,    -1,    -1,  4815,    -1,    -1,    -1,    -1,  4820,
      -1,  2630,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   981,    -1,    -1,    -1,  4837,  4838,    -1,    -1,
    4841,  2111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1002,  4855,    -1,    -1,    -1,    -1,  4860,
    2130,  2670,    -1,    -1,  4865,  5277,    -1,  4868,  4869,    -1,
      -1,    -1,  2142,    -1,    -1,  4876,  4877,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2154,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2827,  4898,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4912,    -1,  3781,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3790,    -1,  2194,    -1,    -1,  2197,  3796,    -1,
    3798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4946,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4956,    -1,  3825,  3826,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2897,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3843,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3851,    -1,    -1,  3854,    -1,  3856,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3865,  4999,    -1,
      -1,    -1,    -1,    -1,    -1,  3873,  3874,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2827,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3904,    -1,    -1,    -1,
      -1,    -1,  3910,  3911,  3912,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5053,    -1,  5055,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2346,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5085,  5086,    -1,  5088,  2897,  5090,
    1849,    -1,  3960,    -1,    -1,    -1,    -1,  3028,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3973,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5114,  3045,    -1,    -1,  5118,    -1,    -1,
      -1,    -1,    -1,  5124,    -1,  3056,    -1,    -1,  5129,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5151,    -1,    -1,    -1,    -1,  1914,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1323,    -1,    -1,    -1,    -1,  5180,
      -1,    -1,    -1,  5184,  5185,    -1,    -1,    -1,  5189,  1948,
      -1,    -1,    -1,    -1,  1343,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1357,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3028,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5233,    -1,    -1,    -1,  3045,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3056,    -1,    -1,
      -1,    -1,    -1,  5254,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2030,    -1,    -1,    -1,  5276,  5277,    -1,    -1,    -1,
    2550,    -1,    -1,    -1,  2554,  2555,  2045,    -1,    -1,    -1,
    1439,    -1,    -1,    -1,  2053,    -1,    -1,    -1,  5299,    -1,
      -1,  5302,    -1,    -1,    -1,  2064,    -1,    -1,    -1,    -1,
    5311,    -1,    -1,    -1,    -1,  5316,    -1,  5318,    -1,  5320,
      -1,    -1,    -1,    -1,    -1,    -1,  5327,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5344,    -1,    -1,    -1,    -1,  2618,    -1,
      -1,    -1,  2111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2630,    -1,    -1,    -1,    -1,  3296,    -1,    -1,  3299,    -1,
    3301,  2130,    -1,    -1,    -1,  3306,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2154,    -1,    -1,    -1,    -1,
    2670,    -1,    -1,    -1,    -1,    -1,    -1,  5408,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4284,  4285,    -1,    -1,
      -1,  1570,    -1,    -1,    -1,    -1,    -1,  3358,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2194,    -1,    -1,  2197,    -1,
    5441,  5442,    -1,    -1,  3375,    -1,    -1,    -1,    -1,    -1,
      -1,  5452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3400,
      -1,  5472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3296,    -1,    -1,
    3299,    -1,  3301,    -1,    -1,    -1,    -1,  3306,    -1,    -1,
      -1,  4369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4380,    -1,    -1,    -1,    -1,    -1,    -1,  5520,
      -1,    -1,    -1,    -1,    -1,  5526,  5527,    -1,  5529,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3469,    -1,
    3471,    -1,    -1,    -1,    -1,    -1,    -1,  5548,    -1,  3358,
      -1,    -1,  4420,  4421,    -1,    -1,    -1,  2827,    -1,  4427,
    4428,    -1,    -1,    -1,  4432,    -1,  3375,    -1,    -1,  4437,
      -1,    -1,  4440,  4441,    -1,    -1,    -1,  4445,    -1,    -1,
      -1,    -1,    -1,  4451,    -1,    -1,    -1,  2346,    -1,    -1,
      -1,  3400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3532,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4485,    -1,    -1,
      -1,    -1,  4490,    -1,    -1,    -1,  3557,  2897,  4496,    -1,
    5631,  5632,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5645,  4513,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3585,    -1,  5657,  5658,    -1,  3590,
    3469,    -1,  3471,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4542,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1849,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3649,    -1,
      -1,    -1,    -1,  3532,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3667,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3557,    -1,
      -1,  3682,    -1,    -1,    -1,    -1,    -1,    -1,  3028,    -1,
      -1,    -1,  4630,    -1,    -1,  1914,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3045,  3585,    -1,    -1,    -1,
      -1,  3590,    -1,    -1,    -1,    -1,  3056,    -1,    -1,    -1,
      -1,  2550,    -1,    -1,    -1,  2554,  2555,    -1,    -1,  1948,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4692,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3649,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3784,    -1,    -1,    -1,    -1,  3667,  2618,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2630,    -1,  3682,  3805,    -1,    -1,    -1,    -1,    -1,
      -1,  2030,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2045,    -1,    -1,  3830,
      -1,    -1,    -1,    -1,  2053,    -1,    -1,    -1,    -1,    -1,
      -1,  2670,    -1,    -1,    -1,  2064,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1673,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3864,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2111,    -1,    -1,    -1,    -1,    -1,    -1,  4837,
    4838,    -1,    -1,  4841,    -1,  3784,    -1,    -1,    -1,    -1,
      -1,  2130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2142,    -1,    -1,  3805,    -1,    -1,    -1,
      -1,    -1,  1751,    -1,    -1,  2154,    -1,    -1,  4876,  4877,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3830,    -1,    -1,    -1,    -1,  3296,    -1,    -1,  3299,
      -1,  3301,    -1,    -1,    -1,    -1,  3306,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2194,    -1,    -1,  2197,    -1,
      -1,    -1,    -1,    -1,    -1,  3864,    -1,    -1,  3989,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2827,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3358,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3375,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2897,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4089,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2346,    -1,  3469,
      -1,  3471,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5088,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5114,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5129,  3532,    -1,    -1,    -1,    -1,    -1,    -1,  3028,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4089,    -1,    -1,  5151,    -1,    -1,  3045,  3557,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3056,    -1,    -1,
      -1,    -1,    -1,  4234,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3585,    -1,    -1,    -1,    -1,
    3590,  5189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3649,
      -1,    -1,    -1,    -1,    -1,    -1,  5254,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3667,    -1,    -1,
      -1,  2550,    -1,    -1,    -1,  2554,  2555,    -1,    -1,    -1,
      -1,    -1,  3682,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4234,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2213,    -1,    -1,    -1,    -1,  2618,
      -1,    -1,    -1,    -1,  4283,    -1,  5344,    -1,    -1,    -1,
      -1,  2630,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3784,    -1,    -1,    -1,    -1,    -1,
      -1,  2670,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3805,    -1,  3296,    -1,    -1,
    3299,    -1,  3301,    -1,    -1,    -1,    -1,  3306,    -1,    -1,
      -1,    -1,    -1,  2302,    -1,    -1,    -1,    -1,    -1,    -1,
    3830,    -1,    -1,    -1,    -1,    -1,    -1,  2316,    -1,    -1,
      -1,  2320,    -1,  5441,  5442,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5452,  2334,  2335,  2336,    -1,    -1,
    2339,    -1,    -1,    -1,  3864,    -1,    -1,    -1,    -1,  3358,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4423,    -1,  3375,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4433,    -1,    -1,    -1,    -1,  4560,
      -1,    -1,  2381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4591,  5529,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2827,    -1,
    5548,  4612,    -1,    -1,    -1,    -1,    -1,  2436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4627,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3469,  2460,  3471,    -1,    -1,    -1,    -1,    -1,    -1,  3989,
      -1,    -1,    -1,  2472,    -1,    -1,    -1,    -1,  2477,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4670,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2897,    -1,
      -1,  4560,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5631,  5632,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3532,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3557,    -1,
      -1,    -1,    -1,  4612,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4627,  4089,
      -1,    -1,    -1,    -1,    -1,    -1,  3585,    -1,    -1,  4760,
      -1,  3590,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4670,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3028,
      -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,    -1,    -1,
    3649,    -1,    -1,    -1,    -1,    -1,  3045,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3056,  3667,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3682,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4234,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,
      -1,    -1,    -1,  4283,    -1,  4946,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3784,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3805,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3864,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5055,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4946,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3296,    -1,    -1,
    3299,    -1,  3301,  4423,    -1,  5086,    -1,  3306,    -1,    -1,
      -1,    -1,    -1,  4433,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5124,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3358,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3375,    -1,    -1,    -1,
    3989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5055,    -1,    -1,  5180,
      -1,  3400,    -1,  5184,  5185,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5086,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4560,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5124,    -1,    -1,    -1,  3068,
    3469,  4591,  3471,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4089,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3088,
      -1,  3090,  4612,    -1,  3093,  3094,  5277,  3096,    -1,  3098,
      -1,    -1,    -1,  3102,    -1,    -1,  3105,  4627,    -1,    -1,
      -1,  3110,    -1,    -1,    -1,    -1,    -1,  3116,    -1,    -1,
      -1,  5180,  3121,    -1,    -1,  5184,  5185,    -1,    -1,  3128,
    3129,  3130,  3131,  3532,    -1,    -1,  3135,  3136,    -1,  3138,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4670,  3150,    -1,  3152,    -1,    -1,    -1,    -1,  3557,    -1,
    3159,  3160,  3161,  3162,  3163,  3164,  3165,  3166,  3167,  3168,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3585,    -1,    -1,    -1,
      -1,  3590,    -1,    -1,    -1,    -1,    -1,  3196,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     6,     7,     8,    -1,
      10,    11,    12,    -1,    -1,    -1,    16,    -1,  5277,    19,
      20,    21,    22,    23,    24,  4234,    26,    27,    -1,    -1,
      -1,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
    4760,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,    -1,
    3649,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3667,    -1,
      70,    -1,    -1,    -1,  4283,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,  3682,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,
      -1,    -1,   122,   123,   124,   125,   126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,
      -1,    -1,    -1,    -1,    -1,   145,  3345,   147,    -1,    -1,
      -1,    -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,    -1,
      -1,    -1,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   182,   183,    -1,  3784,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3805,    -1,    -1,    -1,
     210,    -1,    -1,    -1,  4423,    -1,    -1,    -1,   218,    -1,
      -1,    -1,   222,    -1,  4433,    -1,  4946,    -1,   228,    -1,
      -1,  3830,    -1,    -1,   234,    -1,   236,    -1,    -1,    -1,
      -1,    -1,   242,    -1,   244,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3864,   266,   267,    -1,    -1,
      -1,    -1,    -1,   273,    -1,   275,    -1,    -1,   278,   279,
      -1,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     290,   291,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   316,   317,   318,    -1,
      -1,   321,    -1,    -1,    -1,   325,    -1,    -1,   328,    -1,
     330,    -1,    -1,    -1,    -1,  5055,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   344,   345,    -1,   347,   348,    -1,
      -1,  4560,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     360,    -1,   362,    -1,    -1,    -1,  5086,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   375,    -1,    -1,    -1,    -1,
      -1,    -1,  4591,    -1,    -1,    -1,    -1,  3586,    -1,    -1,
    3989,    -1,    -1,    -1,    -1,   395,    -1,    -1,    -1,   399,
      -1,    -1,    -1,  4612,  5124,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,  4627,    -1,
     420,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,
      -1,    -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,    -1,
     450,   451,    -1,    -1,    -1,    -1,   456,    -1,   458,    -1,
    5180,  4670,    -1,    -1,  5184,  5185,    -1,   467,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   482,    -1,    -1,   485,    -1,    -1,    -1,    -1,
    4089,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,   508,   509,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3724,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4760,    -1,    -1,    -1,    -1,    -1,  5277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3780,    -1,    -1,    -1,    -1,    -1,  3786,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3802,  3803,    -1,  4815,  3806,  3807,  3808,
    3809,    -1,    -1,  3812,  3813,  3814,  3815,  3816,  3817,  3818,
    3819,  3820,  3821,  3822,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4234,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3844,    -1,    -1,  3847,    -1,
    3849,    -1,    -1,  3852,  3853,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3867,  3868,
    3869,  3870,    -1,  3872,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4283,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4946,    -1,    -1,
      -1,  3940,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4001,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4423,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4433,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5055,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5086,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4560,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5180,    -1,    -1,    -1,  5184,  5185,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4207,    -1,
      -1,    -1,    -1,  4612,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4627,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5277,    -1,
      -1,  4670,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4370,    -1,    -1,    -1,  4374,  4375,  4376,    -1,    -1,
      -1,    -1,    -1,  4382,  4383,  4384,  4385,    -1,    -1,    -1,
      -1,  4390,  4391,  4392,  4393,  4394,  4395,  4396,  4397,  4398,
    4399,  4400,  4401,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4426,    -1,    -1,
    4429,    -1,  4431,    -1,    -1,    -1,  4435,    -1,    -1,  4438,
    4439,    -1,    -1,  4442,  4443,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4487,    -1,
      -1,    -1,    -1,    -1,    -1,  4494,  4495,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4512,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4946,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5055,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5086,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4695,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4755,  4756,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5180,    -1,    -1,    -1,  5184,  5185,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4805,    -1,    -1,    -1,
      -1,  4810,  4811,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4825,    -1,  4827,    -1,
      -1,    -1,  4831,  4832,  4833,    -1,    -1,  4836,    -1,    -1,
    4839,  4840,    -1,    -1,    -1,  4844,    -1,    -1,    -1,  4848,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5277,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4910,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,  4970,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,  5004,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,
      -1,   106,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,   118,    -1,    -1,   121,   122,   123,   124,
     125,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   138,    -1,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,   151,    -1,   153,    -1,
      -1,    -1,    -1,    -1,    -1,  5084,  5085,   162,    -1,   164,
     165,    -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,    -1,
      -1,  5100,  5101,  5102,   179,    -1,   181,   182,   183,   184,
      -1,    -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,    -1,
      -1,    -1,   197,    -1,   199,    -1,    -1,    -1,   203,    -1,
      -1,    -1,    -1,    -1,   209,   210,    -1,  5136,  5137,    -1,
      -1,    -1,   217,   218,   219,    -1,    -1,   222,    -1,    -1,
     225,    -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,   234,
      -1,   236,    -1,    -1,    -1,   240,    -1,   242,    -1,   244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,
      -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   266,   267,    -1,    -1,   270,    -1,    -1,   273,    -1,
     275,    -1,    -1,   278,   279,    -1,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   290,   291,    -1,   293,    -1,
     295,   296,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   313,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,    -1,    -1,   324,
     325,    -1,    -1,   328,    -1,   330,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   344,
     345,    -1,   347,   348,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   360,    -1,   362,    -1,   364,
      -1,    -1,  5291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     375,   376,    -1,    -1,    -1,    -1,   381,   382,  5307,   384,
      -1,    -1,    -1,    -1,   389,    -1,    -1,    -1,    -1,   394,
     395,    -1,   397,    -1,   399,    -1,    -1,   402,    -1,    -1,
      -1,    -1,   407,   408,    -1,    -1,    -1,    -1,    -1,    -1,
     415,    -1,   417,    -1,   419,   420,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,   429,    -1,    -1,  5356,    -1,    -1,
      -1,    -1,   437,    -1,    -1,    -1,   441,    -1,   443,    -1,
      -1,    -1,    -1,    -1,    -1,   450,   451,    -1,    -1,    -1,
      -1,   456,    -1,   458,    -1,   460,    -1,   462,    -1,    -1,
      -1,    -1,   467,    -1,    -1,   470,    -1,    -1,   473,    -1,
      -1,   476,    -1,    -1,    -1,    -1,   481,   482,  5407,    -1,
     485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   494,
      -1,    -1,    -1,    -1,    -1,    -1,   501,   502,   503,   504,
     505,   506,   507,   508,   509,    -1,    -1,    -1,    -1,    -1,
     515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   529,    -1,    -1,    -1,   533,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5470,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5532,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,  5603,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5644,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,     6,     7,     8,    -1,    10,
      11,    12,    -1,    -1,    -1,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,   535,    -1,    -1,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    -1,
      41,    42,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,
      -1,   122,   123,   124,   125,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,
      -1,    -1,    -1,    -1,   145,    -1,   147,    -1,    -1,    -1,
      -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,    -1,    -1,
      -1,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   182,   183,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,    -1,    -1,
      -1,   222,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
      -1,    -1,    -1,   234,    -1,   236,    -1,    -1,    -1,    -1,
      -1,   242,    -1,   244,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   266,   267,    -1,    -1,    -1,
      -1,    -1,   273,    -1,   275,    -1,    -1,   278,   279,    -1,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   290,
     291,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,    -1,    -1,    -1,   325,    -1,    -1,   328,    -1,   330,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   344,   345,    -1,   347,   348,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,
      -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   375,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   395,    -1,    -1,    -1,   399,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,    -1,   420,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,    -1,
      -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,    -1,   450,
     451,    -1,    -1,    -1,    -1,   456,    -1,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   467,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   482,    -1,    -1,   485,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     501,   502,   503,   504,   505,   506,   507,   508,   509,    -1,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,   536,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,    -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,    -1,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,   198,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,    -1,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,    -1,   468,   469,   470,   471,   472,   473,   474,
      -1,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,    -1,
      -1,    -1,    -1,    -1,    -1,   520,   521,   522,    -1,    -1,
      -1,    -1,    -1,    -1,   529,   530,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    71,    -1,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,   110,    -1,    -1,   113,   114,    -1,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,    -1,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,    -1,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,    -1,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,   293,    -1,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,    -1,   468,
     469,   470,   471,   472,   473,   474,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,   485,   486,   487,   488,
     489,    -1,    -1,   492,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,    -1,   515,    -1,    -1,    -1,
      -1,   520,   521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     529,   530,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    71,    -1,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,   110,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,    -1,   468,   469,   470,   471,   472,
     473,   474,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,    -1,    -1,    -1,    -1,    -1,    -1,   520,   521,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   529,   530,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    71,    -1,    -1,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,    -1,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,    -1,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,    -1,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
      -1,   468,   469,   470,   471,   472,   473,   474,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,   485,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,    -1,    -1,    -1,
      -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   529,   530,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,   530,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
      -1,    -1,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,    -1,    -1,    -1,    -1,   172,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,    -1,   219,   220,   221,    -1,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,    -1,    -1,    -1,
     245,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,    -1,   289,    -1,   291,   292,   293,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,    -1,    -1,   323,   324,
     325,   326,    -1,    -1,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,   361,    -1,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,    -1,   457,    -1,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   510,   511,   512,    -1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,   530,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,    -1,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,    -1,
      -1,    -1,   245,    -1,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,    -1,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,    -1,    -1,
     323,   324,   325,   326,    -1,    -1,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,   361,    -1,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,    -1,   457,    -1,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,   511,   512,
      -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,   530,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,   515,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,   468,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,   515,
      -1,    -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,   235,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,   468,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,
      -1,   527,   528,   529,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,   522,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,   468,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,   235,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,   468,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,   468,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,   468,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,   468,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,   468,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,   468,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,    -1,    -1,
      -1,    -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   520,   521,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   529,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,   110,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   529,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,    -1,    -1,    -1,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,   529,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,   110,    -1,    -1,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,    -1,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,    -1,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,   474,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
     485,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   529,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,   110,    -1,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,    -1,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,    -1,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,   281,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,    -1,   468,   469,   470,   471,   472,   473,
     474,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   520,   521,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   529,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,   134,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,    -1,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,    -1,
     269,   270,   271,    -1,   273,    -1,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,   293,    -1,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,   337,   338,
     339,   340,    -1,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,   474,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,   485,   486,   487,   488,
     489,    -1,    -1,   492,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,    -1,   515,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
     529,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    42,    43,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,   134,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,   165,   166,   167,
      -1,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
      -1,   289,   290,   291,   292,   293,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,   337,
     338,   339,   340,    -1,    -1,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,   474,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,    -1,    -1,    -1,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,   529,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,    -1,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,    -1,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,   474,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,   485,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,   529,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,   134,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,    -1,    -1,    -1,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,   529,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,    -1,    -1,    -1,    -1,   172,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
     485,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   529,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,   111,    -1,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
      -1,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
      -1,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,   281,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,    -1,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,
     344,    -1,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,    -1,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,    -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,    -1,
      -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,   530,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    74,    75,    76,    77,    78,    79,    -1,    81,
      -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,    -1,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,   231,
      -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,    -1,
     292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,
      -1,   343,   344,    -1,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,    -1,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,    -1,
     442,    -1,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,   481,
     482,    -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,    -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,   528,   529,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    79,    -1,
      81,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,    -1,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,    -1,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,
      -1,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
      -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,    -1,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,    -1,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,    -1,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,    -1,    -1,    -1,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,   529,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,    -1,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,
     280,    -1,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,    -1,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,    -1,    -1,   338,   339,
     340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
      -1,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,    -1,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,   481,   482,    -1,   484,    -1,   486,   487,   488,   489,
      -1,    -1,   492,    -1,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,    -1,    -1,   515,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   529,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,    -1,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,
      -1,   280,    -1,   282,   283,   284,   285,   286,    -1,    -1,
     289,   290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,    -1,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,    -1,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,    -1,   486,   487,   488,
     489,    -1,    -1,   492,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,    -1,   515,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
     529,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,    -1,    -1,    -1,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,   529,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,    -1,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
      -1,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,    -1,    -1,   280,    -1,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,    -1,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,    -1,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,    -1,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,    -1,    -1,    -1,    -1,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,   529,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,    -1,    -1,    -1,
      -1,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,   529,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,    -1,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,    -1,
      -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
      -1,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,    -1,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,    -1,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
      -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   529,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,
      74,    75,    76,    77,    78,    79,    80,    81,    -1,    -1,
      84,    85,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,    -1,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,    -1,   243,
      -1,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    -1,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,    -1,   457,    -1,   459,   460,   461,   462,   463,
     464,   465,   466,    -1,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   510,   511,   512,    -1,
      -1,    -1,   516,   517,   518,    -1,   520,   521,   522,   523,
     524,   525,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    71,    -1,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    -1,
      -1,    84,    85,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,    -1,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,    -1,
     243,    -1,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,    -1,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,    -1,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,    -1,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,    -1,
     453,   454,   455,    -1,   457,    -1,   459,   460,   461,   462,
     463,   464,   465,   466,    -1,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,   511,   512,
      -1,    -1,    -1,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,   516,   517,   518,    -1,   520,   521,   522,
     523,   524,   525,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     5,     6,     7,     8,     9,    10,    11,    12,    13,
     522,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,    -1,    -1,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,    -1,    -1,
      -1,   245,    -1,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
      -1,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,    -1,   289,    -1,   291,   292,   293,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,    -1,   323,
     324,   325,   326,    -1,    -1,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,   361,    -1,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,    -1,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,    -1,   457,    -1,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   510,   511,   512,    -1,
       6,     7,     8,     9,    10,    11,    12,    13,   522,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,   522,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,    -1,     6,     7,     8,     9,
      10,    11,    12,    13,   522,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,    -1,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,    -1,   235,    -1,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,
     280,    -1,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,    -1,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,    -1,    -1,   338,   339,
     340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
      -1,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,    -1,   442,    -1,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,   481,   482,    -1,   484,    -1,   486,   487,   488,   489,
      -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     520,   521,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
      -1,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
      -1,   235,    -1,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,
     344,    -1,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,    -1,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,    -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   520,   521,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,   235,    -1,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   520,   521,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,    -1,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,   231,
      -1,   233,    -1,   235,    -1,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,    -1,
     292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,
      -1,   343,   344,    -1,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,    -1,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,    -1,
     442,    -1,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,   481,
     482,    -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   520,   521,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,    -1,    -1,    -1,
      -1,     4,   518,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    -1,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,   134,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,    -1,    -1,    -1,    -1,   172,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
     485,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,    -1,    -1,    -1,    -1,   172,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,   485,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,    -1,    -1,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,    -1,
      -1,    -1,    -1,   172,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,    -1,
     219,   220,   221,    -1,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,    -1,    -1,    -1,   245,    -1,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,    -1,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,    -1,
     289,    -1,   291,   292,   293,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,    -1,    -1,   323,   324,   325,   326,    -1,    -1,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,   361,    -1,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,    -1,   457,    -1,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,
     499,   500,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   510,   511,   512,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,    -1,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,    -1,    -1,
      -1,   172,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,    -1,   219,   220,
     221,    -1,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,    -1,    -1,    -1,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,    -1,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,    -1,
     291,   292,   293,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,    -1,   323,   324,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,    -1,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
     361,    -1,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,    -1,   457,    -1,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,
     511,   512,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,    -1,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,    -1,
      -1,    -1,   245,    -1,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,    -1,    -1,   269,   270,   271,   272,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,    -1,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,    -1,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,    -1,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,   361,    -1,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,    -1,   457,    -1,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,   511,   512,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
      -1,    -1,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,    -1,    -1,    -1,    -1,   172,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,    -1,   219,   220,   221,    -1,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,    -1,    -1,    -1,
     245,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,    -1,    -1,   269,   270,   271,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,    -1,   289,    -1,   291,   292,   293,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,    -1,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,    -1,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,   361,    -1,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,    -1,   457,    -1,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   510,   511,   512,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,    -1,    -1,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,    -1,    -1,    -1,    -1,   172,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,    -1,   219,   220,   221,    -1,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,    -1,    -1,    -1,   245,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
      -1,    -1,   269,   270,   271,   272,   273,    -1,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,    -1,   289,    -1,   291,   292,   293,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,    -1,    -1,   323,   324,   325,   326,
      -1,    -1,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,    -1,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,   361,    -1,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,   439,   440,    -1,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,    -1,
     457,    -1,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   510,   511,   512,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,    -1,    -1,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,    -1,
      -1,    -1,    -1,   172,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,    -1,
     219,   220,   221,    -1,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,    -1,    -1,    -1,   245,    -1,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,    -1,    -1,
     269,   270,   271,   272,   273,    -1,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,    -1,
     289,    -1,   291,   292,   293,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,    -1,    -1,   323,   324,   325,   326,    -1,    -1,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,    -1,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,   361,    -1,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,    -1,   457,    -1,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,   488,
     489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,
     499,   500,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   510,   511,   512,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    42,    43,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,    -1,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,    -1,    -1,
      -1,   172,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,    -1,   219,   220,
     221,    -1,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,    -1,    -1,    -1,   245,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,    -1,    -1,   269,   270,
     271,   272,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,    -1,
     291,   292,   293,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,    -1,   323,   324,   325,   326,    -1,    -1,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,    -1,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
     361,    -1,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,    -1,   457,    -1,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,
     511,   512,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,    -1,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,    -1,
      -1,    -1,   245,    -1,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,    -1,    -1,   269,   270,   271,   272,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,    -1,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,    -1,    -1,
     323,   324,   325,   326,    -1,    -1,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,    -1,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,   361,    -1,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,    -1,   457,    -1,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,   511,   512,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
      -1,    -1,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,    -1,    -1,    -1,    -1,   172,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,    -1,   219,   220,   221,    -1,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,    -1,    -1,    -1,
     245,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,    -1,    -1,   269,   270,   271,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,    -1,   289,    -1,   291,   292,   293,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,    -1,    -1,   323,   324,
     325,   326,    -1,    -1,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,    -1,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,   361,    -1,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,    -1,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,    -1,   457,    -1,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   510,   511,   512,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,    -1,    -1,   124,    -1,    -1,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
      -1,    -1,   139,    -1,   141,   142,   143,   144,    -1,    -1,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,    -1,    -1,    -1,    -1,   172,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,    -1,    -1,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,    -1,   219,   220,   221,    -1,    -1,   224,    -1,   226,
     227,    -1,   229,    -1,   231,    -1,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,    -1,    -1,    -1,   245,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
      -1,    -1,   269,   270,   271,    -1,    -1,    -1,    -1,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,    -1,   289,    -1,   291,   292,   293,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,    -1,   319,   320,    -1,    -1,   323,   324,   325,   326,
      -1,    -1,   329,    -1,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,    -1,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,   361,    -1,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
      -1,   418,   419,   420,   421,   422,    -1,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,   439,   440,    -1,   442,   443,   444,   445,   446,
     447,   448,    -1,    -1,    -1,    -1,    -1,   454,   455,    -1,
     457,    -1,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,    -1,    -1,    -1,   484,   485,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   510,   511,   512,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,    -1,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,    -1,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,    -1,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,    -1,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
      -1,   511,   512,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    71,    -1,
      -1,    74,    75,    76,    77,    78,    79,    -1,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    78,    79,    -1,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,    -1,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,    -1,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,   232,   233,    -1,    -1,    -1,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,
      -1,   280,    -1,   282,   283,   284,   285,   286,    -1,    -1,
     289,   290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,    -1,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,    -1,   442,    -1,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,   468,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,    -1,   486,   487,   488,
     489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,    -1,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,   231,
     232,   233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,    -1,
     292,   293,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,
      -1,   343,   344,    -1,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,    -1,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,    -1,
     442,    -1,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,   466,    -1,   468,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,   481,
     482,    -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,    -1,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,    -1,
      -1,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
      -1,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,    -1,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,    -1,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
      -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,
     238,   239,   240,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    79,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,    -1,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,    -1,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,
      -1,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
      -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,    -1,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,    -1,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,    -1,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
      -1,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,   232,   233,
      -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,
     344,    -1,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,    -1,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,   468,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,    -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,    -1,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
      -1,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,    -1,    -1,   280,    -1,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,    -1,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,    -1,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,    -1,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,    -1,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,
     280,    -1,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,    -1,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,    -1,    -1,   338,   339,
     340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
      -1,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,    -1,   442,    -1,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,   481,   482,    -1,   484,    -1,   486,   487,   488,   489,
      -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,   232,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,    -1,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,
      -1,   280,    -1,   282,   283,   284,   285,   286,    -1,    -1,
     289,   290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,    -1,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,    -1,   442,    -1,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,    -1,   486,   487,   488,
     489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,    -1,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,   231,
      -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,    -1,
     292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,
      -1,   343,   344,    -1,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,    -1,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,    -1,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,   481,
     482,    -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,    -1,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,    -1,
      -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
      -1,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,    -1,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,    -1,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
      -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,    -1,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,    -1,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,
      -1,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
      -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,    -1,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,    -1,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,    -1,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
      -1,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
      -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,   337,   338,   339,   340,    -1,    -1,   343,
     344,    -1,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,    -1,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,    -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,    -1,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
      -1,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,    -1,    -1,   280,    -1,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,    -1,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,    -1,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,    -1,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,   106,   107,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,    -1,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,
     280,    -1,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,    -1,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,    -1,    -1,   338,   339,
     340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
      -1,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,    -1,   442,    -1,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,   481,   482,    -1,   484,    -1,   486,   487,   488,   489,
      -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,   474,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,   474,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,    -1,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,
      -1,   280,    -1,   282,   283,   284,   285,   286,    -1,    -1,
     289,   290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,    -1,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,    -1,   442,    -1,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,    -1,   486,   487,   488,
     489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,    -1,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,   231,
      -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,    -1,
     292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,
      -1,   343,   344,    -1,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,    -1,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,    -1,
     442,    -1,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,   481,
     482,    -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,    -1,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,    -1,
      -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
      -1,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,    -1,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,    -1,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
      -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,    -1,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,    -1,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,
      -1,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
      -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,   337,   338,   339,   340,
      -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,    -1,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,    -1,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,    -1,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
      -1,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
      -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,
     344,    -1,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,    -1,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,    -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,    -1,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
      -1,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,    -1,    -1,   280,    -1,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,    -1,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,    -1,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,    -1,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,    -1,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,
     280,    -1,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,    -1,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,    -1,   337,   338,   339,
     340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
      -1,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,    -1,   442,    -1,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,   481,   482,    -1,   484,    -1,   486,   487,   488,   489,
      -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,    -1,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,
      -1,   280,    -1,   282,   283,   284,   285,   286,    -1,    -1,
     289,   290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,    -1,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,    -1,   442,    -1,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,    -1,   486,   487,   488,
     489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,   111,
      -1,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,    -1,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,   231,
      -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,    -1,
     292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,
      -1,   343,   344,    -1,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,    -1,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,    -1,
     442,    -1,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,   481,
     482,    -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,   111,    -1,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,    -1,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,    -1,
      -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
      -1,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,    -1,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,    -1,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
      -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,    -1,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,    -1,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,
      -1,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
      -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,    -1,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,    -1,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,    -1,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
      -1,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,
     154,   155,    -1,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
      -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,
     344,    -1,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,    -1,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,    -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,    -1,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
      -1,    -1,   149,   150,   151,   152,    -1,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,    -1,    -1,   280,    -1,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,    -1,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,    -1,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,    -1,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,    -1,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,
     280,    -1,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,    -1,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,    -1,    -1,   338,   339,
     340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
      -1,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,    -1,   442,    -1,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,   481,   482,    -1,   484,    -1,   486,   487,   488,   489,
      -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,    -1,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,
      -1,   280,    -1,   282,   283,   284,   285,   286,    -1,    -1,
     289,   290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,    -1,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,    -1,   442,    -1,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,    -1,   486,   487,   488,
     489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,    -1,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,   231,
      -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,    -1,
     292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,
      -1,   343,   344,    -1,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,    -1,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,    -1,
     442,    -1,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,   481,
     482,    -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,    -1,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,    -1,
      -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
      -1,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,    -1,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,    -1,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
      -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,    -1,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,    -1,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,
      -1,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
      -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,    -1,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,    -1,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,    -1,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
      -1,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
      -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,
     344,    -1,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,    -1,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,    -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,    -1,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
      -1,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,    -1,    -1,   280,    -1,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,    -1,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,    -1,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,    -1,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,    -1,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,
     280,    -1,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,    -1,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,    -1,    -1,   338,   339,
     340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
      -1,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,    -1,   442,    -1,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,   481,   482,    -1,   484,    -1,   486,   487,   488,   489,
      -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,
     149,   150,   151,   152,    -1,   154,   155,    -1,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,
      -1,   280,    -1,   282,   283,   284,   285,   286,    -1,    -1,
     289,   290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,    -1,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,    -1,   442,    -1,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,    -1,   486,   487,   488,
     489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,    -1,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,   231,
      -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,    -1,
     292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,
      -1,   343,   344,    -1,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,    -1,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,    -1,
     442,    -1,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,   481,
     482,    -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,    -1,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,    -1,
      -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
      -1,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,    -1,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,    -1,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
      -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,    -1,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,    -1,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,
      -1,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
      -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,    -1,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,    -1,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,    -1,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
      -1,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
      -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,
     344,    -1,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,    -1,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,    -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,    -1,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
      -1,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,    -1,    -1,   280,    -1,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,    -1,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,    -1,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,    -1,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,    -1,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,
     280,    -1,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,    -1,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,    -1,    -1,   338,   339,
     340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
      -1,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,    -1,   442,    -1,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,   481,   482,    -1,   484,    -1,   486,   487,   488,   489,
      -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,   111,    -1,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,    -1,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,
      -1,   280,    -1,   282,   283,   284,   285,   286,    -1,    -1,
     289,   290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,    -1,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,    -1,   442,    -1,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,    -1,   486,   487,   488,
     489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,    -1,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,   231,
      -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,    -1,
     292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,
      -1,   343,   344,    -1,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,    -1,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,    -1,
     442,    -1,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,   481,
     482,    -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,    -1,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,    -1,
      -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
      -1,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,    -1,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,    -1,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
      -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,    -1,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,    -1,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,
      -1,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
      -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,    -1,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,    -1,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,    -1,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
      -1,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
      -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,
     344,    -1,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,    -1,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,    -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,    -1,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
      -1,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,    -1,    -1,   280,    -1,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,    -1,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,    -1,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,    -1,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,    -1,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,
     280,    -1,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,    -1,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,    -1,    -1,   338,   339,
     340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
      -1,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,    -1,   442,    -1,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,   481,   482,    -1,   484,    -1,   486,   487,   488,   489,
      -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,    -1,   119,   120,   121,   122,
     123,    -1,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,    -1,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,   250,   251,    -1,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,    -1,   292,
      -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,    -1,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,    -1,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
      -1,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,   481,   482,
      -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,    45,
      -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,    -1,   119,   120,   121,   122,   123,    -1,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,
      -1,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,   409,   410,   411,   412,   413,    -1,   415,
     416,   417,   418,   419,    -1,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,    -1,   444,   445,
     446,   447,   448,    -1,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,   481,   482,    -1,   484,    -1,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,
     119,   120,   121,   122,   123,    -1,   125,   126,    -1,   128,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,    -1,   188,
     189,   190,   191,   192,   193,    -1,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,
     239,    -1,   241,   242,    -1,   244,   245,    -1,   247,   248,
     249,   250,   251,    -1,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,
      -1,   280,    -1,   282,   283,   284,   285,   286,    -1,    -1,
     289,   290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,    -1,   328,
     329,   330,   331,   332,   333,    -1,   335,    -1,    -1,   338,
     339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,    -1,
     409,   410,   411,   412,   413,    -1,   415,   416,   417,   418,
     419,    -1,   421,   422,   423,   424,    -1,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,    -1,   442,    -1,   444,   445,   446,   447,   448,
      -1,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,   470,   471,   472,   473,    -1,    -1,   476,   477,   478,
     479,   480,   481,   482,    -1,   484,    -1,   486,   487,   488,
     489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    -1,    41,
      -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,    -1,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,   231,
      -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,   249,   250,   251,
      -1,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,    -1,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,    -1,
     292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,
      -1,   343,   344,    -1,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,    -1,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,    -1,
     442,    -1,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,   481,
     482,    -1,   484,    -1,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,    -1,   119,   120,   121,   122,   123,    -1,
     125,   126,    -1,   128,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,   144,
     145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,    -1,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
      -1,   226,   227,   228,   229,    -1,   231,    -1,   233,    -1,
      -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,   244,
     245,    -1,   247,   248,   249,   250,   251,    -1,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,    -1,
     275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,   284,
     285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,    -1,
     295,   296,   297,    -1,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,    -1,   328,   329,   330,   331,   332,   333,    -1,
     335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,
      -1,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,    -1,   409,   410,   411,   412,   413,    -1,
     415,   416,   417,   418,   419,    -1,   421,   422,   423,   424,
      -1,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,    -1,   442,    -1,   444,
     445,   446,   447,   448,    -1,   450,   451,    -1,    -1,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,   470,   471,   472,   473,    -1,
      -1,   476,   477,   478,   479,   480,   481,   482,    -1,   484,
      -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,    -1,
      -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
      -1,   119,   120,   121,   122,   123,    -1,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,    -1,
      -1,   149,   150,   151,   152,    -1,   154,   155,    -1,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
      -1,    -1,   280,    -1,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,    -1,    -1,
     338,   339,   340,    -1,    -1,   343,   344,    -1,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,    -1,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,    -1,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,   481,   482,    -1,   484,    -1,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,    50,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,   120,
     121,   122,   123,    -1,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,    -1,    -1,   149,   150,
     151,   152,    -1,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,   280,
      -1,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
      -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,    -1,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,    -1,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,    -1,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    66,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,    -1,   119,   120,   121,   122,   123,
      -1,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,    -1,    -1,   149,   150,   151,   152,    -1,
     154,   155,    -1,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
      -1,    -1,    -1,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,   249,   250,   251,    -1,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,    -1,    -1,   280,    -1,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,    -1,   292,    -1,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,   343,
     344,    -1,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,    -1,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,    -1,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,    -1,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    -1,    41,    -1,    -1,    44,    45,    -1,
      -1,    -1,    49,    50,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,    -1,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,    -1,   119,   120,   121,   122,   123,    -1,   125,   126,
      -1,   128,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,   144,   145,    -1,
      -1,    -1,   149,   150,   151,   152,    -1,   154,   155,    -1,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
      -1,   188,   189,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,   231,    -1,   233,    -1,    -1,    -1,
     237,   238,   239,    -1,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,   250,   251,    -1,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,    -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,
     277,    -1,    -1,   280,    -1,   282,   283,   284,   285,   286,
      -1,    -1,   289,   290,    -1,   292,    -1,    -1,   295,   296,
     297,    -1,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
      -1,   328,   329,   330,   331,   332,   333,    -1,   335,    -1,
      -1,   338,   339,   340,    -1,    -1,   343,   344,    -1,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,    -1,   409,   410,   411,   412,   413,    -1,   415,   416,
     417,   418,   419,    -1,   421,   422,   423,   424,    -1,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,    -1,   442,    -1,   444,   445,   446,
     447,   448,    -1,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,    -1,   486,
     487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,    -1,   119,
     120,   121,   122,   123,    -1,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,    -1,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,    -1,    -1,    -1,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,   249,
     250,   251,    -1,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,    -1,    -1,
     280,    -1,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,    -1,   292,    -1,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,    -1,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,    -1,    -1,   338,   339,
     340,    -1,    -1,   343,   344,    -1,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,    -1,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
      -1,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,    -1,   442,    -1,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,   481,   482,    -1,   484,    -1,   486,   487,   488,   489,
      -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,     6,     7,     8,    -1,    10,    11,    12,
      -1,    -1,    -1,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    -1,    -1,    -1,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    66,    -1,    68,    69,    70,    -1,    72,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,   122,
     123,   124,   125,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,
      -1,    -1,   145,    -1,   147,    -1,    -1,    -1,    -1,    -1,
     153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   165,    -1,    -1,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   182,
     183,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   218,    -1,    -1,    -1,   222,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,    -1,    -1,
      -1,   234,    -1,   236,    -1,    -1,    -1,    -1,    -1,   242,
      -1,   244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   266,   267,    -1,    -1,    -1,    -1,    -1,
     273,    -1,   275,    -1,    -1,   278,   279,    -1,   281,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   290,   291,    -1,
     293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   316,   317,   318,    -1,    -1,   321,    -1,
      -1,    -1,   325,    -1,    -1,   328,    -1,   330,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   344,   345,    -1,   347,   348,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,    -1,   362,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   375,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   395,    -1,    -1,    -1,   399,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,    -1,    -1,   420,    -1,    -1,
     423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   437,    -1,    -1,    -1,    -1,    -1,
     443,    -1,    -1,    -1,    -1,    -1,    -1,   450,   451,    -1,
      -1,    -1,    -1,   456,    -1,   458,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   467,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   482,
      -1,    -1,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,   502,
     503,   504,   505,   506,   507,   508,   509,     6,     7,     8,
      -1,    10,    11,    12,    -1,    -1,    -1,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    -1,
      -1,    -1,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    72,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   118,
      -1,    -1,    -1,   122,   123,   124,   125,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
      -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,   147,    -1,
      -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,
      -1,    -1,    -1,   172,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   182,   183,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,    -1,    -1,    -1,   234,    -1,   236,    -1,    -1,
      -1,    -1,    -1,   242,    -1,   244,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,   267,    -1,
      -1,    -1,    -1,    -1,   273,    -1,   275,    -1,    -1,   278,
     279,    -1,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   290,   291,    -1,   293,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   316,   317,   318,
      -1,    -1,   321,    -1,    -1,    -1,   325,    -1,    -1,   328,
      -1,   330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   344,   345,    -1,   347,   348,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   360,    -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   375,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   395,    -1,    -1,    -1,
     399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,
      -1,   420,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,
      -1,    -1,    -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,
      -1,   450,   451,    -1,    -1,    -1,    -1,   456,    -1,   458,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   467,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   482,    -1,    -1,   485,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,   503,   504,   505,   506,   507,   508,
     509,     6,     7,     8,    -1,    10,    11,    12,    -1,    -1,
      -1,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    -1,    -1,    -1,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    -1,    41,    42,    43,    -1,
      -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    66,    -1,    68,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   118,    -1,    -1,    -1,   122,   123,   124,
     125,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,    -1,    -1,
     145,    -1,   147,    -1,    -1,    -1,    -1,    -1,   153,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     165,    -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   182,   183,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   218,    -1,    -1,    -1,   222,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,   234,
      -1,   236,    -1,    -1,    -1,    -1,    -1,   242,    -1,   244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   266,   267,    -1,    -1,    -1,    -1,    -1,   273,    -1,
     275,    -1,    -1,   278,   279,    -1,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   290,   291,    -1,   293,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   316,   317,   318,    -1,    -1,   321,    -1,    -1,    -1,
     325,    -1,    -1,   328,    -1,   330,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   344,
     345,    -1,   347,   348,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   360,    -1,   362,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     375,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     395,    -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,    -1,    -1,   420,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,    -1,    -1,    -1,    -1,    -1,   443,    -1,
      -1,    -1,    -1,    -1,    -1,   450,   451,    -1,    -1,    -1,
      -1,   456,    -1,   458,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   467,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   482,    -1,    -1,
     485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   501,   502,   503,   504,
     505,   506,   507,   508,   509,     6,     7,     8,    -1,    10,
      11,    12,    -1,    -1,    -1,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    -1,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,
      -1,   122,   123,   124,   125,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,
      -1,    -1,    -1,    -1,   145,    -1,   147,    -1,    -1,    -1,
      -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,    -1,    -1,
      -1,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   182,   183,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,    -1,    -1,
      -1,   222,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
      -1,    -1,    -1,   234,    -1,   236,    -1,    -1,    -1,    -1,
      -1,   242,    -1,   244,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   266,   267,    -1,    -1,    -1,
      -1,    -1,   273,    -1,   275,    -1,    -1,   278,   279,    -1,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   290,
     291,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   316,   317,   318,    -1,    -1,
     321,    -1,    -1,    -1,   325,    -1,    -1,   328,    -1,   330,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   344,   345,    -1,   347,   348,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,
      -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   375,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   395,    -1,    -1,    -1,   399,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,    -1,   420,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,    -1,
      -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,    -1,   450,
     451,    -1,    -1,    -1,    -1,   456,    -1,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   482,    -1,    -1,   485,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     501,   502,   503,   504,   505,   506,   507,   508,   509,    70,
      71,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,    -1,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,    -1,    -1,
      -1,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,    -1,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,    -1,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,    -1,   407,    -1,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,    -1,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,    70,
     511,   512,    -1,    -1,    -1,    -1,    -1,    78,    79,   520,
     521,   522,    -1,    -1,    -1,    -1,    -1,    -1,   529,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,   103,   104,   105,   106,   107,    -1,    -1,    -1,
      -1,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,   129,   130,
     131,   132,    -1,    -1,   135,   136,    -1,   138,   139,    -1,
     141,   142,   143,   144,   145,    -1,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,    -1,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,    -1,    -1,    -1,
      -1,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
     231,    -1,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,    -1,   247,   248,    -1,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,    -1,   269,   270,
     271,    -1,   273,    -1,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,    -1,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,    -1,   310,
     311,    -1,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,   330,
     331,   332,   333,    -1,   335,    -1,    -1,   338,   339,   340,
      -1,    -1,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,   470,
     471,   472,   473,    -1,    -1,   476,   477,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,    -1,
      -1,   492,    -1,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,    -1,
     511,   512,    70,    71,   515,    -1,    74,    75,    76,    77,
      78,    79,    80,    81,    -1,    -1,    -1,    85,   529,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,    -1,
     128,   129,   130,   131,   132,    -1,    -1,   135,   136,    -1,
     138,   139,    -1,   141,   142,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,    -1,    -1,
     158,   159,   160,   161,   162,   163,    -1,   165,   166,   167,
      -1,    -1,    -1,    -1,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,    -1,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,    -1,   226,   227,
     228,   229,    -1,   231,    -1,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,   245,    -1,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,    -1,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,    -1,   295,   296,   297,
      -1,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,    -1,   310,   311,    -1,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,   332,   333,    -1,   335,   336,    -1,
     338,   339,   340,    -1,    -1,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,    -1,   407,
      -1,   409,   410,   411,   412,   413,    -1,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,   470,   471,   472,   473,    -1,    -1,   476,   477,
     478,   479,   480,    -1,   482,    -1,   484,   485,   486,   487,
     488,   489,    -1,    -1,   492,    -1,    -1,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,    -1,   511,   512,    -1,    -1,    -1,    -1,    -1,
      70,    71,   520,   521,    74,    75,    76,    77,    78,    79,
      80,    81,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,    -1,   128,   129,
     130,   131,   132,    -1,    -1,   135,   136,    -1,   138,   139,
      -1,   141,   142,   143,   144,   145,    -1,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,    -1,    -1,   158,   159,
     160,   161,   162,   163,    -1,   165,   166,   167,    -1,    -1,
      -1,    -1,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,    -1,   226,   227,   228,   229,
      -1,   231,    -1,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,   245,    -1,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,    -1,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,    -1,   295,   296,   297,    -1,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,    -1,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,    -1,   338,   339,
     340,    -1,    -1,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,   407,    -1,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
     470,   471,   472,   473,    -1,    -1,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,   488,   489,
      -1,    -1,   492,    -1,    -1,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
      -1,   511,   512,    -1,    -1,    -1,    -1,    -1,    70,    71,
     520,   521,    74,    75,    76,    77,    78,    79,    80,    81,
      -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,    -1,   128,   129,   130,   131,
     132,    -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,
     142,   143,   144,   145,    -1,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,    -1,    -1,   158,   159,   160,   161,
     162,   163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,    -1,   186,    -1,   188,   189,   190,   191,
     192,   193,    -1,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,    -1,   226,   227,   228,   229,    -1,   231,
      -1,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,   245,    -1,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,    -1,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,    -1,   295,   296,   297,    -1,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,    -1,   310,   311,
      -1,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,    -1,   338,   339,   340,    -1,
      -1,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,    -1,   409,   410,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,   470,   471,
     472,   473,    -1,    -1,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,   488,   489,    -1,    -1,
     492,    -1,    -1,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,    -1,   511,
     512,    -1,    -1,    -1,    -1,    -1,    70,    71,   520,   521,
      74,    75,    76,    77,    78,    79,    -1,    81,    -1,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,   103,
     104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,    -1,   128,   129,   130,   131,   132,    -1,
      -1,   135,   136,    -1,   138,   139,    -1,   141,   142,   143,
     144,   145,    -1,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,    -1,    -1,   158,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,    -1,   226,   227,   228,   229,    -1,   231,    -1,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,   245,    -1,   247,   248,    -1,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
      -1,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
      -1,   295,   296,   297,    -1,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,    -1,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,    -1,   338,   339,   340,    -1,    -1,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,    -1,   407,    -1,   409,   410,   411,   412,   413,
      -1,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,   470,   471,   472,   473,
      -1,    -1,   476,   477,   478,   479,   480,    -1,   482,    -1,
     484,   485,   486,   487,   488,   489,    -1,    -1,   492,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,    -1,   511,   512,    -1,
      -1,    -1,    -1,    -1,    70,    71,   520,   521,    74,    75,
      76,    77,    78,    79,    -1,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,   129,   130,   131,   132,    -1,    -1,   135,
     136,    -1,   138,   139,    -1,   141,   142,   143,   144,   145,
      -1,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
      -1,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,    -1,    -1,    -1,    -1,   172,    -1,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,    -1,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,    -1,
     226,   227,   228,   229,    -1,   231,    -1,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,   245,
      -1,   247,   248,    -1,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,   297,    -1,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,    -1,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,   330,   331,   332,   333,    -1,   335,
      -1,    -1,   338,   339,   340,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,   407,    -1,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,    -1,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,   470,   471,   472,   473,    -1,    -1,
     476,   477,   478,   479,   480,    -1,   482,    -1,   484,   485,
     486,   487,   488,   489,    -1,    -1,   492,    -1,    -1,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,    -1,   511,   512,    70,    71,    -1,
      -1,    74,    75,    76,    77,    78,    79,    -1,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    74,    75,    76,    77,    78,    79,    -1,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    74,    75,    76,    77,    78,    79,    -1,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    74,    75,    76,    77,    78,    79,    -1,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    74,    75,    76,    77,    78,    79,    -1,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,   474,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
     243,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    70,   511,   512,
      -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
     103,   104,   105,   106,   107,    -1,    -1,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,   129,   130,   131,   132,
      -1,    -1,   135,   136,    -1,   138,   139,    -1,   141,   142,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,   224,    -1,   226,   227,   228,   229,    -1,   231,    -1,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,   245,    -1,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,    -1,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,    -1,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,    -1,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,   330,   331,   332,
     333,    -1,   335,    -1,    -1,   338,   339,   340,    -1,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,    -1,   409,   410,   411,   412,
     413,    -1,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,   470,   471,   472,
     473,    -1,    -1,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,   488,   489,    -1,    -1,   492,
      -1,    -1,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,    -1,   511,   512
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   538,  1148,     0,     5,    25,    35,    36,    40,    42,
      43,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    72,    74,    75,    76,
      77,    78,    79,    80,    81,    85,   137,   210,   228,   249,
     272,   309,   312,   327,   406,   452,   467,   482,   510,   518,
     520,   521,   522,   523,   524,   527,   528,   529,   530,   532,
     533,   534,   535,   536,  1138,  1149,  1178,  1180,  1271,  1281,
    1282,  1284,  1290,  1291,  1179,     3,     6,     7,     8,     9,
      10,    11,    12,    13,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    26,    27,    28,    31,    32,    33,
      34,    36,    37,    38,    39,    41,    42,    43,    44,    45,
      49,    50,    55,    64,    66,    68,    69,    94,   104,   106,
     107,   116,   118,   121,   122,   123,   124,   125,   126,   138,
     141,   143,   144,   145,   147,   149,   151,   153,   162,   164,
     165,   172,   179,   181,   182,   183,   184,   197,   199,   203,
     209,   210,   217,   218,   219,   222,   225,   228,   234,   236,
     240,   242,   244,   252,   256,   266,   267,   273,   275,   278,
     279,   281,   290,   291,   293,   295,   296,   301,   313,   316,
     317,   318,   321,   324,   325,   328,   330,   344,   345,   347,
     348,   360,   362,   364,   375,   376,   381,   382,   384,   389,
     394,   395,   397,   399,   402,   407,   408,   415,   417,   419,
     420,   423,   429,   437,   441,   443,   450,   451,   456,   458,
     460,   462,   467,   470,   476,   481,   482,   485,   494,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   515,   529,
     539,   540,   546,   547,   549,   550,   551,   552,   553,   554,
     555,   557,   558,   562,   574,   579,   580,   583,   584,   585,
     597,   600,   601,   617,   656,   659,   660,   661,   668,   674,
     676,   678,   679,   682,   685,   686,   690,   691,   700,   704,
     705,   706,   707,   708,   711,   713,   714,   715,   716,   717,
     724,   725,   738,   739,   743,   745,   746,   747,   757,   759,
     766,   767,   770,   771,   772,   773,   774,   780,   782,   785,
     789,   793,   794,   804,   805,   808,   813,   824,   847,   850,
     851,   852,   855,   858,   860,   862,   864,   865,   870,   871,
     874,   875,   876,   879,   880,   887,   888,   890,   891,   892,
     897,   899,   900,   906,   907,   908,   909,   910,   911,   913,
     914,   916,   917,   919,   922,   923,   928,   934,   937,   939,
     947,   949,   954,   961,   965,   966,   967,   968,   969,   970,
     973,  1008,  1145,  1146,  1150,  1153,  1154,  1171,  1172,  1173,
    1174,  1185,  1187,  1191,  1192,  1193,  1194,  1195,  1197,  1199,
    1201,  1202,  1203,  1204,  1206,  1211,  1212,  1216,  1217,  1226,
    1228,  1229,  1230,  1233,  1238,  1241,  1246,  1248,  1249,  1252,
    1254,  1257,  1266,  1284,  1292,    72,  1174,  1182,  1183,    14,
      71,    94,    95,    96,    97,    98,    99,   100,   101,   103,
     104,   105,   113,   114,   116,   117,   119,   120,   121,   128,
     129,   130,   131,   132,   135,   136,   139,   141,   142,   143,
     144,   149,   150,   151,   152,   154,   155,   158,   159,   160,
     161,   162,   163,   166,   167,   175,   176,   177,   178,   179,
     181,   184,   186,   188,   189,   190,   191,   192,   193,   195,
     196,   197,   200,   201,   202,   203,   204,   206,   207,   208,
     210,   211,   212,   214,   215,   216,   217,   219,   220,   221,
     224,   226,   227,   229,   231,   233,   237,   238,   239,   241,
     245,   247,   248,   250,   251,   253,   254,   255,   256,   258,
     259,   260,   261,   262,   263,   265,   269,   270,   271,   277,
     280,   282,   283,   284,   285,   286,   289,   292,   295,   296,
     297,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     310,   311,   313,   314,   315,   319,   320,   323,   324,   326,
     329,   331,   332,   333,   335,   338,   339,   340,   343,   346,
     349,   350,   351,   352,   353,   354,   355,   356,   358,   359,
     361,   363,   364,   365,   367,   368,   369,   370,   371,   372,
     373,   374,   376,   377,   378,   379,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   393,   394,   396,
     397,   398,   400,   401,   402,   403,   404,   405,   407,   409,
     410,   411,   412,   413,   414,   415,   416,   418,   419,   421,
     422,   424,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   439,   440,   442,   444,   445,   446,   447,
     448,   452,   454,   455,   457,   460,   461,   462,   463,   464,
     465,   466,   469,   470,   471,   472,   473,   476,   477,   478,
     479,   480,   484,   486,   487,   488,   489,   492,   495,   496,
     497,   498,   499,   500,   511,   512,  1140,  1141,  1143,  1144,
    1145,  1146,  1164,  1165,  1276,  1278,  1282,  1284,    29,   268,
    1227,     9,    13,    15,    28,    44,    45,    49,    50,    55,
      64,    66,    68,    69,   102,   137,   156,   168,   180,   185,
     249,   309,   312,   406,   481,   510,  1131,  1144,  1145,  1166,
    1213,  1214,  1256,  1257,  1258,  1262,  1267,  1268,  1269,  1278,
    1284,   102,   962,  1130,  1166,  1262,  1275,    14,   962,     5,
      25,    29,    35,    36,    42,    43,   102,   106,   107,   108,
     109,   110,   111,   112,   115,   127,   133,   134,   137,   140,
     146,   148,   156,   157,   164,   168,   169,   170,   171,   173,
     174,   175,   185,   187,   194,   198,   199,   205,   209,   213,
     223,   225,   230,   232,   235,   240,   243,   246,   257,   264,
     268,   272,   274,   276,   287,   288,   294,   298,   299,   322,
     327,   334,   336,   337,   341,   342,   357,   366,   380,   392,
     408,   414,   425,   438,   441,   449,   452,   453,   459,   467,
     468,   474,   475,   481,   483,   490,   491,   493,   494,  1144,
    1147,  1258,  1259,  1260,  1264,  1265,  1266,  1267,  1269,    25,
      35,   137,   272,  1253,    37,    39,   322,  1186,   454,   497,
     893,   101,   147,   161,   179,   185,   201,   212,   220,   232,
     237,   243,   260,   285,   306,   338,   359,   369,   396,   401,
     403,   409,   412,   440,   441,   444,   448,   457,   462,   474,
     487,   675,  1214,   184,   893,   102,   962,   485,   924,   336,
     365,   893,   124,   529,   608,    96,   101,   113,   134,   147,
     157,   179,   185,   201,   212,   220,   232,   239,   243,   297,
     338,   341,   359,   396,   403,   412,   444,   445,   447,   448,
     457,   462,   468,   471,   474,   618,   658,   762,   814,   825,
    1131,  1155,  1156,  1157,  1166,  1282,  1284,    14,   102,   364,
    1130,  1166,  1170,   430,   962,   102,   358,   410,   445,   447,
     284,   856,   857,  1282,    96,   101,   113,   134,   147,   161,
     179,   201,   212,   220,   232,   237,   243,   260,   306,   338,
     349,   359,   396,   401,   403,   409,   412,   441,   444,   448,
     455,   457,   462,   474,   487,   675,   775,   893,   535,  1196,
    1260,   253,  1170,   164,   184,   217,   485,   529,   656,   659,
     923,   929,   937,   939,   947,   954,   961,   965,  1150,    95,
     102,   119,   227,   233,   235,   257,   286,   319,   367,   383,
     520,   521,   790,   791,   962,  1138,  1139,  1276,  1278,   102,
     164,   380,   408,   795,   796,   797,  1262,   232,  1262,  1135,
    1282,   441,   976,   119,   233,   790,  1262,   454,  1170,   349,
     306,   179,   260,   403,   440,   441,   529,   866,   867,   402,
    1262,   102,   137,   413,   450,   454,   481,   566,   575,   576,
    1144,  1145,  1256,  1261,  1267,  1269,  1284,    99,   240,   795,
     796,   365,   893,  1262,   283,   102,   198,   978,   979,     4,
      14,   135,   156,   158,   297,   315,   396,   403,   413,   450,
     454,   500,   563,   564,   565,   566,   102,   413,   450,   454,
     566,   454,   337,  1019,  1128,  1262,   976,  1250,  1260,   522,
    1262,   236,   529,   925,   529,  1123,   378,   971,   972,  1130,
     971,   966,   967,   970,   533,   924,   213,   274,   342,   467,
     980,   981,   966,   968,   969,   190,   270,   473,   532,   121,
     539,  1194,  1197,  1193,  1189,   533,  1198,  1200,     5,    25,
      35,   137,   202,   272,  1205,   180,   249,   309,   312,   406,
     510,   529,  1056,  1057,  1177,  1181,  1271,    72,  1174,  1130,
    1166,  1285,   185,  1155,    21,   475,   523,  1170,  1170,  1285,
     475,  1218,  1219,  1220,    25,   272,   272,  1264,     7,    19,
      20,    38,    41,   160,   199,  1255,  1255,    16,  1194,  1136,
    1146,  1256,  1259,  1262,  1263,  1267,  1268,  1284,   777,  1262,
     777,  1131,   368,   777,   457,   777,  1130,  1262,   178,   441,
     803,  1136,  1140,  1141,   102,   251,  1128,   331,   487,    84,
      91,    92,    93,   142,   224,   516,   517,   518,   520,   521,
     522,   523,   524,   525,   854,  1089,  1090,  1262,   251,  1130,
     102,  1140,  1141,  1130,  1130,   251,  1128,  1130,   389,   415,
     102,   251,  1019,  1130,   405,  1130,   777,   102,   304,  1140,
    1141,   251,  1128,   284,    34,   187,   280,   322,   374,   894,
     895,   896,  1128,  1134,  1262,    96,   101,   134,   147,   148,
     157,   161,   179,   201,   212,   220,   232,   237,   260,   285,
     306,   338,   359,   396,   401,   403,   409,   412,   441,   444,
     448,   455,   457,   462,   487,   675,   783,  1282,   936,   939,
     947,   954,   965,  1128,   308,  1136,  1130,   529,   777,   457,
    1131,   777,   457,   251,  1130,   178,   441,   445,   447,  1140,
     445,   447,   142,   224,   854,   387,  1130,  1140,   251,   559,
    1262,  1130,  1130,   405,  1130,   777,   304,  1140,   378,   409,
     441,   487,   306,   161,   260,   237,   401,   455,   461,   669,
      84,  1158,  1159,   534,  1278,  1285,   102,  1170,  1284,   963,
     573,  1143,  1282,   857,   308,   251,  1136,  1130,   251,   861,
     251,  1131,   123,   125,   126,   137,   138,   182,   183,   202,
     228,   251,   272,   273,   275,   316,   318,   330,   375,   417,
     423,   450,   451,   482,   779,  1034,  1036,  1038,  1040,  1042,
    1044,  1045,  1046,  1048,  1049,  1050,  1053,  1054,  1256,  1263,
    1267,  1268,  1284,   457,   178,   441,   251,  1136,   251,  1141,
    1142,   153,   487,   142,   224,   251,   854,   128,   251,  1130,
     251,  1142,   251,  1130,   251,  1130,   251,  1130,   405,   861,
     251,  1130,   251,   779,   251,   304,  1142,   284,   251,   776,
     777,   529,   535,  1286,  1287,  1288,  1289,  1291,  1196,    70,
    1166,  1215,   529,   938,   618,   962,   929,   923,   930,   931,
     932,  1143,   924,  1139,   791,   792,   102,   791,   962,  1139,
     792,   102,   791,   962,  1139,   792,   792,   792,  1139,  1138,
    1138,   276,   475,  1220,  1221,  1295,  1297,   962,   792,   368,
     529,   529,   637,   637,   637,   336,   452,   532,   637,   403,
    1019,  1020,   791,   962,   791,   962,   532,   889,  1282,   235,
     529,   935,   128,   487,   485,   868,   869,  1128,  1130,  1262,
     118,   512,   280,   531,   339,   339,   336,   235,  1282,   452,
     230,   786,   336,    82,    83,    84,    86,   110,   123,   125,
     126,   133,   134,   137,   138,   145,   147,   169,   170,   171,
     172,   173,   174,   175,   182,   183,   218,   222,   223,   228,
     242,   244,   273,   275,   290,   298,   299,   316,   318,   322,
     327,   328,   330,   338,   348,   360,   375,   399,   414,   423,
     437,   450,   451,   456,   458,   459,   468,   474,   482,   502,
     503,   504,   505,   506,   507,   508,   509,   513,   520,   521,
     522,   529,   966,  1037,  1040,  1043,  1044,  1045,  1047,  1048,
    1049,  1053,  1054,  1058,  1060,  1061,  1062,  1064,  1085,  1086,
    1087,  1091,  1110,  1115,  1125,  1126,  1136,  1137,  1138,  1262,
    1274,  1276,  1278,  1279,  1280,  1281,  1282,  1124,  1125,   452,
     518,  1285,  1282,   452,   518,  1214,   102,   581,  1127,  1128,
     413,   563,   185,   572,  1282,   573,  1282,   118,   139,   563,
     512,   424,   895,   339,   235,   452,   518,   118,   512,   280,
    1295,   896,   529,  1128,   522,   527,   531,  1116,  1118,  1020,
    1266,   234,   236,   485,   920,   921,   923,  1284,   234,   926,
     185,  1058,  1121,  1122,   971,   532,   529,   927,   530,   530,
    1128,   102,   198,   977,   977,   128,   977,   225,   230,   294,
     334,   984,   986,   987,  1002,  1004,  1005,  1006,   980,   981,
     235,   276,  1019,  1021,  1123,   533,  1188,   522,  1207,  1208,
    1210,   535,   535,    25,   272,   272,   452,   452,   452,   452,
     529,   452,   520,   521,   666,  1139,  1175,  1281,   209,   111,
    1162,   128,  1165,  1165,   276,  1220,  1222,   276,  1220,  1221,
    1222,   480,  1231,  1232,  1278,    14,    83,   426,   520,   521,
    1138,  1223,  1224,  1225,  1274,  1276,  1280,  1281,  1282,  1283,
     272,   278,  1130,   452,  1130,     6,  1130,  1255,  1210,   529,
     837,  1118,   350,   385,   415,   531,   778,   350,   385,   415,
     156,   207,   300,   350,   385,   415,   444,   446,   494,   574,
     577,   901,   902,   903,   904,  1284,   809,    98,   203,   350,
     385,   415,   478,   588,  1130,   415,    98,   203,   473,   556,
     498,   251,  1019,   130,   163,   193,   221,   254,   289,   322,
     350,   351,   385,   393,   400,   407,   415,   427,   435,   489,
     574,   578,   840,   848,   529,   826,   385,   556,   257,   218,
      98,   104,   144,   193,   196,   203,   206,   231,   262,   320,
     322,   332,   340,   350,   385,   388,   389,   415,   478,   586,
     587,   694,   666,   102,   251,  1128,   777,   777,   529,   853,
     531,   218,   336,   257,   548,   385,   494,   515,   541,   548,
     336,   350,   385,   218,   129,   177,   259,   307,   310,   320,
     349,   385,   390,   415,   429,   586,   663,   664,   350,   385,
     486,   694,   702,   576,   564,   566,   257,   218,   385,   415,
     586,   350,   385,   389,   415,   154,   195,   352,   446,   336,
      98,   104,   203,   350,   385,   415,   598,   599,   548,   230,
     385,   541,   548,   218,   385,   415,   586,  1130,   533,   292,
     187,   337,   499,   532,   894,   475,   918,   336,   308,  1136,
     529,  1130,  1034,   457,   178,   441,  1136,   331,   487,   142,
     224,   854,  1130,  1130,   405,   230,  1130,  1034,   284,   777,
     530,   637,  1130,   529,   752,   837,   140,  1034,   235,   529,
     748,  1130,   541,   111,   912,  1130,   322,   541,   498,   251,
    1128,   541,   777,   777,   748,   471,   618,   336,   541,   322,
     118,   560,   462,   701,   350,   677,   154,   195,   352,   446,
     100,   120,   271,   726,   111,   748,   230,   541,   487,   251,
    1128,   251,   654,  1128,  1128,   487,   777,   153,   815,  1136,
    1130,   230,   675,    73,  1160,  1262,   534,  1161,  1158,   124,
     176,   269,   320,   404,   218,   837,   131,   391,   589,   218,
     529,   218,   484,  1051,  1051,  1051,   529,  1039,  1039,   362,
     529,  1041,   218,   137,   138,  1051,  1039,  1036,   496,   515,
     529,  1055,   529,  1055,   532,   589,   110,  1035,   138,   529,
    1052,   180,   312,   510,   529,  1056,   778,  1039,   498,   218,
     826,   218,   532,   251,   776,   251,   777,   251,   777,   218,
     853,  1142,   218,   336,   218,   218,   336,   218,   589,   218,
     154,   195,   352,   446,   230,   218,   336,   218,   589,   218,
     230,   251,   251,   573,   218,   532,   589,   530,  1287,  1288,
    1286,   532,   536,  1058,  1094,  1219,  1294,  1295,   441,   963,
     530,   532,   223,   336,   459,   570,   573,   666,   933,   929,
     792,   962,   792,   962,  1297,  1298,   792,   962,   792,   962,
    1298,   792,   962,   962,   962,   792,    14,   426,  1270,  1273,
    1278,   962,   529,   638,   639,  1262,   638,   102,   179,   201,
     232,   237,   284,   285,   403,   409,   441,   444,   462,   798,
    1127,  1142,   797,  1130,   257,   532,   950,   962,   962,  1282,
    1215,  1034,  1097,   111,  1142,   815,   530,   532,   292,  1262,
     230,   230,   798,  1142,   402,  1262,   573,   336,   529,   527,
     966,  1098,  1058,  1114,   529,   529,   230,   529,   529,   966,
     529,   529,   529,   529,   529,   529,  1058,   529,   529,   529,
     529,   529,   529,   529,   529,   966,   529,   529,   529,   529,
     529,   529,   529,   529,  1058,  1058,  1058,   481,   966,  1058,
    1094,  1118,  1282,   529,  1282,    84,    87,    91,    92,    93,
     108,   111,   116,   122,   146,   252,   257,   278,   279,   293,
     325,   338,   341,   420,   513,   516,   517,   518,   520,   521,
     522,   523,   524,   525,  1089,  1091,  1093,  1284,   495,  1073,
     347,  1058,   276,   532,   974,  1295,   529,  1282,  1118,    22,
    1277,  1278,  1119,   974,   333,   336,  1247,  1247,    10,   480,
    1234,  1235,  1237,  1214,  1214,   188,   253,   582,   532,   139,
     185,   573,   111,   185,   297,   571,   666,  1054,  1282,  1284,
    1282,   159,   200,  1070,   168,   185,   567,   568,   570,   666,
     185,   567,  1295,  1295,   292,  1128,  1058,  1117,   522,  1133,
    1264,  1116,   160,   390,   781,   278,   530,   532,   924,   530,
     532,   972,  1129,  1130,   111,   927,   968,   968,   982,   983,
    1058,   968,   227,   319,   993,   282,   320,   374,   418,   473,
     102,   988,  1058,   520,   521,   989,   990,  1058,  1060,  1002,
    1003,   987,   986,   984,   985,   230,  1005,   332,  1007,   984,
    1002,  1021,   940,  1128,   111,  1262,   415,  1207,   522,   532,
     533,  1265,  1184,  1187,  1184,   272,   180,   249,   309,  1057,
     309,  1057,  1057,   312,  1138,   309,   312,   406,  1281,  1281,
     532,  1176,   184,  1214,   474,  1163,  1165,  1130,   426,  1138,
    1236,  1278,   532,   518,  1130,    14,  1138,  1281,  1138,  1281,
     532,  1194,   529,  1130,   529,  1266,   257,   267,   342,   344,
     417,   483,   522,   830,   831,   832,   834,   836,   838,  1034,
    1263,   350,   385,   415,   452,   452,   403,  1133,   531,   452,
     452,   403,   294,   452,   452,   444,   563,   350,   901,   903,
     518,   905,   230,   240,   257,   394,   810,   811,   140,   157,
     214,   232,   366,   468,   634,   635,   157,   185,   322,   452,
     157,   452,   185,   322,   403,   157,   196,   206,   350,   385,
     744,   403,   683,    96,   101,   134,   147,   161,   201,   212,
     232,   237,   306,   338,   403,   409,   412,   441,   448,   455,
     462,   487,   675,  1130,   218,   385,   415,   586,   336,   666,
     336,   407,   289,   452,  1262,   452,   327,   666,   189,   277,
     403,   413,   454,   565,   391,   415,   840,   849,   530,   827,
     830,   452,   474,   444,  1128,   148,   214,   251,   625,   634,
    1262,   148,   157,   872,   336,   336,   399,   401,   457,   157,
     872,   105,   388,   399,   401,   457,   399,  1128,   231,   262,
     332,   777,   529,   452,   452,   250,   529,   593,   303,   444,
     471,   494,   496,   593,   157,   532,   350,   257,   218,   193,
     385,   415,   586,   475,   475,   321,  1034,   350,   415,   854,
    1130,  1128,   179,   415,   577,   452,   543,   577,  1128,   452,
     452,  1128,   666,   128,   665,   666,   666,   177,   307,   310,
     128,   452,   541,   403,   541,   320,   664,   452,   452,   327,
    1282,   694,   444,  1019,   157,   452,   872,   403,   452,   452,
     593,   593,   777,   777,   777,   777,  1128,   117,   480,   117,
     117,   452,   117,   452,   403,   532,   577,   474,   712,  1141,
     452,   543,   577,  1128,   452,   403,   350,   385,   374,   386,
     411,   569,   894,  1134,  1262,  1128,   837,  1034,   336,   278,
     498,   826,   666,   777,   777,   853,   336,   278,   336,   154,
     195,   352,   446,  1034,   336,   278,   777,   278,   452,   494,
     609,   462,   753,   754,  1284,   748,   529,   111,   777,   749,
     750,  1264,   100,   901,  1034,   336,   218,   680,  1130,   322,
     529,   542,   762,   475,   378,   487,  1128,   542,   218,  1141,
     164,   240,   561,   617,   660,   725,   793,   813,   897,  1282,
     702,   703,  1141,   300,   777,   777,   777,   777,   332,   190,
     270,   460,   473,   727,   728,   210,   373,   529,   712,   542,
    1128,   322,   662,   663,   322,   111,   332,   529,   637,   637,
     251,   657,  1128,   230,   251,   816,  1134,   529,   828,   111,
    1034,   284,   531,  1138,  1161,   494,   496,   964,   404,  1136,
     589,  1034,  1131,   529,  1094,  1138,   779,  1051,  1051,   110,
    1035,   450,   450,  1138,  1138,  1034,   527,   527,   415,  1138,
     452,   452,  1138,  1039,   251,  1130,  1136,   589,  1142,  1141,
     218,   589,   218,   475,   218,   475,   854,   589,   589,  1130,
     777,  1142,  1130,   777,  1130,  1130,  1034,  1130,   777,   779,
    1142,   712,   218,   218,   589,   776,   777,   530,   536,  1289,
     530,   532,  1295,  1296,  1219,   251,  1128,   176,   929,   931,
     962,   962,  1298,   962,   962,  1298,   962,   962,  1130,    14,
     532,  1277,   638,   530,   532,   530,   238,   410,   442,  1129,
     776,   178,   412,   802,   803,  1129,   331,  1129,  1127,  1127,
    1129,   776,   452,   494,   806,   213,   294,   709,   710,    96,
     216,   399,   418,   951,  1019,   326,   952,   530,   532,   936,
     452,  1128,   866,   867,   869,   796,   795,   796,   235,   241,
     807,  1262,   101,   148,   179,   201,   212,   232,   237,   285,
     306,   396,   403,   409,   441,   444,   462,   487,   675,   787,
    1094,   528,  1094,  1098,  1099,   490,  1111,  1112,  1058,  1094,
     529,  1138,  1138,   180,   249,   309,   312,   406,   510,  1100,
    1101,  1282,  1284,  1094,  1094,  1094,  1138,  1138,  1058,   854,
    1058,  1102,   399,   520,   521,   529,  1059,  1060,  1091,  1104,
     530,  1094,  1058,  1094,  1105,  1058,   127,   235,   288,   453,
    1058,  1094,  1108,  1094,   314,  1060,  1058,  1068,  1069,  1070,
     314,  1058,  1070,   530,   532,  1138,  1056,  1034,  1058,  1058,
    1058,  1058,  1264,   450,   115,   438,  1120,   777,  1058,   529,
     966,  1109,   198,   200,   223,   322,   327,   332,   459,   469,
    1058,   529,  1058,   452,   122,   252,   257,   293,   420,  1058,
    1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,   102,
     109,   425,  1088,   243,   226,  1074,   399,   529,  1085,   239,
     297,   441,   445,   447,   471,   975,  1128,  1126,   235,  1009,
     102,   198,   483,   522,   530,   832,  1058,  1095,  1096,  1263,
    1130,  1278,  1116,  1009,  1236,   532,   518,  1128,   454,   529,
    1282,   532,  1295,   530,   528,   534,   250,   250,   589,  1194,
    1128,   921,   922,  1128,  1121,   530,   532,   529,   532,   112,
     194,   475,   822,   399,   400,   520,   521,   990,   992,  1060,
     418,   282,   337,   532,   991,  1138,  1281,   991,   399,   400,
     992,  1127,   326,   422,   953,  1003,   985,   475,   948,   185,
     529,   941,   965,   111,  1262,   529,   955,   956,   957,   958,
     959,  1262,   533,  1208,  1035,   536,  1187,   536,   530,   666,
     530,    34,  1164,  1239,  1240,  1278,  1232,  1237,  1285,  1223,
    1035,  1272,  1288,  1272,  1035,   344,   128,  1263,   530,   832,
     834,   831,   834,  1263,   342,   530,   532,   778,   452,   452,
     403,  1141,  1130,  1130,  1133,  1141,  1130,  1130,  1141,  1131,
    1130,   185,   570,  1139,   396,   474,   795,   403,   240,   795,
     529,  1130,   475,   817,   282,   282,   475,   529,   653,   251,
    1130,   327,  1141,  1130,  1130,  1058,   327,  1130,  1130,   105,
     388,   452,   452,  1130,   452,   684,   308,  1136,   529,   777,
     777,  1034,   457,   178,   441,   803,   487,   142,   224,   854,
    1130,   777,  1130,   777,   405,   230,  1034,   777,   284,   245,
     320,   350,   385,   479,   687,   688,   689,  1019,   452,   872,
     403,   327,   220,   189,   277,  1141,  1130,   336,  1130,   530,
     532,  1140,  1142,  1130,   385,   586,   251,   625,   322,  1034,
    1130,  1262,  1130,   220,   292,  1130,   102,   474,  1130,   251,
    1130,   251,  1262,   401,   457,   401,   457,   292,  1130,   102,
     474,  1130,   292,   399,  1128,    98,   203,   415,   695,   696,
     697,   698,  1264,  1141,  1130,   185,   236,   323,   475,   592,
     595,   596,  1264,  1130,   335,   144,   335,  1130,   587,   452,
     444,  1128,   336,   452,   872,   403,  1132,  1262,  1132,   532,
     530,   532,   452,   403,   529,   336,   385,   452,   721,  1131,
    1140,   156,   208,   262,   356,   466,   474,   477,   544,  1284,
     385,  1141,  1130,   385,   415,   586,   663,   666,   777,  1130,
     666,  1130,   666,  1141,  1130,  1130,   385,   415,   586,  1130,
    1130,  1130,  1130,  1141,  1130,    98,   104,   203,   350,   385,
     415,   350,   385,   415,   748,   385,   415,   385,   415,   193,
     385,  1033,  1262,   251,   758,  1262,   251,  1262,  1141,  1130,
    1130,  1130,    98,   599,   412,  1140,   385,   415,   586,  1130,
    1130,   452,   452,   152,   465,   374,   278,   111,   201,   777,
     327,   784,  1282,   278,   278,   475,   475,   278,   777,   784,
     777,   284,   777,   784,   278,   784,   371,   603,   335,   235,
     452,   602,   260,   530,   532,   518,  1058,  1034,   530,   532,
     518,   727,   627,  1264,  1130,   131,   235,   403,   486,   681,
     688,   689,   218,   293,   619,   621,   623,   625,   631,   634,
      99,   257,   396,   439,   544,   545,   230,  1132,   487,  1128,
     230,   722,   559,  1262,   560,   341,   618,   232,  1282,   748,
     748,   748,   748,   332,   336,   341,   529,   748,  1031,  1032,
    1033,   412,   529,   218,   218,   217,  1151,   777,   619,  1262,
     494,   496,   649,   494,   594,   322,   111,   637,  1282,   322,
     336,   530,   829,   830,   835,   111,   284,   393,   455,   493,
     839,   840,   841,   336,   284,   573,  1160,   523,   248,   248,
     230,   837,   111,  1094,   530,   530,   589,   527,   512,   512,
     530,   530,  1138,   528,   529,  1138,  1262,  1282,  1293,  1262,
     530,   530,   218,   589,   826,   776,   777,  1132,   777,  1132,
     853,   336,   589,   336,   589,   589,   284,   336,   589,   589,
     412,   230,   573,   589,  1058,   322,   964,  1285,  1273,   530,
     639,   257,   257,   257,   498,  1129,   532,   666,   667,   243,
     799,   800,  1141,    99,   807,   452,   529,   235,   216,   418,
     216,   418,   399,   473,   311,  1034,  1141,   494,   655,  1128,
    1130,   235,   336,   799,   128,   589,  1136,  1034,   457,   441,
    1136,   331,   487,  1034,   284,   777,   530,   528,   528,   532,
    1058,   205,  1112,  1113,   111,   530,  1058,   530,   530,   530,
     235,   530,   530,   530,   530,   530,   532,   530,   357,  1103,
     530,   529,  1059,  1059,  1094,    87,    91,    92,    93,   257,
     278,   338,   516,   517,   518,   520,   521,   522,   523,   524,
     525,  1091,  1059,   530,   530,   230,   235,  1106,  1107,   530,
     111,  1108,  1094,  1108,  1108,   235,   530,   530,  1264,   355,
    1072,   111,   530,   532,  1058,  1264,   532,  1058,  1119,  1058,
     530,   512,  1059,  1059,   211,  1094,   235,   198,   200,   223,
     327,   332,   459,   469,   529,   211,   854,  1058,   438,  1120,
    1058,  1109,  1058,   452,   529,   966,   529,   529,   346,  1078,
     529,  1094,   445,   447,   445,   447,  1128,   976,   976,   976,
     287,   400,   529,   966,  1010,  1011,  1012,  1019,  1024,  1061,
    1063,  1064,  1136,  1262,   491,  1029,  1095,  1095,  1096,   530,
      89,    90,   532,   980,   981,  1029,     8,    11,    12,    22,
      23,    24,    26,    27,    31,    32,    33,   178,   314,   362,
     462,  1242,  1243,  1245,  1235,  1236,   895,  1138,  1056,   568,
    1058,  1117,  1035,   927,  1130,   936,   983,   338,  1089,  1092,
     514,   823,  1138,  1281,   992,   337,   473,   989,   302,  1010,
     491,  1030,   481,   942,   943,  1262,   336,   944,  1262,   959,
     960,   532,  1009,   518,  1119,   534,  1190,   533,   532,   518,
      30,  1251,   530,   530,   533,   838,   778,   834,   834,   128,
     836,   524,  1141,  1130,  1130,  1142,  1142,   336,  1129,   339,
     336,  1058,   635,  1132,   529,   529,   529,   653,   260,   638,
     736,   218,   589,   452,  1141,  1130,   573,  1130,   837,  1034,
    1130,   498,   777,   777,   777,   777,   853,   154,   195,   352,
     446,  1034,  1130,   670,  1130,   245,   479,   452,   452,   670,
     687,   694,   385,   415,   586,  1130,  1130,  1130,   268,  1130,
     327,   830,   349,   415,   452,   322,   218,   340,   692,   736,
     203,   389,   415,   588,   694,   873,  1130,   407,   218,   589,
     218,   589,  1130,  1130,  1130,  1130,   407,   407,   292,   697,
     698,   697,   530,   532,   699,  1282,   260,   530,   532,   518,
     531,  1141,  1130,   385,   415,   586,   220,  1130,  1130,  1130,
     350,   385,   415,    98,   203,   350,   385,   415,  1034,   321,
    1034,  1141,  1130,   877,   878,  1264,  1128,   452,  1142,   475,
     718,   294,   356,   327,  1282,   356,  1142,   472,   452,   452,
     403,   349,   415,   157,   452,   872,   403,   452,   452,   304,
     304,   304,   452,   452,   403,   452,   452,   403,   452,   403,
     452,   403,   336,   452,   589,  1034,   322,  1282,   415,   873,
     218,   589,   452,  1130,   452,   403,  1141,  1130,   784,  1034,
     777,   278,   784,   784,  1132,  1132,   784,   278,   278,  1130,
     278,   784,   432,   433,   604,  1282,   603,   245,   754,  1284,
     338,   520,   521,   666,   751,   834,  1092,  1147,  1282,   530,
     530,   750,   751,   336,   140,   146,   157,   185,   187,   264,
     322,   327,   366,   380,   468,   628,   629,   630,   217,   490,
     541,   573,  1130,   573,   692,  1128,  1128,   530,   532,  1142,
     243,   396,  1142,  1138,   462,  1128,   637,   102,   190,   270,
     408,   473,   723,   452,   720,   118,   560,   387,   441,   178,
     594,   638,  1128,   728,   755,   756,  1282,   530,   532,  1130,
     638,  1128,   654,  1128,  1130,   965,   529,   620,   530,   335,
     593,   335,   336,   650,   593,   111,   218,   965,   594,   452,
     218,  1128,   530,   532,   185,   518,   842,  1282,   573,   441,
     833,   834,   230,   843,   494,   841,   844,   190,   270,   408,
     473,   885,  1130,   245,  1156,   965,  1170,   589,  1034,   530,
    1138,  1055,  1055,   528,  1293,   529,   520,   521,   522,   523,
     524,   528,  1052,  1130,   589,   589,   475,   589,   475,   589,
     589,   777,   777,  1130,   777,  1130,   712,   589,   218,   230,
     403,   403,   403,  1129,   803,   532,  1141,   494,   532,   801,
     339,  1020,   412,   216,   216,   178,   320,  1142,   798,   589,
    1141,   837,   278,   826,   666,   278,   777,   278,  1098,   449,
    1058,   209,  1034,   530,  1058,  1058,  1058,  1106,   530,  1094,
     532,  1034,  1059,  1059,  1059,  1059,   198,   200,   322,   332,
    1059,  1059,  1059,  1059,  1059,  1059,  1059,  1059,  1059,  1059,
    1058,  1058,  1107,  1106,  1034,   530,   530,   530,  1094,   530,
     532,   128,  1060,   530,  1264,  1069,   363,   436,  1071,   530,
     532,   486,  1065,   111,   530,  1282,  1058,   108,   108,  1058,
     530,  1058,   235,   529,  1097,  1058,   530,   211,  1059,  1059,
     211,   211,  1058,  1058,   981,   491,   529,  1079,  1262,   530,
    1094,   532,   976,   976,   976,   976,  1128,  1128,  1128,   966,
    1024,   235,   966,  1011,  1012,   111,  1013,  1014,  1262,   532,
     165,   236,   266,   281,   291,   317,   395,  1016,  1014,   111,
    1013,  1015,  1262,   515,  1028,   529,  1118,  1058,   243,   994,
     532,   980,   980,   980,  1058,  1058,   483,  1096,   530,   994,
     532,   518,   530,   528,  1251,   530,   529,   823,   227,   286,
     337,   168,  1058,   392,   946,   530,   532,  1119,   155,   946,
     530,   532,   956,  1030,  1121,  1138,   518,  1209,  1240,  1245,
     530,   524,   838,   462,   238,   410,   442,   463,   812,   230,
     812,   530,   529,   641,   642,   819,  1063,  1262,   638,   638,
     736,  1134,   530,   187,   264,   320,   322,   737,  1130,  1130,
     111,  1130,   475,   475,   777,   777,   777,   777,   284,   778,
    1141,  1130,   452,   872,   403,   452,   268,   128,   444,  1130,
     218,   625,   529,   627,   322,   593,   178,   322,   431,   434,
     593,   462,  1130,  1262,   407,   696,  1130,   596,   751,  1264,
     349,   415,   452,   872,   403,  1130,   452,   452,   452,   403,
     237,   338,   434,   760,   761,   237,   338,   768,   769,   452,
     452,   403,   530,   530,   530,   530,   532,   518,   385,  1130,
     529,   494,   719,  1139,  1282,  1282,  1282,  1130,  1130,  1130,
     128,   444,  1130,  1130,  1130,  1130,  1130,  1130,   230,   230,
     387,   230,   251,  1141,  1130,  1130,  1141,  1130,  1130,  1130,
    1130,  1130,  1130,   220,  1130,   146,   590,   218,   100,   120,
     462,  1262,  1130,   694,  1130,  1130,   530,   278,   784,   278,
     278,   784,   784,   278,   784,   541,   604,   670,   736,   494,
     496,  1128,   529,   777,  1130,  1059,   188,   253,   187,   327,
     282,  1128,   844,   370,   740,   741,  1262,   680,   529,   632,
     263,   648,   623,  1142,  1142,  1034,   529,   594,  1142,   718,
    1141,   251,  1128,   498,   230,   729,   530,   532,  1033,   692,
     530,   662,   111,   332,   529,   938,   655,   622,   624,   626,
     634,  1262,   649,   648,   151,   444,   651,   965,   657,   655,
     651,  1282,  1134,   817,   835,  1058,  1058,   532,   529,   839,
     462,   532,   748,   452,   529,   670,    84,  1167,   530,   528,
     530,  1194,  1293,  1293,  1293,  1293,  1293,   589,  1132,  1132,
     589,   589,   589,   589,   412,  1129,  1129,  1129,   666,   240,
     800,   530,  1130,   178,   807,   235,   278,   327,   788,  1282,
     278,   278,   788,   278,   788,  1058,   530,   530,  1107,   530,
    1058,   235,   198,   200,   332,   529,   530,   501,  1067,  1094,
     379,   128,   492,   492,   530,  1058,   320,  1058,   532,  1066,
    1036,  1058,  1058,  1058,  1097,   530,  1058,   108,   108,  1058,
    1058,   211,   530,   530,  1058,  1080,  1262,   530,  1058,  1128,
    1128,  1128,  1128,  1014,  1015,   529,   530,  1262,   529,  1011,
     281,   345,  1017,  1011,  1017,   281,  1016,  1017,   281,   443,
    1022,   529,  1262,   529,   343,  1095,   128,   246,  1001,   530,
     530,   530,  1096,  1282,  1001,  1243,   521,  1236,  1244,  1281,
    1282,  1282,   854,   332,  1125,   965,   943,   336,   529,   945,
     518,   959,   946,  1289,   462,   530,   452,   795,   235,   736,
    1058,   530,   532,   494,   146,   820,   820,   530,   530,   844,
     188,   253,   262,   187,   477,   589,  1034,  1132,  1132,  1130,
    1130,  1130,  1130,  1130,  1142,  1130,   625,   693,   697,   327,
     327,  1139,  1262,  1034,   589,   589,   518,   128,   444,  1130,
    1130,  1130,  1130,  1141,  1130,  1130,  1138,  1138,  1034,   532,
    1138,  1138,   532,  1141,  1130,  1130,   878,   321,   751,   452,
    1058,   140,  1142,  1130,   452,   452,  1129,  1129,   777,  1129,
     218,  1130,   777,  1282,  1282,  1034,   589,   589,   278,   784,
     784,   784,   784,   529,   605,   606,   475,   610,   611,   237,
     267,   237,   235,   735,  1058,   322,   629,   844,   637,   475,
     652,  1136,   108,   217,   257,   619,   215,   258,   529,   412,
     475,   638,   111,   719,   560,   322,   529,  1130,   204,   730,
     490,   732,  1282,   594,   217,  1152,   777,   619,   655,   530,
     532,   494,   650,   649,   190,   203,   363,  1130,   494,   898,
     111,   235,   336,   529,  1282,   832,   845,   846,  1263,   844,
    1034,   230,  1128,   235,   452,   863,   265,   671,  1168,  1262,
     589,   530,   589,   589,  1130,   339,   276,   589,   799,   788,
     788,   788,   788,   530,  1059,   235,   529,  1097,   529,   530,
     532,   530,  1060,   379,   530,   480,   428,   530,   530,   530,
    1058,  1058,  1058,   530,   354,  1081,   530,  1025,  1026,  1063,
    1013,   529,  1129,  1011,   336,   475,  1018,  1011,   281,  1011,
    1136,  1032,   529,  1032,  1262,   980,   167,   244,   398,   529,
     995,   996,   997,   998,   999,  1000,  1058,  1058,   493,  1075,
     980,  1075,  1138,  1281,   530,   962,  1296,   157,   818,   819,
     199,   529,   966,  1123,   799,   336,   799,   530,   844,   642,
     338,   854,   777,   777,   821,   821,   380,   844,   652,   530,
     452,   415,   952,   530,   532,   590,   751,  1142,  1130,   452,
     529,  1136,   854,   761,   529,   529,   769,  1130,   530,   529,
     415,   952,  1130,  1130,   494,   515,   915,   387,   915,   915,
     230,   590,   784,   612,   613,  1264,   124,   166,   191,   207,
     211,   231,   234,   247,   327,   335,   372,   607,   541,   192,
     803,   111,   859,   859,  1128,   736,   530,   652,   305,   640,
     260,   529,   741,   370,   529,   530,   102,   150,   158,   186,
     261,   434,   633,   633,  1127,  1130,  1132,   530,   965,   218,
     692,   399,   430,   731,   529,   217,   111,  1130,   965,   620,
     530,   624,   340,   651,   650,   400,   400,   132,   140,   297,
     965,   777,  1128,   818,   834,   530,   532,   462,  1029,   426,
     426,   530,   670,   320,   479,   672,   673,   518,  1169,  1130,
     589,  1059,  1097,   530,  1068,  1094,   128,   320,   511,   128,
     980,   530,   532,   111,  1027,  1129,   530,  1058,   529,  1011,
    1018,   529,   530,  1032,   530,   530,   529,   416,   529,   530,
     532,  1076,  1077,  1262,   530,  1130,   530,   532,   323,   473,
     801,   812,   589,   820,   652,   529,   822,   822,  1128,   652,
     736,  1130,   444,   697,   475,   591,   415,   952,  1130,  1097,
     826,   230,   764,   853,  1097,  1097,  1058,   444,   776,   777,
     776,   777,  1129,   589,   530,   532,   522,   529,   570,   614,
     666,   912,  1282,   912,   322,   327,   372,   912,   912,   605,
    1282,   859,   114,   255,   230,   320,   636,   236,   353,   421,
     336,   644,   645,   646,   444,   530,  1136,    81,   742,   648,
     530,   692,   224,   763,   594,   898,  1128,  1058,   370,   965,
     938,   655,   649,   648,   627,   651,   140,   339,   140,   655,
     817,   530,   839,   845,  1034,   199,   494,   494,   479,   670,
    1138,  1276,  1284,    84,   692,   530,   530,   530,   379,   480,
    1094,   373,   400,  1082,  1028,  1025,   529,   530,  1129,  1094,
     530,  1094,   529,  1094,   996,   532,   111,  1029,   819,   415,
     235,   821,   491,   643,   854,   823,   823,   637,   736,  1130,
    1058,   444,   530,   342,   405,   377,   765,   764,   530,   530,
     530,  1130,   915,   613,   570,   615,   616,  1282,  1282,   327,
     638,   522,   638,  1282,  1282,   204,   262,   190,   473,   336,
     646,   336,   645,  1130,   529,   530,   532,   412,   777,   111,
     111,   529,   530,  1136,   898,   655,   650,   649,   339,   339,
     529,   594,   844,   103,   271,   886,   237,   237,  1168,   122,
     168,   464,  1058,  1083,  1084,  1083,   530,  1032,   530,   530,
     530,   995,   530,  1077,  1079,   955,   799,   822,   529,   736,
     530,   640,   952,  1130,  1136,   128,   765,   952,   777,   530,
     532,   638,   399,   131,   320,   391,   415,   647,   647,   530,
      81,  1130,   760,   965,   529,   651,   650,   818,   651,   323,
     529,   881,   883,   888,   939,   947,   954,   965,   803,   803,
    1084,   399,   229,   361,   229,   361,   530,   386,  1023,   530,
    1029,   589,   823,  1058,   644,   952,   826,   777,   616,   732,
      97,   185,   327,   692,   898,   733,   734,  1138,  1264,  1281,
    1282,   651,   530,  1029,   882,   883,   884,   966,   967,   532,
     532,   108,   529,   530,   736,   217,   530,   532,   594,   530,
     533,   452,   235,  1084,  1058,   370,   734,   651,   884,   426,
     426,   530,  1136,  1029,   494,   494,   529,   237,   237,   733,
     803,   803,   530
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   537,   538,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   540,   541,
     541,   541,   542,   542,   543,   543,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   545,   545,   545,   545,   545,
     545,   546,   547,   548,   548,   549,   549,   550,   551,   551,
     552,   552,   553,   553,   554,   555,   556,   556,   557,   557,
     558,   558,   558,   558,   559,   559,   560,   560,   561,   561,
     561,   561,   561,   561,   562,   562,   562,   563,   563,   563,
     564,   564,   564,   564,   565,   565,   565,   565,   565,   565,
     565,   565,   565,   565,   565,   566,   566,   567,   567,   568,
     568,   569,   569,   569,   569,   570,   570,   570,   570,   571,
     571,   571,   571,   571,   571,   571,   572,   572,   572,   573,
     573,   574,   575,   575,   575,   575,   576,   576,   577,   577,
     578,   578,   579,   579,   579,   579,   579,   580,   581,   581,
     582,   582,   583,   584,   584,   584,   584,   584,   585,   585,
     585,   585,   585,   585,   585,   585,   585,   585,   585,   585,
     585,   585,   585,   585,   586,   586,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   587,   588,   588,
     589,   589,   589,   590,   590,   591,   591,   592,   592,   592,
     592,   593,   594,   594,   595,   595,   596,   596,   596,   596,
     597,   598,   598,   599,   599,   599,   599,   600,   600,   601,
     601,   602,   602,   603,   603,   604,   604,   604,   605,   605,
     606,   606,   607,   607,   607,   607,   607,   607,   607,   607,
     607,   607,   607,   607,   607,   607,   608,   608,   609,   609,
     610,   610,   611,   611,   612,   612,   613,   614,   614,   614,
     614,   614,   615,   615,   616,   617,   617,   617,   617,   618,
     618,   618,   618,   618,   618,   618,   618,   619,   619,   620,
     620,   621,   621,   622,   622,   623,   623,   623,   624,   624,
     625,   626,   627,   627,   628,   628,   628,   628,   629,   629,
     629,   629,   629,   629,   629,   630,   630,   630,   630,   631,
     632,   632,   632,   633,   633,   633,   633,   633,   633,   634,
     634,   635,   635,   635,   635,   635,   635,   635,   636,   636,
     637,   637,   638,   638,   639,   640,   640,   640,   640,   641,
     641,   642,   642,   643,   643,   644,   644,   644,   644,   644,
     645,   646,   647,   647,   647,   647,   647,   648,   648,   649,
     649,   649,   649,   650,   650,   650,   650,   651,   651,   652,
     652,   653,   654,   655,   655,   655,   656,   656,   657,   658,
     658,   659,   660,   660,   661,   661,   662,   662,   663,   663,
     664,   664,   664,   664,   664,   664,   664,   664,   664,   664,
     664,   664,   665,   665,   666,   666,   666,   666,   667,   667,
     668,   668,   669,   669,   670,   670,   671,   671,   672,   672,
     673,   673,   674,   674,   675,   675,   676,   677,   677,   678,
     678,   679,   679,   680,   680,   681,   681,   681,   681,   682,
     683,   683,   684,   685,   685,   685,   685,   685,   685,   685,
     685,   685,   685,   685,   685,   685,   685,   685,   685,   685,
     685,   685,   685,   685,   685,   685,   685,   685,   685,   686,
     687,   687,   687,   687,   688,   688,   689,   689,   690,   690,
     691,   691,   692,   692,   693,   693,   694,   695,   695,   696,
     696,   696,   696,   697,   698,   699,   700,   701,   701,   702,
     702,   703,   703,   704,   704,   705,   705,   705,   706,   706,
     707,   707,   708,   709,   709,   710,   710,   711,   712,   712,
     713,   713,   714,   715,   716,   717,   717,   718,   718,   719,
     719,   720,   720,   721,   721,   722,   722,   723,   723,   723,
     723,   723,   724,   725,   725,   726,   726,   726,   727,   727,
     728,   728,   728,   728,   728,   729,   729,   730,   730,   731,
     731,   732,   732,   733,   733,   733,   734,   734,   734,   734,
     735,   735,   736,   736,   737,   737,   737,   737,   737,   737,
     738,   738,   739,   739,   740,   740,   741,   742,   742,   743,
     744,   744,   744,   744,   745,   746,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     748,   749,   749,   750,   750,   751,   751,   751,   751,   751,
     752,   753,   753,   754,   755,   755,   756,   756,   757,   757,
     757,   758,   758,   759,   760,   760,   761,   761,   761,   761,
     761,   762,   762,   763,   763,   764,   764,   764,   765,   765,
     766,   767,   767,   768,   768,   769,   769,   770,   770,   771,
     771,   772,   773,   774,   774,   774,   774,   774,   774,   774,
     774,   775,   775,   775,   775,   775,   775,   775,   775,   775,
     775,   775,   775,   775,   775,   775,   775,   776,   776,   777,
     777,   778,   778,   779,   779,   780,   781,   781,   781,   782,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782,   783,   783,   783,
     783,   783,   783,   783,   783,   783,   783,   783,   783,   783,
     783,   783,   783,   783,   783,   783,   783,   783,   783,   784,
     784,   785,   785,   785,   785,   785,   785,   785,   786,   786,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   788,   788,   789,   789,   789,   789,   789,   789,   789,
     789,   789,   789,   789,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   791,   791,
     792,   792,   793,   794,   794,   795,   795,   795,   795,   795,
     796,   796,   797,   797,   797,   797,   798,   798,   798,   798,
     798,   798,   798,   798,   798,   798,   798,   798,   798,   798,
     798,   798,   799,   799,   800,   800,   801,   801,   802,   802,
     803,   804,   805,   805,   806,   806,   807,   807,   808,   809,
     809,   810,   810,   810,   811,   811,   811,   812,   812,   812,
     812,   813,   813,   814,   814,   815,   815,   816,   816,   817,
     817,   818,   818,   819,   819,   819,   820,   820,   821,   821,
     822,   822,   822,   823,   823,   823,   824,   824,   824,   825,
     825,   826,   826,   827,   827,   828,   828,   829,   829,   830,
     830,   830,   830,   830,   831,   831,   831,   831,   831,   832,
     833,   834,   834,   834,   835,   835,   835,   836,   837,   837,
     837,   837,   838,   838,   839,   839,   840,   840,   840,   840,
     840,   840,   840,   840,   840,   840,   840,   840,   840,   840,
     840,   840,   841,   841,   841,   841,   841,   842,   842,   843,
     843,   844,   844,   845,   846,   846,   847,   848,   848,   849,
     849,   850,   850,   851,   851,   852,   852,   853,   853,   853,
     853,   854,   854,   855,   856,   856,   857,   857,   858,   858,
     858,   859,   859,   859,   860,   861,   861,   862,   863,   863,
     863,   863,   864,   865,   865,   865,   865,   866,   866,   867,
     867,   867,   868,   868,   869,   870,   870,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   872,   872,   873,   873,   874,
     874,   874,   874,   875,   875,   875,   875,   875,   875,   875,
     875,   875,   875,   875,   875,   875,   875,   875,   875,   875,
     875,   875,   875,   875,   875,   875,   875,   876,   877,   877,
     878,   878,   879,   879,   879,   879,   879,   879,   879,   879,
     879,   879,   879,   879,   879,   879,   879,   879,   879,   879,
     879,   880,   881,   881,   881,   882,   882,   883,   883,   883,
     883,   883,   884,   884,   885,   885,   885,   885,   886,   886,
     886,   887,   887,   888,   889,   889,   890,   891,   891,   892,
     892,   892,   892,   892,   892,   892,   892,   892,   892,   892,
     892,   892,   892,   893,   893,   893,   894,   894,   894,   894,
     894,   895,   895,   895,   896,   896,   897,   897,   897,   897,
     898,   898,   898,   898,   899,   900,   901,   901,   902,   902,
     903,   903,   903,   904,   904,   904,   904,   904,   904,   904,
     905,   905,   906,   906,   906,   907,   908,   908,   909,   909,
     910,   911,   911,   911,   911,   911,   911,   911,   912,   912,
     913,   914,   914,   914,   914,   914,   914,   915,   915,   916,
     917,   917,   917,   918,   918,   919,   919,   919,   919,   919,
     920,   920,   921,   921,   921,   921,   921,   922,   922,   923,
     923,   924,   924,   925,   925,   926,   926,   927,   927,   928,
     928,   928,   928,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   930,   930,   931,   932,   932,   933,   933,   933,
     934,   934,   935,   935,   936,   936,   936,   936,   937,   937,
     937,   938,   938,   939,   940,   940,   941,   941,   941,   942,
     942,   943,   944,   944,   944,   945,   945,   945,   946,   946,
     947,   948,   948,   949,   950,   950,   951,   951,   951,   951,
     951,   951,   951,   951,   952,   952,   953,   953,   953,   954,
     955,   955,   956,   956,   957,   958,   958,   959,   960,   960,
     961,   962,   962,   963,   963,   963,   963,   963,   964,   964,
     964,   965,   965,   966,   966,   967,   967,   967,   967,   967,
     967,   967,   967,   968,   968,   969,   969,   969,   969,   969,
     969,   969,   970,   970,   970,   971,   971,   972,   973,   973,
     974,   974,   974,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   976,   976,   977,   977,   977,   978,   978,   979,
     979,   980,   980,   981,   982,   982,   983,   983,   984,   984,
     984,   984,   985,   985,   986,   986,   986,   986,   987,   987,
     988,   988,   989,   990,   990,   990,   991,   991,   992,   992,
     993,   993,   994,   994,   995,   995,   996,   996,   996,   996,
     996,   997,   998,   999,  1000,  1001,  1001,  1002,  1002,  1003,
    1003,  1004,  1004,  1005,  1006,  1006,  1006,  1006,  1007,  1007,
    1008,  1008,  1009,  1009,  1010,  1010,  1011,  1011,  1011,  1011,
    1011,  1011,  1011,  1011,  1012,  1012,  1012,  1012,  1012,  1012,
    1013,  1013,  1013,  1013,  1014,  1014,  1015,  1015,  1015,  1015,
    1015,  1016,  1016,  1016,  1016,  1017,  1017,  1018,  1018,  1019,
    1019,  1019,  1019,  1020,  1020,  1021,  1021,  1021,  1022,  1023,
    1023,  1024,  1024,  1025,  1026,  1026,  1027,  1027,  1028,  1028,
    1029,  1029,  1030,  1030,  1030,  1031,  1031,  1032,  1032,  1033,
    1034,  1034,  1034,  1034,  1034,  1034,  1035,  1035,  1035,  1036,
    1036,  1036,  1036,  1036,  1036,  1036,  1037,  1037,  1037,  1037,
    1038,  1038,  1039,  1039,  1040,  1040,  1040,  1040,  1040,  1040,
    1040,  1040,  1040,  1040,  1040,  1041,  1041,  1042,  1042,  1043,
    1043,  1044,  1045,  1046,  1046,  1047,  1047,  1048,  1049,  1050,
    1050,  1050,  1050,  1050,  1050,  1051,  1051,  1052,  1052,  1053,
    1053,  1053,  1053,  1054,  1055,  1055,  1055,  1056,  1056,  1056,
    1056,  1056,  1056,  1056,  1056,  1056,  1056,  1056,  1056,  1056,
    1056,  1057,  1057,  1058,  1058,  1058,  1058,  1058,  1058,  1058,
    1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,
    1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,
    1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,
    1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,
    1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,  1058,
    1058,  1058,  1058,  1058,  1058,  1058,  1059,  1059,  1059,  1059,
    1059,  1059,  1059,  1059,  1059,  1059,  1059,  1059,  1059,  1059,
    1059,  1059,  1059,  1059,  1059,  1059,  1059,  1059,  1059,  1059,
    1059,  1060,  1060,  1060,  1060,  1060,  1060,  1060,  1060,  1060,
    1060,  1060,  1060,  1060,  1060,  1061,  1061,  1061,  1061,  1061,
    1061,  1061,  1062,  1062,  1063,  1063,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1064,  1065,  1065,
    1066,  1066,  1066,  1066,  1067,  1068,  1068,  1069,  1069,  1070,
    1070,  1071,  1071,  1071,  1072,  1072,  1072,  1072,  1073,  1073,
    1074,  1074,  1075,  1075,  1076,  1076,  1077,  1078,  1078,  1078,
    1079,  1080,  1080,  1081,  1081,  1082,  1082,  1082,  1083,  1083,
    1084,  1084,  1084,  1084,  1084,  1085,  1085,  1085,  1086,  1086,
    1087,  1088,  1088,  1088,  1089,  1089,  1090,  1090,  1090,  1090,
    1090,  1090,  1090,  1090,  1090,  1090,  1090,  1090,  1091,  1091,
    1092,  1092,  1093,  1093,  1093,  1093,  1093,  1093,  1094,  1094,
    1095,  1095,  1096,  1096,  1096,  1097,  1097,  1098,  1098,  1098,
    1099,  1099,  1100,  1100,  1101,  1101,  1101,  1101,  1101,  1101,
    1101,  1101,  1102,  1102,  1103,  1104,  1104,  1105,  1105,  1105,
    1105,  1105,  1105,  1106,  1107,  1108,  1108,  1108,  1109,  1109,
    1110,  1111,  1111,  1112,  1113,  1113,  1114,  1114,  1115,  1115,
    1116,  1116,  1116,  1116,  1117,  1117,  1118,  1118,  1119,  1119,
    1120,  1120,  1121,  1121,  1122,  1122,  1123,  1124,  1124,  1125,
    1125,  1126,  1126,  1126,  1126,  1127,  1127,  1128,  1128,  1129,
    1129,  1130,  1131,  1132,  1133,  1134,  1135,  1136,  1136,  1137,
    1137,  1137,  1137,  1137,  1137,  1137,  1137,  1137,  1137,  1137,
    1137,  1137,  1137,  1137,  1138,  1139,  1139,  1139,  1139,  1140,
    1141,  1141,  1141,  1142,  1142,  1143,  1143,  1143,  1143,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,  1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,
    1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,
    1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,
    1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,
    1145,  1145,  1145,  1145,  1145,  1145,  1146,  1146,  1146,  1146,
    1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,
    1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1148,  1148,  1149,  1149,  1149,  1149,
    1149,  1149,  1149,  1149,  1151,  1150,  1152,  1150,  1153,  1154,
    1154,  1154,  1154,  1155,  1155,  1155,  1155,  1156,  1156,  1157,
    1158,  1159,  1159,  1160,  1160,  1160,  1161,  1161,  1162,  1162,
    1163,  1163,  1164,  1164,  1164,  1164,  1165,  1165,  1165,  1166,
    1167,  1167,  1168,  1168,  1169,  1169,  1169,  1169,  1170,  1170,
    1171,  1172,  1173,  1174,  1174,  1175,  1176,  1176,  1177,  1177,
    1177,  1177,  1177,  1179,  1178,  1180,  1181,  1182,  1182,  1183,
    1183,  1183,  1183,  1184,  1184,  1186,  1185,  1188,  1187,  1189,
    1187,  1187,  1190,  1190,  1191,  1191,  1191,  1192,  1192,  1192,
    1192,  1193,  1193,  1194,  1194,  1194,  1194,  1194,  1194,  1195,
    1195,  1195,  1196,  1198,  1197,  1199,  1200,  1199,  1201,  1201,
    1202,  1202,  1203,  1203,  1204,  1204,  1204,  1204,  1204,  1204,
    1204,  1204,  1204,  1205,  1205,  1205,  1205,  1205,  1205,  1205,
    1205,  1205,  1205,  1206,  1206,  1207,  1207,  1208,  1209,  1209,
    1210,  1210,  1210,  1211,  1212,  1213,  1213,  1213,  1213,  1214,
    1214,  1214,  1215,  1215,  1216,  1216,  1217,  1218,  1218,  1219,
    1219,  1220,  1220,  1221,  1221,  1222,  1223,  1223,  1224,  1224,
    1224,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1226,  1226,  1226,  1226,  1226,  1227,  1227,  1228,  1229,  1230,
    1231,  1231,  1232,  1233,  1234,  1234,  1235,  1236,  1236,  1237,
    1238,  1239,  1239,  1240,  1241,  1242,  1242,  1243,  1244,  1244,
    1244,  1244,  1244,  1245,  1245,  1245,  1245,  1245,  1245,  1245,
    1245,  1245,  1245,  1245,  1245,  1245,  1245,  1245,  1246,  1246,
    1247,  1247,  1248,  1248,  1248,  1250,  1249,  1251,  1251,  1253,
    1252,  1254,  1254,  1254,  1255,  1255,  1255,  1255,  1255,  1255,
    1255,  1255,  1255,  1256,  1256,  1257,  1257,  1257,  1257,  1257,
    1257,  1257,  1257,  1257,  1257,  1257,  1257,  1257,  1257,  1257,
    1257,  1257,  1257,  1257,  1257,  1257,  1257,  1257,  1258,  1258,
    1258,  1258,  1258,  1258,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1260,  1261,  1261,  1261,  1261,  1261,  1261,  1261,  1261,
    1262,  1262,  1262,  1262,  1262,  1262,  1262,  1263,  1263,  1263,
    1263,  1263,  1263,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1265,  1265,  1265,  1265,  1265,  1266,
    1266,  1266,  1266,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1268,  1268,  1268,  1269,  1269,  1269,  1269,  1269,  1269,  1270,
    1270,  1271,  1272,  1272,  1273,  1273,  1274,  1275,  1276,  1277,
    1277,  1277,  1278,  1279,  1280,  1281,  1282,  1282,  1282,  1282,
    1282,  1283,  1284,  1284,  1284,  1285,  1285,  1286,  1286,  1286,
    1287,  1287,  1288,  1288,  1289,  1289,  1290,  1290,  1290,  1290,
    1290,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,
    1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,
    1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,
    1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,
    1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,  1291,
    1291,  1291,  1291,  1291,  1291,  1291,  1291,  1292,  1292,  1292,
    1292,  1293,  1293,  1293,  1293,  1293,  1293,  1293,  1293,  1293,
    1293,  1294,  1294,  1294,  1294,  1295,  1295,  1296,  1296,  1297,
    1297,  1298,  1298
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     1,
       1,     0,     2,     0,     2,     0,     2,     2,     3,     3,
       1,     3,     3,     2,     1,     1,     2,     2,     2,     3,
       3,     5,     5,     0,     3,     5,     5,     5,     5,     5,
       3,     5,     3,     5,     5,     6,     1,     1,     3,     5,
       6,     4,     9,     7,     1,     0,     2,     0,     1,     1,
       1,     1,     1,     1,     2,     3,     3,     2,     5,     1,
       3,     3,     3,     3,     1,     3,     3,     2,     2,     2,
       2,     3,     3,     3,     3,     1,     3,     1,     3,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     1,     2,     3,     2,     1,     1,     2,     1,
       2,     1,     3,     4,     5,     4,     2,     4,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     4,     6,
      10,    13,     4,     6,    10,    13,     4,     6,     4,     6,
       5,     7,    11,    14,     1,     3,     2,     5,     3,     6,
       4,     6,     6,     6,     5,     5,     6,     6,     4,     8,
       4,     2,     4,     3,     6,     4,     3,     3,     3,     3,
       2,     2,     3,     4,     4,     3,     3,     3,     3,     3,
       3,     4,     4,     3,     2,     3,     2,     2,     3,     3,
       2,     2,     3,     4,     4,     4,     5,     1,     3,     2,
       1,     1,     0,     2,     0,     2,     0,     1,     1,     1,
       3,     3,     2,     0,     1,     3,     3,     1,     5,     3,
       4,     1,     3,     4,     6,     4,     8,     2,     2,    11,
       9,     1,     1,     1,     0,     1,     1,     1,     1,     3,
       2,     0,     1,     1,     1,     3,     3,     1,     1,     3,
       3,     3,     3,     4,     3,     2,     1,     0,     2,     0,
       3,     0,     1,     0,     1,     3,     2,     1,     1,     1,
       3,     0,     1,     3,     1,    11,    14,    10,    13,     1,
       1,     2,     2,     2,     2,     1,     0,     1,     0,     3,
       0,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       4,     4,     2,     0,     3,     1,     1,     2,     2,     1,
       3,     4,     5,     2,     5,     1,     2,     2,     2,     3,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     3,
       1,     5,     7,     3,     8,     4,     9,    11,     2,     0,
       3,     0,     1,     3,     1,     2,     2,     2,     0,     1,
       3,     3,     6,     4,     0,     1,     1,     2,     2,     0,
       3,     3,     2,     1,     1,     2,     2,     4,     0,     2,
       2,     2,     0,     3,     4,     4,     0,     2,     0,     4,
       0,     3,     5,     2,     3,     0,     8,    11,     4,     1,
       0,     6,     5,     8,     4,     6,     1,     0,     1,     2,
       2,     1,     2,     3,     2,     2,     2,     2,     3,     3,
       1,     3,     1,     0,     1,     2,     2,     1,     1,     3,
       6,    10,     1,     0,     1,     2,     2,     0,     2,     2,
       1,     0,     5,     7,     1,     0,     7,     2,     0,     3,
       5,     5,     8,     2,     0,     2,     2,     2,     1,     5,
       2,     0,     2,     7,     7,    10,     6,     6,     6,     6,
       7,     7,     9,     9,     6,     7,     6,     8,     8,     8,
       8,     6,     6,     7,     7,     8,     6,     9,     6,     7,
       2,     2,     2,     2,     1,     2,     1,     0,     6,     8,
       7,     6,     4,     0,     1,     3,     4,     1,     3,     1,
       2,     2,     2,     2,     1,     1,    10,     2,     0,     2,
       2,     1,     0,     4,     6,     5,     4,     4,    11,    14,
       5,     7,    11,     2,     1,     4,     0,     8,     1,     1,
       7,     9,     8,     9,     8,     6,     8,     4,     0,     5,
       0,     2,     0,     2,     0,     2,     0,     1,     1,     1,
       1,     1,     8,    15,    20,     1,     1,     2,     1,     3,
       1,     1,     1,     3,     1,     3,     0,     1,     0,     1,
       1,     4,     0,     1,     3,     0,     1,     1,     1,     1,
       2,     0,     0,     2,     2,     1,     2,     2,     2,     2,
       6,     8,    11,    13,     1,     3,     5,     1,     3,     5,
       1,     2,     2,     1,     8,     4,     5,     4,     4,     4,
       3,     7,     8,     6,     6,     6,     6,     6,     4,     5,
       3,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     3,     1,     0,     1,     3,     7,     9,
       9,     3,     0,    13,     1,     3,     5,     6,     4,     7,
       2,     1,     0,     2,     0,     2,     4,     0,     1,     0,
       6,     8,     8,     1,     3,     5,     5,     7,     9,     7,
       9,     5,     6,     6,     4,     4,     6,     4,     6,     5,
       7,     1,     1,     1,     2,     1,     2,     2,     2,     1,
       1,     1,     1,     3,     3,     3,     3,     1,     3,     1,
       2,     2,     3,     1,     3,     5,     2,     2,     0,     6,
       6,     6,     7,     7,     7,     8,     9,     8,     8,     6,
       9,     8,     9,     9,     7,    10,     7,     2,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     1,     3,     2,     3,     3,     3,     3,     1,
       1,     8,     8,     8,     9,     9,     9,     9,     2,     0,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     2,     2,     3,     4,     5,     4,     5,
       3,     4,     3,     4,     1,     2,     3,     3,     3,     3,
       4,     4,     3,     3,     4,     4,     4,     4,     1,     1,
       1,     0,     7,     7,    10,     1,     1,     2,     4,     5,
       1,     3,     2,     2,     2,     2,     1,     2,     2,     4,
       3,     2,     2,     2,     2,     3,     2,     2,     2,     5,
       5,     5,     1,     3,     1,     2,     3,     0,     1,     3,
       2,     6,     6,     9,     3,     0,     3,     0,     5,     2,
       0,     3,     3,     3,     7,     7,    10,     1,     1,     1,
       1,    14,    17,     1,     0,     1,     0,     1,     0,     2,
       0,     1,     3,     5,     5,     7,     2,     0,     1,     0,
       1,     1,     0,     2,     2,     0,     9,    12,     7,     2,
       0,     3,     2,     1,     3,     3,     2,     1,     3,     3,
       3,     2,     2,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     4,     5,     1,     3,     3,     1,     3,     3,
       5,     6,     1,     3,     1,     2,     4,     5,     1,     1,
       1,     1,     3,     3,     2,     2,     1,     2,     2,     2,
       1,     2,     2,     2,     2,     1,     1,     1,     3,     3,
       5,     2,     0,     2,     1,     3,     5,     1,     2,     1,
       0,     5,     7,     5,     7,     5,     7,     3,     5,     5,
       5,     1,     3,     2,     1,     2,     1,     2,    11,    10,
      10,     2,     2,     0,     9,     2,     0,    10,    11,    11,
       5,     5,     8,     3,     3,     6,     6,     1,     1,     1,
       1,     1,     1,     3,     1,     5,     5,     7,     6,     6,
       6,     6,     8,     8,     6,     6,     7,     9,     9,     8,
      10,     6,     6,     6,     8,     6,     8,     6,     8,     7,
       9,     6,     8,     7,     9,     8,    10,     9,    11,     8,
      10,     9,    11,     8,     8,     7,     6,     6,     6,     8,
       8,     8,     8,     6,     9,     1,     0,     2,     0,     7,
       9,     8,     7,     7,     6,     6,     6,     6,     6,     7,
       9,     9,     6,     8,     8,     8,     8,     8,     6,     8,
       6,     8,     7,     9,     7,     9,     6,     8,     1,     3,
       3,     3,     7,     6,     6,     6,     6,     6,     7,     7,
       7,     9,     9,     6,     6,     6,     8,     8,     8,     6,
       7,    13,     1,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       0,     6,     8,     3,     2,     0,     2,     2,     2,     2,
       3,     3,     2,     2,     2,     2,     3,     2,     5,     4,
       3,     3,     3,     1,     1,     0,     3,     2,     2,     1,
       2,     1,     3,     2,     1,     0,     9,    11,    12,    14,
       3,     4,     4,     0,     2,     5,     1,     0,     1,     2,
       3,     3,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     0,     5,     4,     6,     4,     3,     5,     4,     4,
       6,     4,     6,     6,     5,     7,     9,     6,     1,     0,
       6,    11,    11,    11,    13,     9,    11,     1,     1,    10,
       4,     2,     5,     2,     0,     4,     5,     5,     4,     6,
       1,     3,     1,     1,     1,     1,     1,     2,     4,     1,
       1,     1,     0,     1,     0,     1,     0,     3,     0,     2,
       4,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     1,     1,     1,     1,     0,
       5,     4,     3,     0,     1,     1,     1,     1,     4,     9,
      12,     3,     0,     7,     1,     3,     1,     4,     2,     1,
       3,     2,     8,     5,     0,     4,     3,     0,     3,     0,
       7,     2,     0,     5,     3,     0,     2,     2,     2,     3,
       1,     3,     1,     2,     1,     0,     1,     2,     0,     8,
       1,     3,     1,     1,     3,     5,     5,     2,     1,     3,
       7,     1,     1,     0,     3,     2,     2,     2,     0,     2,
       2,     1,     1,     3,     3,     1,     2,     4,     4,     2,
       3,     5,     5,     1,     1,     9,     9,     1,     2,     4,
       4,     4,     2,     2,     3,     1,     3,     6,     1,     0,
       2,     1,     0,     3,     3,     4,     4,     4,     4,     3,
       2,     1,     1,     0,     1,     1,     0,     1,     5,     1,
       0,     1,     0,     3,     1,     3,     4,     3,     2,     2,
       1,     1,     1,     0,     2,     4,     5,     4,     2,     3,
       1,     1,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     3,     0,     1,     3,     1,     1,     1,     1,
       1,     2,     4,     4,     5,     2,     0,     1,     3,     1,
       0,     1,     2,     3,     2,     4,     2,     3,     2,     0,
       2,     3,     2,     0,     1,     3,     2,     3,     2,     3,
       2,     3,     1,     4,     3,     4,     5,     4,     5,     4,
       5,     2,     4,     1,     1,     0,     1,     4,     5,     4,
       0,     2,     2,     2,     1,     1,     0,     4,     2,     1,
       2,     2,     4,     1,     3,     1,     2,     3,     6,     4,
       0,     2,     6,     2,     1,     3,     4,     0,     2,     0,
       2,     0,     2,     4,     0,     1,     0,     1,     3,     3,
       2,     3,     5,     6,     2,     3,     3,     4,     0,     1,
       1,     1,     1,     1,     2,     4,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     1,     3,     0,     1,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     5,     2,     2,
       2,     1,     3,     3,     2,     1,     0,     3,     0,     5,
       2,     5,     2,     1,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     4,     1,     3,     3,     5,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     3,     3,     2,     2,     3,     5,
       4,     6,     3,     5,     4,     6,     4,     6,     5,     7,
       3,     2,     4,     2,     3,     3,     4,     3,     4,     3,
       4,     5,     6,     6,     7,     6,     7,     6,     7,     3,
       4,     4,     6,     2,     3,     4,     1,     3,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     5,     6,     6,     7,     3,
       4,     1,     1,     2,     4,     1,     1,     1,     2,     2,
       2,     2,     1,     1,     4,     3,     5,     6,     8,     6,
       6,     4,     4,     1,     1,     1,     5,     1,     1,     4,
       1,     4,     1,     4,     1,     4,     1,     1,     1,     1,
       1,     1,     6,     4,     4,     4,     4,     6,     5,     5,
       5,     4,     6,     4,     4,     4,     4,     5,     7,     7,
       9,     5,     4,     6,     5,     7,     7,     7,     2,     3,
       3,     3,     4,     0,     4,     1,     3,     3,     1,     1,
       1,     2,     2,     0,     2,     4,     4,     6,     5,     0,
       5,     0,     2,     0,     1,     3,     3,     2,     2,     0,
       6,     1,     0,     3,     0,     2,     2,     0,     1,     4,
       2,     2,     2,     2,     2,     4,     3,     5,     4,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       1,     4,     1,     4,     1,     2,     1,     2,     1,     3,
       1,     3,     1,     3,     3,     1,     3,     3,     3,     2,
       1,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     2,     3,     0,     3,     3,     2,
       2,     1,     0,     2,     2,     3,     2,     1,     1,     3,
       5,     1,     2,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     5,     1,     0,     1,     2,     0,     2,
       1,     0,     1,     1,     1,     3,     3,     1,     0,     1,
       3,     3,     2,     1,     1,     1,     3,     1,     2,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     6,     2,     3,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     2,     4,     3,     2,     1,
       1,     1,     1,     1,     0,     8,     0,    11,     2,     5,
       3,     2,     2,     3,     7,     1,     1,     1,     0,     2,
       2,     1,     0,     1,     3,     1,     2,     0,     2,     0,
       2,     0,     1,     3,     4,     3,     1,     1,     1,     1,
       2,     0,     2,     4,     0,     2,     2,     2,     1,     1,
       7,     3,     1,     1,     1,     1,     2,     0,     1,     3,
       3,     3,     3,     0,     4,     5,     5,     0,     1,     1,
       1,     2,     2,     1,     2,     0,     7,     0,     5,     0,
       4,     2,     2,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     2,     1,     3,
       2,     2,     3,     0,     5,     1,     0,     5,     2,     2,
       1,     1,     1,     2,     2,     3,     1,     2,     2,     3,
       3,     4,     2,     1,     2,     1,     1,     2,     2,     3,
       1,     1,     1,     1,     0,     1,     3,     5,     0,     2,
       0,     1,     2,     3,     2,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     2,     2,     3,     0,     1,     2,
       1,     4,     3,     4,     3,     2,     1,     3,     1,     1,
       1,     1,     2,     2,     1,     2,     2,     1,     1,     1,
       4,     4,     4,     4,     4,     1,     0,     3,     3,     4,
       1,     3,     3,     4,     1,     3,     3,     1,     1,     1,
       6,     1,     3,     3,     6,     1,     3,     3,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     4,
       1,     1,     4,     4,     3,     0,     7,     1,     0,     0,
       7,     3,     4,     3,     1,     1,     1,     2,     3,     5,
       2,     5,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     0,     1,     2,     1,     2,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     3,
       1,     2,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     2,
       3,     1,     3,     3,     3,     3,     3,     3,     1,     1,
       4,     0,     2,     2,     1,     2,     1,     0,     1,     1,
       1,     0,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 1565 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31217 "preproc.c" /* yacc.c:1652  */
    break;

  case 4:
#line 1567 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31223 "preproc.c" /* yacc.c:1652  */
    break;

  case 5:
#line 1569 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31229 "preproc.c" /* yacc.c:1652  */
    break;

  case 6:
#line 1571 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31235 "preproc.c" /* yacc.c:1652  */
    break;

  case 7:
#line 1573 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31241 "preproc.c" /* yacc.c:1652  */
    break;

  case 8:
#line 1575 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31247 "preproc.c" /* yacc.c:1652  */
    break;

  case 9:
#line 1577 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31253 "preproc.c" /* yacc.c:1652  */
    break;

  case 10:
#line 1579 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31259 "preproc.c" /* yacc.c:1652  */
    break;

  case 11:
#line 1581 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31265 "preproc.c" /* yacc.c:1652  */
    break;

  case 12:
#line 1583 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31271 "preproc.c" /* yacc.c:1652  */
    break;

  case 13:
#line 1585 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31277 "preproc.c" /* yacc.c:1652  */
    break;

  case 14:
#line 1587 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31283 "preproc.c" /* yacc.c:1652  */
    break;

  case 15:
#line 1589 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31289 "preproc.c" /* yacc.c:1652  */
    break;

  case 16:
#line 1591 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31295 "preproc.c" /* yacc.c:1652  */
    break;

  case 17:
#line 1593 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31301 "preproc.c" /* yacc.c:1652  */
    break;

  case 18:
#line 1595 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31307 "preproc.c" /* yacc.c:1652  */
    break;

  case 19:
#line 1597 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31313 "preproc.c" /* yacc.c:1652  */
    break;

  case 20:
#line 1599 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31319 "preproc.c" /* yacc.c:1652  */
    break;

  case 21:
#line 1601 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31325 "preproc.c" /* yacc.c:1652  */
    break;

  case 22:
#line 1603 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31331 "preproc.c" /* yacc.c:1652  */
    break;

  case 23:
#line 1605 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31337 "preproc.c" /* yacc.c:1652  */
    break;

  case 24:
#line 1607 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31343 "preproc.c" /* yacc.c:1652  */
    break;

  case 25:
#line 1609 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31349 "preproc.c" /* yacc.c:1652  */
    break;

  case 26:
#line 1611 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31355 "preproc.c" /* yacc.c:1652  */
    break;

  case 27:
#line 1613 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31361 "preproc.c" /* yacc.c:1652  */
    break;

  case 28:
#line 1615 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31367 "preproc.c" /* yacc.c:1652  */
    break;

  case 29:
#line 1617 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31373 "preproc.c" /* yacc.c:1652  */
    break;

  case 30:
#line 1619 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31379 "preproc.c" /* yacc.c:1652  */
    break;

  case 31:
#line 1621 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31385 "preproc.c" /* yacc.c:1652  */
    break;

  case 32:
#line 1623 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31391 "preproc.c" /* yacc.c:1652  */
    break;

  case 33:
#line 1625 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31397 "preproc.c" /* yacc.c:1652  */
    break;

  case 34:
#line 1627 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31403 "preproc.c" /* yacc.c:1652  */
    break;

  case 35:
#line 1629 "preproc.y" /* yacc.c:1652  */
    {
		if (INFORMIX_MODE)
		{
			if (pg_strcasecmp((yyvsp[0].str)+strlen("close "), "database") == 0)
			{
				if (connection)
					mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CLOSE DATABASE statement");

				fprintf(base_yyout, "{ ECPGdisconnect(__LINE__, \"CURRENT\");");
				whenever_action(2);
				free((yyvsp[0].str));
				break;
			}
		}

		output_statement((yyvsp[0].str), 0, ECPGst_normal);
	}
#line 31425 "preproc.c" /* yacc.c:1652  */
    break;

  case 36:
#line 1647 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31431 "preproc.c" /* yacc.c:1652  */
    break;

  case 37:
#line 1649 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31437 "preproc.c" /* yacc.c:1652  */
    break;

  case 38:
#line 1651 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31443 "preproc.c" /* yacc.c:1652  */
    break;

  case 39:
#line 1653 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31449 "preproc.c" /* yacc.c:1652  */
    break;

  case 40:
#line 1655 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31455 "preproc.c" /* yacc.c:1652  */
    break;

  case 41:
#line 1657 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31461 "preproc.c" /* yacc.c:1652  */
    break;

  case 42:
#line 1659 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31467 "preproc.c" /* yacc.c:1652  */
    break;

  case 43:
#line 1661 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31473 "preproc.c" /* yacc.c:1652  */
    break;

  case 44:
#line 1663 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31479 "preproc.c" /* yacc.c:1652  */
    break;

  case 45:
#line 1665 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31485 "preproc.c" /* yacc.c:1652  */
    break;

  case 46:
#line 1667 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31491 "preproc.c" /* yacc.c:1652  */
    break;

  case 47:
#line 1669 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31497 "preproc.c" /* yacc.c:1652  */
    break;

  case 48:
#line 1671 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31503 "preproc.c" /* yacc.c:1652  */
    break;

  case 49:
#line 1673 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31509 "preproc.c" /* yacc.c:1652  */
    break;

  case 50:
#line 1675 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31515 "preproc.c" /* yacc.c:1652  */
    break;

  case 51:
#line 1677 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31521 "preproc.c" /* yacc.c:1652  */
    break;

  case 52:
#line 1679 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31527 "preproc.c" /* yacc.c:1652  */
    break;

  case 53:
#line 1681 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31533 "preproc.c" /* yacc.c:1652  */
    break;

  case 54:
#line 1683 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31539 "preproc.c" /* yacc.c:1652  */
    break;

  case 55:
#line 1685 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31545 "preproc.c" /* yacc.c:1652  */
    break;

  case 56:
#line 1687 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31551 "preproc.c" /* yacc.c:1652  */
    break;

  case 57:
#line 1689 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31557 "preproc.c" /* yacc.c:1652  */
    break;

  case 58:
#line 1691 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31563 "preproc.c" /* yacc.c:1652  */
    break;

  case 59:
#line 1693 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31569 "preproc.c" /* yacc.c:1652  */
    break;

  case 60:
#line 1695 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31575 "preproc.c" /* yacc.c:1652  */
    break;

  case 61:
#line 1697 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31581 "preproc.c" /* yacc.c:1652  */
    break;

  case 62:
#line 1699 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31587 "preproc.c" /* yacc.c:1652  */
    break;

  case 63:
#line 1701 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31593 "preproc.c" /* yacc.c:1652  */
    break;

  case 64:
#line 1703 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31599 "preproc.c" /* yacc.c:1652  */
    break;

  case 65:
#line 1705 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31605 "preproc.c" /* yacc.c:1652  */
    break;

  case 66:
#line 1707 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31611 "preproc.c" /* yacc.c:1652  */
    break;

  case 67:
#line 1709 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31617 "preproc.c" /* yacc.c:1652  */
    break;

  case 68:
#line 1711 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31623 "preproc.c" /* yacc.c:1652  */
    break;

  case 69:
#line 1713 "preproc.y" /* yacc.c:1652  */
    {
		output_deallocate_prepare_statement((yyvsp[0].str));
	}
#line 31631 "preproc.c" /* yacc.c:1652  */
    break;

  case 70:
#line 1717 "preproc.y" /* yacc.c:1652  */
    { output_simple_statement((yyvsp[0].str)); }
#line 31637 "preproc.c" /* yacc.c:1652  */
    break;

  case 71:
#line 1719 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31643 "preproc.c" /* yacc.c:1652  */
    break;

  case 72:
#line 1721 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 31649 "preproc.c" /* yacc.c:1652  */
    break;

  case 73:
#line 1723 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_normal); }
#line 31655 "preproc.c" /* yacc.c:1652  */
    break;

  case 74:
#line 1725 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31661 "preproc.c" /* yacc.c:1652  */
    break;

  case 75:
#line 1727 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31667 "preproc.c" /* yacc.c:1652  */
    break;

  case 76:
#line 1729 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31673 "preproc.c" /* yacc.c:1652  */
    break;

  case 77:
#line 1731 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31679 "preproc.c" /* yacc.c:1652  */
    break;

  case 78:
#line 1733 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31685 "preproc.c" /* yacc.c:1652  */
    break;

  case 79:
#line 1735 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31691 "preproc.c" /* yacc.c:1652  */
    break;

  case 80:
#line 1737 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31697 "preproc.c" /* yacc.c:1652  */
    break;

  case 81:
#line 1739 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31703 "preproc.c" /* yacc.c:1652  */
    break;

  case 82:
#line 1741 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31709 "preproc.c" /* yacc.c:1652  */
    break;

  case 83:
#line 1743 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31715 "preproc.c" /* yacc.c:1652  */
    break;

  case 84:
#line 1745 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31721 "preproc.c" /* yacc.c:1652  */
    break;

  case 85:
#line 1747 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31727 "preproc.c" /* yacc.c:1652  */
    break;

  case 86:
#line 1749 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31733 "preproc.c" /* yacc.c:1652  */
    break;

  case 87:
#line 1751 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31739 "preproc.c" /* yacc.c:1652  */
    break;

  case 88:
#line 1753 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31745 "preproc.c" /* yacc.c:1652  */
    break;

  case 89:
#line 1755 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31751 "preproc.c" /* yacc.c:1652  */
    break;

  case 90:
#line 1757 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31757 "preproc.c" /* yacc.c:1652  */
    break;

  case 91:
#line 1759 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31763 "preproc.c" /* yacc.c:1652  */
    break;

  case 92:
#line 1761 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31769 "preproc.c" /* yacc.c:1652  */
    break;

  case 93:
#line 1763 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31775 "preproc.c" /* yacc.c:1652  */
    break;

  case 94:
#line 1765 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_execute); }
#line 31781 "preproc.c" /* yacc.c:1652  */
    break;

  case 95:
#line 1767 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31787 "preproc.c" /* yacc.c:1652  */
    break;

  case 96:
#line 1769 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_normal); }
#line 31793 "preproc.c" /* yacc.c:1652  */
    break;

  case 97:
#line 1771 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31799 "preproc.c" /* yacc.c:1652  */
    break;

  case 98:
#line 1773 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31805 "preproc.c" /* yacc.c:1652  */
    break;

  case 99:
#line 1775 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31811 "preproc.c" /* yacc.c:1652  */
    break;

  case 100:
#line 1777 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31817 "preproc.c" /* yacc.c:1652  */
    break;

  case 101:
#line 1779 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 31823 "preproc.c" /* yacc.c:1652  */
    break;

  case 102:
#line 1781 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31829 "preproc.c" /* yacc.c:1652  */
    break;

  case 103:
#line 1783 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31835 "preproc.c" /* yacc.c:1652  */
    break;

  case 104:
#line 1785 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31841 "preproc.c" /* yacc.c:1652  */
    break;

  case 105:
#line 1787 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31847 "preproc.c" /* yacc.c:1652  */
    break;

  case 106:
#line 1789 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31853 "preproc.c" /* yacc.c:1652  */
    break;

  case 107:
#line 1791 "preproc.y" /* yacc.c:1652  */
    {
		if ((yyvsp[0].prep).type == NULL || strlen((yyvsp[0].prep).type) == 0)
			output_prepare_statement((yyvsp[0].prep).name, (yyvsp[0].prep).stmt);
		else
			output_statement(cat_str(5, mm_strdup("prepare"), (yyvsp[0].prep).name, (yyvsp[0].prep).type, mm_strdup("as"), (yyvsp[0].prep).stmt), 0, ECPGst_normal);
	}
#line 31864 "preproc.c" /* yacc.c:1652  */
    break;

  case 108:
#line 1798 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31870 "preproc.c" /* yacc.c:1652  */
    break;

  case 109:
#line 1800 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31876 "preproc.c" /* yacc.c:1652  */
    break;

  case 110:
#line 1802 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31882 "preproc.c" /* yacc.c:1652  */
    break;

  case 111:
#line 1804 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31888 "preproc.c" /* yacc.c:1652  */
    break;

  case 112:
#line 1806 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31894 "preproc.c" /* yacc.c:1652  */
    break;

  case 113:
#line 1808 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31900 "preproc.c" /* yacc.c:1652  */
    break;

  case 114:
#line 1810 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31906 "preproc.c" /* yacc.c:1652  */
    break;

  case 115:
#line 1812 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31912 "preproc.c" /* yacc.c:1652  */
    break;

  case 116:
#line 1814 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31918 "preproc.c" /* yacc.c:1652  */
    break;

  case 117:
#line 1816 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31924 "preproc.c" /* yacc.c:1652  */
    break;

  case 118:
#line 1818 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 31930 "preproc.c" /* yacc.c:1652  */
    break;

  case 119:
#line 1820 "preproc.y" /* yacc.c:1652  */
    {
		fprintf(base_yyout, "{ ECPGtrans(__LINE__, %s, \"%s\");", connection ? connection : "NULL", (yyvsp[0].str));
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 31940 "preproc.c" /* yacc.c:1652  */
    break;

  case 120:
#line 1826 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31946 "preproc.c" /* yacc.c:1652  */
    break;

  case 121:
#line 1828 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31952 "preproc.c" /* yacc.c:1652  */
    break;

  case 122:
#line 1830 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 31958 "preproc.c" /* yacc.c:1652  */
    break;

  case 123:
#line 1832 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31964 "preproc.c" /* yacc.c:1652  */
    break;

  case 124:
#line 1834 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31970 "preproc.c" /* yacc.c:1652  */
    break;

  case 125:
#line 1836 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31976 "preproc.c" /* yacc.c:1652  */
    break;

  case 126:
#line 1838 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31982 "preproc.c" /* yacc.c:1652  */
    break;

  case 127:
#line 1840 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 31988 "preproc.c" /* yacc.c:1652  */
    break;

  case 128:
#line 1842 "preproc.y" /* yacc.c:1652  */
    {
		fprintf(base_yyout,"ECPGallocate_desc(__LINE__, %s);",(yyvsp[0].str));
		whenever_action(0);
		free((yyvsp[0].str));
	}
#line 31998 "preproc.c" /* yacc.c:1652  */
    break;

  case 129:
#line 1848 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CONNECT statement");

		fprintf(base_yyout, "{ ECPGconnect(__LINE__, %d, %s, %d); ", compat, (yyvsp[0].str), autocommit);
		reset_variables();
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 32012 "preproc.c" /* yacc.c:1652  */
    break;

  case 130:
#line 1858 "preproc.y" /* yacc.c:1652  */
    {
		output_simple_statement((yyvsp[0].str));
	}
#line 32020 "preproc.c" /* yacc.c:1652  */
    break;

  case 131:
#line 1862 "preproc.y" /* yacc.c:1652  */
    {
		fprintf(base_yyout,"ECPGdeallocate_desc(__LINE__, %s);",(yyvsp[0].str));
		whenever_action(0);
		free((yyvsp[0].str));
	}
#line 32030 "preproc.c" /* yacc.c:1652  */
    break;

  case 132:
#line 1868 "preproc.y" /* yacc.c:1652  */
    {
		output_simple_statement((yyvsp[0].str));
	}
#line 32038 "preproc.c" /* yacc.c:1652  */
    break;

  case 133:
#line 1872 "preproc.y" /* yacc.c:1652  */
    {
		fprintf(base_yyout, "{ ECPGdescribe(__LINE__, %d, %s,", compat, (yyvsp[0].str));
		dump_variables(argsresult, 1);
		fputs("ECPGt_EORT);", base_yyout);
		fprintf(base_yyout, "}");
		output_line_number();

		free((yyvsp[0].str));
	}
#line 32052 "preproc.c" /* yacc.c:1652  */
    break;

  case 134:
#line 1882 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in DISCONNECT statement");

		fprintf(base_yyout, "{ ECPGdisconnect(__LINE__, %s);",
				(yyvsp[0].str) ? (yyvsp[0].str) : "\"CURRENT\"");
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 32066 "preproc.c" /* yacc.c:1652  */
    break;

  case 135:
#line 1891 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_exec_immediate); }
#line 32072 "preproc.c" /* yacc.c:1652  */
    break;

  case 136:
#line 1893 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";

		if (strcmp((yyvsp[0].str), "all") == 0)
			fprintf(base_yyout, "{ ECPGdeallocate_all(__LINE__, %d, %s);", compat, con);
		else if ((yyvsp[0].str)[0] == ':')
			fprintf(base_yyout, "{ ECPGdeallocate(__LINE__, %d, %s, %s);", compat, con, (yyvsp[0].str)+1);
		else
			fprintf(base_yyout, "{ ECPGdeallocate(__LINE__, %d, %s, \"%s\");", compat, con, (yyvsp[0].str));

		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 32090 "preproc.c" /* yacc.c:1652  */
    break;

  case 137:
#line 1907 "preproc.y" /* yacc.c:1652  */
    {
		lookup_descriptor((yyvsp[0].descriptor).name, connection);
		output_get_descr((yyvsp[0].descriptor).name, (yyvsp[0].descriptor).str);
		free((yyvsp[0].descriptor).name);
		free((yyvsp[0].descriptor).str);
	}
#line 32101 "preproc.c" /* yacc.c:1652  */
    break;

  case 138:
#line 1914 "preproc.y" /* yacc.c:1652  */
    {
		lookup_descriptor((yyvsp[0].str), connection);
		output_get_descr_header((yyvsp[0].str));
		free((yyvsp[0].str));
	}
#line 32111 "preproc.c" /* yacc.c:1652  */
    break;

  case 139:
#line 1920 "preproc.y" /* yacc.c:1652  */
    {
		struct cursor *ptr;

		if ((ptr = add_additional_variables((yyvsp[0].str), true)) != NULL)
		{
			connection = ptr->connection ? mm_strdup(ptr->connection) : NULL;
			output_statement(mm_strdup(ptr->command), 0, ECPGst_normal);
			ptr->opened = true;
		}
	}
#line 32126 "preproc.c" /* yacc.c:1652  */
    break;

  case 140:
#line 1931 "preproc.y" /* yacc.c:1652  */
    {
		fprintf(base_yyout, "{ ECPGsetcommit(__LINE__, \"%s\", %s);", (yyvsp[0].str), connection ? connection : "NULL");
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 32136 "preproc.c" /* yacc.c:1652  */
    break;

  case 141:
#line 1937 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in SET CONNECTION statement");

		fprintf(base_yyout, "{ ECPGsetconn(__LINE__, %s);", (yyvsp[0].str));
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 32149 "preproc.c" /* yacc.c:1652  */
    break;

  case 142:
#line 1946 "preproc.y" /* yacc.c:1652  */
    {
		lookup_descriptor((yyvsp[0].descriptor).name, connection);
		output_set_descr((yyvsp[0].descriptor).name, (yyvsp[0].descriptor).str);
		free((yyvsp[0].descriptor).name);
		free((yyvsp[0].descriptor).str);
	}
#line 32160 "preproc.c" /* yacc.c:1652  */
    break;

  case 143:
#line 1953 "preproc.y" /* yacc.c:1652  */
    {
		lookup_descriptor((yyvsp[0].str), connection);
		output_set_descr_header((yyvsp[0].str));
		free((yyvsp[0].str));
	}
#line 32170 "preproc.c" /* yacc.c:1652  */
    break;

  case 144:
#line 1959 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in TYPE statement");

		fprintf(base_yyout, "%s", (yyvsp[0].str));
		free((yyvsp[0].str));
		output_line_number();
	}
#line 32183 "preproc.c" /* yacc.c:1652  */
    break;

  case 145:
#line 1968 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in VAR statement");

		output_simple_statement((yyvsp[0].str));
	}
#line 32194 "preproc.c" /* yacc.c:1652  */
    break;

  case 146:
#line 1975 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in WHENEVER statement");

		output_simple_statement((yyvsp[0].str));
	}
#line 32205 "preproc.c" /* yacc.c:1652  */
    break;

  case 147:
#line 1982 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = NULL; }
#line 32211 "preproc.c" /* yacc.c:1652  */
    break;

  case 148:
#line 1988 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32219 "preproc.c" /* yacc.c:1652  */
    break;

  case 149:
#line 1996 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with");
}
#line 32227 "preproc.c" /* yacc.c:1652  */
    break;

  case 150:
#line 2000 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with");
}
#line 32235 "preproc.c" /* yacc.c:1652  */
    break;

  case 151:
#line 2004 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 32242 "preproc.c" /* yacc.c:1652  */
    break;

  case 152:
#line 2011 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32250 "preproc.c" /* yacc.c:1652  */
    break;

  case 153:
#line 2015 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 32257 "preproc.c" /* yacc.c:1652  */
    break;

  case 154:
#line 2022 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32265 "preproc.c" /* yacc.c:1652  */
    break;

  case 155:
#line 2026 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 32272 "preproc.c" /* yacc.c:1652  */
    break;

  case 156:
#line 2033 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("password"),(yyvsp[0].str));
}
#line 32280 "preproc.c" /* yacc.c:1652  */
    break;

  case 157:
#line 2037 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("password null");
}
#line 32288 "preproc.c" /* yacc.c:1652  */
    break;

  case 158:
#line 2041 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("encrypted password"),(yyvsp[0].str));
}
#line 32296 "preproc.c" /* yacc.c:1652  */
    break;

  case 159:
#line 2045 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("unencrypted password"),(yyvsp[0].str));
}
#line 32304 "preproc.c" /* yacc.c:1652  */
    break;

  case 160:
#line 2049 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inherit");
}
#line 32312 "preproc.c" /* yacc.c:1652  */
    break;

  case 161:
#line 2053 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("connection limit"),(yyvsp[0].str));
}
#line 32320 "preproc.c" /* yacc.c:1652  */
    break;

  case 162:
#line 2057 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("valid until"),(yyvsp[0].str));
}
#line 32328 "preproc.c" /* yacc.c:1652  */
    break;

  case 163:
#line 2061 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("user"),(yyvsp[0].str));
}
#line 32336 "preproc.c" /* yacc.c:1652  */
    break;

  case 164:
#line 2065 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32344 "preproc.c" /* yacc.c:1652  */
    break;

  case 165:
#line 2073 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32352 "preproc.c" /* yacc.c:1652  */
    break;

  case 166:
#line 2077 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("sysid"),(yyvsp[0].str));
}
#line 32360 "preproc.c" /* yacc.c:1652  */
    break;

  case 167:
#line 2081 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("admin"),(yyvsp[0].str));
}
#line 32368 "preproc.c" /* yacc.c:1652  */
    break;

  case 168:
#line 2085 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("role"),(yyvsp[0].str));
}
#line 32376 "preproc.c" /* yacc.c:1652  */
    break;

  case 169:
#line 2089 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("in role"),(yyvsp[0].str));
}
#line 32384 "preproc.c" /* yacc.c:1652  */
    break;

  case 170:
#line 2093 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("in group"),(yyvsp[0].str));
}
#line 32392 "preproc.c" /* yacc.c:1652  */
    break;

  case 171:
#line 2101 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32400 "preproc.c" /* yacc.c:1652  */
    break;

  case 172:
#line 2109 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32408 "preproc.c" /* yacc.c:1652  */
    break;

  case 173:
#line 2117 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 32415 "preproc.c" /* yacc.c:1652  */
    break;

  case 174:
#line 2120 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("in database"),(yyvsp[0].str));
}
#line 32423 "preproc.c" /* yacc.c:1652  */
    break;

  case 175:
#line 2128 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32431 "preproc.c" /* yacc.c:1652  */
    break;

  case 176:
#line 2132 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter role all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32439 "preproc.c" /* yacc.c:1652  */
    break;

  case 177:
#line 2140 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32447 "preproc.c" /* yacc.c:1652  */
    break;

  case 178:
#line 2148 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32455 "preproc.c" /* yacc.c:1652  */
    break;

  case 179:
#line 2152 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter user all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32463 "preproc.c" /* yacc.c:1652  */
    break;

  case 180:
#line 2160 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop role"),(yyvsp[0].str));
}
#line 32471 "preproc.c" /* yacc.c:1652  */
    break;

  case 181:
#line 2164 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop role if exists"),(yyvsp[0].str));
}
#line 32479 "preproc.c" /* yacc.c:1652  */
    break;

  case 182:
#line 2172 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop user"),(yyvsp[0].str));
}
#line 32487 "preproc.c" /* yacc.c:1652  */
    break;

  case 183:
#line 2176 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop user if exists"),(yyvsp[0].str));
}
#line 32495 "preproc.c" /* yacc.c:1652  */
    break;

  case 184:
#line 2184 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create group"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32503 "preproc.c" /* yacc.c:1652  */
    break;

  case 185:
#line 2192 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter group"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("user"),(yyvsp[0].str));
}
#line 32511 "preproc.c" /* yacc.c:1652  */
    break;

  case 186:
#line 2200 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("add");
}
#line 32519 "preproc.c" /* yacc.c:1652  */
    break;

  case 187:
#line 2204 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("drop");
}
#line 32527 "preproc.c" /* yacc.c:1652  */
    break;

  case 188:
#line 2212 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop group"),(yyvsp[0].str));
}
#line 32535 "preproc.c" /* yacc.c:1652  */
    break;

  case 189:
#line 2216 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop group if exists"),(yyvsp[0].str));
}
#line 32543 "preproc.c" /* yacc.c:1652  */
    break;

  case 190:
#line 2224 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create schema"),(yyvsp[-3].str),mm_strdup("authorization"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32551 "preproc.c" /* yacc.c:1652  */
    break;

  case 191:
#line 2228 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create schema"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32559 "preproc.c" /* yacc.c:1652  */
    break;

  case 192:
#line 2232 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(5,mm_strdup("create schema if not exists"),(yyvsp[-3].str),mm_strdup("authorization"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32568 "preproc.c" /* yacc.c:1652  */
    break;

  case 193:
#line 2237 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(3,mm_strdup("create schema if not exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32577 "preproc.c" /* yacc.c:1652  */
    break;

  case 194:
#line 2246 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32585 "preproc.c" /* yacc.c:1652  */
    break;

  case 195:
#line 2250 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 32592 "preproc.c" /* yacc.c:1652  */
    break;

  case 196:
#line 2257 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32600 "preproc.c" /* yacc.c:1652  */
    break;

  case 197:
#line 2261 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 32607 "preproc.c" /* yacc.c:1652  */
    break;

  case 198:
#line 2268 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32615 "preproc.c" /* yacc.c:1652  */
    break;

  case 199:
#line 2272 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32623 "preproc.c" /* yacc.c:1652  */
    break;

  case 200:
#line 2276 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32631 "preproc.c" /* yacc.c:1652  */
    break;

  case 201:
#line 2280 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32639 "preproc.c" /* yacc.c:1652  */
    break;

  case 202:
#line 2284 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32647 "preproc.c" /* yacc.c:1652  */
    break;

  case 203:
#line 2288 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32655 "preproc.c" /* yacc.c:1652  */
    break;

  case 204:
#line 2296 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 32663 "preproc.c" /* yacc.c:1652  */
    break;

  case 205:
#line 2300 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set local"),(yyvsp[0].str));
}
#line 32671 "preproc.c" /* yacc.c:1652  */
    break;

  case 206:
#line 2304 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set session"),(yyvsp[0].str));
}
#line 32679 "preproc.c" /* yacc.c:1652  */
    break;

  case 207:
#line 2312 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("transaction"),(yyvsp[0].str));
}
#line 32687 "preproc.c" /* yacc.c:1652  */
    break;

  case 208:
#line 2316 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("session characteristics as transaction"),(yyvsp[0].str));
}
#line 32695 "preproc.c" /* yacc.c:1652  */
    break;

  case 209:
#line 2320 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32703 "preproc.c" /* yacc.c:1652  */
    break;

  case 210:
#line 2328 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 32711 "preproc.c" /* yacc.c:1652  */
    break;

  case 211:
#line 2332 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 32719 "preproc.c" /* yacc.c:1652  */
    break;

  case 212:
#line 2336 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("to default"));
}
#line 32727 "preproc.c" /* yacc.c:1652  */
    break;

  case 213:
#line 2340 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("= default"));
}
#line 32735 "preproc.c" /* yacc.c:1652  */
    break;

  case 214:
#line 2348 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32743 "preproc.c" /* yacc.c:1652  */
    break;

  case 215:
#line 2352 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("from current"));
}
#line 32751 "preproc.c" /* yacc.c:1652  */
    break;

  case 216:
#line 2356 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("time zone"),(yyvsp[0].str));
}
#line 32759 "preproc.c" /* yacc.c:1652  */
    break;

  case 217:
#line 2360 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("catalog"),(yyvsp[0].str));
}
#line 32768 "preproc.c" /* yacc.c:1652  */
    break;

  case 218:
#line 2365 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 32776 "preproc.c" /* yacc.c:1652  */
    break;

  case 219:
#line 2369 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("names"),(yyvsp[0].str));
}
#line 32784 "preproc.c" /* yacc.c:1652  */
    break;

  case 220:
#line 2373 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("role"),(yyvsp[0].str));
}
#line 32792 "preproc.c" /* yacc.c:1652  */
    break;

  case 221:
#line 2377 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("session authorization"),(yyvsp[0].str));
}
#line 32800 "preproc.c" /* yacc.c:1652  */
    break;

  case 222:
#line 2381 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session authorization default");
}
#line 32808 "preproc.c" /* yacc.c:1652  */
    break;

  case 223:
#line 2385 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("xml option"),(yyvsp[0].str));
}
#line 32816 "preproc.c" /* yacc.c:1652  */
    break;

  case 224:
#line 2389 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("transaction snapshot"),(yyvsp[0].str));
}
#line 32824 "preproc.c" /* yacc.c:1652  */
    break;

  case 225:
#line 2397 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32832 "preproc.c" /* yacc.c:1652  */
    break;

  case 226:
#line 2401 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 32840 "preproc.c" /* yacc.c:1652  */
    break;

  case 227:
#line 2409 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32848 "preproc.c" /* yacc.c:1652  */
    break;

  case 228:
#line 2413 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 32856 "preproc.c" /* yacc.c:1652  */
    break;

  case 229:
#line 2421 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32864 "preproc.c" /* yacc.c:1652  */
    break;

  case 230:
#line 2425 "preproc.y" /* yacc.c:1652  */
    { 
		if ((yyvsp[0].str)[0] == '$')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = (yyvsp[0].str);
}
#line 32878 "preproc.c" /* yacc.c:1652  */
    break;

  case 231:
#line 2439 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("read uncommitted");
}
#line 32886 "preproc.c" /* yacc.c:1652  */
    break;

  case 232:
#line 2443 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("read committed");
}
#line 32894 "preproc.c" /* yacc.c:1652  */
    break;

  case 233:
#line 2447 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("repeatable read");
}
#line 32902 "preproc.c" /* yacc.c:1652  */
    break;

  case 234:
#line 2451 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("serializable");
}
#line 32910 "preproc.c" /* yacc.c:1652  */
    break;

  case 235:
#line 2459 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("true");
}
#line 32918 "preproc.c" /* yacc.c:1652  */
    break;

  case 236:
#line 2463 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("false");
}
#line 32926 "preproc.c" /* yacc.c:1652  */
    break;

  case 237:
#line 2467 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("on");
}
#line 32934 "preproc.c" /* yacc.c:1652  */
    break;

  case 238:
#line 2471 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32942 "preproc.c" /* yacc.c:1652  */
    break;

  case 239:
#line 2479 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32950 "preproc.c" /* yacc.c:1652  */
    break;

  case 240:
#line 2483 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32958 "preproc.c" /* yacc.c:1652  */
    break;

  case 241:
#line 2487 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 32966 "preproc.c" /* yacc.c:1652  */
    break;

  case 242:
#line 2491 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 32974 "preproc.c" /* yacc.c:1652  */
    break;

  case 243:
#line 2495 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 32982 "preproc.c" /* yacc.c:1652  */
    break;

  case 244:
#line 2499 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 32990 "preproc.c" /* yacc.c:1652  */
    break;

  case 245:
#line 2503 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("local");
}
#line 32998 "preproc.c" /* yacc.c:1652  */
    break;

  case 246:
#line 2511 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33006 "preproc.c" /* yacc.c:1652  */
    break;

  case 247:
#line 2515 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 33014 "preproc.c" /* yacc.c:1652  */
    break;

  case 248:
#line 2519 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 33021 "preproc.c" /* yacc.c:1652  */
    break;

  case 249:
#line 2526 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33029 "preproc.c" /* yacc.c:1652  */
    break;

  case 250:
#line 2530 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33037 "preproc.c" /* yacc.c:1652  */
    break;

  case 251:
#line 2538 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("reset"),(yyvsp[0].str));
}
#line 33045 "preproc.c" /* yacc.c:1652  */
    break;

  case 252:
#line 2546 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33053 "preproc.c" /* yacc.c:1652  */
    break;

  case 253:
#line 2550 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("time zone");
}
#line 33061 "preproc.c" /* yacc.c:1652  */
    break;

  case 254:
#line 2554 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("transaction isolation level");
}
#line 33069 "preproc.c" /* yacc.c:1652  */
    break;

  case 255:
#line 2558 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session authorization");
}
#line 33077 "preproc.c" /* yacc.c:1652  */
    break;

  case 256:
#line 2566 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33085 "preproc.c" /* yacc.c:1652  */
    break;

  case 257:
#line 2570 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 33093 "preproc.c" /* yacc.c:1652  */
    break;

  case 258:
#line 2578 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 33101 "preproc.c" /* yacc.c:1652  */
    break;

  case 259:
#line 2582 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33109 "preproc.c" /* yacc.c:1652  */
    break;

  case 260:
#line 2590 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 33117 "preproc.c" /* yacc.c:1652  */
    break;

  case 261:
#line 2594 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33125 "preproc.c" /* yacc.c:1652  */
    break;

  case 262:
#line 2602 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("show"),(yyvsp[-1].str));
}
#line 33133 "preproc.c" /* yacc.c:1652  */
    break;

  case 263:
#line 2606 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("show time zone");
}
#line 33141 "preproc.c" /* yacc.c:1652  */
    break;

  case 264:
#line 2610 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("show transaction isolation level");
}
#line 33149 "preproc.c" /* yacc.c:1652  */
    break;

  case 265:
#line 2614 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("show session authorization");
}
#line 33157 "preproc.c" /* yacc.c:1652  */
    break;

  case 266:
#line 2618 "preproc.y" /* yacc.c:1652  */
    {
		mmerror(PARSE_ERROR, ET_ERROR, "SHOW ALL is not implemented");
		(yyval.str) = EMPTY;
	}
#line 33166 "preproc.c" /* yacc.c:1652  */
    break;

  case 267:
#line 2627 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("set constraints"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33174 "preproc.c" /* yacc.c:1652  */
    break;

  case 268:
#line 2635 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 33182 "preproc.c" /* yacc.c:1652  */
    break;

  case 269:
#line 2639 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33190 "preproc.c" /* yacc.c:1652  */
    break;

  case 270:
#line 2647 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferred");
}
#line 33198 "preproc.c" /* yacc.c:1652  */
    break;

  case 271:
#line 2651 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("immediate");
}
#line 33206 "preproc.c" /* yacc.c:1652  */
    break;

  case 272:
#line 2659 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("checkpoint");
}
#line 33214 "preproc.c" /* yacc.c:1652  */
    break;

  case 273:
#line 2667 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard all");
}
#line 33222 "preproc.c" /* yacc.c:1652  */
    break;

  case 274:
#line 2671 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard temp");
}
#line 33230 "preproc.c" /* yacc.c:1652  */
    break;

  case 275:
#line 2675 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard temporary");
}
#line 33238 "preproc.c" /* yacc.c:1652  */
    break;

  case 276:
#line 2679 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard plans");
}
#line 33246 "preproc.c" /* yacc.c:1652  */
    break;

  case 277:
#line 2683 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard sequences");
}
#line 33254 "preproc.c" /* yacc.c:1652  */
    break;

  case 278:
#line 2691 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33262 "preproc.c" /* yacc.c:1652  */
    break;

  case 279:
#line 2695 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter table if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33270 "preproc.c" /* yacc.c:1652  */
    break;

  case 280:
#line 2699 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter table all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33278 "preproc.c" /* yacc.c:1652  */
    break;

  case 281:
#line 2703 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter table all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33286 "preproc.c" /* yacc.c:1652  */
    break;

  case 282:
#line 2707 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter index"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33294 "preproc.c" /* yacc.c:1652  */
    break;

  case 283:
#line 2711 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter index if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33302 "preproc.c" /* yacc.c:1652  */
    break;

  case 284:
#line 2715 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter index all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33310 "preproc.c" /* yacc.c:1652  */
    break;

  case 285:
#line 2719 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter index all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33318 "preproc.c" /* yacc.c:1652  */
    break;

  case 286:
#line 2723 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33326 "preproc.c" /* yacc.c:1652  */
    break;

  case 287:
#line 2727 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33334 "preproc.c" /* yacc.c:1652  */
    break;

  case 288:
#line 2731 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter view"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33342 "preproc.c" /* yacc.c:1652  */
    break;

  case 289:
#line 2735 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter view if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33350 "preproc.c" /* yacc.c:1652  */
    break;

  case 290:
#line 2739 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter materialized view"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33358 "preproc.c" /* yacc.c:1652  */
    break;

  case 291:
#line 2743 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter materialized view if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33366 "preproc.c" /* yacc.c:1652  */
    break;

  case 292:
#line 2747 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter materialized view all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33374 "preproc.c" /* yacc.c:1652  */
    break;

  case 293:
#line 2751 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33382 "preproc.c" /* yacc.c:1652  */
    break;

  case 294:
#line 2759 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33390 "preproc.c" /* yacc.c:1652  */
    break;

  case 295:
#line 2763 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 33398 "preproc.c" /* yacc.c:1652  */
    break;

  case 296:
#line 2771 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 33406 "preproc.c" /* yacc.c:1652  */
    break;

  case 297:
#line 2775 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add if not exists"),(yyvsp[0].str));
}
#line 33414 "preproc.c" /* yacc.c:1652  */
    break;

  case 298:
#line 2779 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add column"),(yyvsp[0].str));
}
#line 33422 "preproc.c" /* yacc.c:1652  */
    break;

  case 299:
#line 2783 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add column if not exists"),(yyvsp[0].str));
}
#line 33430 "preproc.c" /* yacc.c:1652  */
    break;

  case 300:
#line 2787 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33438 "preproc.c" /* yacc.c:1652  */
    break;

  case 301:
#line 2791 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("drop not null"));
}
#line 33446 "preproc.c" /* yacc.c:1652  */
    break;

  case 302:
#line 2795 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set not null"));
}
#line 33454 "preproc.c" /* yacc.c:1652  */
    break;

  case 303:
#line 2799 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set statistics"),(yyvsp[0].str));
}
#line 33462 "preproc.c" /* yacc.c:1652  */
    break;

  case 304:
#line 2803 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 33470 "preproc.c" /* yacc.c:1652  */
    break;

  case 305:
#line 2807 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("reset"),(yyvsp[0].str));
}
#line 33478 "preproc.c" /* yacc.c:1652  */
    break;

  case 306:
#line 2811 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set storage"),(yyvsp[0].str));
}
#line 33486 "preproc.c" /* yacc.c:1652  */
    break;

  case 307:
#line 2815 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-4].str),mm_strdup("if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33494 "preproc.c" /* yacc.c:1652  */
    break;

  case 308:
#line 2819 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33502 "preproc.c" /* yacc.c:1652  */
    break;

  case 309:
#line 2823 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("alter"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("type"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33510 "preproc.c" /* yacc.c:1652  */
    break;

  case 310:
#line 2827 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33518 "preproc.c" /* yacc.c:1652  */
    break;

  case 311:
#line 2831 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 33526 "preproc.c" /* yacc.c:1652  */
    break;

  case 312:
#line 2835 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33534 "preproc.c" /* yacc.c:1652  */
    break;

  case 313:
#line 2839 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("validate constraint"),(yyvsp[0].str));
}
#line 33542 "preproc.c" /* yacc.c:1652  */
    break;

  case 314:
#line 2843 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop constraint if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33550 "preproc.c" /* yacc.c:1652  */
    break;

  case 315:
#line 2847 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33558 "preproc.c" /* yacc.c:1652  */
    break;

  case 316:
#line 2851 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set with oids");
}
#line 33566 "preproc.c" /* yacc.c:1652  */
    break;

  case 317:
#line 2855 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set without oids");
}
#line 33574 "preproc.c" /* yacc.c:1652  */
    break;

  case 318:
#line 2859 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("cluster on"),(yyvsp[0].str));
}
#line 33582 "preproc.c" /* yacc.c:1652  */
    break;

  case 319:
#line 2863 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set without cluster");
}
#line 33590 "preproc.c" /* yacc.c:1652  */
    break;

  case 320:
#line 2867 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set logged");
}
#line 33598 "preproc.c" /* yacc.c:1652  */
    break;

  case 321:
#line 2871 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set unlogged");
}
#line 33606 "preproc.c" /* yacc.c:1652  */
    break;

  case 322:
#line 2875 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable trigger"),(yyvsp[0].str));
}
#line 33614 "preproc.c" /* yacc.c:1652  */
    break;

  case 323:
#line 2879 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable always trigger"),(yyvsp[0].str));
}
#line 33622 "preproc.c" /* yacc.c:1652  */
    break;

  case 324:
#line 2883 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable replica trigger"),(yyvsp[0].str));
}
#line 33630 "preproc.c" /* yacc.c:1652  */
    break;

  case 325:
#line 2887 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable trigger all");
}
#line 33638 "preproc.c" /* yacc.c:1652  */
    break;

  case 326:
#line 2891 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable trigger user");
}
#line 33646 "preproc.c" /* yacc.c:1652  */
    break;

  case 327:
#line 2895 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("disable trigger"),(yyvsp[0].str));
}
#line 33654 "preproc.c" /* yacc.c:1652  */
    break;

  case 328:
#line 2899 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("disable trigger all");
}
#line 33662 "preproc.c" /* yacc.c:1652  */
    break;

  case 329:
#line 2903 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("disable trigger user");
}
#line 33670 "preproc.c" /* yacc.c:1652  */
    break;

  case 330:
#line 2907 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable rule"),(yyvsp[0].str));
}
#line 33678 "preproc.c" /* yacc.c:1652  */
    break;

  case 331:
#line 2911 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable always rule"),(yyvsp[0].str));
}
#line 33686 "preproc.c" /* yacc.c:1652  */
    break;

  case 332:
#line 2915 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable replica rule"),(yyvsp[0].str));
}
#line 33694 "preproc.c" /* yacc.c:1652  */
    break;

  case 333:
#line 2919 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("disable rule"),(yyvsp[0].str));
}
#line 33702 "preproc.c" /* yacc.c:1652  */
    break;

  case 334:
#line 2923 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("inherit"),(yyvsp[0].str));
}
#line 33710 "preproc.c" /* yacc.c:1652  */
    break;

  case 335:
#line 2927 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("no inherit"),(yyvsp[0].str));
}
#line 33718 "preproc.c" /* yacc.c:1652  */
    break;

  case 336:
#line 2931 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("of"),(yyvsp[0].str));
}
#line 33726 "preproc.c" /* yacc.c:1652  */
    break;

  case 337:
#line 2935 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not of");
}
#line 33734 "preproc.c" /* yacc.c:1652  */
    break;

  case 338:
#line 2939 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("owner to"),(yyvsp[0].str));
}
#line 33742 "preproc.c" /* yacc.c:1652  */
    break;

  case 339:
#line 2943 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set tablespace"),(yyvsp[0].str));
}
#line 33750 "preproc.c" /* yacc.c:1652  */
    break;

  case 340:
#line 2947 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 33758 "preproc.c" /* yacc.c:1652  */
    break;

  case 341:
#line 2951 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("reset"),(yyvsp[0].str));
}
#line 33766 "preproc.c" /* yacc.c:1652  */
    break;

  case 342:
#line 2955 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("replica identity"),(yyvsp[0].str));
}
#line 33774 "preproc.c" /* yacc.c:1652  */
    break;

  case 343:
#line 2959 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable row level security");
}
#line 33782 "preproc.c" /* yacc.c:1652  */
    break;

  case 344:
#line 2963 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("disable row level security");
}
#line 33790 "preproc.c" /* yacc.c:1652  */
    break;

  case 345:
#line 2967 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("force row level security");
}
#line 33798 "preproc.c" /* yacc.c:1652  */
    break;

  case 346:
#line 2971 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no force row level security");
}
#line 33806 "preproc.c" /* yacc.c:1652  */
    break;

  case 347:
#line 2975 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33814 "preproc.c" /* yacc.c:1652  */
    break;

  case 348:
#line 2983 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set default"),(yyvsp[0].str));
}
#line 33822 "preproc.c" /* yacc.c:1652  */
    break;

  case 349:
#line 2987 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("drop default");
}
#line 33830 "preproc.c" /* yacc.c:1652  */
    break;

  case 350:
#line 2995 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cascade");
}
#line 33838 "preproc.c" /* yacc.c:1652  */
    break;

  case 351:
#line 2999 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restrict");
}
#line 33846 "preproc.c" /* yacc.c:1652  */
    break;

  case 352:
#line 3003 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 33853 "preproc.c" /* yacc.c:1652  */
    break;

  case 353:
#line 3010 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 33861 "preproc.c" /* yacc.c:1652  */
    break;

  case 354:
#line 3014 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 33868 "preproc.c" /* yacc.c:1652  */
    break;

  case 355:
#line 3021 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 33876 "preproc.c" /* yacc.c:1652  */
    break;

  case 356:
#line 3025 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 33883 "preproc.c" /* yacc.c:1652  */
    break;

  case 357:
#line 3032 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nothing");
}
#line 33891 "preproc.c" /* yacc.c:1652  */
    break;

  case 358:
#line 3036 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("full");
}
#line 33899 "preproc.c" /* yacc.c:1652  */
    break;

  case 359:
#line 3040 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 33907 "preproc.c" /* yacc.c:1652  */
    break;

  case 360:
#line 3044 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using index"),(yyvsp[0].str));
}
#line 33915 "preproc.c" /* yacc.c:1652  */
    break;

  case 361:
#line 3052 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 33923 "preproc.c" /* yacc.c:1652  */
    break;

  case 362:
#line 3060 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 33931 "preproc.c" /* yacc.c:1652  */
    break;

  case 363:
#line 3064 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 33938 "preproc.c" /* yacc.c:1652  */
    break;

  case 364:
#line 3071 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33946 "preproc.c" /* yacc.c:1652  */
    break;

  case 365:
#line 3075 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 33954 "preproc.c" /* yacc.c:1652  */
    break;

  case 366:
#line 3083 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 33962 "preproc.c" /* yacc.c:1652  */
    break;

  case 367:
#line 3087 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 33970 "preproc.c" /* yacc.c:1652  */
    break;

  case 368:
#line 3091 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("."),(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 33978 "preproc.c" /* yacc.c:1652  */
    break;

  case 369:
#line 3095 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 33986 "preproc.c" /* yacc.c:1652  */
    break;

  case 370:
#line 3103 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 33994 "preproc.c" /* yacc.c:1652  */
    break;

  case 371:
#line 3111 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34002 "preproc.c" /* yacc.c:1652  */
    break;

  case 372:
#line 3115 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 34010 "preproc.c" /* yacc.c:1652  */
    break;

  case 373:
#line 3123 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("add attribute"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34018 "preproc.c" /* yacc.c:1652  */
    break;

  case 374:
#line 3127 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop attribute if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34026 "preproc.c" /* yacc.c:1652  */
    break;

  case 375:
#line 3131 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop attribute"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34034 "preproc.c" /* yacc.c:1652  */
    break;

  case 376:
#line 3135 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter attribute"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("type"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34042 "preproc.c" /* yacc.c:1652  */
    break;

  case 377:
#line 3143 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		(yyval.str) = cat2_str(mm_strdup("close"), cursor_marker);
	}
#line 34051 "preproc.c" /* yacc.c:1652  */
    break;

  case 378:
#line 3148 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("close all");
}
#line 34059 "preproc.c" /* yacc.c:1652  */
    break;

  case 379:
#line 3156 "preproc.y" /* yacc.c:1652  */
    { 
			if (strcmp((yyvsp[-5].str), "from") == 0 &&
			   (strcmp((yyvsp[-4].str), "stdin") == 0 || strcmp((yyvsp[-4].str), "stdout") == 0))
				mmerror(PARSE_ERROR, ET_WARNING, "COPY FROM STDIN is not implemented");

 (yyval.str) = cat_str(11,mm_strdup("copy"),(yyvsp[-9].str),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34071 "preproc.c" /* yacc.c:1652  */
    break;

  case 380:
#line 3164 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("copy ("),(yyvsp[-6].str),mm_strdup(") to"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34079 "preproc.c" /* yacc.c:1652  */
    break;

  case 381:
#line 3172 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("from");
}
#line 34087 "preproc.c" /* yacc.c:1652  */
    break;

  case 382:
#line 3176 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("to");
}
#line 34095 "preproc.c" /* yacc.c:1652  */
    break;

  case 383:
#line 3184 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("program");
}
#line 34103 "preproc.c" /* yacc.c:1652  */
    break;

  case 384:
#line 3188 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34110 "preproc.c" /* yacc.c:1652  */
    break;

  case 385:
#line 3195 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34118 "preproc.c" /* yacc.c:1652  */
    break;

  case 386:
#line 3199 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stdin");
}
#line 34126 "preproc.c" /* yacc.c:1652  */
    break;

  case 387:
#line 3203 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stdout");
}
#line 34134 "preproc.c" /* yacc.c:1652  */
    break;

  case 388:
#line 3211 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34142 "preproc.c" /* yacc.c:1652  */
    break;

  case 389:
#line 3215 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 34150 "preproc.c" /* yacc.c:1652  */
    break;

  case 390:
#line 3223 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34158 "preproc.c" /* yacc.c:1652  */
    break;

  case 391:
#line 3227 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34165 "preproc.c" /* yacc.c:1652  */
    break;

  case 392:
#line 3234 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("binary");
}
#line 34173 "preproc.c" /* yacc.c:1652  */
    break;

  case 393:
#line 3238 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("oids");
}
#line 34181 "preproc.c" /* yacc.c:1652  */
    break;

  case 394:
#line 3242 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("freeze");
}
#line 34189 "preproc.c" /* yacc.c:1652  */
    break;

  case 395:
#line 3246 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("delimiter"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34197 "preproc.c" /* yacc.c:1652  */
    break;

  case 396:
#line 3250 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("null"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34205 "preproc.c" /* yacc.c:1652  */
    break;

  case 397:
#line 3254 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("csv");
}
#line 34213 "preproc.c" /* yacc.c:1652  */
    break;

  case 398:
#line 3258 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("header");
}
#line 34221 "preproc.c" /* yacc.c:1652  */
    break;

  case 399:
#line 3262 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("quote"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34229 "preproc.c" /* yacc.c:1652  */
    break;

  case 400:
#line 3266 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("escape"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34237 "preproc.c" /* yacc.c:1652  */
    break;

  case 401:
#line 3270 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("force quote"),(yyvsp[0].str));
}
#line 34245 "preproc.c" /* yacc.c:1652  */
    break;

  case 402:
#line 3274 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("force quote *");
}
#line 34253 "preproc.c" /* yacc.c:1652  */
    break;

  case 403:
#line 3278 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("force not null"),(yyvsp[0].str));
}
#line 34261 "preproc.c" /* yacc.c:1652  */
    break;

  case 404:
#line 3282 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("force null"),(yyvsp[0].str));
}
#line 34269 "preproc.c" /* yacc.c:1652  */
    break;

  case 405:
#line 3286 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("encoding"),(yyvsp[0].str));
}
#line 34277 "preproc.c" /* yacc.c:1652  */
    break;

  case 406:
#line 3294 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("binary");
}
#line 34285 "preproc.c" /* yacc.c:1652  */
    break;

  case 407:
#line 3298 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34292 "preproc.c" /* yacc.c:1652  */
    break;

  case 408:
#line 3305 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with oids");
}
#line 34300 "preproc.c" /* yacc.c:1652  */
    break;

  case 409:
#line 3309 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34307 "preproc.c" /* yacc.c:1652  */
    break;

  case 410:
#line 3316 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("delimiters"),(yyvsp[0].str));
}
#line 34315 "preproc.c" /* yacc.c:1652  */
    break;

  case 411:
#line 3320 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34322 "preproc.c" /* yacc.c:1652  */
    break;

  case 412:
#line 3327 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("using");
}
#line 34330 "preproc.c" /* yacc.c:1652  */
    break;

  case 413:
#line 3331 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34337 "preproc.c" /* yacc.c:1652  */
    break;

  case 414:
#line 3338 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34345 "preproc.c" /* yacc.c:1652  */
    break;

  case 415:
#line 3342 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 34353 "preproc.c" /* yacc.c:1652  */
    break;

  case 416:
#line 3350 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34361 "preproc.c" /* yacc.c:1652  */
    break;

  case 417:
#line 3358 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34369 "preproc.c" /* yacc.c:1652  */
    break;

  case 418:
#line 3362 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34377 "preproc.c" /* yacc.c:1652  */
    break;

  case 419:
#line 3366 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("*");
}
#line 34385 "preproc.c" /* yacc.c:1652  */
    break;

  case 420:
#line 3370 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 34393 "preproc.c" /* yacc.c:1652  */
    break;

  case 421:
#line 3374 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34400 "preproc.c" /* yacc.c:1652  */
    break;

  case 422:
#line 3381 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34408 "preproc.c" /* yacc.c:1652  */
    break;

  case 423:
#line 3385 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 34416 "preproc.c" /* yacc.c:1652  */
    break;

  case 424:
#line 3393 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34424 "preproc.c" /* yacc.c:1652  */
    break;

  case 425:
#line 3401 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(11,mm_strdup("create"),(yyvsp[-9].str),mm_strdup("table"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34432 "preproc.c" /* yacc.c:1652  */
    break;

  case 426:
#line 3405 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(11,mm_strdup("create"),(yyvsp[-12].str),mm_strdup("table if not exists"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34440 "preproc.c" /* yacc.c:1652  */
    break;

  case 427:
#line 3409 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-8].str),mm_strdup("table"),(yyvsp[-6].str),mm_strdup("of"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34448 "preproc.c" /* yacc.c:1652  */
    break;

  case 428:
#line 3413 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-11].str),mm_strdup("table if not exists"),(yyvsp[-6].str),mm_strdup("of"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34456 "preproc.c" /* yacc.c:1652  */
    break;

  case 429:
#line 3421 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("temporary");
}
#line 34464 "preproc.c" /* yacc.c:1652  */
    break;

  case 430:
#line 3425 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("temp");
}
#line 34472 "preproc.c" /* yacc.c:1652  */
    break;

  case 431:
#line 3429 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("local temporary");
}
#line 34480 "preproc.c" /* yacc.c:1652  */
    break;

  case 432:
#line 3433 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("local temp");
}
#line 34488 "preproc.c" /* yacc.c:1652  */
    break;

  case 433:
#line 3437 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("global temporary");
}
#line 34496 "preproc.c" /* yacc.c:1652  */
    break;

  case 434:
#line 3441 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("global temp");
}
#line 34504 "preproc.c" /* yacc.c:1652  */
    break;

  case 435:
#line 3445 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 34512 "preproc.c" /* yacc.c:1652  */
    break;

  case 436:
#line 3449 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34519 "preproc.c" /* yacc.c:1652  */
    break;

  case 437:
#line 3456 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34527 "preproc.c" /* yacc.c:1652  */
    break;

  case 438:
#line 3460 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34534 "preproc.c" /* yacc.c:1652  */
    break;

  case 439:
#line 3467 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 34542 "preproc.c" /* yacc.c:1652  */
    break;

  case 440:
#line 3471 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34549 "preproc.c" /* yacc.c:1652  */
    break;

  case 441:
#line 3478 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34557 "preproc.c" /* yacc.c:1652  */
    break;

  case 442:
#line 3482 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 34565 "preproc.c" /* yacc.c:1652  */
    break;

  case 443:
#line 3490 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34573 "preproc.c" /* yacc.c:1652  */
    break;

  case 444:
#line 3494 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 34581 "preproc.c" /* yacc.c:1652  */
    break;

  case 445:
#line 3502 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34589 "preproc.c" /* yacc.c:1652  */
    break;

  case 446:
#line 3506 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34597 "preproc.c" /* yacc.c:1652  */
    break;

  case 447:
#line 3510 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34605 "preproc.c" /* yacc.c:1652  */
    break;

  case 448:
#line 3518 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34613 "preproc.c" /* yacc.c:1652  */
    break;

  case 449:
#line 3522 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34621 "preproc.c" /* yacc.c:1652  */
    break;

  case 450:
#line 3530 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34629 "preproc.c" /* yacc.c:1652  */
    break;

  case 451:
#line 3538 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("with options"),(yyvsp[0].str));
}
#line 34637 "preproc.c" /* yacc.c:1652  */
    break;

  case 452:
#line 3546 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34645 "preproc.c" /* yacc.c:1652  */
    break;

  case 453:
#line 3550 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34652 "preproc.c" /* yacc.c:1652  */
    break;

  case 454:
#line 3557 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34660 "preproc.c" /* yacc.c:1652  */
    break;

  case 455:
#line 3561 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34668 "preproc.c" /* yacc.c:1652  */
    break;

  case 456:
#line 3565 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34676 "preproc.c" /* yacc.c:1652  */
    break;

  case 457:
#line 3569 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 34684 "preproc.c" /* yacc.c:1652  */
    break;

  case 458:
#line 3577 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not null");
}
#line 34692 "preproc.c" /* yacc.c:1652  */
    break;

  case 459:
#line 3581 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 34700 "preproc.c" /* yacc.c:1652  */
    break;

  case 460:
#line 3585 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("unique"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34708 "preproc.c" /* yacc.c:1652  */
    break;

  case 461:
#line 3589 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("primary key"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34716 "preproc.c" /* yacc.c:1652  */
    break;

  case 462:
#line 3593 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 34724 "preproc.c" /* yacc.c:1652  */
    break;

  case 463:
#line 3597 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("default"),(yyvsp[0].str));
}
#line 34732 "preproc.c" /* yacc.c:1652  */
    break;

  case 464:
#line 3601 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("references"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34740 "preproc.c" /* yacc.c:1652  */
    break;

  case 465:
#line 3609 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 34748 "preproc.c" /* yacc.c:1652  */
    break;

  case 466:
#line 3613 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 34756 "preproc.c" /* yacc.c:1652  */
    break;

  case 467:
#line 3617 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("initially deferred");
}
#line 34764 "preproc.c" /* yacc.c:1652  */
    break;

  case 468:
#line 3621 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("initially immediate");
}
#line 34772 "preproc.c" /* yacc.c:1652  */
    break;

  case 469:
#line 3629 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("like"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34780 "preproc.c" /* yacc.c:1652  */
    break;

  case 470:
#line 3637 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("including"),(yyvsp[0].str));
}
#line 34788 "preproc.c" /* yacc.c:1652  */
    break;

  case 471:
#line 3641 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("excluding"),(yyvsp[0].str));
}
#line 34796 "preproc.c" /* yacc.c:1652  */
    break;

  case 472:
#line 3645 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34803 "preproc.c" /* yacc.c:1652  */
    break;

  case 473:
#line 3652 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("defaults");
}
#line 34811 "preproc.c" /* yacc.c:1652  */
    break;

  case 474:
#line 3656 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("constraints");
}
#line 34819 "preproc.c" /* yacc.c:1652  */
    break;

  case 475:
#line 3660 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("indexes");
}
#line 34827 "preproc.c" /* yacc.c:1652  */
    break;

  case 476:
#line 3664 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("storage");
}
#line 34835 "preproc.c" /* yacc.c:1652  */
    break;

  case 477:
#line 3668 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("comments");
}
#line 34843 "preproc.c" /* yacc.c:1652  */
    break;

  case 478:
#line 3672 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 34851 "preproc.c" /* yacc.c:1652  */
    break;

  case 479:
#line 3680 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34859 "preproc.c" /* yacc.c:1652  */
    break;

  case 480:
#line 3684 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34867 "preproc.c" /* yacc.c:1652  */
    break;

  case 481:
#line 3692 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 34875 "preproc.c" /* yacc.c:1652  */
    break;

  case 482:
#line 3696 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("unique ("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34883 "preproc.c" /* yacc.c:1652  */
    break;

  case 483:
#line 3700 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("unique"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34891 "preproc.c" /* yacc.c:1652  */
    break;

  case 484:
#line 3704 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("primary key ("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34899 "preproc.c" /* yacc.c:1652  */
    break;

  case 485:
#line 3708 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("primary key"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34907 "preproc.c" /* yacc.c:1652  */
    break;

  case 486:
#line 3712 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("exclude"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34915 "preproc.c" /* yacc.c:1652  */
    break;

  case 487:
#line 3716 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("foreign key ("),(yyvsp[-7].str),mm_strdup(") references"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 34923 "preproc.c" /* yacc.c:1652  */
    break;

  case 488:
#line 3724 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no inherit");
}
#line 34931 "preproc.c" /* yacc.c:1652  */
    break;

  case 489:
#line 3728 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34938 "preproc.c" /* yacc.c:1652  */
    break;

  case 490:
#line 3735 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 34946 "preproc.c" /* yacc.c:1652  */
    break;

  case 491:
#line 3739 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 34953 "preproc.c" /* yacc.c:1652  */
    break;

  case 492:
#line 3746 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34961 "preproc.c" /* yacc.c:1652  */
    break;

  case 493:
#line 3750 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 34969 "preproc.c" /* yacc.c:1652  */
    break;

  case 494:
#line 3758 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 34977 "preproc.c" /* yacc.c:1652  */
    break;

  case 495:
#line 3766 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("match full");
}
#line 34985 "preproc.c" /* yacc.c:1652  */
    break;

  case 496:
#line 3770 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = mm_strdup("match partial");
}
#line 34994 "preproc.c" /* yacc.c:1652  */
    break;

  case 497:
#line 3775 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("match simple");
}
#line 35002 "preproc.c" /* yacc.c:1652  */
    break;

  case 498:
#line 3779 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35009 "preproc.c" /* yacc.c:1652  */
    break;

  case 499:
#line 3786 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35017 "preproc.c" /* yacc.c:1652  */
    break;

  case 500:
#line 3790 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 35025 "preproc.c" /* yacc.c:1652  */
    break;

  case 501:
#line 3798 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 35033 "preproc.c" /* yacc.c:1652  */
    break;

  case 502:
#line 3802 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("with operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 35041 "preproc.c" /* yacc.c:1652  */
    break;

  case 503:
#line 3810 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("where ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 35049 "preproc.c" /* yacc.c:1652  */
    break;

  case 504:
#line 3814 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35056 "preproc.c" /* yacc.c:1652  */
    break;

  case 505:
#line 3821 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35064 "preproc.c" /* yacc.c:1652  */
    break;

  case 506:
#line 3825 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35072 "preproc.c" /* yacc.c:1652  */
    break;

  case 507:
#line 3829 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35080 "preproc.c" /* yacc.c:1652  */
    break;

  case 508:
#line 3833 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35088 "preproc.c" /* yacc.c:1652  */
    break;

  case 509:
#line 3837 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35095 "preproc.c" /* yacc.c:1652  */
    break;

  case 510:
#line 3844 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("on update"),(yyvsp[0].str));
}
#line 35103 "preproc.c" /* yacc.c:1652  */
    break;

  case 511:
#line 3852 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("on delete"),(yyvsp[0].str));
}
#line 35111 "preproc.c" /* yacc.c:1652  */
    break;

  case 512:
#line 3860 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no action");
}
#line 35119 "preproc.c" /* yacc.c:1652  */
    break;

  case 513:
#line 3864 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restrict");
}
#line 35127 "preproc.c" /* yacc.c:1652  */
    break;

  case 514:
#line 3868 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cascade");
}
#line 35135 "preproc.c" /* yacc.c:1652  */
    break;

  case 515:
#line 3872 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set null");
}
#line 35143 "preproc.c" /* yacc.c:1652  */
    break;

  case 516:
#line 3876 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set default");
}
#line 35151 "preproc.c" /* yacc.c:1652  */
    break;

  case 517:
#line 3884 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("inherits ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 35159 "preproc.c" /* yacc.c:1652  */
    break;

  case 518:
#line 3888 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35166 "preproc.c" /* yacc.c:1652  */
    break;

  case 519:
#line 3895 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 35174 "preproc.c" /* yacc.c:1652  */
    break;

  case 520:
#line 3899 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with oids");
}
#line 35182 "preproc.c" /* yacc.c:1652  */
    break;

  case 521:
#line 3903 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("without oids");
}
#line 35190 "preproc.c" /* yacc.c:1652  */
    break;

  case 522:
#line 3907 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35197 "preproc.c" /* yacc.c:1652  */
    break;

  case 523:
#line 3914 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("on commit drop");
}
#line 35205 "preproc.c" /* yacc.c:1652  */
    break;

  case 524:
#line 3918 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("on commit delete rows");
}
#line 35213 "preproc.c" /* yacc.c:1652  */
    break;

  case 525:
#line 3922 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("on commit preserve rows");
}
#line 35221 "preproc.c" /* yacc.c:1652  */
    break;

  case 526:
#line 3926 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35228 "preproc.c" /* yacc.c:1652  */
    break;

  case 527:
#line 3933 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("tablespace"),(yyvsp[0].str));
}
#line 35236 "preproc.c" /* yacc.c:1652  */
    break;

  case 528:
#line 3937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35243 "preproc.c" /* yacc.c:1652  */
    break;

  case 529:
#line 3944 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using index tablespace"),(yyvsp[0].str));
}
#line 35251 "preproc.c" /* yacc.c:1652  */
    break;

  case 530:
#line 3948 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35258 "preproc.c" /* yacc.c:1652  */
    break;

  case 531:
#line 3955 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using index"),(yyvsp[0].str));
}
#line 35266 "preproc.c" /* yacc.c:1652  */
    break;

  case 532:
#line 3963 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35274 "preproc.c" /* yacc.c:1652  */
    break;

  case 533:
#line 3971 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with data");
}
#line 35282 "preproc.c" /* yacc.c:1652  */
    break;

  case 534:
#line 3975 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with no data");
}
#line 35290 "preproc.c" /* yacc.c:1652  */
    break;

  case 535:
#line 3979 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35297 "preproc.c" /* yacc.c:1652  */
    break;

  case 536:
#line 3986 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create"),(yyvsp[-6].str),mm_strdup("materialized view"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35305 "preproc.c" /* yacc.c:1652  */
    break;

  case 537:
#line 3990 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create"),(yyvsp[-9].str),mm_strdup("materialized view if not exists"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35313 "preproc.c" /* yacc.c:1652  */
    break;

  case 538:
#line 3998 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35321 "preproc.c" /* yacc.c:1652  */
    break;

  case 539:
#line 4006 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 35329 "preproc.c" /* yacc.c:1652  */
    break;

  case 540:
#line 4010 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35336 "preproc.c" /* yacc.c:1652  */
    break;

  case 541:
#line 4017 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("refresh materialized view"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35344 "preproc.c" /* yacc.c:1652  */
    break;

  case 542:
#line 4025 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create"),(yyvsp[-3].str),mm_strdup("sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35352 "preproc.c" /* yacc.c:1652  */
    break;

  case 543:
#line 4029 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create"),(yyvsp[-6].str),mm_strdup("sequence if not exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35360 "preproc.c" /* yacc.c:1652  */
    break;

  case 544:
#line 4037 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35368 "preproc.c" /* yacc.c:1652  */
    break;

  case 545:
#line 4041 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35376 "preproc.c" /* yacc.c:1652  */
    break;

  case 546:
#line 4049 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35384 "preproc.c" /* yacc.c:1652  */
    break;

  case 547:
#line 4053 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35391 "preproc.c" /* yacc.c:1652  */
    break;

  case 548:
#line 4060 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35399 "preproc.c" /* yacc.c:1652  */
    break;

  case 549:
#line 4064 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35407 "preproc.c" /* yacc.c:1652  */
    break;

  case 550:
#line 4072 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("cache"),(yyvsp[0].str));
}
#line 35415 "preproc.c" /* yacc.c:1652  */
    break;

  case 551:
#line 4076 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cycle");
}
#line 35423 "preproc.c" /* yacc.c:1652  */
    break;

  case 552:
#line 4080 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no cycle");
}
#line 35431 "preproc.c" /* yacc.c:1652  */
    break;

  case 553:
#line 4084 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("increment"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35439 "preproc.c" /* yacc.c:1652  */
    break;

  case 554:
#line 4088 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("maxvalue"),(yyvsp[0].str));
}
#line 35447 "preproc.c" /* yacc.c:1652  */
    break;

  case 555:
#line 4092 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("minvalue"),(yyvsp[0].str));
}
#line 35455 "preproc.c" /* yacc.c:1652  */
    break;

  case 556:
#line 4096 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no maxvalue");
}
#line 35463 "preproc.c" /* yacc.c:1652  */
    break;

  case 557:
#line 4100 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no minvalue");
}
#line 35471 "preproc.c" /* yacc.c:1652  */
    break;

  case 558:
#line 4104 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("owned by"),(yyvsp[0].str));
}
#line 35479 "preproc.c" /* yacc.c:1652  */
    break;

  case 559:
#line 4108 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("start"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35487 "preproc.c" /* yacc.c:1652  */
    break;

  case 560:
#line 4112 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restart");
}
#line 35495 "preproc.c" /* yacc.c:1652  */
    break;

  case 561:
#line 4116 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("restart"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35503 "preproc.c" /* yacc.c:1652  */
    break;

  case 562:
#line 4124 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("by");
}
#line 35511 "preproc.c" /* yacc.c:1652  */
    break;

  case 563:
#line 4128 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35518 "preproc.c" /* yacc.c:1652  */
    break;

  case 564:
#line 4135 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35526 "preproc.c" /* yacc.c:1652  */
    break;

  case 565:
#line 4139 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 35534 "preproc.c" /* yacc.c:1652  */
    break;

  case 566:
#line 4143 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 35542 "preproc.c" /* yacc.c:1652  */
    break;

  case 567:
#line 4147 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35550 "preproc.c" /* yacc.c:1652  */
    break;

  case 568:
#line 4155 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35558 "preproc.c" /* yacc.c:1652  */
    break;

  case 569:
#line 4159 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 35566 "preproc.c" /* yacc.c:1652  */
    break;

  case 570:
#line 4167 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 35574 "preproc.c" /* yacc.c:1652  */
    break;

  case 571:
#line 4171 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("language"),(yyvsp[-4].str),mm_strdup("handler"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35582 "preproc.c" /* yacc.c:1652  */
    break;

  case 572:
#line 4179 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trusted");
}
#line 35590 "preproc.c" /* yacc.c:1652  */
    break;

  case 573:
#line 4183 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35597 "preproc.c" /* yacc.c:1652  */
    break;

  case 574:
#line 4190 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35605 "preproc.c" /* yacc.c:1652  */
    break;

  case 575:
#line 4194 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35613 "preproc.c" /* yacc.c:1652  */
    break;

  case 576:
#line 4202 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("inline"),(yyvsp[0].str));
}
#line 35621 "preproc.c" /* yacc.c:1652  */
    break;

  case 577:
#line 4206 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35628 "preproc.c" /* yacc.c:1652  */
    break;

  case 578:
#line 4213 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("validator"),(yyvsp[0].str));
}
#line 35636 "preproc.c" /* yacc.c:1652  */
    break;

  case 579:
#line 4217 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no validator");
}
#line 35644 "preproc.c" /* yacc.c:1652  */
    break;

  case 580:
#line 4225 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35652 "preproc.c" /* yacc.c:1652  */
    break;

  case 581:
#line 4229 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35659 "preproc.c" /* yacc.c:1652  */
    break;

  case 582:
#line 4236 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-3].str),mm_strdup("language"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35667 "preproc.c" /* yacc.c:1652  */
    break;

  case 583:
#line 4240 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-5].str),mm_strdup("language if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35675 "preproc.c" /* yacc.c:1652  */
    break;

  case 584:
#line 4248 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("procedural");
}
#line 35683 "preproc.c" /* yacc.c:1652  */
    break;

  case 585:
#line 4252 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35690 "preproc.c" /* yacc.c:1652  */
    break;

  case 586:
#line 4259 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create tablespace"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("location"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35698 "preproc.c" /* yacc.c:1652  */
    break;

  case 587:
#line 4267 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("owner"),(yyvsp[0].str));
}
#line 35706 "preproc.c" /* yacc.c:1652  */
    break;

  case 588:
#line 4271 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35713 "preproc.c" /* yacc.c:1652  */
    break;

  case 589:
#line 4278 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop tablespace"),(yyvsp[0].str));
}
#line 35721 "preproc.c" /* yacc.c:1652  */
    break;

  case 590:
#line 4282 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop tablespace if exists"),(yyvsp[0].str));
}
#line 35729 "preproc.c" /* yacc.c:1652  */
    break;

  case 591:
#line 4290 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create extension"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35737 "preproc.c" /* yacc.c:1652  */
    break;

  case 592:
#line 4294 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create extension if not exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35745 "preproc.c" /* yacc.c:1652  */
    break;

  case 593:
#line 4302 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35753 "preproc.c" /* yacc.c:1652  */
    break;

  case 594:
#line 4306 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35760 "preproc.c" /* yacc.c:1652  */
    break;

  case 595:
#line 4313 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 35768 "preproc.c" /* yacc.c:1652  */
    break;

  case 596:
#line 4317 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 35776 "preproc.c" /* yacc.c:1652  */
    break;

  case 597:
#line 4321 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 35784 "preproc.c" /* yacc.c:1652  */
    break;

  case 598:
#line 4325 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cascade");
}
#line 35792 "preproc.c" /* yacc.c:1652  */
    break;

  case 599:
#line 4333 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter extension"),(yyvsp[-2].str),mm_strdup("update"),(yyvsp[0].str));
}
#line 35800 "preproc.c" /* yacc.c:1652  */
    break;

  case 600:
#line 4341 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35808 "preproc.c" /* yacc.c:1652  */
    break;

  case 601:
#line 4345 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35815 "preproc.c" /* yacc.c:1652  */
    break;

  case 602:
#line 4352 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 35823 "preproc.c" /* yacc.c:1652  */
    break;

  case 603:
#line 4360 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("access method"),(yyvsp[0].str));
}
#line 35831 "preproc.c" /* yacc.c:1652  */
    break;

  case 604:
#line 4364 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("aggregate"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35839 "preproc.c" /* yacc.c:1652  */
    break;

  case 605:
#line 4368 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("alter extension"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("cast ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 35847 "preproc.c" /* yacc.c:1652  */
    break;

  case 606:
#line 4372 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("collation"),(yyvsp[0].str));
}
#line 35855 "preproc.c" /* yacc.c:1652  */
    break;

  case 607:
#line 4376 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("conversion"),(yyvsp[0].str));
}
#line 35863 "preproc.c" /* yacc.c:1652  */
    break;

  case 608:
#line 4380 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("domain"),(yyvsp[0].str));
}
#line 35871 "preproc.c" /* yacc.c:1652  */
    break;

  case 609:
#line 4384 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("function"),(yyvsp[0].str));
}
#line 35879 "preproc.c" /* yacc.c:1652  */
    break;

  case 610:
#line 4388 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 35887 "preproc.c" /* yacc.c:1652  */
    break;

  case 611:
#line 4392 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("operator"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35895 "preproc.c" /* yacc.c:1652  */
    break;

  case 612:
#line 4396 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("operator class"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 35903 "preproc.c" /* yacc.c:1652  */
    break;

  case 613:
#line 4400 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("operator family"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 35911 "preproc.c" /* yacc.c:1652  */
    break;

  case 614:
#line 4404 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("schema"),(yyvsp[0].str));
}
#line 35919 "preproc.c" /* yacc.c:1652  */
    break;

  case 615:
#line 4408 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("event trigger"),(yyvsp[0].str));
}
#line 35927 "preproc.c" /* yacc.c:1652  */
    break;

  case 616:
#line 4412 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("table"),(yyvsp[0].str));
}
#line 35935 "preproc.c" /* yacc.c:1652  */
    break;

  case 617:
#line 4416 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search parser"),(yyvsp[0].str));
}
#line 35943 "preproc.c" /* yacc.c:1652  */
    break;

  case 618:
#line 4420 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search dictionary"),(yyvsp[0].str));
}
#line 35951 "preproc.c" /* yacc.c:1652  */
    break;

  case 619:
#line 4424 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search template"),(yyvsp[0].str));
}
#line 35959 "preproc.c" /* yacc.c:1652  */
    break;

  case 620:
#line 4428 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search configuration"),(yyvsp[0].str));
}
#line 35967 "preproc.c" /* yacc.c:1652  */
    break;

  case 621:
#line 4432 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("sequence"),(yyvsp[0].str));
}
#line 35975 "preproc.c" /* yacc.c:1652  */
    break;

  case 622:
#line 4436 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("view"),(yyvsp[0].str));
}
#line 35983 "preproc.c" /* yacc.c:1652  */
    break;

  case 623:
#line 4440 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("materialized view"),(yyvsp[0].str));
}
#line 35991 "preproc.c" /* yacc.c:1652  */
    break;

  case 624:
#line 4444 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("foreign table"),(yyvsp[0].str));
}
#line 35999 "preproc.c" /* yacc.c:1652  */
    break;

  case 625:
#line 4448 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("foreign data wrapper"),(yyvsp[0].str));
}
#line 36007 "preproc.c" /* yacc.c:1652  */
    break;

  case 626:
#line 4452 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 36015 "preproc.c" /* yacc.c:1652  */
    break;

  case 627:
#line 4456 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("transform for"),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 36023 "preproc.c" /* yacc.c:1652  */
    break;

  case 628:
#line 4460 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("type"),(yyvsp[0].str));
}
#line 36031 "preproc.c" /* yacc.c:1652  */
    break;

  case 629:
#line 4468 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create foreign data wrapper"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36039 "preproc.c" /* yacc.c:1652  */
    break;

  case 630:
#line 4476 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("handler"),(yyvsp[0].str));
}
#line 36047 "preproc.c" /* yacc.c:1652  */
    break;

  case 631:
#line 4480 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no handler");
}
#line 36055 "preproc.c" /* yacc.c:1652  */
    break;

  case 632:
#line 4484 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("validator"),(yyvsp[0].str));
}
#line 36063 "preproc.c" /* yacc.c:1652  */
    break;

  case 633:
#line 4488 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no validator");
}
#line 36071 "preproc.c" /* yacc.c:1652  */
    break;

  case 634:
#line 4496 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36079 "preproc.c" /* yacc.c:1652  */
    break;

  case 635:
#line 4500 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36087 "preproc.c" /* yacc.c:1652  */
    break;

  case 636:
#line 4508 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36095 "preproc.c" /* yacc.c:1652  */
    break;

  case 637:
#line 4512 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36102 "preproc.c" /* yacc.c:1652  */
    break;

  case 638:
#line 4519 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36110 "preproc.c" /* yacc.c:1652  */
    break;

  case 639:
#line 4523 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop foreign data wrapper if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36118 "preproc.c" /* yacc.c:1652  */
    break;

  case 640:
#line 4531 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36126 "preproc.c" /* yacc.c:1652  */
    break;

  case 641:
#line 4535 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36134 "preproc.c" /* yacc.c:1652  */
    break;

  case 642:
#line 4543 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("options ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 36142 "preproc.c" /* yacc.c:1652  */
    break;

  case 643:
#line 4547 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36149 "preproc.c" /* yacc.c:1652  */
    break;

  case 644:
#line 4554 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36157 "preproc.c" /* yacc.c:1652  */
    break;

  case 645:
#line 4558 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 36165 "preproc.c" /* yacc.c:1652  */
    break;

  case 646:
#line 4566 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("options ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 36173 "preproc.c" /* yacc.c:1652  */
    break;

  case 647:
#line 4574 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36181 "preproc.c" /* yacc.c:1652  */
    break;

  case 648:
#line 4578 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 36189 "preproc.c" /* yacc.c:1652  */
    break;

  case 649:
#line 4586 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36197 "preproc.c" /* yacc.c:1652  */
    break;

  case 650:
#line 4590 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 36205 "preproc.c" /* yacc.c:1652  */
    break;

  case 651:
#line 4594 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 36213 "preproc.c" /* yacc.c:1652  */
    break;

  case 652:
#line 4598 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop"),(yyvsp[0].str));
}
#line 36221 "preproc.c" /* yacc.c:1652  */
    break;

  case 653:
#line 4606 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36229 "preproc.c" /* yacc.c:1652  */
    break;

  case 654:
#line 4614 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36237 "preproc.c" /* yacc.c:1652  */
    break;

  case 655:
#line 4622 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36245 "preproc.c" /* yacc.c:1652  */
    break;

  case 656:
#line 4630 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create server"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36253 "preproc.c" /* yacc.c:1652  */
    break;

  case 657:
#line 4638 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("type"),(yyvsp[0].str));
}
#line 36261 "preproc.c" /* yacc.c:1652  */
    break;

  case 658:
#line 4642 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36268 "preproc.c" /* yacc.c:1652  */
    break;

  case 659:
#line 4649 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 36276 "preproc.c" /* yacc.c:1652  */
    break;

  case 660:
#line 4653 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("version null");
}
#line 36284 "preproc.c" /* yacc.c:1652  */
    break;

  case 661:
#line 4661 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36292 "preproc.c" /* yacc.c:1652  */
    break;

  case 662:
#line 4665 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36299 "preproc.c" /* yacc.c:1652  */
    break;

  case 663:
#line 4672 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36307 "preproc.c" /* yacc.c:1652  */
    break;

  case 664:
#line 4676 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop server if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36315 "preproc.c" /* yacc.c:1652  */
    break;

  case 665:
#line 4684 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36323 "preproc.c" /* yacc.c:1652  */
    break;

  case 666:
#line 4688 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36331 "preproc.c" /* yacc.c:1652  */
    break;

  case 667:
#line 4692 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36339 "preproc.c" /* yacc.c:1652  */
    break;

  case 668:
#line 4700 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create foreign table"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36347 "preproc.c" /* yacc.c:1652  */
    break;

  case 669:
#line 4704 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create foreign table if not exists"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36355 "preproc.c" /* yacc.c:1652  */
    break;

  case 670:
#line 4712 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36363 "preproc.c" /* yacc.c:1652  */
    break;

  case 671:
#line 4716 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign table if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36371 "preproc.c" /* yacc.c:1652  */
    break;

  case 672:
#line 4724 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("import foreign schema"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("from server"),(yyvsp[-3].str),mm_strdup("into"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36379 "preproc.c" /* yacc.c:1652  */
    break;

  case 673:
#line 4732 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("limit to");
}
#line 36387 "preproc.c" /* yacc.c:1652  */
    break;

  case 674:
#line 4736 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("except");
}
#line 36395 "preproc.c" /* yacc.c:1652  */
    break;

  case 675:
#line 4744 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 36403 "preproc.c" /* yacc.c:1652  */
    break;

  case 676:
#line 4748 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36410 "preproc.c" /* yacc.c:1652  */
    break;

  case 677:
#line 4755 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create user mapping for"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36418 "preproc.c" /* yacc.c:1652  */
    break;

  case 678:
#line 4763 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36426 "preproc.c" /* yacc.c:1652  */
    break;

  case 679:
#line 4767 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("user");
}
#line 36434 "preproc.c" /* yacc.c:1652  */
    break;

  case 680:
#line 4775 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop user mapping for"),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 36442 "preproc.c" /* yacc.c:1652  */
    break;

  case 681:
#line 4779 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop user mapping if exists for"),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 36450 "preproc.c" /* yacc.c:1652  */
    break;

  case 682:
#line 4787 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter user mapping for"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36458 "preproc.c" /* yacc.c:1652  */
    break;

  case 683:
#line 4795 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("create policy"),(yyvsp[-6].str),mm_strdup("on"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36466 "preproc.c" /* yacc.c:1652  */
    break;

  case 684:
#line 4803 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter policy"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36474 "preproc.c" /* yacc.c:1652  */
    break;

  case 685:
#line 4811 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop policy"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36482 "preproc.c" /* yacc.c:1652  */
    break;

  case 686:
#line 4815 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop policy if exists"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36490 "preproc.c" /* yacc.c:1652  */
    break;

  case 687:
#line 4823 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("using ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 36498 "preproc.c" /* yacc.c:1652  */
    break;

  case 688:
#line 4827 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36505 "preproc.c" /* yacc.c:1652  */
    break;

  case 689:
#line 4834 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("with check ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 36513 "preproc.c" /* yacc.c:1652  */
    break;

  case 690:
#line 4838 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36520 "preproc.c" /* yacc.c:1652  */
    break;

  case 691:
#line 4845 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 36528 "preproc.c" /* yacc.c:1652  */
    break;

  case 692:
#line 4849 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36535 "preproc.c" /* yacc.c:1652  */
    break;

  case 693:
#line 4856 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 36543 "preproc.c" /* yacc.c:1652  */
    break;

  case 694:
#line 4860 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36550 "preproc.c" /* yacc.c:1652  */
    break;

  case 695:
#line 4867 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 36558 "preproc.c" /* yacc.c:1652  */
    break;

  case 696:
#line 4871 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36565 "preproc.c" /* yacc.c:1652  */
    break;

  case 697:
#line 4878 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 36573 "preproc.c" /* yacc.c:1652  */
    break;

  case 698:
#line 4882 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("select");
}
#line 36581 "preproc.c" /* yacc.c:1652  */
    break;

  case 699:
#line 4886 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("insert");
}
#line 36589 "preproc.c" /* yacc.c:1652  */
    break;

  case 700:
#line 4890 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("update");
}
#line 36597 "preproc.c" /* yacc.c:1652  */
    break;

  case 701:
#line 4894 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delete");
}
#line 36605 "preproc.c" /* yacc.c:1652  */
    break;

  case 702:
#line 4902 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create access method"),(yyvsp[-4].str),mm_strdup("type index handler"),(yyvsp[0].str));
}
#line 36613 "preproc.c" /* yacc.c:1652  */
    break;

  case 703:
#line 4910 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(13,mm_strdup("create trigger"),(yyvsp[-12].str),(yyvsp[-11].str),(yyvsp[-10].str),mm_strdup("on"),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("execute procedure"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 36621 "preproc.c" /* yacc.c:1652  */
    break;

  case 704:
#line 4914 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(15,mm_strdup("create constraint trigger"),(yyvsp[-16].str),mm_strdup("after"),(yyvsp[-14].str),mm_strdup("on"),(yyvsp[-12].str),(yyvsp[-11].str),(yyvsp[-10].str),mm_strdup("for each row"),(yyvsp[-6].str),mm_strdup("execute procedure"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 36629 "preproc.c" /* yacc.c:1652  */
    break;

  case 705:
#line 4922 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("before");
}
#line 36637 "preproc.c" /* yacc.c:1652  */
    break;

  case 706:
#line 4926 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("after");
}
#line 36645 "preproc.c" /* yacc.c:1652  */
    break;

  case 707:
#line 4930 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("instead of");
}
#line 36653 "preproc.c" /* yacc.c:1652  */
    break;

  case 708:
#line 4938 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36661 "preproc.c" /* yacc.c:1652  */
    break;

  case 709:
#line 4942 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("or"),(yyvsp[0].str));
}
#line 36669 "preproc.c" /* yacc.c:1652  */
    break;

  case 710:
#line 4950 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("insert");
}
#line 36677 "preproc.c" /* yacc.c:1652  */
    break;

  case 711:
#line 4954 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delete");
}
#line 36685 "preproc.c" /* yacc.c:1652  */
    break;

  case 712:
#line 4958 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("update");
}
#line 36693 "preproc.c" /* yacc.c:1652  */
    break;

  case 713:
#line 4962 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("update of"),(yyvsp[0].str));
}
#line 36701 "preproc.c" /* yacc.c:1652  */
    break;

  case 714:
#line 4966 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("truncate");
}
#line 36709 "preproc.c" /* yacc.c:1652  */
    break;

  case 715:
#line 4974 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("for"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36717 "preproc.c" /* yacc.c:1652  */
    break;

  case 716:
#line 4978 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36724 "preproc.c" /* yacc.c:1652  */
    break;

  case 717:
#line 4985 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("each");
}
#line 36732 "preproc.c" /* yacc.c:1652  */
    break;

  case 718:
#line 4989 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36739 "preproc.c" /* yacc.c:1652  */
    break;

  case 719:
#line 4996 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row");
}
#line 36747 "preproc.c" /* yacc.c:1652  */
    break;

  case 720:
#line 5000 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("statement");
}
#line 36755 "preproc.c" /* yacc.c:1652  */
    break;

  case 721:
#line 5008 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("when ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 36763 "preproc.c" /* yacc.c:1652  */
    break;

  case 722:
#line 5012 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36770 "preproc.c" /* yacc.c:1652  */
    break;

  case 723:
#line 5019 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36778 "preproc.c" /* yacc.c:1652  */
    break;

  case 724:
#line 5023 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 36786 "preproc.c" /* yacc.c:1652  */
    break;

  case 725:
#line 5027 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36793 "preproc.c" /* yacc.c:1652  */
    break;

  case 726:
#line 5034 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36801 "preproc.c" /* yacc.c:1652  */
    break;

  case 727:
#line 5038 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36809 "preproc.c" /* yacc.c:1652  */
    break;

  case 728:
#line 5042 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36817 "preproc.c" /* yacc.c:1652  */
    break;

  case 729:
#line 5046 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36825 "preproc.c" /* yacc.c:1652  */
    break;

  case 730:
#line 5054 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 36833 "preproc.c" /* yacc.c:1652  */
    break;

  case 731:
#line 5058 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36840 "preproc.c" /* yacc.c:1652  */
    break;

  case 732:
#line 5065 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36847 "preproc.c" /* yacc.c:1652  */
    break;

  case 733:
#line 5068 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36855 "preproc.c" /* yacc.c:1652  */
    break;

  case 734:
#line 5076 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 36863 "preproc.c" /* yacc.c:1652  */
    break;

  case 735:
#line 5080 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 36871 "preproc.c" /* yacc.c:1652  */
    break;

  case 736:
#line 5084 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("initially immediate");
}
#line 36879 "preproc.c" /* yacc.c:1652  */
    break;

  case 737:
#line 5088 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("initially deferred");
}
#line 36887 "preproc.c" /* yacc.c:1652  */
    break;

  case 738:
#line 5092 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not valid");
}
#line 36895 "preproc.c" /* yacc.c:1652  */
    break;

  case 739:
#line 5096 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no inherit");
}
#line 36903 "preproc.c" /* yacc.c:1652  */
    break;

  case 740:
#line 5104 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop trigger"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36911 "preproc.c" /* yacc.c:1652  */
    break;

  case 741:
#line 5108 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop trigger if exists"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36919 "preproc.c" /* yacc.c:1652  */
    break;

  case 742:
#line 5116 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create event trigger"),(yyvsp[-7].str),mm_strdup("on"),(yyvsp[-5].str),mm_strdup("execute procedure"),(yyvsp[-2].str),mm_strdup("( )"));
}
#line 36927 "preproc.c" /* yacc.c:1652  */
    break;

  case 743:
#line 5120 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create event trigger"),(yyvsp[-9].str),mm_strdup("on"),(yyvsp[-7].str),mm_strdup("when"),(yyvsp[-5].str),mm_strdup("execute procedure"),(yyvsp[-2].str),mm_strdup("( )"));
}
#line 36935 "preproc.c" /* yacc.c:1652  */
    break;

  case 744:
#line 5128 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36943 "preproc.c" /* yacc.c:1652  */
    break;

  case 745:
#line 5132 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 36951 "preproc.c" /* yacc.c:1652  */
    break;

  case 746:
#line 5140 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup("in ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 36959 "preproc.c" /* yacc.c:1652  */
    break;

  case 747:
#line 5148 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sconst");
}
#line 36967 "preproc.c" /* yacc.c:1652  */
    break;

  case 748:
#line 5152 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup(", sconst"));
}
#line 36975 "preproc.c" /* yacc.c:1652  */
    break;

  case 749:
#line 5160 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter event trigger"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36983 "preproc.c" /* yacc.c:1652  */
    break;

  case 750:
#line 5168 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable");
}
#line 36991 "preproc.c" /* yacc.c:1652  */
    break;

  case 751:
#line 5172 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable replica");
}
#line 36999 "preproc.c" /* yacc.c:1652  */
    break;

  case 752:
#line 5176 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable always");
}
#line 37007 "preproc.c" /* yacc.c:1652  */
    break;

  case 753:
#line 5180 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("disable");
}
#line 37015 "preproc.c" /* yacc.c:1652  */
    break;

  case 754:
#line 5188 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(6,mm_strdup("create assertion"),(yyvsp[-5].str),mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 37024 "preproc.c" /* yacc.c:1652  */
    break;

  case 755:
#line 5197 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(3,mm_strdup("drop assertion"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37033 "preproc.c" /* yacc.c:1652  */
    break;

  case 756:
#line 5206 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create aggregate"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37041 "preproc.c" /* yacc.c:1652  */
    break;

  case 757:
#line 5210 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create aggregate"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37049 "preproc.c" /* yacc.c:1652  */
    break;

  case 758:
#line 5214 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create operator"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37057 "preproc.c" /* yacc.c:1652  */
    break;

  case 759:
#line 5218 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37065 "preproc.c" /* yacc.c:1652  */
    break;

  case 760:
#line 5222 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("create type"),(yyvsp[0].str));
}
#line 37073 "preproc.c" /* yacc.c:1652  */
    break;

  case 761:
#line 5226 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create type"),(yyvsp[-4].str),mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37081 "preproc.c" /* yacc.c:1652  */
    break;

  case 762:
#line 5230 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create type"),(yyvsp[-5].str),mm_strdup("as enum ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37089 "preproc.c" /* yacc.c:1652  */
    break;

  case 763:
#line 5234 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create type"),(yyvsp[-3].str),mm_strdup("as range"),(yyvsp[0].str));
}
#line 37097 "preproc.c" /* yacc.c:1652  */
    break;

  case 764:
#line 5238 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create text search parser"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37105 "preproc.c" /* yacc.c:1652  */
    break;

  case 765:
#line 5242 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create text search dictionary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37113 "preproc.c" /* yacc.c:1652  */
    break;

  case 766:
#line 5246 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create text search template"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37121 "preproc.c" /* yacc.c:1652  */
    break;

  case 767:
#line 5250 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create text search configuration"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37129 "preproc.c" /* yacc.c:1652  */
    break;

  case 768:
#line 5254 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create collation"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37137 "preproc.c" /* yacc.c:1652  */
    break;

  case 769:
#line 5258 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create collation"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 37145 "preproc.c" /* yacc.c:1652  */
    break;

  case 770:
#line 5266 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37153 "preproc.c" /* yacc.c:1652  */
    break;

  case 771:
#line 5274 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37161 "preproc.c" /* yacc.c:1652  */
    break;

  case 772:
#line 5278 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37169 "preproc.c" /* yacc.c:1652  */
    break;

  case 773:
#line 5286 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 37177 "preproc.c" /* yacc.c:1652  */
    break;

  case 774:
#line 5290 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37185 "preproc.c" /* yacc.c:1652  */
    break;

  case 775:
#line 5298 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37193 "preproc.c" /* yacc.c:1652  */
    break;

  case 776:
#line 5302 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37201 "preproc.c" /* yacc.c:1652  */
    break;

  case 777:
#line 5306 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37209 "preproc.c" /* yacc.c:1652  */
    break;

  case 778:
#line 5310 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37217 "preproc.c" /* yacc.c:1652  */
    break;

  case 779:
#line 5314 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37225 "preproc.c" /* yacc.c:1652  */
    break;

  case 780:
#line 5322 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37233 "preproc.c" /* yacc.c:1652  */
    break;

  case 781:
#line 5330 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37241 "preproc.c" /* yacc.c:1652  */
    break;

  case 782:
#line 5334 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37249 "preproc.c" /* yacc.c:1652  */
    break;

  case 783:
#line 5342 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 37257 "preproc.c" /* yacc.c:1652  */
    break;

  case 784:
#line 5350 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37265 "preproc.c" /* yacc.c:1652  */
    break;

  case 785:
#line 5354 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37272 "preproc.c" /* yacc.c:1652  */
    break;

  case 786:
#line 5361 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37280 "preproc.c" /* yacc.c:1652  */
    break;

  case 787:
#line 5365 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37288 "preproc.c" /* yacc.c:1652  */
    break;

  case 788:
#line 5373 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter type"),(yyvsp[-4].str),mm_strdup("add value"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37296 "preproc.c" /* yacc.c:1652  */
    break;

  case 789:
#line 5377 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("add value"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("before"),(yyvsp[0].str));
}
#line 37304 "preproc.c" /* yacc.c:1652  */
    break;

  case 790:
#line 5381 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("add value"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("after"),(yyvsp[0].str));
}
#line 37312 "preproc.c" /* yacc.c:1652  */
    break;

  case 791:
#line 5389 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("if not exists");
}
#line 37320 "preproc.c" /* yacc.c:1652  */
    break;

  case 792:
#line 5393 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37327 "preproc.c" /* yacc.c:1652  */
    break;

  case 793:
#line 5400 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("create operator class"),(yyvsp[-9].str),(yyvsp[-8].str),mm_strdup("for type"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 37335 "preproc.c" /* yacc.c:1652  */
    break;

  case 794:
#line 5408 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37343 "preproc.c" /* yacc.c:1652  */
    break;

  case 795:
#line 5412 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37351 "preproc.c" /* yacc.c:1652  */
    break;

  case 796:
#line 5420 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("operator"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37359 "preproc.c" /* yacc.c:1652  */
    break;

  case 797:
#line 5424 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("operator"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37367 "preproc.c" /* yacc.c:1652  */
    break;

  case 798:
#line 5428 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("function"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37375 "preproc.c" /* yacc.c:1652  */
    break;

  case 799:
#line 5432 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("function"),(yyvsp[-5].str),mm_strdup("("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37383 "preproc.c" /* yacc.c:1652  */
    break;

  case 800:
#line 5436 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("storage"),(yyvsp[0].str));
}
#line 37391 "preproc.c" /* yacc.c:1652  */
    break;

  case 801:
#line 5444 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 37399 "preproc.c" /* yacc.c:1652  */
    break;

  case 802:
#line 5448 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37406 "preproc.c" /* yacc.c:1652  */
    break;

  case 803:
#line 5455 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("family"),(yyvsp[0].str));
}
#line 37414 "preproc.c" /* yacc.c:1652  */
    break;

  case 804:
#line 5459 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37421 "preproc.c" /* yacc.c:1652  */
    break;

  case 805:
#line 5466 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for search");
}
#line 37429 "preproc.c" /* yacc.c:1652  */
    break;

  case 806:
#line 5470 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for order by"),(yyvsp[0].str));
}
#line 37437 "preproc.c" /* yacc.c:1652  */
    break;

  case 807:
#line 5474 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37444 "preproc.c" /* yacc.c:1652  */
    break;

  case 808:
#line 5481 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = mm_strdup("recheck");
}
#line 37453 "preproc.c" /* yacc.c:1652  */
    break;

  case 809:
#line 5486 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37460 "preproc.c" /* yacc.c:1652  */
    break;

  case 810:
#line 5493 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create operator family"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 37468 "preproc.c" /* yacc.c:1652  */
    break;

  case 811:
#line 5501 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("add"),(yyvsp[0].str));
}
#line 37476 "preproc.c" /* yacc.c:1652  */
    break;

  case 812:
#line 5505 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("drop"),(yyvsp[0].str));
}
#line 37484 "preproc.c" /* yacc.c:1652  */
    break;

  case 813:
#line 5513 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37492 "preproc.c" /* yacc.c:1652  */
    break;

  case 814:
#line 5517 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37500 "preproc.c" /* yacc.c:1652  */
    break;

  case 815:
#line 5525 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("operator"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37508 "preproc.c" /* yacc.c:1652  */
    break;

  case 816:
#line 5529 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("function"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37516 "preproc.c" /* yacc.c:1652  */
    break;

  case 817:
#line 5537 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator class"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37524 "preproc.c" /* yacc.c:1652  */
    break;

  case 818:
#line 5541 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator class if exists"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37532 "preproc.c" /* yacc.c:1652  */
    break;

  case 819:
#line 5549 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator family"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37540 "preproc.c" /* yacc.c:1652  */
    break;

  case 820:
#line 5553 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator family if exists"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37548 "preproc.c" /* yacc.c:1652  */
    break;

  case 821:
#line 5561 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop owned by"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37556 "preproc.c" /* yacc.c:1652  */
    break;

  case 822:
#line 5569 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("reassign owned by"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 37564 "preproc.c" /* yacc.c:1652  */
    break;

  case 823:
#line 5577 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-4].str),mm_strdup("if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37572 "preproc.c" /* yacc.c:1652  */
    break;

  case 824:
#line 5581 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37580 "preproc.c" /* yacc.c:1652  */
    break;

  case 825:
#line 5585 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37588 "preproc.c" /* yacc.c:1652  */
    break;

  case 826:
#line 5589 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop type if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37596 "preproc.c" /* yacc.c:1652  */
    break;

  case 827:
#line 5593 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop domain"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37604 "preproc.c" /* yacc.c:1652  */
    break;

  case 828:
#line 5597 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop domain if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37612 "preproc.c" /* yacc.c:1652  */
    break;

  case 829:
#line 5601 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop index concurrently"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37620 "preproc.c" /* yacc.c:1652  */
    break;

  case 830:
#line 5605 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop index concurrently if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37628 "preproc.c" /* yacc.c:1652  */
    break;

  case 831:
#line 5613 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 37636 "preproc.c" /* yacc.c:1652  */
    break;

  case 832:
#line 5617 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequence");
}
#line 37644 "preproc.c" /* yacc.c:1652  */
    break;

  case 833:
#line 5621 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("view");
}
#line 37652 "preproc.c" /* yacc.c:1652  */
    break;

  case 834:
#line 5625 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 37660 "preproc.c" /* yacc.c:1652  */
    break;

  case 835:
#line 5629 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("index");
}
#line 37668 "preproc.c" /* yacc.c:1652  */
    break;

  case 836:
#line 5633 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 37676 "preproc.c" /* yacc.c:1652  */
    break;

  case 837:
#line 5637 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("access method");
}
#line 37684 "preproc.c" /* yacc.c:1652  */
    break;

  case 838:
#line 5641 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 37692 "preproc.c" /* yacc.c:1652  */
    break;

  case 839:
#line 5645 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("collation");
}
#line 37700 "preproc.c" /* yacc.c:1652  */
    break;

  case 840:
#line 5649 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("conversion");
}
#line 37708 "preproc.c" /* yacc.c:1652  */
    break;

  case 841:
#line 5653 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schema");
}
#line 37716 "preproc.c" /* yacc.c:1652  */
    break;

  case 842:
#line 5657 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("extension");
}
#line 37724 "preproc.c" /* yacc.c:1652  */
    break;

  case 843:
#line 5661 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search parser");
}
#line 37732 "preproc.c" /* yacc.c:1652  */
    break;

  case 844:
#line 5665 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search dictionary");
}
#line 37740 "preproc.c" /* yacc.c:1652  */
    break;

  case 845:
#line 5669 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search template");
}
#line 37748 "preproc.c" /* yacc.c:1652  */
    break;

  case 846:
#line 5673 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search configuration");
}
#line 37756 "preproc.c" /* yacc.c:1652  */
    break;

  case 847:
#line 5681 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37764 "preproc.c" /* yacc.c:1652  */
    break;

  case 848:
#line 5685 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37772 "preproc.c" /* yacc.c:1652  */
    break;

  case 849:
#line 5693 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37780 "preproc.c" /* yacc.c:1652  */
    break;

  case 850:
#line 5697 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37788 "preproc.c" /* yacc.c:1652  */
    break;

  case 851:
#line 5705 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("."),(yyvsp[0].str));
}
#line 37796 "preproc.c" /* yacc.c:1652  */
    break;

  case 852:
#line 5709 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 37804 "preproc.c" /* yacc.c:1652  */
    break;

  case 853:
#line 5717 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37812 "preproc.c" /* yacc.c:1652  */
    break;

  case 854:
#line 5721 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37820 "preproc.c" /* yacc.c:1652  */
    break;

  case 855:
#line 5729 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("truncate"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37828 "preproc.c" /* yacc.c:1652  */
    break;

  case 856:
#line 5737 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("continue identity");
}
#line 37836 "preproc.c" /* yacc.c:1652  */
    break;

  case 857:
#line 5741 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restart identity");
}
#line 37844 "preproc.c" /* yacc.c:1652  */
    break;

  case 858:
#line 5745 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37851 "preproc.c" /* yacc.c:1652  */
    break;

  case 859:
#line 5752 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("comment on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37859 "preproc.c" /* yacc.c:1652  */
    break;

  case 860:
#line 5756 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on type"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37867 "preproc.c" /* yacc.c:1652  */
    break;

  case 861:
#line 5760 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on domain"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37875 "preproc.c" /* yacc.c:1652  */
    break;

  case 862:
#line 5764 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("comment on aggregate"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37883 "preproc.c" /* yacc.c:1652  */
    break;

  case 863:
#line 5768 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("comment on function"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37891 "preproc.c" /* yacc.c:1652  */
    break;

  case 864:
#line 5772 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("comment on operator"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37899 "preproc.c" /* yacc.c:1652  */
    break;

  case 865:
#line 5776 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on constraint"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37907 "preproc.c" /* yacc.c:1652  */
    break;

  case 866:
#line 5780 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on constraint"),(yyvsp[-5].str),mm_strdup("on domain"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37915 "preproc.c" /* yacc.c:1652  */
    break;

  case 867:
#line 5784 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on policy"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37923 "preproc.c" /* yacc.c:1652  */
    break;

  case 868:
#line 5788 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on rule"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37931 "preproc.c" /* yacc.c:1652  */
    break;

  case 869:
#line 5792 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on rule"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37939 "preproc.c" /* yacc.c:1652  */
    break;

  case 870:
#line 5796 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on transform for"),(yyvsp[-4].str),mm_strdup("language"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37947 "preproc.c" /* yacc.c:1652  */
    break;

  case 871:
#line 5800 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on trigger"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37955 "preproc.c" /* yacc.c:1652  */
    break;

  case 872:
#line 5804 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on operator class"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37963 "preproc.c" /* yacc.c:1652  */
    break;

  case 873:
#line 5808 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37971 "preproc.c" /* yacc.c:1652  */
    break;

  case 874:
#line 5812 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on large object"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37979 "preproc.c" /* yacc.c:1652  */
    break;

  case 875:
#line 5816 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on cast ("),(yyvsp[-5].str),mm_strdup("as"),(yyvsp[-3].str),mm_strdup(") is"),(yyvsp[0].str));
}
#line 37987 "preproc.c" /* yacc.c:1652  */
    break;

  case 876:
#line 5820 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on"),(yyvsp[-4].str),mm_strdup("language"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 37995 "preproc.c" /* yacc.c:1652  */
    break;

  case 877:
#line 5828 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("access method");
}
#line 38003 "preproc.c" /* yacc.c:1652  */
    break;

  case 878:
#line 5832 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("column");
}
#line 38011 "preproc.c" /* yacc.c:1652  */
    break;

  case 879:
#line 5836 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("database");
}
#line 38019 "preproc.c" /* yacc.c:1652  */
    break;

  case 880:
#line 5840 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schema");
}
#line 38027 "preproc.c" /* yacc.c:1652  */
    break;

  case 881:
#line 5844 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("index");
}
#line 38035 "preproc.c" /* yacc.c:1652  */
    break;

  case 882:
#line 5848 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequence");
}
#line 38043 "preproc.c" /* yacc.c:1652  */
    break;

  case 883:
#line 5852 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 38051 "preproc.c" /* yacc.c:1652  */
    break;

  case 884:
#line 5856 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("view");
}
#line 38059 "preproc.c" /* yacc.c:1652  */
    break;

  case 885:
#line 5860 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 38067 "preproc.c" /* yacc.c:1652  */
    break;

  case 886:
#line 5864 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("collation");
}
#line 38075 "preproc.c" /* yacc.c:1652  */
    break;

  case 887:
#line 5868 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("conversion");
}
#line 38083 "preproc.c" /* yacc.c:1652  */
    break;

  case 888:
#line 5872 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 38091 "preproc.c" /* yacc.c:1652  */
    break;

  case 889:
#line 5876 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("extension");
}
#line 38099 "preproc.c" /* yacc.c:1652  */
    break;

  case 890:
#line 5880 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("role");
}
#line 38107 "preproc.c" /* yacc.c:1652  */
    break;

  case 891:
#line 5884 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 38115 "preproc.c" /* yacc.c:1652  */
    break;

  case 892:
#line 5888 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("server");
}
#line 38123 "preproc.c" /* yacc.c:1652  */
    break;

  case 893:
#line 5892 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign data wrapper");
}
#line 38131 "preproc.c" /* yacc.c:1652  */
    break;

  case 894:
#line 5896 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 38139 "preproc.c" /* yacc.c:1652  */
    break;

  case 895:
#line 5900 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search configuration");
}
#line 38147 "preproc.c" /* yacc.c:1652  */
    break;

  case 896:
#line 5904 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search dictionary");
}
#line 38155 "preproc.c" /* yacc.c:1652  */
    break;

  case 897:
#line 5908 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search parser");
}
#line 38163 "preproc.c" /* yacc.c:1652  */
    break;

  case 898:
#line 5912 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search template");
}
#line 38171 "preproc.c" /* yacc.c:1652  */
    break;

  case 899:
#line 5920 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38179 "preproc.c" /* yacc.c:1652  */
    break;

  case 900:
#line 5924 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 38187 "preproc.c" /* yacc.c:1652  */
    break;

  case 901:
#line 5932 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 38195 "preproc.c" /* yacc.c:1652  */
    break;

  case 902:
#line 5936 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on type"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 38203 "preproc.c" /* yacc.c:1652  */
    break;

  case 903:
#line 5940 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on domain"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 38211 "preproc.c" /* yacc.c:1652  */
    break;

  case 904:
#line 5944 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("security label"),(yyvsp[-6].str),mm_strdup("on aggregate"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 38219 "preproc.c" /* yacc.c:1652  */
    break;

  case 905:
#line 5948 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("security label"),(yyvsp[-6].str),mm_strdup("on function"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 38227 "preproc.c" /* yacc.c:1652  */
    break;

  case 906:
#line 5952 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-6].str),mm_strdup("on large object"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 38235 "preproc.c" /* yacc.c:1652  */
    break;

  case 907:
#line 5956 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("security label"),(yyvsp[-6].str),mm_strdup("on"),(yyvsp[-4].str),mm_strdup("language"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 38243 "preproc.c" /* yacc.c:1652  */
    break;

  case 908:
#line 5964 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 38251 "preproc.c" /* yacc.c:1652  */
    break;

  case 909:
#line 5968 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38258 "preproc.c" /* yacc.c:1652  */
    break;

  case 910:
#line 5975 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("column");
}
#line 38266 "preproc.c" /* yacc.c:1652  */
    break;

  case 911:
#line 5979 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("database");
}
#line 38274 "preproc.c" /* yacc.c:1652  */
    break;

  case 912:
#line 5983 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 38282 "preproc.c" /* yacc.c:1652  */
    break;

  case 913:
#line 5987 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 38290 "preproc.c" /* yacc.c:1652  */
    break;

  case 914:
#line 5991 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schema");
}
#line 38298 "preproc.c" /* yacc.c:1652  */
    break;

  case 915:
#line 5995 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequence");
}
#line 38306 "preproc.c" /* yacc.c:1652  */
    break;

  case 916:
#line 5999 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 38314 "preproc.c" /* yacc.c:1652  */
    break;

  case 917:
#line 6003 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("role");
}
#line 38322 "preproc.c" /* yacc.c:1652  */
    break;

  case 918:
#line 6007 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 38330 "preproc.c" /* yacc.c:1652  */
    break;

  case 919:
#line 6011 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("view");
}
#line 38338 "preproc.c" /* yacc.c:1652  */
    break;

  case 920:
#line 6015 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 38346 "preproc.c" /* yacc.c:1652  */
    break;

  case 921:
#line 6023 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38354 "preproc.c" /* yacc.c:1652  */
    break;

  case 922:
#line 6027 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 38362 "preproc.c" /* yacc.c:1652  */
    break;

  case 923:
#line 6035 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("fetch"),(yyvsp[0].str));
}
#line 38370 "preproc.c" /* yacc.c:1652  */
    break;

  case 924:
#line 6039 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("move"),(yyvsp[0].str));
}
#line 38378 "preproc.c" /* yacc.c:1652  */
    break;

  case 925:
#line 6043 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.str) = cat2_str(mm_strdup("fetch"), (yyvsp[-1].str));
	}
#line 38386 "preproc.c" /* yacc.c:1652  */
    break;

  case 926:
#line 6047 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch forward"), cursor_marker);
	}
#line 38396 "preproc.c" /* yacc.c:1652  */
    break;

  case 927:
#line 6053 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch forward from"), cursor_marker);
	}
#line 38406 "preproc.c" /* yacc.c:1652  */
    break;

  case 928:
#line 6059 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch backward"), cursor_marker);
	}
#line 38416 "preproc.c" /* yacc.c:1652  */
    break;

  case 929:
#line 6065 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch backward from"), cursor_marker);
	}
#line 38426 "preproc.c" /* yacc.c:1652  */
    break;

  case 930:
#line 6071 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move forward"), cursor_marker);
	}
#line 38436 "preproc.c" /* yacc.c:1652  */
    break;

  case 931:
#line 6077 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move forward from"), cursor_marker);
	}
#line 38446 "preproc.c" /* yacc.c:1652  */
    break;

  case 932:
#line 6083 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move backward"), cursor_marker);
	}
#line 38456 "preproc.c" /* yacc.c:1652  */
    break;

  case 933:
#line 6089 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move backward from"), cursor_marker);
	}
#line 38466 "preproc.c" /* yacc.c:1652  */
    break;

  case 934:
#line 6099 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = (yyvsp[0].str);
}
#line 38481 "preproc.c" /* yacc.c:1652  */
    break;

  case 935:
#line 6110 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38496 "preproc.c" /* yacc.c:1652  */
    break;

  case 936:
#line 6121 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("next"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38511 "preproc.c" /* yacc.c:1652  */
    break;

  case 937:
#line 6132 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("prior"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38526 "preproc.c" /* yacc.c:1652  */
    break;

  case 938:
#line 6143 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("first"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38541 "preproc.c" /* yacc.c:1652  */
    break;

  case 939:
#line 6154 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("last"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38556 "preproc.c" /* yacc.c:1652  */
    break;

  case 940:
#line 6165 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("absolute"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38576 "preproc.c" /* yacc.c:1652  */
    break;

  case 941:
#line 6181 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("relative"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38596 "preproc.c" /* yacc.c:1652  */
    break;

  case 942:
#line 6197 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38616 "preproc.c" /* yacc.c:1652  */
    break;

  case 943:
#line 6213 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38631 "preproc.c" /* yacc.c:1652  */
    break;

  case 944:
#line 6224 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("forward"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38651 "preproc.c" /* yacc.c:1652  */
    break;

  case 945:
#line 6240 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("forward all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38666 "preproc.c" /* yacc.c:1652  */
    break;

  case 946:
#line 6251 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("backward"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38686 "preproc.c" /* yacc.c:1652  */
    break;

  case 947:
#line 6267 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("backward all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38701 "preproc.c" /* yacc.c:1652  */
    break;

  case 948:
#line 6282 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("from");
}
#line 38709 "preproc.c" /* yacc.c:1652  */
    break;

  case 949:
#line 6286 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("in");
}
#line 38717 "preproc.c" /* yacc.c:1652  */
    break;

  case 950:
#line 6294 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38725 "preproc.c" /* yacc.c:1652  */
    break;

  case 951:
#line 6298 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38732 "preproc.c" /* yacc.c:1652  */
    break;

  case 952:
#line 6305 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("grant"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38740 "preproc.c" /* yacc.c:1652  */
    break;

  case 953:
#line 6313 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("revoke"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38748 "preproc.c" /* yacc.c:1652  */
    break;

  case 954:
#line 6317 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("revoke grant option for"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38756 "preproc.c" /* yacc.c:1652  */
    break;

  case 955:
#line 6325 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38764 "preproc.c" /* yacc.c:1652  */
    break;

  case 956:
#line 6329 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 38772 "preproc.c" /* yacc.c:1652  */
    break;

  case 957:
#line 6333 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all privileges");
}
#line 38780 "preproc.c" /* yacc.c:1652  */
    break;

  case 958:
#line 6337 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("all ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38788 "preproc.c" /* yacc.c:1652  */
    break;

  case 959:
#line 6341 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("all privileges ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38796 "preproc.c" /* yacc.c:1652  */
    break;

  case 960:
#line 6349 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38804 "preproc.c" /* yacc.c:1652  */
    break;

  case 961:
#line 6353 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 38812 "preproc.c" /* yacc.c:1652  */
    break;

  case 962:
#line 6361 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("select"),(yyvsp[0].str));
}
#line 38820 "preproc.c" /* yacc.c:1652  */
    break;

  case 963:
#line 6365 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("references"),(yyvsp[0].str));
}
#line 38828 "preproc.c" /* yacc.c:1652  */
    break;

  case 964:
#line 6369 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("create"),(yyvsp[0].str));
}
#line 38836 "preproc.c" /* yacc.c:1652  */
    break;

  case 965:
#line 6373 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38844 "preproc.c" /* yacc.c:1652  */
    break;

  case 966:
#line 6381 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38852 "preproc.c" /* yacc.c:1652  */
    break;

  case 967:
#line 6385 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 38860 "preproc.c" /* yacc.c:1652  */
    break;

  case 968:
#line 6389 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("sequence"),(yyvsp[0].str));
}
#line 38868 "preproc.c" /* yacc.c:1652  */
    break;

  case 969:
#line 6393 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("foreign data wrapper"),(yyvsp[0].str));
}
#line 38876 "preproc.c" /* yacc.c:1652  */
    break;

  case 970:
#line 6397 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("foreign server"),(yyvsp[0].str));
}
#line 38884 "preproc.c" /* yacc.c:1652  */
    break;

  case 971:
#line 6401 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("function"),(yyvsp[0].str));
}
#line 38892 "preproc.c" /* yacc.c:1652  */
    break;

  case 972:
#line 6405 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("database"),(yyvsp[0].str));
}
#line 38900 "preproc.c" /* yacc.c:1652  */
    break;

  case 973:
#line 6409 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("domain"),(yyvsp[0].str));
}
#line 38908 "preproc.c" /* yacc.c:1652  */
    break;

  case 974:
#line 6413 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 38916 "preproc.c" /* yacc.c:1652  */
    break;

  case 975:
#line 6417 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("large object"),(yyvsp[0].str));
}
#line 38924 "preproc.c" /* yacc.c:1652  */
    break;

  case 976:
#line 6421 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 38932 "preproc.c" /* yacc.c:1652  */
    break;

  case 977:
#line 6425 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("tablespace"),(yyvsp[0].str));
}
#line 38940 "preproc.c" /* yacc.c:1652  */
    break;

  case 978:
#line 6429 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("type"),(yyvsp[0].str));
}
#line 38948 "preproc.c" /* yacc.c:1652  */
    break;

  case 979:
#line 6433 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("all tables in schema"),(yyvsp[0].str));
}
#line 38956 "preproc.c" /* yacc.c:1652  */
    break;

  case 980:
#line 6437 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("all sequences in schema"),(yyvsp[0].str));
}
#line 38964 "preproc.c" /* yacc.c:1652  */
    break;

  case 981:
#line 6441 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("all functions in schema"),(yyvsp[0].str));
}
#line 38972 "preproc.c" /* yacc.c:1652  */
    break;

  case 982:
#line 6449 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38980 "preproc.c" /* yacc.c:1652  */
    break;

  case 983:
#line 6453 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 38988 "preproc.c" /* yacc.c:1652  */
    break;

  case 984:
#line 6461 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38996 "preproc.c" /* yacc.c:1652  */
    break;

  case 985:
#line 6465 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("group"),(yyvsp[0].str));
}
#line 39004 "preproc.c" /* yacc.c:1652  */
    break;

  case 986:
#line 6473 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with grant option");
}
#line 39012 "preproc.c" /* yacc.c:1652  */
    break;

  case 987:
#line 6477 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39019 "preproc.c" /* yacc.c:1652  */
    break;

  case 988:
#line 6484 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39027 "preproc.c" /* yacc.c:1652  */
    break;

  case 989:
#line 6488 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39035 "preproc.c" /* yacc.c:1652  */
    break;

  case 990:
#line 6496 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39043 "preproc.c" /* yacc.c:1652  */
    break;

  case 991:
#line 6504 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("grant"),(yyvsp[-4].str),mm_strdup("to"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39051 "preproc.c" /* yacc.c:1652  */
    break;

  case 992:
#line 6512 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("revoke"),(yyvsp[-4].str),mm_strdup("from"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39059 "preproc.c" /* yacc.c:1652  */
    break;

  case 993:
#line 6516 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("revoke admin option for"),(yyvsp[-4].str),mm_strdup("from"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39067 "preproc.c" /* yacc.c:1652  */
    break;

  case 994:
#line 6524 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with admin option");
}
#line 39075 "preproc.c" /* yacc.c:1652  */
    break;

  case 995:
#line 6528 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39082 "preproc.c" /* yacc.c:1652  */
    break;

  case 996:
#line 6535 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("granted by"),(yyvsp[0].str));
}
#line 39090 "preproc.c" /* yacc.c:1652  */
    break;

  case 997:
#line 6539 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39097 "preproc.c" /* yacc.c:1652  */
    break;

  case 998:
#line 6546 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter default privileges"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39105 "preproc.c" /* yacc.c:1652  */
    break;

  case 999:
#line 6554 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39113 "preproc.c" /* yacc.c:1652  */
    break;

  case 1000:
#line 6558 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39120 "preproc.c" /* yacc.c:1652  */
    break;

  case 1001:
#line 6565 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("in schema"),(yyvsp[0].str));
}
#line 39128 "preproc.c" /* yacc.c:1652  */
    break;

  case 1002:
#line 6569 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for role"),(yyvsp[0].str));
}
#line 39136 "preproc.c" /* yacc.c:1652  */
    break;

  case 1003:
#line 6573 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for user"),(yyvsp[0].str));
}
#line 39144 "preproc.c" /* yacc.c:1652  */
    break;

  case 1004:
#line 6581 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("grant"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39152 "preproc.c" /* yacc.c:1652  */
    break;

  case 1005:
#line 6585 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("revoke"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39160 "preproc.c" /* yacc.c:1652  */
    break;

  case 1006:
#line 6589 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("revoke grant option for"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39168 "preproc.c" /* yacc.c:1652  */
    break;

  case 1007:
#line 6597 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tables");
}
#line 39176 "preproc.c" /* yacc.c:1652  */
    break;

  case 1008:
#line 6601 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("functions");
}
#line 39184 "preproc.c" /* yacc.c:1652  */
    break;

  case 1009:
#line 6605 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequences");
}
#line 39192 "preproc.c" /* yacc.c:1652  */
    break;

  case 1010:
#line 6609 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("types");
}
#line 39200 "preproc.c" /* yacc.c:1652  */
    break;

  case 1011:
#line 6617 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(14,mm_strdup("create"),(yyvsp[-12].str),mm_strdup("index"),(yyvsp[-10].str),(yyvsp[-9].str),mm_strdup("on"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39208 "preproc.c" /* yacc.c:1652  */
    break;

  case 1012:
#line 6621 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(15,mm_strdup("create"),(yyvsp[-15].str),mm_strdup("index"),(yyvsp[-13].str),mm_strdup("if not exists"),(yyvsp[-9].str),mm_strdup("on"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39216 "preproc.c" /* yacc.c:1652  */
    break;

  case 1013:
#line 6629 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unique");
}
#line 39224 "preproc.c" /* yacc.c:1652  */
    break;

  case 1014:
#line 6633 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39231 "preproc.c" /* yacc.c:1652  */
    break;

  case 1015:
#line 6640 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("concurrently");
}
#line 39239 "preproc.c" /* yacc.c:1652  */
    break;

  case 1016:
#line 6644 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39246 "preproc.c" /* yacc.c:1652  */
    break;

  case 1017:
#line 6651 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39254 "preproc.c" /* yacc.c:1652  */
    break;

  case 1018:
#line 6655 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39261 "preproc.c" /* yacc.c:1652  */
    break;

  case 1019:
#line 6662 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 39269 "preproc.c" /* yacc.c:1652  */
    break;

  case 1020:
#line 6666 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39276 "preproc.c" /* yacc.c:1652  */
    break;

  case 1021:
#line 6673 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39284 "preproc.c" /* yacc.c:1652  */
    break;

  case 1022:
#line 6677 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39292 "preproc.c" /* yacc.c:1652  */
    break;

  case 1023:
#line 6685 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39300 "preproc.c" /* yacc.c:1652  */
    break;

  case 1024:
#line 6689 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39308 "preproc.c" /* yacc.c:1652  */
    break;

  case 1025:
#line 6693 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39316 "preproc.c" /* yacc.c:1652  */
    break;

  case 1026:
#line 6701 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 39324 "preproc.c" /* yacc.c:1652  */
    break;

  case 1027:
#line 6705 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39331 "preproc.c" /* yacc.c:1652  */
    break;

  case 1028:
#line 6712 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39339 "preproc.c" /* yacc.c:1652  */
    break;

  case 1029:
#line 6716 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39346 "preproc.c" /* yacc.c:1652  */
    break;

  case 1030:
#line 6723 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("asc");
}
#line 39354 "preproc.c" /* yacc.c:1652  */
    break;

  case 1031:
#line 6727 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("desc");
}
#line 39362 "preproc.c" /* yacc.c:1652  */
    break;

  case 1032:
#line 6731 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39369 "preproc.c" /* yacc.c:1652  */
    break;

  case 1033:
#line 6738 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nulls first");
}
#line 39377 "preproc.c" /* yacc.c:1652  */
    break;

  case 1034:
#line 6742 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nulls last");
}
#line 39385 "preproc.c" /* yacc.c:1652  */
    break;

  case 1035:
#line 6746 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39392 "preproc.c" /* yacc.c:1652  */
    break;

  case 1036:
#line 6753 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("function"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("returns"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39400 "preproc.c" /* yacc.c:1652  */
    break;

  case 1037:
#line 6757 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-10].str),mm_strdup("function"),(yyvsp[-8].str),(yyvsp[-7].str),mm_strdup("returns table ("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39408 "preproc.c" /* yacc.c:1652  */
    break;

  case 1038:
#line 6761 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create"),(yyvsp[-5].str),mm_strdup("function"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39416 "preproc.c" /* yacc.c:1652  */
    break;

  case 1039:
#line 6769 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("or replace");
}
#line 39424 "preproc.c" /* yacc.c:1652  */
    break;

  case 1040:
#line 6773 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39431 "preproc.c" /* yacc.c:1652  */
    break;

  case 1041:
#line 6780 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39439 "preproc.c" /* yacc.c:1652  */
    break;

  case 1042:
#line 6784 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("( )");
}
#line 39447 "preproc.c" /* yacc.c:1652  */
    break;

  case 1043:
#line 6792 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39455 "preproc.c" /* yacc.c:1652  */
    break;

  case 1044:
#line 6796 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39463 "preproc.c" /* yacc.c:1652  */
    break;

  case 1045:
#line 6804 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39471 "preproc.c" /* yacc.c:1652  */
    break;

  case 1046:
#line 6808 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("( )");
}
#line 39479 "preproc.c" /* yacc.c:1652  */
    break;

  case 1047:
#line 6816 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39487 "preproc.c" /* yacc.c:1652  */
    break;

  case 1048:
#line 6820 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39495 "preproc.c" /* yacc.c:1652  */
    break;

  case 1049:
#line 6828 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39503 "preproc.c" /* yacc.c:1652  */
    break;

  case 1050:
#line 6832 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39511 "preproc.c" /* yacc.c:1652  */
    break;

  case 1051:
#line 6836 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39519 "preproc.c" /* yacc.c:1652  */
    break;

  case 1052:
#line 6840 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39527 "preproc.c" /* yacc.c:1652  */
    break;

  case 1053:
#line 6844 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39535 "preproc.c" /* yacc.c:1652  */
    break;

  case 1054:
#line 6852 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("in");
}
#line 39543 "preproc.c" /* yacc.c:1652  */
    break;

  case 1055:
#line 6856 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("out");
}
#line 39551 "preproc.c" /* yacc.c:1652  */
    break;

  case 1056:
#line 6860 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inout");
}
#line 39559 "preproc.c" /* yacc.c:1652  */
    break;

  case 1057:
#line 6864 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("in out");
}
#line 39567 "preproc.c" /* yacc.c:1652  */
    break;

  case 1058:
#line 6868 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("variadic");
}
#line 39575 "preproc.c" /* yacc.c:1652  */
    break;

  case 1059:
#line 6876 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39583 "preproc.c" /* yacc.c:1652  */
    break;

  case 1060:
#line 6884 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39591 "preproc.c" /* yacc.c:1652  */
    break;

  case 1061:
#line 6892 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39599 "preproc.c" /* yacc.c:1652  */
    break;

  case 1062:
#line 6896 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("% type"));
}
#line 39607 "preproc.c" /* yacc.c:1652  */
    break;

  case 1063:
#line 6900 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("setof"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("% type"));
}
#line 39615 "preproc.c" /* yacc.c:1652  */
    break;

  case 1064:
#line 6908 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39623 "preproc.c" /* yacc.c:1652  */
    break;

  case 1065:
#line 6912 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("default"),(yyvsp[0].str));
}
#line 39631 "preproc.c" /* yacc.c:1652  */
    break;

  case 1066:
#line 6916 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 39639 "preproc.c" /* yacc.c:1652  */
    break;

  case 1067:
#line 6924 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = (yyvsp[0].str);
}
#line 39648 "preproc.c" /* yacc.c:1652  */
    break;

  case 1068:
#line 6933 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("( * )");
}
#line 39656 "preproc.c" /* yacc.c:1652  */
    break;

  case 1069:
#line 6937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39664 "preproc.c" /* yacc.c:1652  */
    break;

  case 1070:
#line 6941 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("( order by"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39672 "preproc.c" /* yacc.c:1652  */
    break;

  case 1071:
#line 6945 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-4].str),mm_strdup("order by"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39680 "preproc.c" /* yacc.c:1652  */
    break;

  case 1072:
#line 6953 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39688 "preproc.c" /* yacc.c:1652  */
    break;

  case 1073:
#line 6957 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39696 "preproc.c" /* yacc.c:1652  */
    break;

  case 1074:
#line 6965 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39704 "preproc.c" /* yacc.c:1652  */
    break;

  case 1075:
#line 6969 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39712 "preproc.c" /* yacc.c:1652  */
    break;

  case 1076:
#line 6977 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("called on null input");
}
#line 39720 "preproc.c" /* yacc.c:1652  */
    break;

  case 1077:
#line 6981 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("returns null on null input");
}
#line 39728 "preproc.c" /* yacc.c:1652  */
    break;

  case 1078:
#line 6985 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("strict");
}
#line 39736 "preproc.c" /* yacc.c:1652  */
    break;

  case 1079:
#line 6989 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("immutable");
}
#line 39744 "preproc.c" /* yacc.c:1652  */
    break;

  case 1080:
#line 6993 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stable");
}
#line 39752 "preproc.c" /* yacc.c:1652  */
    break;

  case 1081:
#line 6997 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("volatile");
}
#line 39760 "preproc.c" /* yacc.c:1652  */
    break;

  case 1082:
#line 7001 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("external security definer");
}
#line 39768 "preproc.c" /* yacc.c:1652  */
    break;

  case 1083:
#line 7005 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("external security invoker");
}
#line 39776 "preproc.c" /* yacc.c:1652  */
    break;

  case 1084:
#line 7009 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("security definer");
}
#line 39784 "preproc.c" /* yacc.c:1652  */
    break;

  case 1085:
#line 7013 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("security invoker");
}
#line 39792 "preproc.c" /* yacc.c:1652  */
    break;

  case 1086:
#line 7017 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("leakproof");
}
#line 39800 "preproc.c" /* yacc.c:1652  */
    break;

  case 1087:
#line 7021 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not leakproof");
}
#line 39808 "preproc.c" /* yacc.c:1652  */
    break;

  case 1088:
#line 7025 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("cost"),(yyvsp[0].str));
}
#line 39816 "preproc.c" /* yacc.c:1652  */
    break;

  case 1089:
#line 7029 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("rows"),(yyvsp[0].str));
}
#line 39824 "preproc.c" /* yacc.c:1652  */
    break;

  case 1090:
#line 7033 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39832 "preproc.c" /* yacc.c:1652  */
    break;

  case 1091:
#line 7037 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("parallel"),(yyvsp[0].str));
}
#line 39840 "preproc.c" /* yacc.c:1652  */
    break;

  case 1092:
#line 7045 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 39848 "preproc.c" /* yacc.c:1652  */
    break;

  case 1093:
#line 7049 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 39856 "preproc.c" /* yacc.c:1652  */
    break;

  case 1094:
#line 7053 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("transform"),(yyvsp[0].str));
}
#line 39864 "preproc.c" /* yacc.c:1652  */
    break;

  case 1095:
#line 7057 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("window");
}
#line 39872 "preproc.c" /* yacc.c:1652  */
    break;

  case 1096:
#line 7061 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39880 "preproc.c" /* yacc.c:1652  */
    break;

  case 1097:
#line 7069 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39888 "preproc.c" /* yacc.c:1652  */
    break;

  case 1098:
#line 7073 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39896 "preproc.c" /* yacc.c:1652  */
    break;

  case 1099:
#line 7081 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for type"),(yyvsp[0].str));
}
#line 39904 "preproc.c" /* yacc.c:1652  */
    break;

  case 1100:
#line 7085 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup(", for type"),(yyvsp[0].str));
}
#line 39912 "preproc.c" /* yacc.c:1652  */
    break;

  case 1101:
#line 7093 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 39920 "preproc.c" /* yacc.c:1652  */
    break;

  case 1102:
#line 7097 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39927 "preproc.c" /* yacc.c:1652  */
    break;

  case 1103:
#line 7104 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39935 "preproc.c" /* yacc.c:1652  */
    break;

  case 1104:
#line 7112 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39943 "preproc.c" /* yacc.c:1652  */
    break;

  case 1105:
#line 7116 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39951 "preproc.c" /* yacc.c:1652  */
    break;

  case 1106:
#line 7124 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39959 "preproc.c" /* yacc.c:1652  */
    break;

  case 1107:
#line 7132 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39967 "preproc.c" /* yacc.c:1652  */
    break;

  case 1108:
#line 7136 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39975 "preproc.c" /* yacc.c:1652  */
    break;

  case 1109:
#line 7144 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restrict");
}
#line 39983 "preproc.c" /* yacc.c:1652  */
    break;

  case 1110:
#line 7148 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39990 "preproc.c" /* yacc.c:1652  */
    break;

  case 1111:
#line 7155 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop function"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39998 "preproc.c" /* yacc.c:1652  */
    break;

  case 1112:
#line 7159 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop function if exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40006 "preproc.c" /* yacc.c:1652  */
    break;

  case 1113:
#line 7167 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop aggregate"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40014 "preproc.c" /* yacc.c:1652  */
    break;

  case 1114:
#line 7171 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop aggregate if exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40022 "preproc.c" /* yacc.c:1652  */
    break;

  case 1115:
#line 7179 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop operator"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40030 "preproc.c" /* yacc.c:1652  */
    break;

  case 1116:
#line 7183 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop operator if exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40038 "preproc.c" /* yacc.c:1652  */
    break;

  case 1117:
#line 7191 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40046 "preproc.c" /* yacc.c:1652  */
    break;

  case 1118:
#line 7195 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40054 "preproc.c" /* yacc.c:1652  */
    break;

  case 1119:
#line 7199 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("( none ,"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40062 "preproc.c" /* yacc.c:1652  */
    break;

  case 1120:
#line 7203 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-3].str),mm_strdup(", none )"));
}
#line 40070 "preproc.c" /* yacc.c:1652  */
    break;

  case 1121:
#line 7211 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40078 "preproc.c" /* yacc.c:1652  */
    break;

  case 1122:
#line 7215 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 40086 "preproc.c" /* yacc.c:1652  */
    break;

  case 1123:
#line 7223 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("do"),(yyvsp[0].str));
}
#line 40094 "preproc.c" /* yacc.c:1652  */
    break;

  case 1124:
#line 7231 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40102 "preproc.c" /* yacc.c:1652  */
    break;

  case 1125:
#line 7235 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40110 "preproc.c" /* yacc.c:1652  */
    break;

  case 1126:
#line 7243 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40118 "preproc.c" /* yacc.c:1652  */
    break;

  case 1127:
#line 7247 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 40126 "preproc.c" /* yacc.c:1652  */
    break;

  case 1128:
#line 7255 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create cast ("),(yyvsp[-7].str),mm_strdup("as"),(yyvsp[-5].str),mm_strdup(") with function"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40134 "preproc.c" /* yacc.c:1652  */
    break;

  case 1129:
#line 7259 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create cast ("),(yyvsp[-6].str),mm_strdup("as"),(yyvsp[-4].str),mm_strdup(") without function"),(yyvsp[0].str));
}
#line 40142 "preproc.c" /* yacc.c:1652  */
    break;

  case 1130:
#line 7263 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create cast ("),(yyvsp[-6].str),mm_strdup("as"),(yyvsp[-4].str),mm_strdup(") with inout"),(yyvsp[0].str));
}
#line 40150 "preproc.c" /* yacc.c:1652  */
    break;

  case 1131:
#line 7271 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("as implicit");
}
#line 40158 "preproc.c" /* yacc.c:1652  */
    break;

  case 1132:
#line 7275 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("as assignment");
}
#line 40166 "preproc.c" /* yacc.c:1652  */
    break;

  case 1133:
#line 7279 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40173 "preproc.c" /* yacc.c:1652  */
    break;

  case 1134:
#line 7286 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("drop cast"),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup("as"),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 40181 "preproc.c" /* yacc.c:1652  */
    break;

  case 1135:
#line 7294 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("if exists");
}
#line 40189 "preproc.c" /* yacc.c:1652  */
    break;

  case 1136:
#line 7298 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40196 "preproc.c" /* yacc.c:1652  */
    break;

  case 1137:
#line 7305 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-8].str),mm_strdup("transform for"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40204 "preproc.c" /* yacc.c:1652  */
    break;

  case 1138:
#line 7313 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("from sql with function"),(yyvsp[-6].str),mm_strdup(", to sql with function"),(yyvsp[0].str));
}
#line 40212 "preproc.c" /* yacc.c:1652  */
    break;

  case 1139:
#line 7317 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("to sql with function"),(yyvsp[-6].str),mm_strdup(", from sql with function"),(yyvsp[0].str));
}
#line 40220 "preproc.c" /* yacc.c:1652  */
    break;

  case 1140:
#line 7321 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from sql with function"),(yyvsp[0].str));
}
#line 40228 "preproc.c" /* yacc.c:1652  */
    break;

  case 1141:
#line 7325 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("to sql with function"),(yyvsp[0].str));
}
#line 40236 "preproc.c" /* yacc.c:1652  */
    break;

  case 1142:
#line 7333 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("drop transform"),(yyvsp[-5].str),mm_strdup("for"),(yyvsp[-3].str),mm_strdup("language"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40244 "preproc.c" /* yacc.c:1652  */
    break;

  case 1143:
#line 7341 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("reindex"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40252 "preproc.c" /* yacc.c:1652  */
    break;

  case 1144:
#line 7345 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("reindex"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40260 "preproc.c" /* yacc.c:1652  */
    break;

  case 1145:
#line 7349 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("reindex ("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40268 "preproc.c" /* yacc.c:1652  */
    break;

  case 1146:
#line 7353 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("reindex ("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40276 "preproc.c" /* yacc.c:1652  */
    break;

  case 1147:
#line 7361 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("index");
}
#line 40284 "preproc.c" /* yacc.c:1652  */
    break;

  case 1148:
#line 7365 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 40292 "preproc.c" /* yacc.c:1652  */
    break;

  case 1149:
#line 7373 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schema");
}
#line 40300 "preproc.c" /* yacc.c:1652  */
    break;

  case 1150:
#line 7377 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("system");
}
#line 40308 "preproc.c" /* yacc.c:1652  */
    break;

  case 1151:
#line 7381 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("database");
}
#line 40316 "preproc.c" /* yacc.c:1652  */
    break;

  case 1152:
#line 7389 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40324 "preproc.c" /* yacc.c:1652  */
    break;

  case 1153:
#line 7393 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40332 "preproc.c" /* yacc.c:1652  */
    break;

  case 1154:
#line 7401 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("verbose");
}
#line 40340 "preproc.c" /* yacc.c:1652  */
    break;

  case 1155:
#line 7409 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 40348 "preproc.c" /* yacc.c:1652  */
    break;

  case 1156:
#line 7413 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-2].str),mm_strdup("reset"),(yyvsp[0].str));
}
#line 40356 "preproc.c" /* yacc.c:1652  */
    break;

  case 1157:
#line 7421 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter aggregate"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40364 "preproc.c" /* yacc.c:1652  */
    break;

  case 1158:
#line 7425 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40372 "preproc.c" /* yacc.c:1652  */
    break;

  case 1159:
#line 7429 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40380 "preproc.c" /* yacc.c:1652  */
    break;

  case 1160:
#line 7433 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40388 "preproc.c" /* yacc.c:1652  */
    break;

  case 1161:
#line 7437 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40396 "preproc.c" /* yacc.c:1652  */
    break;

  case 1162:
#line 7441 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter domain"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 40404 "preproc.c" /* yacc.c:1652  */
    break;

  case 1163:
#line 7445 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40412 "preproc.c" /* yacc.c:1652  */
    break;

  case 1164:
#line 7449 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40420 "preproc.c" /* yacc.c:1652  */
    break;

  case 1165:
#line 7453 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter group"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40428 "preproc.c" /* yacc.c:1652  */
    break;

  case 1166:
#line 7457 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40436 "preproc.c" /* yacc.c:1652  */
    break;

  case 1167:
#line 7461 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40444 "preproc.c" /* yacc.c:1652  */
    break;

  case 1168:
#line 7465 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40452 "preproc.c" /* yacc.c:1652  */
    break;

  case 1169:
#line 7469 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter policy"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40460 "preproc.c" /* yacc.c:1652  */
    break;

  case 1170:
#line 7473 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter policy if exists"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40468 "preproc.c" /* yacc.c:1652  */
    break;

  case 1171:
#line 7477 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter schema"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40476 "preproc.c" /* yacc.c:1652  */
    break;

  case 1172:
#line 7481 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40484 "preproc.c" /* yacc.c:1652  */
    break;

  case 1173:
#line 7485 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter table"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40492 "preproc.c" /* yacc.c:1652  */
    break;

  case 1174:
#line 7489 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter table if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40500 "preproc.c" /* yacc.c:1652  */
    break;

  case 1175:
#line 7493 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40508 "preproc.c" /* yacc.c:1652  */
    break;

  case 1176:
#line 7497 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40516 "preproc.c" /* yacc.c:1652  */
    break;

  case 1177:
#line 7501 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter view"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40524 "preproc.c" /* yacc.c:1652  */
    break;

  case 1178:
#line 7505 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter view if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40532 "preproc.c" /* yacc.c:1652  */
    break;

  case 1179:
#line 7509 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40540 "preproc.c" /* yacc.c:1652  */
    break;

  case 1180:
#line 7513 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40548 "preproc.c" /* yacc.c:1652  */
    break;

  case 1181:
#line 7517 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter index"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40556 "preproc.c" /* yacc.c:1652  */
    break;

  case 1182:
#line 7521 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter index if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40564 "preproc.c" /* yacc.c:1652  */
    break;

  case 1183:
#line 7525 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40572 "preproc.c" /* yacc.c:1652  */
    break;

  case 1184:
#line 7529 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40580 "preproc.c" /* yacc.c:1652  */
    break;

  case 1185:
#line 7533 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter table"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 40588 "preproc.c" /* yacc.c:1652  */
    break;

  case 1186:
#line 7537 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter table if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 40596 "preproc.c" /* yacc.c:1652  */
    break;

  case 1187:
#line 7541 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 40604 "preproc.c" /* yacc.c:1652  */
    break;

  case 1188:
#line 7545 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 40612 "preproc.c" /* yacc.c:1652  */
    break;

  case 1189:
#line 7549 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter table"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 40620 "preproc.c" /* yacc.c:1652  */
    break;

  case 1190:
#line 7553 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter table if exists"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 40628 "preproc.c" /* yacc.c:1652  */
    break;

  case 1191:
#line 7557 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter foreign table"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 40636 "preproc.c" /* yacc.c:1652  */
    break;

  case 1192:
#line 7561 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter foreign table if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 40644 "preproc.c" /* yacc.c:1652  */
    break;

  case 1193:
#line 7565 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter rule"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40652 "preproc.c" /* yacc.c:1652  */
    break;

  case 1194:
#line 7569 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter trigger"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40660 "preproc.c" /* yacc.c:1652  */
    break;

  case 1195:
#line 7573 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter event trigger"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40668 "preproc.c" /* yacc.c:1652  */
    break;

  case 1196:
#line 7577 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40676 "preproc.c" /* yacc.c:1652  */
    break;

  case 1197:
#line 7581 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40684 "preproc.c" /* yacc.c:1652  */
    break;

  case 1198:
#line 7585 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40692 "preproc.c" /* yacc.c:1652  */
    break;

  case 1199:
#line 7589 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search parser"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40700 "preproc.c" /* yacc.c:1652  */
    break;

  case 1200:
#line 7593 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40708 "preproc.c" /* yacc.c:1652  */
    break;

  case 1201:
#line 7597 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search template"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40716 "preproc.c" /* yacc.c:1652  */
    break;

  case 1202:
#line 7601 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40724 "preproc.c" /* yacc.c:1652  */
    break;

  case 1203:
#line 7605 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 40732 "preproc.c" /* yacc.c:1652  */
    break;

  case 1204:
#line 7609 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("rename attribute"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40740 "preproc.c" /* yacc.c:1652  */
    break;

  case 1205:
#line 7617 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("column");
}
#line 40748 "preproc.c" /* yacc.c:1652  */
    break;

  case 1206:
#line 7621 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40755 "preproc.c" /* yacc.c:1652  */
    break;

  case 1207:
#line 7628 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set data");
}
#line 40763 "preproc.c" /* yacc.c:1652  */
    break;

  case 1208:
#line 7632 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40770 "preproc.c" /* yacc.c:1652  */
    break;

  case 1209:
#line 7639 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 40778 "preproc.c" /* yacc.c:1652  */
    break;

  case 1210:
#line 7643 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter trigger"),(yyvsp[-6].str),mm_strdup("on"),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 40786 "preproc.c" /* yacc.c:1652  */
    break;

  case 1211:
#line 7647 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view"),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 40794 "preproc.c" /* yacc.c:1652  */
    break;

  case 1212:
#line 7651 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter index"),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 40802 "preproc.c" /* yacc.c:1652  */
    break;

  case 1213:
#line 7659 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter aggregate"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40810 "preproc.c" /* yacc.c:1652  */
    break;

  case 1214:
#line 7663 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40818 "preproc.c" /* yacc.c:1652  */
    break;

  case 1215:
#line 7667 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40826 "preproc.c" /* yacc.c:1652  */
    break;

  case 1216:
#line 7671 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40834 "preproc.c" /* yacc.c:1652  */
    break;

  case 1217:
#line 7675 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter extension"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40842 "preproc.c" /* yacc.c:1652  */
    break;

  case 1218:
#line 7679 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40850 "preproc.c" /* yacc.c:1652  */
    break;

  case 1219:
#line 7683 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter operator"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40858 "preproc.c" /* yacc.c:1652  */
    break;

  case 1220:
#line 7687 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40866 "preproc.c" /* yacc.c:1652  */
    break;

  case 1221:
#line 7691 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40874 "preproc.c" /* yacc.c:1652  */
    break;

  case 1222:
#line 7695 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter table"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40882 "preproc.c" /* yacc.c:1652  */
    break;

  case 1223:
#line 7699 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter table if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40890 "preproc.c" /* yacc.c:1652  */
    break;

  case 1224:
#line 7703 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search parser"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40898 "preproc.c" /* yacc.c:1652  */
    break;

  case 1225:
#line 7707 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40906 "preproc.c" /* yacc.c:1652  */
    break;

  case 1226:
#line 7711 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search template"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40914 "preproc.c" /* yacc.c:1652  */
    break;

  case 1227:
#line 7715 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40922 "preproc.c" /* yacc.c:1652  */
    break;

  case 1228:
#line 7719 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40930 "preproc.c" /* yacc.c:1652  */
    break;

  case 1229:
#line 7723 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40938 "preproc.c" /* yacc.c:1652  */
    break;

  case 1230:
#line 7727 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter view"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40946 "preproc.c" /* yacc.c:1652  */
    break;

  case 1231:
#line 7731 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter view if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40954 "preproc.c" /* yacc.c:1652  */
    break;

  case 1232:
#line 7735 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40962 "preproc.c" /* yacc.c:1652  */
    break;

  case 1233:
#line 7739 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40970 "preproc.c" /* yacc.c:1652  */
    break;

  case 1234:
#line 7743 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40978 "preproc.c" /* yacc.c:1652  */
    break;

  case 1235:
#line 7747 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40986 "preproc.c" /* yacc.c:1652  */
    break;

  case 1236:
#line 7751 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 40994 "preproc.c" /* yacc.c:1652  */
    break;

  case 1237:
#line 7759 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("set ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41002 "preproc.c" /* yacc.c:1652  */
    break;

  case 1238:
#line 7767 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41010 "preproc.c" /* yacc.c:1652  */
    break;

  case 1239:
#line 7771 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41018 "preproc.c" /* yacc.c:1652  */
    break;

  case 1240:
#line 7779 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("= none"));
}
#line 41026 "preproc.c" /* yacc.c:1652  */
    break;

  case 1241:
#line 7783 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 41034 "preproc.c" /* yacc.c:1652  */
    break;

  case 1242:
#line 7791 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter aggregate"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41042 "preproc.c" /* yacc.c:1652  */
    break;

  case 1243:
#line 7795 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41050 "preproc.c" /* yacc.c:1652  */
    break;

  case 1244:
#line 7799 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41058 "preproc.c" /* yacc.c:1652  */
    break;

  case 1245:
#line 7803 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41066 "preproc.c" /* yacc.c:1652  */
    break;

  case 1246:
#line 7807 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41074 "preproc.c" /* yacc.c:1652  */
    break;

  case 1247:
#line 7811 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41082 "preproc.c" /* yacc.c:1652  */
    break;

  case 1248:
#line 7815 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41090 "preproc.c" /* yacc.c:1652  */
    break;

  case 1249:
#line 7819 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter large object"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41098 "preproc.c" /* yacc.c:1652  */
    break;

  case 1250:
#line 7823 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter operator"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41106 "preproc.c" /* yacc.c:1652  */
    break;

  case 1251:
#line 7827 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41114 "preproc.c" /* yacc.c:1652  */
    break;

  case 1252:
#line 7831 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41122 "preproc.c" /* yacc.c:1652  */
    break;

  case 1253:
#line 7835 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter schema"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41130 "preproc.c" /* yacc.c:1652  */
    break;

  case 1254:
#line 7839 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41138 "preproc.c" /* yacc.c:1652  */
    break;

  case 1255:
#line 7843 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41146 "preproc.c" /* yacc.c:1652  */
    break;

  case 1256:
#line 7847 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41154 "preproc.c" /* yacc.c:1652  */
    break;

  case 1257:
#line 7851 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41162 "preproc.c" /* yacc.c:1652  */
    break;

  case 1258:
#line 7855 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41170 "preproc.c" /* yacc.c:1652  */
    break;

  case 1259:
#line 7859 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41178 "preproc.c" /* yacc.c:1652  */
    break;

  case 1260:
#line 7863 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter event trigger"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 41186 "preproc.c" /* yacc.c:1652  */
    break;

  case 1261:
#line 7871 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(12,mm_strdup("create"),(yyvsp[-11].str),mm_strdup("rule"),(yyvsp[-9].str),mm_strdup("as on"),(yyvsp[-6].str),mm_strdup("to"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("do"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41194 "preproc.c" /* yacc.c:1652  */
    break;

  case 1262:
#line 7879 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nothing");
}
#line 41202 "preproc.c" /* yacc.c:1652  */
    break;

  case 1263:
#line 7883 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41210 "preproc.c" /* yacc.c:1652  */
    break;

  case 1264:
#line 7887 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41218 "preproc.c" /* yacc.c:1652  */
    break;

  case 1265:
#line 7895 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(";"),(yyvsp[0].str));
}
#line 41226 "preproc.c" /* yacc.c:1652  */
    break;

  case 1266:
#line 7899 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41234 "preproc.c" /* yacc.c:1652  */
    break;

  case 1267:
#line 7907 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41242 "preproc.c" /* yacc.c:1652  */
    break;

  case 1268:
#line 7911 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41250 "preproc.c" /* yacc.c:1652  */
    break;

  case 1269:
#line 7915 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41258 "preproc.c" /* yacc.c:1652  */
    break;

  case 1270:
#line 7919 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41266 "preproc.c" /* yacc.c:1652  */
    break;

  case 1271:
#line 7923 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41274 "preproc.c" /* yacc.c:1652  */
    break;

  case 1272:
#line 7931 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41282 "preproc.c" /* yacc.c:1652  */
    break;

  case 1273:
#line 7935 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41289 "preproc.c" /* yacc.c:1652  */
    break;

  case 1274:
#line 7942 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("select");
}
#line 41297 "preproc.c" /* yacc.c:1652  */
    break;

  case 1275:
#line 7946 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("update");
}
#line 41305 "preproc.c" /* yacc.c:1652  */
    break;

  case 1276:
#line 7950 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delete");
}
#line 41313 "preproc.c" /* yacc.c:1652  */
    break;

  case 1277:
#line 7954 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("insert");
}
#line 41321 "preproc.c" /* yacc.c:1652  */
    break;

  case 1278:
#line 7962 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("instead");
}
#line 41329 "preproc.c" /* yacc.c:1652  */
    break;

  case 1279:
#line 7966 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("also");
}
#line 41337 "preproc.c" /* yacc.c:1652  */
    break;

  case 1280:
#line 7970 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41344 "preproc.c" /* yacc.c:1652  */
    break;

  case 1281:
#line 7977 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop rule"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41352 "preproc.c" /* yacc.c:1652  */
    break;

  case 1282:
#line 7981 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop rule if exists"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41360 "preproc.c" /* yacc.c:1652  */
    break;

  case 1283:
#line 7989 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("notify"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41368 "preproc.c" /* yacc.c:1652  */
    break;

  case 1284:
#line 7997 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup(","),(yyvsp[0].str));
}
#line 41376 "preproc.c" /* yacc.c:1652  */
    break;

  case 1285:
#line 8001 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41383 "preproc.c" /* yacc.c:1652  */
    break;

  case 1286:
#line 8008 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("listen"),(yyvsp[0].str));
}
#line 41391 "preproc.c" /* yacc.c:1652  */
    break;

  case 1287:
#line 8016 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("unlisten"),(yyvsp[0].str));
}
#line 41399 "preproc.c" /* yacc.c:1652  */
    break;

  case 1288:
#line 8020 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unlisten *");
}
#line 41407 "preproc.c" /* yacc.c:1652  */
    break;

  case 1289:
#line 8028 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("abort"),(yyvsp[0].str));
}
#line 41415 "preproc.c" /* yacc.c:1652  */
    break;

  case 1290:
#line 8032 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("begin"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41423 "preproc.c" /* yacc.c:1652  */
    break;

  case 1291:
#line 8036 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("start transaction"),(yyvsp[0].str));
}
#line 41431 "preproc.c" /* yacc.c:1652  */
    break;

  case 1292:
#line 8040 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("commit"),(yyvsp[0].str));
}
#line 41439 "preproc.c" /* yacc.c:1652  */
    break;

  case 1293:
#line 8044 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("end"),(yyvsp[0].str));
}
#line 41447 "preproc.c" /* yacc.c:1652  */
    break;

  case 1294:
#line 8048 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("rollback"),(yyvsp[0].str));
}
#line 41455 "preproc.c" /* yacc.c:1652  */
    break;

  case 1295:
#line 8052 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("savepoint"),(yyvsp[0].str));
}
#line 41463 "preproc.c" /* yacc.c:1652  */
    break;

  case 1296:
#line 8056 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("release savepoint"),(yyvsp[0].str));
}
#line 41471 "preproc.c" /* yacc.c:1652  */
    break;

  case 1297:
#line 8060 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("release"),(yyvsp[0].str));
}
#line 41479 "preproc.c" /* yacc.c:1652  */
    break;

  case 1298:
#line 8064 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("rollback"),(yyvsp[-3].str),mm_strdup("to savepoint"),(yyvsp[0].str));
}
#line 41487 "preproc.c" /* yacc.c:1652  */
    break;

  case 1299:
#line 8068 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("rollback"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 41495 "preproc.c" /* yacc.c:1652  */
    break;

  case 1300:
#line 8072 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("prepare transaction"),(yyvsp[0].str));
}
#line 41503 "preproc.c" /* yacc.c:1652  */
    break;

  case 1301:
#line 8076 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("commit prepared"),(yyvsp[0].str));
}
#line 41511 "preproc.c" /* yacc.c:1652  */
    break;

  case 1302:
#line 8080 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("rollback prepared"),(yyvsp[0].str));
}
#line 41519 "preproc.c" /* yacc.c:1652  */
    break;

  case 1303:
#line 8088 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("work");
}
#line 41527 "preproc.c" /* yacc.c:1652  */
    break;

  case 1304:
#line 8092 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("transaction");
}
#line 41535 "preproc.c" /* yacc.c:1652  */
    break;

  case 1305:
#line 8096 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41542 "preproc.c" /* yacc.c:1652  */
    break;

  case 1306:
#line 8103 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("isolation level"),(yyvsp[0].str));
}
#line 41550 "preproc.c" /* yacc.c:1652  */
    break;

  case 1307:
#line 8107 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("read only");
}
#line 41558 "preproc.c" /* yacc.c:1652  */
    break;

  case 1308:
#line 8111 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("read write");
}
#line 41566 "preproc.c" /* yacc.c:1652  */
    break;

  case 1309:
#line 8115 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 41574 "preproc.c" /* yacc.c:1652  */
    break;

  case 1310:
#line 8119 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 41582 "preproc.c" /* yacc.c:1652  */
    break;

  case 1311:
#line 8127 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41590 "preproc.c" /* yacc.c:1652  */
    break;

  case 1312:
#line 8131 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41598 "preproc.c" /* yacc.c:1652  */
    break;

  case 1313:
#line 8135 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41606 "preproc.c" /* yacc.c:1652  */
    break;

  case 1314:
#line 8143 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41614 "preproc.c" /* yacc.c:1652  */
    break;

  case 1315:
#line 8147 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41621 "preproc.c" /* yacc.c:1652  */
    break;

  case 1316:
#line 8154 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("view"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41629 "preproc.c" /* yacc.c:1652  */
    break;

  case 1317:
#line 8158 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create or replace"),(yyvsp[-7].str),mm_strdup("view"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41637 "preproc.c" /* yacc.c:1652  */
    break;

  case 1318:
#line 8162 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(11,mm_strdup("create"),(yyvsp[-10].str),mm_strdup("recursive view"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41646 "preproc.c" /* yacc.c:1652  */
    break;

  case 1319:
#line 8167 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(11,mm_strdup("create or replace"),(yyvsp[-10].str),mm_strdup("recursive view"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41655 "preproc.c" /* yacc.c:1652  */
    break;

  case 1320:
#line 8176 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with check option");
}
#line 41663 "preproc.c" /* yacc.c:1652  */
    break;

  case 1321:
#line 8180 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with cascaded check option");
}
#line 41671 "preproc.c" /* yacc.c:1652  */
    break;

  case 1322:
#line 8184 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with local check option");
}
#line 41679 "preproc.c" /* yacc.c:1652  */
    break;

  case 1323:
#line 8188 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41686 "preproc.c" /* yacc.c:1652  */
    break;

  case 1324:
#line 8195 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("load"),(yyvsp[0].str));
}
#line 41694 "preproc.c" /* yacc.c:1652  */
    break;

  case 1325:
#line 8203 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create database"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41702 "preproc.c" /* yacc.c:1652  */
    break;

  case 1326:
#line 8211 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41710 "preproc.c" /* yacc.c:1652  */
    break;

  case 1327:
#line 8215 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41717 "preproc.c" /* yacc.c:1652  */
    break;

  case 1328:
#line 8222 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41725 "preproc.c" /* yacc.c:1652  */
    break;

  case 1329:
#line 8226 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41733 "preproc.c" /* yacc.c:1652  */
    break;

  case 1330:
#line 8234 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41741 "preproc.c" /* yacc.c:1652  */
    break;

  case 1331:
#line 8238 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41749 "preproc.c" /* yacc.c:1652  */
    break;

  case 1332:
#line 8242 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("default"));
}
#line 41757 "preproc.c" /* yacc.c:1652  */
    break;

  case 1333:
#line 8250 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41765 "preproc.c" /* yacc.c:1652  */
    break;

  case 1334:
#line 8254 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("connection limit");
}
#line 41773 "preproc.c" /* yacc.c:1652  */
    break;

  case 1335:
#line 8258 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("encoding");
}
#line 41781 "preproc.c" /* yacc.c:1652  */
    break;

  case 1336:
#line 8262 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("location");
}
#line 41789 "preproc.c" /* yacc.c:1652  */
    break;

  case 1337:
#line 8266 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("owner");
}
#line 41797 "preproc.c" /* yacc.c:1652  */
    break;

  case 1338:
#line 8270 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 41805 "preproc.c" /* yacc.c:1652  */
    break;

  case 1339:
#line 8274 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("template");
}
#line 41813 "preproc.c" /* yacc.c:1652  */
    break;

  case 1340:
#line 8282 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("=");
}
#line 41821 "preproc.c" /* yacc.c:1652  */
    break;

  case 1341:
#line 8286 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41828 "preproc.c" /* yacc.c:1652  */
    break;

  case 1342:
#line 8293 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 41836 "preproc.c" /* yacc.c:1652  */
    break;

  case 1343:
#line 8297 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter database"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41844 "preproc.c" /* yacc.c:1652  */
    break;

  case 1344:
#line 8301 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("set tablespace"),(yyvsp[0].str));
}
#line 41852 "preproc.c" /* yacc.c:1652  */
    break;

  case 1345:
#line 8309 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter database"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41860 "preproc.c" /* yacc.c:1652  */
    break;

  case 1346:
#line 8317 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop database"),(yyvsp[0].str));
}
#line 41868 "preproc.c" /* yacc.c:1652  */
    break;

  case 1347:
#line 8321 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop database if exists"),(yyvsp[0].str));
}
#line 41876 "preproc.c" /* yacc.c:1652  */
    break;

  case 1348:
#line 8329 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("alter system set"),(yyvsp[0].str));
}
#line 41884 "preproc.c" /* yacc.c:1652  */
    break;

  case 1349:
#line 8333 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("alter system reset"),(yyvsp[0].str));
}
#line 41892 "preproc.c" /* yacc.c:1652  */
    break;

  case 1350:
#line 8341 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create domain"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41900 "preproc.c" /* yacc.c:1652  */
    break;

  case 1351:
#line 8349 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41908 "preproc.c" /* yacc.c:1652  */
    break;

  case 1352:
#line 8353 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("drop not null"));
}
#line 41916 "preproc.c" /* yacc.c:1652  */
    break;

  case 1353:
#line 8357 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("set not null"));
}
#line 41924 "preproc.c" /* yacc.c:1652  */
    break;

  case 1354:
#line 8361 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-2].str),mm_strdup("add"),(yyvsp[0].str));
}
#line 41932 "preproc.c" /* yacc.c:1652  */
    break;

  case 1355:
#line 8365 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter domain"),(yyvsp[-4].str),mm_strdup("drop constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41940 "preproc.c" /* yacc.c:1652  */
    break;

  case 1356:
#line 8369 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter domain"),(yyvsp[-6].str),mm_strdup("drop constraint if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41948 "preproc.c" /* yacc.c:1652  */
    break;

  case 1357:
#line 8373 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("validate constraint"),(yyvsp[0].str));
}
#line 41956 "preproc.c" /* yacc.c:1652  */
    break;

  case 1358:
#line 8381 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("as");
}
#line 41964 "preproc.c" /* yacc.c:1652  */
    break;

  case 1359:
#line 8385 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41971 "preproc.c" /* yacc.c:1652  */
    break;

  case 1360:
#line 8392 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter text search dictionary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41979 "preproc.c" /* yacc.c:1652  */
    break;

  case 1361:
#line 8400 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("add mapping for"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41987 "preproc.c" /* yacc.c:1652  */
    break;

  case 1362:
#line 8404 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("alter mapping for"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41995 "preproc.c" /* yacc.c:1652  */
    break;

  case 1363:
#line 8408 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("alter mapping replace"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42003 "preproc.c" /* yacc.c:1652  */
    break;

  case 1364:
#line 8412 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("alter text search configuration"),(yyvsp[-8].str),mm_strdup("alter mapping for"),(yyvsp[-4].str),mm_strdup("replace"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42011 "preproc.c" /* yacc.c:1652  */
    break;

  case 1365:
#line 8416 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-4].str),mm_strdup("drop mapping for"),(yyvsp[0].str));
}
#line 42019 "preproc.c" /* yacc.c:1652  */
    break;

  case 1366:
#line 8420 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("drop mapping if exists for"),(yyvsp[0].str));
}
#line 42027 "preproc.c" /* yacc.c:1652  */
    break;

  case 1367:
#line 8428 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with");
}
#line 42035 "preproc.c" /* yacc.c:1652  */
    break;

  case 1368:
#line 8432 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with");
}
#line 42043 "preproc.c" /* yacc.c:1652  */
    break;

  case 1369:
#line 8440 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-8].str),mm_strdup("conversion"),(yyvsp[-6].str),mm_strdup("for"),(yyvsp[-4].str),mm_strdup("to"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 42051 "preproc.c" /* yacc.c:1652  */
    break;

  case 1370:
#line 8448 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("cluster"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42059 "preproc.c" /* yacc.c:1652  */
    break;

  case 1371:
#line 8452 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("cluster"),(yyvsp[0].str));
}
#line 42067 "preproc.c" /* yacc.c:1652  */
    break;

  case 1372:
#line 8456 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("cluster"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("on"),(yyvsp[0].str));
}
#line 42075 "preproc.c" /* yacc.c:1652  */
    break;

  case 1373:
#line 8464 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 42083 "preproc.c" /* yacc.c:1652  */
    break;

  case 1374:
#line 8468 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42090 "preproc.c" /* yacc.c:1652  */
    break;

  case 1375:
#line 8475 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("vacuum"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42098 "preproc.c" /* yacc.c:1652  */
    break;

  case 1376:
#line 8479 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("vacuum"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42106 "preproc.c" /* yacc.c:1652  */
    break;

  case 1377:
#line 8483 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("vacuum"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42114 "preproc.c" /* yacc.c:1652  */
    break;

  case 1378:
#line 8487 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("vacuum ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42122 "preproc.c" /* yacc.c:1652  */
    break;

  case 1379:
#line 8491 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("vacuum ("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42130 "preproc.c" /* yacc.c:1652  */
    break;

  case 1380:
#line 8499 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42138 "preproc.c" /* yacc.c:1652  */
    break;

  case 1381:
#line 8503 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42146 "preproc.c" /* yacc.c:1652  */
    break;

  case 1382:
#line 8511 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42154 "preproc.c" /* yacc.c:1652  */
    break;

  case 1383:
#line 8515 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("verbose");
}
#line 42162 "preproc.c" /* yacc.c:1652  */
    break;

  case 1384:
#line 8519 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("freeze");
}
#line 42170 "preproc.c" /* yacc.c:1652  */
    break;

  case 1385:
#line 8523 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("full");
}
#line 42178 "preproc.c" /* yacc.c:1652  */
    break;

  case 1386:
#line 8527 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42186 "preproc.c" /* yacc.c:1652  */
    break;

  case 1387:
#line 8535 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42194 "preproc.c" /* yacc.c:1652  */
    break;

  case 1388:
#line 8539 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42202 "preproc.c" /* yacc.c:1652  */
    break;

  case 1389:
#line 8547 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("analyze");
}
#line 42210 "preproc.c" /* yacc.c:1652  */
    break;

  case 1390:
#line 8551 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("analyse");
}
#line 42218 "preproc.c" /* yacc.c:1652  */
    break;

  case 1391:
#line 8559 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("verbose");
}
#line 42226 "preproc.c" /* yacc.c:1652  */
    break;

  case 1392:
#line 8563 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42233 "preproc.c" /* yacc.c:1652  */
    break;

  case 1393:
#line 8570 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("full");
}
#line 42241 "preproc.c" /* yacc.c:1652  */
    break;

  case 1394:
#line 8574 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42248 "preproc.c" /* yacc.c:1652  */
    break;

  case 1395:
#line 8581 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("freeze");
}
#line 42256 "preproc.c" /* yacc.c:1652  */
    break;

  case 1396:
#line 8585 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42263 "preproc.c" /* yacc.c:1652  */
    break;

  case 1397:
#line 8592 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42271 "preproc.c" /* yacc.c:1652  */
    break;

  case 1398:
#line 8596 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42278 "preproc.c" /* yacc.c:1652  */
    break;

  case 1399:
#line 8603 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("explain"),(yyvsp[0].str));
}
#line 42286 "preproc.c" /* yacc.c:1652  */
    break;

  case 1400:
#line 8607 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("explain"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42294 "preproc.c" /* yacc.c:1652  */
    break;

  case 1401:
#line 8611 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("explain verbose"),(yyvsp[0].str));
}
#line 42302 "preproc.c" /* yacc.c:1652  */
    break;

  case 1402:
#line 8615 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("explain ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 42310 "preproc.c" /* yacc.c:1652  */
    break;

  case 1403:
#line 8623 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42318 "preproc.c" /* yacc.c:1652  */
    break;

  case 1404:
#line 8627 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42326 "preproc.c" /* yacc.c:1652  */
    break;

  case 1405:
#line 8631 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42334 "preproc.c" /* yacc.c:1652  */
    break;

  case 1406:
#line 8635 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42342 "preproc.c" /* yacc.c:1652  */
    break;

  case 1407:
#line 8639 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42350 "preproc.c" /* yacc.c:1652  */
    break;

  case 1408:
#line 8643 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42358 "preproc.c" /* yacc.c:1652  */
    break;

  case 1409:
#line 8647 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42366 "preproc.c" /* yacc.c:1652  */
    break;

  case 1410:
#line 8651 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42374 "preproc.c" /* yacc.c:1652  */
    break;

  case 1411:
#line 8655 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42382 "preproc.c" /* yacc.c:1652  */
    break;

  case 1412:
#line 8663 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42390 "preproc.c" /* yacc.c:1652  */
    break;

  case 1413:
#line 8667 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42398 "preproc.c" /* yacc.c:1652  */
    break;

  case 1414:
#line 8675 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42406 "preproc.c" /* yacc.c:1652  */
    break;

  case 1415:
#line 8683 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42414 "preproc.c" /* yacc.c:1652  */
    break;

  case 1416:
#line 8687 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42422 "preproc.c" /* yacc.c:1652  */
    break;

  case 1417:
#line 8695 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42430 "preproc.c" /* yacc.c:1652  */
    break;

  case 1418:
#line 8699 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42438 "preproc.c" /* yacc.c:1652  */
    break;

  case 1419:
#line 8703 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42445 "preproc.c" /* yacc.c:1652  */
    break;

  case 1420:
#line 8710 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.prep).name = (yyvsp[-3].str);
		(yyval.prep).type = (yyvsp[-2].str);
		(yyval.prep).stmt = cat_str(3, mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
	}
#line 42455 "preproc.c" /* yacc.c:1652  */
    break;

  case 1421:
#line 8716 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.prep).name = (yyvsp[-2].str);
		(yyval.prep).type = NULL;
		(yyval.prep).stmt = (yyvsp[0].str);
	}
#line 42465 "preproc.c" /* yacc.c:1652  */
    break;

  case 1422:
#line 8726 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42473 "preproc.c" /* yacc.c:1652  */
    break;

  case 1423:
#line 8730 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42480 "preproc.c" /* yacc.c:1652  */
    break;

  case 1424:
#line 8737 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42488 "preproc.c" /* yacc.c:1652  */
    break;

  case 1425:
#line 8741 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42496 "preproc.c" /* yacc.c:1652  */
    break;

  case 1426:
#line 8745 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42504 "preproc.c" /* yacc.c:1652  */
    break;

  case 1427:
#line 8749 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42512 "preproc.c" /* yacc.c:1652  */
    break;

  case 1428:
#line 8757 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[-2].str); }
#line 42518 "preproc.c" /* yacc.c:1652  */
    break;

  case 1429:
#line 8759 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("table"),(yyvsp[-5].str),mm_strdup("as execute"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42526 "preproc.c" /* yacc.c:1652  */
    break;

  case 1430:
#line 8763 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("create"),(yyvsp[-10].str),mm_strdup("table if not exists"),(yyvsp[-5].str),mm_strdup("as execute"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42534 "preproc.c" /* yacc.c:1652  */
    break;

  case 1431:
#line 8771 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42542 "preproc.c" /* yacc.c:1652  */
    break;

  case 1432:
#line 8775 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42549 "preproc.c" /* yacc.c:1652  */
    break;

  case 1433:
#line 8782 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("insert into"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42557 "preproc.c" /* yacc.c:1652  */
    break;

  case 1434:
#line 8790 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42565 "preproc.c" /* yacc.c:1652  */
    break;

  case 1435:
#line 8794 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 42573 "preproc.c" /* yacc.c:1652  */
    break;

  case 1436:
#line 8802 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42581 "preproc.c" /* yacc.c:1652  */
    break;

  case 1437:
#line 8806 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 42589 "preproc.c" /* yacc.c:1652  */
    break;

  case 1438:
#line 8810 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default values");
}
#line 42597 "preproc.c" /* yacc.c:1652  */
    break;

  case 1439:
#line 8818 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42605 "preproc.c" /* yacc.c:1652  */
    break;

  case 1440:
#line 8822 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42613 "preproc.c" /* yacc.c:1652  */
    break;

  case 1441:
#line 8830 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42621 "preproc.c" /* yacc.c:1652  */
    break;

  case 1442:
#line 8838 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("on conflict"),(yyvsp[-5].str),mm_strdup("do update set"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42629 "preproc.c" /* yacc.c:1652  */
    break;

  case 1443:
#line 8842 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("on conflict"),(yyvsp[-2].str),mm_strdup("do nothing"));
}
#line 42637 "preproc.c" /* yacc.c:1652  */
    break;

  case 1444:
#line 8846 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42644 "preproc.c" /* yacc.c:1652  */
    break;

  case 1445:
#line 8853 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 42652 "preproc.c" /* yacc.c:1652  */
    break;

  case 1446:
#line 8857 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("on constraint"),(yyvsp[0].str));
}
#line 42660 "preproc.c" /* yacc.c:1652  */
    break;

  case 1447:
#line 8861 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42667 "preproc.c" /* yacc.c:1652  */
    break;

  case 1448:
#line 8868 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("returning"),(yyvsp[-1].str));
}
#line 42675 "preproc.c" /* yacc.c:1652  */
    break;

  case 1449:
#line 8872 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42682 "preproc.c" /* yacc.c:1652  */
    break;

  case 1450:
#line 8879 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("delete from"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42690 "preproc.c" /* yacc.c:1652  */
    break;

  case 1451:
#line 8887 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 42698 "preproc.c" /* yacc.c:1652  */
    break;

  case 1452:
#line 8891 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42705 "preproc.c" /* yacc.c:1652  */
    break;

  case 1453:
#line 8898 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("lock"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42713 "preproc.c" /* yacc.c:1652  */
    break;

  case 1454:
#line 8906 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("in"),(yyvsp[-1].str),mm_strdup("mode"));
}
#line 42721 "preproc.c" /* yacc.c:1652  */
    break;

  case 1455:
#line 8910 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42728 "preproc.c" /* yacc.c:1652  */
    break;

  case 1456:
#line 8917 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("access share");
}
#line 42736 "preproc.c" /* yacc.c:1652  */
    break;

  case 1457:
#line 8921 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row share");
}
#line 42744 "preproc.c" /* yacc.c:1652  */
    break;

  case 1458:
#line 8925 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row exclusive");
}
#line 42752 "preproc.c" /* yacc.c:1652  */
    break;

  case 1459:
#line 8929 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("share update exclusive");
}
#line 42760 "preproc.c" /* yacc.c:1652  */
    break;

  case 1460:
#line 8933 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("share");
}
#line 42768 "preproc.c" /* yacc.c:1652  */
    break;

  case 1461:
#line 8937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("share row exclusive");
}
#line 42776 "preproc.c" /* yacc.c:1652  */
    break;

  case 1462:
#line 8941 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exclusive");
}
#line 42784 "preproc.c" /* yacc.c:1652  */
    break;

  case 1463:
#line 8945 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("access exclusive");
}
#line 42792 "preproc.c" /* yacc.c:1652  */
    break;

  case 1464:
#line 8953 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nowait");
}
#line 42800 "preproc.c" /* yacc.c:1652  */
    break;

  case 1465:
#line 8957 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42807 "preproc.c" /* yacc.c:1652  */
    break;

  case 1466:
#line 8964 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nowait");
}
#line 42815 "preproc.c" /* yacc.c:1652  */
    break;

  case 1467:
#line 8968 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("skip locked");
}
#line 42823 "preproc.c" /* yacc.c:1652  */
    break;

  case 1468:
#line 8972 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42830 "preproc.c" /* yacc.c:1652  */
    break;

  case 1469:
#line 8979 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,(yyvsp[-7].str),mm_strdup("update"),(yyvsp[-5].str),mm_strdup("set"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42838 "preproc.c" /* yacc.c:1652  */
    break;

  case 1470:
#line 8987 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42846 "preproc.c" /* yacc.c:1652  */
    break;

  case 1471:
#line 8991 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42854 "preproc.c" /* yacc.c:1652  */
    break;

  case 1472:
#line 8999 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42862 "preproc.c" /* yacc.c:1652  */
    break;

  case 1473:
#line 9003 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42870 "preproc.c" /* yacc.c:1652  */
    break;

  case 1474:
#line 9011 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 42878 "preproc.c" /* yacc.c:1652  */
    break;

  case 1475:
#line 9019 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-3].str),mm_strdup(") ="),(yyvsp[0].str));
}
#line 42886 "preproc.c" /* yacc.c:1652  */
    break;

  case 1476:
#line 9023 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-3].str),mm_strdup(") ="),(yyvsp[0].str));
}
#line 42894 "preproc.c" /* yacc.c:1652  */
    break;

  case 1477:
#line 9031 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42902 "preproc.c" /* yacc.c:1652  */
    break;

  case 1478:
#line 9039 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42910 "preproc.c" /* yacc.c:1652  */
    break;

  case 1479:
#line 9043 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42918 "preproc.c" /* yacc.c:1652  */
    break;

  case 1480:
#line 9051 "preproc.y" /* yacc.c:1652  */
    {
		struct cursor *ptr, *this;
		char *cursor_marker = (yyvsp[-5].str)[0] == ':' ? mm_strdup("$0") : mm_strdup((yyvsp[-5].str));
		char *comment, *c1, *c2;
		int (* strcmp_fn)(const char *, const char *) = (((yyvsp[-5].str)[0] == ':' || (yyvsp[-5].str)[0] == '"') ? strcmp : pg_strcasecmp);

		for (ptr = cur; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp_fn((yyvsp[-5].str), ptr->name) == 0)
			{
				if ((yyvsp[-5].str)[0] == ':')
					mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[-5].str)+1);
				else
					mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[-5].str));
			}
		}

		this = (struct cursor *) mm_alloc(sizeof(struct cursor));

		this->next = cur;
		this->name = (yyvsp[-5].str);
		this->function = (current_function ? mm_strdup(current_function) : NULL);
		this->connection = connection;
		this->opened = false;
		this->command =  cat_str(7, mm_strdup("declare"), cursor_marker, (yyvsp[-4].str), mm_strdup("cursor"), (yyvsp[-2].str), mm_strdup("for"), (yyvsp[0].str));
		this->argsinsert = argsinsert;
		this->argsinsert_oos = NULL;
		this->argsresult = argsresult;
		this->argsresult_oos = NULL;
		argsinsert = argsresult = NULL;
		cur = this;

		c1 = mm_strdup(this->command);
		if ((c2 = strstr(c1, "*/")) != NULL)
		{
			/* We put this text into a comment, so we better remove [*][/]. */
			c2[0] = '.';
			c2[1] = '.';
		}
		comment = cat_str(3, mm_strdup("/*"), c1, mm_strdup("*/"));

		if ((braces_open > 0) && INFORMIX_MODE) /* we're in a function */
			(yyval.str) = cat_str(3, adjust_outofscope_cursor_vars(this),
				mm_strdup("ECPG_informix_reset_sqlca();"),
				comment);
		else
			(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
	}
#line 42971 "preproc.c" /* yacc.c:1652  */
    break;

  case 1481:
#line 9104 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42979 "preproc.c" /* yacc.c:1652  */
    break;

  case 1482:
#line 9108 "preproc.y" /* yacc.c:1652  */
    {
			char *curname = mm_alloc(strlen((yyvsp[0].str)) + 2);
			sprintf(curname, ":%s", (yyvsp[0].str));
			free((yyvsp[0].str));
			(yyvsp[0].str) = curname;
			(yyval.str) = (yyvsp[0].str);
		}
#line 42991 "preproc.c" /* yacc.c:1652  */
    break;

  case 1483:
#line 9120 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42998 "preproc.c" /* yacc.c:1652  */
    break;

  case 1484:
#line 9123 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("no scroll"));
}
#line 43006 "preproc.c" /* yacc.c:1652  */
    break;

  case 1485:
#line 9127 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("scroll"));
}
#line 43014 "preproc.c" /* yacc.c:1652  */
    break;

  case 1486:
#line 9131 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("binary"));
}
#line 43022 "preproc.c" /* yacc.c:1652  */
    break;

  case 1487:
#line 9135 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("insensitive"));
}
#line 43030 "preproc.c" /* yacc.c:1652  */
    break;

  case 1488:
#line 9143 "preproc.y" /* yacc.c:1652  */
    {
		if (compat == ECPG_COMPAT_INFORMIX_SE && autocommit)
			(yyval.str) = mm_strdup("with hold");
		else
			(yyval.str) = EMPTY;
	}
#line 43041 "preproc.c" /* yacc.c:1652  */
    break;

  case 1489:
#line 9150 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with hold");
}
#line 43049 "preproc.c" /* yacc.c:1652  */
    break;

  case 1490:
#line 9154 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("without hold");
}
#line 43057 "preproc.c" /* yacc.c:1652  */
    break;

  case 1491:
#line 9162 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43065 "preproc.c" /* yacc.c:1652  */
    break;

  case 1492:
#line 9166 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43073 "preproc.c" /* yacc.c:1652  */
    break;

  case 1493:
#line 9174 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43081 "preproc.c" /* yacc.c:1652  */
    break;

  case 1494:
#line 9178 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43089 "preproc.c" /* yacc.c:1652  */
    break;

  case 1495:
#line 9186 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43097 "preproc.c" /* yacc.c:1652  */
    break;

  case 1496:
#line 9190 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43105 "preproc.c" /* yacc.c:1652  */
    break;

  case 1497:
#line 9194 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43113 "preproc.c" /* yacc.c:1652  */
    break;

  case 1498:
#line 9198 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43121 "preproc.c" /* yacc.c:1652  */
    break;

  case 1499:
#line 9202 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43129 "preproc.c" /* yacc.c:1652  */
    break;

  case 1500:
#line 9206 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43137 "preproc.c" /* yacc.c:1652  */
    break;

  case 1501:
#line 9210 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43145 "preproc.c" /* yacc.c:1652  */
    break;

  case 1502:
#line 9214 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43153 "preproc.c" /* yacc.c:1652  */
    break;

  case 1503:
#line 9222 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43161 "preproc.c" /* yacc.c:1652  */
    break;

  case 1504:
#line 9226 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43169 "preproc.c" /* yacc.c:1652  */
    break;

  case 1505:
#line 9234 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("select"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43177 "preproc.c" /* yacc.c:1652  */
    break;

  case 1506:
#line 9238 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("select"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43185 "preproc.c" /* yacc.c:1652  */
    break;

  case 1507:
#line 9242 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43193 "preproc.c" /* yacc.c:1652  */
    break;

  case 1508:
#line 9246 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 43201 "preproc.c" /* yacc.c:1652  */
    break;

  case 1509:
#line 9250 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("union"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43209 "preproc.c" /* yacc.c:1652  */
    break;

  case 1510:
#line 9254 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("intersect"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43217 "preproc.c" /* yacc.c:1652  */
    break;

  case 1511:
#line 9258 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("except"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43225 "preproc.c" /* yacc.c:1652  */
    break;

  case 1512:
#line 9266 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 43233 "preproc.c" /* yacc.c:1652  */
    break;

  case 1513:
#line 9270 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 43241 "preproc.c" /* yacc.c:1652  */
    break;

  case 1514:
#line 9274 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with recursive"),(yyvsp[0].str));
}
#line 43249 "preproc.c" /* yacc.c:1652  */
    break;

  case 1515:
#line 9282 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43257 "preproc.c" /* yacc.c:1652  */
    break;

  case 1516:
#line 9286 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43265 "preproc.c" /* yacc.c:1652  */
    break;

  case 1517:
#line 9294 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43273 "preproc.c" /* yacc.c:1652  */
    break;

  case 1518:
#line 9302 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43281 "preproc.c" /* yacc.c:1652  */
    break;

  case 1519:
#line 9306 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43288 "preproc.c" /* yacc.c:1652  */
    break;

  case 1520:
#line 9313 "preproc.y" /* yacc.c:1652  */
    {
						FoundInto = 1;
						(yyval.str)= cat2_str(mm_strdup("into"), (yyvsp[0].str));
					}
#line 43297 "preproc.c" /* yacc.c:1652  */
    break;

  case 1521:
#line 9317 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 43303 "preproc.c" /* yacc.c:1652  */
    break;

  case 1522:
#line 9319 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43310 "preproc.c" /* yacc.c:1652  */
    break;

  case 1523:
#line 9326 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43318 "preproc.c" /* yacc.c:1652  */
    break;

  case 1524:
#line 9330 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43326 "preproc.c" /* yacc.c:1652  */
    break;

  case 1525:
#line 9334 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("local temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43334 "preproc.c" /* yacc.c:1652  */
    break;

  case 1526:
#line 9338 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("local temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43342 "preproc.c" /* yacc.c:1652  */
    break;

  case 1527:
#line 9342 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("global temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43350 "preproc.c" /* yacc.c:1652  */
    break;

  case 1528:
#line 9346 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("global temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43358 "preproc.c" /* yacc.c:1652  */
    break;

  case 1529:
#line 9350 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("unlogged"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43366 "preproc.c" /* yacc.c:1652  */
    break;

  case 1530:
#line 9354 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 43374 "preproc.c" /* yacc.c:1652  */
    break;

  case 1531:
#line 9358 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43382 "preproc.c" /* yacc.c:1652  */
    break;

  case 1532:
#line 9366 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 43390 "preproc.c" /* yacc.c:1652  */
    break;

  case 1533:
#line 9370 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43397 "preproc.c" /* yacc.c:1652  */
    break;

  case 1534:
#line 9377 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 43405 "preproc.c" /* yacc.c:1652  */
    break;

  case 1535:
#line 9381 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("distinct");
}
#line 43413 "preproc.c" /* yacc.c:1652  */
    break;

  case 1536:
#line 9385 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43420 "preproc.c" /* yacc.c:1652  */
    break;

  case 1537:
#line 9392 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("distinct");
}
#line 43428 "preproc.c" /* yacc.c:1652  */
    break;

  case 1538:
#line 9396 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("distinct on ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43436 "preproc.c" /* yacc.c:1652  */
    break;

  case 1539:
#line 9404 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 43444 "preproc.c" /* yacc.c:1652  */
    break;

  case 1540:
#line 9408 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43451 "preproc.c" /* yacc.c:1652  */
    break;

  case 1541:
#line 9415 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43459 "preproc.c" /* yacc.c:1652  */
    break;

  case 1542:
#line 9419 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43466 "preproc.c" /* yacc.c:1652  */
    break;

  case 1543:
#line 9426 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("order by"),(yyvsp[0].str));
}
#line 43474 "preproc.c" /* yacc.c:1652  */
    break;

  case 1544:
#line 9434 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43482 "preproc.c" /* yacc.c:1652  */
    break;

  case 1545:
#line 9438 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43490 "preproc.c" /* yacc.c:1652  */
    break;

  case 1546:
#line 9446 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43498 "preproc.c" /* yacc.c:1652  */
    break;

  case 1547:
#line 9450 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43506 "preproc.c" /* yacc.c:1652  */
    break;

  case 1548:
#line 9458 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43514 "preproc.c" /* yacc.c:1652  */
    break;

  case 1549:
#line 9462 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43522 "preproc.c" /* yacc.c:1652  */
    break;

  case 1550:
#line 9466 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43530 "preproc.c" /* yacc.c:1652  */
    break;

  case 1551:
#line 9470 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43538 "preproc.c" /* yacc.c:1652  */
    break;

  case 1552:
#line 9478 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43546 "preproc.c" /* yacc.c:1652  */
    break;

  case 1553:
#line 9482 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43553 "preproc.c" /* yacc.c:1652  */
    break;

  case 1554:
#line 9489 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("limit"),(yyvsp[0].str));
}
#line 43561 "preproc.c" /* yacc.c:1652  */
    break;

  case 1555:
#line 9493 "preproc.y" /* yacc.c:1652  */
    {
		mmerror(PARSE_ERROR, ET_WARNING, "no longer supported LIMIT #,# syntax passed to server");
		(yyval.str) = cat_str(4, mm_strdup("limit"), (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str));
	}
#line 43570 "preproc.c" /* yacc.c:1652  */
    break;

  case 1556:
#line 9498 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("fetch"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("only"));
}
#line 43578 "preproc.c" /* yacc.c:1652  */
    break;

  case 1557:
#line 9502 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("fetch"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("only"));
}
#line 43586 "preproc.c" /* yacc.c:1652  */
    break;

  case 1558:
#line 9510 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("offset"),(yyvsp[0].str));
}
#line 43594 "preproc.c" /* yacc.c:1652  */
    break;

  case 1559:
#line 9514 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("offset"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43602 "preproc.c" /* yacc.c:1652  */
    break;

  case 1560:
#line 9522 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43610 "preproc.c" /* yacc.c:1652  */
    break;

  case 1561:
#line 9526 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 43618 "preproc.c" /* yacc.c:1652  */
    break;

  case 1562:
#line 9534 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43626 "preproc.c" /* yacc.c:1652  */
    break;

  case 1563:
#line 9542 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43634 "preproc.c" /* yacc.c:1652  */
    break;

  case 1564:
#line 9546 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 43642 "preproc.c" /* yacc.c:1652  */
    break;

  case 1565:
#line 9550 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 43650 "preproc.c" /* yacc.c:1652  */
    break;

  case 1566:
#line 9558 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43658 "preproc.c" /* yacc.c:1652  */
    break;

  case 1567:
#line 9562 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43666 "preproc.c" /* yacc.c:1652  */
    break;

  case 1568:
#line 9570 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row");
}
#line 43674 "preproc.c" /* yacc.c:1652  */
    break;

  case 1569:
#line 9574 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rows");
}
#line 43682 "preproc.c" /* yacc.c:1652  */
    break;

  case 1570:
#line 9582 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("first");
}
#line 43690 "preproc.c" /* yacc.c:1652  */
    break;

  case 1571:
#line 9586 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("next");
}
#line 43698 "preproc.c" /* yacc.c:1652  */
    break;

  case 1572:
#line 9594 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("group by"),(yyvsp[0].str));
}
#line 43706 "preproc.c" /* yacc.c:1652  */
    break;

  case 1573:
#line 9598 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43713 "preproc.c" /* yacc.c:1652  */
    break;

  case 1574:
#line 9605 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43721 "preproc.c" /* yacc.c:1652  */
    break;

  case 1575:
#line 9609 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43729 "preproc.c" /* yacc.c:1652  */
    break;

  case 1576:
#line 9617 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43737 "preproc.c" /* yacc.c:1652  */
    break;

  case 1577:
#line 9621 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43745 "preproc.c" /* yacc.c:1652  */
    break;

  case 1578:
#line 9625 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43753 "preproc.c" /* yacc.c:1652  */
    break;

  case 1579:
#line 9629 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43761 "preproc.c" /* yacc.c:1652  */
    break;

  case 1580:
#line 9633 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43769 "preproc.c" /* yacc.c:1652  */
    break;

  case 1581:
#line 9641 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("( )");
}
#line 43777 "preproc.c" /* yacc.c:1652  */
    break;

  case 1582:
#line 9649 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("rollup ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43785 "preproc.c" /* yacc.c:1652  */
    break;

  case 1583:
#line 9657 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("cube ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43793 "preproc.c" /* yacc.c:1652  */
    break;

  case 1584:
#line 9665 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("grouping sets ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43801 "preproc.c" /* yacc.c:1652  */
    break;

  case 1585:
#line 9673 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("having"),(yyvsp[0].str));
}
#line 43809 "preproc.c" /* yacc.c:1652  */
    break;

  case 1586:
#line 9677 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43816 "preproc.c" /* yacc.c:1652  */
    break;

  case 1587:
#line 9684 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43824 "preproc.c" /* yacc.c:1652  */
    break;

  case 1588:
#line 9688 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for read only");
}
#line 43832 "preproc.c" /* yacc.c:1652  */
    break;

  case 1589:
#line 9696 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43840 "preproc.c" /* yacc.c:1652  */
    break;

  case 1590:
#line 9700 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43847 "preproc.c" /* yacc.c:1652  */
    break;

  case 1591:
#line 9707 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43855 "preproc.c" /* yacc.c:1652  */
    break;

  case 1592:
#line 9711 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43863 "preproc.c" /* yacc.c:1652  */
    break;

  case 1593:
#line 9719 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43871 "preproc.c" /* yacc.c:1652  */
    break;

  case 1594:
#line 9727 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for update");
}
#line 43879 "preproc.c" /* yacc.c:1652  */
    break;

  case 1595:
#line 9731 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for no key update");
}
#line 43887 "preproc.c" /* yacc.c:1652  */
    break;

  case 1596:
#line 9735 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for share");
}
#line 43895 "preproc.c" /* yacc.c:1652  */
    break;

  case 1597:
#line 9739 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for key share");
}
#line 43903 "preproc.c" /* yacc.c:1652  */
    break;

  case 1598:
#line 9747 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("of"),(yyvsp[0].str));
}
#line 43911 "preproc.c" /* yacc.c:1652  */
    break;

  case 1599:
#line 9751 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43918 "preproc.c" /* yacc.c:1652  */
    break;

  case 1600:
#line 9758 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("values"),(yyvsp[0].str));
}
#line 43926 "preproc.c" /* yacc.c:1652  */
    break;

  case 1601:
#line 9762 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43934 "preproc.c" /* yacc.c:1652  */
    break;

  case 1602:
#line 9770 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 43942 "preproc.c" /* yacc.c:1652  */
    break;

  case 1603:
#line 9774 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43949 "preproc.c" /* yacc.c:1652  */
    break;

  case 1604:
#line 9781 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43957 "preproc.c" /* yacc.c:1652  */
    break;

  case 1605:
#line 9785 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43965 "preproc.c" /* yacc.c:1652  */
    break;

  case 1606:
#line 9793 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43973 "preproc.c" /* yacc.c:1652  */
    break;

  case 1607:
#line 9797 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43981 "preproc.c" /* yacc.c:1652  */
    break;

  case 1608:
#line 9801 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43989 "preproc.c" /* yacc.c:1652  */
    break;

  case 1609:
#line 9805 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("lateral"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43997 "preproc.c" /* yacc.c:1652  */
    break;

  case 1610:
#line 9809 "preproc.y" /* yacc.c:1652  */
    { 
	if ((yyvsp[0].str) == NULL)
		mmerror(PARSE_ERROR, ET_ERROR, "subquery in FROM must have an alias");

 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44008 "preproc.c" /* yacc.c:1652  */
    break;

  case 1611:
#line 9816 "preproc.y" /* yacc.c:1652  */
    { 
	if ((yyvsp[0].str) == NULL)
		mmerror(PARSE_ERROR, ET_ERROR, "subquery in FROM must have an alias");

 (yyval.str) = cat_str(3,mm_strdup("lateral"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44019 "preproc.c" /* yacc.c:1652  */
    break;

  case 1612:
#line 9823 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44027 "preproc.c" /* yacc.c:1652  */
    break;

  case 1613:
#line 9827 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 44035 "preproc.c" /* yacc.c:1652  */
    break;

  case 1614:
#line 9835 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44043 "preproc.c" /* yacc.c:1652  */
    break;

  case 1615:
#line 9839 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("cross join"),(yyvsp[0].str));
}
#line 44051 "preproc.c" /* yacc.c:1652  */
    break;

  case 1616:
#line 9843 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("join"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44059 "preproc.c" /* yacc.c:1652  */
    break;

  case 1617:
#line 9847 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("join"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44067 "preproc.c" /* yacc.c:1652  */
    break;

  case 1618:
#line 9851 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("natural"),(yyvsp[-2].str),mm_strdup("join"),(yyvsp[0].str));
}
#line 44075 "preproc.c" /* yacc.c:1652  */
    break;

  case 1619:
#line 9855 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("natural join"),(yyvsp[0].str));
}
#line 44083 "preproc.c" /* yacc.c:1652  */
    break;

  case 1620:
#line 9863 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("as"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44091 "preproc.c" /* yacc.c:1652  */
    break;

  case 1621:
#line 9867 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 44099 "preproc.c" /* yacc.c:1652  */
    break;

  case 1622:
#line 9871 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44107 "preproc.c" /* yacc.c:1652  */
    break;

  case 1623:
#line 9875 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44115 "preproc.c" /* yacc.c:1652  */
    break;

  case 1624:
#line 9883 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44123 "preproc.c" /* yacc.c:1652  */
    break;

  case 1625:
#line 9887 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44130 "preproc.c" /* yacc.c:1652  */
    break;

  case 1626:
#line 9894 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44138 "preproc.c" /* yacc.c:1652  */
    break;

  case 1627:
#line 9898 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44146 "preproc.c" /* yacc.c:1652  */
    break;

  case 1628:
#line 9902 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("as"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44154 "preproc.c" /* yacc.c:1652  */
    break;

  case 1629:
#line 9906 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44162 "preproc.c" /* yacc.c:1652  */
    break;

  case 1630:
#line 9910 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44169 "preproc.c" /* yacc.c:1652  */
    break;

  case 1631:
#line 9917 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("full"),(yyvsp[0].str));
}
#line 44177 "preproc.c" /* yacc.c:1652  */
    break;

  case 1632:
#line 9921 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("left"),(yyvsp[0].str));
}
#line 44185 "preproc.c" /* yacc.c:1652  */
    break;

  case 1633:
#line 9925 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("right"),(yyvsp[0].str));
}
#line 44193 "preproc.c" /* yacc.c:1652  */
    break;

  case 1634:
#line 9929 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inner");
}
#line 44201 "preproc.c" /* yacc.c:1652  */
    break;

  case 1635:
#line 9937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("outer");
}
#line 44209 "preproc.c" /* yacc.c:1652  */
    break;

  case 1636:
#line 9941 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44216 "preproc.c" /* yacc.c:1652  */
    break;

  case 1637:
#line 9948 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("using ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44224 "preproc.c" /* yacc.c:1652  */
    break;

  case 1638:
#line 9952 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("on"),(yyvsp[0].str));
}
#line 44232 "preproc.c" /* yacc.c:1652  */
    break;

  case 1639:
#line 9960 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44240 "preproc.c" /* yacc.c:1652  */
    break;

  case 1640:
#line 9964 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("*"));
}
#line 44248 "preproc.c" /* yacc.c:1652  */
    break;

  case 1641:
#line 9968 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("only"),(yyvsp[0].str));
}
#line 44256 "preproc.c" /* yacc.c:1652  */
    break;

  case 1642:
#line 9972 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("only ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44264 "preproc.c" /* yacc.c:1652  */
    break;

  case 1643:
#line 9980 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44272 "preproc.c" /* yacc.c:1652  */
    break;

  case 1644:
#line 9984 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44280 "preproc.c" /* yacc.c:1652  */
    break;

  case 1645:
#line 9992 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44288 "preproc.c" /* yacc.c:1652  */
    break;

  case 1646:
#line 9996 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44296 "preproc.c" /* yacc.c:1652  */
    break;

  case 1647:
#line 10000 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 44304 "preproc.c" /* yacc.c:1652  */
    break;

  case 1648:
#line 10008 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("tablesample"),(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 44312 "preproc.c" /* yacc.c:1652  */
    break;

  case 1649:
#line 10016 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("repeatable ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44320 "preproc.c" /* yacc.c:1652  */
    break;

  case 1650:
#line 10020 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44327 "preproc.c" /* yacc.c:1652  */
    break;

  case 1651:
#line 10027 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44335 "preproc.c" /* yacc.c:1652  */
    break;

  case 1652:
#line 10031 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("rows from ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 44343 "preproc.c" /* yacc.c:1652  */
    break;

  case 1653:
#line 10039 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44351 "preproc.c" /* yacc.c:1652  */
    break;

  case 1654:
#line 10047 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44359 "preproc.c" /* yacc.c:1652  */
    break;

  case 1655:
#line 10051 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44367 "preproc.c" /* yacc.c:1652  */
    break;

  case 1656:
#line 10059 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44375 "preproc.c" /* yacc.c:1652  */
    break;

  case 1657:
#line 10063 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44382 "preproc.c" /* yacc.c:1652  */
    break;

  case 1658:
#line 10070 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with ordinality");
}
#line 44390 "preproc.c" /* yacc.c:1652  */
    break;

  case 1659:
#line 10074 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44397 "preproc.c" /* yacc.c:1652  */
    break;

  case 1660:
#line 10081 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("where"),(yyvsp[0].str));
}
#line 44405 "preproc.c" /* yacc.c:1652  */
    break;

  case 1661:
#line 10085 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44412 "preproc.c" /* yacc.c:1652  */
    break;

  case 1662:
#line 10092 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("where"),(yyvsp[0].str));
}
#line 44420 "preproc.c" /* yacc.c:1652  */
    break;

  case 1663:
#line 10096 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		(yyval.str) = cat_str(2,mm_strdup("where current of"), cursor_marker);
	}
#line 44429 "preproc.c" /* yacc.c:1652  */
    break;

  case 1664:
#line 10101 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44436 "preproc.c" /* yacc.c:1652  */
    break;

  case 1665:
#line 10108 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44444 "preproc.c" /* yacc.c:1652  */
    break;

  case 1666:
#line 10112 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44451 "preproc.c" /* yacc.c:1652  */
    break;

  case 1667:
#line 10119 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44459 "preproc.c" /* yacc.c:1652  */
    break;

  case 1668:
#line 10123 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44467 "preproc.c" /* yacc.c:1652  */
    break;

  case 1669:
#line 10131 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44475 "preproc.c" /* yacc.c:1652  */
    break;

  case 1670:
#line 10139 "preproc.y" /* yacc.c:1652  */
    {	(yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].index).str); }
#line 44481 "preproc.c" /* yacc.c:1652  */
    break;

  case 1671:
#line 10141 "preproc.y" /* yacc.c:1652  */
    {	(yyval.str) = cat_str(3, mm_strdup("setof"), (yyvsp[-1].str), (yyvsp[0].index).str); }
#line 44487 "preproc.c" /* yacc.c:1652  */
    break;

  case 1672:
#line 10143 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup("array ["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 44495 "preproc.c" /* yacc.c:1652  */
    break;

  case 1673:
#line 10147 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("setof"),(yyvsp[-4].str),mm_strdup("array ["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 44503 "preproc.c" /* yacc.c:1652  */
    break;

  case 1674:
#line 10151 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("array"));
}
#line 44511 "preproc.c" /* yacc.c:1652  */
    break;

  case 1675:
#line 10155 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("setof"),(yyvsp[-1].str),mm_strdup("array"));
}
#line 44519 "preproc.c" /* yacc.c:1652  */
    break;

  case 1676:
#line 10163 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.index).index1 = (yyvsp[-2].index).index1;
		(yyval.index).index2 = (yyvsp[-2].index).index2;
		if (strcmp((yyval.index).index1, "-1") == 0)
			(yyval.index).index1 = mm_strdup("0");
		else if (strcmp((yyvsp[-2].index).index2, "-1") == 0)
			(yyval.index).index2 = mm_strdup("0");
		(yyval.index).str = cat_str(2, (yyvsp[-2].index).str, mm_strdup("[]"));
	}
#line 44533 "preproc.c" /* yacc.c:1652  */
    break;

  case 1677:
#line 10173 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.index).index1 = (yyvsp[-3].index).index1;
		(yyval.index).index2 = (yyvsp[-3].index).index2;
		if (strcmp((yyvsp[-3].index).index1, "-1") == 0)
			(yyval.index).index1 = mm_strdup((yyvsp[-1].str));
		else if (strcmp((yyvsp[-3].index).index2, "-1") == 0)
			(yyval.index).index2 = mm_strdup((yyvsp[-1].str));
		(yyval.index).str = cat_str(4, (yyvsp[-3].index).str, mm_strdup("["), (yyvsp[-1].str), mm_strdup("]"));
	}
#line 44547 "preproc.c" /* yacc.c:1652  */
    break;

  case 1678:
#line 10183 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.index).index1 = mm_strdup("-1");
		(yyval.index).index2 = mm_strdup("-1");
		(yyval.index).str= EMPTY;
	}
#line 44557 "preproc.c" /* yacc.c:1652  */
    break;

  case 1679:
#line 10193 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44565 "preproc.c" /* yacc.c:1652  */
    break;

  case 1680:
#line 10197 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44573 "preproc.c" /* yacc.c:1652  */
    break;

  case 1681:
#line 10201 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44581 "preproc.c" /* yacc.c:1652  */
    break;

  case 1682:
#line 10205 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44589 "preproc.c" /* yacc.c:1652  */
    break;

  case 1683:
#line 10209 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44597 "preproc.c" /* yacc.c:1652  */
    break;

  case 1684:
#line 10213 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44605 "preproc.c" /* yacc.c:1652  */
    break;

  case 1685:
#line 10217 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44613 "preproc.c" /* yacc.c:1652  */
    break;

  case 1686:
#line 10225 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44621 "preproc.c" /* yacc.c:1652  */
    break;

  case 1687:
#line 10229 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44629 "preproc.c" /* yacc.c:1652  */
    break;

  case 1688:
#line 10233 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44637 "preproc.c" /* yacc.c:1652  */
    break;

  case 1689:
#line 10237 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44645 "preproc.c" /* yacc.c:1652  */
    break;

  case 1690:
#line 10245 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44653 "preproc.c" /* yacc.c:1652  */
    break;

  case 1691:
#line 10249 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44661 "preproc.c" /* yacc.c:1652  */
    break;

  case 1692:
#line 10257 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44669 "preproc.c" /* yacc.c:1652  */
    break;

  case 1693:
#line 10261 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44676 "preproc.c" /* yacc.c:1652  */
    break;

  case 1694:
#line 10268 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("int");
}
#line 44684 "preproc.c" /* yacc.c:1652  */
    break;

  case 1695:
#line 10272 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("integer");
}
#line 44692 "preproc.c" /* yacc.c:1652  */
    break;

  case 1696:
#line 10276 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("smallint");
}
#line 44700 "preproc.c" /* yacc.c:1652  */
    break;

  case 1697:
#line 10280 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("bigint");
}
#line 44708 "preproc.c" /* yacc.c:1652  */
    break;

  case 1698:
#line 10284 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("real");
}
#line 44716 "preproc.c" /* yacc.c:1652  */
    break;

  case 1699:
#line 10288 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("float"),(yyvsp[0].str));
}
#line 44724 "preproc.c" /* yacc.c:1652  */
    break;

  case 1700:
#line 10292 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("double precision");
}
#line 44732 "preproc.c" /* yacc.c:1652  */
    break;

  case 1701:
#line 10296 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("decimal"),(yyvsp[0].str));
}
#line 44740 "preproc.c" /* yacc.c:1652  */
    break;

  case 1702:
#line 10300 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("dec"),(yyvsp[0].str));
}
#line 44748 "preproc.c" /* yacc.c:1652  */
    break;

  case 1703:
#line 10304 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("numeric"),(yyvsp[0].str));
}
#line 44756 "preproc.c" /* yacc.c:1652  */
    break;

  case 1704:
#line 10308 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("boolean");
}
#line 44764 "preproc.c" /* yacc.c:1652  */
    break;

  case 1705:
#line 10316 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44772 "preproc.c" /* yacc.c:1652  */
    break;

  case 1706:
#line 10320 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44779 "preproc.c" /* yacc.c:1652  */
    break;

  case 1707:
#line 10327 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44787 "preproc.c" /* yacc.c:1652  */
    break;

  case 1708:
#line 10331 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44795 "preproc.c" /* yacc.c:1652  */
    break;

  case 1709:
#line 10339 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44803 "preproc.c" /* yacc.c:1652  */
    break;

  case 1710:
#line 10343 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44811 "preproc.c" /* yacc.c:1652  */
    break;

  case 1711:
#line 10351 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("bit"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44819 "preproc.c" /* yacc.c:1652  */
    break;

  case 1712:
#line 10359 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("bit"),(yyvsp[0].str));
}
#line 44827 "preproc.c" /* yacc.c:1652  */
    break;

  case 1713:
#line 10367 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44835 "preproc.c" /* yacc.c:1652  */
    break;

  case 1714:
#line 10371 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44843 "preproc.c" /* yacc.c:1652  */
    break;

  case 1715:
#line 10379 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44851 "preproc.c" /* yacc.c:1652  */
    break;

  case 1716:
#line 10383 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44859 "preproc.c" /* yacc.c:1652  */
    break;

  case 1717:
#line 10391 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 44867 "preproc.c" /* yacc.c:1652  */
    break;

  case 1718:
#line 10399 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44875 "preproc.c" /* yacc.c:1652  */
    break;

  case 1719:
#line 10407 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("character"),(yyvsp[0].str));
}
#line 44883 "preproc.c" /* yacc.c:1652  */
    break;

  case 1720:
#line 10411 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("char"),(yyvsp[0].str));
}
#line 44891 "preproc.c" /* yacc.c:1652  */
    break;

  case 1721:
#line 10415 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("varchar");
}
#line 44899 "preproc.c" /* yacc.c:1652  */
    break;

  case 1722:
#line 10419 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("national character"),(yyvsp[0].str));
}
#line 44907 "preproc.c" /* yacc.c:1652  */
    break;

  case 1723:
#line 10423 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("national char"),(yyvsp[0].str));
}
#line 44915 "preproc.c" /* yacc.c:1652  */
    break;

  case 1724:
#line 10427 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("nchar"),(yyvsp[0].str));
}
#line 44923 "preproc.c" /* yacc.c:1652  */
    break;

  case 1725:
#line 10435 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("varying");
}
#line 44931 "preproc.c" /* yacc.c:1652  */
    break;

  case 1726:
#line 10439 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44938 "preproc.c" /* yacc.c:1652  */
    break;

  case 1727:
#line 10446 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("character set"),(yyvsp[0].str));
}
#line 44946 "preproc.c" /* yacc.c:1652  */
    break;

  case 1728:
#line 10450 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44953 "preproc.c" /* yacc.c:1652  */
    break;

  case 1729:
#line 10457 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("timestamp ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 44961 "preproc.c" /* yacc.c:1652  */
    break;

  case 1730:
#line 10461 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("timestamp"),(yyvsp[0].str));
}
#line 44969 "preproc.c" /* yacc.c:1652  */
    break;

  case 1731:
#line 10465 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("time ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 44977 "preproc.c" /* yacc.c:1652  */
    break;

  case 1732:
#line 10469 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("time"),(yyvsp[0].str));
}
#line 44985 "preproc.c" /* yacc.c:1652  */
    break;

  case 1733:
#line 10477 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("interval");
}
#line 44993 "preproc.c" /* yacc.c:1652  */
    break;

  case 1734:
#line 10485 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with time zone");
}
#line 45001 "preproc.c" /* yacc.c:1652  */
    break;

  case 1735:
#line 10489 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("without time zone");
}
#line 45009 "preproc.c" /* yacc.c:1652  */
    break;

  case 1736:
#line 10493 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 45016 "preproc.c" /* yacc.c:1652  */
    break;

  case 1737:
#line 10500 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("year");
}
#line 45024 "preproc.c" /* yacc.c:1652  */
    break;

  case 1738:
#line 10504 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("month");
}
#line 45032 "preproc.c" /* yacc.c:1652  */
    break;

  case 1739:
#line 10508 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("day");
}
#line 45040 "preproc.c" /* yacc.c:1652  */
    break;

  case 1740:
#line 10512 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("hour");
}
#line 45048 "preproc.c" /* yacc.c:1652  */
    break;

  case 1741:
#line 10516 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("minute");
}
#line 45056 "preproc.c" /* yacc.c:1652  */
    break;

  case 1742:
#line 10520 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45064 "preproc.c" /* yacc.c:1652  */
    break;

  case 1743:
#line 10524 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("year to month");
}
#line 45072 "preproc.c" /* yacc.c:1652  */
    break;

  case 1744:
#line 10528 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("day to hour");
}
#line 45080 "preproc.c" /* yacc.c:1652  */
    break;

  case 1745:
#line 10532 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("day to minute");
}
#line 45088 "preproc.c" /* yacc.c:1652  */
    break;

  case 1746:
#line 10536 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("day to"),(yyvsp[0].str));
}
#line 45096 "preproc.c" /* yacc.c:1652  */
    break;

  case 1747:
#line 10540 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("hour to minute");
}
#line 45104 "preproc.c" /* yacc.c:1652  */
    break;

  case 1748:
#line 10544 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("hour to"),(yyvsp[0].str));
}
#line 45112 "preproc.c" /* yacc.c:1652  */
    break;

  case 1749:
#line 10548 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("minute to"),(yyvsp[0].str));
}
#line 45120 "preproc.c" /* yacc.c:1652  */
    break;

  case 1750:
#line 10552 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 45127 "preproc.c" /* yacc.c:1652  */
    break;

  case 1751:
#line 10559 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("second");
}
#line 45135 "preproc.c" /* yacc.c:1652  */
    break;

  case 1752:
#line 10563 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("second ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45143 "preproc.c" /* yacc.c:1652  */
    break;

  case 1753:
#line 10571 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45151 "preproc.c" /* yacc.c:1652  */
    break;

  case 1754:
#line 10575 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("::"),(yyvsp[0].str));
}
#line 45159 "preproc.c" /* yacc.c:1652  */
    break;

  case 1755:
#line 10579 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("collate"),(yyvsp[0].str));
}
#line 45167 "preproc.c" /* yacc.c:1652  */
    break;

  case 1756:
#line 10583 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("at time zone"),(yyvsp[0].str));
}
#line 45175 "preproc.c" /* yacc.c:1652  */
    break;

  case 1757:
#line 10587 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 45183 "preproc.c" /* yacc.c:1652  */
    break;

  case 1758:
#line 10591 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 45191 "preproc.c" /* yacc.c:1652  */
    break;

  case 1759:
#line 10595 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("+"),(yyvsp[0].str));
}
#line 45199 "preproc.c" /* yacc.c:1652  */
    break;

  case 1760:
#line 10599 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("-"),(yyvsp[0].str));
}
#line 45207 "preproc.c" /* yacc.c:1652  */
    break;

  case 1761:
#line 10603 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("*"),(yyvsp[0].str));
}
#line 45215 "preproc.c" /* yacc.c:1652  */
    break;

  case 1762:
#line 10607 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("/"),(yyvsp[0].str));
}
#line 45223 "preproc.c" /* yacc.c:1652  */
    break;

  case 1763:
#line 10611 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("%"),(yyvsp[0].str));
}
#line 45231 "preproc.c" /* yacc.c:1652  */
    break;

  case 1764:
#line 10615 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("^"),(yyvsp[0].str));
}
#line 45239 "preproc.c" /* yacc.c:1652  */
    break;

  case 1765:
#line 10619 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<"),(yyvsp[0].str));
}
#line 45247 "preproc.c" /* yacc.c:1652  */
    break;

  case 1766:
#line 10623 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">"),(yyvsp[0].str));
}
#line 45255 "preproc.c" /* yacc.c:1652  */
    break;

  case 1767:
#line 10627 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 45263 "preproc.c" /* yacc.c:1652  */
    break;

  case 1768:
#line 10631 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<="),(yyvsp[0].str));
}
#line 45271 "preproc.c" /* yacc.c:1652  */
    break;

  case 1769:
#line 10635 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">="),(yyvsp[0].str));
}
#line 45279 "preproc.c" /* yacc.c:1652  */
    break;

  case 1770:
#line 10639 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<>"),(yyvsp[0].str));
}
#line 45287 "preproc.c" /* yacc.c:1652  */
    break;

  case 1771:
#line 10643 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45295 "preproc.c" /* yacc.c:1652  */
    break;

  case 1772:
#line 10647 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45303 "preproc.c" /* yacc.c:1652  */
    break;

  case 1773:
#line 10651 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45311 "preproc.c" /* yacc.c:1652  */
    break;

  case 1774:
#line 10655 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 45319 "preproc.c" /* yacc.c:1652  */
    break;

  case 1775:
#line 10659 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("or"),(yyvsp[0].str));
}
#line 45327 "preproc.c" /* yacc.c:1652  */
    break;

  case 1776:
#line 10663 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("not"),(yyvsp[0].str));
}
#line 45335 "preproc.c" /* yacc.c:1652  */
    break;

  case 1777:
#line 10667 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("not"),(yyvsp[0].str));
}
#line 45343 "preproc.c" /* yacc.c:1652  */
    break;

  case 1778:
#line 10671 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("like"),(yyvsp[0].str));
}
#line 45351 "preproc.c" /* yacc.c:1652  */
    break;

  case 1779:
#line 10675 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("like"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 45359 "preproc.c" /* yacc.c:1652  */
    break;

  case 1780:
#line 10679 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not like"),(yyvsp[0].str));
}
#line 45367 "preproc.c" /* yacc.c:1652  */
    break;

  case 1781:
#line 10683 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("not like"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 45375 "preproc.c" /* yacc.c:1652  */
    break;

  case 1782:
#line 10687 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("ilike"),(yyvsp[0].str));
}
#line 45383 "preproc.c" /* yacc.c:1652  */
    break;

  case 1783:
#line 10691 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("ilike"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 45391 "preproc.c" /* yacc.c:1652  */
    break;

  case 1784:
#line 10695 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not ilike"),(yyvsp[0].str));
}
#line 45399 "preproc.c" /* yacc.c:1652  */
    break;

  case 1785:
#line 10699 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("not ilike"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 45407 "preproc.c" /* yacc.c:1652  */
    break;

  case 1786:
#line 10703 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("similar to"),(yyvsp[0].str));
}
#line 45415 "preproc.c" /* yacc.c:1652  */
    break;

  case 1787:
#line 10707 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("similar to"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 45423 "preproc.c" /* yacc.c:1652  */
    break;

  case 1788:
#line 10711 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("not similar to"),(yyvsp[0].str));
}
#line 45431 "preproc.c" /* yacc.c:1652  */
    break;

  case 1789:
#line 10715 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-6].str),mm_strdup("not similar to"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 45439 "preproc.c" /* yacc.c:1652  */
    break;

  case 1790:
#line 10719 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is null"));
}
#line 45447 "preproc.c" /* yacc.c:1652  */
    break;

  case 1791:
#line 10723 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("isnull"));
}
#line 45455 "preproc.c" /* yacc.c:1652  */
    break;

  case 1792:
#line 10727 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not null"));
}
#line 45463 "preproc.c" /* yacc.c:1652  */
    break;

  case 1793:
#line 10731 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("notnull"));
}
#line 45471 "preproc.c" /* yacc.c:1652  */
    break;

  case 1794:
#line 10735 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("overlaps"),(yyvsp[0].str));
}
#line 45479 "preproc.c" /* yacc.c:1652  */
    break;

  case 1795:
#line 10739 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is true"));
}
#line 45487 "preproc.c" /* yacc.c:1652  */
    break;

  case 1796:
#line 10743 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not true"));
}
#line 45495 "preproc.c" /* yacc.c:1652  */
    break;

  case 1797:
#line 10747 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is false"));
}
#line 45503 "preproc.c" /* yacc.c:1652  */
    break;

  case 1798:
#line 10751 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not false"));
}
#line 45511 "preproc.c" /* yacc.c:1652  */
    break;

  case 1799:
#line 10755 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is unknown"));
}
#line 45519 "preproc.c" /* yacc.c:1652  */
    break;

  case 1800:
#line 10759 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not unknown"));
}
#line 45527 "preproc.c" /* yacc.c:1652  */
    break;

  case 1801:
#line 10763 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("is distinct from"),(yyvsp[0].str));
}
#line 45535 "preproc.c" /* yacc.c:1652  */
    break;

  case 1802:
#line 10767 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-5].str),mm_strdup("is not distinct from"),(yyvsp[0].str));
}
#line 45543 "preproc.c" /* yacc.c:1652  */
    break;

  case 1803:
#line 10771 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("is of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45551 "preproc.c" /* yacc.c:1652  */
    break;

  case 1804:
#line 10775 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-6].str),mm_strdup("is not of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45559 "preproc.c" /* yacc.c:1652  */
    break;

  case 1805:
#line 10779 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),mm_strdup("between"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 45567 "preproc.c" /* yacc.c:1652  */
    break;

  case 1806:
#line 10783 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("not between"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 45575 "preproc.c" /* yacc.c:1652  */
    break;

  case 1807:
#line 10787 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("between symmetric"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 45583 "preproc.c" /* yacc.c:1652  */
    break;

  case 1808:
#line 10791 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-6].str),mm_strdup("not between symmetric"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 45591 "preproc.c" /* yacc.c:1652  */
    break;

  case 1809:
#line 10795 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("in"),(yyvsp[0].str));
}
#line 45599 "preproc.c" /* yacc.c:1652  */
    break;

  case 1810:
#line 10799 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not in"),(yyvsp[0].str));
}
#line 45607 "preproc.c" /* yacc.c:1652  */
    break;

  case 1811:
#line 10803 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45615 "preproc.c" /* yacc.c:1652  */
    break;

  case 1812:
#line 10807 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45623 "preproc.c" /* yacc.c:1652  */
    break;

  case 1813:
#line 10811 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("unique"),(yyvsp[0].str));
}
#line 45632 "preproc.c" /* yacc.c:1652  */
    break;

  case 1814:
#line 10816 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is document"));
}
#line 45640 "preproc.c" /* yacc.c:1652  */
    break;

  case 1815:
#line 10820 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not document"));
}
#line 45648 "preproc.c" /* yacc.c:1652  */
    break;

  case 1816:
#line 10828 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45656 "preproc.c" /* yacc.c:1652  */
    break;

  case 1817:
#line 10832 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("::"),(yyvsp[0].str));
}
#line 45664 "preproc.c" /* yacc.c:1652  */
    break;

  case 1818:
#line 10836 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 45672 "preproc.c" /* yacc.c:1652  */
    break;

  case 1819:
#line 10840 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 45680 "preproc.c" /* yacc.c:1652  */
    break;

  case 1820:
#line 10844 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("+"),(yyvsp[0].str));
}
#line 45688 "preproc.c" /* yacc.c:1652  */
    break;

  case 1821:
#line 10848 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("-"),(yyvsp[0].str));
}
#line 45696 "preproc.c" /* yacc.c:1652  */
    break;

  case 1822:
#line 10852 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("*"),(yyvsp[0].str));
}
#line 45704 "preproc.c" /* yacc.c:1652  */
    break;

  case 1823:
#line 10856 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("/"),(yyvsp[0].str));
}
#line 45712 "preproc.c" /* yacc.c:1652  */
    break;

  case 1824:
#line 10860 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("%"),(yyvsp[0].str));
}
#line 45720 "preproc.c" /* yacc.c:1652  */
    break;

  case 1825:
#line 10864 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("^"),(yyvsp[0].str));
}
#line 45728 "preproc.c" /* yacc.c:1652  */
    break;

  case 1826:
#line 10868 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<"),(yyvsp[0].str));
}
#line 45736 "preproc.c" /* yacc.c:1652  */
    break;

  case 1827:
#line 10872 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">"),(yyvsp[0].str));
}
#line 45744 "preproc.c" /* yacc.c:1652  */
    break;

  case 1828:
#line 10876 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 45752 "preproc.c" /* yacc.c:1652  */
    break;

  case 1829:
#line 10880 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<="),(yyvsp[0].str));
}
#line 45760 "preproc.c" /* yacc.c:1652  */
    break;

  case 1830:
#line 10884 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">="),(yyvsp[0].str));
}
#line 45768 "preproc.c" /* yacc.c:1652  */
    break;

  case 1831:
#line 10888 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<>"),(yyvsp[0].str));
}
#line 45776 "preproc.c" /* yacc.c:1652  */
    break;

  case 1832:
#line 10892 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45784 "preproc.c" /* yacc.c:1652  */
    break;

  case 1833:
#line 10896 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45792 "preproc.c" /* yacc.c:1652  */
    break;

  case 1834:
#line 10900 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45800 "preproc.c" /* yacc.c:1652  */
    break;

  case 1835:
#line 10904 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("is distinct from"),(yyvsp[0].str));
}
#line 45808 "preproc.c" /* yacc.c:1652  */
    break;

  case 1836:
#line 10908 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-5].str),mm_strdup("is not distinct from"),(yyvsp[0].str));
}
#line 45816 "preproc.c" /* yacc.c:1652  */
    break;

  case 1837:
#line 10912 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("is of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45824 "preproc.c" /* yacc.c:1652  */
    break;

  case 1838:
#line 10916 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-6].str),mm_strdup("is not of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45832 "preproc.c" /* yacc.c:1652  */
    break;

  case 1839:
#line 10920 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is document"));
}
#line 45840 "preproc.c" /* yacc.c:1652  */
    break;

  case 1840:
#line 10924 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not document"));
}
#line 45848 "preproc.c" /* yacc.c:1652  */
    break;

  case 1841:
#line 10932 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45856 "preproc.c" /* yacc.c:1652  */
    break;

  case 1842:
#line 10936 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45864 "preproc.c" /* yacc.c:1652  */
    break;

  case 1843:
#line 10940 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45872 "preproc.c" /* yacc.c:1652  */
    break;

  case 1844:
#line 10944 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 45880 "preproc.c" /* yacc.c:1652  */
    break;

  case 1845:
#line 10948 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45888 "preproc.c" /* yacc.c:1652  */
    break;

  case 1846:
#line 10952 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45896 "preproc.c" /* yacc.c:1652  */
    break;

  case 1847:
#line 10956 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45904 "preproc.c" /* yacc.c:1652  */
    break;

  case 1848:
#line 10960 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45912 "preproc.c" /* yacc.c:1652  */
    break;

  case 1849:
#line 10964 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("exists"),(yyvsp[0].str));
}
#line 45920 "preproc.c" /* yacc.c:1652  */
    break;

  case 1850:
#line 10968 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("array"),(yyvsp[0].str));
}
#line 45928 "preproc.c" /* yacc.c:1652  */
    break;

  case 1851:
#line 10972 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("array"),(yyvsp[0].str));
}
#line 45936 "preproc.c" /* yacc.c:1652  */
    break;

  case 1852:
#line 10976 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45944 "preproc.c" /* yacc.c:1652  */
    break;

  case 1853:
#line 10980 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45952 "preproc.c" /* yacc.c:1652  */
    break;

  case 1854:
#line 10984 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("grouping ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45960 "preproc.c" /* yacc.c:1652  */
    break;

  case 1855:
#line 10992 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("( )"));
}
#line 45968 "preproc.c" /* yacc.c:1652  */
    break;

  case 1856:
#line 10996 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45976 "preproc.c" /* yacc.c:1652  */
    break;

  case 1857:
#line 11000 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( variadic"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45984 "preproc.c" /* yacc.c:1652  */
    break;

  case 1858:
#line 11004 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(", variadic"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45992 "preproc.c" /* yacc.c:1652  */
    break;

  case 1859:
#line 11008 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( all"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46000 "preproc.c" /* yacc.c:1652  */
    break;

  case 1860:
#line 11012 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( distinct"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46008 "preproc.c" /* yacc.c:1652  */
    break;

  case 1861:
#line 11016 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("( * )"));
}
#line 46016 "preproc.c" /* yacc.c:1652  */
    break;

  case 1862:
#line 11024 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46024 "preproc.c" /* yacc.c:1652  */
    break;

  case 1863:
#line 11028 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46032 "preproc.c" /* yacc.c:1652  */
    break;

  case 1864:
#line 11036 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46040 "preproc.c" /* yacc.c:1652  */
    break;

  case 1865:
#line 11040 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46048 "preproc.c" /* yacc.c:1652  */
    break;

  case 1866:
#line 11048 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("collation for ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46056 "preproc.c" /* yacc.c:1652  */
    break;

  case 1867:
#line 11052 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_date");
}
#line 46064 "preproc.c" /* yacc.c:1652  */
    break;

  case 1868:
#line 11056 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_time");
}
#line 46072 "preproc.c" /* yacc.c:1652  */
    break;

  case 1869:
#line 11060 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("current_time ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46080 "preproc.c" /* yacc.c:1652  */
    break;

  case 1870:
#line 11064 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_timestamp");
}
#line 46088 "preproc.c" /* yacc.c:1652  */
    break;

  case 1871:
#line 11068 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("current_timestamp ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46096 "preproc.c" /* yacc.c:1652  */
    break;

  case 1872:
#line 11072 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("localtime");
}
#line 46104 "preproc.c" /* yacc.c:1652  */
    break;

  case 1873:
#line 11076 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("localtime ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46112 "preproc.c" /* yacc.c:1652  */
    break;

  case 1874:
#line 11080 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("localtimestamp");
}
#line 46120 "preproc.c" /* yacc.c:1652  */
    break;

  case 1875:
#line 11084 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("localtimestamp ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46128 "preproc.c" /* yacc.c:1652  */
    break;

  case 1876:
#line 11088 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_role");
}
#line 46136 "preproc.c" /* yacc.c:1652  */
    break;

  case 1877:
#line 11092 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_user");
}
#line 46144 "preproc.c" /* yacc.c:1652  */
    break;

  case 1878:
#line 11096 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session_user");
}
#line 46152 "preproc.c" /* yacc.c:1652  */
    break;

  case 1879:
#line 11100 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("user");
}
#line 46160 "preproc.c" /* yacc.c:1652  */
    break;

  case 1880:
#line 11104 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_catalog");
}
#line 46168 "preproc.c" /* yacc.c:1652  */
    break;

  case 1881:
#line 11108 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_schema");
}
#line 46176 "preproc.c" /* yacc.c:1652  */
    break;

  case 1882:
#line 11112 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("cast ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46184 "preproc.c" /* yacc.c:1652  */
    break;

  case 1883:
#line 11116 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("extract ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46192 "preproc.c" /* yacc.c:1652  */
    break;

  case 1884:
#line 11120 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("overlay ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46200 "preproc.c" /* yacc.c:1652  */
    break;

  case 1885:
#line 11124 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("position ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46208 "preproc.c" /* yacc.c:1652  */
    break;

  case 1886:
#line 11128 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("substring ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46216 "preproc.c" /* yacc.c:1652  */
    break;

  case 1887:
#line 11132 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("treat ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46224 "preproc.c" /* yacc.c:1652  */
    break;

  case 1888:
#line 11136 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( both"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46232 "preproc.c" /* yacc.c:1652  */
    break;

  case 1889:
#line 11140 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( leading"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46240 "preproc.c" /* yacc.c:1652  */
    break;

  case 1890:
#line 11144 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( trailing"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46248 "preproc.c" /* yacc.c:1652  */
    break;

  case 1891:
#line 11148 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("trim ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46256 "preproc.c" /* yacc.c:1652  */
    break;

  case 1892:
#line 11152 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("nullif ("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46264 "preproc.c" /* yacc.c:1652  */
    break;

  case 1893:
#line 11156 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("coalesce ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46272 "preproc.c" /* yacc.c:1652  */
    break;

  case 1894:
#line 11160 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("greatest ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46280 "preproc.c" /* yacc.c:1652  */
    break;

  case 1895:
#line 11164 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("least ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46288 "preproc.c" /* yacc.c:1652  */
    break;

  case 1896:
#line 11168 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("xmlconcat ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46296 "preproc.c" /* yacc.c:1652  */
    break;

  case 1897:
#line 11172 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("xmlelement ( name"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46304 "preproc.c" /* yacc.c:1652  */
    break;

  case 1898:
#line 11176 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("xmlelement ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46312 "preproc.c" /* yacc.c:1652  */
    break;

  case 1899:
#line 11180 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("xmlelement ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46320 "preproc.c" /* yacc.c:1652  */
    break;

  case 1900:
#line 11184 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("xmlelement ( name"),(yyvsp[-5].str),mm_strdup(","),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46328 "preproc.c" /* yacc.c:1652  */
    break;

  case 1901:
#line 11188 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("xmlexists ("),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46336 "preproc.c" /* yacc.c:1652  */
    break;

  case 1902:
#line 11192 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("xmlforest ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46344 "preproc.c" /* yacc.c:1652  */
    break;

  case 1903:
#line 11196 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("xmlparse ("),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46352 "preproc.c" /* yacc.c:1652  */
    break;

  case 1904:
#line 11200 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("xmlpi ( name"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46360 "preproc.c" /* yacc.c:1652  */
    break;

  case 1905:
#line 11204 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("xmlpi ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46368 "preproc.c" /* yacc.c:1652  */
    break;

  case 1906:
#line 11208 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("xmlroot ("),(yyvsp[-4].str),mm_strdup(","),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46376 "preproc.c" /* yacc.c:1652  */
    break;

  case 1907:
#line 11212 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("xmlserialize ("),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46384 "preproc.c" /* yacc.c:1652  */
    break;

  case 1908:
#line 11220 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 46392 "preproc.c" /* yacc.c:1652  */
    break;

  case 1909:
#line 11224 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("version no value");
}
#line 46400 "preproc.c" /* yacc.c:1652  */
    break;

  case 1910:
#line 11232 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(", standalone yes");
}
#line 46408 "preproc.c" /* yacc.c:1652  */
    break;

  case 1911:
#line 11236 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(", standalone no");
}
#line 46416 "preproc.c" /* yacc.c:1652  */
    break;

  case 1912:
#line 11240 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(", standalone no value");
}
#line 46424 "preproc.c" /* yacc.c:1652  */
    break;

  case 1913:
#line 11244 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46431 "preproc.c" /* yacc.c:1652  */
    break;

  case 1914:
#line 11251 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("xmlattributes ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46439 "preproc.c" /* yacc.c:1652  */
    break;

  case 1915:
#line 11259 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46447 "preproc.c" /* yacc.c:1652  */
    break;

  case 1916:
#line 11263 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46455 "preproc.c" /* yacc.c:1652  */
    break;

  case 1917:
#line 11271 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 46463 "preproc.c" /* yacc.c:1652  */
    break;

  case 1918:
#line 11275 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46471 "preproc.c" /* yacc.c:1652  */
    break;

  case 1919:
#line 11283 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("document");
}
#line 46479 "preproc.c" /* yacc.c:1652  */
    break;

  case 1920:
#line 11287 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("content");
}
#line 46487 "preproc.c" /* yacc.c:1652  */
    break;

  case 1921:
#line 11295 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("preserve whitespace");
}
#line 46495 "preproc.c" /* yacc.c:1652  */
    break;

  case 1922:
#line 11299 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("strip whitespace");
}
#line 46503 "preproc.c" /* yacc.c:1652  */
    break;

  case 1923:
#line 11303 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46510 "preproc.c" /* yacc.c:1652  */
    break;

  case 1924:
#line 11310 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("passing"),(yyvsp[0].str));
}
#line 46518 "preproc.c" /* yacc.c:1652  */
    break;

  case 1925:
#line 11314 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("passing"),(yyvsp[-2].str),mm_strdup("by ref"));
}
#line 46526 "preproc.c" /* yacc.c:1652  */
    break;

  case 1926:
#line 11318 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("passing by ref"),(yyvsp[0].str));
}
#line 46534 "preproc.c" /* yacc.c:1652  */
    break;

  case 1927:
#line 11322 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("passing by ref"),(yyvsp[-2].str),mm_strdup("by ref"));
}
#line 46542 "preproc.c" /* yacc.c:1652  */
    break;

  case 1928:
#line 11330 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("within group ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46550 "preproc.c" /* yacc.c:1652  */
    break;

  case 1929:
#line 11334 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46557 "preproc.c" /* yacc.c:1652  */
    break;

  case 1930:
#line 11341 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("filter ( where"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46565 "preproc.c" /* yacc.c:1652  */
    break;

  case 1931:
#line 11345 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46572 "preproc.c" /* yacc.c:1652  */
    break;

  case 1932:
#line 11352 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("window"),(yyvsp[0].str));
}
#line 46580 "preproc.c" /* yacc.c:1652  */
    break;

  case 1933:
#line 11356 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46587 "preproc.c" /* yacc.c:1652  */
    break;

  case 1934:
#line 11363 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46595 "preproc.c" /* yacc.c:1652  */
    break;

  case 1935:
#line 11367 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46603 "preproc.c" /* yacc.c:1652  */
    break;

  case 1936:
#line 11375 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 46611 "preproc.c" /* yacc.c:1652  */
    break;

  case 1937:
#line 11383 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("over"),(yyvsp[0].str));
}
#line 46619 "preproc.c" /* yacc.c:1652  */
    break;

  case 1938:
#line 11387 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("over"),(yyvsp[0].str));
}
#line 46627 "preproc.c" /* yacc.c:1652  */
    break;

  case 1939:
#line 11391 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46634 "preproc.c" /* yacc.c:1652  */
    break;

  case 1940:
#line 11398 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("("),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46642 "preproc.c" /* yacc.c:1652  */
    break;

  case 1941:
#line 11406 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46650 "preproc.c" /* yacc.c:1652  */
    break;

  case 1942:
#line 11410 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46657 "preproc.c" /* yacc.c:1652  */
    break;

  case 1943:
#line 11417 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("partition by"),(yyvsp[0].str));
}
#line 46665 "preproc.c" /* yacc.c:1652  */
    break;

  case 1944:
#line 11421 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46672 "preproc.c" /* yacc.c:1652  */
    break;

  case 1945:
#line 11428 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("range"),(yyvsp[0].str));
}
#line 46681 "preproc.c" /* yacc.c:1652  */
    break;

  case 1946:
#line 11433 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("rows"),(yyvsp[0].str));
}
#line 46689 "preproc.c" /* yacc.c:1652  */
    break;

  case 1947:
#line 11437 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46696 "preproc.c" /* yacc.c:1652  */
    break;

  case 1948:
#line 11444 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46704 "preproc.c" /* yacc.c:1652  */
    break;

  case 1949:
#line 11448 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("between"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 46712 "preproc.c" /* yacc.c:1652  */
    break;

  case 1950:
#line 11456 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unbounded preceding");
}
#line 46720 "preproc.c" /* yacc.c:1652  */
    break;

  case 1951:
#line 11460 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unbounded following");
}
#line 46728 "preproc.c" /* yacc.c:1652  */
    break;

  case 1952:
#line 11464 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current row");
}
#line 46736 "preproc.c" /* yacc.c:1652  */
    break;

  case 1953:
#line 11468 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("preceding"));
}
#line 46744 "preproc.c" /* yacc.c:1652  */
    break;

  case 1954:
#line 11472 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("following"));
}
#line 46752 "preproc.c" /* yacc.c:1652  */
    break;

  case 1955:
#line 11480 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("row ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46760 "preproc.c" /* yacc.c:1652  */
    break;

  case 1956:
#line 11484 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row ( )");
}
#line 46768 "preproc.c" /* yacc.c:1652  */
    break;

  case 1957:
#line 11488 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46776 "preproc.c" /* yacc.c:1652  */
    break;

  case 1958:
#line 11496 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("row ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46784 "preproc.c" /* yacc.c:1652  */
    break;

  case 1959:
#line 11500 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row ( )");
}
#line 46792 "preproc.c" /* yacc.c:1652  */
    break;

  case 1960:
#line 11508 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46800 "preproc.c" /* yacc.c:1652  */
    break;

  case 1961:
#line 11516 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("any");
}
#line 46808 "preproc.c" /* yacc.c:1652  */
    break;

  case 1962:
#line 11520 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("some");
}
#line 46816 "preproc.c" /* yacc.c:1652  */
    break;

  case 1963:
#line 11524 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 46824 "preproc.c" /* yacc.c:1652  */
    break;

  case 1964:
#line 11532 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46832 "preproc.c" /* yacc.c:1652  */
    break;

  case 1965:
#line 11536 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46840 "preproc.c" /* yacc.c:1652  */
    break;

  case 1966:
#line 11544 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("+");
}
#line 46848 "preproc.c" /* yacc.c:1652  */
    break;

  case 1967:
#line 11548 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("-");
}
#line 46856 "preproc.c" /* yacc.c:1652  */
    break;

  case 1968:
#line 11552 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("*");
}
#line 46864 "preproc.c" /* yacc.c:1652  */
    break;

  case 1969:
#line 11556 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("/");
}
#line 46872 "preproc.c" /* yacc.c:1652  */
    break;

  case 1970:
#line 11560 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("%");
}
#line 46880 "preproc.c" /* yacc.c:1652  */
    break;

  case 1971:
#line 11564 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("^");
}
#line 46888 "preproc.c" /* yacc.c:1652  */
    break;

  case 1972:
#line 11568 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("<");
}
#line 46896 "preproc.c" /* yacc.c:1652  */
    break;

  case 1973:
#line 11572 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(">");
}
#line 46904 "preproc.c" /* yacc.c:1652  */
    break;

  case 1974:
#line 11576 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("=");
}
#line 46912 "preproc.c" /* yacc.c:1652  */
    break;

  case 1975:
#line 11580 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("<=");
}
#line 46920 "preproc.c" /* yacc.c:1652  */
    break;

  case 1976:
#line 11584 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(">=");
}
#line 46928 "preproc.c" /* yacc.c:1652  */
    break;

  case 1977:
#line 11588 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("<>");
}
#line 46936 "preproc.c" /* yacc.c:1652  */
    break;

  case 1978:
#line 11596 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46944 "preproc.c" /* yacc.c:1652  */
    break;

  case 1979:
#line 11600 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46952 "preproc.c" /* yacc.c:1652  */
    break;

  case 1980:
#line 11608 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46960 "preproc.c" /* yacc.c:1652  */
    break;

  case 1981:
#line 11612 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46968 "preproc.c" /* yacc.c:1652  */
    break;

  case 1982:
#line 11620 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46976 "preproc.c" /* yacc.c:1652  */
    break;

  case 1983:
#line 11624 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46984 "preproc.c" /* yacc.c:1652  */
    break;

  case 1984:
#line 11628 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("like");
}
#line 46992 "preproc.c" /* yacc.c:1652  */
    break;

  case 1985:
#line 11632 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not like");
}
#line 47000 "preproc.c" /* yacc.c:1652  */
    break;

  case 1986:
#line 11636 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("ilike");
}
#line 47008 "preproc.c" /* yacc.c:1652  */
    break;

  case 1987:
#line 11640 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not ilike");
}
#line 47016 "preproc.c" /* yacc.c:1652  */
    break;

  case 1988:
#line 11648 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47024 "preproc.c" /* yacc.c:1652  */
    break;

  case 1989:
#line 11652 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47032 "preproc.c" /* yacc.c:1652  */
    break;

  case 1990:
#line 11660 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47040 "preproc.c" /* yacc.c:1652  */
    break;

  case 1991:
#line 11664 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47048 "preproc.c" /* yacc.c:1652  */
    break;

  case 1992:
#line 11672 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47056 "preproc.c" /* yacc.c:1652  */
    break;

  case 1993:
#line 11676 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(":="),(yyvsp[0].str));
}
#line 47064 "preproc.c" /* yacc.c:1652  */
    break;

  case 1994:
#line 11680 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("=>"),(yyvsp[0].str));
}
#line 47072 "preproc.c" /* yacc.c:1652  */
    break;

  case 1995:
#line 11688 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47080 "preproc.c" /* yacc.c:1652  */
    break;

  case 1996:
#line 11692 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47088 "preproc.c" /* yacc.c:1652  */
    break;

  case 1997:
#line 11700 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 47096 "preproc.c" /* yacc.c:1652  */
    break;

  case 1998:
#line 11704 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 47104 "preproc.c" /* yacc.c:1652  */
    break;

  case 1999:
#line 11708 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("[ ]");
}
#line 47112 "preproc.c" /* yacc.c:1652  */
    break;

  case 2000:
#line 11716 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47120 "preproc.c" /* yacc.c:1652  */
    break;

  case 2001:
#line 11720 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47128 "preproc.c" /* yacc.c:1652  */
    break;

  case 2002:
#line 11728 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 47136 "preproc.c" /* yacc.c:1652  */
    break;

  case 2003:
#line 11732 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47143 "preproc.c" /* yacc.c:1652  */
    break;

  case 2004:
#line 11739 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47151 "preproc.c" /* yacc.c:1652  */
    break;

  case 2005:
#line 11743 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("year");
}
#line 47159 "preproc.c" /* yacc.c:1652  */
    break;

  case 2006:
#line 11747 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("month");
}
#line 47167 "preproc.c" /* yacc.c:1652  */
    break;

  case 2007:
#line 11751 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("day");
}
#line 47175 "preproc.c" /* yacc.c:1652  */
    break;

  case 2008:
#line 11755 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("hour");
}
#line 47183 "preproc.c" /* yacc.c:1652  */
    break;

  case 2009:
#line 11759 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("minute");
}
#line 47191 "preproc.c" /* yacc.c:1652  */
    break;

  case 2010:
#line 11763 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("second");
}
#line 47199 "preproc.c" /* yacc.c:1652  */
    break;

  case 2011:
#line 11767 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47207 "preproc.c" /* yacc.c:1652  */
    break;

  case 2012:
#line 11775 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47215 "preproc.c" /* yacc.c:1652  */
    break;

  case 2013:
#line 11779 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47223 "preproc.c" /* yacc.c:1652  */
    break;

  case 2014:
#line 11787 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("placing"),(yyvsp[0].str));
}
#line 47231 "preproc.c" /* yacc.c:1652  */
    break;

  case 2015:
#line 11795 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("in"),(yyvsp[0].str));
}
#line 47239 "preproc.c" /* yacc.c:1652  */
    break;

  case 2016:
#line 11799 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47246 "preproc.c" /* yacc.c:1652  */
    break;

  case 2017:
#line 11806 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47254 "preproc.c" /* yacc.c:1652  */
    break;

  case 2018:
#line 11810 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47262 "preproc.c" /* yacc.c:1652  */
    break;

  case 2019:
#line 11814 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47270 "preproc.c" /* yacc.c:1652  */
    break;

  case 2020:
#line 11818 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47278 "preproc.c" /* yacc.c:1652  */
    break;

  case 2021:
#line 11822 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47286 "preproc.c" /* yacc.c:1652  */
    break;

  case 2022:
#line 11826 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47293 "preproc.c" /* yacc.c:1652  */
    break;

  case 2023:
#line 11833 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 47301 "preproc.c" /* yacc.c:1652  */
    break;

  case 2024:
#line 11841 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 47309 "preproc.c" /* yacc.c:1652  */
    break;

  case 2025:
#line 11849 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 47317 "preproc.c" /* yacc.c:1652  */
    break;

  case 2026:
#line 11853 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 47325 "preproc.c" /* yacc.c:1652  */
    break;

  case 2027:
#line 11857 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47333 "preproc.c" /* yacc.c:1652  */
    break;

  case 2028:
#line 11865 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47341 "preproc.c" /* yacc.c:1652  */
    break;

  case 2029:
#line 11869 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47349 "preproc.c" /* yacc.c:1652  */
    break;

  case 2030:
#line 11877 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("case"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("end"));
}
#line 47357 "preproc.c" /* yacc.c:1652  */
    break;

  case 2031:
#line 11885 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47365 "preproc.c" /* yacc.c:1652  */
    break;

  case 2032:
#line 11889 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47373 "preproc.c" /* yacc.c:1652  */
    break;

  case 2033:
#line 11897 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("when"),(yyvsp[-2].str),mm_strdup("then"),(yyvsp[0].str));
}
#line 47381 "preproc.c" /* yacc.c:1652  */
    break;

  case 2034:
#line 11905 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("else"),(yyvsp[0].str));
}
#line 47389 "preproc.c" /* yacc.c:1652  */
    break;

  case 2035:
#line 11909 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47396 "preproc.c" /* yacc.c:1652  */
    break;

  case 2036:
#line 11916 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47404 "preproc.c" /* yacc.c:1652  */
    break;

  case 2037:
#line 11920 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47411 "preproc.c" /* yacc.c:1652  */
    break;

  case 2038:
#line 11927 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47419 "preproc.c" /* yacc.c:1652  */
    break;

  case 2039:
#line 11931 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47427 "preproc.c" /* yacc.c:1652  */
    break;

  case 2040:
#line 11939 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("."),(yyvsp[0].str));
}
#line 47435 "preproc.c" /* yacc.c:1652  */
    break;

  case 2041:
#line 11943 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(". *");
}
#line 47443 "preproc.c" /* yacc.c:1652  */
    break;

  case 2042:
#line 11947 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 47451 "preproc.c" /* yacc.c:1652  */
    break;

  case 2043:
#line 11951 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("["),(yyvsp[-3].str),mm_strdup(":"),(yyvsp[-1].str),mm_strdup("]"));
}
#line 47459 "preproc.c" /* yacc.c:1652  */
    break;

  case 2044:
#line 11959 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47467 "preproc.c" /* yacc.c:1652  */
    break;

  case 2045:
#line 11963 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47474 "preproc.c" /* yacc.c:1652  */
    break;

  case 2046:
#line 11970 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47482 "preproc.c" /* yacc.c:1652  */
    break;

  case 2047:
#line 11974 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47490 "preproc.c" /* yacc.c:1652  */
    break;

  case 2048:
#line 11982 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47497 "preproc.c" /* yacc.c:1652  */
    break;

  case 2049:
#line 11985 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47505 "preproc.c" /* yacc.c:1652  */
    break;

  case 2050:
#line 11993 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("asymmetric");
}
#line 47513 "preproc.c" /* yacc.c:1652  */
    break;

  case 2051:
#line 11997 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47520 "preproc.c" /* yacc.c:1652  */
    break;

  case 2052:
#line 12004 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47528 "preproc.c" /* yacc.c:1652  */
    break;

  case 2053:
#line 12008 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 47536 "preproc.c" /* yacc.c:1652  */
    break;

  case 2054:
#line 12016 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47544 "preproc.c" /* yacc.c:1652  */
    break;

  case 2055:
#line 12020 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47552 "preproc.c" /* yacc.c:1652  */
    break;

  case 2056:
#line 12028 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47560 "preproc.c" /* yacc.c:1652  */
    break;

  case 2057:
#line 12036 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47568 "preproc.c" /* yacc.c:1652  */
    break;

  case 2058:
#line 12040 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47575 "preproc.c" /* yacc.c:1652  */
    break;

  case 2059:
#line 12047 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47583 "preproc.c" /* yacc.c:1652  */
    break;

  case 2060:
#line 12051 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47591 "preproc.c" /* yacc.c:1652  */
    break;

  case 2061:
#line 12059 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 47599 "preproc.c" /* yacc.c:1652  */
    break;

  case 2062:
#line 12063 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47607 "preproc.c" /* yacc.c:1652  */
    break;

  case 2063:
#line 12067 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47615 "preproc.c" /* yacc.c:1652  */
    break;

  case 2064:
#line 12071 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("*");
}
#line 47623 "preproc.c" /* yacc.c:1652  */
    break;

  case 2065:
#line 12079 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47631 "preproc.c" /* yacc.c:1652  */
    break;

  case 2066:
#line 12083 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47639 "preproc.c" /* yacc.c:1652  */
    break;

  case 2067:
#line 12091 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47647 "preproc.c" /* yacc.c:1652  */
    break;

  case 2068:
#line 12095 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47655 "preproc.c" /* yacc.c:1652  */
    break;

  case 2069:
#line 12103 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47663 "preproc.c" /* yacc.c:1652  */
    break;

  case 2070:
#line 12107 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47671 "preproc.c" /* yacc.c:1652  */
    break;

  case 2071:
#line 12115 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47679 "preproc.c" /* yacc.c:1652  */
    break;

  case 2072:
#line 12123 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47687 "preproc.c" /* yacc.c:1652  */
    break;

  case 2073:
#line 12131 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47695 "preproc.c" /* yacc.c:1652  */
    break;

  case 2074:
#line 12139 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47703 "preproc.c" /* yacc.c:1652  */
    break;

  case 2075:
#line 12147 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47711 "preproc.c" /* yacc.c:1652  */
    break;

  case 2076:
#line 12155 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47719 "preproc.c" /* yacc.c:1652  */
    break;

  case 2077:
#line 12163 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47727 "preproc.c" /* yacc.c:1652  */
    break;

  case 2078:
#line 12167 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47735 "preproc.c" /* yacc.c:1652  */
    break;

  case 2079:
#line 12175 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47743 "preproc.c" /* yacc.c:1652  */
    break;

  case 2080:
#line 12179 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47751 "preproc.c" /* yacc.c:1652  */
    break;

  case 2081:
#line 12183 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47759 "preproc.c" /* yacc.c:1652  */
    break;

  case 2082:
#line 12187 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47767 "preproc.c" /* yacc.c:1652  */
    break;

  case 2083:
#line 12191 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xconst");
}
#line 47775 "preproc.c" /* yacc.c:1652  */
    break;

  case 2084:
#line 12195 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47783 "preproc.c" /* yacc.c:1652  */
    break;

  case 2085:
#line 12199 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),mm_strdup("("),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 47791 "preproc.c" /* yacc.c:1652  */
    break;

  case 2086:
#line 12203 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47799 "preproc.c" /* yacc.c:1652  */
    break;

  case 2087:
#line 12207 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47807 "preproc.c" /* yacc.c:1652  */
    break;

  case 2088:
#line 12211 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 47815 "preproc.c" /* yacc.c:1652  */
    break;

  case 2089:
#line 12215 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("true");
}
#line 47823 "preproc.c" /* yacc.c:1652  */
    break;

  case 2090:
#line 12219 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("false");
}
#line 47831 "preproc.c" /* yacc.c:1652  */
    break;

  case 2091:
#line 12223 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 47839 "preproc.c" /* yacc.c:1652  */
    break;

  case 2092:
#line 12226 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47845 "preproc.c" /* yacc.c:1652  */
    break;

  case 2093:
#line 12227 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47851 "preproc.c" /* yacc.c:1652  */
    break;

  case 2094:
#line 12233 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 47857 "preproc.c" /* yacc.c:1652  */
    break;

  case 2095:
#line 12239 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47865 "preproc.c" /* yacc.c:1652  */
    break;

  case 2096:
#line 12242 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47871 "preproc.c" /* yacc.c:1652  */
    break;

  case 2097:
#line 12244 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 47879 "preproc.c" /* yacc.c:1652  */
    break;

  case 2098:
#line 12248 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 47887 "preproc.c" /* yacc.c:1652  */
    break;

  case 2099:
#line 12256 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47895 "preproc.c" /* yacc.c:1652  */
    break;

  case 2100:
#line 12264 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47903 "preproc.c" /* yacc.c:1652  */
    break;

  case 2101:
#line 12268 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_user");
}
#line 47911 "preproc.c" /* yacc.c:1652  */
    break;

  case 2102:
#line 12272 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session_user");
}
#line 47919 "preproc.c" /* yacc.c:1652  */
    break;

  case 2103:
#line 12280 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47927 "preproc.c" /* yacc.c:1652  */
    break;

  case 2104:
#line 12284 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47935 "preproc.c" /* yacc.c:1652  */
    break;

  case 2105:
#line 12292 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47943 "preproc.c" /* yacc.c:1652  */
    break;

  case 2106:
#line 12296 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47951 "preproc.c" /* yacc.c:1652  */
    break;

  case 2107:
#line 12300 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47959 "preproc.c" /* yacc.c:1652  */
    break;

  case 2108:
#line 12304 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47967 "preproc.c" /* yacc.c:1652  */
    break;

  case 2109:
#line 12312 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("abort");
}
#line 47975 "preproc.c" /* yacc.c:1652  */
    break;

  case 2110:
#line 12316 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("absolute");
}
#line 47983 "preproc.c" /* yacc.c:1652  */
    break;

  case 2111:
#line 12320 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("access");
}
#line 47991 "preproc.c" /* yacc.c:1652  */
    break;

  case 2112:
#line 12324 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("action");
}
#line 47999 "preproc.c" /* yacc.c:1652  */
    break;

  case 2113:
#line 12328 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("add");
}
#line 48007 "preproc.c" /* yacc.c:1652  */
    break;

  case 2114:
#line 12332 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("admin");
}
#line 48015 "preproc.c" /* yacc.c:1652  */
    break;

  case 2115:
#line 12336 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("after");
}
#line 48023 "preproc.c" /* yacc.c:1652  */
    break;

  case 2116:
#line 12340 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("aggregate");
}
#line 48031 "preproc.c" /* yacc.c:1652  */
    break;

  case 2117:
#line 12344 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("also");
}
#line 48039 "preproc.c" /* yacc.c:1652  */
    break;

  case 2118:
#line 12348 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("alter");
}
#line 48047 "preproc.c" /* yacc.c:1652  */
    break;

  case 2119:
#line 12352 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("always");
}
#line 48055 "preproc.c" /* yacc.c:1652  */
    break;

  case 2120:
#line 12356 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("assertion");
}
#line 48063 "preproc.c" /* yacc.c:1652  */
    break;

  case 2121:
#line 12360 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("assignment");
}
#line 48071 "preproc.c" /* yacc.c:1652  */
    break;

  case 2122:
#line 12364 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("at");
}
#line 48079 "preproc.c" /* yacc.c:1652  */
    break;

  case 2123:
#line 12368 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("attribute");
}
#line 48087 "preproc.c" /* yacc.c:1652  */
    break;

  case 2124:
#line 12372 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("backward");
}
#line 48095 "preproc.c" /* yacc.c:1652  */
    break;

  case 2125:
#line 12376 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("before");
}
#line 48103 "preproc.c" /* yacc.c:1652  */
    break;

  case 2126:
#line 12380 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("begin");
}
#line 48111 "preproc.c" /* yacc.c:1652  */
    break;

  case 2127:
#line 12384 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("by");
}
#line 48119 "preproc.c" /* yacc.c:1652  */
    break;

  case 2128:
#line 12388 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cache");
}
#line 48127 "preproc.c" /* yacc.c:1652  */
    break;

  case 2129:
#line 12392 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("called");
}
#line 48135 "preproc.c" /* yacc.c:1652  */
    break;

  case 2130:
#line 12396 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cascade");
}
#line 48143 "preproc.c" /* yacc.c:1652  */
    break;

  case 2131:
#line 12400 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cascaded");
}
#line 48151 "preproc.c" /* yacc.c:1652  */
    break;

  case 2132:
#line 12404 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("catalog");
}
#line 48159 "preproc.c" /* yacc.c:1652  */
    break;

  case 2133:
#line 12408 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("chain");
}
#line 48167 "preproc.c" /* yacc.c:1652  */
    break;

  case 2134:
#line 12412 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("characteristics");
}
#line 48175 "preproc.c" /* yacc.c:1652  */
    break;

  case 2135:
#line 12416 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("checkpoint");
}
#line 48183 "preproc.c" /* yacc.c:1652  */
    break;

  case 2136:
#line 12420 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("class");
}
#line 48191 "preproc.c" /* yacc.c:1652  */
    break;

  case 2137:
#line 12424 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("close");
}
#line 48199 "preproc.c" /* yacc.c:1652  */
    break;

  case 2138:
#line 12428 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cluster");
}
#line 48207 "preproc.c" /* yacc.c:1652  */
    break;

  case 2139:
#line 12432 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("comment");
}
#line 48215 "preproc.c" /* yacc.c:1652  */
    break;

  case 2140:
#line 12436 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("comments");
}
#line 48223 "preproc.c" /* yacc.c:1652  */
    break;

  case 2141:
#line 12440 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("commit");
}
#line 48231 "preproc.c" /* yacc.c:1652  */
    break;

  case 2142:
#line 12444 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("committed");
}
#line 48239 "preproc.c" /* yacc.c:1652  */
    break;

  case 2143:
#line 12448 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("configuration");
}
#line 48247 "preproc.c" /* yacc.c:1652  */
    break;

  case 2144:
#line 12452 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("conflict");
}
#line 48255 "preproc.c" /* yacc.c:1652  */
    break;

  case 2145:
#line 12456 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("constraints");
}
#line 48263 "preproc.c" /* yacc.c:1652  */
    break;

  case 2146:
#line 12460 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("content");
}
#line 48271 "preproc.c" /* yacc.c:1652  */
    break;

  case 2147:
#line 12464 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("continue");
}
#line 48279 "preproc.c" /* yacc.c:1652  */
    break;

  case 2148:
#line 12468 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("conversion");
}
#line 48287 "preproc.c" /* yacc.c:1652  */
    break;

  case 2149:
#line 12472 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("copy");
}
#line 48295 "preproc.c" /* yacc.c:1652  */
    break;

  case 2150:
#line 12476 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cost");
}
#line 48303 "preproc.c" /* yacc.c:1652  */
    break;

  case 2151:
#line 12480 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("csv");
}
#line 48311 "preproc.c" /* yacc.c:1652  */
    break;

  case 2152:
#line 12484 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cube");
}
#line 48319 "preproc.c" /* yacc.c:1652  */
    break;

  case 2153:
#line 12488 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cursor");
}
#line 48327 "preproc.c" /* yacc.c:1652  */
    break;

  case 2154:
#line 12492 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cycle");
}
#line 48335 "preproc.c" /* yacc.c:1652  */
    break;

  case 2155:
#line 12496 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("data");
}
#line 48343 "preproc.c" /* yacc.c:1652  */
    break;

  case 2156:
#line 12500 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("database");
}
#line 48351 "preproc.c" /* yacc.c:1652  */
    break;

  case 2157:
#line 12504 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deallocate");
}
#line 48359 "preproc.c" /* yacc.c:1652  */
    break;

  case 2158:
#line 12508 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("declare");
}
#line 48367 "preproc.c" /* yacc.c:1652  */
    break;

  case 2159:
#line 12512 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("defaults");
}
#line 48375 "preproc.c" /* yacc.c:1652  */
    break;

  case 2160:
#line 12516 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferred");
}
#line 48383 "preproc.c" /* yacc.c:1652  */
    break;

  case 2161:
#line 12520 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("definer");
}
#line 48391 "preproc.c" /* yacc.c:1652  */
    break;

  case 2162:
#line 12524 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delete");
}
#line 48399 "preproc.c" /* yacc.c:1652  */
    break;

  case 2163:
#line 12528 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delimiter");
}
#line 48407 "preproc.c" /* yacc.c:1652  */
    break;

  case 2164:
#line 12532 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delimiters");
}
#line 48415 "preproc.c" /* yacc.c:1652  */
    break;

  case 2165:
#line 12536 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("depends");
}
#line 48423 "preproc.c" /* yacc.c:1652  */
    break;

  case 2166:
#line 12540 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("dictionary");
}
#line 48431 "preproc.c" /* yacc.c:1652  */
    break;

  case 2167:
#line 12544 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("disable");
}
#line 48439 "preproc.c" /* yacc.c:1652  */
    break;

  case 2168:
#line 12548 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard");
}
#line 48447 "preproc.c" /* yacc.c:1652  */
    break;

  case 2169:
#line 12552 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("document");
}
#line 48455 "preproc.c" /* yacc.c:1652  */
    break;

  case 2170:
#line 12556 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("domain");
}
#line 48463 "preproc.c" /* yacc.c:1652  */
    break;

  case 2171:
#line 12560 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("double");
}
#line 48471 "preproc.c" /* yacc.c:1652  */
    break;

  case 2172:
#line 12564 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("drop");
}
#line 48479 "preproc.c" /* yacc.c:1652  */
    break;

  case 2173:
#line 12568 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("each");
}
#line 48487 "preproc.c" /* yacc.c:1652  */
    break;

  case 2174:
#line 12572 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable");
}
#line 48495 "preproc.c" /* yacc.c:1652  */
    break;

  case 2175:
#line 12576 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("encoding");
}
#line 48503 "preproc.c" /* yacc.c:1652  */
    break;

  case 2176:
#line 12580 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("encrypted");
}
#line 48511 "preproc.c" /* yacc.c:1652  */
    break;

  case 2177:
#line 12584 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enum");
}
#line 48519 "preproc.c" /* yacc.c:1652  */
    break;

  case 2178:
#line 12588 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("escape");
}
#line 48527 "preproc.c" /* yacc.c:1652  */
    break;

  case 2179:
#line 12592 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("event");
}
#line 48535 "preproc.c" /* yacc.c:1652  */
    break;

  case 2180:
#line 12596 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exclude");
}
#line 48543 "preproc.c" /* yacc.c:1652  */
    break;

  case 2181:
#line 12600 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("excluding");
}
#line 48551 "preproc.c" /* yacc.c:1652  */
    break;

  case 2182:
#line 12604 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exclusive");
}
#line 48559 "preproc.c" /* yacc.c:1652  */
    break;

  case 2183:
#line 12608 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("execute");
}
#line 48567 "preproc.c" /* yacc.c:1652  */
    break;

  case 2184:
#line 12612 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("explain");
}
#line 48575 "preproc.c" /* yacc.c:1652  */
    break;

  case 2185:
#line 12616 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("extension");
}
#line 48583 "preproc.c" /* yacc.c:1652  */
    break;

  case 2186:
#line 12620 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("external");
}
#line 48591 "preproc.c" /* yacc.c:1652  */
    break;

  case 2187:
#line 12624 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("family");
}
#line 48599 "preproc.c" /* yacc.c:1652  */
    break;

  case 2188:
#line 12628 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("filter");
}
#line 48607 "preproc.c" /* yacc.c:1652  */
    break;

  case 2189:
#line 12632 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("first");
}
#line 48615 "preproc.c" /* yacc.c:1652  */
    break;

  case 2190:
#line 12636 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("following");
}
#line 48623 "preproc.c" /* yacc.c:1652  */
    break;

  case 2191:
#line 12640 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("force");
}
#line 48631 "preproc.c" /* yacc.c:1652  */
    break;

  case 2192:
#line 12644 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("forward");
}
#line 48639 "preproc.c" /* yacc.c:1652  */
    break;

  case 2193:
#line 12648 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("function");
}
#line 48647 "preproc.c" /* yacc.c:1652  */
    break;

  case 2194:
#line 12652 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("functions");
}
#line 48655 "preproc.c" /* yacc.c:1652  */
    break;

  case 2195:
#line 12656 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("global");
}
#line 48663 "preproc.c" /* yacc.c:1652  */
    break;

  case 2196:
#line 12660 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("granted");
}
#line 48671 "preproc.c" /* yacc.c:1652  */
    break;

  case 2197:
#line 12664 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("handler");
}
#line 48679 "preproc.c" /* yacc.c:1652  */
    break;

  case 2198:
#line 12668 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("header");
}
#line 48687 "preproc.c" /* yacc.c:1652  */
    break;

  case 2199:
#line 12672 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("hold");
}
#line 48695 "preproc.c" /* yacc.c:1652  */
    break;

  case 2200:
#line 12676 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("identity");
}
#line 48703 "preproc.c" /* yacc.c:1652  */
    break;

  case 2201:
#line 12680 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("if");
}
#line 48711 "preproc.c" /* yacc.c:1652  */
    break;

  case 2202:
#line 12684 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("immediate");
}
#line 48719 "preproc.c" /* yacc.c:1652  */
    break;

  case 2203:
#line 12688 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("immutable");
}
#line 48727 "preproc.c" /* yacc.c:1652  */
    break;

  case 2204:
#line 12692 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("implicit");
}
#line 48735 "preproc.c" /* yacc.c:1652  */
    break;

  case 2205:
#line 12696 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("import");
}
#line 48743 "preproc.c" /* yacc.c:1652  */
    break;

  case 2206:
#line 12700 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("including");
}
#line 48751 "preproc.c" /* yacc.c:1652  */
    break;

  case 2207:
#line 12704 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("increment");
}
#line 48759 "preproc.c" /* yacc.c:1652  */
    break;

  case 2208:
#line 12708 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("index");
}
#line 48767 "preproc.c" /* yacc.c:1652  */
    break;

  case 2209:
#line 12712 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("indexes");
}
#line 48775 "preproc.c" /* yacc.c:1652  */
    break;

  case 2210:
#line 12716 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inherit");
}
#line 48783 "preproc.c" /* yacc.c:1652  */
    break;

  case 2211:
#line 12720 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inherits");
}
#line 48791 "preproc.c" /* yacc.c:1652  */
    break;

  case 2212:
#line 12724 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inline");
}
#line 48799 "preproc.c" /* yacc.c:1652  */
    break;

  case 2213:
#line 12728 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("insensitive");
}
#line 48807 "preproc.c" /* yacc.c:1652  */
    break;

  case 2214:
#line 12732 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("insert");
}
#line 48815 "preproc.c" /* yacc.c:1652  */
    break;

  case 2215:
#line 12736 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("instead");
}
#line 48823 "preproc.c" /* yacc.c:1652  */
    break;

  case 2216:
#line 12740 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("invoker");
}
#line 48831 "preproc.c" /* yacc.c:1652  */
    break;

  case 2217:
#line 12744 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("isolation");
}
#line 48839 "preproc.c" /* yacc.c:1652  */
    break;

  case 2218:
#line 12748 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("key");
}
#line 48847 "preproc.c" /* yacc.c:1652  */
    break;

  case 2219:
#line 12752 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("label");
}
#line 48855 "preproc.c" /* yacc.c:1652  */
    break;

  case 2220:
#line 12756 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("language");
}
#line 48863 "preproc.c" /* yacc.c:1652  */
    break;

  case 2221:
#line 12760 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("large");
}
#line 48871 "preproc.c" /* yacc.c:1652  */
    break;

  case 2222:
#line 12764 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("last");
}
#line 48879 "preproc.c" /* yacc.c:1652  */
    break;

  case 2223:
#line 12768 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("leakproof");
}
#line 48887 "preproc.c" /* yacc.c:1652  */
    break;

  case 2224:
#line 12772 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("level");
}
#line 48895 "preproc.c" /* yacc.c:1652  */
    break;

  case 2225:
#line 12776 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("listen");
}
#line 48903 "preproc.c" /* yacc.c:1652  */
    break;

  case 2226:
#line 12780 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("load");
}
#line 48911 "preproc.c" /* yacc.c:1652  */
    break;

  case 2227:
#line 12784 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("local");
}
#line 48919 "preproc.c" /* yacc.c:1652  */
    break;

  case 2228:
#line 12788 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("location");
}
#line 48927 "preproc.c" /* yacc.c:1652  */
    break;

  case 2229:
#line 12792 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("lock");
}
#line 48935 "preproc.c" /* yacc.c:1652  */
    break;

  case 2230:
#line 12796 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("locked");
}
#line 48943 "preproc.c" /* yacc.c:1652  */
    break;

  case 2231:
#line 12800 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("logged");
}
#line 48951 "preproc.c" /* yacc.c:1652  */
    break;

  case 2232:
#line 12804 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("mapping");
}
#line 48959 "preproc.c" /* yacc.c:1652  */
    break;

  case 2233:
#line 12808 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("match");
}
#line 48967 "preproc.c" /* yacc.c:1652  */
    break;

  case 2234:
#line 12812 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("materialized");
}
#line 48975 "preproc.c" /* yacc.c:1652  */
    break;

  case 2235:
#line 12816 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("maxvalue");
}
#line 48983 "preproc.c" /* yacc.c:1652  */
    break;

  case 2236:
#line 12820 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("method");
}
#line 48991 "preproc.c" /* yacc.c:1652  */
    break;

  case 2237:
#line 12824 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("minvalue");
}
#line 48999 "preproc.c" /* yacc.c:1652  */
    break;

  case 2238:
#line 12828 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("mode");
}
#line 49007 "preproc.c" /* yacc.c:1652  */
    break;

  case 2239:
#line 12832 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("move");
}
#line 49015 "preproc.c" /* yacc.c:1652  */
    break;

  case 2240:
#line 12836 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("name");
}
#line 49023 "preproc.c" /* yacc.c:1652  */
    break;

  case 2241:
#line 12840 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("names");
}
#line 49031 "preproc.c" /* yacc.c:1652  */
    break;

  case 2242:
#line 12844 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("next");
}
#line 49039 "preproc.c" /* yacc.c:1652  */
    break;

  case 2243:
#line 12848 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no");
}
#line 49047 "preproc.c" /* yacc.c:1652  */
    break;

  case 2244:
#line 12852 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nothing");
}
#line 49055 "preproc.c" /* yacc.c:1652  */
    break;

  case 2245:
#line 12856 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("notify");
}
#line 49063 "preproc.c" /* yacc.c:1652  */
    break;

  case 2246:
#line 12860 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nowait");
}
#line 49071 "preproc.c" /* yacc.c:1652  */
    break;

  case 2247:
#line 12864 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nulls");
}
#line 49079 "preproc.c" /* yacc.c:1652  */
    break;

  case 2248:
#line 12868 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("object");
}
#line 49087 "preproc.c" /* yacc.c:1652  */
    break;

  case 2249:
#line 12872 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("of");
}
#line 49095 "preproc.c" /* yacc.c:1652  */
    break;

  case 2250:
#line 12876 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("off");
}
#line 49103 "preproc.c" /* yacc.c:1652  */
    break;

  case 2251:
#line 12880 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("oids");
}
#line 49111 "preproc.c" /* yacc.c:1652  */
    break;

  case 2252:
#line 12884 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("operator");
}
#line 49119 "preproc.c" /* yacc.c:1652  */
    break;

  case 2253:
#line 12888 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("option");
}
#line 49127 "preproc.c" /* yacc.c:1652  */
    break;

  case 2254:
#line 12892 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("options");
}
#line 49135 "preproc.c" /* yacc.c:1652  */
    break;

  case 2255:
#line 12896 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("ordinality");
}
#line 49143 "preproc.c" /* yacc.c:1652  */
    break;

  case 2256:
#line 12900 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("over");
}
#line 49151 "preproc.c" /* yacc.c:1652  */
    break;

  case 2257:
#line 12904 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("owned");
}
#line 49159 "preproc.c" /* yacc.c:1652  */
    break;

  case 2258:
#line 12908 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("owner");
}
#line 49167 "preproc.c" /* yacc.c:1652  */
    break;

  case 2259:
#line 12912 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("parallel");
}
#line 49175 "preproc.c" /* yacc.c:1652  */
    break;

  case 2260:
#line 12916 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("parser");
}
#line 49183 "preproc.c" /* yacc.c:1652  */
    break;

  case 2261:
#line 12920 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("partial");
}
#line 49191 "preproc.c" /* yacc.c:1652  */
    break;

  case 2262:
#line 12924 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("partition");
}
#line 49199 "preproc.c" /* yacc.c:1652  */
    break;

  case 2263:
#line 12928 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("passing");
}
#line 49207 "preproc.c" /* yacc.c:1652  */
    break;

  case 2264:
#line 12932 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("password");
}
#line 49215 "preproc.c" /* yacc.c:1652  */
    break;

  case 2265:
#line 12936 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("plans");
}
#line 49223 "preproc.c" /* yacc.c:1652  */
    break;

  case 2266:
#line 12940 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("policy");
}
#line 49231 "preproc.c" /* yacc.c:1652  */
    break;

  case 2267:
#line 12944 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("preceding");
}
#line 49239 "preproc.c" /* yacc.c:1652  */
    break;

  case 2268:
#line 12948 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("prepare");
}
#line 49247 "preproc.c" /* yacc.c:1652  */
    break;

  case 2269:
#line 12952 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("prepared");
}
#line 49255 "preproc.c" /* yacc.c:1652  */
    break;

  case 2270:
#line 12956 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("preserve");
}
#line 49263 "preproc.c" /* yacc.c:1652  */
    break;

  case 2271:
#line 12960 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("prior");
}
#line 49271 "preproc.c" /* yacc.c:1652  */
    break;

  case 2272:
#line 12964 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("privileges");
}
#line 49279 "preproc.c" /* yacc.c:1652  */
    break;

  case 2273:
#line 12968 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("procedural");
}
#line 49287 "preproc.c" /* yacc.c:1652  */
    break;

  case 2274:
#line 12972 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("procedure");
}
#line 49295 "preproc.c" /* yacc.c:1652  */
    break;

  case 2275:
#line 12976 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("program");
}
#line 49303 "preproc.c" /* yacc.c:1652  */
    break;

  case 2276:
#line 12980 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("quote");
}
#line 49311 "preproc.c" /* yacc.c:1652  */
    break;

  case 2277:
#line 12984 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("range");
}
#line 49319 "preproc.c" /* yacc.c:1652  */
    break;

  case 2278:
#line 12988 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("read");
}
#line 49327 "preproc.c" /* yacc.c:1652  */
    break;

  case 2279:
#line 12992 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("reassign");
}
#line 49335 "preproc.c" /* yacc.c:1652  */
    break;

  case 2280:
#line 12996 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("recheck");
}
#line 49343 "preproc.c" /* yacc.c:1652  */
    break;

  case 2281:
#line 13000 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("recursive");
}
#line 49351 "preproc.c" /* yacc.c:1652  */
    break;

  case 2282:
#line 13004 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("ref");
}
#line 49359 "preproc.c" /* yacc.c:1652  */
    break;

  case 2283:
#line 13008 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("refresh");
}
#line 49367 "preproc.c" /* yacc.c:1652  */
    break;

  case 2284:
#line 13012 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("reindex");
}
#line 49375 "preproc.c" /* yacc.c:1652  */
    break;

  case 2285:
#line 13016 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("relative");
}
#line 49383 "preproc.c" /* yacc.c:1652  */
    break;

  case 2286:
#line 13020 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("release");
}
#line 49391 "preproc.c" /* yacc.c:1652  */
    break;

  case 2287:
#line 13024 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rename");
}
#line 49399 "preproc.c" /* yacc.c:1652  */
    break;

  case 2288:
#line 13028 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("repeatable");
}
#line 49407 "preproc.c" /* yacc.c:1652  */
    break;

  case 2289:
#line 13032 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("replace");
}
#line 49415 "preproc.c" /* yacc.c:1652  */
    break;

  case 2290:
#line 13036 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("replica");
}
#line 49423 "preproc.c" /* yacc.c:1652  */
    break;

  case 2291:
#line 13040 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("reset");
}
#line 49431 "preproc.c" /* yacc.c:1652  */
    break;

  case 2292:
#line 13044 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restart");
}
#line 49439 "preproc.c" /* yacc.c:1652  */
    break;

  case 2293:
#line 13048 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restrict");
}
#line 49447 "preproc.c" /* yacc.c:1652  */
    break;

  case 2294:
#line 13052 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("returns");
}
#line 49455 "preproc.c" /* yacc.c:1652  */
    break;

  case 2295:
#line 13056 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("revoke");
}
#line 49463 "preproc.c" /* yacc.c:1652  */
    break;

  case 2296:
#line 13060 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("role");
}
#line 49471 "preproc.c" /* yacc.c:1652  */
    break;

  case 2297:
#line 13064 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rollback");
}
#line 49479 "preproc.c" /* yacc.c:1652  */
    break;

  case 2298:
#line 13068 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rollup");
}
#line 49487 "preproc.c" /* yacc.c:1652  */
    break;

  case 2299:
#line 13072 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rows");
}
#line 49495 "preproc.c" /* yacc.c:1652  */
    break;

  case 2300:
#line 13076 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rule");
}
#line 49503 "preproc.c" /* yacc.c:1652  */
    break;

  case 2301:
#line 13080 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("savepoint");
}
#line 49511 "preproc.c" /* yacc.c:1652  */
    break;

  case 2302:
#line 13084 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schema");
}
#line 49519 "preproc.c" /* yacc.c:1652  */
    break;

  case 2303:
#line 13088 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("scroll");
}
#line 49527 "preproc.c" /* yacc.c:1652  */
    break;

  case 2304:
#line 13092 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("search");
}
#line 49535 "preproc.c" /* yacc.c:1652  */
    break;

  case 2305:
#line 13096 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("security");
}
#line 49543 "preproc.c" /* yacc.c:1652  */
    break;

  case 2306:
#line 13100 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequence");
}
#line 49551 "preproc.c" /* yacc.c:1652  */
    break;

  case 2307:
#line 13104 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequences");
}
#line 49559 "preproc.c" /* yacc.c:1652  */
    break;

  case 2308:
#line 13108 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("serializable");
}
#line 49567 "preproc.c" /* yacc.c:1652  */
    break;

  case 2309:
#line 13112 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("server");
}
#line 49575 "preproc.c" /* yacc.c:1652  */
    break;

  case 2310:
#line 13116 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session");
}
#line 49583 "preproc.c" /* yacc.c:1652  */
    break;

  case 2311:
#line 13120 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set");
}
#line 49591 "preproc.c" /* yacc.c:1652  */
    break;

  case 2312:
#line 13124 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sets");
}
#line 49599 "preproc.c" /* yacc.c:1652  */
    break;

  case 2313:
#line 13128 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("share");
}
#line 49607 "preproc.c" /* yacc.c:1652  */
    break;

  case 2314:
#line 13132 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("show");
}
#line 49615 "preproc.c" /* yacc.c:1652  */
    break;

  case 2315:
#line 13136 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("simple");
}
#line 49623 "preproc.c" /* yacc.c:1652  */
    break;

  case 2316:
#line 13140 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("skip");
}
#line 49631 "preproc.c" /* yacc.c:1652  */
    break;

  case 2317:
#line 13144 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("snapshot");
}
#line 49639 "preproc.c" /* yacc.c:1652  */
    break;

  case 2318:
#line 13148 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sql");
}
#line 49647 "preproc.c" /* yacc.c:1652  */
    break;

  case 2319:
#line 13152 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stable");
}
#line 49655 "preproc.c" /* yacc.c:1652  */
    break;

  case 2320:
#line 13156 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("standalone");
}
#line 49663 "preproc.c" /* yacc.c:1652  */
    break;

  case 2321:
#line 13160 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("start");
}
#line 49671 "preproc.c" /* yacc.c:1652  */
    break;

  case 2322:
#line 13164 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("statement");
}
#line 49679 "preproc.c" /* yacc.c:1652  */
    break;

  case 2323:
#line 13168 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("statistics");
}
#line 49687 "preproc.c" /* yacc.c:1652  */
    break;

  case 2324:
#line 13172 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stdin");
}
#line 49695 "preproc.c" /* yacc.c:1652  */
    break;

  case 2325:
#line 13176 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stdout");
}
#line 49703 "preproc.c" /* yacc.c:1652  */
    break;

  case 2326:
#line 13180 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("storage");
}
#line 49711 "preproc.c" /* yacc.c:1652  */
    break;

  case 2327:
#line 13184 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("strict");
}
#line 49719 "preproc.c" /* yacc.c:1652  */
    break;

  case 2328:
#line 13188 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("strip");
}
#line 49727 "preproc.c" /* yacc.c:1652  */
    break;

  case 2329:
#line 13192 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sysid");
}
#line 49735 "preproc.c" /* yacc.c:1652  */
    break;

  case 2330:
#line 13196 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("system");
}
#line 49743 "preproc.c" /* yacc.c:1652  */
    break;

  case 2331:
#line 13200 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tables");
}
#line 49751 "preproc.c" /* yacc.c:1652  */
    break;

  case 2332:
#line 13204 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 49759 "preproc.c" /* yacc.c:1652  */
    break;

  case 2333:
#line 13208 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("temp");
}
#line 49767 "preproc.c" /* yacc.c:1652  */
    break;

  case 2334:
#line 13212 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("template");
}
#line 49775 "preproc.c" /* yacc.c:1652  */
    break;

  case 2335:
#line 13216 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("temporary");
}
#line 49783 "preproc.c" /* yacc.c:1652  */
    break;

  case 2336:
#line 13220 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text");
}
#line 49791 "preproc.c" /* yacc.c:1652  */
    break;

  case 2337:
#line 13224 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("transaction");
}
#line 49799 "preproc.c" /* yacc.c:1652  */
    break;

  case 2338:
#line 13228 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("transform");
}
#line 49807 "preproc.c" /* yacc.c:1652  */
    break;

  case 2339:
#line 13232 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trigger");
}
#line 49815 "preproc.c" /* yacc.c:1652  */
    break;

  case 2340:
#line 13236 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("truncate");
}
#line 49823 "preproc.c" /* yacc.c:1652  */
    break;

  case 2341:
#line 13240 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trusted");
}
#line 49831 "preproc.c" /* yacc.c:1652  */
    break;

  case 2342:
#line 13244 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("type");
}
#line 49839 "preproc.c" /* yacc.c:1652  */
    break;

  case 2343:
#line 13248 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("types");
}
#line 49847 "preproc.c" /* yacc.c:1652  */
    break;

  case 2344:
#line 13252 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unbounded");
}
#line 49855 "preproc.c" /* yacc.c:1652  */
    break;

  case 2345:
#line 13256 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("uncommitted");
}
#line 49863 "preproc.c" /* yacc.c:1652  */
    break;

  case 2346:
#line 13260 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unencrypted");
}
#line 49871 "preproc.c" /* yacc.c:1652  */
    break;

  case 2347:
#line 13264 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unknown");
}
#line 49879 "preproc.c" /* yacc.c:1652  */
    break;

  case 2348:
#line 13268 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unlisten");
}
#line 49887 "preproc.c" /* yacc.c:1652  */
    break;

  case 2349:
#line 13272 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 49895 "preproc.c" /* yacc.c:1652  */
    break;

  case 2350:
#line 13276 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("until");
}
#line 49903 "preproc.c" /* yacc.c:1652  */
    break;

  case 2351:
#line 13280 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("update");
}
#line 49911 "preproc.c" /* yacc.c:1652  */
    break;

  case 2352:
#line 13284 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("vacuum");
}
#line 49919 "preproc.c" /* yacc.c:1652  */
    break;

  case 2353:
#line 13288 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("valid");
}
#line 49927 "preproc.c" /* yacc.c:1652  */
    break;

  case 2354:
#line 13292 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("validate");
}
#line 49935 "preproc.c" /* yacc.c:1652  */
    break;

  case 2355:
#line 13296 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("validator");
}
#line 49943 "preproc.c" /* yacc.c:1652  */
    break;

  case 2356:
#line 13300 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("value");
}
#line 49951 "preproc.c" /* yacc.c:1652  */
    break;

  case 2357:
#line 13304 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("varying");
}
#line 49959 "preproc.c" /* yacc.c:1652  */
    break;

  case 2358:
#line 13308 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("version");
}
#line 49967 "preproc.c" /* yacc.c:1652  */
    break;

  case 2359:
#line 13312 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("view");
}
#line 49975 "preproc.c" /* yacc.c:1652  */
    break;

  case 2360:
#line 13316 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("views");
}
#line 49983 "preproc.c" /* yacc.c:1652  */
    break;

  case 2361:
#line 13320 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("volatile");
}
#line 49991 "preproc.c" /* yacc.c:1652  */
    break;

  case 2362:
#line 13324 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("whitespace");
}
#line 49999 "preproc.c" /* yacc.c:1652  */
    break;

  case 2363:
#line 13328 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("within");
}
#line 50007 "preproc.c" /* yacc.c:1652  */
    break;

  case 2364:
#line 13332 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("without");
}
#line 50015 "preproc.c" /* yacc.c:1652  */
    break;

  case 2365:
#line 13336 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("work");
}
#line 50023 "preproc.c" /* yacc.c:1652  */
    break;

  case 2366:
#line 13340 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("wrapper");
}
#line 50031 "preproc.c" /* yacc.c:1652  */
    break;

  case 2367:
#line 13344 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("write");
}
#line 50039 "preproc.c" /* yacc.c:1652  */
    break;

  case 2368:
#line 13348 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xml");
}
#line 50047 "preproc.c" /* yacc.c:1652  */
    break;

  case 2369:
#line 13352 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("yes");
}
#line 50055 "preproc.c" /* yacc.c:1652  */
    break;

  case 2370:
#line 13356 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("zone");
}
#line 50063 "preproc.c" /* yacc.c:1652  */
    break;

  case 2371:
#line 13364 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("between");
}
#line 50071 "preproc.c" /* yacc.c:1652  */
    break;

  case 2372:
#line 13368 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("bigint");
}
#line 50079 "preproc.c" /* yacc.c:1652  */
    break;

  case 2373:
#line 13372 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("bit");
}
#line 50087 "preproc.c" /* yacc.c:1652  */
    break;

  case 2374:
#line 13376 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("boolean");
}
#line 50095 "preproc.c" /* yacc.c:1652  */
    break;

  case 2375:
#line 13380 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("character");
}
#line 50103 "preproc.c" /* yacc.c:1652  */
    break;

  case 2376:
#line 13384 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("coalesce");
}
#line 50111 "preproc.c" /* yacc.c:1652  */
    break;

  case 2377:
#line 13388 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("dec");
}
#line 50119 "preproc.c" /* yacc.c:1652  */
    break;

  case 2378:
#line 13392 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("decimal");
}
#line 50127 "preproc.c" /* yacc.c:1652  */
    break;

  case 2379:
#line 13396 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exists");
}
#line 50135 "preproc.c" /* yacc.c:1652  */
    break;

  case 2380:
#line 13400 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("extract");
}
#line 50143 "preproc.c" /* yacc.c:1652  */
    break;

  case 2381:
#line 13404 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("float");
}
#line 50151 "preproc.c" /* yacc.c:1652  */
    break;

  case 2382:
#line 13408 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("greatest");
}
#line 50159 "preproc.c" /* yacc.c:1652  */
    break;

  case 2383:
#line 13412 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("grouping");
}
#line 50167 "preproc.c" /* yacc.c:1652  */
    break;

  case 2384:
#line 13416 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inout");
}
#line 50175 "preproc.c" /* yacc.c:1652  */
    break;

  case 2385:
#line 13420 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("integer");
}
#line 50183 "preproc.c" /* yacc.c:1652  */
    break;

  case 2386:
#line 13424 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("interval");
}
#line 50191 "preproc.c" /* yacc.c:1652  */
    break;

  case 2387:
#line 13428 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("least");
}
#line 50199 "preproc.c" /* yacc.c:1652  */
    break;

  case 2388:
#line 13432 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("national");
}
#line 50207 "preproc.c" /* yacc.c:1652  */
    break;

  case 2389:
#line 13436 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nchar");
}
#line 50215 "preproc.c" /* yacc.c:1652  */
    break;

  case 2390:
#line 13440 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("none");
}
#line 50223 "preproc.c" /* yacc.c:1652  */
    break;

  case 2391:
#line 13444 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nullif");
}
#line 50231 "preproc.c" /* yacc.c:1652  */
    break;

  case 2392:
#line 13448 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("numeric");
}
#line 50239 "preproc.c" /* yacc.c:1652  */
    break;

  case 2393:
#line 13452 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("out");
}
#line 50247 "preproc.c" /* yacc.c:1652  */
    break;

  case 2394:
#line 13456 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("overlay");
}
#line 50255 "preproc.c" /* yacc.c:1652  */
    break;

  case 2395:
#line 13460 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("position");
}
#line 50263 "preproc.c" /* yacc.c:1652  */
    break;

  case 2396:
#line 13464 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("precision");
}
#line 50271 "preproc.c" /* yacc.c:1652  */
    break;

  case 2397:
#line 13468 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("real");
}
#line 50279 "preproc.c" /* yacc.c:1652  */
    break;

  case 2398:
#line 13472 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row");
}
#line 50287 "preproc.c" /* yacc.c:1652  */
    break;

  case 2399:
#line 13476 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("setof");
}
#line 50295 "preproc.c" /* yacc.c:1652  */
    break;

  case 2400:
#line 13480 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("smallint");
}
#line 50303 "preproc.c" /* yacc.c:1652  */
    break;

  case 2401:
#line 13484 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("substring");
}
#line 50311 "preproc.c" /* yacc.c:1652  */
    break;

  case 2402:
#line 13488 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("time");
}
#line 50319 "preproc.c" /* yacc.c:1652  */
    break;

  case 2403:
#line 13492 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("timestamp");
}
#line 50327 "preproc.c" /* yacc.c:1652  */
    break;

  case 2404:
#line 13496 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("treat");
}
#line 50335 "preproc.c" /* yacc.c:1652  */
    break;

  case 2405:
#line 13500 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trim");
}
#line 50343 "preproc.c" /* yacc.c:1652  */
    break;

  case 2406:
#line 13504 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("varchar");
}
#line 50351 "preproc.c" /* yacc.c:1652  */
    break;

  case 2407:
#line 13508 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlattributes");
}
#line 50359 "preproc.c" /* yacc.c:1652  */
    break;

  case 2408:
#line 13512 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlconcat");
}
#line 50367 "preproc.c" /* yacc.c:1652  */
    break;

  case 2409:
#line 13516 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlelement");
}
#line 50375 "preproc.c" /* yacc.c:1652  */
    break;

  case 2410:
#line 13520 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlexists");
}
#line 50383 "preproc.c" /* yacc.c:1652  */
    break;

  case 2411:
#line 13524 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlforest");
}
#line 50391 "preproc.c" /* yacc.c:1652  */
    break;

  case 2412:
#line 13528 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlparse");
}
#line 50399 "preproc.c" /* yacc.c:1652  */
    break;

  case 2413:
#line 13532 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlpi");
}
#line 50407 "preproc.c" /* yacc.c:1652  */
    break;

  case 2414:
#line 13536 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlroot");
}
#line 50415 "preproc.c" /* yacc.c:1652  */
    break;

  case 2415:
#line 13540 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlserialize");
}
#line 50423 "preproc.c" /* yacc.c:1652  */
    break;

  case 2416:
#line 13548 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("authorization");
}
#line 50431 "preproc.c" /* yacc.c:1652  */
    break;

  case 2417:
#line 13552 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("binary");
}
#line 50439 "preproc.c" /* yacc.c:1652  */
    break;

  case 2418:
#line 13556 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("collation");
}
#line 50447 "preproc.c" /* yacc.c:1652  */
    break;

  case 2419:
#line 13560 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("concurrently");
}
#line 50455 "preproc.c" /* yacc.c:1652  */
    break;

  case 2420:
#line 13564 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cross");
}
#line 50463 "preproc.c" /* yacc.c:1652  */
    break;

  case 2421:
#line 13568 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_schema");
}
#line 50471 "preproc.c" /* yacc.c:1652  */
    break;

  case 2422:
#line 13572 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("freeze");
}
#line 50479 "preproc.c" /* yacc.c:1652  */
    break;

  case 2423:
#line 13576 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("full");
}
#line 50487 "preproc.c" /* yacc.c:1652  */
    break;

  case 2424:
#line 13580 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("ilike");
}
#line 50495 "preproc.c" /* yacc.c:1652  */
    break;

  case 2425:
#line 13584 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inner");
}
#line 50503 "preproc.c" /* yacc.c:1652  */
    break;

  case 2426:
#line 13588 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("is");
}
#line 50511 "preproc.c" /* yacc.c:1652  */
    break;

  case 2427:
#line 13592 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("isnull");
}
#line 50519 "preproc.c" /* yacc.c:1652  */
    break;

  case 2428:
#line 13596 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("join");
}
#line 50527 "preproc.c" /* yacc.c:1652  */
    break;

  case 2429:
#line 13600 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("left");
}
#line 50535 "preproc.c" /* yacc.c:1652  */
    break;

  case 2430:
#line 13604 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("like");
}
#line 50543 "preproc.c" /* yacc.c:1652  */
    break;

  case 2431:
#line 13608 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("natural");
}
#line 50551 "preproc.c" /* yacc.c:1652  */
    break;

  case 2432:
#line 13612 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("notnull");
}
#line 50559 "preproc.c" /* yacc.c:1652  */
    break;

  case 2433:
#line 13616 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("outer");
}
#line 50567 "preproc.c" /* yacc.c:1652  */
    break;

  case 2434:
#line 13620 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("overlaps");
}
#line 50575 "preproc.c" /* yacc.c:1652  */
    break;

  case 2435:
#line 13624 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("right");
}
#line 50583 "preproc.c" /* yacc.c:1652  */
    break;

  case 2436:
#line 13628 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("similar");
}
#line 50591 "preproc.c" /* yacc.c:1652  */
    break;

  case 2437:
#line 13632 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tablesample");
}
#line 50599 "preproc.c" /* yacc.c:1652  */
    break;

  case 2438:
#line 13636 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("verbose");
}
#line 50607 "preproc.c" /* yacc.c:1652  */
    break;

  case 2439:
#line 13644 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 50615 "preproc.c" /* yacc.c:1652  */
    break;

  case 2440:
#line 13648 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("analyse");
}
#line 50623 "preproc.c" /* yacc.c:1652  */
    break;

  case 2441:
#line 13652 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("analyze");
}
#line 50631 "preproc.c" /* yacc.c:1652  */
    break;

  case 2442:
#line 13656 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("and");
}
#line 50639 "preproc.c" /* yacc.c:1652  */
    break;

  case 2443:
#line 13660 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("any");
}
#line 50647 "preproc.c" /* yacc.c:1652  */
    break;

  case 2444:
#line 13664 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("array");
}
#line 50655 "preproc.c" /* yacc.c:1652  */
    break;

  case 2445:
#line 13668 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("as");
}
#line 50663 "preproc.c" /* yacc.c:1652  */
    break;

  case 2446:
#line 13672 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("asc");
}
#line 50671 "preproc.c" /* yacc.c:1652  */
    break;

  case 2447:
#line 13676 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("asymmetric");
}
#line 50679 "preproc.c" /* yacc.c:1652  */
    break;

  case 2448:
#line 13680 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("both");
}
#line 50687 "preproc.c" /* yacc.c:1652  */
    break;

  case 2449:
#line 13684 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("case");
}
#line 50695 "preproc.c" /* yacc.c:1652  */
    break;

  case 2450:
#line 13688 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cast");
}
#line 50703 "preproc.c" /* yacc.c:1652  */
    break;

  case 2451:
#line 13692 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("check");
}
#line 50711 "preproc.c" /* yacc.c:1652  */
    break;

  case 2452:
#line 13696 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("collate");
}
#line 50719 "preproc.c" /* yacc.c:1652  */
    break;

  case 2453:
#line 13700 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("column");
}
#line 50727 "preproc.c" /* yacc.c:1652  */
    break;

  case 2454:
#line 13704 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("constraint");
}
#line 50735 "preproc.c" /* yacc.c:1652  */
    break;

  case 2455:
#line 13708 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("create");
}
#line 50743 "preproc.c" /* yacc.c:1652  */
    break;

  case 2456:
#line 13712 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_catalog");
}
#line 50751 "preproc.c" /* yacc.c:1652  */
    break;

  case 2457:
#line 13716 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_date");
}
#line 50759 "preproc.c" /* yacc.c:1652  */
    break;

  case 2458:
#line 13720 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_role");
}
#line 50767 "preproc.c" /* yacc.c:1652  */
    break;

  case 2459:
#line 13724 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_time");
}
#line 50775 "preproc.c" /* yacc.c:1652  */
    break;

  case 2460:
#line 13728 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_timestamp");
}
#line 50783 "preproc.c" /* yacc.c:1652  */
    break;

  case 2461:
#line 13732 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_user");
}
#line 50791 "preproc.c" /* yacc.c:1652  */
    break;

  case 2462:
#line 13736 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 50799 "preproc.c" /* yacc.c:1652  */
    break;

  case 2463:
#line 13740 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 50807 "preproc.c" /* yacc.c:1652  */
    break;

  case 2464:
#line 13744 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("desc");
}
#line 50815 "preproc.c" /* yacc.c:1652  */
    break;

  case 2465:
#line 13748 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("distinct");
}
#line 50823 "preproc.c" /* yacc.c:1652  */
    break;

  case 2466:
#line 13752 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("do");
}
#line 50831 "preproc.c" /* yacc.c:1652  */
    break;

  case 2467:
#line 13756 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("else");
}
#line 50839 "preproc.c" /* yacc.c:1652  */
    break;

  case 2468:
#line 13760 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("end");
}
#line 50847 "preproc.c" /* yacc.c:1652  */
    break;

  case 2469:
#line 13764 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("except");
}
#line 50855 "preproc.c" /* yacc.c:1652  */
    break;

  case 2470:
#line 13768 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("false");
}
#line 50863 "preproc.c" /* yacc.c:1652  */
    break;

  case 2471:
#line 13772 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("fetch");
}
#line 50871 "preproc.c" /* yacc.c:1652  */
    break;

  case 2472:
#line 13776 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for");
}
#line 50879 "preproc.c" /* yacc.c:1652  */
    break;

  case 2473:
#line 13780 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign");
}
#line 50887 "preproc.c" /* yacc.c:1652  */
    break;

  case 2474:
#line 13784 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("from");
}
#line 50895 "preproc.c" /* yacc.c:1652  */
    break;

  case 2475:
#line 13788 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("grant");
}
#line 50903 "preproc.c" /* yacc.c:1652  */
    break;

  case 2476:
#line 13792 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("group");
}
#line 50911 "preproc.c" /* yacc.c:1652  */
    break;

  case 2477:
#line 13796 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("having");
}
#line 50919 "preproc.c" /* yacc.c:1652  */
    break;

  case 2478:
#line 13800 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("in");
}
#line 50927 "preproc.c" /* yacc.c:1652  */
    break;

  case 2479:
#line 13804 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("initially");
}
#line 50935 "preproc.c" /* yacc.c:1652  */
    break;

  case 2480:
#line 13808 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("intersect");
}
#line 50943 "preproc.c" /* yacc.c:1652  */
    break;

  case 2481:
#line 13812 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("into");
}
#line 50951 "preproc.c" /* yacc.c:1652  */
    break;

  case 2482:
#line 13816 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("lateral");
}
#line 50959 "preproc.c" /* yacc.c:1652  */
    break;

  case 2483:
#line 13820 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("leading");
}
#line 50967 "preproc.c" /* yacc.c:1652  */
    break;

  case 2484:
#line 13824 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("limit");
}
#line 50975 "preproc.c" /* yacc.c:1652  */
    break;

  case 2485:
#line 13828 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("localtime");
}
#line 50983 "preproc.c" /* yacc.c:1652  */
    break;

  case 2486:
#line 13832 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("localtimestamp");
}
#line 50991 "preproc.c" /* yacc.c:1652  */
    break;

  case 2487:
#line 13836 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not");
}
#line 50999 "preproc.c" /* yacc.c:1652  */
    break;

  case 2488:
#line 13840 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 51007 "preproc.c" /* yacc.c:1652  */
    break;

  case 2489:
#line 13844 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("offset");
}
#line 51015 "preproc.c" /* yacc.c:1652  */
    break;

  case 2490:
#line 13848 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("on");
}
#line 51023 "preproc.c" /* yacc.c:1652  */
    break;

  case 2491:
#line 13852 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("only");
}
#line 51031 "preproc.c" /* yacc.c:1652  */
    break;

  case 2492:
#line 13856 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("or");
}
#line 51039 "preproc.c" /* yacc.c:1652  */
    break;

  case 2493:
#line 13860 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("order");
}
#line 51047 "preproc.c" /* yacc.c:1652  */
    break;

  case 2494:
#line 13864 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("placing");
}
#line 51055 "preproc.c" /* yacc.c:1652  */
    break;

  case 2495:
#line 13868 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("primary");
}
#line 51063 "preproc.c" /* yacc.c:1652  */
    break;

  case 2496:
#line 13872 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("references");
}
#line 51071 "preproc.c" /* yacc.c:1652  */
    break;

  case 2497:
#line 13876 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("returning");
}
#line 51079 "preproc.c" /* yacc.c:1652  */
    break;

  case 2498:
#line 13880 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("select");
}
#line 51087 "preproc.c" /* yacc.c:1652  */
    break;

  case 2499:
#line 13884 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session_user");
}
#line 51095 "preproc.c" /* yacc.c:1652  */
    break;

  case 2500:
#line 13888 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("some");
}
#line 51103 "preproc.c" /* yacc.c:1652  */
    break;

  case 2501:
#line 13892 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("symmetric");
}
#line 51111 "preproc.c" /* yacc.c:1652  */
    break;

  case 2502:
#line 13896 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 51119 "preproc.c" /* yacc.c:1652  */
    break;

  case 2503:
#line 13900 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("then");
}
#line 51127 "preproc.c" /* yacc.c:1652  */
    break;

  case 2504:
#line 13904 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trailing");
}
#line 51135 "preproc.c" /* yacc.c:1652  */
    break;

  case 2505:
#line 13908 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("true");
}
#line 51143 "preproc.c" /* yacc.c:1652  */
    break;

  case 2506:
#line 13912 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unique");
}
#line 51151 "preproc.c" /* yacc.c:1652  */
    break;

  case 2507:
#line 13916 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("user");
}
#line 51159 "preproc.c" /* yacc.c:1652  */
    break;

  case 2508:
#line 13920 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("using");
}
#line 51167 "preproc.c" /* yacc.c:1652  */
    break;

  case 2509:
#line 13924 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("variadic");
}
#line 51175 "preproc.c" /* yacc.c:1652  */
    break;

  case 2510:
#line 13928 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("when");
}
#line 51183 "preproc.c" /* yacc.c:1652  */
    break;

  case 2511:
#line 13932 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("where");
}
#line 51191 "preproc.c" /* yacc.c:1652  */
    break;

  case 2512:
#line 13936 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("window");
}
#line 51199 "preproc.c" /* yacc.c:1652  */
    break;

  case 2513:
#line 13940 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with");
}
#line 51207 "preproc.c" /* yacc.c:1652  */
    break;

  case 2516:
#line 13953 "preproc.y" /* yacc.c:1652  */
    { connection = NULL; }
#line 51213 "preproc.c" /* yacc.c:1652  */
    break;

  case 2518:
#line 13956 "preproc.y" /* yacc.c:1652  */
    {
					fprintf(base_yyout, "%s", (yyvsp[0].str));
					free((yyvsp[0].str));
					output_line_number();
				}
#line 51223 "preproc.c" /* yacc.c:1652  */
    break;

  case 2520:
#line 13962 "preproc.y" /* yacc.c:1652  */
    { fprintf(base_yyout, "%s", (yyvsp[0].str)); free((yyvsp[0].str)); }
#line 51229 "preproc.c" /* yacc.c:1652  */
    break;

  case 2521:
#line 13963 "preproc.y" /* yacc.c:1652  */
    { fprintf(base_yyout, "%s", (yyvsp[0].str)); free((yyvsp[0].str)); }
#line 51235 "preproc.c" /* yacc.c:1652  */
    break;

  case 2522:
#line 13964 "preproc.y" /* yacc.c:1652  */
    { braces_open++; fputs("{", base_yyout); }
#line 51241 "preproc.c" /* yacc.c:1652  */
    break;

  case 2523:
#line 13966 "preproc.y" /* yacc.c:1652  */
    {
			remove_typedefs(braces_open);
			remove_variables(braces_open--);
			if (braces_open == 0)
			{
				free(current_function);
				current_function = NULL;
			}
			fputs("}", base_yyout);
		}
#line 51256 "preproc.c" /* yacc.c:1652  */
    break;

  case 2524:
#line 13978 "preproc.y" /* yacc.c:1652  */
    {FoundInto = 0;}
#line 51262 "preproc.c" /* yacc.c:1652  */
    break;

  case 2525:
#line 13979 "preproc.y" /* yacc.c:1652  */
    {
			if (FoundInto == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "CREATE TABLE AS cannot specify INTO");

			(yyval.str) = cat_str(7, mm_strdup("create"), (yyvsp[-6].str), mm_strdup("table"), (yyvsp[-4].str), mm_strdup("as"), (yyvsp[-1].str), (yyvsp[0].str));
		}
#line 51273 "preproc.c" /* yacc.c:1652  */
    break;

  case 2526:
#line 13985 "preproc.y" /* yacc.c:1652  */
    {FoundInto = 0;}
#line 51279 "preproc.c" /* yacc.c:1652  */
    break;

  case 2527:
#line 13986 "preproc.y" /* yacc.c:1652  */
    {
			if (FoundInto == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "CREATE TABLE AS cannot specify INTO");

			(yyval.str) = cat_str(7, mm_strdup("create"), (yyvsp[-9].str), mm_strdup("table if not exists"), (yyvsp[-4].str), mm_strdup("as"), (yyvsp[-1].str), (yyvsp[0].str));
		}
#line 51290 "preproc.c" /* yacc.c:1652  */
    break;

  case 2528:
#line 13995 "preproc.y" /* yacc.c:1652  */
    {
			connection = (yyvsp[0].str);
			/*
			 * Do we have a variable as connection target?  Remove the variable
			 * from the variable list or else it will be used twice.
			 */
			if (argsinsert != NULL)
				argsinsert = NULL;
		}
#line 51304 "preproc.c" /* yacc.c:1652  */
    break;

  case 2529:
#line 14010 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(5, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str), mm_strdup(","), (yyvsp[-1].str)); }
#line 51310 "preproc.c" /* yacc.c:1652  */
    break;

  case 2530:
#line 14012 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("NULL, NULL, NULL, \"DEFAULT\""); }
#line 51316 "preproc.c" /* yacc.c:1652  */
    break;

  case 2531:
#line 14015 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("NULL,"), (yyvsp[0].str), mm_strdup(", NULL")); }
#line 51322 "preproc.c" /* yacc.c:1652  */
    break;

  case 2532:
#line 14017 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[0].str), mm_strdup(", NULL, NULL, NULL")); }
#line 51328 "preproc.c" /* yacc.c:1652  */
    break;

  case 2533:
#line 14021 "preproc.y" /* yacc.c:1652  */
    {
			/* old style: dbname[@server][:port] */
			if (strlen((yyvsp[-1].str)) > 0 && *((yyvsp[-1].str)) != '@')
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\", found \"%s\"", (yyvsp[-1].str));

			/* C strings need to be handled differently */
			if ((yyvsp[-2].str)[0] == '\"')
				(yyval.str) = (yyvsp[-2].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), make3_str((yyvsp[-2].str), (yyvsp[-1].str), (yyvsp[0].str)), mm_strdup("\""));
		}
#line 51344 "preproc.c" /* yacc.c:1652  */
    break;

  case 2534:
#line 14033 "preproc.y" /* yacc.c:1652  */
    {
			/* new style: <tcp|unix>:postgresql://server[:port][/dbname] */
			if (strncmp((yyvsp[-6].str), "unix:postgresql", strlen("unix:postgresql")) != 0 && strncmp((yyvsp[-6].str), "tcp:postgresql", strlen("tcp:postgresql")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "only protocols \"tcp\" and \"unix\" and database type \"postgresql\" are supported");

			if (strncmp((yyvsp[-4].str), "//", strlen("//")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"://\", found \"%s\"", (yyvsp[-4].str));

			if (strncmp((yyvsp[-6].str), "unix", strlen("unix")) == 0 &&
				strncmp((yyvsp[-4].str) + strlen("//"), "localhost", strlen("localhost")) != 0 &&
				strncmp((yyvsp[-4].str) + strlen("//"), "127.0.0.1", strlen("127.0.0.1")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "Unix-domain sockets only work on \"localhost\" but not on \"%s\"", (yyvsp[-4].str) + strlen("//"));

			(yyval.str) = make3_str(make3_str(mm_strdup("\""), (yyvsp[-6].str), mm_strdup(":")), (yyvsp[-4].str), make3_str(make3_str((yyvsp[-3].str), mm_strdup("/"), (yyvsp[-1].str)), (yyvsp[0].str), mm_strdup("\"")));
		}
#line 51364 "preproc.c" /* yacc.c:1652  */
    break;

  case 2535:
#line 14049 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = (yyvsp[0].str);
		}
#line 51372 "preproc.c" /* yacc.c:1652  */
    break;

  case 2536:
#line 14053 "preproc.y" /* yacc.c:1652  */
    {
			/* We can only process double quoted strings not single quotes ones,
			 * so we change the quotes.
			 * Note, that the rule for ecpg_sconst adds these single quotes. */
			(yyvsp[0].str)[0] = '\"';
			(yyvsp[0].str)[strlen((yyvsp[0].str))-1] = '\"';
			(yyval.str) = (yyvsp[0].str);
		}
#line 51385 "preproc.c" /* yacc.c:1652  */
    break;

  case 2537:
#line 14063 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51391 "preproc.c" /* yacc.c:1652  */
    break;

  case 2538:
#line 14064 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 51397 "preproc.c" /* yacc.c:1652  */
    break;

  case 2539:
#line 14068 "preproc.y" /* yacc.c:1652  */
    {
			if (strcmp((yyvsp[0].str), "postgresql") != 0 && strcmp((yyvsp[0].str), "postgres") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"postgresql\", found \"%s\"", (yyvsp[0].str));

			if (strcmp((yyvsp[-1].str), "tcp") != 0 && strcmp((yyvsp[-1].str), "unix") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "invalid connection type: %s", (yyvsp[-1].str));

			(yyval.str) = make3_str((yyvsp[-1].str), mm_strdup(":"), (yyvsp[0].str));
		}
#line 51411 "preproc.c" /* yacc.c:1652  */
    break;

  case 2540:
#line 14080 "preproc.y" /* yacc.c:1652  */
    {
			if (strcmp((yyvsp[-1].str), "@") != 0 && strcmp((yyvsp[-1].str), "//") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\" or \"://\", found \"%s\"", (yyvsp[-1].str));

			(yyval.str) = make2_str((yyvsp[-1].str), (yyvsp[0].str));
		}
#line 51422 "preproc.c" /* yacc.c:1652  */
    break;

  case 2541:
#line 14088 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51428 "preproc.c" /* yacc.c:1652  */
    break;

  case 2542:
#line 14089 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 51434 "preproc.c" /* yacc.c:1652  */
    break;

  case 2543:
#line 14092 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51440 "preproc.c" /* yacc.c:1652  */
    break;

  case 2544:
#line 14093 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str((yyvsp[-2].str), mm_strdup("."), (yyvsp[0].str)); }
#line 51446 "preproc.c" /* yacc.c:1652  */
    break;

  case 2545:
#line 14094 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 51452 "preproc.c" /* yacc.c:1652  */
    break;

  case 2546:
#line 14097 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make2_str(mm_strdup(":"), (yyvsp[0].str)); }
#line 51458 "preproc.c" /* yacc.c:1652  */
    break;

  case 2547:
#line 14098 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 51464 "preproc.c" /* yacc.c:1652  */
    break;

  case 2548:
#line 14101 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51470 "preproc.c" /* yacc.c:1652  */
    break;

  case 2549:
#line 14102 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("NULL"); }
#line 51476 "preproc.c" /* yacc.c:1652  */
    break;

  case 2550:
#line 14105 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51482 "preproc.c" /* yacc.c:1652  */
    break;

  case 2551:
#line 14106 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("NULL, NULL"); }
#line 51488 "preproc.c" /* yacc.c:1652  */
    break;

  case 2552:
#line 14110 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[0].str), mm_strdup(", NULL")); }
#line 51494 "preproc.c" /* yacc.c:1652  */
    break;

  case 2553:
#line 14112 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 51500 "preproc.c" /* yacc.c:1652  */
    break;

  case 2554:
#line 14114 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-3].str), mm_strdup(","), (yyvsp[0].str)); }
#line 51506 "preproc.c" /* yacc.c:1652  */
    break;

  case 2555:
#line 14116 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 51512 "preproc.c" /* yacc.c:1652  */
    break;

  case 2556:
#line 14120 "preproc.y" /* yacc.c:1652  */
    {
			if ((yyvsp[0].str)[0] == '\"')
				(yyval.str) = (yyvsp[0].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
		}
#line 51523 "preproc.c" /* yacc.c:1652  */
    break;

  case 2557:
#line 14127 "preproc.y" /* yacc.c:1652  */
    {
			if ((yyvsp[0].str)[0] == '\"')
				(yyval.str) = (yyvsp[0].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
		}
#line 51534 "preproc.c" /* yacc.c:1652  */
    break;

  case 2558:
#line 14134 "preproc.y" /* yacc.c:1652  */
    {
			enum ECPGttype type = argsinsert->variable->type->type;

			/* if array see what's inside */
			if (type == ECPGt_array)
				type = argsinsert->variable->type->u.element->type;

			/* handle varchars */
			if (type == ECPGt_varchar)
				(yyval.str) = make2_str(mm_strdup(argsinsert->variable->name), mm_strdup(".arr"));
			else
				(yyval.str) = mm_strdup(argsinsert->variable->name);
		}
#line 51552 "preproc.c" /* yacc.c:1652  */
    break;

  case 2559:
#line 14150 "preproc.y" /* yacc.c:1652  */
    {
			/* check if we have a string variable */
			struct variable *p = find_variable((yyvsp[0].str));
			enum ECPGttype type = p->type->type;

			/* If we have just one character this is not a string */
			if (atol(p->type->size) == 1)
					mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
			else
			{
				/* if array see what's inside */
				if (type == ECPGt_array)
					type = p->type->u.element->type;

				switch (type)
				{
					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						(yyval.str) = (yyvsp[0].str);
						break;
					case ECPGt_varchar:
						(yyval.str) = make2_str((yyvsp[0].str), mm_strdup(".arr"));
						break;
					default:
						mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
						(yyval.str) = (yyvsp[0].str);
						break;
				}
			}
		}
#line 51588 "preproc.c" /* yacc.c:1652  */
    break;

  case 2560:
#line 14184 "preproc.y" /* yacc.c:1652  */
    {
			if (strlen((yyvsp[-1].str)) == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

			if (strcmp((yyvsp[-1].str), "?") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[-1].str));

			(yyval.str) = make2_str(mm_strdup("?"), (yyvsp[0].str));
		}
#line 51602 "preproc.c" /* yacc.c:1652  */
    break;

  case 2561:
#line 14193 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 51608 "preproc.c" /* yacc.c:1652  */
    break;

  case 2562:
#line 14197 "preproc.y" /* yacc.c:1652  */
    {
				(yyval.str) = make2_str((yyvsp[-1].str), (yyvsp[0].str));
			}
#line 51616 "preproc.c" /* yacc.c:1652  */
    break;

  case 2563:
#line 14201 "preproc.y" /* yacc.c:1652  */
    {
				if (strlen((yyvsp[-1].str)) == 0)
					mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

				if (strcmp((yyvsp[-1].str), "&") != 0)
					mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[-1].str));

				(yyval.str) = cat_str(3, make2_str((yyvsp[-3].str), (yyvsp[-2].str)), (yyvsp[-1].str), (yyvsp[0].str));
			}
#line 51630 "preproc.c" /* yacc.c:1652  */
    break;

  case 2564:
#line 14213 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 51636 "preproc.c" /* yacc.c:1652  */
    break;

  case 2565:
#line 14215 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 51642 "preproc.c" /* yacc.c:1652  */
    break;

  case 2566:
#line 14217 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 51648 "preproc.c" /* yacc.c:1652  */
    break;

  case 2567:
#line 14219 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 51654 "preproc.c" /* yacc.c:1652  */
    break;

  case 2568:
#line 14223 "preproc.y" /* yacc.c:1652  */
    {
			if ((yyvsp[0].str)[0] == '\"' && (yyvsp[0].str)[strlen((yyvsp[0].str))-1] == '\"') /* already quoted? */
				(yyval.str) = (yyvsp[0].str);
			else /* not quoted => convert to lowercase */
			{
				size_t i;

				for (i = 0; i< strlen((yyvsp[0].str)); i++)
					(yyvsp[0].str)[i] = tolower((unsigned char) (yyvsp[0].str)[i]);

				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
			}
		}
#line 51672 "preproc.c" /* yacc.c:1652  */
    break;

  case 2569:
#line 14236 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51678 "preproc.c" /* yacc.c:1652  */
    break;

  case 2570:
#line 14244 "preproc.y" /* yacc.c:1652  */
    {
			struct cursor *ptr, *this;
			char *cursor_marker = (yyvsp[-5].str)[0] == ':' ? mm_strdup("$0") : mm_strdup((yyvsp[-5].str));
			int (* strcmp_fn)(const char *, const char *) = (((yyvsp[-5].str)[0] == ':' || (yyvsp[-5].str)[0] == '"') ? strcmp : pg_strcasecmp);
			struct variable *thisquery = (struct variable *)mm_alloc(sizeof(struct variable));
			const char *con = connection ? connection : "NULL";
			char *comment;

			for (ptr = cur; ptr != NULL; ptr = ptr->next)
			{
				if (strcmp_fn((yyvsp[-5].str), ptr->name) == 0)
				{
					/* re-definition is a bug */
					if ((yyvsp[-5].str)[0] == ':')
						mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[-5].str)+1);
					else
						mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[-5].str));
				}
			}

			this = (struct cursor *) mm_alloc(sizeof(struct cursor));

			/* initial definition */
			this->next = cur;
			this->name = (yyvsp[-5].str);
			this->function = (current_function ? mm_strdup(current_function) : NULL);
			this->connection = connection;
			this->command =  cat_str(6, mm_strdup("declare"), cursor_marker, (yyvsp[-4].str), mm_strdup("cursor"), (yyvsp[-2].str), mm_strdup("for $1"));
			this->argsresult = NULL;
			this->argsresult_oos = NULL;

			thisquery->type = &ecpg_query;
			thisquery->brace_level = 0;
			thisquery->next = NULL;
			thisquery->name = (char *) mm_alloc(sizeof("ECPGprepared_statement(, , __LINE__)") + strlen(con) + strlen((yyvsp[0].str)));
			sprintf(thisquery->name, "ECPGprepared_statement(%s, %s, __LINE__)", con, (yyvsp[0].str));

			this->argsinsert = NULL;
			this->argsinsert_oos = NULL;
			if ((yyvsp[-5].str)[0] == ':')
			{
				struct variable *var = find_variable((yyvsp[-5].str) + 1);
				remove_variable_from_list(&argsinsert, var);
				add_variable_to_head(&(this->argsinsert), var, &no_indicator);
			}
			add_variable_to_head(&(this->argsinsert), thisquery, &no_indicator);

			cur = this;

			comment = cat_str(3, mm_strdup("/*"), mm_strdup(this->command), mm_strdup("*/"));

			if ((braces_open > 0) && INFORMIX_MODE) /* we're in a function */
				(yyval.str) = cat_str(3, adjust_outofscope_cursor_vars(this),
					mm_strdup("ECPG_informix_reset_sqlca();"),
					comment);
			else
				(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
		}
#line 51741 "preproc.c" /* yacc.c:1652  */
    break;

  case 2571:
#line 14305 "preproc.y" /* yacc.c:1652  */
    {
			  /* execute immediate means prepare the statement and
			   * immediately execute it */
			  (yyval.str) = (yyvsp[0].str);
			}
#line 51751 "preproc.c" /* yacc.c:1652  */
    break;

  case 2573:
#line 14315 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51757 "preproc.c" /* yacc.c:1652  */
    break;

  case 2574:
#line 14316 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51763 "preproc.c" /* yacc.c:1652  */
    break;

  case 2575:
#line 14319 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51769 "preproc.c" /* yacc.c:1652  */
    break;

  case 2576:
#line 14321 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51775 "preproc.c" /* yacc.c:1652  */
    break;

  case 2577:
#line 14322 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 51781 "preproc.c" /* yacc.c:1652  */
    break;

  case 2578:
#line 14325 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51787 "preproc.c" /* yacc.c:1652  */
    break;

  case 2579:
#line 14326 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("year to minute"); }
#line 51793 "preproc.c" /* yacc.c:1652  */
    break;

  case 2580:
#line 14327 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("year to second"); }
#line 51799 "preproc.c" /* yacc.c:1652  */
    break;

  case 2581:
#line 14328 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("day to day"); }
#line 51805 "preproc.c" /* yacc.c:1652  */
    break;

  case 2582:
#line 14329 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("month to month"); }
#line 51811 "preproc.c" /* yacc.c:1652  */
    break;

  case 2583:
#line 14336 "preproc.y" /* yacc.c:1652  */
    { fputs("/* exec sql begin declare section */", base_yyout); }
#line 51817 "preproc.c" /* yacc.c:1652  */
    break;

  case 2584:
#line 14338 "preproc.y" /* yacc.c:1652  */
    {
			fprintf(base_yyout, "%s/* exec sql end declare section */", (yyvsp[-1].str));
			free((yyvsp[-1].str));
			output_line_number();
		}
#line 51827 "preproc.c" /* yacc.c:1652  */
    break;

  case 2585:
#line 14345 "preproc.y" /* yacc.c:1652  */
    {}
#line 51833 "preproc.c" /* yacc.c:1652  */
    break;

  case 2586:
#line 14347 "preproc.y" /* yacc.c:1652  */
    {}
#line 51839 "preproc.c" /* yacc.c:1652  */
    break;

  case 2587:
#line 14349 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 51845 "preproc.c" /* yacc.c:1652  */
    break;

  case 2588:
#line 14350 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51851 "preproc.c" /* yacc.c:1652  */
    break;

  case 2589:
#line 14353 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51857 "preproc.c" /* yacc.c:1652  */
    break;

  case 2590:
#line 14354 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51863 "preproc.c" /* yacc.c:1652  */
    break;

  case 2591:
#line 14355 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 51869 "preproc.c" /* yacc.c:1652  */
    break;

  case 2592:
#line 14356 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 51875 "preproc.c" /* yacc.c:1652  */
    break;

  case 2593:
#line 14359 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51881 "preproc.c" /* yacc.c:1652  */
    break;

  case 2594:
#line 14360 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 51887 "preproc.c" /* yacc.c:1652  */
    break;

  case 2595:
#line 14364 "preproc.y" /* yacc.c:1652  */
    {
		/* reset this variable so we see if there was */
		/* an initializer specified */
		initializer = 0;
	}
#line 51897 "preproc.c" /* yacc.c:1652  */
    break;

  case 2596:
#line 14370 "preproc.y" /* yacc.c:1652  */
    {
		add_typedef((yyvsp[-2].str), (yyvsp[-1].index).index1, (yyvsp[-1].index).index2, (yyvsp[-4].type).type_enum, (yyvsp[-4].type).type_dimension, (yyvsp[-4].type).type_index, initializer, *(yyvsp[-3].str) ? 1 : 0);

		fprintf(base_yyout, "typedef %s %s %s %s;\n", (yyvsp[-4].type).type_str, *(yyvsp[-3].str) ? "*" : "", (yyvsp[-2].str), (yyvsp[-1].index).str);
		output_line_number();
		(yyval.str) = mm_strdup("");
	}
#line 51909 "preproc.c" /* yacc.c:1652  */
    break;

  case 2597:
#line 14380 "preproc.y" /* yacc.c:1652  */
    {
			actual_type[struct_level].type_enum = (yyvsp[0].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[0].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[0].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[0].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[0].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		}
#line 51923 "preproc.c" /* yacc.c:1652  */
    break;

  case 2598:
#line 14390 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = cat_str(5, actual_startline[struct_level], (yyvsp[-4].str), (yyvsp[-3].type).type_str, (yyvsp[-1].str), mm_strdup(";\n"));
		}
#line 51931 "preproc.c" /* yacc.c:1652  */
    break;

  case 2599:
#line 14394 "preproc.y" /* yacc.c:1652  */
    {
			actual_type[struct_level].type_enum = (yyvsp[0].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[0].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[0].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[0].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[0].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		}
#line 51945 "preproc.c" /* yacc.c:1652  */
    break;

  case 2600:
#line 14404 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = cat_str(4, actual_startline[struct_level], (yyvsp[-3].type).type_str, (yyvsp[-1].str), mm_strdup(";\n"));
		}
#line 51953 "preproc.c" /* yacc.c:1652  */
    break;

  case 2601:
#line 14408 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = cat2_str((yyvsp[-1].str), mm_strdup(";"));
		}
#line 51961 "preproc.c" /* yacc.c:1652  */
    break;

  case 2602:
#line 14413 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) =cat2_str(mm_strdup(":"), (yyvsp[0].str)); }
#line 51967 "preproc.c" /* yacc.c:1652  */
    break;

  case 2603:
#line 14414 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 51973 "preproc.c" /* yacc.c:1652  */
    break;

  case 2604:
#line 14418 "preproc.y" /* yacc.c:1652  */
    {(yyval.str) = cat2_str ((yyvsp[-1].str), (yyvsp[0].str)); }
#line 51979 "preproc.c" /* yacc.c:1652  */
    break;

  case 2605:
#line 14419 "preproc.y" /* yacc.c:1652  */
    {(yyval.str) = (yyvsp[0].str); }
#line 51985 "preproc.c" /* yacc.c:1652  */
    break;

  case 2606:
#line 14420 "preproc.y" /* yacc.c:1652  */
    {(yyval.str) = (yyvsp[0].str); }
#line 51991 "preproc.c" /* yacc.c:1652  */
    break;

  case 2607:
#line 14423 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("extern"); }
#line 51997 "preproc.c" /* yacc.c:1652  */
    break;

  case 2608:
#line 14424 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("static"); }
#line 52003 "preproc.c" /* yacc.c:1652  */
    break;

  case 2609:
#line 14425 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("register"); }
#line 52009 "preproc.c" /* yacc.c:1652  */
    break;

  case 2610:
#line 14426 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("auto"); }
#line 52015 "preproc.c" /* yacc.c:1652  */
    break;

  case 2611:
#line 14429 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("const"); }
#line 52021 "preproc.c" /* yacc.c:1652  */
    break;

  case 2612:
#line 14430 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("volatile"); }
#line 52027 "preproc.c" /* yacc.c:1652  */
    break;

  case 2613:
#line 14434 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.type).type_enum = (yyvsp[0].type_enum);
			(yyval.type).type_str = mm_strdup(ecpg_type_name((yyvsp[0].type_enum)));
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 52039 "preproc.c" /* yacc.c:1652  */
    break;

  case 2614:
#line 14442 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.type).type_str = (yyvsp[0].str);
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");

			if (strncmp((yyvsp[0].str), "struct", sizeof("struct")-1) == 0)
			{
				(yyval.type).type_enum = ECPGt_struct;
				(yyval.type).type_sizeof = ECPGstruct_sizeof;
			}
			else
			{
				(yyval.type).type_enum = ECPGt_union;
				(yyval.type).type_sizeof = NULL;
			}
		}
#line 52060 "preproc.c" /* yacc.c:1652  */
    break;

  case 2615:
#line 14459 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.type).type_str = (yyvsp[0].str);
			(yyval.type).type_enum = ECPGt_int;
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 52072 "preproc.c" /* yacc.c:1652  */
    break;

  case 2616:
#line 14467 "preproc.y" /* yacc.c:1652  */
    {
			if (strcmp((yyvsp[-4].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
			}
			else if (strcmp((yyvsp[-4].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = mm_strdup("decimal");
			}
			else
			{
				mmerror(PARSE_ERROR, ET_ERROR, "only data types numeric and decimal have precision/scale argument");
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
			}

			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 52099 "preproc.c" /* yacc.c:1652  */
    break;

  case 2617:
#line 14490 "preproc.y" /* yacc.c:1652  */
    {
			if (strlen((yyvsp[0].str)) != 0 && strcmp ((yyvsp[-1].str), "datetime") != 0 && strcmp ((yyvsp[-1].str), "interval") != 0)
				mmerror (PARSE_ERROR, ET_ERROR, "interval specification not allowed here");

			/*
			 * Check for type names that the SQL grammar treats as
			 * unreserved keywords
			 */
			if (strcmp((yyvsp[-1].str), "varchar") == 0)
			{
				(yyval.type).type_enum = ECPGt_varchar;
				(yyval.type).type_str = EMPTY; /*mm_strdup("varchar");*/
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "float") == 0)
			{
				(yyval.type).type_enum = ECPGt_float;
				(yyval.type).type_str = mm_strdup("float");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "double") == 0)
			{
				(yyval.type).type_enum = ECPGt_double;
				(yyval.type).type_str = mm_strdup("double");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = mm_strdup("decimal");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "date") == 0)
			{
				(yyval.type).type_enum = ECPGt_date;
				(yyval.type).type_str = mm_strdup("date");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "timestamp") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = mm_strdup("timestamp");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "interval") == 0)
			{
				(yyval.type).type_enum = ECPGt_interval;
				(yyval.type).type_str = mm_strdup("interval");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "datetime") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = mm_strdup("timestamp");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if ((strcmp((yyvsp[-1].str), "string") == 0) && INFORMIX_MODE)
			{
				(yyval.type).type_enum = ECPGt_string;
				(yyval.type).type_str = mm_strdup("char");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else
			{
				/* this is for typedef'ed types */
				struct typedefs *this = get_typedef((yyvsp[-1].str));

				(yyval.type).type_str = (this->type->type_enum == ECPGt_varchar) ? EMPTY : mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				if (this->type->type_sizeof && strlen(this->type->type_sizeof) != 0)
					(yyval.type).type_sizeof = this->type->type_sizeof;
				else
					(yyval.type).type_sizeof = cat_str(3, mm_strdup("sizeof("), mm_strdup(this->name), mm_strdup(")"));

				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
			}
		}
#line 52209 "preproc.c" /* yacc.c:1652  */
    break;

  case 2618:
#line 14596 "preproc.y" /* yacc.c:1652  */
    {
			/* this is for named structs/unions */
			char *name;
			struct typedefs *this;
			bool forward = (forward_name != NULL && strcmp((yyvsp[0].struct_union).symbol, forward_name) == 0 && strcmp((yyvsp[0].struct_union).su, "struct") == 0);

			name = cat2_str((yyvsp[0].struct_union).su, (yyvsp[0].struct_union).symbol);
			/* Do we have a forward definition? */
			if (!forward)
			{
				/* No */

				this = get_typedef(name);
				(yyval.type).type_str = mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				(yyval.type).type_sizeof = this->type->type_sizeof;
				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
				free(name);
			}
			else
			{
				(yyval.type).type_str = name;
				(yyval.type).type_enum = ECPGt_long;
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = mm_strdup("");
				struct_member_list[struct_level] = NULL;
			}
		}
#line 52245 "preproc.c" /* yacc.c:1652  */
    break;

  case 2619:
#line 14630 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("enum"), (yyvsp[-1].str), (yyvsp[0].str)); }
#line 52251 "preproc.c" /* yacc.c:1652  */
    break;

  case 2620:
#line 14632 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str(mm_strdup("enum"), (yyvsp[0].str)); }
#line 52257 "preproc.c" /* yacc.c:1652  */
    break;

  case 2621:
#line 14634 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str(mm_strdup("enum"), (yyvsp[0].str)); }
#line 52263 "preproc.c" /* yacc.c:1652  */
    break;

  case 2622:
#line 14638 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}")); }
#line 52269 "preproc.c" /* yacc.c:1652  */
    break;

  case 2623:
#line 14641 "preproc.y" /* yacc.c:1652  */
    {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
			forward_name = mm_strdup((yyvsp[0].struct_union).symbol);
		}
#line 52280 "preproc.c" /* yacc.c:1652  */
    break;

  case 2624:
#line 14648 "preproc.y" /* yacc.c:1652  */
    {
			struct typedefs *ptr, *this;
			struct this_type su_type;

			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			if (strncmp((yyvsp[-4].struct_union).su, "struct", sizeof("struct")-1) == 0)
				su_type.type_enum = ECPGt_struct;
			else
				su_type.type_enum = ECPGt_union;
			su_type.type_str = cat2_str((yyvsp[-4].struct_union).su, (yyvsp[-4].struct_union).symbol);
			free(forward_name);
			forward_name = NULL;

			/* This is essentially a typedef but needs the keyword struct/union as well.
			 * So we create the typedef for each struct definition with symbol */
			for (ptr = types; ptr != NULL; ptr = ptr->next)
			{
					if (strcmp(su_type.type_str, ptr->name) == 0)
							/* re-definition is a bug */
							mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", su_type.type_str);
			}

			this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

			/* initial definition */
			this->next = types;
			this->name = mm_strdup(su_type.type_str);
			this->brace_level = braces_open;
			this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
			this->type->type_enum = su_type.type_enum;
			this->type->type_str = mm_strdup(su_type.type_str);
			this->type->type_dimension = mm_strdup("-1"); /* dimension of array */
			this->type->type_index = mm_strdup("-1");	/* length of string */
			this->type->type_sizeof = ECPGstruct_sizeof;
			this->struct_member_list = struct_member_list[struct_level];

			types = this;
			(yyval.str) = cat_str(4, su_type.type_str, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}"));
		}
#line 52326 "preproc.c" /* yacc.c:1652  */
    break;

  case 2625:
#line 14691 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52332 "preproc.c" /* yacc.c:1652  */
    break;

  case 2626:
#line 14693 "preproc.y" /* yacc.c:1652  */
    {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
		}
#line 52342 "preproc.c" /* yacc.c:1652  */
    break;

  case 2627:
#line 14699 "preproc.y" /* yacc.c:1652  */
    {
			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			(yyval.str) = cat_str(4, (yyvsp[-4].str), mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}"));
		}
#line 52353 "preproc.c" /* yacc.c:1652  */
    break;

  case 2628:
#line 14708 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.struct_union).su = mm_strdup("struct");
			(yyval.struct_union).symbol = (yyvsp[0].str);
			ECPGstruct_sizeof = cat_str(3, mm_strdup("sizeof("), cat2_str(mm_strdup((yyval.struct_union).su), mm_strdup((yyval.struct_union).symbol)), mm_strdup(")"));
		}
#line 52363 "preproc.c" /* yacc.c:1652  */
    break;

  case 2629:
#line 14714 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.struct_union).su = mm_strdup("union");
			(yyval.struct_union).symbol = (yyvsp[0].str);
		}
#line 52372 "preproc.c" /* yacc.c:1652  */
    break;

  case 2630:
#line 14721 "preproc.y" /* yacc.c:1652  */
    {
			ECPGstruct_sizeof = mm_strdup(""); /* This must not be NULL to distinguish from simple types. */
			(yyval.str) = mm_strdup("struct");
		}
#line 52381 "preproc.c" /* yacc.c:1652  */
    break;

  case 2631:
#line 14726 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = mm_strdup("union");
		}
#line 52389 "preproc.c" /* yacc.c:1652  */
    break;

  case 2632:
#line 14731 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum)=(yyvsp[0].type_enum); }
#line 52395 "preproc.c" /* yacc.c:1652  */
    break;

  case 2633:
#line 14732 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum)=(yyvsp[0].type_enum); }
#line 52401 "preproc.c" /* yacc.c:1652  */
    break;

  case 2634:
#line 14735 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_short; }
#line 52407 "preproc.c" /* yacc.c:1652  */
    break;

  case 2635:
#line 14736 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_short; }
#line 52413 "preproc.c" /* yacc.c:1652  */
    break;

  case 2636:
#line 14737 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_int; }
#line 52419 "preproc.c" /* yacc.c:1652  */
    break;

  case 2637:
#line 14738 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_int; }
#line 52425 "preproc.c" /* yacc.c:1652  */
    break;

  case 2638:
#line 14739 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_long; }
#line 52431 "preproc.c" /* yacc.c:1652  */
    break;

  case 2639:
#line 14740 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_long; }
#line 52437 "preproc.c" /* yacc.c:1652  */
    break;

  case 2640:
#line 14742 "preproc.y" /* yacc.c:1652  */
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_unsigned_long_long;
#else
			(yyval.type_enum) = ECPGt_unsigned_long;
#endif
		}
#line 52449 "preproc.c" /* yacc.c:1652  */
    break;

  case 2641:
#line 14750 "preproc.y" /* yacc.c:1652  */
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_unsigned_long_long;
#else
			(yyval.type_enum) = ECPGt_unsigned_long;
#endif
		}
#line 52461 "preproc.c" /* yacc.c:1652  */
    break;

  case 2642:
#line 14757 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_char; }
#line 52467 "preproc.c" /* yacc.c:1652  */
    break;

  case 2643:
#line 14760 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_short; }
#line 52473 "preproc.c" /* yacc.c:1652  */
    break;

  case 2644:
#line 14761 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_short; }
#line 52479 "preproc.c" /* yacc.c:1652  */
    break;

  case 2645:
#line 14762 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_int; }
#line 52485 "preproc.c" /* yacc.c:1652  */
    break;

  case 2646:
#line 14763 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_long; }
#line 52491 "preproc.c" /* yacc.c:1652  */
    break;

  case 2647:
#line 14764 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_long; }
#line 52497 "preproc.c" /* yacc.c:1652  */
    break;

  case 2648:
#line 14766 "preproc.y" /* yacc.c:1652  */
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_long_long;
#else
			(yyval.type_enum) = ECPGt_long;
#endif
		}
#line 52509 "preproc.c" /* yacc.c:1652  */
    break;

  case 2649:
#line 14774 "preproc.y" /* yacc.c:1652  */
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_long_long;
#else
			(yyval.type_enum) = ECPGt_long;
#endif
		}
#line 52521 "preproc.c" /* yacc.c:1652  */
    break;

  case 2650:
#line 14781 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_bool; }
#line 52527 "preproc.c" /* yacc.c:1652  */
    break;

  case 2651:
#line 14782 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_char; }
#line 52533 "preproc.c" /* yacc.c:1652  */
    break;

  case 2652:
#line 14783 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_double; }
#line 52539 "preproc.c" /* yacc.c:1652  */
    break;

  case 2655:
#line 14791 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52545 "preproc.c" /* yacc.c:1652  */
    break;

  case 2656:
#line 14793 "preproc.y" /* yacc.c:1652  */
    {
			if (actual_type[struct_level].type_enum == ECPGt_varchar)
				(yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(";"), (yyvsp[0].str));
			else
				(yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str));
		}
#line 52556 "preproc.c" /* yacc.c:1652  */
    break;

  case 2657:
#line 14802 "preproc.y" /* yacc.c:1652  */
    {
			struct ECPGtype * type;
			char *dimension = (yyvsp[-2].index).index1;	/* dimension of array */
			char *length = (yyvsp[-2].index).index2;		/* length of string */
			char *dim_str;
			char *vcn;

			adjust_array(actual_type[struct_level].type_enum, &dimension, &length, actual_type[struct_level].type_dimension, actual_type[struct_level].type_index, strlen((yyvsp[-4].str)), false);

			switch (actual_type[struct_level].type_enum)
			{
				case ECPGt_struct:
				case ECPGt_union:
					if (atoi(dimension) < 0)
						type = ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof);
					else
						type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;

				case ECPGt_varchar:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, varchar_counter);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, varchar_counter), dimension);

					if (strcmp(dimension, "0") == 0 || abs(atoi(dimension)) == 1)
							dim_str=mm_strdup("");
					else
							dim_str=cat_str(3, mm_strdup("["), mm_strdup(dimension), mm_strdup("]"));
					/* cannot check for atoi <= 0 because a defined constant will yield 0 here as well */
					if (atoi(length) < 0 || strcmp(length, "0") == 0)
						mmerror(PARSE_ERROR, ET_ERROR, "pointers to varchar are not implemented");

					/* make sure varchar struct name is unique by adding a unique counter to its definition */
					vcn = (char *) mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
					sprintf(vcn, "%d", varchar_counter);
					if (strcmp(dimension, "0") == 0)
						(yyval.str) = cat_str(7, make2_str(mm_strdup(" struct varchar_"), vcn), mm_strdup(" { int len; char arr["), mm_strdup(length), mm_strdup("]; } *"), mm_strdup((yyvsp[-3].str)), (yyvsp[-1].str), (yyvsp[0].str));
					else
						(yyval.str) = cat_str(8, make2_str(mm_strdup(" struct varchar_"), vcn), mm_strdup(" { int len; char arr["), mm_strdup(length), mm_strdup("]; } "), mm_strdup((yyvsp[-3].str)), dim_str, (yyvsp[-1].str), (yyvsp[0].str));
					varchar_counter++;
					break;

				case ECPGt_char:
				case ECPGt_unsigned_char:
				case ECPGt_string:
					if (atoi(dimension) == -1)
					{
						int i = strlen((yyvsp[0].str));

						if (atoi(length) == -1 && i > 0) /* char <var>[] = "string" */
						{
							/* if we have an initializer but no string size set, let's use the initializer's length */
							free(length);
							length = mm_alloc(i+sizeof("sizeof()"));
							sprintf(length, "sizeof(%s)", (yyvsp[0].str)+2);
						}
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0);
					}
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;

				default:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, mm_strdup("1"), 0);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, mm_strdup("1"), 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;
			}

			if (struct_level == 0)
				new_variable((yyvsp[-3].str), type, braces_open);
			else
				ECPGmake_struct_member((yyvsp[-3].str), type, &(struct_member_list[struct_level - 1]));

			free((yyvsp[-3].str));
		}
#line 52645 "preproc.c" /* yacc.c:1652  */
    break;

  case 2658:
#line 14889 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 52651 "preproc.c" /* yacc.c:1652  */
    break;

  case 2659:
#line 14891 "preproc.y" /* yacc.c:1652  */
    {
			initializer = 1;
			(yyval.str) = cat2_str(mm_strdup("="), (yyvsp[0].str));
		}
#line 52660 "preproc.c" /* yacc.c:1652  */
    break;

  case 2660:
#line 14897 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 52666 "preproc.c" /* yacc.c:1652  */
    break;

  case 2661:
#line 14898 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("*"); }
#line 52672 "preproc.c" /* yacc.c:1652  */
    break;

  case 2662:
#line 14899 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("**"); }
#line 52678 "preproc.c" /* yacc.c:1652  */
    break;

  case 2663:
#line 14906 "preproc.y" /* yacc.c:1652  */
    {
			/* this is only supported for compatibility */
			(yyval.str) = cat_str(3, mm_strdup("/* declare statement"), (yyvsp[0].str), mm_strdup("*/"));
		}
#line 52687 "preproc.c" /* yacc.c:1652  */
    break;

  case 2664:
#line 14914 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52693 "preproc.c" /* yacc.c:1652  */
    break;

  case 2665:
#line 14917 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52699 "preproc.c" /* yacc.c:1652  */
    break;

  case 2666:
#line 14918 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("\"CURRENT\""); }
#line 52705 "preproc.c" /* yacc.c:1652  */
    break;

  case 2667:
#line 14919 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("\"ALL\""); }
#line 52711 "preproc.c" /* yacc.c:1652  */
    break;

  case 2668:
#line 14920 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("\"CURRENT\""); }
#line 52717 "preproc.c" /* yacc.c:1652  */
    break;

  case 2669:
#line 14923 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 52723 "preproc.c" /* yacc.c:1652  */
    break;

  case 2670:
#line 14924 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("\"DEFAULT\""); }
#line 52729 "preproc.c" /* yacc.c:1652  */
    break;

  case 2671:
#line 14925 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52735 "preproc.c" /* yacc.c:1652  */
    break;

  case 2672:
#line 14929 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52741 "preproc.c" /* yacc.c:1652  */
    break;

  case 2673:
#line 14931 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 52747 "preproc.c" /* yacc.c:1652  */
    break;

  case 2674:
#line 14938 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52753 "preproc.c" /* yacc.c:1652  */
    break;

  case 2675:
#line 14939 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("all"); }
#line 52759 "preproc.c" /* yacc.c:1652  */
    break;

  case 2676:
#line 14946 "preproc.y" /* yacc.c:1652  */
    {
			if ((yyvsp[-1].str)[0] == ':')
				remove_variable_from_list(&argsinsert, find_variable((yyvsp[-1].str) + 1));
			(yyval.str) = (yyvsp[-1].str);
		}
#line 52769 "preproc.c" /* yacc.c:1652  */
    break;

  case 2677:
#line 14953 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 52775 "preproc.c" /* yacc.c:1652  */
    break;

  case 2678:
#line 14954 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52781 "preproc.c" /* yacc.c:1652  */
    break;

  case 2679:
#line 14957 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 52787 "preproc.c" /* yacc.c:1652  */
    break;

  case 2680:
#line 14958 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52793 "preproc.c" /* yacc.c:1652  */
    break;

  case 2681:
#line 14962 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsinsert, descriptor_variable((yyvsp[0].str),0), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 52802 "preproc.c" /* yacc.c:1652  */
    break;

  case 2682:
#line 14967 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsinsert, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 52811 "preproc.c" /* yacc.c:1652  */
    break;

  case 2683:
#line 14974 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsresult, descriptor_variable((yyvsp[0].str),1), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 52820 "preproc.c" /* yacc.c:1652  */
    break;

  case 2684:
#line 14979 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 52829 "preproc.c" /* yacc.c:1652  */
    break;

  case 2685:
#line 14986 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 52838 "preproc.c" /* yacc.c:1652  */
    break;

  case 2688:
#line 14995 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(32);

			sprintf(length, "%d", (int) strlen((yyvsp[0].str)));
			add_variable_to_head(&argsinsert, new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0), &no_indicator);
		}
#line 52849 "preproc.c" /* yacc.c:1652  */
    break;

  case 2689:
#line 15001 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 52855 "preproc.c" /* yacc.c:1652  */
    break;

  case 2690:
#line 15002 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 52861 "preproc.c" /* yacc.c:1652  */
    break;

  case 2691:
#line 15005 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52867 "preproc.c" /* yacc.c:1652  */
    break;

  case 2692:
#line 15006 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(2, mm_strdup("+"), (yyvsp[0].str)); }
#line 52873 "preproc.c" /* yacc.c:1652  */
    break;

  case 2693:
#line 15007 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(2, mm_strdup("-"), (yyvsp[0].str)); }
#line 52879 "preproc.c" /* yacc.c:1652  */
    break;

  case 2694:
#line 15008 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52885 "preproc.c" /* yacc.c:1652  */
    break;

  case 2695:
#line 15009 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(2, mm_strdup("+"), (yyvsp[0].str)); }
#line 52891 "preproc.c" /* yacc.c:1652  */
    break;

  case 2696:
#line 15010 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(2, mm_strdup("-"), (yyvsp[0].str)); }
#line 52897 "preproc.c" /* yacc.c:1652  */
    break;

  case 2697:
#line 15011 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52903 "preproc.c" /* yacc.c:1652  */
    break;

  case 2698:
#line 15012 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52909 "preproc.c" /* yacc.c:1652  */
    break;

  case 2699:
#line 15013 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52915 "preproc.c" /* yacc.c:1652  */
    break;

  case 2700:
#line 15020 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[-1].str));
	}
#line 52926 "preproc.c" /* yacc.c:1652  */
    break;

  case 2701:
#line 15027 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);

		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 52942 "preproc.c" /* yacc.c:1652  */
    break;

  case 2702:
#line 15039 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 52952 "preproc.c" /* yacc.c:1652  */
    break;

  case 2703:
#line 15045 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[-1].str));
	}
#line 52963 "preproc.c" /* yacc.c:1652  */
    break;

  case 2704:
#line 15052 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 52973 "preproc.c" /* yacc.c:1652  */
    break;

  case 2705:
#line 15059 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("output"); }
#line 52979 "preproc.c" /* yacc.c:1652  */
    break;

  case 2706:
#line 15060 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 52985 "preproc.c" /* yacc.c:1652  */
    break;

  case 2707:
#line 15073 "preproc.y" /* yacc.c:1652  */
    {
			add_descriptor((yyvsp[0].str),connection);
			(yyval.str) = (yyvsp[0].str);
		}
#line 52994 "preproc.c" /* yacc.c:1652  */
    break;

  case 2708:
#line 15084 "preproc.y" /* yacc.c:1652  */
    {
			drop_descriptor((yyvsp[0].str),connection);
			(yyval.str) = (yyvsp[0].str);
		}
#line 53003 "preproc.c" /* yacc.c:1652  */
    break;

  case 2709:
#line 15095 "preproc.y" /* yacc.c:1652  */
    {  (yyval.str) = (yyvsp[-1].str); }
#line 53009 "preproc.c" /* yacc.c:1652  */
    break;

  case 2712:
#line 15103 "preproc.y" /* yacc.c:1652  */
    { push_assignment((yyvsp[-2].str), (yyvsp[0].dtype_enum)); }
#line 53015 "preproc.c" /* yacc.c:1652  */
    break;

  case 2713:
#line 15108 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[-1].str); }
#line 53021 "preproc.c" /* yacc.c:1652  */
    break;

  case 2716:
#line 15116 "preproc.y" /* yacc.c:1652  */
    {
			push_assignment((yyvsp[0].str), (yyvsp[-2].dtype_enum));
		}
#line 53029 "preproc.c" /* yacc.c:1652  */
    break;

  case 2717:
#line 15122 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

			sprintf(length, "%d", (int) strlen((yyvsp[0].str)));
			new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = (yyvsp[0].str);
		}
#line 53041 "preproc.c" /* yacc.c:1652  */
    break;

  case 2718:
#line 15130 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = (yyvsp[0].str);
		}
#line 53049 "preproc.c" /* yacc.c:1652  */
    break;

  case 2719:
#line 15135 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_count; }
#line 53055 "preproc.c" /* yacc.c:1652  */
    break;

  case 2720:
#line 15143 "preproc.y" /* yacc.c:1652  */
    {  (yyval.descriptor).str = (yyvsp[-1].str); (yyval.descriptor).name = (yyvsp[-3].str); }
#line 53061 "preproc.c" /* yacc.c:1652  */
    break;

  case 2723:
#line 15150 "preproc.y" /* yacc.c:1652  */
    { push_assignment((yyvsp[-2].str), (yyvsp[0].dtype_enum)); }
#line 53067 "preproc.c" /* yacc.c:1652  */
    break;

  case 2724:
#line 15154 "preproc.y" /* yacc.c:1652  */
    {  (yyval.descriptor).str = (yyvsp[-1].str); (yyval.descriptor).name = (yyvsp[-3].str); }
#line 53073 "preproc.c" /* yacc.c:1652  */
    break;

  case 2727:
#line 15162 "preproc.y" /* yacc.c:1652  */
    {
			push_assignment((yyvsp[0].str), (yyvsp[-2].dtype_enum));
		}
#line 53081 "preproc.c" /* yacc.c:1652  */
    break;

  case 2728:
#line 15168 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

			sprintf(length, "%d", (int) strlen((yyvsp[0].str)));
			new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = (yyvsp[0].str);
		}
#line 53093 "preproc.c" /* yacc.c:1652  */
    break;

  case 2729:
#line 15177 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = (yyvsp[0].str);
		}
#line 53101 "preproc.c" /* yacc.c:1652  */
    break;

  case 2730:
#line 15182 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = cat2_str(mm_strdup("-"), (yyvsp[0].str));

			sprintf(length, "%d", (int) strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 53114 "preproc.c" /* yacc.c:1652  */
    break;

  case 2731:
#line 15192 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = cat2_str(mm_strdup("-"), (yyvsp[0].str));

			sprintf(length, "%d", (int) strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 53127 "preproc.c" /* yacc.c:1652  */
    break;

  case 2732:
#line 15202 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = (yyvsp[0].str) + 1;

			var[strlen(var) - 1] = '\0';
			sprintf(length, "%d", (int) strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 53141 "preproc.c" /* yacc.c:1652  */
    break;

  case 2733:
#line 15213 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_cardinality; }
#line 53147 "preproc.c" /* yacc.c:1652  */
    break;

  case 2734:
#line 15214 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_data; }
#line 53153 "preproc.c" /* yacc.c:1652  */
    break;

  case 2735:
#line 15215 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_di_code; }
#line 53159 "preproc.c" /* yacc.c:1652  */
    break;

  case 2736:
#line 15216 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_di_precision; }
#line 53165 "preproc.c" /* yacc.c:1652  */
    break;

  case 2737:
#line 15217 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_indicator; }
#line 53171 "preproc.c" /* yacc.c:1652  */
    break;

  case 2738:
#line 15218 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_key_member; }
#line 53177 "preproc.c" /* yacc.c:1652  */
    break;

  case 2739:
#line 15219 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_length; }
#line 53183 "preproc.c" /* yacc.c:1652  */
    break;

  case 2740:
#line 15220 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_name; }
#line 53189 "preproc.c" /* yacc.c:1652  */
    break;

  case 2741:
#line 15221 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_nullable; }
#line 53195 "preproc.c" /* yacc.c:1652  */
    break;

  case 2742:
#line 15222 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_octet; }
#line 53201 "preproc.c" /* yacc.c:1652  */
    break;

  case 2743:
#line 15223 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_precision; }
#line 53207 "preproc.c" /* yacc.c:1652  */
    break;

  case 2744:
#line 15224 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_length; }
#line 53213 "preproc.c" /* yacc.c:1652  */
    break;

  case 2745:
#line 15225 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_ret_octet; }
#line 53219 "preproc.c" /* yacc.c:1652  */
    break;

  case 2746:
#line 15226 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_scale; }
#line 53225 "preproc.c" /* yacc.c:1652  */
    break;

  case 2747:
#line 15227 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_type; }
#line 53231 "preproc.c" /* yacc.c:1652  */
    break;

  case 2748:
#line 15234 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53237 "preproc.c" /* yacc.c:1652  */
    break;

  case 2749:
#line 15235 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53243 "preproc.c" /* yacc.c:1652  */
    break;

  case 2750:
#line 15238 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("on"); }
#line 53249 "preproc.c" /* yacc.c:1652  */
    break;

  case 2751:
#line 15239 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("off"); }
#line 53255 "preproc.c" /* yacc.c:1652  */
    break;

  case 2752:
#line 15246 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53261 "preproc.c" /* yacc.c:1652  */
    break;

  case 2753:
#line 15247 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53267 "preproc.c" /* yacc.c:1652  */
    break;

  case 2754:
#line 15248 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53273 "preproc.c" /* yacc.c:1652  */
    break;

  case 2755:
#line 15255 "preproc.y" /* yacc.c:1652  */
    {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		}
#line 53283 "preproc.c" /* yacc.c:1652  */
    break;

  case 2756:
#line 15261 "preproc.y" /* yacc.c:1652  */
    {
			add_typedef((yyvsp[-4].str), (yyvsp[-1].index).index1, (yyvsp[-1].index).index2, (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_dimension, (yyvsp[-2].type).type_index, initializer, *(yyvsp[0].str) ? 1 : 0);

			if (auto_create_c == false)
				(yyval.str) = cat_str(7, mm_strdup("/* exec sql type"), mm_strdup((yyvsp[-4].str)), mm_strdup("is"), mm_strdup((yyvsp[-2].type).type_str), mm_strdup((yyvsp[-1].index).str), (yyvsp[0].str), mm_strdup("*/"));
			else
				(yyval.str) = cat_str(6, mm_strdup("typedef "), mm_strdup((yyvsp[-2].type).type_str), *(yyvsp[0].str)?mm_strdup("*"):mm_strdup(""), mm_strdup((yyvsp[-4].str)), mm_strdup((yyvsp[-1].index).str), mm_strdup(";"));
		}
#line 53296 "preproc.c" /* yacc.c:1652  */
    break;

  case 2757:
#line 15271 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("reference"); }
#line 53302 "preproc.c" /* yacc.c:1652  */
    break;

  case 2758:
#line 15272 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 53308 "preproc.c" /* yacc.c:1652  */
    break;

  case 2759:
#line 15279 "preproc.y" /* yacc.c:1652  */
    {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		}
#line 53318 "preproc.c" /* yacc.c:1652  */
    break;

  case 2760:
#line 15285 "preproc.y" /* yacc.c:1652  */
    {
			struct variable *p = find_variable((yyvsp[-4].str));
			char *dimension = (yyvsp[-1].index).index1;
			char *length = (yyvsp[-1].index).index2;
			struct ECPGtype * type;

			if (((yyvsp[-2].type).type_enum == ECPGt_struct ||
				 (yyvsp[-2].type).type_enum == ECPGt_union) &&
				initializer == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in EXEC SQL VAR command");
			else
			{
				adjust_array((yyvsp[-2].type).type_enum, &dimension, &length, (yyvsp[-2].type).type_dimension, (yyvsp[-2].type).type_index, *(yyvsp[0].str)?1:0, false);

				switch ((yyvsp[-2].type).type_enum)
				{
					case ECPGt_struct:
					case ECPGt_union:
						if (atoi(dimension) < 0)
							type = ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_str, (yyvsp[-2].type).type_sizeof);
						else
							type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_str, (yyvsp[-2].type).type_sizeof), dimension);
						break;

					case ECPGt_varchar:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0), dimension);
						break;

					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0), dimension);
						break;

					default:
						if (atoi(length) >= 0)
							mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

						if (atoi(dimension) < 0)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, mm_strdup("1"), 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, mm_strdup("1"), 0), dimension);
						break;
				}

				ECPGfree_type(p->type);
				p->type = type;
			}

			(yyval.str) = cat_str(7, mm_strdup("/* exec sql var"), mm_strdup((yyvsp[-4].str)), mm_strdup("is"), mm_strdup((yyvsp[-2].type).type_str), mm_strdup((yyvsp[-1].index).str), (yyvsp[0].str), mm_strdup("*/"));
		}
#line 53380 "preproc.c" /* yacc.c:1652  */
    break;

  case 2761:
#line 15349 "preproc.y" /* yacc.c:1652  */
    {
			when_error.code = (yyvsp[0].action).code;
			when_error.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever sqlerror "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 53390 "preproc.c" /* yacc.c:1652  */
    break;

  case 2762:
#line 15355 "preproc.y" /* yacc.c:1652  */
    {
			when_nf.code = (yyvsp[0].action).code;
			when_nf.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever not found "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 53400 "preproc.c" /* yacc.c:1652  */
    break;

  case 2763:
#line 15361 "preproc.y" /* yacc.c:1652  */
    {
			when_warn.code = (yyvsp[0].action).code;
			when_warn.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever sql_warning "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 53410 "preproc.c" /* yacc.c:1652  */
    break;

  case 2764:
#line 15369 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_NOTHING;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("continue");
		}
#line 53420 "preproc.c" /* yacc.c:1652  */
    break;

  case 2765:
#line 15375 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_SQLPRINT;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("sqlprint");
		}
#line 53430 "preproc.c" /* yacc.c:1652  */
    break;

  case 2766:
#line 15381 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_STOP;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("stop");
		}
#line 53440 "preproc.c" /* yacc.c:1652  */
    break;

  case 2767:
#line 15387 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = mm_strdup((yyvsp[0].str));
			(yyval.action).str = cat2_str(mm_strdup("goto "), (yyvsp[0].str));
		}
#line 53450 "preproc.c" /* yacc.c:1652  */
    break;

  case 2768:
#line 15393 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = mm_strdup((yyvsp[0].str));
			(yyval.action).str = cat2_str(mm_strdup("goto "), (yyvsp[0].str));
		}
#line 53460 "preproc.c" /* yacc.c:1652  */
    break;

  case 2769:
#line 15399 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].str), mm_strdup(")"));
			(yyval.action).str = cat2_str(mm_strdup("do"), mm_strdup((yyval.action).command));
		}
#line 53470 "preproc.c" /* yacc.c:1652  */
    break;

  case 2770:
#line 15405 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_BREAK;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("break");
		}
#line 53480 "preproc.c" /* yacc.c:1652  */
    break;

  case 2771:
#line 15411 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].str), mm_strdup(")"));
			(yyval.action).str = cat2_str(mm_strdup("call"), mm_strdup((yyval.action).command));
		}
#line 53490 "preproc.c" /* yacc.c:1652  */
    break;

  case 2772:
#line 15417 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat2_str((yyvsp[0].str), mm_strdup("()"));
			(yyval.action).str = cat2_str(mm_strdup("call"), mm_strdup((yyval.action).command));
		}
#line 53500 "preproc.c" /* yacc.c:1652  */
    break;

  case 2773:
#line 15427 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53506 "preproc.c" /* yacc.c:1652  */
    break;

  case 2774:
#line 15428 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53512 "preproc.c" /* yacc.c:1652  */
    break;

  case 2775:
#line 15431 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("break"); }
#line 53518 "preproc.c" /* yacc.c:1652  */
    break;

  case 2776:
#line 15432 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("call"); }
#line 53524 "preproc.c" /* yacc.c:1652  */
    break;

  case 2777:
#line 15433 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("cardinality"); }
#line 53530 "preproc.c" /* yacc.c:1652  */
    break;

  case 2778:
#line 15434 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("count"); }
#line 53536 "preproc.c" /* yacc.c:1652  */
    break;

  case 2779:
#line 15435 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("datetime_interval_code"); }
#line 53542 "preproc.c" /* yacc.c:1652  */
    break;

  case 2780:
#line 15436 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("datetime_interval_precision"); }
#line 53548 "preproc.c" /* yacc.c:1652  */
    break;

  case 2781:
#line 15437 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("found"); }
#line 53554 "preproc.c" /* yacc.c:1652  */
    break;

  case 2782:
#line 15438 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("go"); }
#line 53560 "preproc.c" /* yacc.c:1652  */
    break;

  case 2783:
#line 15439 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("goto"); }
#line 53566 "preproc.c" /* yacc.c:1652  */
    break;

  case 2784:
#line 15440 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("identified"); }
#line 53572 "preproc.c" /* yacc.c:1652  */
    break;

  case 2785:
#line 15441 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("indicator"); }
#line 53578 "preproc.c" /* yacc.c:1652  */
    break;

  case 2786:
#line 15442 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("key_member"); }
#line 53584 "preproc.c" /* yacc.c:1652  */
    break;

  case 2787:
#line 15443 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("length"); }
#line 53590 "preproc.c" /* yacc.c:1652  */
    break;

  case 2788:
#line 15444 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("nullable"); }
#line 53596 "preproc.c" /* yacc.c:1652  */
    break;

  case 2789:
#line 15445 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("octet_length"); }
#line 53602 "preproc.c" /* yacc.c:1652  */
    break;

  case 2790:
#line 15446 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("returned_length"); }
#line 53608 "preproc.c" /* yacc.c:1652  */
    break;

  case 2791:
#line 15447 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("returned_octet_length"); }
#line 53614 "preproc.c" /* yacc.c:1652  */
    break;

  case 2792:
#line 15448 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("scale"); }
#line 53620 "preproc.c" /* yacc.c:1652  */
    break;

  case 2793:
#line 15449 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("section"); }
#line 53626 "preproc.c" /* yacc.c:1652  */
    break;

  case 2794:
#line 15450 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("sqlerror"); }
#line 53632 "preproc.c" /* yacc.c:1652  */
    break;

  case 2795:
#line 15451 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("sqlprint"); }
#line 53638 "preproc.c" /* yacc.c:1652  */
    break;

  case 2796:
#line 15452 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("sqlwarning"); }
#line 53644 "preproc.c" /* yacc.c:1652  */
    break;

  case 2797:
#line 15453 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("stop"); }
#line 53650 "preproc.c" /* yacc.c:1652  */
    break;

  case 2798:
#line 15456 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("connect"); }
#line 53656 "preproc.c" /* yacc.c:1652  */
    break;

  case 2799:
#line 15457 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("describe"); }
#line 53662 "preproc.c" /* yacc.c:1652  */
    break;

  case 2800:
#line 15458 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("disconnect"); }
#line 53668 "preproc.c" /* yacc.c:1652  */
    break;

  case 2801:
#line 15459 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("open"); }
#line 53674 "preproc.c" /* yacc.c:1652  */
    break;

  case 2802:
#line 15460 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("var"); }
#line 53680 "preproc.c" /* yacc.c:1652  */
    break;

  case 2803:
#line 15461 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("whenever"); }
#line 53686 "preproc.c" /* yacc.c:1652  */
    break;

  case 2804:
#line 15465 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("bool"); }
#line 53692 "preproc.c" /* yacc.c:1652  */
    break;

  case 2805:
#line 15466 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("long"); }
#line 53698 "preproc.c" /* yacc.c:1652  */
    break;

  case 2806:
#line 15467 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("output"); }
#line 53704 "preproc.c" /* yacc.c:1652  */
    break;

  case 2807:
#line 15468 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("short"); }
#line 53710 "preproc.c" /* yacc.c:1652  */
    break;

  case 2808:
#line 15469 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("struct"); }
#line 53716 "preproc.c" /* yacc.c:1652  */
    break;

  case 2809:
#line 15470 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("signed"); }
#line 53722 "preproc.c" /* yacc.c:1652  */
    break;

  case 2810:
#line 15471 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("unsigned"); }
#line 53728 "preproc.c" /* yacc.c:1652  */
    break;

  case 2811:
#line 15474 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53734 "preproc.c" /* yacc.c:1652  */
    break;

  case 2812:
#line 15477 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53740 "preproc.c" /* yacc.c:1652  */
    break;

  case 2813:
#line 15478 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53746 "preproc.c" /* yacc.c:1652  */
    break;

  case 2814:
#line 15479 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53752 "preproc.c" /* yacc.c:1652  */
    break;

  case 2815:
#line 15480 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53758 "preproc.c" /* yacc.c:1652  */
    break;

  case 2816:
#line 15481 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53764 "preproc.c" /* yacc.c:1652  */
    break;

  case 2817:
#line 15482 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53770 "preproc.c" /* yacc.c:1652  */
    break;

  case 2818:
#line 15483 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("char"); }
#line 53776 "preproc.c" /* yacc.c:1652  */
    break;

  case 2819:
#line 15484 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("values"); }
#line 53782 "preproc.c" /* yacc.c:1652  */
    break;

  case 2820:
#line 15497 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53788 "preproc.c" /* yacc.c:1652  */
    break;

  case 2821:
#line 15498 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53794 "preproc.c" /* yacc.c:1652  */
    break;

  case 2822:
#line 15499 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53800 "preproc.c" /* yacc.c:1652  */
    break;

  case 2823:
#line 15500 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53806 "preproc.c" /* yacc.c:1652  */
    break;

  case 2824:
#line 15501 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53812 "preproc.c" /* yacc.c:1652  */
    break;

  case 2825:
#line 15502 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("char"); }
#line 53818 "preproc.c" /* yacc.c:1652  */
    break;

  case 2826:
#line 15503 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("values"); }
#line 53824 "preproc.c" /* yacc.c:1652  */
    break;

  case 2827:
#line 15508 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53830 "preproc.c" /* yacc.c:1652  */
    break;

  case 2828:
#line 15509 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53836 "preproc.c" /* yacc.c:1652  */
    break;

  case 2829:
#line 15510 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53842 "preproc.c" /* yacc.c:1652  */
    break;

  case 2830:
#line 15511 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53848 "preproc.c" /* yacc.c:1652  */
    break;

  case 2831:
#line 15512 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53854 "preproc.c" /* yacc.c:1652  */
    break;

  case 2832:
#line 15513 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53860 "preproc.c" /* yacc.c:1652  */
    break;

  case 2833:
#line 15519 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53866 "preproc.c" /* yacc.c:1652  */
    break;

  case 2834:
#line 15520 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53872 "preproc.c" /* yacc.c:1652  */
    break;

  case 2835:
#line 15521 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("char"); }
#line 53878 "preproc.c" /* yacc.c:1652  */
    break;

  case 2836:
#line 15522 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("current"); }
#line 53884 "preproc.c" /* yacc.c:1652  */
    break;

  case 2837:
#line 15523 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("input"); }
#line 53890 "preproc.c" /* yacc.c:1652  */
    break;

  case 2838:
#line 15524 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("int"); }
#line 53896 "preproc.c" /* yacc.c:1652  */
    break;

  case 2839:
#line 15525 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("to"); }
#line 53902 "preproc.c" /* yacc.c:1652  */
    break;

  case 2840:
#line 15526 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("union"); }
#line 53908 "preproc.c" /* yacc.c:1652  */
    break;

  case 2841:
#line 15527 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("values"); }
#line 53914 "preproc.c" /* yacc.c:1652  */
    break;

  case 2842:
#line 15528 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53920 "preproc.c" /* yacc.c:1652  */
    break;

  case 2843:
#line 15529 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53926 "preproc.c" /* yacc.c:1652  */
    break;

  case 2844:
#line 15532 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53932 "preproc.c" /* yacc.c:1652  */
    break;

  case 2845:
#line 15533 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53938 "preproc.c" /* yacc.c:1652  */
    break;

  case 2846:
#line 15534 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53944 "preproc.c" /* yacc.c:1652  */
    break;

  case 2847:
#line 15535 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53950 "preproc.c" /* yacc.c:1652  */
    break;

  case 2848:
#line 15536 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("connection"); }
#line 53956 "preproc.c" /* yacc.c:1652  */
    break;

  case 2849:
#line 15539 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53962 "preproc.c" /* yacc.c:1652  */
    break;

  case 2850:
#line 15540 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53968 "preproc.c" /* yacc.c:1652  */
    break;

  case 2851:
#line 15541 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53974 "preproc.c" /* yacc.c:1652  */
    break;

  case 2852:
#line 15542 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53980 "preproc.c" /* yacc.c:1652  */
    break;

  case 2853:
#line 15545 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("auto"); }
#line 53986 "preproc.c" /* yacc.c:1652  */
    break;

  case 2854:
#line 15546 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("const"); }
#line 53992 "preproc.c" /* yacc.c:1652  */
    break;

  case 2855:
#line 15547 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("extern"); }
#line 53998 "preproc.c" /* yacc.c:1652  */
    break;

  case 2856:
#line 15548 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("register"); }
#line 54004 "preproc.c" /* yacc.c:1652  */
    break;

  case 2857:
#line 15549 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("static"); }
#line 54010 "preproc.c" /* yacc.c:1652  */
    break;

  case 2858:
#line 15550 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("typedef"); }
#line 54016 "preproc.c" /* yacc.c:1652  */
    break;

  case 2859:
#line 15551 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("volatile"); }
#line 54022 "preproc.c" /* yacc.c:1652  */
    break;

  case 2860:
#line 15568 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54028 "preproc.c" /* yacc.c:1652  */
    break;

  case 2861:
#line 15569 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54034 "preproc.c" /* yacc.c:1652  */
    break;

  case 2862:
#line 15570 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("connection"); }
#line 54040 "preproc.c" /* yacc.c:1652  */
    break;

  case 2863:
#line 15573 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("day"); }
#line 54046 "preproc.c" /* yacc.c:1652  */
    break;

  case 2864:
#line 15574 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("hour"); }
#line 54052 "preproc.c" /* yacc.c:1652  */
    break;

  case 2865:
#line 15575 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("minute"); }
#line 54058 "preproc.c" /* yacc.c:1652  */
    break;

  case 2866:
#line 15576 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("month"); }
#line 54064 "preproc.c" /* yacc.c:1652  */
    break;

  case 2867:
#line 15577 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("second"); }
#line 54070 "preproc.c" /* yacc.c:1652  */
    break;

  case 2868:
#line 15578 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("year"); }
#line 54076 "preproc.c" /* yacc.c:1652  */
    break;

  case 2871:
#line 15585 "preproc.y" /* yacc.c:1652  */
    {
				reset_variables();
				pacounter = 1;
			}
#line 54085 "preproc.c" /* yacc.c:1652  */
    break;

  case 2872:
#line 15591 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 54091 "preproc.c" /* yacc.c:1652  */
    break;

  case 2873:
#line 15592 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54097 "preproc.c" /* yacc.c:1652  */
    break;

  case 2874:
#line 15596 "preproc.y" /* yacc.c:1652  */
    { add_variable_to_head(&argsresult, find_variable((yyvsp[-1].str)), find_variable((yyvsp[0].str))); }
#line 54103 "preproc.c" /* yacc.c:1652  */
    break;

  case 2875:
#line 15598 "preproc.y" /* yacc.c:1652  */
    { add_variable_to_head(&argsresult, find_variable((yyvsp[0].str)), &no_indicator); }
#line 54109 "preproc.c" /* yacc.c:1652  */
    break;

  case 2876:
#line 15603 "preproc.y" /* yacc.c:1652  */
    {
			if (find_variable((yyvsp[0].str))->type->type == ECPGt_array)
				mmerror(PARSE_ERROR, ET_ERROR, "arrays of indicators are not allowed on input");

			add_variable_to_head(&argsinsert, find_variable((yyvsp[-1].str)), find_variable((yyvsp[0].str)));
			(yyval.str) = create_questionmarks((yyvsp[-1].str), false);
		}
#line 54121 "preproc.c" /* yacc.c:1652  */
    break;

  case 2877:
#line 15613 "preproc.y" /* yacc.c:1652  */
    {
			char *ptr = strstr((yyvsp[0].str), ".arr");

			if (ptr) /* varchar, we need the struct name here, not the struct element */
				*ptr = '\0';
			add_variable_to_head(&argsinsert, find_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = (yyvsp[0].str);
		}
#line 54134 "preproc.c" /* yacc.c:1652  */
    break;

  case 2878:
#line 15624 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsinsert, find_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = create_questionmarks((yyvsp[0].str), false);
		}
#line 54143 "preproc.c" /* yacc.c:1652  */
    break;

  case 2879:
#line 15630 "preproc.y" /* yacc.c:1652  */
    { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 54149 "preproc.c" /* yacc.c:1652  */
    break;

  case 2880:
#line 15631 "preproc.y" /* yacc.c:1652  */
    { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 54155 "preproc.c" /* yacc.c:1652  */
    break;

  case 2881:
#line 15632 "preproc.y" /* yacc.c:1652  */
    { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 54161 "preproc.c" /* yacc.c:1652  */
    break;

  case 2882:
#line 15636 "preproc.y" /* yacc.c:1652  */
    {
			/* As long as multidimensional arrays are not implemented we have to check for those here */
			char *ptr = (yyvsp[0].str);
			int brace_open=0, brace = false;

			for (; *ptr; ptr++)
			{
				switch (*ptr)
				{
					case '[':
							if (brace)
								mmfatal(PARSE_ERROR, "multidimensional arrays for simple data types are not supported");
							brace_open++;
							break;
					case ']':
							brace_open--;
							if (brace_open == 0)
								brace = true;
							break;
					case '\t':
					case ' ':
							break;
					default:
							if (brace_open == 0)
								brace = false;
							break;
				}
			}
			(yyval.str) = (yyvsp[0].str);
		}
#line 54196 "preproc.c" /* yacc.c:1652  */
    break;

  case 2883:
#line 15668 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 54202 "preproc.c" /* yacc.c:1652  */
    break;

  case 2884:
#line 15670 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 54208 "preproc.c" /* yacc.c:1652  */
    break;

  case 2885:
#line 15672 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 54214 "preproc.c" /* yacc.c:1652  */
    break;

  case 2886:
#line 15676 "preproc.y" /* yacc.c:1652  */
    {
			/* could have been input as '' or $$ */
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[0].str)) + 3);
			(yyval.str)[0]='\'';
			strcpy((yyval.str)+1, (yyvsp[0].str));
			(yyval.str)[strlen((yyvsp[0].str))+1]='\'';
			(yyval.str)[strlen((yyvsp[0].str))+2]='\0';
			free((yyvsp[0].str));
		}
#line 54228 "preproc.c" /* yacc.c:1652  */
    break;

  case 2887:
#line 15686 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[0].str)) + 4);
			(yyval.str)[0]='E';
			(yyval.str)[1]='\'';
			strcpy((yyval.str)+2, (yyvsp[0].str));
			(yyval.str)[strlen((yyvsp[0].str))+2]='\'';
			(yyval.str)[strlen((yyvsp[0].str))+3]='\0';
			free((yyvsp[0].str));
		}
#line 54242 "preproc.c" /* yacc.c:1652  */
    break;

  case 2888:
#line 15696 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[0].str)) + 4);
			(yyval.str)[0]='N';
			(yyval.str)[1]='\'';
			strcpy((yyval.str)+2, (yyvsp[0].str));
			(yyval.str)[strlen((yyvsp[0].str))+2]='\'';
			(yyval.str)[strlen((yyvsp[0].str))+3]='\0';
			free((yyvsp[0].str));
		}
#line 54256 "preproc.c" /* yacc.c:1652  */
    break;

  case 2889:
#line 15705 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54262 "preproc.c" /* yacc.c:1652  */
    break;

  case 2890:
#line 15706 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54268 "preproc.c" /* yacc.c:1652  */
    break;

  case 2891:
#line 15709 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 54274 "preproc.c" /* yacc.c:1652  */
    break;

  case 2892:
#line 15711 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 54280 "preproc.c" /* yacc.c:1652  */
    break;

  case 2893:
#line 15712 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 54286 "preproc.c" /* yacc.c:1652  */
    break;

  case 2894:
#line 15713 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54292 "preproc.c" /* yacc.c:1652  */
    break;

  case 2895:
#line 15717 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 54298 "preproc.c" /* yacc.c:1652  */
    break;

  case 2896:
#line 15719 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str(mm_strdup("("), (yyvsp[0].str), mm_strdup(")")); }
#line 54304 "preproc.c" /* yacc.c:1652  */
    break;

  case 2897:
#line 15726 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54310 "preproc.c" /* yacc.c:1652  */
    break;

  case 2898:
#line 15727 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("()"); }
#line 54316 "preproc.c" /* yacc.c:1652  */
    break;

  case 2899:
#line 15729 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("("), (yyvsp[-1].str), mm_strdup(")")); }
#line 54322 "preproc.c" /* yacc.c:1652  */
    break;

  case 2900:
#line 15732 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54328 "preproc.c" /* yacc.c:1652  */
    break;

  case 2901:
#line 15734 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 54334 "preproc.c" /* yacc.c:1652  */
    break;

  case 2902:
#line 15737 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54340 "preproc.c" /* yacc.c:1652  */
    break;

  case 2903:
#line 15738 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 54346 "preproc.c" /* yacc.c:1652  */
    break;

  case 2904:
#line 15741 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54352 "preproc.c" /* yacc.c:1652  */
    break;

  case 2905:
#line 15742 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}")); }
#line 54358 "preproc.c" /* yacc.c:1652  */
    break;

  case 2906:
#line 15745 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54364 "preproc.c" /* yacc.c:1652  */
    break;

  case 2907:
#line 15746 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("("); }
#line 54370 "preproc.c" /* yacc.c:1652  */
    break;

  case 2908:
#line 15747 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(")"); }
#line 54376 "preproc.c" /* yacc.c:1652  */
    break;

  case 2909:
#line 15748 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(","); }
#line 54382 "preproc.c" /* yacc.c:1652  */
    break;

  case 2910:
#line 15749 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(";"); }
#line 54388 "preproc.c" /* yacc.c:1652  */
    break;

  case 2911:
#line 15752 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54394 "preproc.c" /* yacc.c:1652  */
    break;

  case 2912:
#line 15753 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54400 "preproc.c" /* yacc.c:1652  */
    break;

  case 2913:
#line 15754 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54406 "preproc.c" /* yacc.c:1652  */
    break;

  case 2914:
#line 15755 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54412 "preproc.c" /* yacc.c:1652  */
    break;

  case 2915:
#line 15756 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("*"); }
#line 54418 "preproc.c" /* yacc.c:1652  */
    break;

  case 2916:
#line 15757 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("+"); }
#line 54424 "preproc.c" /* yacc.c:1652  */
    break;

  case 2917:
#line 15758 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("-"); }
#line 54430 "preproc.c" /* yacc.c:1652  */
    break;

  case 2918:
#line 15759 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("/"); }
#line 54436 "preproc.c" /* yacc.c:1652  */
    break;

  case 2919:
#line 15760 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("%"); }
#line 54442 "preproc.c" /* yacc.c:1652  */
    break;

  case 2920:
#line 15761 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("NULL"); }
#line 54448 "preproc.c" /* yacc.c:1652  */
    break;

  case 2921:
#line 15762 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("+="); }
#line 54454 "preproc.c" /* yacc.c:1652  */
    break;

  case 2922:
#line 15763 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("&&"); }
#line 54460 "preproc.c" /* yacc.c:1652  */
    break;

  case 2923:
#line 15764 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 54466 "preproc.c" /* yacc.c:1652  */
    break;

  case 2924:
#line 15765 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("auto"); }
#line 54472 "preproc.c" /* yacc.c:1652  */
    break;

  case 2925:
#line 15766 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("const"); }
#line 54478 "preproc.c" /* yacc.c:1652  */
    break;

  case 2926:
#line 15767 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("--"); }
#line 54484 "preproc.c" /* yacc.c:1652  */
    break;

  case 2927:
#line 15768 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("/="); }
#line 54490 "preproc.c" /* yacc.c:1652  */
    break;

  case 2928:
#line 15769 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(".*"); }
#line 54496 "preproc.c" /* yacc.c:1652  */
    break;

  case 2929:
#line 15770 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("=="); }
#line 54502 "preproc.c" /* yacc.c:1652  */
    break;

  case 2930:
#line 15771 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("extern"); }
#line 54508 "preproc.c" /* yacc.c:1652  */
    break;

  case 2931:
#line 15772 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("++"); }
#line 54514 "preproc.c" /* yacc.c:1652  */
    break;

  case 2932:
#line 15773 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("<<"); }
#line 54520 "preproc.c" /* yacc.c:1652  */
    break;

  case 2933:
#line 15774 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("->"); }
#line 54526 "preproc.c" /* yacc.c:1652  */
    break;

  case 2934:
#line 15775 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("->*"); }
#line 54532 "preproc.c" /* yacc.c:1652  */
    break;

  case 2935:
#line 15776 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("%="); }
#line 54538 "preproc.c" /* yacc.c:1652  */
    break;

  case 2936:
#line 15777 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("*="); }
#line 54544 "preproc.c" /* yacc.c:1652  */
    break;

  case 2937:
#line 15778 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("!="); }
#line 54550 "preproc.c" /* yacc.c:1652  */
    break;

  case 2938:
#line 15779 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("||"); }
#line 54556 "preproc.c" /* yacc.c:1652  */
    break;

  case 2939:
#line 15780 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("register"); }
#line 54562 "preproc.c" /* yacc.c:1652  */
    break;

  case 2940:
#line 15781 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(">>"); }
#line 54568 "preproc.c" /* yacc.c:1652  */
    break;

  case 2941:
#line 15782 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("static"); }
#line 54574 "preproc.c" /* yacc.c:1652  */
    break;

  case 2942:
#line 15783 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("-="); }
#line 54580 "preproc.c" /* yacc.c:1652  */
    break;

  case 2943:
#line 15784 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("typedef"); }
#line 54586 "preproc.c" /* yacc.c:1652  */
    break;

  case 2944:
#line 15785 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("volatile"); }
#line 54592 "preproc.c" /* yacc.c:1652  */
    break;

  case 2945:
#line 15786 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("bool"); }
#line 54598 "preproc.c" /* yacc.c:1652  */
    break;

  case 2946:
#line 15787 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("enum"); }
#line 54604 "preproc.c" /* yacc.c:1652  */
    break;

  case 2947:
#line 15788 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("hour"); }
#line 54610 "preproc.c" /* yacc.c:1652  */
    break;

  case 2948:
#line 15789 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("int"); }
#line 54616 "preproc.c" /* yacc.c:1652  */
    break;

  case 2949:
#line 15790 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("long"); }
#line 54622 "preproc.c" /* yacc.c:1652  */
    break;

  case 2950:
#line 15791 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("minute"); }
#line 54628 "preproc.c" /* yacc.c:1652  */
    break;

  case 2951:
#line 15792 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("month"); }
#line 54634 "preproc.c" /* yacc.c:1652  */
    break;

  case 2952:
#line 15793 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("second"); }
#line 54640 "preproc.c" /* yacc.c:1652  */
    break;

  case 2953:
#line 15794 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("short"); }
#line 54646 "preproc.c" /* yacc.c:1652  */
    break;

  case 2954:
#line 15795 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("signed"); }
#line 54652 "preproc.c" /* yacc.c:1652  */
    break;

  case 2955:
#line 15796 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("struct"); }
#line 54658 "preproc.c" /* yacc.c:1652  */
    break;

  case 2956:
#line 15797 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("unsigned"); }
#line 54664 "preproc.c" /* yacc.c:1652  */
    break;

  case 2957:
#line 15798 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("year"); }
#line 54670 "preproc.c" /* yacc.c:1652  */
    break;

  case 2958:
#line 15799 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("char"); }
#line 54676 "preproc.c" /* yacc.c:1652  */
    break;

  case 2959:
#line 15800 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("float"); }
#line 54682 "preproc.c" /* yacc.c:1652  */
    break;

  case 2960:
#line 15801 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("to"); }
#line 54688 "preproc.c" /* yacc.c:1652  */
    break;

  case 2961:
#line 15802 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("union"); }
#line 54694 "preproc.c" /* yacc.c:1652  */
    break;

  case 2962:
#line 15803 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("varchar"); }
#line 54700 "preproc.c" /* yacc.c:1652  */
    break;

  case 2963:
#line 15804 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("["); }
#line 54706 "preproc.c" /* yacc.c:1652  */
    break;

  case 2964:
#line 15805 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("]"); }
#line 54712 "preproc.c" /* yacc.c:1652  */
    break;

  case 2965:
#line 15806 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("="); }
#line 54718 "preproc.c" /* yacc.c:1652  */
    break;

  case 2966:
#line 15807 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(":"); }
#line 54724 "preproc.c" /* yacc.c:1652  */
    break;

  case 2967:
#line 15810 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54730 "preproc.c" /* yacc.c:1652  */
    break;

  case 2968:
#line 15811 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54736 "preproc.c" /* yacc.c:1652  */
    break;

  case 2969:
#line 15812 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("all"); }
#line 54742 "preproc.c" /* yacc.c:1652  */
    break;

  case 2970:
#line 15813 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("all"); }
#line 54748 "preproc.c" /* yacc.c:1652  */
    break;

  case 2971:
#line 15816 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54754 "preproc.c" /* yacc.c:1652  */
    break;

  case 2972:
#line 15817 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("("), (yyvsp[-1].str), mm_strdup(")")); }
#line 54760 "preproc.c" /* yacc.c:1652  */
    break;

  case 2973:
#line 15818 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("+"), (yyvsp[0].str)); }
#line 54766 "preproc.c" /* yacc.c:1652  */
    break;

  case 2974:
#line 15819 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("-"), (yyvsp[0].str)); }
#line 54772 "preproc.c" /* yacc.c:1652  */
    break;

  case 2975:
#line 15820 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("*"), (yyvsp[0].str)); }
#line 54778 "preproc.c" /* yacc.c:1652  */
    break;

  case 2976:
#line 15821 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("/"), (yyvsp[0].str)); }
#line 54784 "preproc.c" /* yacc.c:1652  */
    break;

  case 2977:
#line 15822 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("%"), (yyvsp[0].str)); }
#line 54790 "preproc.c" /* yacc.c:1652  */
    break;

  case 2978:
#line 15823 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54796 "preproc.c" /* yacc.c:1652  */
    break;

  case 2979:
#line 15824 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54802 "preproc.c" /* yacc.c:1652  */
    break;

  case 2980:
#line 15825 "preproc.y" /* yacc.c:1652  */
    { if (pg_strcasecmp((yyvsp[-3].str), "sizeof") != 0)
							mmerror(PARSE_ERROR, ET_ERROR, "operator not allowed in variable definition");
						  else
							(yyval.str) = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].type).type_str, mm_strdup(")"));
						}
#line 54812 "preproc.c" /* yacc.c:1652  */
    break;

  case 2981:
#line 15832 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 54818 "preproc.c" /* yacc.c:1652  */
    break;

  case 2982:
#line 15833 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 54824 "preproc.c" /* yacc.c:1652  */
    break;

  case 2983:
#line 15834 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 54830 "preproc.c" /* yacc.c:1652  */
    break;

  case 2984:
#line 15835 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 54836 "preproc.c" /* yacc.c:1652  */
    break;

  case 2985:
#line 15838 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 54842 "preproc.c" /* yacc.c:1652  */
    break;

  case 2986:
#line 15839 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54848 "preproc.c" /* yacc.c:1652  */
    break;

  case 2987:
#line 15842 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 54854 "preproc.c" /* yacc.c:1652  */
    break;

  case 2988:
#line 15843 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54860 "preproc.c" /* yacc.c:1652  */
    break;

  case 2989:
#line 15846 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54866 "preproc.c" /* yacc.c:1652  */
    break;

  case 2990:
#line 15848 "preproc.y" /* yacc.c:1652  */
    {
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);
		(yyval.str) = (yyvsp[0].str);
	}
#line 54879 "preproc.c" /* yacc.c:1652  */
    break;

  case 2991:
#line 15858 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 54885 "preproc.c" /* yacc.c:1652  */
    break;

  case 2992:
#line 15859 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 54891 "preproc.c" /* yacc.c:1652  */
    break;


#line 54895 "preproc.c" /* yacc.c:1652  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 15862 "preproc.y" /* yacc.c:1918  */


void base_yyerror(const char *error)
{
	/* translator: %s is typically the translation of "syntax error" */
	mmerror(PARSE_ERROR, ET_ERROR, "%s at or near \"%s\"",
			_(error), token_start ? token_start : base_yytext);
}

void parser_init(void)
{
 /* This function is empty. It only exists for compatibility with the backend parser right now. */
}
